package com.ibm.btools.blm.ie.exprt;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

/**
 *	Implementors of this interface answer one of the prescribed return codes
 *	when asked whether to overwrite a certain path string (which could
 *	represent a file system path, etc).
 */
public interface IExportQuery {
	
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
		
	/**
	 * Return code indicating the file should be skipped
	 */
	public static final int CANCEL = 0;

	/**
	 * Return code indicating the file should be overwritten.
	 */
	public static final int OVERWRITE = 1;
	


	/**
	 * Returns one of the return code constants declared on this interface,
	 * indicating whether the file represented by the passed String should be overwritten.
	 * <p>
	 * This method may be called from a non-UI thread, in which case this method must run the query
	 * in a sync exec in the UI thread, if it needs to query the user.
	 * </p>
	 * @param fileName a file name string representing the file to be overwritten
	 * @return one of the return code constants declared on this interface
	 */
	public int queryExportOption(String fileName);
}