package com.ibm.btools.blm.ie.exprt.filter;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import com.ibm.btools.blm.ie.imprt.rule.util.BOMUtil;
import com.ibm.btools.blm.ui.navigation.model.AbstractLibraryChildNode;
import com.ibm.btools.blm.ui.navigation.model.AbstractNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationBOCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationBOCatalogsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationBusinessEntitiesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationBusinessEntityNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationBusinessRuleTaskNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationBusinessRuleTasksNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCalendarNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCalendarsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCategoriesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCategoryNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationDataCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationDataCatalogsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationExternalModelCatalogsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationExternalServiceCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationExternalServiceCatalogsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationFormNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationFormsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationHumanTaskNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationHumanTasksNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationLocationDefinitionCategoriesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationLocationDefinitionCategoryNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationLocationDefinitionNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationLocationDefinitionsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationCatalogsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationDefinitionCategoriesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationDefinitionCategoryNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationDefinitionNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationDefinitionsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationUnitNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationUnitsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProcessCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProcessCatalogsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProcessNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProcessesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProjectNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourceCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourceCatalogsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourceDefinitionCategoriesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourceDefinitionCategoryNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourceDefinitionNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourceDefinitionsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourceNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationRoleNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationServiceNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationServicesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationSignalCategoriesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationSignalCategoryNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationSignalNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationSignalsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationTaskNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationTasksNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationWSDLFileNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationXSDFileNode;
import com.ibm.btools.bom.command.compound.PredefTypesConst;
import com.ibm.btools.bom.model.artifacts.Classifier;
import com.ibm.btools.bom.model.artifacts.LiteralString;
import com.ibm.btools.bom.model.artifacts.Package;
import com.ibm.btools.bom.model.artifacts.PackageableElement;
import com.ibm.btools.bom.model.artifacts.Slot;
import com.ibm.btools.bom.model.artifacts.Type;
import com.ibm.btools.bom.model.organizationstructures.OrganizationUnit;
import com.ibm.btools.bom.model.organizationstructures.OrganizationUnitType;
import com.ibm.btools.bom.model.resources.BulkResource;
import com.ibm.btools.bom.model.resources.IndividualResource;

/**
 * @author agrabovs
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class WpsExportFilter implements IExportFilter {
	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	

	private static WpsExportFilter wpsExportFilter = null;
	
	private WpsExportFilter() {
	}
	
	public static WpsExportFilter getInstance() {
		if (wpsExportFilter==null) {
			wpsExportFilter = new WpsExportFilter();
		}
		return wpsExportFilter;
	}
	
	static List predefinedListTypes = new LinkedList();
	
	static {
		predefinedListTypes.add(PredefTypesConst.ROOT_RES_MODEL_NAME +"/" + PredefTypesConst.STAFF_CATEGORY_TYPE_NAME );
		predefinedListTypes.add(PredefTypesConst.ROOT_RES_MODEL_NAME +"/" + PredefTypesConst.STAFF_TYPE_NAME);
		predefinedListTypes.add(PredefTypesConst.ROOT_RES_MODEL_NAME +"/" + PredefTypesConst.PERSON_TYPE_NAME );
		predefinedListTypes.add(PredefTypesConst.ROOT_RES_MODEL_NAME +"/" + PredefTypesConst.PERSON_CATEGORY_TYPE_NAME);
		predefinedListTypes.add(PredefTypesConst.ORGANIZATION_TYPE_NAME);			
		predefinedListTypes.add(PredefTypesConst.ORGANIZATION_CATEGORY_TYPE_NAME);
	}
	
	public boolean isNodeSupported(AbstractNode node) {
		if (
			node instanceof NavigationBusinessEntitiesNode ||
			node instanceof NavigationBusinessEntityNode ||
//			node instanceof NavigationBusinessGroupNode || //??
//			node instanceof NavigationBusinessGroupsNode || // ??
			node instanceof NavigationCategoriesNode || 
			node instanceof NavigationCategoryNode || 
			node instanceof NavigationDataCatalogNode || 
			node instanceof NavigationDataCatalogsNode ||
//			node instanceof NavigationLibraryNode || //??
			node instanceof NavigationLocationDefinitionCategoriesNode ||
			node instanceof NavigationLocationDefinitionCategoryNode ||
			node instanceof NavigationLocationDefinitionNode ||
			node instanceof NavigationLocationDefinitionsNode ||
			node instanceof NavigationOrganizationCatalogNode ||
			node instanceof NavigationOrganizationCatalogsNode ||
			node instanceof NavigationOrganizationDefinitionCategoriesNode ||
			node instanceof NavigationOrganizationDefinitionCategoryNode ||
			node instanceof NavigationOrganizationDefinitionNode ||
			node instanceof NavigationOrganizationDefinitionsNode ||
//			node instanceof NavigationOrganizationUnitNode && isKindOfOrganization(node) || // needs subfilter
//			node instanceof NavigationOrganizationUnitsNode ||
//			node instanceof NavigationPackage || //??
			node instanceof NavigationProcessCatalogNode ||
			node instanceof NavigationProcessCatalogsNode ||
			node instanceof NavigationProcessesNode ||
			node instanceof NavigationProcessNode ||
			node instanceof NavigationProjectNode ||
			node instanceof NavigationResourceCatalogNode ||
			node instanceof NavigationResourceCatalogsNode ||
			node instanceof NavigationResourceDefinitionCategoriesNode ||
			node instanceof NavigationResourceDefinitionCategoryNode ||
			node instanceof NavigationResourceDefinitionNode ||
			node instanceof NavigationResourceDefinitionsNode ||
//			(node instanceof NavigationResourceNode && isStaffResource(node)) || // needs subfilter
//			node instanceof NavigationRoleNode ||
			node instanceof NavigationServiceNode ||
			node instanceof NavigationServicesNode ||
			node instanceof NavigationSignalCategoriesNode ||
			node instanceof NavigationSignalCategoryNode ||
			node instanceof NavigationSignalNode ||
			node instanceof NavigationSignalsNode ||			
			node instanceof NavigationTaskNode ||
			node instanceof NavigationTasksNode ||
			node instanceof NavigationExternalModelCatalogsNode ||
			node instanceof NavigationBOCatalogsNode ||
			node instanceof NavigationBOCatalogNode ||
			node instanceof NavigationXSDFileNode ||
			node instanceof NavigationExternalServiceCatalogsNode ||
			node instanceof NavigationExternalServiceCatalogNode ||
			node instanceof NavigationWSDLFileNode ||
			node instanceof NavigationHumanTasksNode ||
			node instanceof NavigationHumanTaskNode ||
			node instanceof NavigationBusinessRuleTasksNode ||
			node instanceof NavigationBusinessRuleTaskNode ||
			node instanceof NavigationFormNode ||
			node instanceof NavigationFormsNode ||
			node instanceof NavigationCalendarsNode ||
			node instanceof NavigationCalendarNode

		) {
			return true;
		}
		return false;
	}
	
	/**
	 * Returns try if the <code>node</code> represents an IndividualResource of predefined Staff or Resource.
	 * @param node
	 * @return
	 */
	private boolean isStaffResource(AbstractNode node){
		AbstractLibraryChildNode thisNode = (AbstractLibraryChildNode)node;
		Object bomObject = BOMUtil.loadRootObject(thisNode);
		if(bomObject instanceof BulkResource){
			return false;
		}else if(bomObject instanceof IndividualResource && isKindOfStaff((Type)((IndividualResource)bomObject).getClassifier().get(0)) && isValidStaffResource(bomObject)){
			return true;
		}else{
			return false;
		}
	}
	
	/**
	 * Checks if staff resource has personID for filtering in export wizard
	 *
	 */
	private boolean isValidStaffResource(Object bomObject) {
		IndividualResource resource = (IndividualResource)bomObject;
		String personID = null;
		List slots = resource.getSlot();		
		if(slots != null && !slots.isEmpty()){
			Iterator it = slots.iterator();
			while(it.hasNext()){
				Slot thisSlot = (Slot)it.next();	
				if (thisSlot.getDefiningFeature().getName()!=null){					
					if(thisSlot.getDefiningFeature().getName().equals("personId")){
						if(thisSlot.getValue() != null && !thisSlot.getValue().isEmpty()){
							personID =((LiteralString)thisSlot.getValue().get(0)).getValue();
						}
					}
				}
			}
		}
		if(personID == null){
			return false;
		}
		
		return true;
	}

	/**
	 * Returns try if the <code>node</code> represents an OrganizationUnit of predefined Organization type
	 * @param node
	 * @return
	 */
	private boolean isKindOfOrganization(AbstractNode node){
		AbstractLibraryChildNode thisNode = (AbstractLibraryChildNode)node;
		Object bomObject = BOMUtil.loadRootObject(thisNode);
		if(bomObject instanceof OrganizationUnit){
			if(isKindOfOrganization((Type)((OrganizationUnit)bomObject).getClassifier().get(0)) && isValidOrgUnit(bomObject)){ 
				return true;
			}
			return false;
		}
		return false;
	}
	
	/**
	 * Checks if organization unit has name field to filter in export wizard
	 * 
	 */
	private boolean isValidOrgUnit(Object bomObject) {
		OrganizationUnit orgUnit = (OrganizationUnit)bomObject;
		String groupName = null;
		List slots = orgUnit.getSlot();		
		if(slots != null && !slots.isEmpty()){
			Iterator it = slots.iterator();
			while(it.hasNext()){
				Slot thisSlot = (Slot)it.next();	
				if (thisSlot.getDefiningFeature().getName()!=null){		
					if(thisSlot.getDefiningFeature().getName().equals("name")){
						if(thisSlot.getValue() != null && !thisSlot.getValue().isEmpty()){
							groupName =((LiteralString)thisSlot.getValue().get(0)).getValue();
						}
					}
				}
			}
		}
		if(groupName == null){
			return false;
		}
		
		return true;
	}

	/**
	 * Returns true if the input type is a subclass of the predefined Resource types. 
	 * @param type BOM Type
	 * @return boolean
	 */ 
	public boolean isKindOfStaff(Type type){
		List superClassifiers = ((Classifier)type).getSuperClassifier();
		if(superClassifiers != null && !superClassifiers.isEmpty()){
			Iterator it = superClassifiers.iterator();
			while(it.hasNext()){
				Classifier classifier = (Classifier)it.next();
				if(isPredefinedStaff(classifier)){
					return true;
				}
			}
		}
		return false;
	}
	
	/**
	 * Returns true if the type is one of the predefined Staff Resource or a subclass of those.
	 * @param type BOM Type
	 * @return boolean
	 */	
	public boolean isPredefinedStaff(Type type){

		String canonicalName = getCanonicalName(type);
		if(predefinedListTypes.contains(canonicalName) || isKindOfStaff(type)){
			return true;
		}
		return false;
	}
	
	/**
	 * Returns the canonical name of this type. 
	 * @param type BOM Type (normally a resource type)
	 * @return String canonical name
	 */
	private String getCanonicalName(PackageableElement type){
		String canonicalName = null;
			if(type.getOwningPackage()!= null){
				Package model = type.getOwningPackage();
				canonicalName = model.getName() + "/" + type.getName();
				Package belongingModel = model.getOwningPackage();
				while (belongingModel != null && !isRootPackage(belongingModel)) {
					canonicalName = belongingModel.getName() + "/" + canonicalName;
					belongingModel = belongingModel.getOwningPackage();
			}
		}
		return canonicalName;
	}
	
	private boolean isRootPackage(Package pkg) {

		if (pkg != null && pkg.getName() != null &&
			(pkg.getName().equals(PredefTypesConst.ROOT_PROC_MODEL_NAME)
				|| pkg.getName().equals(PredefTypesConst.ROOT_INFO_MODEL_NAME)
				|| pkg.getName().equals(PredefTypesConst.ROOT_ORG_MODEL_NAME)
				|| pkg.getName().equals(PredefTypesConst.ROOT_RES_MODEL_NAME)
				|| pkg.getName().equals(PredefTypesConst.ROOT_SERV_MODEL_NAME)
				|| pkg.getName().equals("RootReportModel")
				|| pkg.getName().equals("RootCEFModel")
				|| pkg.getName().equals(PredefTypesConst.ROOT_CATEGORY_MODEL_NAME)
				|| PredefTypesConst.ROOT_EXT_MODEL_NAME.equals(pkg.getName())
			 )
			) {
			return pkg.getOwningPackage()==null; 
		}
		return false;
	}

	/**
	 * Returns true if the type is one of the predefined Staff Resource or a subclass of those.
	 * @param type BOM Type
	 * @return boolean
	 */	
	private boolean isPredefinedOrg(Type type){
		if(!(type instanceof OrganizationUnitType)){
			return false;
		}
		if((predefinedListTypes.contains(type.getName()) && type.getOwningPackage().getName().equals(PredefTypesConst.ROOT_ORG_MODEL_NAME)) || isKindOfOrganization(type)){
			return true;
		}
		return false;
	}
	
	/**
	 * Returns true if the input type is a subclass of the predefined Resource types. 
	 * @param type BOM Type
	 * @return boolean
	 */ 
	private boolean isKindOfOrganization(Type type){
		List superClassifiers = ((Classifier)type).getSuperClassifier();
		if(superClassifiers != null && !superClassifiers.isEmpty()){
			Iterator it = superClassifiers.iterator();
			while(it.hasNext()){
				Classifier classifier = (Classifier)it.next();
				if(isPredefinedOrg(classifier)){
					return true;
				}
			}
		}
		return false;
	}	
}
