package com.ibm.btools.blm.ie.exprt.filter;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import com.ibm.btools.blm.ui.navigation.model.AbstractNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationBusinessEntitiesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationBusinessEntityNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCategoriesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCategoryNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationDataCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationDataCatalogsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProcessCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProcessCatalogsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProcessNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProcessesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProjectNode;

/**
 * @author agrabovs
 *
 * Only valid items for Xpdl export are Process Catalog(s), Process(es), Information Model(s) 
 * and Business Item(s).
 */
public class XpdlExportFilter implements IExportFilter {
	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	

	private static XpdlExportFilter xpdlExportFilter = null;
	
	private XpdlExportFilter() {
	}
	
	public static XpdlExportFilter getInstance() {
		if (xpdlExportFilter==null) {
			xpdlExportFilter = new XpdlExportFilter();
		}
		return xpdlExportFilter;
	}
	
	public boolean isNodeSupported(AbstractNode node) {
		if (
				node instanceof NavigationBusinessEntitiesNode ||
				node instanceof NavigationBusinessEntityNode ||
				node instanceof NavigationCategoriesNode || 
				node instanceof NavigationCategoryNode || 
				node instanceof NavigationDataCatalogNode || 
				node instanceof NavigationDataCatalogsNode ||
				node instanceof NavigationProcessCatalogNode ||
				node instanceof NavigationProcessCatalogsNode ||
				node instanceof NavigationProcessesNode ||
				node instanceof NavigationProcessNode ||
				node instanceof NavigationProjectNode 
		) {
			return true;
		}
		return false;
	}
}


