package com.ibm.btools.blm.ie.imprt;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import java.util.HashMap;

import com.ibm.btools.blm.ie.imprt.rule.util.LoggingUtil;

/**
 * Context of the import operation
 */
public class ImportContext extends HashMap {
		
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	/**
	 * Create a new sub context by name
	 * @param name
	 */		
	public ImportContext createSubContext(final Object name) {
		LoggingUtil.traceEntry(this, "createSubContext");		
		Object element = get(name);
		if (element != null) {		
			if (element instanceof ImportContext) {
				LoggingUtil.traceExit(this, "createSubContext");
				return (ImportContext) element;
			} else {
				LoggingUtil.traceExit(this, "createSubContext");
				return null;
			}
		} else {		
			ImportContext subContext  = new ImportContext();
			put(name, subContext);
			LoggingUtil.traceExit(this, "createSubContext");
			return subContext;
		}	 
	}
	
	/**
	 * Return a sub context by name
	 * @param name
	 */	
	public ImportContext getSubContext(final Object name) {
		return createSubContext(name);	
	}
	
	/**
	 * Remove a sub context by name
	 * @param name
	 */	
	public void removeSubContext(final Object name) {
		LoggingUtil.traceEntry(this, "removeSubContext");
		Object element = get(name);
		if (element != null) {		
			if (element instanceof ImportContext) {
				remove(element);
			}
		}
		LoggingUtil.traceExit(this, "removeSubContext");		
	}	
}