package com.ibm.btools.blm.ie.imprt;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import java.util.HashMap;
import java.util.Map;

/**
 * Import options
 */
public class ImportOptions {
	
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	
	
	private boolean alwaysOverwrite;
	private boolean alwaysNewCopy;
	private boolean alwaysIgnore;
	private boolean overwrite;
	private boolean newCopy;
	private boolean ignore;
	private boolean cancel;
	private boolean resolveRef = false;
	private boolean collisionHandlingEnabled = false;

	
	private Map options;

	/**
	 * Check always ignore
	 * @return
	 */
	public boolean isAlwaysIgnore() {
		return alwaysIgnore;
	}

	/**
	 * Check always create a new copy
	 * @return
	 */
	public boolean isAlwaysNewCopy() {
		return alwaysNewCopy;
	}

	/**
	 * Check always overwrite
	 * @return
	 */
	public boolean isAlwaysOverwrite() {
		return alwaysOverwrite;
	}

	/**
	 * Check cancel
	 * @return
	 */
	public boolean isCancel() {
		return cancel;
	}

	/**
	 * Check ignore
	 * @return
	 */
	public boolean isIgnore() {
		return ignore;
	}

	/**
	 * Check create a new copy
	 * @return
	 */
	public boolean isNewCopy() {
		return newCopy;
	}

	/**
	 * Check overwrite
	 * @return
	 */
	public boolean isOverwrite() {
		return overwrite;
	}

	/**
	 * Set always ignore
	 * @param alwaysIgnore
	 */
	public void setAlwaysIgnore(final boolean alwaysIgnore) {
		this.alwaysIgnore = alwaysIgnore;
	}

	/**
	 * Set always create a new copy
	 * @param alwaysNewCopy
	 */
	public void setAlwaysNewCopy(final boolean alwaysNewCopy) {
		this.alwaysNewCopy = alwaysNewCopy;
	}

	/**
	 * Set always overwrite
	 * @param alwaysOverwrite
	 */
	public void setAlwaysOverwrite(final boolean alwaysOverwrite) {
		this.alwaysOverwrite = alwaysOverwrite;
	}

	/**
	 * Set cancel
	 * @param cancel
	 */
	public void setCancel(final boolean cancel) {
		this.cancel = cancel;
	}

	/**
	 * Set ignore
	 * @param ignore
	 */
	public void setIgnore(final boolean ignore) {
		this.ignore = ignore;
	}

	/**
	 * Set create a new copy
	 * @param newCopy
	 */
	public void setNewCopy(final boolean newCopy) {
		this.newCopy = newCopy;
	}

	/**
	 * Set overwrite
	 * @param overwrite
	 */
	public void setOverwrite(final boolean overwrite) {
		this.overwrite = overwrite;
	}
	
	/**
	 * @return
	 */
	public boolean isResolveRef() {
		return resolveRef;
	}

	/**
	 * @param b
	 */
	public void setResolveRef(boolean b) {
		resolveRef = b;
	}
	
	/**
	 * Set additional option by key and value
	 * @param key
	 * @param value
	 */
	public void setAdditionalOption(final String key, Object value) {
		if (options == null) {
			options = new HashMap();
		}
		options.put(key, value);
	}	
	
	/**
	 * Get additional option by name
	 * @param overwrite
	 */
	public Object getAdditionalOption(final String key) {
		if (options == null) {
			return null;
		}
		return options.get(key);
	}
	
	/**
	 * Set the additional options.
	 * @param options
	 */
	public void setAdditionalOptions(Map options) {
		this.options = options;
	}
	
	/**
	 * Get the additional options.
	 * @return options
	 */
	public Map getAdditionalOptions() {
		return options;
	}

	public boolean isCollisionHandlingEnabled() {
		return collisionHandlingEnabled;
	}

	public void setCollisionHandlingEnabled(boolean collisionHandlingEnabled) {
		this.collisionHandlingEnabled = collisionHandlingEnabled;
	}
}
