package com.ibm.btools.blm.ie.imprt.rule;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import com.ibm.btools.blm.ie.imprt.ImportSession;

/**
 * Interface of the Import rule
 */
public interface IImportRule {
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	
	
	/**
	 * Set Original object
	 * @param object
	 */
	public void setSource(final Object object);
	
	/**
	 * Set the working copy
	 * @param workingCopy
	 */
	public void setWorkingCopy(final Object workingCopy);
	
	/**
	 * Set projectName
	 * @param projectName
	 */
	public void setProjectName(final String projectName);
	
	/**
	 * Get project name
	 * @return
	 */
	public String getProjectName();
	
	/**
	 * Set the import session
	 * @param session
	 */
	public void setImportSession(final ImportSession session);
	
	/**
	 * Get the import session
	 * @param session
	 */
	public ImportSession getImportSession();	
	
	/**
	 * Invoke the rule
	 */	
	public void invoke();
}
