package com.ibm.btools.blm.ie.imprt.rule.expressionModel;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import org.eclipse.emf.ecore.EObject;

import com.ibm.btools.blm.ie.imprt.rule.util.LoggingUtil;
import com.ibm.btools.blm.ie.resource.IeMessageKeys;
import com.ibm.btools.emf.cf.BtCompoundCommand;
import com.ibm.btools.expression.command.AddBinaryLogicalBooleanExpressionFirstOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddBinaryLogicalBooleanExpressionToFunctionArgumentEXPCmd;
import com.ibm.btools.expression.command.AddBinaryLogicalBooleanExpressionToUnaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddBinaryNumericExpressionFirstOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddBinaryNumericExpressionToFunctionArgumentEXPCmd;
import com.ibm.btools.expression.command.AddBinaryNumericExpressionToUnaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddBooleanLiteralExpressionFirstOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddBooleanLiteralExpressionToFunctionArgumentEXPCmd;
import com.ibm.btools.expression.command.AddBooleanLiteralExpressionToUnaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddComparisonExpressionFirstOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddComparisonExpressionToFunctionArgumentEXPCmd;
import com.ibm.btools.expression.command.AddComparisonExpressionToUnaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddFunctionExpressionFirstOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddFunctionExpressionToFunctionArgumentEXPCmd;
import com.ibm.btools.expression.command.AddModelPathExpressionFirstOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddModelPathExpressionToFunctionArgumentEXPCmd;
import com.ibm.btools.expression.command.AddModelPathExpressionToUnaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddNegationExpressionFirstOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddNegationExpressionToFunctionArgumentEXPCmd;
import com.ibm.btools.expression.command.AddNegationExpressionToUnaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddNotExpressionFirstOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddNotExpressionToFunctionArgumentEXPCmd;
import com.ibm.btools.expression.command.AddNotExpressionToUnaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddNumericLiteralExpressionFirstOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddNumericLiteralExpressionToFunctionArgumentEXPCmd;
import com.ibm.btools.expression.command.AddNumericLiteralExpressionToUnaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddStringLiteralExpressionFirstOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddStringLiteralExpressionToFunctionArgumentEXPCmd;
import com.ibm.btools.expression.command.AddStringLiteralExpressionToUnaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddUnionExpressionFirstOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddUnionExpressionToFunctionArgumentEXPCmd;
import com.ibm.btools.expression.command.AddUnionExpressionToUnaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddVariableExpressionFirstOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.model.BinaryLogicalBooleanExpression;
import com.ibm.btools.expression.model.BinaryNumericExpression;
import com.ibm.btools.expression.model.BinaryOperatorExpression;
import com.ibm.btools.expression.model.BooleanLiteralExpression;
import com.ibm.btools.expression.model.ComparisonExpression;
import com.ibm.btools.expression.model.Expression;
import com.ibm.btools.expression.model.FunctionArgument;
import com.ibm.btools.expression.model.FunctionExpression;
import com.ibm.btools.expression.model.ModelPathExpression;
import com.ibm.btools.expression.model.NegationExpression;
import com.ibm.btools.expression.model.NotExpression;
import com.ibm.btools.expression.model.NumericLiteralExpression;
import com.ibm.btools.expression.model.StringLiteralExpression;
import com.ibm.btools.expression.model.UnaryOperatorExpression;
import com.ibm.btools.expression.model.UnionExpression;
import com.ibm.btools.expression.model.VariableExpression;


public class UpdateFirstOperandRule extends UpdateExpressionRule{
	//copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	
	
	private Expression sourceExpr;
	private Expression workingCopy;
	protected EObject parentExpression;

	/**
	 * Set Original StructuredOpaqueExpression
	 * @param expr
	 */
	public void setSource(final Object expression) {
		this.sourceExpr = (Expression) expression;
	}
	
	/**
	 * Set the working copy
	 * @param workingCopy
	 */
	public void setWorkingCopy(final Object workingCopy) {
		this.workingCopy = (Expression) workingCopy;
	}
	
	/**
	 * @param parentExpression
	 */
	protected void setParentExpression(final Object parentExpression){
		this.parentExpression = (EObject)parentExpression;
	}
	
	/**
	 * Invoke the rule
	 */
	public void invoke() {
		LoggingUtil.traceEntry(this, "invoke");
		updateFirstOperand(workingCopy, parentExpression, wrapperCmd);
		LoggingUtil.traceExit(this, "invoke");
	}
	
	private void updateFirstOperand(Expression operandExpr, EObject parentExpr, BtCompoundCommand wrapperCmd){
		LoggingUtil.traceEntry(this, "updateFirstOperand");
		if (operandExpr instanceof BinaryLogicalBooleanExpression ){
			try{			
				if (parentExpr instanceof BinaryOperatorExpression){
					AddBinaryLogicalBooleanExpressionFirstOperandToBinaryOperatorExpressionEXPCmd addcmd = 
						new AddBinaryLogicalBooleanExpressionFirstOperandToBinaryOperatorExpressionEXPCmd((BinaryLogicalBooleanExpression)operandExpr, (BinaryOperatorExpression)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);
				}else if (parentExpr instanceof FunctionArgument){
					AddBinaryLogicalBooleanExpressionToFunctionArgumentEXPCmd addcmd = 
						new AddBinaryLogicalBooleanExpressionToFunctionArgumentEXPCmd((BinaryLogicalBooleanExpression)operandExpr, (FunctionArgument)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);
				}else if (parentExpr instanceof UnaryOperatorExpression){
					AddBinaryLogicalBooleanExpressionToUnaryOperatorExpressionEXPCmd addcmd = 
						new AddBinaryLogicalBooleanExpressionToUnaryOperatorExpressionEXPCmd((BinaryLogicalBooleanExpression)operandExpr, (UnaryOperatorExpression)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);					
				}	
			}catch (RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.UPDATE_FIRST_OPRERAND_EXCEPTION, new String[]{operandExpr.getUid()}, ex);
			}	
		}else if (operandExpr instanceof  BinaryNumericExpression) {
			try{
				if (parentExpr instanceof BinaryOperatorExpression){
					AddBinaryNumericExpressionFirstOperandToBinaryOperatorExpressionEXPCmd addcmd = 
						new AddBinaryNumericExpressionFirstOperandToBinaryOperatorExpressionEXPCmd((BinaryNumericExpression)operandExpr, (BinaryOperatorExpression)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);				
				}else if (parentExpr instanceof FunctionArgument){
					AddBinaryNumericExpressionToFunctionArgumentEXPCmd addcmd = 
						new AddBinaryNumericExpressionToFunctionArgumentEXPCmd((BinaryNumericExpression)operandExpr, (FunctionArgument)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);
				}else if (parentExpr instanceof UnaryOperatorExpression){
					AddBinaryNumericExpressionToUnaryOperatorExpressionEXPCmd addcmd = 
						new AddBinaryNumericExpressionToUnaryOperatorExpressionEXPCmd((BinaryNumericExpression)operandExpr, (UnaryOperatorExpression)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);		
				}	
			}catch (RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.UPDATE_FIRST_OPRERAND_EXCEPTION, new String[]{operandExpr.getUid()}, ex);
			}
		}else if (operandExpr instanceof  BooleanLiteralExpression ){
			try{
				if (parentExpr instanceof BinaryOperatorExpression){
					AddBooleanLiteralExpressionFirstOperandToBinaryOperatorExpressionEXPCmd addcmd = 
						new AddBooleanLiteralExpressionFirstOperandToBinaryOperatorExpressionEXPCmd((BooleanLiteralExpression)operandExpr, (BinaryOperatorExpression)parentExpr);	
					wrapperCmd.appendAndExecute(addcmd);				
				}else if (parentExpr instanceof FunctionArgument){
					AddBooleanLiteralExpressionToFunctionArgumentEXPCmd addcmd = 
						new AddBooleanLiteralExpressionToFunctionArgumentEXPCmd((BooleanLiteralExpression)operandExpr, (FunctionArgument)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);
				}else if (parentExpr instanceof UnaryOperatorExpression){
					AddBooleanLiteralExpressionToUnaryOperatorExpressionEXPCmd addcmd = 
						new AddBooleanLiteralExpressionToUnaryOperatorExpressionEXPCmd((BooleanLiteralExpression)operandExpr, (UnaryOperatorExpression)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);				
				}
			}catch (RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.UPDATE_FIRST_OPRERAND_EXCEPTION, new String[]{operandExpr.getUid()}, ex);
			}	
		}else if (operandExpr instanceof  ComparisonExpression){
			try{
				if (parentExpr instanceof BinaryOperatorExpression){
					AddComparisonExpressionFirstOperandToBinaryOperatorExpressionEXPCmd addcmd = 
						new AddComparisonExpressionFirstOperandToBinaryOperatorExpressionEXPCmd((ComparisonExpression)operandExpr, (BinaryOperatorExpression)parentExpr);	
					wrapperCmd.appendAndExecute(addcmd);				
				}else if (parentExpr instanceof FunctionArgument){
					AddComparisonExpressionToFunctionArgumentEXPCmd addcmd = 
						new AddComparisonExpressionToFunctionArgumentEXPCmd((ComparisonExpression)operandExpr, (FunctionArgument)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);
				}else if (parentExpr instanceof UnaryOperatorExpression){
					AddComparisonExpressionToUnaryOperatorExpressionEXPCmd addcmd = 
						new AddComparisonExpressionToUnaryOperatorExpressionEXPCmd((ComparisonExpression)operandExpr, (UnaryOperatorExpression)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);				
				}	
			}catch (RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.UPDATE_FIRST_OPRERAND_EXCEPTION, new String[]{operandExpr.getUid()}, ex);
			}
		}else if (operandExpr instanceof  FunctionExpression){
			try{
				if (parentExpr instanceof BinaryOperatorExpression){
					AddFunctionExpressionFirstOperandToBinaryOperatorExpressionEXPCmd addcmd = 
						new AddFunctionExpressionFirstOperandToBinaryOperatorExpressionEXPCmd((FunctionExpression)operandExpr, (BinaryOperatorExpression)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);				
				}else if (parentExpr instanceof FunctionArgument){
					AddFunctionExpressionToFunctionArgumentEXPCmd addcmd = 
						new AddFunctionExpressionToFunctionArgumentEXPCmd((FunctionExpression)operandExpr, (FunctionArgument)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);
				}else if (parentExpr instanceof UnaryOperatorExpression){
					AddNumericLiteralExpressionToUnaryOperatorExpressionEXPCmd addcmd = 
						new AddNumericLiteralExpressionToUnaryOperatorExpressionEXPCmd((NumericLiteralExpression)operandExpr, (UnaryOperatorExpression)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);				
				}
			}catch (RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.UPDATE_FIRST_OPRERAND_EXCEPTION, new String[]{operandExpr.getUid()}, ex);
			}	
		}else if (operandExpr instanceof  NumericLiteralExpression){
			try{
				if (parentExpr instanceof BinaryOperatorExpression){
					AddNumericLiteralExpressionFirstOperandToBinaryOperatorExpressionEXPCmd addcmd = 
						new AddNumericLiteralExpressionFirstOperandToBinaryOperatorExpressionEXPCmd((NumericLiteralExpression)operandExpr, (BinaryOperatorExpression)parentExpr);	
					wrapperCmd.appendAndExecute(addcmd);				
				}else if (parentExpr instanceof FunctionArgument){
					AddNumericLiteralExpressionToFunctionArgumentEXPCmd addcmd = 
						new AddNumericLiteralExpressionToFunctionArgumentEXPCmd((NumericLiteralExpression)operandExpr, (FunctionArgument)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);
				}else if (parentExpr instanceof UnaryOperatorExpression){
					AddNumericLiteralExpressionToUnaryOperatorExpressionEXPCmd addcmd = 
						new AddNumericLiteralExpressionToUnaryOperatorExpressionEXPCmd((NumericLiteralExpression)operandExpr, (UnaryOperatorExpression)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);				
				}
			}catch (RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.UPDATE_FIRST_OPRERAND_EXCEPTION, new String[]{operandExpr.getUid()}, ex);
			}
		}else if (operandExpr instanceof  ModelPathExpression){
			try{
				if (parentExpr instanceof BinaryOperatorExpression){
					AddModelPathExpressionFirstOperandToBinaryOperatorExpressionEXPCmd addcmd = 
						new AddModelPathExpressionFirstOperandToBinaryOperatorExpressionEXPCmd((ModelPathExpression)operandExpr, (BinaryOperatorExpression)parentExpr);	
					wrapperCmd.appendAndExecute(addcmd);				
				}else if (parentExpr instanceof FunctionArgument){
					AddModelPathExpressionToFunctionArgumentEXPCmd addcmd = 
						new AddModelPathExpressionToFunctionArgumentEXPCmd((ModelPathExpression)operandExpr, (FunctionArgument)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);
				}else if (parentExpr instanceof UnaryOperatorExpression){
					AddModelPathExpressionToUnaryOperatorExpressionEXPCmd addcmd = 
						new AddModelPathExpressionToUnaryOperatorExpressionEXPCmd((ModelPathExpression)operandExpr, (UnaryOperatorExpression)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);				
				}
			}catch (RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.UPDATE_FIRST_OPRERAND_EXCEPTION, new String[]{operandExpr.getUid()}, ex);
			}	
		}else if (operandExpr instanceof  NegationExpression){
			try{
				if (parentExpr instanceof BinaryOperatorExpression){
					AddNegationExpressionFirstOperandToBinaryOperatorExpressionEXPCmd addcmd = 
						new AddNegationExpressionFirstOperandToBinaryOperatorExpressionEXPCmd((NegationExpression)operandExpr, (BinaryOperatorExpression)parentExpr);	
					wrapperCmd.appendAndExecute(addcmd);				
				}else if (parentExpr instanceof FunctionArgument){
					AddNegationExpressionToFunctionArgumentEXPCmd addcmd = 
						new AddNegationExpressionToFunctionArgumentEXPCmd((NegationExpression)operandExpr, (FunctionArgument)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);
				}else if (parentExpr instanceof UnaryOperatorExpression){
					AddNegationExpressionToUnaryOperatorExpressionEXPCmd addcmd = 
						new AddNegationExpressionToUnaryOperatorExpressionEXPCmd((NegationExpression)operandExpr, (UnaryOperatorExpression)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);				
				}
			}catch (RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.UPDATE_FIRST_OPRERAND_EXCEPTION, new String[]{operandExpr.getUid()}, ex);
			}	
		}else if (operandExpr instanceof  NotExpression){
			try{
				if (parentExpr instanceof BinaryOperatorExpression){
					AddNotExpressionFirstOperandToBinaryOperatorExpressionEXPCmd addcmd = 
						new AddNotExpressionFirstOperandToBinaryOperatorExpressionEXPCmd((NotExpression)operandExpr, (BinaryOperatorExpression)parentExpr);		
					wrapperCmd.appendAndExecute(addcmd);				
				}else if (parentExpr instanceof FunctionArgument){
					AddNotExpressionToFunctionArgumentEXPCmd addcmd = 
						new AddNotExpressionToFunctionArgumentEXPCmd((NotExpression)operandExpr, (FunctionArgument)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);
				}else if (parentExpr instanceof UnaryOperatorExpression){
					AddNotExpressionToUnaryOperatorExpressionEXPCmd addcmd = 
						new AddNotExpressionToUnaryOperatorExpressionEXPCmd((NotExpression)operandExpr, (UnaryOperatorExpression)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);				
				}
			}catch (RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.UPDATE_FIRST_OPRERAND_EXCEPTION, new String[]{operandExpr.getUid()}, ex);
			}
		/*
		}else if (operandExpr instanceof  RealLiteralExpression){
			try{
				if (parentExpr instanceof BinaryOperatorExpression){
					AddRealLiteralExpressionFirstOperandToBinaryOperatorExpressionEXPCmd addcmd = 
						new AddRealLiteralExpressionFirstOperandToBinaryOperatorExpressionEXPCmd((RealLiteralExpression)operandExpr, (BinaryOperatorExpression)parentExpr);	
					wrapperCmd.appendAndExecute(addcmd);				
				}else if (parentExpr instanceof FunctionArgument){
					AddRealLiteralExpressionToFunctionArgumentEXPCmd addcmd = 
						new AddRealLiteralExpressionToFunctionArgumentEXPCmd((RealLiteralExpression)operandExpr, (FunctionArgument)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);
				}else if (parentExpr instanceof UnaryOperatorExpression){
					AddRealLiteralExpressionToUnaryOperatorExpressionEXPCmd addcmd = 
						new AddRealLiteralExpressionToUnaryOperatorExpressionEXPCmd((RealLiteralExpression)operandExpr, (UnaryOperatorExpression)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);				
				}
			}catch (RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.UPDATE_FIRST_OPRERAND_EXCEPTION, new String[]{operandExpr.getUid()}, ex);
			}
		*/
		}else if (operandExpr instanceof  StringLiteralExpression){
			try{
				if (parentExpr instanceof BinaryOperatorExpression){
					AddStringLiteralExpressionFirstOperandToBinaryOperatorExpressionEXPCmd addcmd = 
						new AddStringLiteralExpressionFirstOperandToBinaryOperatorExpressionEXPCmd((StringLiteralExpression)operandExpr, (BinaryOperatorExpression)parentExpr);	
					wrapperCmd.appendAndExecute(addcmd);
				}else if (parentExpr instanceof FunctionArgument){
					AddStringLiteralExpressionToFunctionArgumentEXPCmd addcmd = 
						new AddStringLiteralExpressionToFunctionArgumentEXPCmd((StringLiteralExpression)operandExpr, (FunctionArgument)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);
				}else if (parentExpr instanceof UnaryOperatorExpression){
					AddStringLiteralExpressionToUnaryOperatorExpressionEXPCmd addcmd = 
						new AddStringLiteralExpressionToUnaryOperatorExpressionEXPCmd((StringLiteralExpression)operandExpr, (UnaryOperatorExpression)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);			
				}
			}catch (RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.UPDATE_FIRST_OPRERAND_EXCEPTION, new String[]{operandExpr.getUid()}, ex);
			}
		}else if (operandExpr instanceof  UnionExpression){
			try{
				if (parentExpr instanceof BinaryOperatorExpression){
					AddUnionExpressionFirstOperandToBinaryOperatorExpressionEXPCmd addcmd = 
						new AddUnionExpressionFirstOperandToBinaryOperatorExpressionEXPCmd((UnionExpression)operandExpr, (BinaryOperatorExpression)parentExpr);	
					wrapperCmd.appendAndExecute(addcmd);
				}else if (parentExpr instanceof FunctionArgument){
					AddUnionExpressionToFunctionArgumentEXPCmd addcmd = 
						new AddUnionExpressionToFunctionArgumentEXPCmd((UnionExpression)operandExpr, (FunctionArgument)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);
				}else if (parentExpr instanceof UnaryOperatorExpression){
					AddUnionExpressionToUnaryOperatorExpressionEXPCmd addcmd = 
						new AddUnionExpressionToUnaryOperatorExpressionEXPCmd((UnionExpression)operandExpr, (UnaryOperatorExpression)parentExpr);
					wrapperCmd.appendAndExecute(addcmd);				
				}
			}catch (RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.UPDATE_FIRST_OPRERAND_EXCEPTION, new String[]{operandExpr.getUid()}, ex);
			}
		} else if (operandExpr instanceof VariableExpression) {  // newly added to support the VariableExpression
			try{
				if (parentExpr instanceof BinaryOperatorExpression){
					AddVariableExpressionFirstOperandToBinaryOperatorExpressionEXPCmd addcmd = 
						new AddVariableExpressionFirstOperandToBinaryOperatorExpressionEXPCmd((VariableExpression)operandExpr, (BinaryOperatorExpression)parentExpr);	
					wrapperCmd.appendAndExecute(addcmd);
				}
			}catch (RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.UPDATE_FIRST_OPRERAND_EXCEPTION, new String[]{operandExpr.getUid()}, ex);
			}			
		}		
		LoggingUtil.traceExit(this, "updateFirstOperand");
	}
		
}
