package com.ibm.btools.blm.ie.imprt.rule.expressionModel;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import com.ibm.btools.blm.ie.imprt.rule.util.LoggingUtil;
import com.ibm.btools.blm.ie.resource.IeMessageKeys;
import com.ibm.btools.emf.cf.BtCompoundCommand;
import com.ibm.btools.expression.command.AddBinaryLogicalBooleanExpressionSecondOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddBinaryNumericExpressionSecondOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddBooleanLiteralExpressionSecondOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddComparisonExpressionSecondOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddDurationLiteralExpressionSecondOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddFunctionExpressionSecondOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddNumericLiteralExpressionSecondOperandToBinaryOperatorExpressionEXPCmd;
//import com.ibm.btools.expression.command.AddIntegerLiteralExpressionSecondOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddModelPathExpressionSecondOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddNegationExpressionSecondOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddNotExpressionSecondOperandToBinaryOperatorExpressionEXPCmd;
//import com.ibm.btools.expression.command.AddRealLiteralExpressionSecondOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddStringLiteralExpressionSecondOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.command.AddUnionExpressionSecondOperandToBinaryOperatorExpressionEXPCmd;
import com.ibm.btools.expression.model.BinaryLogicalBooleanExpression;
import com.ibm.btools.expression.model.BinaryNumericExpression;
import com.ibm.btools.expression.model.BinaryOperatorExpression;
import com.ibm.btools.expression.model.BooleanLiteralExpression;
import com.ibm.btools.expression.model.ComparisonExpression;
import com.ibm.btools.expression.model.DurationLiteralExpression;
import com.ibm.btools.expression.model.Expression;
import com.ibm.btools.expression.model.FunctionExpression;
import com.ibm.btools.expression.model.NumericLiteralExpression;
//import com.ibm.btools.expression.model.IntegerLiteralExpression;
import com.ibm.btools.expression.model.ModelPathExpression;
import com.ibm.btools.expression.model.NegationExpression;
import com.ibm.btools.expression.model.NotExpression;
//import com.ibm.btools.expression.model.RealLiteralExpression;
import com.ibm.btools.expression.model.StringLiteralExpression;
import com.ibm.btools.expression.model.UnionExpression;


public class UpdateSecondOperandRule extends UpdateExpressionRule{
	
	//copyright
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	
	private Expression sourceExpr;
	private Expression workingCopy;
	protected Expression parentExpression;

	/**
	 * Set Original StructuredOpaqueExpression
	 * @param expr
	 */
	public void setSource(final Object expression) {
		this.sourceExpr = (Expression) expression;
	}
	
	/**
	 * Set the working copy
	 * @param workingCopy
	 */
	public void setWorkingCopy(final Object workingCopy) {
		this.workingCopy = (Expression) workingCopy;
	}
	
	/**
	 * @param parentExpression
	 */
	protected void setParentExpression(final Object parentExpression){
		this.parentExpression = (Expression)parentExpression;
	}
		
	
	/**
	 * Invoke the rule
	 */
	public void invoke() {
		LoggingUtil.traceEntry(this, "invoke");
		if (parentExpression instanceof BinaryOperatorExpression)
			updateSecondOperand(workingCopy, (BinaryOperatorExpression)parentExpression, wrapperCmd);
		LoggingUtil.traceExit(this, "invoke");
	}

	private void updateSecondOperand(Expression operandExpr, BinaryOperatorExpression parentExpr, BtCompoundCommand wrapperCmd){
		LoggingUtil.traceEntry(this, "updateSecondOperand");
		try{
		
			if (operandExpr instanceof BinaryLogicalBooleanExpression ){
				AddBinaryLogicalBooleanExpressionSecondOperandToBinaryOperatorExpressionEXPCmd addcmd = 
					new AddBinaryLogicalBooleanExpressionSecondOperandToBinaryOperatorExpressionEXPCmd((BinaryLogicalBooleanExpression)operandExpr, parentExpr);
				wrapperCmd.appendAndExecute(addcmd);
				
			}else if (operandExpr instanceof  BinaryNumericExpression) {
				AddBinaryNumericExpressionSecondOperandToBinaryOperatorExpressionEXPCmd addcmd = 
					new AddBinaryNumericExpressionSecondOperandToBinaryOperatorExpressionEXPCmd((BinaryNumericExpression)operandExpr, parentExpr);
				wrapperCmd.appendAndExecute(addcmd);
				
			}else if (operandExpr instanceof  BooleanLiteralExpression ){
				AddBooleanLiteralExpressionSecondOperandToBinaryOperatorExpressionEXPCmd addcmd = 
					new AddBooleanLiteralExpressionSecondOperandToBinaryOperatorExpressionEXPCmd((BooleanLiteralExpression)operandExpr, parentExpr);	
				wrapperCmd.appendAndExecute(addcmd);
				
			}else if (operandExpr instanceof  ComparisonExpression){
				AddComparisonExpressionSecondOperandToBinaryOperatorExpressionEXPCmd addcmd = 
					new AddComparisonExpressionSecondOperandToBinaryOperatorExpressionEXPCmd((ComparisonExpression)operandExpr, parentExpr);	
				wrapperCmd.appendAndExecute(addcmd);
					
			}else if (operandExpr instanceof  FunctionExpression){
				AddFunctionExpressionSecondOperandToBinaryOperatorExpressionEXPCmd addcmd = 
					new AddFunctionExpressionSecondOperandToBinaryOperatorExpressionEXPCmd((FunctionExpression)operandExpr, parentExpr);
				wrapperCmd.appendAndExecute(addcmd);
					
			}else if (operandExpr instanceof  NumericLiteralExpression){
				AddNumericLiteralExpressionSecondOperandToBinaryOperatorExpressionEXPCmd addcmd = 
					new AddNumericLiteralExpressionSecondOperandToBinaryOperatorExpressionEXPCmd((NumericLiteralExpression)operandExpr, parentExpr);	
				wrapperCmd.appendAndExecute(addcmd);
				
			}else if (operandExpr instanceof  ModelPathExpression){
				AddModelPathExpressionSecondOperandToBinaryOperatorExpressionEXPCmd addcmd = 
					new AddModelPathExpressionSecondOperandToBinaryOperatorExpressionEXPCmd((ModelPathExpression)operandExpr, parentExpr);	
				wrapperCmd.appendAndExecute(addcmd);
				
			}else if (operandExpr instanceof  NegationExpression){
				AddNegationExpressionSecondOperandToBinaryOperatorExpressionEXPCmd addcmd = 
					new AddNegationExpressionSecondOperandToBinaryOperatorExpressionEXPCmd((NegationExpression)operandExpr, parentExpr);	
				wrapperCmd.appendAndExecute(addcmd);
				
			}else if (operandExpr instanceof  NotExpression){
				AddNotExpressionSecondOperandToBinaryOperatorExpressionEXPCmd addcmd = 
					new AddNotExpressionSecondOperandToBinaryOperatorExpressionEXPCmd((NotExpression)operandExpr, parentExpr);		
				wrapperCmd.appendAndExecute(addcmd);
			/*	
			}else if (operandExpr instanceof  RealLiteralExpression){
				AddRealLiteralExpressionSecondOperandToBinaryOperatorExpressionEXPCmd addcmd = 
					new AddRealLiteralExpressionSecondOperandToBinaryOperatorExpressionEXPCmd((RealLiteralExpression)operandExpr, parentExpr);	
				wrapperCmd.appendAndExecute(addcmd);
			*/	
			}else if (operandExpr instanceof  StringLiteralExpression){
				AddStringLiteralExpressionSecondOperandToBinaryOperatorExpressionEXPCmd addcmd = 
					new AddStringLiteralExpressionSecondOperandToBinaryOperatorExpressionEXPCmd((StringLiteralExpression)operandExpr, parentExpr);	
				wrapperCmd.appendAndExecute(addcmd);
					
			}else if (operandExpr instanceof  UnionExpression){
				AddUnionExpressionSecondOperandToBinaryOperatorExpressionEXPCmd addcmd = 
					new AddUnionExpressionSecondOperandToBinaryOperatorExpressionEXPCmd((UnionExpression)operandExpr, parentExpr);	
				wrapperCmd.appendAndExecute(addcmd);
				
			} else if (operandExpr instanceof DurationLiteralExpression) { //newly added to support the DurationLiteralExpression
				AddDurationLiteralExpressionSecondOperandToBinaryOperatorExpressionEXPCmd addcmd = 
					new AddDurationLiteralExpressionSecondOperandToBinaryOperatorExpressionEXPCmd((DurationLiteralExpression)operandExpr, parentExpr);	
				wrapperCmd.appendAndExecute(addcmd);				
			}
		}catch(RuntimeException ex){
			LoggingUtil.logWarning(getImportSession(), IeMessageKeys.ADD_SECOND_OPERAND_EXCEPTION, new String[]{operandExpr.getUid()}, ex);
		}
		LoggingUtil.traceExit(this, "updateSecondOperand");
	}	
	
}
