package com.ibm.btools.blm.ie.imprt.rule.organizationModel;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import java.util.Iterator;

import org.eclipse.emf.common.util.EList;

import com.ibm.btools.blm.ie.imprt.rule.informationModel.UpdateClassifierRule;
import com.ibm.btools.blm.ie.imprt.rule.informationModel.UpdatePropertyRule;
import com.ibm.btools.bom.command.artifacts.AddPropertyToLocationTypeBOMCmd;
import com.ibm.btools.bom.command.artifacts.UpdatePropertyBOMCmd;
import com.ibm.btools.bom.model.artifacts.Property;
import com.ibm.btools.bom.model.organizationstructures.LocationType;


public class UpdateLocationDefinitionRule extends UpdateClassifierRule {
	
	static final String COPYRIGHT = " Copyright IBM Corporation 2004, 2009." ;

	/* (non-Javadoc)
	 * @see com.ibm.btools.blm.ie.imprt.rule.IImportRule#invoke()
	 */
	public void invoke() {
		super.invoke();
		createProperties();
	}
	
	private void createProperties() {	
		
		EList attributes =((LocationType) classifier).getOwnedAttribute();
		Iterator iterator = attributes.iterator();
		Property property = null;
		Property workingProperty = null;
		AddPropertyToLocationTypeBOMCmd addCmd = null;	
		UpdatePropertyBOMCmd updateCmd = null;
		while(iterator.hasNext()) {
			property = (Property) iterator.next();
			addCmd = new AddPropertyToLocationTypeBOMCmd((LocationType)workingCopy);
			if (addCmd.canExecute()) {
				addCmd.execute();
			} else {
				continue;
			}
			workingProperty = (Property)addCmd.getObject();
			
			UpdatePropertyRule rule = new UpdatePropertyRule();
			rule.setImportSession(getImportSession());
			rule.setProjectName(getProjectName());
			rule.setSource(property);
			rule.setWorkingCopy(workingProperty);
			rule.invoke();
		}
	}


}
