package com.ibm.btools.blm.ie.imprt.rule.processModel;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.util.Iterator;

import org.eclipse.emf.common.util.EList;

import com.ibm.btools.blm.ie.imprt.rule.util.LoggingUtil;
import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.bom.model.processes.activities.ActivityNode;
import com.ibm.btools.bom.model.processes.activities.StructuredActivityNode;


/**
 * Update the StructuredActivityNode's Expression
 */
public class UpdateStructuredActivityNodeExpressionRule extends UpdateActionExpressionRule {
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	
	
	/**
	 * Update Implementation
	 */
	protected void updateImplementationExpression() {
		LoggingUtil.traceEntry(this, "updateImplementationExpression");	
		EList nodeContentsList = ((StructuredActivityNode)action).getNodeContents();
		Iterator iterator = nodeContentsList.iterator();
		ActivityNode node = null;
		UpdateActionExpressionRule rule = null;
		while(iterator.hasNext()) {
			node = (ActivityNode) iterator.next();
			if (node instanceof Action) {
				if (node instanceof StructuredActivityNode) {
					rule = new UpdateStructuredActivityNodeExpressionRule();
					rule.setWorkingCopy(getWorkingCopy(node));
					rule.setImportSession(getImportSession());
					rule.setProjectName(getProjectName());
					rule.setSource(node);
					rule.setProcess(process);
					rule.invoke();	
				} else {
					rule = new UpdateActionExpressionRule();
					rule.setWorkingCopy(getWorkingCopy(node));
					rule.setImportSession(getImportSession());
					rule.setProjectName(getProjectName());
					rule.setSource(node);
					rule.setProcess(process);
					rule.invoke();
				}
			}
		}	
		LoggingUtil.traceExit(this, "updateImplementationExpression");	
	}
}
