package com.ibm.btools.blm.ie.imprt.rule.processModel.node;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.util.Iterator;

import org.eclipse.emf.ecore.EObject;

import com.ibm.btools.blm.compoundcommand.gef.DomainViewObjectHelper;
import com.ibm.btools.blm.ie.imprt.rule.util.IImportResultMessages;
import com.ibm.btools.blm.ie.imprt.rule.util.LoggingUtil;
import com.ibm.btools.blm.ie.resource.IeMessageKeys;
import com.ibm.btools.bom.command.processes.activities.UpdateInitialNodeBOMCmd;
import com.ibm.btools.bom.model.processes.activities.InitialNode;
import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.cef.model.CommonNodeModel;


/**
 * Update the InitialNode
 */
public class UpdateInitialNodeRule extends UpdateControlNodeRule {
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	
	
	/**
	 * Update Model
	 */
	protected void updateModel() {		
		LoggingUtil.traceEntry(this, "updateModel");
		super.updateModel();

		if (domainModel == null) {
			LoggingUtil.traceExit(this, "updateModel");
			return;
		}		
		if (node instanceof InitialNode && domainModel instanceof InitialNode) {
			Iterator entryIterator = ((InitialNode)node).getEntryPoint().iterator();
			InputPinSet pinSet = null;
			Object pinSetViewModel = null;
			Object pinSetDomainModel = null;
			while(entryIterator.hasNext()) {
				pinSet = (InputPinSet) entryIterator.next();
				pinSetViewModel = getModelFromContext(pinSet);
				if (pinSetViewModel == null) {
					LoggingUtil.traceExit(this, "updateModel");
					return;
				}				
				if (pinSetViewModel instanceof CommonNodeModel) {
					pinSetDomainModel = DomainViewObjectHelper.getDomainObject((EObject)pinSetViewModel);
					if (pinSetDomainModel instanceof InputPinSet) {
						UpdateInitialNodeBOMCmd cmd = new UpdateInitialNodeBOMCmd((InitialNode)domainModel);
						cmd.addEntryPoint((InputPinSet)pinSetDomainModel);
						if (cmd.canExecute()) {
							try {
								cmd.execute();
							} catch (RuntimeException e) {
								logWarning(getImportSession(), 
									IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null,  
									IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
							}								
						} else {
							logWarning(getImportSession(), 
								IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
								IImportResultMessages.CANNOT_EXECUTE_BOM_COMMAND);			
						}
					}
				}		
			}
		}
					
		LoggingUtil.traceExit(this, "updateModel");
	}	
}
