package com.ibm.btools.blm.ie.imprt.rule.processModel.node;

import java.util.HashMap;

import com.ibm.btools.blm.ie.imprt.rule.util.BOMUtil;
import com.ibm.btools.blm.ie.imprt.rule.util.LoggingUtil;
import com.ibm.btools.bom.model.processes.actions.Map;

/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

/**
 * Update the Map
 */
public class UpdateMapRule extends UpdateApplyFunctionActionRule {
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$		

	/**
	 * Update Model
	 */
	protected void updateModel() {		
		LoggingUtil.traceEntry(this, "updateModel");
		
		super.updateModel();
		
		if (action instanceof Map && domainModel instanceof Map) {
			
        //	20050413 - create the UID hashmap for ADF Import
			if (action.getUid() != null) {
				HashMap processHashMap = BOMUtil.getUIDMap(getImportSession().getContext());
				// track the source process elements UID as 'key' and its corresponding working copy process element UID as 'value'
				processHashMap.put(action.getUid(), ((Map)domainModel).getUid());
			}
			// end of 20050413 - create the UID hashmap for ADF Import			
		}		
		
		// operational data
		createOperationalData();
		
		LoggingUtil.traceExit(this, "updateModel");
	}
}
