package com.ibm.btools.blm.ie.imprt.rule.processModel.node;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import org.eclipse.emf.common.util.EList;

import com.ibm.btools.blm.ie.imprt.rule.util.IImportResultMessages;
import com.ibm.btools.blm.ie.imprt.rule.util.LoggingUtil;
import com.ibm.btools.blm.ie.resource.IeMessageKeys;
import com.ibm.btools.bom.command.processes.activities.UpdateInputPinSetBOMCmd;
import com.ibm.btools.bom.command.processes.activities.UpdateOutputPinSetBOMCmd;
import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.bom.model.processes.activities.OutputPinSet;


/**
 * Update the Control Action
 */
public class UpdateSinglePinSetControlActionRule extends UpdateControlActionRule {
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	
	/**
	 * Update single pin sets
	 */
	protected void updateSinglePinSets() {
		LoggingUtil.traceEntry(this, "updateSinglePinSets");
		Object pinSet = null;
		Object newPinSet = null;
		String name = null;
		EList newList = ((Action)domainModel).getInputPinSet();
		EList list = (action).getInputPinSet();
		if (newList.size() > 0 && list.size() > 0) {
			newPinSet = newList.get(0);
			pinSet = list.get(0);
			name = ((InputPinSet)pinSet).getName();
			if (name != null) {
				UpdateInputPinSetBOMCmd cmd = new UpdateInputPinSetBOMCmd((InputPinSet)newPinSet);
				cmd.setName(name);
			
				if (cmd.canExecute()) {
					try {
						cmd.execute();
					} catch (RuntimeException e) {
						logWarning(getImportSession(), 
							IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
							IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
					}
				} else {
					logWarning(getImportSession(), 
						IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
						IImportResultMessages.CANNOT_EXECUTE_BOM_COMMAND);	
				}						
			}
		}
		
		newList = ((Action)domainModel).getOutputPinSet();
		list = (action).getOutputPinSet();
		if (newList.size() > 0 && list.size() > 0) {
			newPinSet = newList.get(0);
			pinSet = list.get(0);
			name = ((OutputPinSet)pinSet).getName();
			if (name != null) {
				UpdateOutputPinSetBOMCmd cmd = new UpdateOutputPinSetBOMCmd((OutputPinSet)newPinSet);
				cmd.setName(name);
			
				if (cmd.canExecute()) {
					try {
						cmd.execute();
					} catch (RuntimeException e) {
						logWarning(getImportSession(), 
							IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
							IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
					}
				} else {
					logWarning(getImportSession(), 
						IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
						IImportResultMessages.CANNOT_EXECUTE_BOM_COMMAND);
				}	
			}						
		}
		LoggingUtil.traceExit(this, "updateSinglePinSets");
	}
}
