package com.ibm.btools.blm.ie.imprt.rule.processModel.node;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.OperationCanceledException;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

import com.ibm.btools.blm.compoundcommand.gef.DomainViewObjectHelper;
import com.ibm.btools.blm.compoundcommand.pe.conn.add.AddAssociationConnPeCmd;
import com.ibm.btools.blm.compoundcommand.pe.factory.PeCmdFactory;
import com.ibm.btools.blm.compoundcommand.pe.factory.RemovePeCmd;
import com.ibm.btools.blm.compoundcommand.pe.node.add.AddCommentPeCmd;
import com.ibm.btools.blm.compoundcommand.process.util.PECommandConstants;
import com.ibm.btools.blm.ie.imprt.IImportFramework;
import com.ibm.btools.blm.ie.imprt.ImportContext;
import com.ibm.btools.blm.ie.imprt.ImportSession;
import com.ibm.btools.blm.ie.imprt.engine.ProgressCalculator;
import com.ibm.btools.blm.ie.imprt.rule.processModel.UpdateEdgeRule;
import com.ibm.btools.blm.ie.imprt.rule.processModel.UpdateRepositoryFlowRule;
import com.ibm.btools.blm.ie.imprt.rule.processModel.UpdateVariableRule;
import com.ibm.btools.blm.ie.imprt.rule.processModel.UpdateViewModelRule;
import com.ibm.btools.blm.ie.imprt.rule.util.BOMUtil;
import com.ibm.btools.blm.ie.imprt.rule.util.IImportResultMessages;
import com.ibm.btools.blm.ie.imprt.rule.util.LoggingUtil;
import com.ibm.btools.blm.ie.imprt.rule.util.NavigatorUtil;
import com.ibm.btools.blm.ie.resource.IeMessageKeys;
import com.ibm.btools.blm.ui.navigation.model.NavigationCalendarNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProjectNode;
import com.ibm.btools.bom.command.artifacts.AddCommentToElementBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddConstraintToNamedElementBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralBooleanToTemplateInstanceRuleBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralDurationToEscalationActionBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralDurationToEscalationBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralIntegerToTemplateInstanceRuleBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralRealToTemplateInstanceRuleBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralStringToTemplateInstanceRuleBOMCmd;
import com.ibm.btools.bom.command.artifacts.UpdateCommentBOMCmd;
import com.ibm.btools.bom.command.artifacts.UpdateLiteralDurationBOMCmd;
import com.ibm.btools.bom.command.artifacts.UpdateNamedElementBOMCmd;
import com.ibm.btools.bom.command.compound.PredefTypesConst;
import com.ibm.btools.bom.command.processes.activities.UpdateRetrieveArtifactPinBOMCmd;
import com.ibm.btools.bom.command.processes.activities.UpdateSANBOMCmd;
import com.ibm.btools.bom.command.processes.activities.UpdateStoreArtifactPinBOMCmd;
import com.ibm.btools.bom.command.processes.businessrules.AddBusinessRuleBlockToBusinessRuleSetBOMCmd;
import com.ibm.btools.bom.command.processes.businessrules.AddBusinessRuleGroupToBusinessRuleActionBOMCmd;
import com.ibm.btools.bom.command.processes.businessrules.AddBusinessRuleSetSelectionRecordToBusinessRuleGroupBOMCmd;
import com.ibm.btools.bom.command.processes.businessrules.AddBusinessRuleSetToBusinessRuleActionBOMCmd;
import com.ibm.btools.bom.command.processes.businessrules.AddBusinessRuleTemplateToBusinessRuleSetBOMCmd;
import com.ibm.btools.bom.command.processes.businessrules.AddIfThenRuleToBusinessRuleBlockBOMCmd;
import com.ibm.btools.bom.command.processes.businessrules.AddIfThenRuleToBusinessRuleTemplateBOMCmd;
import com.ibm.btools.bom.command.processes.businessrules.AddTemplateInstanceRuleToBusinessRuleBlockBOMCmd;
import com.ibm.btools.bom.command.processes.businessrules.AddTemplateParameterToBusinessRuleTemplateBOMCmd;
import com.ibm.btools.bom.command.processes.humantasks.AddEmailEscalationActionToEscalationBOMCmd;
import com.ibm.btools.bom.command.processes.humantasks.AddEmailMessageToHumanTaskBOMCmd;
import com.ibm.btools.bom.command.processes.humantasks.AddEscalationChainToHumanTaskBOMCmd;
import com.ibm.btools.bom.command.processes.humantasks.AddEscalationToEscalationChainBOMCmd;
import com.ibm.btools.bom.command.processes.humantasks.AddRecurringTimeToHumanTaskBOMCmd;
import com.ibm.btools.bom.command.processes.humantasks.AddWorkItemEscalationActionToEscalationBOMCmd;
import com.ibm.btools.bom.command.processes.humantasks.UpdateHumanTaskBOMCmd;
import com.ibm.btools.bom.command.resources.AddIndividualResourceRequirementToEscalationActionBOMCmd;
import com.ibm.btools.bom.command.time.UpdateTimeIntervalsBOMCmd;
import com.ibm.btools.bom.model.artifacts.Comment;
import com.ibm.btools.bom.model.artifacts.Constraint;
import com.ibm.btools.bom.model.artifacts.Element;
import com.ibm.btools.bom.model.artifacts.LiteralBoolean;
import com.ibm.btools.bom.model.artifacts.LiteralDuration;
import com.ibm.btools.bom.model.artifacts.LiteralInteger;
import com.ibm.btools.bom.model.artifacts.LiteralReal;
import com.ibm.btools.bom.model.artifacts.LiteralString;
import com.ibm.btools.bom.model.artifacts.Type;
import com.ibm.btools.bom.model.artifacts.ValueSpecification;
import com.ibm.btools.bom.model.artifacts.impl.ConstraintImpl;
import com.ibm.btools.bom.model.processes.actions.AcceptSignalAction;
import com.ibm.btools.bom.model.processes.actions.BroadcastSignalAction;
import com.ibm.btools.bom.model.processes.actions.CallBehaviorAction;
import com.ibm.btools.bom.model.processes.actions.Decision;
import com.ibm.btools.bom.model.processes.actions.Fork;
import com.ibm.btools.bom.model.processes.actions.Join;
import com.ibm.btools.bom.model.processes.actions.Map;
import com.ibm.btools.bom.model.processes.actions.Merge;
import com.ibm.btools.bom.model.processes.actions.ObserverAction;
import com.ibm.btools.bom.model.processes.actions.TimerAction;
import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.bom.model.processes.activities.ActivityEdge;
import com.ibm.btools.bom.model.processes.activities.ActivityNode;
import com.ibm.btools.bom.model.processes.activities.ControlNode;
import com.ibm.btools.bom.model.processes.activities.FlowFinalNode;
import com.ibm.btools.bom.model.processes.activities.ForLoopNode;
import com.ibm.btools.bom.model.processes.activities.InitialNode;
import com.ibm.btools.bom.model.processes.activities.LoopNode;
import com.ibm.btools.bom.model.processes.activities.Repository;
import com.ibm.btools.bom.model.processes.activities.RetrieveArtifactPin;
import com.ibm.btools.bom.model.processes.activities.StoreArtifactPin;
import com.ibm.btools.bom.model.processes.activities.StructuredActivityNode;
import com.ibm.btools.bom.model.processes.activities.TerminationNode;
import com.ibm.btools.bom.model.processes.activities.Variable;
import com.ibm.btools.bom.model.processes.businessrules.BusinessRule;
import com.ibm.btools.bom.model.processes.businessrules.BusinessRuleAction;
import com.ibm.btools.bom.model.processes.businessrules.BusinessRuleBlock;
import com.ibm.btools.bom.model.processes.businessrules.BusinessRuleGroup;
import com.ibm.btools.bom.model.processes.businessrules.BusinessRuleSet;
import com.ibm.btools.bom.model.processes.businessrules.BusinessRuleSetSelectionRecord;
import com.ibm.btools.bom.model.processes.businessrules.BusinessRuleTemplate;
import com.ibm.btools.bom.model.processes.businessrules.IfThenRule;
import com.ibm.btools.bom.model.processes.businessrules.TemplateInstanceRule;
import com.ibm.btools.bom.model.processes.businessrules.TemplateParameter;
import com.ibm.btools.bom.model.processes.humantasks.EmailEscalationAction;
import com.ibm.btools.bom.model.processes.humantasks.EmailMessage;
import com.ibm.btools.bom.model.processes.humantasks.Escalation;
import com.ibm.btools.bom.model.processes.humantasks.EscalationAction;
import com.ibm.btools.bom.model.processes.humantasks.EscalationChain;
import com.ibm.btools.bom.model.processes.humantasks.HumanTask;
import com.ibm.btools.bom.model.resources.IndividualResourceRequirement;
import com.ibm.btools.bom.model.resources.IndividualResourceType;
import com.ibm.btools.bom.model.resources.ResourceRequirement;
import com.ibm.btools.bom.model.resources.Role;
import com.ibm.btools.bom.model.time.RecurringTimeIntervals;
import com.ibm.btools.bom.model.time.TimeIntervals;
import com.ibm.btools.cef.model.CommonNodeModel;
import com.ibm.btools.cef.model.Content;
import com.ibm.btools.expression.bom.command.AddExpressionToStructuredOpaqueExpressionBEXCmd;
import com.ibm.btools.expression.bom.command.AddStructuredOpaqueExpressionToConstraintBEXCmd;
import com.ibm.btools.expression.bom.command.AddStructuredOpaqueExpressionToIfThenRuleBEXCmd;
import com.ibm.btools.expression.bom.command.CreateStructuredOpaqueExpressionBEXCmd;
import com.ibm.btools.expression.bom.model.StructuredOpaqueExpression;
import com.ibm.btools.expression.command.AddFunctionArgumentDefinitionToFunctionDefinitionEXPCmd;
import com.ibm.btools.expression.command.AddFunctionArgumentToFunctionExpressionEXPCmd;
import com.ibm.btools.expression.command.AddFunctionDefinitionToFunctionExpressionEXPCmd;
import com.ibm.btools.expression.command.AddStringLiteralExpressionToFunctionArgumentEXPCmd;
import com.ibm.btools.expression.command.CreateFuncionExpressionEXPCmd;
import com.ibm.btools.expression.command.UpdateStringLiteralExpressionEXPCmd;
import com.ibm.btools.expression.model.FunctionArgument;
import com.ibm.btools.expression.model.FunctionArgumentDefinition;
import com.ibm.btools.expression.model.FunctionDefinition;
import com.ibm.btools.expression.model.FunctionExpression;
import com.ibm.btools.expression.model.StringLiteralExpression;
import com.ibm.btools.model.filemanager.FileMGR;
import com.ibm.btools.model.resourcemanager.ResourceMGR;
import com.ibm.btools.model.resourcemanager.util.PredefUtil;
import com.ibm.btools.util.ContextVariables;
import com.ibm.btools.util.resource.CommonMessageKeys;
import com.ibm.btools.util.resource.UtilResourceBundleSingleton;

/**
* Update the StructuredActivityNode
*/
public class UpdateStructuredActivityNodeRule extends UpdateActionRule {
	// copyright
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	
	//info need context variables when its of type RESOURCES_THAT_ARE_RECEIVERS_OF_ANOTHER_ESCALATION
	//to convert name to id
	HashMap<String, String> escalationNameIdMap = new HashMap<String, String>();
	List<FunctionArgument> cvFunctionArgList = new ArrayList(); 
	ContextVariables cv = ContextVariables.getInstance();

	/**
	 * Update Model
	 */
	protected void updateModel() {
		LoggingUtil.traceEntry(this, "updateModel");
		super.updateModel();
		clearContent();

		createVariables();

		createNodeContents();

		createEdgeContents();

		// Attribute mustIsolate
		updateAttribute();

		// operational data
		createOperationalData();
		
		// Create the repository flow
		createRepositoryFlow();
		
		if (action instanceof StructuredActivityNode && domainModel instanceof StructuredActivityNode) {		
			// 20050413 - create the UID hashmap for ADF Import
			if (action.getUid() != null) {
				HashMap processHashMap = BOMUtil.getUIDMap(getImportSession().getContext());
				// track the source process elements UID as 'key' and its corresponding working copy process element UID as 'value'
				processHashMap.put(action.getUid(), ((StructuredActivityNode)domainModel).getUid());
			}
			// end of 20050413 - create the UID hashmap for ADF Import		
		}
		
		if(domainModel instanceof HumanTask) {
			createHumanTaskRuleGroup();
		} else if (domainModel instanceof BusinessRuleAction) {
			createBusinessRuleGroup();
		}

		LoggingUtil.traceExit(this, "updateModel");
	}
	
	/**
	 * update HumanTask
	 *
	 */
	protected void createHumanTaskRuleGroup() {
		HumanTask srcHumanTask = (HumanTask)action;
		HumanTask trgHumanTask = (HumanTask)domainModel;
		ResourceRequirement resReq = srcHumanTask.getPotentialOwner();	
		//add time table to Human task
		addTimeTableToHumanTask(srcHumanTask.getRecurringTime(), trgHumanTask);
		//add primaryOwner to Human task
		addPrimaryOwnerToHumanTask(resReq,trgHumanTask);
		if (resReq != null) {
			//add description to primaryOwner		
			copyCommentToElement(resReq.getOwnedComment(), (Element)trgHumanTask.getPotentialOwner());	
			//add constraints/criteria info to primaryOwner
			addConstraint(resReq, trgHumanTask.getPotentialOwner());
		}
		//add email messages to HumanTasks
		addEmailMsgToHumanTask(srcHumanTask,trgHumanTask);
		//add escalations
		addEscalationChainToHumanTask(srcHumanTask, trgHumanTask);
		//post process convert name to id for any RESOURCES_THAT_ARE_RECEIVERS_OF_ANOTHER_ESCALATION context variable
		convertNameToIdCV();
	}
	
	/**
	 * update timetables to Humantask
	 * @param srcTimeInterval
	 * @param trgHT
	 */
	private void addTimeTableToHumanTask(TimeIntervals srcTimeInterval, HumanTask trgHT) {
		if (srcTimeInterval == null) {
			return;
		}
		//add timeintervals to HT
		AddRecurringTimeToHumanTaskBOMCmd addRTtoHTCmd = new AddRecurringTimeToHumanTaskBOMCmd(trgHT);
		executeCmd(addRTtoHTCmd);
		TimeIntervals recurringTime =(TimeIntervals)addRTtoHTCmd.getObject();
		
		//update the name of timeintervals
		UpdateNamedElementBOMCmd updTimeIntervalsNameCmd = new UpdateNamedElementBOMCmd(recurringTime);
		String timeIntervalsElementName = trgHT.getName() + "_RecurringTime"; 
		updTimeIntervalsNameCmd.setName(timeIntervalsElementName);
		executeCmd(updTimeIntervalsNameCmd);

		RecurringTimeIntervals trgRecurringTimeInterval = null;
		//add timetables to timeIntervals
		List<RecurringTimeIntervals> srcRecurringTimeInterval = srcTimeInterval.getRecurringTimeIntervals();
		for (RecurringTimeIntervals srcRTInterval : srcRecurringTimeInterval) {			
			ImportContext context = getImportSession().getContext();
			NavigationCalendarNode node = (NavigationCalendarNode)context.get(srcRTInterval);
			String id = (String)node.getEntityReferences().get(0);
			String path = FileMGR.getProjectPath(getProjectName());
			EList temp = ResourceMGR.getResourceManger().getRootObjects(getProjectName(), path, id);
			trgRecurringTimeInterval = (RecurringTimeIntervals)temp.get(0);			
			
			//add recurringtimeinterval(timetable) to timeintervals
			UpdateTimeIntervalsBOMCmd updateCmd = new UpdateTimeIntervalsBOMCmd(recurringTime);
			updateCmd.addRecurringTimeIntervals(trgRecurringTimeInterval);
			executeCmd(updateCmd);
		}
	}
	
	/**
	 * update primary owner for humantask
	 * @param resReq
	 * @param trgHT
	 */
	private void addPrimaryOwnerToHumanTask(ResourceRequirement resReq, HumanTask trgHT) {
		//resReq is null when dealing with older version of import xml
		if (resReq == null) {
			UpdateHumanTaskBOMCmd cmd0 = new UpdateHumanTaskBOMCmd(
					trgHT);
			UpdateHumanTaskBOMCmd cmd = new UpdateHumanTaskBOMCmd(
					trgHT);
			List required = trgHT.getResourceRequirement();
			if (required != null && !required.isEmpty()) {
				// d159547
				String primaryOwnerName = UtilResourceBundleSingleton.INSTANCE
						.getMessage(CommonMessageKeys.class,
								CommonMessageKeys.PRIMARY_OWNER);
				String personName = UtilResourceBundleSingleton.INSTANCE
						.getMessage(CommonMessageKeys.class,
								CommonMessageKeys.PERSON);

				int requiredSize = required.size();
				for (int i = 0; i < requiredSize; i++) {
					ResourceRequirement rr = (ResourceRequirement) required
							.get(i);
					if (rr.getName().equals(primaryOwnerName)) {
						resReq = rr;
						break;
					} else if (rr instanceof IndividualResourceRequirement
							&& rr.getName().equals(personName)) {
						Type resourceType = ((IndividualResourceRequirement) rr)
								.getResourceType();
						if (resourceType.getUid().equals(
								"FID-00000000000000000000000000000101")) {
							resReq = (IndividualResourceRequirement) rr;
							break;
						}
					}
				}
				cmd.setPotentialOwner(resReq);
				cmd0.appendAndExecute(cmd);
			}
		} else {
			// list of all resReq with name PrimaryOwner
			List<ResourceRequirement> trgPrimaryOwner = new ArrayList();
			// find primaryOwner from the resReq list and set the targetHT's
			// primaryOwner
			Iterator iterator = trgHT.getResourceRequirement().iterator();
			ResourceRequirement requirement = null;
			while (iterator.hasNext()) {
				requirement = (ResourceRequirement) iterator.next();
				if (resReq.getName().equals(requirement.getName())) {
					trgPrimaryOwner.add(requirement);
				}
			}
			// set the last entry as PrimaryOwer of HT from the list
			ResourceRequirement trgPO = trgPrimaryOwner.get(trgPrimaryOwner
					.size() - 1);
			UpdateHumanTaskBOMCmd cmd = new UpdateHumanTaskBOMCmd(trgHT);
			cmd.setPotentialOwner(trgPO);
			executeCmd(cmd);
		}
	}
	
	/**
	 * update criteria 
	 * @param resReq
	 * @param trgResReq
	 */
	private void addConstraint(ResourceRequirement resReq, ResourceRequirement trgResReq) {
		List<ConstraintImpl> srcConstraintList = resReq.getOwnedConstraint();
		if (srcConstraintList.isEmpty()) {
			return;
		}
		//get src info
		ConstraintImpl srcConstraint = srcConstraintList.get(0);
		StructuredOpaqueExpression srcExp = (StructuredOpaqueExpression)srcConstraint.getSpecification();
		FunctionExpression srcFunctionExp = (FunctionExpression)srcExp.getExpression();
		FunctionDefinition srcFunctionDef = srcFunctionExp.getDefinition();
		List<FunctionArgumentDefinition> srcArgDefList = srcFunctionDef.getArgumentDefinition();
		List<FunctionArgument> srcArgList = srcFunctionExp.getArguments();		
		
		//create constraint		
		AddConstraintToNamedElementBOMCmd constraintCmd = new AddConstraintToNamedElementBOMCmd(trgResReq);		
		executeCmd(constraintCmd);
		Constraint trgConstraint = (Constraint)constraintCmd.getObject();
		
		//create StructuredOpaqueExpression		
		CreateStructuredOpaqueExpressionBEXCmd expCmd = new CreateStructuredOpaqueExpressionBEXCmd();		
		executeCmd(expCmd);
		StructuredOpaqueExpression trgExp = expCmd.getStructuredOpaquedExpression();
		
		//add StructuredOpaqueExpression to constraint
		AddStructuredOpaqueExpressionToConstraintBEXCmd addExpToConstraintCmd = 
			new AddStructuredOpaqueExpressionToConstraintBEXCmd(trgExp, trgConstraint);
		executeCmd(addExpToConstraintCmd);
		
		//create functionExpression
		CreateFuncionExpressionEXPCmd funExpCmd = new CreateFuncionExpressionEXPCmd();		
		executeCmd(funExpCmd);
		FunctionExpression trgFunctionExp = funExpCmd.getExpression();
		
		//add functionExpression to StructuredOpaqueExpression
		AddExpressionToStructuredOpaqueExpressionBEXCmd addExpToOpaqueExpCmd = 
			new AddExpressionToStructuredOpaqueExpressionBEXCmd(trgFunctionExp, trgExp);
		executeCmd(addExpToOpaqueExpCmd);
		
		//add FunctionDef to FunctionExp
		AddFunctionDefinitionToFunctionExpressionEXPCmd addDefToExp = 
			new AddFunctionDefinitionToFunctionExpressionEXPCmd(trgFunctionExp);
		addDefToExp.setFunctionID(srcFunctionDef.getFunctionID());
		addDefToExp.setFunctionName(srcFunctionDef.getFunctionName());
		addDefToExp.setReturnType(srcFunctionDef.getReturnType());
		addDefToExp.setLowerBound(srcFunctionDef.getLowerBound());
		addDefToExp.setUpperBound(srcFunctionDef.getUpperBound());
		FunctionDefinition trgFunctionDef = (FunctionDefinition)addDefToExp.getObject();
		executeCmd(addDefToExp);
		
		//add FunctionArgumentDefinition to functionDefinition
		Iterator<FunctionArgumentDefinition> it = srcArgDefList.iterator();
		while(it.hasNext()) {
			FunctionArgumentDefinition srcArgDef = it.next(); 
			AddFunctionArgumentDefinitionToFunctionDefinitionEXPCmd addArgDefToDef =
					new AddFunctionArgumentDefinitionToFunctionDefinitionEXPCmd(trgFunctionDef);
			FunctionArgumentDefinition argDef = (FunctionArgumentDefinition)addArgDefToDef.getObject();
			addArgDefToDef.setArgumentID(srcArgDef.getArgumentID());
			addArgDefToDef.setArgumentName(srcArgDef.getArgumentName());
			addArgDefToDef.setArgumentType(srcArgDef.getArgumentType());	
			addArgDefToDef.setRequired(srcArgDef.getRequired());
			addArgDefToDef.setLowerBound(srcArgDef.getLowerBound());
			addArgDefToDef.setUpperBound(srcArgDef.getUpperBound());
			executeCmd(addArgDefToDef);
			
			//add FunctionArgument to Exp
			AddFunctionArgumentToFunctionExpressionEXPCmd addArgToExpCmd =
				new AddFunctionArgumentToFunctionExpressionEXPCmd(trgFunctionExp);
			addArgToExpCmd.setArgumentID(srcArgDef.getArgumentID());
			addArgToExpCmd.setDefinition(argDef);
			FunctionArgument trgArg = (FunctionArgument)addArgToExpCmd.getObject();
			executeCmd(addArgToExpCmd);
			
			//add value if exists			
			String trgValue = getArgumentValue(srcArgList,srcArgDef.getArgumentID());
			if (trgValue != null) {
				addToContextVariableFunctionArgList(trgValue, trgArg);
				AddStringLiteralExpressionToFunctionArgumentEXPCmd addValToArgCmd = 
					new AddStringLiteralExpressionToFunctionArgumentEXPCmd(trgArg);
				//resolve role with UID 
				trgValue = resolveRoleWithID(trgValue);
				addValToArgCmd.setStringSymbol(trgValue);
				executeCmd(addValToArgCmd);
			}			
		}	
	}
	
	private void addToContextVariableFunctionArgList(String val, FunctionArgument trgArg) {
		if (cv.isContextVarLongFormat(val) && cv.getExtraInfo(val) != null) {
			cvFunctionArgList.add(trgArg);
		}
	}
	
	private String resolveRoleWithID(String val) {
		String result = val;
		String[] valArray = val.split("##");
		if (valArray.length==2) {
			String tempID = valArray[1];
			ImportContext context = getImportSession().getContext();
			Set<Object> keys = context.keySet();
			Iterator<Object> it = keys.iterator();
			while(it.hasNext()) {
				Object currentObj = it.next();
				if (currentObj instanceof Role) {
					if (tempID.equals(((Role)currentObj).getUid())) {
						Role role =(Role)getModelFromContext(currentObj);
						result = role.getName()+ "###" + role.getUid();
						break;
					}
				}
			}
		}
		return result;
	}
	
	/**
	 * update email messages for humantask
	 * @param srcHumanTask
	 * @param trgHumanTask
	 */
	private void addEmailMsgToHumanTask(HumanTask srcHumanTask, HumanTask trgHumanTask) {
		List<EmailMessage> emailList = srcHumanTask.getEmailMessages();
		for (EmailMessage message : emailList) {
			AddEmailMessageToHumanTaskBOMCmd cmd = new AddEmailMessageToHumanTaskBOMCmd(trgHumanTask);
			cmd.setName(message.getName());
			cmd.setSubject(message.getSubject());
			cmd.setBody(message.getBody());
			executeCmd(cmd);
		}
	}
	
	/**
	 * update escalations
	 * @param srcHumanTask
	 * @param trgHumanTask
	 */
	private void addEscalationChainToHumanTask(HumanTask srcHumanTask, HumanTask trgHumanTask) {
		List<EscalationChain> escalationChain = srcHumanTask.getEscalationChains();
		for (EscalationChain chain : escalationChain) {
			AddEscalationChainToHumanTaskBOMCmd cmd = new AddEscalationChainToHumanTaskBOMCmd(trgHumanTask);
			cmd.setActivationState(chain.getActivationState());
			EscalationChain trgEscalationChain = (EscalationChain)cmd.getObject();
			executeCmd(cmd);
			List<Escalation> escalationList = chain.getEscalations();
			for (Escalation escalation : escalationList) {
				AddEscalationToEscalationChainBOMCmd escalationCmd = new AddEscalationToEscalationChainBOMCmd(trgEscalationChain);
				escalationCmd.setName(escalation.getName());

				//set desired task state
				escalationCmd.setDesiredState(escalation.getDesiredState());	
				Escalation trgEscalation = (Escalation)escalationCmd.getObject();
				executeCmd(escalationCmd);
				
				//add escalation name and id to hashmap need for context variable
				escalationNameIdMap.put(trgEscalation.getName(), trgEscalation.getUid());
				
				//set description
				copyCommentToElement(escalation.getOwnedComment(), trgEscalation);
				
				//set duration for escalatoin
				AddLiteralDurationToEscalationBOMCmd durationEscalationCmd = new AddLiteralDurationToEscalationBOMCmd(trgEscalation);
				LiteralDuration trgDuration = (LiteralDuration)durationEscalationCmd.getObject();
				executeCmd(durationEscalationCmd);
				
				//update the escalation period
				LiteralDuration srcDuration = (LiteralDuration)escalation.getEscalationPeriod();
				UpdateLiteralDurationBOMCmd updateDurationCmd = new UpdateLiteralDurationBOMCmd(trgDuration);
				updateDurationCmd.setValue(srcDuration.getValue());
				executeCmd(updateDurationCmd);
				
				EscalationAction trgEscalationAction = null;
				//add escalation action
				if (escalation.getEscalationAction() instanceof EmailEscalationAction) {
					AddEmailEscalationActionToEscalationBOMCmd emailActionCmd = new AddEmailEscalationActionToEscalationBOMCmd(trgEscalation);
					emailActionCmd.setEmailMessage(getEmailMessage(escalation, trgHumanTask.getEmailMessages()));
					executeCmd(emailActionCmd);
					trgEscalationAction = (EscalationAction)emailActionCmd.getObject();
				} else {
					AddWorkItemEscalationActionToEscalationBOMCmd workItemActionCmd = new AddWorkItemEscalationActionToEscalationBOMCmd(trgEscalation);
					executeCmd(workItemActionCmd);
					trgEscalationAction = (EscalationAction)workItemActionCmd.getObject();
				}
				
				EscalationAction srcEscalationAction = escalation.getEscalationAction();
				//add escalation receiver
				AddIndividualResourceRequirementToEscalationActionBOMCmd resReqEscalationActionCmd = 
					new AddIndividualResourceRequirementToEscalationActionBOMCmd(trgEscalationAction);
				
				//Add "Person" as a default "EscalationReceiver" resource requirement
				String predefResourceTypeName = UtilResourceBundleSingleton.INSTANCE.getMessage(CommonMessageKeys.class, CommonMessageKeys.PERSON);
				resReqEscalationActionCmd.setName(predefResourceTypeName);
		  		String blmUri = PredefTypesConst.PERSON_TYPE_RFUID; //"RID-00000000000000000000000000000101" ==> "Person"
		  		String predefProjectName = PredefUtil.getPredefinedProjectName();
		  		String projectUri = FileMGR.getProjectPath(predefProjectName);
		  		IndividualResourceType predefResourceType = (IndividualResourceType)ResourceMGR.getResourceManger().getRootObjects(predefProjectName, projectUri, blmUri).get(0);
		  		resReqEscalationActionCmd.setResourceType(predefResourceType);
		  		executeCmd(resReqEscalationActionCmd);
		  		
				//add constraints
		  		IndividualResourceRequirement trgEscalationReceiver = (IndividualResourceRequirement)resReqEscalationActionCmd.getObject();
				addConstraint(srcEscalationAction.getEscalationReceiver(), trgEscalationReceiver);
				
				//set repetition to action
				if (srcEscalationAction.getRepetitionPeriod() != null) {
					AddLiteralDurationToEscalationActionBOMCmd addDurationToEscalationAction = 
						new AddLiteralDurationToEscalationActionBOMCmd(trgEscalationAction);
					executeCmd(addDurationToEscalationAction);
					LiteralDuration trgRepetitionPeriod = (LiteralDuration)addDurationToEscalationAction.getObject();
					
					//update repetition period
					LiteralDuration srcRepPeriod = (LiteralDuration)srcEscalationAction.getRepetitionPeriod();
					UpdateLiteralDurationBOMCmd updateRepetitonPeriod = new UpdateLiteralDurationBOMCmd(trgRepetitionPeriod);
					updateRepetitonPeriod.setValue(srcRepPeriod.getValue());
					executeCmd(updateRepetitonPeriod);
				}			
			}		
		}
	}
	
	private EmailMessage getEmailMessage(Escalation escalation, List<EmailMessage> trgEmailMsgList) {
		EmailEscalationAction srcEmailEscalationAction = (EmailEscalationAction)escalation.getEscalationAction();
		EmailMessage srcEmailMsg = srcEmailEscalationAction.getEmailMessage();
		if (srcEmailMsg != null) {
			String srcEmailName = srcEmailMsg.getName();
			
			for (EmailMessage message : trgEmailMsgList) {
				if (message.getName().equals(srcEmailName)) {
					return message;
				}
			}
		}
		return null;
	}
	
	private String getArgumentValue(List<FunctionArgument> argList, String id) {
		for (FunctionArgument argument : argList) {
			if (argument.getArgumentID().equals(id)) {
				StringLiteralExpression value = (StringLiteralExpression)argument.getArgumentValue();
				if (value != null) {					
					return value.getStringSymbol();
				}
			}
		}
		return null;
	}
	
	private void convertNameToIdCV() {
		for (FunctionArgument arg : cvFunctionArgList) {
			StringLiteralExpression expression = (StringLiteralExpression)arg.getArgumentValue();
			String val = expression.getStringSymbol();
			String id = escalationNameIdMap.get(cv.getExtraInfo(val));
			String[] parseResult = cv.parse(val);
		  	String contextVarName = parseResult[0];	
		  	String localizedContextVarName = cv.getLocalizedContextVar(contextVarName);
			val = cv.format(localizedContextVarName, null, id, true);
			//update the expression
			UpdateStringLiteralExpressionEXPCmd updateCmd = new UpdateStringLiteralExpressionEXPCmd(expression);
			updateCmd.setStringSymbol(val);
			executeCmd(updateCmd);
		}
	}

	private void createBusinessRuleGroup() {
		BusinessRuleAction srcAction = (BusinessRuleAction)action;
		if (srcAction.getOwnedRuleGroup().size() == 0) {
			return;
		}
		
		BusinessRuleAction tgtAction = (BusinessRuleAction)domainModel;
		
		BusinessRuleGroup srcGroup = (BusinessRuleGroup)
				srcAction.getOwnedRuleGroup().get(0);
		for (Iterator it=srcAction.getOwnedRuleSet().iterator(); it.hasNext();) {
			BusinessRuleSet srcRuleSet = (BusinessRuleSet)it.next();
			AddBusinessRuleSetToBusinessRuleActionBOMCmd cmd =
				new AddBusinessRuleSetToBusinessRuleActionBOMCmd(tgtAction);
			cmd.setName(srcRuleSet.getName());
			executeCmd(cmd);
			
			BusinessRuleSet tgtRuleSet = (BusinessRuleSet)cmd.getObject();
			
			copyCommentToElement(srcRuleSet.getOwnedComment(), tgtRuleSet);
			
			AddBusinessRuleBlockToBusinessRuleSetBOMCmd blockCmd =
				new AddBusinessRuleBlockToBusinessRuleSetBOMCmd(tgtRuleSet);
			executeCmd(blockCmd);
			
			for (Iterator it2=srcRuleSet.getRuleTemplates().iterator(); it2.hasNext(); ) {
				BusinessRuleTemplate srcTemplate = (BusinessRuleTemplate)it2.next();
				AddBusinessRuleTemplateToBusinessRuleSetBOMCmd templateCmd =
						new AddBusinessRuleTemplateToBusinessRuleSetBOMCmd(tgtRuleSet);
				templateCmd.setName(srcTemplate.getName());
				templateCmd.setPresentation(srcTemplate.getPresentation());
				executeCmd(templateCmd);

				BusinessRuleTemplate tgtTemplate = (BusinessRuleTemplate)templateCmd.getObject();
				copyCommentToElement(srcTemplate.getOwnedComment(), tgtTemplate);
				
				AddIfThenRuleToBusinessRuleTemplateBOMCmd ruleCmd =
						new AddIfThenRuleToBusinessRuleTemplateBOMCmd(tgtTemplate);
				executeCmd(ruleCmd);
				
				AddStructuredOpaqueExpressionToIfThenRuleBEXCmd conditionCmd =
						new AddStructuredOpaqueExpressionToIfThenRuleBEXCmd(
								(IfThenRule)ruleCmd.getObject());
				executeCmd(conditionCmd);
				
				for (Iterator it3=srcTemplate.getParameters().iterator(); it3.hasNext(); ) {
					TemplateParameter srcParam = (TemplateParameter)it3.next();
					AddTemplateParameterToBusinessRuleTemplateBOMCmd paramCmd
							= new AddTemplateParameterToBusinessRuleTemplateBOMCmd(
									(BusinessRuleTemplate)templateCmd.getObject());
					paramCmd.setName(srcParam.getName());
					paramCmd.setType(getPrimitiveTypeFromPredefinedProject(srcParam.getType()));
					executeCmd(paramCmd);
					
					copyCommentToElement(srcParam.getOwnedComment(), (Element) paramCmd.getObject());
				}
			}
			
			BusinessRuleBlock srcBlock = (BusinessRuleBlock)srcRuleSet.getRuleBlocks().get(0);
			BusinessRuleBlock tgtBlock = (BusinessRuleBlock)tgtRuleSet.getRuleBlocks().get(0);
			for (int j=0; j<srcBlock.getRules().size(); j++) {
				BusinessRule srcRule = (BusinessRule)srcBlock.getRules().get(j);
				if (srcRule instanceof IfThenRule) {
					AddIfThenRuleToBusinessRuleBlockBOMCmd ifRuleCmd =
							new AddIfThenRuleToBusinessRuleBlockBOMCmd(tgtBlock);
					ifRuleCmd.setName(srcRule.getName());
					ifRuleCmd.setPresentation(srcRule.getPresentation());
					executeCmd(ifRuleCmd);

					copyCommentToElement(srcRule.getOwnedComment(),
							(Element)ifRuleCmd.getObject());
				} else {
					// srcRule is a TemplateInstanceRule.
					TemplateInstanceRule srcInstanceRule = (TemplateInstanceRule)srcRule;
					int templateIndex = srcRuleSet.getRuleTemplates().indexOf(
							srcInstanceRule.getTemplate());
					AddTemplateInstanceRuleToBusinessRuleBlockBOMCmd templateRuleCmd =
							new AddTemplateInstanceRuleToBusinessRuleBlockBOMCmd(tgtBlock);
					templateRuleCmd.setName(srcRule.getName());
					templateRuleCmd.setPresentation(srcRule.getPresentation());
					if (templateIndex >= 0) {
						templateRuleCmd.setTemplate((BusinessRuleTemplate)
								tgtRuleSet.getRuleTemplates().get(templateIndex));
					}
					executeCmd(templateRuleCmd);
					
					EList srcParamValues = srcInstanceRule.getParameterValues();
					for (int i=0; i < srcParamValues.size(); i++) {
						ValueSpecification srcValue = (ValueSpecification)srcParamValues.get(i);
						TemplateInstanceRule tgtRule = (TemplateInstanceRule)templateRuleCmd.getObject();
						String typeName = srcValue.getType().getName();

						if (typeName.equals("Boolean")) {
							AddLiteralBooleanToTemplateInstanceRuleBOMCmd valueCmd
								= new AddLiteralBooleanToTemplateInstanceRuleBOMCmd(tgtRule);
							valueCmd.setValue(((LiteralBoolean)srcValue).getValue().booleanValue());
							valueCmd.setType(getPrimitiveTypeFromPredefinedProject(srcValue.getType()));
							executeCmd(valueCmd);
						}
						else if (typeName.equals("Byte")
								|| typeName.equals("Integer")
								|| typeName.equals("Short")
								|| typeName.equals("Long")) {
							AddLiteralIntegerToTemplateInstanceRuleBOMCmd valueCmd
								= new AddLiteralIntegerToTemplateInstanceRuleBOMCmd(tgtRule);
							valueCmd.setValue(((LiteralInteger)srcValue).getValue().intValue());
							valueCmd.setType(getPrimitiveTypeFromPredefinedProject(srcValue.getType()));
							executeCmd(valueCmd);
						}
						else if (typeName.equals("Double")
								|| typeName.equals("Float")) {
							AddLiteralRealToTemplateInstanceRuleBOMCmd valueCmd
								= new AddLiteralRealToTemplateInstanceRuleBOMCmd(tgtRule);
							valueCmd.setValue(((LiteralReal)srcValue).getValue().doubleValue());
							valueCmd.setType(getPrimitiveTypeFromPredefinedProject(srcValue.getType()));
							executeCmd(valueCmd);
						}
						else {
							AddLiteralStringToTemplateInstanceRuleBOMCmd valueCmd
								= new AddLiteralStringToTemplateInstanceRuleBOMCmd(tgtRule);
							valueCmd.setValue(((LiteralString)srcValue).getValue());
							valueCmd.setType(getPrimitiveTypeFromPredefinedProject(srcValue.getType()));
							executeCmd(valueCmd);
						}
					}
				}
			}
		}
		
		AddBusinessRuleGroupToBusinessRuleActionBOMCmd cmd =
			new AddBusinessRuleGroupToBusinessRuleActionBOMCmd((BusinessRuleAction)domainModel);
		for (Iterator it=tgtAction.getOwnedRuleSet().iterator(); it.hasNext();) {
			cmd.addAvailableTargets((BusinessRuleSet)it.next());
		}
		int defaultRuleSetIndex = srcGroup.getAvailableTargets().indexOf(
				srcGroup.getDefaultRuleSet()); 
		if (defaultRuleSetIndex >= 0) {
			cmd.setDefaultRuleSet((BusinessRuleSet)tgtAction.getOwnedRuleSet().get(defaultRuleSetIndex));
		}
		executeCmd(cmd);
		
		BusinessRuleGroup tgtGroup = (BusinessRuleGroup)cmd.getObject();
		EList srcSelRecs = srcGroup.getSelectionRecords();
		for (Iterator it=srcSelRecs.iterator(); it.hasNext(); ) {
			BusinessRuleSetSelectionRecord srcSelRec =
					(BusinessRuleSetSelectionRecord)it.next();
			AddBusinessRuleSetSelectionRecordToBusinessRuleGroupBOMCmd selRecCmd =
				new AddBusinessRuleSetSelectionRecordToBusinessRuleGroupBOMCmd(tgtGroup);
			selRecCmd.setSelectionStartTime(srcSelRec.getSelectionStartTime());
			selRecCmd.setSelectionEndTime(srcSelRec.getSelectionEndTime());
			int selRuleIndex = srcGroup.getAvailableTargets().indexOf(
					srcSelRec.getRuleSet());
			if (selRuleIndex >= 0) {
				selRecCmd.setRuleSet((BusinessRuleSet)
						tgtGroup.getAvailableTargets().get(selRuleIndex));
			}
			executeCmd(selRecCmd);
		}
	}

	private Type getPrimitiveTypeFromPredefinedProject(Type type) {
		return BOMUtil.getPrimitiveType(PredefUtil.getPredefinedProjectName(),
				type.getName());
	}
	
	private void copyCommentToElement(EList srcComments, Element tgtElement) {
		if (srcComments != null && srcComments.size() > 0) {
			AddCommentToElementBOMCmd commentCmd = new AddCommentToElementBOMCmd(tgtElement);
			commentCmd.setBody(((Comment)srcComments.get(0)).getBody());
			executeCmd(commentCmd);
		}
	}

	/**
	 * Create Variables
	 */
	protected void createVariables() {
		LoggingUtil.traceEntry(this, "createVariables");

		// Attribute variable
		List list = ((StructuredActivityNode)action).getVariable();
		Iterator iterator = list.iterator();

		Variable variable = null;
		UpdateVariableRule rule = null;
		while(iterator.hasNext()) {
			variable = (Variable) iterator.next();
			rule = new UpdateVariableRule();
			rule.setWorkingCopy(getContent());
			rule.setImportSession(getImportSession());
			rule.setProjectName(getProjectName());
			rule.setSource(variable);
			rule.setProcess(process);
			rule.invoke();
		}

		LoggingUtil.traceExit(this, "createVariables");
	}

	/**
	 * Create Edge Contents
	 */
	protected void createEdgeContents() {
		LoggingUtil.traceEntry(this, "createEdgeContents");

		List edgeContentsList = ((StructuredActivityNode)action).getEdgeContents();
		Iterator iterator = edgeContentsList.iterator();

		ActivityEdge edge = null;
		UpdateEdgeRule rule = null;
		while(iterator.hasNext()) {
			edge = (ActivityEdge) iterator.next();
			rule = new UpdateEdgeRule();
			rule.setWorkingCopy(getContent());
			rule.setImportSession(getImportSession());
			rule.setProjectName(getProjectName());
			rule.setSource(edge);
			rule.setProcess(process);
			rule.invoke();
		}

		LoggingUtil.traceExit(this, "createEdgeContents");
	}

	/**
	 * Create Node Contents
	 */
	protected void createNodeContents() {
		LoggingUtil.traceEntry(this, "createNodeContents");

		List nodeContentsList = ((StructuredActivityNode)action).getNodeContents();
		Iterator iterator = nodeContentsList.iterator();
		ActivityNode node = null;
		UpdateViewModelRule rule = null;
		while(iterator.hasNext()) {
			node = (ActivityNode) iterator.next();
			if (node instanceof FlowFinalNode) {
				rule = new UpdateFlowFinalNodeRule();
			} else if (node instanceof TerminationNode) {
				rule = new UpdateTerminationlNodeRule();
			} else if (node instanceof InitialNode) {
				rule = new UpdateInitialNodeRule();
			} else if (node instanceof AcceptSignalAction) {
				rule = new UpdateAcceptSignalActionRule();
			} else if (node instanceof Map) {
				rule = new UpdateMapRule();
			} else if (node instanceof Decision) {
				rule = new UpdateDecisionRule();
			} else if (node instanceof Fork) {
				rule = new UpdateForkRule();
			} else if (node instanceof Join) {
				rule = new UpdateJoinRule();
			} else if (node instanceof Merge) {
				rule = new UpdateMergeRule();
			} else if (node instanceof ObserverAction) {
				rule = new UpdateObserverActionRule();
			} else if (node instanceof TimerAction) {
				rule = new UpdateTimerActionRule();
			} else if (node instanceof ForLoopNode) {
				rule = new UpdateForLoopNodeRule();
			} else if (node instanceof LoopNode) {
				rule = new UpdateLoopNodeRule();
			} else if (node instanceof CallBehaviorAction) {
				rule = new UpdateCallBehaviorActionRule();
			} else if (node instanceof BroadcastSignalAction) {
				rule = new UpdateBroadcastSignalActionRule();
			} else if (node instanceof StructuredActivityNode) {
				String aspect = node.getAspect();
				if (aspect != null) {
					if (PECommandConstants.TASK_ASPECT.compareTo(aspect) == 0) {
						rule = new UpdateTaskRule();
					} else if (PECommandConstants.PROCESS_ASPECT.compareTo(aspect) == 0) {
						rule = new UpdateSubprocessRule();
					} else if (PECommandConstants.HUMAN_TASK_ASPECT.compareTo(aspect) == 0) {
						rule = new UpdateHumanTaskRule();
					} else if (PECommandConstants.BUSINESS_RULE_TASK_ASPECT.compareTo(aspect) == 0) {
						rule = new UpdateBusinessRulesTaskRule();
					}
				}
			}

			if (node instanceof Action && rule != null) {
				createAction((Action)node, rule);
			} else if (node instanceof ControlNode && rule != null) {
				createNode((ControlNode)node, rule);
			}
		}
		LoggingUtil.traceExit(this, "createNodeContents");
	}

	/**
	 * Create Node
	 */
	private void createNode(final ControlNode node, UpdateViewModelRule rule) {
		LoggingUtil.traceEntry(this, "createNode");
		rule.setWorkingCopy(getContent());
		rule.setImportSession(getImportSession());
		rule.setProjectName(getProjectName());
		rule.setSource(node);
		rule.setProcess(process);
		rule.invoke();

		// After creation of each node, update the monitor
		IProgressMonitor monitor = getImportSession().getProgressMonitor();
		if (monitor != null) {
			if (monitor.isCanceled()) {
				LoggingUtil.trace(this, "createNode", "The user cancels the operation.");
				throw new OperationCanceledException();
			 }
			 monitor.worked(ProgressCalculator.getSimpleTask());
		}


		LoggingUtil.traceEntry(this, "createNode");
	}

	/**
	 * Create Action
	 */
	private void createAction(final Action action, UpdateViewModelRule rule) {
		LoggingUtil.traceEntry(this, "createAction");
		rule.setWorkingCopy(getContent());
		rule.setImportSession(getImportSession());
		rule.setProjectName(getProjectName());
		rule.setSource(action);
		rule.setProcess(process);
		rule.invoke();
		LoggingUtil.traceEntry(this, "createAction");
	}

	/**
	 * Return the content of the view model
	 * @return
	 */
	private Content getContent() {
		return viewModel.getContent();
	}

	protected void clearContent() {
		LoggingUtil.traceEntry(this, "clearTopLevelSAN");
		Content content = getContent();

		LoggingUtil.trace(this, "clearContent", "Remove existing nodes");
		NavigationProjectNode projectNode = NavigatorUtil.getProjectNode(getProjectName());
		if (projectNode == null) {
			LoggingUtil.trace(this, "clearContent", IImportResultMessages.PROJECT_NODE_IS_NULL);
			LoggingUtil.traceExit(this, "clearTopLevelSAN");
			return;
		}
		PeCmdFactory cmdFactory = getPeCmdFactory();
		RemovePeCmd removeCmd = null;

		Object contentChildren = null;
		Object domainModel = null;
		List contentList = null;
		if(content != null) {
			List removeList = new ArrayList(content.getContentChildren());
			Iterator iterator = removeList.iterator();
			while(iterator.hasNext()) {
				contentChildren = iterator.next();
				if (contentChildren instanceof CommonNodeModel) {
					contentList = ((CommonNodeModel)contentChildren).getDomainContent();
					if (contentList.size() <= 0) {
						continue;
					}
					domainModel = contentList.get(0);
					if (domainModel instanceof ControlNode) {
						removeCmd = cmdFactory.buildRemovePeCmd((CommonNodeModel)contentChildren);
						if (removeCmd.canExecute()) {
							try {
								removeCmd.execute();
							} catch (RuntimeException e) {
								LoggingUtil.trace(this, "clearContent", IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
							}
						} else {
							LoggingUtil.trace(this, "clearContent", IImportResultMessages.CANNOT_EXECUTE_REMOVE_CEF_COMMAND);
						}
					}
				}
			}
		}

		LoggingUtil.traceExit(this, "clearTopLevelSAN");
		return;
	}

	/**
	 * update the attribute
	 */
	private void updateAttribute() {
		LoggingUtil.traceEntry(this, "updateAttribute");
		// Attribute mustIsolate
		UpdateSANBOMCmd cmd = new UpdateSANBOMCmd((StructuredActivityNode)domainModel);
		Boolean mustIsolate = ((StructuredActivityNode)action).getMustIsolate();
		if (mustIsolate != null) {
			cmd.setMustIsolate(mustIsolate.booleanValue());
			LoggingUtil.trace(this, "invoke", "Set mustIsolate.");
		}

		// Execute the command
		if (cmd.canExecute()) {
			try {
				cmd.execute();
			} catch (RuntimeException e) {
				logWarning(getImportSession(), 
					IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
					IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
			}
		} else {
			logWarning(getImportSession(), 
				IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
 				IImportResultMessages.CANNOT_EXECUTE_BOM_COMMAND);
		}

		// Add Comment
		addComment();

		LoggingUtil.traceExit(this, "updateAttribute");
	}

	/**
	 * Add Comment to SAN
	 */
	private void addComment() {
		LoggingUtil.traceEntry(this, "addComment");
		if (action instanceof StructuredActivityNode) {
			ImportContext context = getImportSession().getContext().getSubContext(IImportFramework.CONTEXT_PROCESS_KEY).getSubContext(process);

			NavigationProjectNode projectNode = NavigatorUtil.getProjectNode(getProjectName());
			if (projectNode == null) {
				LoggingUtil.trace(this, "addComment", IImportResultMessages.PROJECT_NODE_IS_NULL);
				return;
			}
			PeCmdFactory cmdFactory = getPeCmdFactory();

			Iterator iterator = action.getOwnedComment().iterator();
			Iterator annotationIterator = null;
			Comment comment = null;
			List annotationList = null;
			Object annotation = null;
			AddCommentPeCmd cmd = null;
			AddAssociationConnPeCmd associateCmd = null;
			EObject newDomainModel = null;
			EObject newViewModel = null;
			UpdateCommentBOMCmd updateCmd = null;
			Object originalAnnotation = null;
			while(iterator.hasNext()) {
				comment = (Comment) iterator.next();
				annotationList = comment.getAnnotatedElement();
				if (annotationList.size() > 0) {
					// It is a note
					cmd = cmdFactory.buildAddCommentPeCmd(getContent());
					if (cmd.canExecute()) {
						try {
							cmd.execute();
						} catch (RuntimeException e) {
							LoggingUtil.trace(this, "addComment", IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
						}
					} else {
						LoggingUtil.trace(this, "addComment",
							IImportResultMessages.CANNOT_EXECUTE_BOM_COMMAND);
					}
					newDomainModel = cmd.getNewDomainModel();
					newViewModel = cmd.getNewViewModel();

					if (newDomainModel != null && newDomainModel instanceof Comment) {
						// Note is created.
						annotationIterator = annotationList.iterator();
						while (annotationIterator.hasNext()) {
							originalAnnotation = annotationIterator.next();
							if (originalAnnotation == action) {
								// Do nothing
								continue;
							}
							annotation = context.get(originalAnnotation);

							associateCmd = cmdFactory.buildAddAssociationConnPeCmd(getContent());
							associateCmd.setViewSource(newViewModel);
							if (annotation instanceof EObject) {
								associateCmd.setViewTarget((EObject)annotation);
							}
							if (associateCmd.canExecute()) {
								try {
									associateCmd.execute();
								} catch (RuntimeException e) {
									LoggingUtil.trace(this, "addComment",
										IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
								}
							} else {
								LoggingUtil.trace(this, "addComment",
									IImportResultMessages.CANNOT_EXECUTE_BOM_COMMAND);
							}
						}

						// Set Body
						updateCmd = new UpdateCommentBOMCmd((Comment) newDomainModel);
						updateCmd.setBody(comment.getBody());
						if (updateCmd.canExecute()) {
							try {
								updateCmd.execute();
							} catch (RuntimeException e) {
								LoggingUtil.trace(this, "addComment",
									IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
							}
						} else {
							LoggingUtil.trace(this, "addComment",
								IImportResultMessages.CANNOT_EXECUTE_BOM_COMMAND);
						}
					}
				}
			}
		}
		LoggingUtil.traceExit(this, "addComment");
	}

	/**
	 *  Update the implementation after all the nodes are created.
	 */
	protected void createRepositoryFlow() {
		LoggingUtil.traceEntry(this, "createRepositoryFlow");
		List nodeContentsList = ((StructuredActivityNode)action).getNodeContents();
		Iterator iterator = nodeContentsList.iterator();
		Iterator pinIterator = null;
		Object node = null;
		List inputObjectPins = null;
		List outputObjectPins = null;
		Object pin = null;
		UpdateRepositoryFlowRule rule = null;
		UpdateRetrieveArtifactPinBOMCmd retrieveCmd = null;
		UpdateStoreArtifactPinBOMCmd storeCmd = null;
		Repository repository = null;
		Object repositoryView = null;
		Object repositoryModel = null;
		Object newPin = null;
		ImportContext context = getImportSession().getContext().getSubContext(IImportFramework.CONTEXT_PROCESS_KEY).getSubContext(process);
		while(iterator.hasNext()) {
			node = iterator.next();
			if (node instanceof Action) {
				inputObjectPins = ((Action)node).getInputObjectPin();
				outputObjectPins = ((Action)node).getOutputObjectPin();

				pinIterator = inputObjectPins.iterator();
				while(pinIterator.hasNext()) {
					pin = pinIterator.next();
					if (pin instanceof RetrieveArtifactPin) {
						repository = ((RetrieveArtifactPin)pin).getRepository();
						newPin = DomainViewObjectHelper.getDomainObject((EObject)context.get(pin));
						if (repository instanceof Variable) {
							if (repository.eContainer() != ((EObject)node).eContainer()) {
								repositoryView = context.get(repository);
								repositoryModel = DomainViewObjectHelper.getDomainObject((EObject) repositoryView);
								if (repositoryModel instanceof Repository && newPin instanceof RetrieveArtifactPin) {
									retrieveCmd = new UpdateRetrieveArtifactPinBOMCmd((RetrieveArtifactPin)newPin);
									retrieveCmd.setRepository((Repository)repositoryModel);
									if (retrieveCmd.canExecute()) {
										try {
											retrieveCmd.execute();
										} catch (RuntimeException e) {
											logWarning(getImportSession(), 
												IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
												IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
										}
									} else {
										logWarning(getImportSession(), 
											IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
											IImportResultMessages.CANNOT_EXECUTE_BOM_COMMAND);
									}
								}
							}
						}

						rule = new UpdateRepositoryFlowRule();
						rule.setWorkingCopy(getContent());
						rule.setImportSession(getImportSession());
						rule.setProjectName(getProjectName());
						rule.setSource(pin);
						rule.setProcess(process);
						rule.invoke();
					}
				}

				pinIterator = outputObjectPins.iterator();
				while(pinIterator.hasNext()) {
					pin = pinIterator.next();
					if (pin instanceof StoreArtifactPin) {
						repository = ((StoreArtifactPin)pin).getRepository();
						newPin = DomainViewObjectHelper.getDomainObject((EObject)context.get(pin));
						if (repository instanceof Variable) {
							if (repository.eContainer() != ((EObject)node).eContainer()) {
								repositoryView = context.get(repository);
								repositoryModel = DomainViewObjectHelper.getDomainObject((EObject) repositoryView);
								if (repositoryModel instanceof Repository && newPin instanceof StoreArtifactPin) {
									storeCmd = new UpdateStoreArtifactPinBOMCmd((StoreArtifactPin)newPin);
									storeCmd.setRepository((Repository)repositoryModel);
									if (storeCmd.canExecute()) {
										try {
											storeCmd.execute();
										} catch (RuntimeException e) {
											logWarning(getImportSession(), 
												IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
												IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
										}
									} else {
										logWarning(getImportSession(), 
											IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
											IImportResultMessages.CANNOT_EXECUTE_BOM_COMMAND);
									}
								}
							}
						}
						rule = new UpdateRepositoryFlowRule();
						rule.setWorkingCopy(getContent());
						rule.setImportSession(getImportSession());
						rule.setProjectName(getProjectName());
						rule.setSource(pin);
						rule.setProcess(process);
						rule.invoke();
					}
				}
			}
		}
		LoggingUtil.traceExit(this, "createRepositoryFlow");
	}
}

