package com.ibm.btools.blm.ie.imprt.rule.processModel.node;

import com.ibm.btools.blm.ie.imprt.rule.util.LoggingUtil;
import com.ibm.btools.cef.gef.emf.command.AddModelPropertyCommand;
import com.ibm.btools.cef.model.CommonContainerModel;

/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

/**
 * Update the Subprocess
 */
public class UpdateSubprocessRule extends UpdateStructuredActivityNodeRule {
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	
	
	private final String DO_LAYOUT_PROPERTY_ID 		= "doLayout";
	private final String DO_LAYOUT_PROPERTY_NAME 	= "doLayout";
	private final Boolean DO_LAYOUT_PROPERTY_VALUE	= Boolean.TRUE;	
	
	/**
	 * Update Model
	 */
	protected void updateModel() {
		LoggingUtil.traceEntry(this, "updateModel");
		super.updateModel();

		addFlagForAutoLayout();
		
		LoggingUtil.traceExit(this, "updateModel");
	}	
	
	private void addFlagForAutoLayout() {
		
		if (viewModel instanceof CommonContainerModel) {
			AddModelPropertyCommand command = new AddModelPropertyCommand((CommonContainerModel)viewModel);
			command.setId(DO_LAYOUT_PROPERTY_ID);
			command.setName(DO_LAYOUT_PROPERTY_NAME);
			command.setValue(DO_LAYOUT_PROPERTY_VALUE);	
	
			if (command.canExecute()) {
				try {				
					command.execute();
				} catch (RuntimeException e) {
					LoggingUtil.trace(this, "addFlagForAutoLayout", "Fail to update the command to add model property.");	
				}
			} else {
				LoggingUtil.trace(this, "addFlagForAutoLayout", "Fail to update the command to add model property.");	
			}			
		}		
	}	
}
