package com.ibm.btools.blm.ie.imprt.rule.processModel.node;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.common.command.AbstractCommand;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;

import com.ibm.btools.blm.compoundcommand.pe.factory.PeCmdFactory;
import com.ibm.btools.blm.compoundcommand.pe.pinset.update.AssociateInputPinSetWithOutputPinSetPeCmd;
import com.ibm.btools.blm.compoundcommand.process.util.PECommandConstants;
import com.ibm.btools.blm.ie.imprt.IImportFramework;
import com.ibm.btools.blm.ie.imprt.ImportContext;
import com.ibm.btools.blm.ie.imprt.rule.util.BOMUtil;
import com.ibm.btools.blm.ie.imprt.rule.util.IImportResultMessages;
import com.ibm.btools.blm.ie.imprt.rule.util.LoggingUtil;
import com.ibm.btools.blm.ie.imprt.rule.util.NavigatorUtil;
import com.ibm.btools.blm.ie.resource.IeMessageKeys;
import com.ibm.btools.bom.command.artifacts.AddCommentToElementBOMCmd;
import com.ibm.btools.bom.command.organizationstructures.RemoveLocationBOMCmd;
import com.ibm.btools.bom.command.organizationstructures.RemoveOrganizationUnitBOMCmd;
import com.ibm.btools.bom.command.processes.actions.RemoveOperationalCostsBOMCmd;
import com.ibm.btools.bom.command.processes.actions.RemoveOperationalRevenueBOMCmd;
import com.ibm.btools.bom.command.processes.actions.RemoveOperationalTimesBOMCmd;
import com.ibm.btools.bom.command.processes.activities.UpdateInputObjectPinBOMCmd;
import com.ibm.btools.bom.command.processes.activities.UpdateOutputObjectPinBOMCmd;
import com.ibm.btools.bom.command.processes.activities.UpdateOutputPinSetBOMCmd;
import com.ibm.btools.bom.command.processes.activities.UpdateSANBOMCmd;
import com.ibm.btools.bom.command.processes.humantasks.UpdateHumanTaskBOMCmd;
import com.ibm.btools.bom.command.resources.RemoveResourceRequirementBOMCmd;
import com.ibm.btools.bom.model.artifacts.Comment;
import com.ibm.btools.bom.model.artifacts.Descriptor;
import com.ibm.btools.bom.model.artifacts.Element;
import com.ibm.btools.bom.model.artifacts.Type;
import com.ibm.btools.bom.model.organizationstructures.Location;
import com.ibm.btools.bom.model.organizationstructures.OrganizationUnit;
import com.ibm.btools.bom.model.processes.actions.OperationalCosts;
import com.ibm.btools.bom.model.processes.actions.OperationalRevenue;
import com.ibm.btools.bom.model.processes.actions.OperationalTimes;
import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.bom.model.processes.activities.InputObjectPin;
import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.bom.model.processes.activities.ObjectPin;
import com.ibm.btools.bom.model.processes.activities.OutputObjectPin;
import com.ibm.btools.bom.model.processes.activities.OutputPinSet;
import com.ibm.btools.bom.model.processes.activities.Pin;
import com.ibm.btools.bom.model.processes.activities.PinSet;
import com.ibm.btools.bom.model.processes.activities.StructuredActivityNode;
import com.ibm.btools.bom.model.processes.humantasks.HumanTask;
import com.ibm.btools.bom.model.resources.IndividualResourceRequirement;
import com.ibm.btools.bom.model.resources.ResourceRequirement;
import com.ibm.btools.cef.model.CommonContainerModel;
import com.ibm.btools.cef.model.CommonNodeModel;
import com.ibm.btools.te.attributes.command.definition.technicalproperties.wps.wsdl.AddWSDLOperationToServiceInputCriteriaAttributesTEACmd;
import com.ibm.btools.te.attributes.command.definition.technicalproperties.wps.wsdl.AddWSDLParameterToPinAttributesTEACmd;
import com.ibm.btools.te.attributes.command.definition.technicalproperties.wps.wsdl.AddWSDLPartToWSDLWSIMessageTEACmd;
import com.ibm.btools.te.attributes.command.definition.technicalproperties.wps.wsdl.AddWSDLPortTypeToServiceAttributesTEACmd;
import com.ibm.btools.te.attributes.command.definition.technicalproperties.wps.wsdl.AddWSDLWSIMessageToServiceInputCriteriaAttributesTEACmd;
import com.ibm.btools.te.attributes.command.definition.technicalproperties.wps.wsdl.AddWSDLWSIMessageToServiceOutputCriteriaAttributesTEACmd;
import com.ibm.btools.te.attributes.command.definition.technicalproperties.wps.wsdl.UpdateWSDLOperationTEACmd;
import com.ibm.btools.te.attributes.command.definition.technicalproperties.wps.wsdl.UpdateWSDLParameterTEACmd;
import com.ibm.btools.te.attributes.command.definition.technicalproperties.wps.wsdl.UpdateWSDLPortTypeTEACmd;
import com.ibm.btools.te.attributes.command.definition.technicalproperties.wps.wsdl.UpdateWSDLWSIMessageTEACmd;
import com.ibm.btools.te.attributes.command.specification.processmodel.wps.AddPinAttributesToElementTEACmd;
import com.ibm.btools.te.attributes.command.specification.processmodel.wps.AddServiceAttributesToElementTEACmd;
import com.ibm.btools.te.attributes.command.specification.processmodel.wps.AddServiceInputCriteriaAttributesToElementTEACmd;
import com.ibm.btools.te.attributes.command.specification.processmodel.wps.AddServiceOutputCriteriaAttributesToElementTEACmd;
import com.ibm.btools.te.attributes.command.specification.processmodel.wps.UpdateServiceInputCriteriaAttributesTEACmd;
import com.ibm.btools.te.attributes.model.definition.technicalproperties.wps.wsdl.WSDLOperation;
import com.ibm.btools.te.attributes.model.definition.technicalproperties.wps.wsdl.WSDLParameter;
import com.ibm.btools.te.attributes.model.definition.technicalproperties.wps.wsdl.WSDLPart;
import com.ibm.btools.te.attributes.model.definition.technicalproperties.wps.wsdl.WSDLPortType;
import com.ibm.btools.te.attributes.model.definition.technicalproperties.wps.wsdl.WSDLWSIMessage;
import com.ibm.btools.te.attributes.model.specification.TechnicalAttributes;
import com.ibm.btools.te.attributes.model.specification.processmodel.wps.PinAttributes;
import com.ibm.btools.te.attributes.model.specification.processmodel.wps.ServiceAttributes;
import com.ibm.btools.te.attributes.model.specification.processmodel.wps.ServiceInputCriteriaAttributes;
import com.ibm.btools.te.attributes.model.specification.processmodel.wps.ServiceOutputCriteriaAttributes;
import com.ibm.btools.util.resource.CommonMessageKeys;
import com.ibm.btools.util.resource.UtilResourceBundleSingleton;

/**
 * Update the Top Level SAN
 */
public class UpdateTopLevelStructureActivityNodeRule extends UpdateStructuredActivityNodeRule {
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	
	
	/**
	 * Invoke the rule
	 */
 	public void invoke() {
		// No need to create the SAN
		viewModel = (CommonNodeModel) workingCopy;
		List list = viewModel.getDomainContent();
		if (list.size()>0) {
			domainModel = (EObject) list.get(0);
		}
		ImportContext context = getImportSession().getContext().getSubContext(IImportFramework.CONTEXT_PROCESS_KEY).getSubContext(process);	
		context.put(action, viewModel);		
		
		registerPinAndPinset();
		associatePinset();
		
		updateModel();		
		
		// BEGIN: 20051003 - create the technical attributes for the global service
		String aspect = action.getAspect();
		if (PECommandConstants.SERVICE_ASPECT.equals(aspect)) {
			updateTechnicalAttributes();
		}
		// END: 20051003 - create the technical attributes for the global service
		
		//fixes for d102905
		updatePinSet();
		int i=0;
		//fix the object reference
		if(!NavigatorUtil.isNewNode(getImportSession(),action.eContainer())){
			updateObjectPins();
			//d139498 AZ reset the values when overwrite
			//for the service operation's specification
			resetRevenueAndCost();
			resetDuration();
			resetResources();
			resetOrganizations();
			resetLocations();
		}
	}	
	
	private void resetRevenueAndCost(){
		if(domainModel instanceof Action){
			Action domainAction = (Action)domainModel;
			OperationalCosts ocs = domainAction.getOperationalCosts();
			if(ocs != null){
				RemoveOperationalCostsBOMCmd removeCosts = new RemoveOperationalCostsBOMCmd(ocs);
				if(removeCosts.canExecute()){
					removeCosts.execute();
				}
			}
			OperationalRevenue or = domainAction.getOperationalRevenue();
			if(or != null){
				RemoveOperationalRevenueBOMCmd removeRevenue = new RemoveOperationalRevenueBOMCmd(or);
				if(removeRevenue.canExecute()){
					removeRevenue.execute();
				}
			}		
		}
	}
	
	private void resetDuration(){
		if(domainModel instanceof Action){
			Action domainAction = (Action)domainModel;
			OperationalTimes ots = domainAction.getOperationalTimes();
			if(ots != null){
				RemoveOperationalTimesBOMCmd removeTimes = new RemoveOperationalTimesBOMCmd(ots);
				if(removeTimes.canExecute()){
					removeTimes.execute();
				}
			}			
		}
	}
	
	private void resetResources(){
		if(domainModel instanceof Action){
			Action domainAction = (Action)domainModel;
			EList resources = domainAction.getResourceRequirement();
			List resList = new ArrayList(resources);
			if(resList.size() > 0){
				Iterator resIt = resList.iterator();
				while(resIt.hasNext()){
					ResourceRequirement resource = (ResourceRequirement)resIt.next();
					if(resource != null){
						RemoveResourceRequirementBOMCmd removeResource = new RemoveResourceRequirementBOMCmd(resource);
						if(removeResource.canExecute()){
							removeResource.execute();
						}
					}			
				}
			}
			
		}
	}
	
	private void resetOrganizations(){
		if(domainModel instanceof Action){
			Action domainAction = (Action)domainModel;
			EList organizations = domainAction.getResponsibleOrganization();	
			List orgList = new ArrayList(organizations);
			if(orgList.size() > 0){
				Iterator orgIt = orgList.iterator();
				while(orgIt.hasNext()){
					OrganizationUnit organization = (OrganizationUnit)orgIt.next();
					if(organization != null){
						RemoveOrganizationUnitBOMCmd removeOrganization= new RemoveOrganizationUnitBOMCmd(organization,(EObject)domainAction,(EReference)domainAction.eClass().getEStructuralFeature("responsibleOrganization"));
						if(removeOrganization.canExecute()){
							removeOrganization.execute();
						}
					}			
				}
			}
			
		}
	}
	
	private void resetLocations(){
		if(domainModel instanceof Action){
			Action domainAction = (Action)domainModel;
			EList locations = domainAction.getPerformedAt();
			List locList = new ArrayList(locations);
			if(locList.size() > 0){
				Iterator locIt = locList.iterator();
				while(locIt.hasNext()){
					Location location = (Location)locIt.next();
					if(location != null){
						RemoveLocationBOMCmd removeLocation= new RemoveLocationBOMCmd(location,(EObject)domainAction,(EReference)domainAction.eClass().getEStructuralFeature("performedAt"));
						if(removeLocation.canExecute()){
							removeLocation.execute();
						}
					}			
				}
			}			
		}
	}
	
	/**
	 * Updates the isStream and isException flag on the output pinset of the reusable element
	 */
	private void updatePinSet() {
		int numOfSrcPinSets = 0, numOfDomainMdlPinSets = 0, pinSetSize = 0;		
		List srcOutputPinSets = action.getOutputPinSet();
		List domainMdlOutputPinSets = ((Action) domainModel).getOutputPinSet();
		
		if (srcOutputPinSets != null && !srcOutputPinSets.isEmpty()) {
			numOfSrcPinSets = srcOutputPinSets.size();
		}
		if (domainMdlOutputPinSets != null && !domainMdlOutputPinSets.isEmpty()) {
			numOfDomainMdlPinSets = domainMdlOutputPinSets.size();
		}
		
		if (numOfSrcPinSets > numOfDomainMdlPinSets) {
			pinSetSize = numOfDomainMdlPinSets;
		} else {
			pinSetSize = numOfSrcPinSets;
		}
		
		for (int i=0; i<=pinSetSize - 1; i++) {			
			OutputPinSet srcOutputPinSet = (OutputPinSet) srcOutputPinSets.get(i);
			OutputPinSet domainMdlOutputPinSet = (OutputPinSet) domainMdlOutputPinSets.get(i);				
			UpdateOutputPinSetBOMCmd updateCmd = new UpdateOutputPinSetBOMCmd(domainMdlOutputPinSet);
			updateCmd.setIsException(srcOutputPinSet.getIsException().booleanValue());
			updateCmd.setIsStream(srcOutputPinSet.getIsStream().booleanValue());			
			executeCmd(updateCmd);						
		}		
	}
	
	/**
	 * Update object pins if the existing object pin reference to a null type
	 * or Class with empty content
	 * by resolving the type from the workspace
	 */
	private void updateObjectPins(){
		//Handle outputobjectpins
		EList srcOutputObjectPins = action.getOutputObjectPin();
		EList targetOutputObjectPins = ((Action) domainModel).getOutputObjectPin();	
		if(srcOutputObjectPins == null ||targetOutputObjectPins == null){
			return;
		}
		for(Iterator srcIt = srcOutputObjectPins.iterator();srcIt.hasNext();){
			OutputObjectPin srcPin = (OutputObjectPin)srcIt.next();
			for(Iterator targetIt = targetOutputObjectPins.iterator();targetIt.hasNext();){
				OutputObjectPin targetPin = (OutputObjectPin)targetIt.next();
				if(srcPin.getName()!= null && srcPin.getName().equals(targetPin.getName())){
					UpdateOutputObjectPinBOMCmd updateCmd = new UpdateOutputObjectPinBOMCmd(targetPin);
					Type existingType = BOMUtil.getTypeFromWorkspace(getImportSession(),getProjectName(),srcPin.getType());
					updateCmd.setType(existingType);
					executeCmd(updateCmd);	
					break;
				}
			}
		}
		
		//Handle inputObjectPins
		EList srcInputObjectPins = action.getInputObjectPin();
		EList targetInputObjectPins = ((Action) domainModel).getInputObjectPin();
		if(srcInputObjectPins == null || targetInputObjectPins == null){
			return;
		}
		for(Iterator srcIt = srcInputObjectPins.iterator();srcIt.hasNext();){
			InputObjectPin srcPin = (InputObjectPin)srcIt.next();
			for(Iterator targetIt = targetInputObjectPins.iterator();targetIt.hasNext();){
				InputObjectPin targetPin = (InputObjectPin)targetIt.next();
				if(srcPin.getName()!= null && srcPin.getName().equals(targetPin.getName())){					
					UpdateInputObjectPinBOMCmd updateCmd = new UpdateInputObjectPinBOMCmd(targetPin);					
					Type existingType = BOMUtil.getTypeFromWorkspace(getImportSession(),getProjectName(),srcPin.getType());
					updateCmd.setType(existingType);
					executeCmd(updateCmd);	
					break;				
				}
			}
		}
	}
	
	/**
	 * Create technical attributes for the global service
	 */
	protected void updateTechnicalAttributes() {
		LoggingUtil.traceEntry(this, "updateTechnicalAttributes");
		// update the ownedComments, interface, request and response technical attributes for the global service
		updateOwnedComments();
		updateInterface();
		updateRequest();
		updateResponse();
		updatePinAttributes();
		LoggingUtil.traceExit(this, "updateTechnicalAttributes");
	}
	
	/**
	 * Map Owned Comments for StructuredActivityNode of the global service
	 */
	protected void updateOwnedComments() {
		LoggingUtil.traceEntry(this, "updateOwnedComments");
		// this update only deals with one description and it's the 1st description from the list of ownedComments in the SAN
		// code needs to be modified in the future to support multiple comments in the SAN
		BOMUtil.updateDescription((Element)domainModel, BOMUtil.getDescription((Element)action));
		LoggingUtil.traceExit(this, "updateOwnedComments");
	}
	
	/**
	 * Map technical attributes for InputObjectPins of the global service
	 */
	protected void updateInputObjPinAttributes() {
		LoggingUtil.traceEntry(this, "updateInputObjPinAttributes");		
		int index = -1;
		List srcInputObjPins = action.getInputObjectPin();
		List domainInputObjPins = ((Action) domainModel).getInputObjectPin();
		// at this stage, all the pins in the source and domain model should be created
		if (srcInputObjPins == null || srcInputObjPins.isEmpty() || domainInputObjPins == null || domainInputObjPins.isEmpty()) {
			return;
		}
		
		for (Iterator it=srcInputObjPins.iterator(); it.hasNext();) {
			InputObjectPin srcInputObjPin = (InputObjectPin) it.next();
			
			List srcDescriptors = getTechnicalAttributes(srcInputObjPin);			
			
			if (srcDescriptors == null || srcDescriptors.isEmpty()) {
				continue;
			} else {
				// get the first bom descriptor and cast it to PinAttributes
				PinAttributes srcPinAttrbs = (PinAttributes) srcDescriptors.get(0);				
				WSDLParameter srcWSDLParam = srcPinAttrbs.getWsdlParameter();
				
				if (srcWSDLParam == null || srcWSDLParam.getName() == null) {
					continue;
				} else {
					// only creates the technical attributes in the domain model if the name in the WSDLParameter is present					
					index = srcInputObjPins.indexOf(srcInputObjPin);					
					if (index == -1 || index > domainInputObjPins.size()-1) {
						// error condition
						LoggingUtil.trace(this, "updateInputObjPinAttributes", "The input object pin size is not equal in the source and the domain model");
					} else {						
						InputObjectPin domainInputObjPin = (InputObjectPin) domainInputObjPins.get(index);						
						List domainDescriptors = getTechnicalAttributes(domainInputObjPin);						
						PinAttributes domainPinAttributes = null;						
						if (domainDescriptors == null || domainDescriptors.isEmpty()) {							
							//Add a PinAttributes to domainModelPin							
							AddPinAttributesToElementTEACmd addCmd = new AddPinAttributesToElementTEACmd(domainInputObjPin);
							executeCmd(addCmd);
							domainPinAttributes = (PinAttributes) addCmd.getObject();							
						} else {
							// retrieve the first PinAttributes from the domainModelPin							
							domainPinAttributes = (PinAttributes) domainDescriptors.get(0);					
						}						
						if (domainPinAttributes != null) {
							WSDLParameter domainWSDLParam = domainPinAttributes.getWsdlParameter();							
							if (domainWSDLParam == null) {
								// Add a WSDLParameter to domainPinAttributes
								AddWSDLParameterToPinAttributesTEACmd addCmd = new AddWSDLParameterToPinAttributesTEACmd(domainPinAttributes); 
								addCmd.setName(srcWSDLParam.getName());
								executeCmd(addCmd);								
							} else {
								// retrieve the WSDLParameter from the domainPinAttributes for update
								UpdateWSDLParameterTEACmd updateCmd = new UpdateWSDLParameterTEACmd(domainWSDLParam);
								updateCmd.setName(srcWSDLParam.getName());
								executeCmd(updateCmd);
							}							
						}					
					}					
				}				
			}			
		}		
		LoggingUtil.traceExit(this, "updateInputObjPinAttributes");	
	}
	
	/**
	 * Map technical attributes for OutputObjectPins of the global service
	 */
	protected void updateOutputObjPinAttributes() {
		LoggingUtil.traceEntry(this, "updateOutputObjPinAttributes");		
		int index = -1;
		List srcOutputObjPins = action.getOutputObjectPin();
		List domainOutputObjPins = ((Action) domainModel).getOutputObjectPin();
		// at this stage, all the pins in the source and domain model should be created
		if (srcOutputObjPins == null || srcOutputObjPins.isEmpty() || domainOutputObjPins == null || domainOutputObjPins.isEmpty()) {
			return;
		}
		
		for (Iterator it=srcOutputObjPins.iterator(); it.hasNext();) {
			OutputObjectPin srcOutputObjPin = (OutputObjectPin) it.next();			
			List srcDescriptors = getTechnicalAttributes(srcOutputObjPin);			
			
			if (srcDescriptors == null || srcDescriptors.isEmpty()) {
				continue;
			} else {
				// get the first bom descriptor and cast it to PinAttributes
				PinAttributes srcPinAttrbs = (PinAttributes) srcDescriptors.get(0);				
				WSDLParameter srcWSDLParam = srcPinAttrbs.getWsdlParameter();				
				if (srcWSDLParam == null || srcWSDLParam.getName() == null) {
					continue;
				} else {
					// only creates the technical attributes in the domain model if the name in the WSDLParameter is present					
					index = srcOutputObjPins.indexOf(srcOutputObjPin);					
					if (index == -1 || index > domainOutputObjPins.size()-1) {
						// error condition
						LoggingUtil.trace(this, "updateOutputObjPinAttributes", "The output object pin size is not equal in the source and the domain model");
					} else {						
						OutputObjectPin domainOutputObjPin = (OutputObjectPin) domainOutputObjPins.get(index);						
						List domainDescriptors = getTechnicalAttributes(domainOutputObjPin);						
						PinAttributes domainPinAttributes = null;
						if (domainDescriptors == null || domainDescriptors.isEmpty()) {							
							//Add a PinAttributes to domainModelPin							
							AddPinAttributesToElementTEACmd addCmd = new AddPinAttributesToElementTEACmd(domainOutputObjPin);
							executeCmd(addCmd);
							domainPinAttributes = (PinAttributes) addCmd.getObject();							
						} else {
							// retrieve the PinAttributes from the domainModelPin							
							domainPinAttributes = (PinAttributes) domainDescriptors.get(0);					
						}						
						if (domainPinAttributes != null) {
							WSDLParameter domainWSDLParam = domainPinAttributes.getWsdlParameter();							
							if (domainWSDLParam == null) {
								// Add a WSDLParameter to domainPinAttributes
								AddWSDLParameterToPinAttributesTEACmd addCmd = new AddWSDLParameterToPinAttributesTEACmd(domainPinAttributes); 
								addCmd.setName(srcWSDLParam.getName());
								executeCmd(addCmd);								
							} else {
								// retrieve the WSDLParameter from the domainPinAttributes for update
								UpdateWSDLParameterTEACmd updateCmd = new UpdateWSDLParameterTEACmd(domainWSDLParam);
								updateCmd.setName(srcWSDLParam.getName());
								executeCmd(updateCmd);
							}							
						}					
					}					
				}				
			}			
		}		
		LoggingUtil.traceExit(this, "updateOutputObjPinAttributes");
	}	
	
	/**
	 * Create technical attributes in the pins of the global service
	 */
	protected void updatePinAttributes() {		
		updateInputObjPinAttributes();
		updateOutputObjPinAttributes();
	}	
	
	/**
	 * Create interface technical attributes for the global service
	 */
	protected void updateInterface() {
		LoggingUtil.traceEntry(this, "updateInterface");
		Action newAction = (Action) domainModel;
		List bomDescriptors = getTechnicalAttributes(action);			
		List domainDescriptors = getTechnicalAttributes(newAction);
		
		ServiceAttributes bomSrvAttrs = null;
		ServiceAttributes domainSrvAttrs = null;
		// Assumption: there is only one descriptor per input pin set
		if (bomDescriptors != null && !bomDescriptors.isEmpty()) {
			// cast it to ServiceAttributes
			bomSrvAttrs = (ServiceAttributes) bomDescriptors.get(0);
			
			WSDLPortType bomPortType = bomSrvAttrs.getPortType();
			if (bomPortType != null && (bomPortType.getTargetNamespace() != null || bomPortType.getName() != null)) {
				//create or update existing descriptor in the domain model
				if (domainDescriptors == null || domainDescriptors.isEmpty()) {
					// create a new descriptor in the domain model
					AddServiceAttributesToElementTEACmd addCmd = new AddServiceAttributesToElementTEACmd(newAction);				
					executeCmd(addCmd);
					domainSrvAttrs = (ServiceAttributes) addCmd.getObject();					
				} else {
					// retrieve the domainDescriptors from the newAction
					domainSrvAttrs = (ServiceAttributes) domainDescriptors.get(0);				
				}
				
				if (domainSrvAttrs != null) {					 					
					WSDLPortType domainPortType = domainSrvAttrs.getPortType();						
					if (domainPortType == null) {
						// create a new port type in the domain model
						AddWSDLPortTypeToServiceAttributesTEACmd addCmd = new AddWSDLPortTypeToServiceAttributesTEACmd(domainSrvAttrs);
						if (bomPortType.getTargetNamespace() != null) {
							addCmd.setTargetNamespace(bomPortType.getTargetNamespace());
						}
						if (bomPortType.getName() != null) {
							addCmd.setName(bomPortType.getName());
						}
						executeCmd(addCmd);												
					} else {
						// update the port type in the domain model						
						UpdateWSDLPortTypeTEACmd updateCmd = new UpdateWSDLPortTypeTEACmd(domainPortType);
						if (bomPortType.getTargetNamespace() != null) {
							updateCmd.setTargetNamespace(bomPortType.getTargetNamespace());
						}
						if (bomPortType.getName() != null) {
							updateCmd.setName(bomPortType.getName());
						}
						executeCmd(updateCmd);	
					}					 
				}				
			}		
		}			
		LoggingUtil.traceExit(this, "updateInterface");
	}
	
	/**
	 * Create response technical attributes for the global service
	 */
	protected void updateResponse() {
		LoggingUtil.traceEntry(this, "updateResponse");
		Action newAction = (Action) domainModel;		
		List list = action.getOutputPinSet();
		List domainList = newAction.getOutputPinSet();
		
		int size = 0, pinSetSize = 0, domainPinSetSize = 0;
		if (list != null && !list.isEmpty()) {
			pinSetSize = list.size();
		}
		
		if (domainList != null && !domainList.isEmpty()) {
			domainPinSetSize = domainList.size();
		}
		
		if (pinSetSize > domainPinSetSize) {
			size = domainPinSetSize;
		} else {
			size = pinSetSize;
		}
		
		for (int i = 0; i<size; i++) {
			OutputPinSet outputPinSet = (OutputPinSet) list.get(i);
			OutputPinSet domainPinSet = (OutputPinSet) domainList.get(i);
			
			List bomDescriptors = getTechnicalAttributes(outputPinSet);			
			List domainDescriptors = getTechnicalAttributes(domainPinSet);
			ServiceOutputCriteriaAttributes domainSrvAttrs = null;
			
			// Assumption: there is only one descriptor for each output pin set
			ServiceOutputCriteriaAttributes bomSrvAttrs = null;
			if (bomDescriptors != null && !bomDescriptors.isEmpty()) {
				bomSrvAttrs = (ServiceOutputCriteriaAttributes) bomDescriptors.get(0);			
				
				if (domainDescriptors == null || domainDescriptors.isEmpty()) {
					//Create a new descriptor and add to the domain model
					AddServiceOutputCriteriaAttributesToElementTEACmd addCmd = new AddServiceOutputCriteriaAttributesToElementTEACmd(domainPinSet);											
					executeCmd(addCmd);
					domainSrvAttrs = (ServiceOutputCriteriaAttributes) addCmd.getObject();
				} else {
					//Update the existing descriptor in the domain model
					domainSrvAttrs = (ServiceOutputCriteriaAttributes) domainDescriptors.get(0);					
				}
				
				if (domainSrvAttrs != null) {					
					// update the message name
					WSDLWSIMessage bomWsdlMsg = (WSDLWSIMessage) bomSrvAttrs.getWsdlMessage();
					WSDLWSIMessage domainWsdlMsg = (WSDLWSIMessage) domainSrvAttrs.getWsdlMessage();
					if (bomWsdlMsg != null) {
						if (domainWsdlMsg == null) {
							// create a new WSDL Operation
							AddWSDLWSIMessageToServiceOutputCriteriaAttributesTEACmd addCmd = new AddWSDLWSIMessageToServiceOutputCriteriaAttributesTEACmd(domainSrvAttrs);
							if (bomWsdlMsg.getName() != null) {
								addCmd.setName(bomWsdlMsg.getName());
							}
							executeCmd(addCmd);	
							domainWsdlMsg = (WSDLWSIMessage) addCmd.getObject();
						} else {
							// Update the WSDL Operation
							UpdateWSDLWSIMessageTEACmd updateCmd = new UpdateWSDLWSIMessageTEACmd(domainWsdlMsg);
							if (bomWsdlMsg.getName() != null) {
								updateCmd.setName(bomWsdlMsg.getName());
							}
							executeCmd(updateCmd);
							domainWsdlMsg = (WSDLWSIMessage) updateCmd.getObject();
						}
						
						if (domainWsdlMsg != null) {
							WSDLPart bomWSDLPart = bomWsdlMsg.getWsdlPart();
							WSDLPart domainWSDLPart = domainWsdlMsg.getWsdlPart();
							
							if (bomWSDLPart != null && bomWSDLPart.getName() != null) {
								if (domainWSDLPart == null) {
									// create a new domainWSDLPart
									AddWSDLPartToWSDLWSIMessageTEACmd addCmd = new AddWSDLPartToWSDLWSIMessageTEACmd(domainWsdlMsg);
									addCmd.setName(bomWSDLPart.getName());
									executeCmd(addCmd);
								} else {
									// update an existing domainWSDLPart
									UpdateWSDLWSIMessageTEACmd updateCmd = new UpdateWSDLWSIMessageTEACmd(domainWsdlMsg);
									updateCmd.setName(bomWSDLPart.getName());
									executeCmd(updateCmd);
								}							
							}		
						}
					}					
				}				
			}
		}
		LoggingUtil.traceExit(this, "updateResponse");
	}
	
	/**
	 * Create request technical attributes for the global service
	 */
	protected void updateRequest() {
		LoggingUtil.traceEntry(this, "updateRequest");
		Action newAction = (Action) domainModel;		
		List list = action.getInputPinSet();
		List domainList = newAction.getInputPinSet();
		
		int size = 0, pinSetSize = 0, domainPinSetSize = 0;
		if (list != null && !list.isEmpty()) {
			pinSetSize = list.size();
		}
		
		if (domainList != null && !domainList.isEmpty()) {
			domainPinSetSize = domainList.size();
		}
		
		if (pinSetSize > domainPinSetSize) {
			size = domainPinSetSize;
		} else {
			size = pinSetSize;
		}
		
		for (int i = 0; i<size; i++) {
			InputPinSet inputPinSet = (InputPinSet) list.get(i);
			InputPinSet domainPinSet = (InputPinSet) domainList.get(i);
			
			List bomDescriptors = getTechnicalAttributes(inputPinSet);			
			List domainDescriptors = getTechnicalAttributes(domainPinSet);
			ServiceInputCriteriaAttributes domainSrvAttrs = null;
			
			// Assumption: there is only one descriptor for each input pin set
			ServiceInputCriteriaAttributes bomSrvAttrs = null;
			if (bomDescriptors != null && !bomDescriptors.isEmpty()) {
				bomSrvAttrs = (ServiceInputCriteriaAttributes) bomDescriptors.get(0);			
				
				// create or update one way operation
				if (bomSrvAttrs.getIsOneWayOperation() != null) {				 
					if (domainDescriptors == null || domainDescriptors.isEmpty()) {
						//Create a new descriptor and add to the domain model
						AddServiceInputCriteriaAttributesToElementTEACmd addCmd = new AddServiceInputCriteriaAttributesToElementTEACmd(domainPinSet);
						addCmd.setIsOneWayOperation(bomSrvAttrs.getIsOneWayOperation().booleanValue());						
						executeCmd(addCmd);
						domainSrvAttrs = (ServiceInputCriteriaAttributes) addCmd.getObject();
					} else {
						//Update the existing descriptor in the domain model
						ServiceInputCriteriaAttributes tempDomainSrvAttrs = (ServiceInputCriteriaAttributes) domainDescriptors.get(0);
						UpdateServiceInputCriteriaAttributesTEACmd updateCmd = new UpdateServiceInputCriteriaAttributesTEACmd(tempDomainSrvAttrs);						
						updateCmd.setIsOneWayOperation(bomSrvAttrs.getIsOneWayOperation().booleanValue());						
						executeCmd(updateCmd);
						domainSrvAttrs = (ServiceInputCriteriaAttributes) updateCmd.getObject();
					}
				}
				
				if (domainSrvAttrs != null) {				
					// update operation name					
					WSDLOperation bomWsdlOp = bomSrvAttrs.getWsdlOperation();
					WSDLOperation domainWsdlOp = domainSrvAttrs.getWsdlOperation();
					if (bomWsdlOp != null && bomWsdlOp.getName() != null) {						
						if (domainWsdlOp == null) {
							// create a new WSDL Operation
							AddWSDLOperationToServiceInputCriteriaAttributesTEACmd addCmd = new AddWSDLOperationToServiceInputCriteriaAttributesTEACmd(domainSrvAttrs);
							addCmd.setName(bomWsdlOp.getName());							
							executeCmd(addCmd);							
						} else {
							// Update the WSDL Operation
							UpdateWSDLOperationTEACmd updateCmd = new UpdateWSDLOperationTEACmd(domainWsdlOp);
							updateCmd.setName(bomWsdlOp.getName());
							executeCmd(updateCmd);						
						}					
					}					
					
					// update the message name
					WSDLWSIMessage bomWsdlMsg = (WSDLWSIMessage) bomSrvAttrs.getWsdlMessage();
					WSDLWSIMessage domainWsdlMsg = (WSDLWSIMessage) domainSrvAttrs.getWsdlMessage();
					if (bomWsdlMsg != null) {
						if (domainWsdlMsg == null) {
							// create a new WSDL Operation
							AddWSDLWSIMessageToServiceInputCriteriaAttributesTEACmd addCmd = new AddWSDLWSIMessageToServiceInputCriteriaAttributesTEACmd(domainSrvAttrs);
							if (bomWsdlMsg.getName() != null) {
								addCmd.setName(bomWsdlMsg.getName());
							}
							executeCmd(addCmd);	
							domainWsdlMsg = (WSDLWSIMessage) addCmd.getObject();
						} else {
							// Update the WSDL Operation
							UpdateWSDLWSIMessageTEACmd updateCmd = new UpdateWSDLWSIMessageTEACmd(domainWsdlMsg);
							if (bomWsdlMsg.getName() != null) {
								updateCmd.setName(bomWsdlMsg.getName());
							}
							executeCmd(updateCmd);
							domainWsdlMsg = (WSDLWSIMessage) updateCmd.getObject();
						}
						
						if (domainWsdlMsg != null) {
							WSDLPart bomWSDLPart = bomWsdlMsg.getWsdlPart();
							WSDLPart domainWSDLPart = domainWsdlMsg.getWsdlPart();
							
							if (bomWSDLPart != null && bomWSDLPart.getName() != null) {
								if (domainWSDLPart == null) {
									// create a new domainWSDLPart
									AddWSDLPartToWSDLWSIMessageTEACmd addCmd = new AddWSDLPartToWSDLWSIMessageTEACmd(domainWsdlMsg);
									addCmd.setName(bomWSDLPart.getName());
									executeCmd(addCmd);
								} else {
									// update an existing domainWSDLPart
									UpdateWSDLWSIMessageTEACmd updateCmd = new UpdateWSDLWSIMessageTEACmd(domainWsdlMsg);
									updateCmd.setName(bomWSDLPart.getName());
									executeCmd(updateCmd);
								}							
							}
						}
					}					
				}				
			}
		}
		LoggingUtil.traceExit(this, "updateRequest");
	}
	
	/**
	 * Update Model
	 */
	protected void updateModel() {		
		LoggingUtil.traceEntry(this, "updateModel");
		super.updateModel();
		
		// Attribute name
		updateAttribute();
		if(domainModel instanceof HumanTask) {
			ResourceRequirement resReq = ((HumanTask)domainModel).getPotentialOwner();
			if(resReq == null) {
				UpdateHumanTaskBOMCmd cmd0 = new UpdateHumanTaskBOMCmd((HumanTask)domainModel);
				UpdateHumanTaskBOMCmd cmd = new UpdateHumanTaskBOMCmd((HumanTask)domainModel);
				List required = ((HumanTask)domainModel).getResourceRequirement();
				if(required != null && !required.isEmpty()) {
					// d159547
					String primaryOwnerName = UtilResourceBundleSingleton.INSTANCE.getMessage(CommonMessageKeys.class, CommonMessageKeys.PRIMARY_OWNER);
					String personName = UtilResourceBundleSingleton.INSTANCE.getMessage(CommonMessageKeys.class, CommonMessageKeys.PERSON);
					int requiredSize = required.size();
					for (int i = 0; i < requiredSize; i++) {
						ResourceRequirement rr = (ResourceRequirement)required.get(i);
						if (rr.getName().equals(primaryOwnerName)) {
							resReq = rr;
							break;
						} else if (rr instanceof IndividualResourceRequirement && rr.getName().equals(personName)) {
							Type resourceType = ((IndividualResourceRequirement)rr).getResourceType();
							if(resourceType.getUid().equals("FID-00000000000000000000000000000101")) {
								resReq = (IndividualResourceRequirement)rr;
								break;
							}
						}
					}
//					for (int i = 0; i < requiredSize; i++) {
//						if (required.get(i) instanceof IndividualResourceRequirement) {
//							Type resourceType = ((IndividualResourceRequirement)required.get(i)).getResourceType();
//							if(resourceType.getName().equals("Person") && resourceType.getUid().equals("FID-00000000000000000000000000000101")) {
//								resReq = (IndividualResourceRequirement)required.get(i);
//								break;
//							}
//						}
//					}
//					if(resReq == null) {
//						for (int i = 0; i < requiredSize; i++) {
//							if (required.get(i) instanceof IndividualResourceRequirement) {
//								resReq = (IndividualResourceRequirement)required.get(i);
//								break;
//							}
//						}
//					}
//					if(resReq == null) {
//						resReq = (IndividualResourceRequirement)required.get(0);
//					}
					cmd.setPotentialOwner(resReq);
					cmd0.appendAndExecute(cmd);
				}
			}
		}
		
		LoggingUtil.traceExit(this, "updateModel");
	}
	
	/**
	 * Create pins
	 */
	protected void createPin() {
		// The pins will be created by the command automatically while the parameters are created.
	}	
	
	/**
	 * Create the pin set
	 */	
	protected void createPinSet() {
		// The pin sets will be created by the command automatically while the parameter set are created.		
	}		
	
	/**
	 * update the attribute
	 */
	private void updateAttribute() {
		LoggingUtil.traceEntry(this, "updateAttribute");
		// Attribute name
		UpdateSANBOMCmd cmd = new UpdateSANBOMCmd((StructuredActivityNode)domainModel);
		String name = ((StructuredActivityNode)action).getName();
		if (name == null) {
			LoggingUtil.traceExit(this, "updateAttribute");
			return;
		}
		cmd.setName(name);
		// Execute the command
		if (cmd.canExecute()) {
			try {
				cmd.execute();
			} catch (RuntimeException e) {
				logWarning(getImportSession(), 
						IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
						IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
			}
		} else {		
			logWarning(getImportSession(), 
					IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
					IImportResultMessages.CANNOT_EXECUTE_BOM_COMMAND);									
		}	
		LoggingUtil.traceExit(this, "updateAttribute");
	}
	
	private void associatePinset() {
		// Attribute outputPinSet
		// Attribute inputPinSet
		AssociateInputPinSetWithOutputPinSetPeCmd cmd = null;
		ImportContext context = getImportSession().getContext().getSubContext(IImportFramework.CONTEXT_PROCESS_KEY).getSubContext(process);
		InputPinSet inputPinSet = null;
		OutputPinSet outputPinSet = null;
		Iterator outputPinSetIterator = null;
		EObject inputViewModel = null;
		EObject outputViewModel = null;
		
		PeCmdFactory cmdFactory = getPeCmdFactory();
		
		EObject domainModel = null;
		List contents = null;
		Iterator pinSetIterator = action.getInputPinSet().iterator();
		while(pinSetIterator.hasNext()) {
			inputPinSet = (InputPinSet) pinSetIterator.next();
			inputViewModel = (EObject) context.get(inputPinSet);
			if (inputViewModel == null) {
				continue;
			}
			outputPinSetIterator = inputPinSet.getOutputPinSet().iterator();
			while(outputPinSetIterator.hasNext()) {
				outputPinSet = (OutputPinSet) outputPinSetIterator.next();
				outputViewModel = (EObject) context.get(outputPinSet);
				if (outputViewModel == null) {
					continue;
				}
				cmd = (AssociateInputPinSetWithOutputPinSetPeCmd) 
				cmdFactory.buildAssociateInputPinSetWithOutputPinSetPeCmd(inputViewModel, outputViewModel);
				if (cmd.canExecute()) {
					try {
						cmd.execute();
					} catch (RuntimeException e) {
						logWarning(getImportSession(), 
								IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null,  
								IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);							
					}
				} else {
					logWarning(getImportSession(), 
							IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
							IImportResultMessages.CANNOT_EXECUTE_ASSOCIATE_CEF_COMMAND);
				}
			}
		}
	}
	
	/**
	 * Register the pin and pin set of this SAN
	 */
	private void registerPinAndPinset() {
		if (!(domainModel instanceof Action)) {
			return;
		}
		if (!(viewModel instanceof CommonContainerModel)) {
			return;
		}		
		Action newAction = (Action) domainModel;		
		CommonContainerModel newViewAction = (CommonContainerModel) viewModel;
		
		// Get pin and pinset list
		List list = null;
		List domainList = null;
		List viewList = null;
		list = action.getInputPinSet();
		domainList = newAction.getInputPinSet();
		
		//AZ added to handle targetnamespace 
		updatePinSetComment(list,domainList);
		
		// 20050419 - create the UID hashmap for the InputPinSet in ADF Import
		int size = 0, pinSetSize = 0, domainPinSetSize = 0;
		if (list != null && !list.isEmpty()) {
			pinSetSize = list.size();
			if (domainList != null && !domainList.isEmpty()) {
				domainPinSetSize = domainList.size();
			}
			if (pinSetSize > domainPinSetSize) {
				size = domainPinSetSize;
			} else {
				size = pinSetSize;
			}
			
			HashMap processHashMap = BOMUtil.getUIDMap(getImportSession().getContext());
			for (int i = 0; i < size; i++) {
				InputPinSet inputPinSet = (InputPinSet) list.get(i);
				if (inputPinSet.getUid() != null) {
					InputPinSet domainPinSet = (InputPinSet) domainList.get(i);					
					// track the source process elements UID as 'key' and its corresponding working copy process element UID as 'value'
					processHashMap.put(inputPinSet.getUid(), domainPinSet.getUid());
				}
			}
		}
		// end of 20050419 - create the UID hashmap for the InputPinSet in ADF Import	
		
		viewList = newViewAction.getCompositionChildren();
		registerObjectByOrder(list, domainList, viewList);
		list = action.getOutputPinSet();
		domainList = newAction.getOutputPinSet();
		
		//AZ added to handle targetnamespace 
		updatePinSetComment(list,domainList);
		
		// 20050419 - create the UID hashmap for the InputPinSet in ADF Import
		size = 0; 
		pinSetSize = 0; 
		domainPinSetSize = 0;
		if (list != null && !list.isEmpty()) {
			pinSetSize = list.size();
			if (domainList != null && !domainList.isEmpty()) {
				domainPinSetSize = domainList.size();
			}
			if (pinSetSize > domainPinSetSize) {
				size = domainPinSetSize;
			} else {
				size = pinSetSize;
			}
			
			HashMap processHashMap = BOMUtil.getUIDMap(getImportSession().getContext());
			for (int i = 0; i < size; i++) {
				OutputPinSet outputPinSet = (OutputPinSet) list.get(i);
				if (outputPinSet.getUid() != null) {
					OutputPinSet domainPinSet = (OutputPinSet) domainList.get(i);					
					// track the source process elements UID as 'key' and its corresponding working copy process element UID as 'value'
					processHashMap.put(outputPinSet.getUid(), domainPinSet.getUid());
				}
			}
		}
		// end of 20050419 - create the UID hashmap for the InputPinSet in ADF Import	
		
		registerObjectByOrder(list, domainList, viewList);
		list = action.getInputObjectPin();
		domainList = newAction.getInputObjectPin();	
		//*******************************
		//AZ added for update comments
		updateComments(list,domainList);
		//*******************************
		registerObjectByOrder(list, domainList, viewList);
		
		list = action.getInputControlPin();
		domainList = newAction.getInputControlPin();		
		registerObjectByOrder(list, domainList, viewList);
		
		list = action.getOutputObjectPin();
		domainList = newAction.getOutputObjectPin();
		//*******************************
		//AZ added for update comments
		updateComments(list,domainList);
		//*******************************
		registerObjectByOrder(list, domainList, viewList);
		
		list = action.getOutputControlPin();
		domainList = newAction.getOutputControlPin();		
		registerObjectByOrder(list, domainList, viewList);
	}
	
	private void updateComments(List importedObjectPins,List createdObjectPins){
		LoggingUtil.traceEntry(this, "updateComments");
		ObjectPin pin = null;
		ObjectPin workingCopy = null;
		if(importedObjectPins != null && createdObjectPins != null && 
				createdObjectPins.size() == importedObjectPins.size()){
			for(int i=0;i< importedObjectPins.size();i++){
				Object eachImport = importedObjectPins.get(i);
				Object eachNewCopy = createdObjectPins.get(i);
				if(eachImport instanceof ObjectPin && eachNewCopy instanceof ObjectPin){
					pin = (ObjectPin)eachImport;
					workingCopy = (ObjectPin)eachNewCopy;
					EList comments = pin.getOwnedComment();
//					if(comments != null && comments.size() > 1){
					if(comments != null && comments.size() > 0){
						Iterator it = comments.iterator();
						Comment comment = null;
						Comment workingComment = null;
						AddCommentToElementBOMCmd addCmd = null;
						while(it.hasNext()){
							comment = (Comment)it.next();
							addCmd = new AddCommentToElementBOMCmd((Pin)workingCopy);
							addCmd.setBody(comment.getBody());
							if(addCmd.canExecute()){
								try{
									addCmd.execute();
								}catch(RuntimeException ex){									
								}
							}
						}
					}
				}
			}
		}		
		LoggingUtil.traceExit(this, "updateComments");
	}
	
	/**
	 * Register object by order
	 * @param list
	 * @param domainList
	 * @param viewList
	 */
	private void registerObjectByOrder(final List list, final List domainList, final List viewList) {
		Iterator iterator = list.iterator();
		Iterator domainIterator = domainList.iterator();
		Iterator viewIterator = null;
		Object element = null;
		Object domainElement = null;
		Object domainElementInView = null;
		CommonNodeModel viewElement = null;		
		while (iterator.hasNext()) {
			element = iterator.next();
			if (domainIterator.hasNext()) {
				domainElement = domainIterator.next();
				viewIterator = viewList.iterator(); 
				while(viewIterator.hasNext()) {
					viewElement = (CommonNodeModel) viewIterator.next();
					if (viewElement.getDomainContent().size()>0) {
						domainElementInView = viewElement.getDomainContent().get(0);
						if (domainElement == domainElementInView) {
							// Bind element and viewElement
							putModelInContext(element, viewElement);
							break;
						}
					}
				}
			} else {
				break;
			}
		}
	}
	
	/**
	 * Execute the given command
	 * @param cmd
	 */
	protected void executeCmd(AbstractCommand cmd){
		LoggingUtil.traceEntry(this, "executeCmd");
		if(cmd.canExecute()) {
			try {
				cmd.execute();
			} catch (RuntimeException e) {
				LoggingUtil.trace(this, "executeCmd", IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
				LoggingUtil.traceExit(this, "executeCmd");
				return;
			}
		} else {
			LoggingUtil.trace(this, "executeCmd", IImportResultMessages.CANNOT_EXECUTE_BOM_COMMAND);	
			LoggingUtil.traceExit(this, "executeCmd");
			return;			
		}
		LoggingUtil.traceExit(this, "executeCmd");
	}
	
	/* 
	 * Return a list of technical attributes owned by the element.
	 * @param element, element to be retrieved technical attributes from.
	 * @return a list of technical attributes owned by the element.
	 */
	private List getTechnicalAttributes(Element element) {
		List techAttributes = new ArrayList();
		Descriptor nextDescriptor;
		for(Iterator it = element.getOwnedDescriptor().iterator(); it.hasNext();){
			nextDescriptor = (Descriptor)it.next();
			if(nextDescriptor instanceof TechnicalAttributes){
				techAttributes.add(nextDescriptor);
			}
		}		
		return techAttributes;		
	}
	
	private void updatePinSetComment(List incoming,List domainList){
		int pinSetSize = 0;
		int domainPinSetSize = 0;
		int size = 0;
		if (incoming != null && !incoming.isEmpty()) {
			pinSetSize = incoming.size();
			if (domainList != null && !domainList.isEmpty()) {
				domainPinSetSize = domainList.size();
			}
			if (pinSetSize > domainPinSetSize) {
				size = domainPinSetSize;
			} else {
				size = pinSetSize;
			}
			for (int i = 0; i < size; i++) {
				PinSet pinSet = (PinSet) incoming.get(i);
				if (pinSet.getOwnedComment() != null && pinSet.getOwnedComment().size() > 0) {
					Comment comment = (Comment)pinSet.getOwnedComment().get(0);
					PinSet domainPinSet = (PinSet) domainList.get(i);	
					AddCommentToElementBOMCmd addCommentCmd = new AddCommentToElementBOMCmd(domainPinSet);
					addCommentCmd.setBody(comment.getBody());
					if(addCommentCmd.canExecute()){
						addCommentCmd.execute();
					}
				}
			}
		}
		
	}
}
