package com.ibm.btools.blm.ie.imprt.rule.util;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.emf.common.command.BasicCommandStack;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.xmi.XMLResource;
import org.eclipse.emf.edit.domain.AdapterFactoryEditingDomain;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.wst.wsdl.Definition;
import org.eclipse.wst.wsdl.Import;
import org.eclipse.wst.wsdl.util.WSDLResourceImpl;
import org.eclipse.xsd.XSDImport;
import org.eclipse.xsd.XSDInclude;
import org.eclipse.xsd.XSDRedefine;
import org.eclipse.xsd.XSDSchema;
import org.eclipse.xsd.util.XSDResourceImpl;

import com.ibm.btools.blm.compoundcommand.navigator.util.NamespaceValidationCmd;
import com.ibm.btools.blm.compoundcommand.process.util.PECommandConstants;
import com.ibm.btools.blm.ie.imprt.IImportConstants;
import com.ibm.btools.blm.ie.imprt.IImportFramework;
import com.ibm.btools.blm.ie.imprt.ImportContext;
import com.ibm.btools.blm.ie.imprt.ImportSession;
import com.ibm.btools.blm.ui.navigation.model.AbstractChildContainerNode;
import com.ibm.btools.blm.ui.navigation.model.AbstractChildLeafNode;
import com.ibm.btools.blm.ui.navigation.model.AbstractLibraryChildNode;
import com.ibm.btools.blm.ui.navigation.model.AbstractNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationBOCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationBusinessEntityNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCategoryCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCategoryInstanceNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCategoryNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCategoryValueInstanceNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCategoryValueTypeNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationComplexTypeDefinitionNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationComplexTypeDefinitionsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationComplexTypeTemplateNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationComplexTypeTemplatesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationDataCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationDefinitionCategoryNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationDefinitionNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProcessCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProcessNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProjectNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourceCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourceDefinitionCategoryNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourceDefinitionNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourceNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationRoleNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationServiceNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationSignalNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationTaskNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationXSDFileNode;
import com.ibm.btools.blm.ui.navigation.model.command.business.UpdateAbstractNodeBusCmd;
import com.ibm.btools.blm.ui.navigation.model.util.NavigationConstants;
import com.ibm.btools.blm.ui.notationregistry.model.util.ModelAdapterFactory;
import com.ibm.btools.bom.command.artifacts.AddCommentToElementBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralIntegerUpperBoundToMultiplicityElementBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralUnlimitedNaturalUpperBoundToMultiplicityElementBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddUpdateCommentBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddUpdateLiteralSpecificationBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddUpdateValueSpecificationBOMCmd;
import com.ibm.btools.bom.command.artifacts.RemoveCommentBOMCmd;
import com.ibm.btools.bom.command.artifacts.RemoveValueSpecificationBOMCmd;
import com.ibm.btools.bom.command.artifacts.UpdateCommentBOMCmd;
import com.ibm.btools.bom.command.artifacts.UpdateLiteralIntegerBOMCmd;
import com.ibm.btools.bom.command.artifacts.UpdateLiteralUnlimitedNaturalBOMCmd;
import com.ibm.btools.bom.command.compound.CloseRootObjectBOMCmd;
import com.ibm.btools.bom.command.compound.OpenRootObjectForUpdateBOMCmd;
import com.ibm.btools.bom.command.compound.PredefTypesConst;
import com.ibm.btools.bom.command.compound.SaveRootObjectBOMCmd;
import com.ibm.btools.bom.command.externalmodels.AddUpdateExternalDocumentBOMCmd;
import com.ibm.btools.bom.command.externalmodels.UpdateExternalSchemaBOMCmd;
import com.ibm.btools.bom.command.externalmodels.UpdateExternalServiceBOMCmd;
import com.ibm.btools.bom.model.artifacts.Class;
import com.ibm.btools.bom.model.artifacts.Comment;
import com.ibm.btools.bom.model.artifacts.Element;
import com.ibm.btools.bom.model.artifacts.LiteralInteger;
import com.ibm.btools.bom.model.artifacts.LiteralUnlimitedNatural;
import com.ibm.btools.bom.model.artifacts.MultiplicityElement;
import com.ibm.btools.bom.model.artifacts.NamedElement;
import com.ibm.btools.bom.model.artifacts.Package;
import com.ibm.btools.bom.model.artifacts.PackageableElement;
import com.ibm.btools.bom.model.artifacts.PrimitiveType;
import com.ibm.btools.bom.model.artifacts.Signal;
import com.ibm.btools.bom.model.artifacts.Type;
import com.ibm.btools.bom.model.artifacts.ValueSpecification;
import com.ibm.btools.bom.model.externalmodels.ExternalDocument;
import com.ibm.btools.bom.model.externalmodels.ExternalSchema;
import com.ibm.btools.bom.model.externalmodels.ExternalService;
import com.ibm.btools.bom.model.models.ExternalModel;
import com.ibm.btools.bom.model.models.InformationModel;
import com.ibm.btools.bom.model.models.Model;
import com.ibm.btools.bom.model.models.OrganizationModel;
import com.ibm.btools.bom.model.models.ProcessModel;
import com.ibm.btools.bom.model.organizationstructures.OrganizationUnit;
import com.ibm.btools.bom.model.organizationstructures.OrganizationUnitType;
import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.bom.model.processes.activities.Activity;
import com.ibm.btools.bom.model.processes.humantasks.Form;
import com.ibm.btools.bom.model.resources.Resource;
import com.ibm.btools.bom.model.resources.Role;
import com.ibm.btools.bom.model.services.Behavior;
import com.ibm.btools.model.filemanager.FileMGR;
import com.ibm.btools.model.modelmanager.dependencymanager.DependencyManager;
import com.ibm.btools.model.modelmanager.dependencymanager.DependencyModel;
import com.ibm.btools.model.modelmanager.validation.ValidateProjectCmd;
import com.ibm.btools.model.resourcemanager.ResourceMGR;
import com.ibm.btools.model.resourcemanager.SaveResourceCmd;
import com.ibm.btools.model.resourcemanager.util.PredefUtil;
import com.ibm.btools.ui.attachmentmanager.AttachmentManager;
import com.ibm.btools.util.converters.UnitOfMeasureConverter;

/**
 * Utility class for BOM
 */
public class BOMUtil {
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	
	
	public static final String ASPECT_SCHEMA_TYPE = "SchemaType";
	public static final String ASPECT_SCHEMA_TYPE_PRIVATE = "SchemaType_Private";
	public static final String ASPECT_SERVICE_OPERATION = "ServiceOperation";
	public static final String ASPECT_SERVICE_CATALOG = "ServiceCatalog";
	public static final String ASPECT_DATA_CATALOG = "DataCatalog";
	public static final String ASPECT_INLINE_DATA = "inlineData";
	public static final String ASPECT_FILE_ATTACHMENT = "fileAttachment";
	public static final String ASPECT_INLINE_TYPE = "SchemaType_Inline";
	public static final String FILE_ATTACHMENT_NODE_NAME = "__FILE__ATTACHMENT";
	
	private static final boolean bInterfaceWISCompliant = true;
	private static final String XSD_FILE_EXT = ".xsd";	
	private static final String WSDL_FILE_EXT = ".wsdl";
	//UID prefix for the document conent commment owned by the root bom element
	private static final String DOCUMENT_CONTENT = "BLM-DOCUMENT-CONTENT-";
	//UID prefix for the source file name comment
	private static final String SOURCE_FILE = "BLM-SOURCE-FILE-";
		
	//	Initialize dummy Editing Domain for getting command stack to defend
	//null pointer in the detach file method of attachment manager
	private static BasicCommandStack commandStack = new BasicCommandStack();
	// EditingDomain
	private static EditingDomain ivEditingDomain = new AdapterFactoryEditingDomain(
			new ModelAdapterFactory(), 
			commandStack,
			new HashMap());
	
	/**
	 * This method is to update the "attribute1" for the node in order for the 
	 * navigator to filter it out of the user's perspective
	 * @param type
	 * @param newNode
	 */
	public static void updateNodeAttribute(NamedElement type, AbstractNode newNode){		
		if(BOMUtil.isPrivateSchemaType(type) ||BOMUtil.isFileAttachment(type)|| BOMUtil.isInlineSchema(type)){			
			UpdateAbstractNodeBusCmd updateCmd = new UpdateAbstractNodeBusCmd(newNode);
			updateCmd.setAttribute1(BOMUtil.ASPECT_SCHEMA_TYPE_PRIVATE);
			if(updateCmd.canExecute()){
				updateCmd.execute();
			}
		}
	}
	/**
	 * Return the description of the element. It is the body of the 
	 * first comment without any annotationElement.
	 * @param element
	 * @return
	 */
	public static String getDescription(final Element element) {
		LoggingUtil.traceEntry(BOMUtil.class, "getDescription");
		
		Iterator iterator = element.getOwnedComment().iterator();
		Comment comment = null;
		while(iterator.hasNext()) {
			comment = (Comment) iterator.next();
			if (comment.getAnnotatedElement().size() == 0) {
				LoggingUtil.traceExit(BOMUtil.class, "getDescription");
				return comment.getBody();
			}
		}		
		
		LoggingUtil.traceExit(BOMUtil.class, "getDescription");
		return null;
	}
	
	/**
	 * Update the description of the element. It is the body of the 
	 * first comment without any annotationElement.
	 * @param element
	 * @return
	 */
	public static void updateDescription(Element element, final String description) {
		LoggingUtil.traceEntry(BOMUtil.class, "updateDescription");
		
		if (description == null || description.length() == 0) {	
			LoggingUtil.traceExit(BOMUtil.class, "updateDescription");	
			return;
		}				
		Iterator iterator = element.getOwnedComment().iterator();
		Comment comment = null;
		while(iterator.hasNext()) {
			comment = (Comment) iterator.next();
			if (comment.getAnnotatedElement().size() == 0) {
				break;
			} else {
				comment = null;
			}
		}
		AddUpdateCommentBOMCmd cmd = null;
		if (comment == null) {
			// Create a description
			cmd = new AddCommentToElementBOMCmd(element);			
		} else {
			// updatre the description
			cmd = new UpdateCommentBOMCmd(comment); 
		}
		cmd.setBody(description);
		if (cmd.canExecute()) {
			try {
				cmd.execute();
			} catch (RuntimeException e) {
				LoggingUtil.trace(BOMUtil.class, "updateDescription", "The command throw a RuntimeException.");								
			}
		} else {
			LoggingUtil.trace(BOMUtil.class, "updateDescription", "The command cannot be exected.");			
		}
		
		LoggingUtil.traceExit(BOMUtil.class, "updateDescription");
	}	
	
	/**
	 * Get type
	 * @param projectName
	 * @param element
	 * @param context
	 * @return
	 */
	public static PackageableElement getType(final String projectName, final PackageableElement element, final ImportContext context) {
		LoggingUtil.traceEntry(BOMUtil.class, "getType");
		if (projectName == null) {
			LoggingUtil.trace(BOMUtil.class, "getType", "The project name should not be null.");
			LoggingUtil.traceExit(BOMUtil.class, "getType");
			return null;
		}
		
		if (element == null) {
			LoggingUtil.trace(BOMUtil.class, "getType", "The element should not be null.");
			LoggingUtil.traceExit(BOMUtil.class, "getType");
			return null;
		}
		
		PackageableElement masterElement = null;
		Object object = context.get(element);
		AbstractLibraryChildNode node = null;
		
		if (object != null) {
			if (object instanceof AbstractLibraryChildNode) {
				LoggingUtil.trace(BOMUtil.class, "getType", "The object in the context is: " + object.getClass() + ".");
				node = (AbstractLibraryChildNode) object;
			}
		}
		
		masterElement = (PackageableElement) BOMUtil.loadRootObject(node);
		if (masterElement == null) {
			LoggingUtil.trace(BOMUtil.class, "getType", "This is not in the context.");
			if (element instanceof PrimitiveType) {
				LoggingUtil.trace(BOMUtil.class, "getType", "It is a primitive type.");
				// Ray 06/06/07 - Shared Across Project fix.  Find the type from the new predefined project
				//masterElement = getPrimitiveType(projectName, element.getName());
				masterElement = getPrimitiveType(PredefUtil.getPredefinedProjectName(), element.getName());
			} else {
				LoggingUtil.trace(BOMUtil.class, "getType", "It is a predefined type.");
				// Ray 06/06/07 - Shared Across Project fix.  Find the type from the new predefined project
				//masterElement = getPredefinedType(projectName, element);
				masterElement = getPredefinedType(PredefUtil.getPredefinedProjectName(), element);
			}
		}
		
		LoggingUtil.traceExit(BOMUtil.class, "getType");
		return masterElement;
	}
	
	/**
	 * Returns predefined categoryValue organizationUnit for the given organization Unit
	 * @param projectName
	 * @param orgUnit
	 * @param context
	 * @return
	 */
	public static OrganizationUnit getPredefinedCategoryValueOrganizationUnit(final String projectName, 
			final OrganizationUnit orgUnit, final ImportContext context){
		
		LoggingUtil.traceEntry(BOMUtil.class, "getPredefinedCategoryValueOrganizationUnit");
		
		OrganizationModel parent = (OrganizationModel)orgUnit.getOwningPackage();
		if(parent == null){
			return null;
		}
		
		String[] FIXED_CATEGORY_IDS = {PredefTypesConst.CATEGORY_INSTANCE_1_FUID, 
				PredefTypesConst.CATEGORY_INSTANCE_2_FUID,
				PredefTypesConst.CATEGORY_INSTANCE_3_FUID,
		};
		
		//use UID to identify the parent category, since name is susceptive to change.
		String parentCategoryFixedId = null;							   
		if(parent.getAspect().compareTo(PredefTypesConst.CATEGORY_ASPECT)== 0){
			for(int i = 0; i< FIXED_CATEGORY_IDS.length; i++){
				if(parent.getUid() != null && FIXED_CATEGORY_IDS[i].compareTo(parent.getUid())== 0){
					parentCategoryFixedId = FIXED_CATEGORY_IDS[i];  
					break;
				}
			}
		}
		
		if((parentCategoryFixedId != null)){
			String parentCategoryName = parent.getName(); //this is require non-localized name is used for predefined types.
			//it is reference one of the predefined category value
			NavigationProjectNode navProjectNode = NavigatorUtil.getProjectNode(projectName);
			if (navProjectNode == null) {
				LoggingUtil.trace(BOMUtil.class, "getPredefinedType", "The project node should not be null.");
				LoggingUtil.traceExit(BOMUtil.class, "getPredefinedType");			
				return null;
			}
			List navCategoryCatalogList = navProjectNode.getLibraryNode().getNavigationCategoryCatalogs().getNavigationCategoryCatalog();
			Iterator iterator = navCategoryCatalogList.iterator();		
			NavigationCategoryCatalogNode navCategoryCatalog = null;
			Object navNode = null;
			while(iterator.hasNext()) {
				navNode = iterator.next();
				if (navNode instanceof NavigationCategoryCatalogNode) {
					// The predefined type resource catalog
					if (((NavigationCategoryCatalogNode) navNode).getId().compareTo(NavigationConstants.PREDEFINED_TYPES_DATA_CATALOG_NAME)== 0) {
						LoggingUtil.trace(BOMUtil.class, "getPredefinedType", "The predefined resource types navigation node.");
						navCategoryCatalog = (NavigationCategoryCatalogNode) navNode;
						break;
					}
				}
			}				
			
			if (navCategoryCatalog != null) {
				String orgUnitName = orgUnit.getName();								
				AbstractLibraryChildNode navCategoryInsatnceNode = null;
				Object rootObject = null;							
				List navCategoryInstanceList = navCategoryCatalog.getNavigationCategoryInstance();
				Iterator categoryIterator = navCategoryInstanceList.iterator();
				while(categoryIterator.hasNext()) {
					// Get the navigator node
					navCategoryInsatnceNode = (AbstractLibraryChildNode) categoryIterator.next();
					if (navCategoryInsatnceNode instanceof NavigationCategoryInstanceNode) {
						String parentId = ((NavigationCategoryInstanceNode)navCategoryInsatnceNode).getId();
						if (  parentId != null && parentId.equals(parentCategoryName)) {
							//parent category found, find the categoryValue
							List categoryValues = ((NavigationCategoryInstanceNode)navCategoryInsatnceNode).getNavigationCategoryValueInstance();
							NavigationCategoryValueInstanceNode categoryValueNode = null;
							for(Iterator it = categoryValues.iterator(); it.hasNext(); ){
								categoryValueNode= (NavigationCategoryValueInstanceNode) it.next();
								String catValueNodeId = categoryValueNode.getId();
								if(orgUnitName != null && catValueNodeId != null && catValueNodeId.equals(orgUnitName)){
									//category value found, load the type by its URI						
									rootObject = loadRootObject(categoryValueNode);
									if (rootObject instanceof OrganizationUnit) {
										LoggingUtil.trace(BOMUtil.class, "getPredefinedCategoryValueOrganizationUnit", "The predefined resource type");
										LoggingUtil.traceExit(BOMUtil.class, "getPredefinedCategoryValueOrganizationUnit");	
										
										return (OrganizationUnit) rootObject;
									}
									
								}
							}
							
						}
					}
				}
			}			
		}
		
		LoggingUtil.traceExit(BOMUtil.class, "getPredefinedCategoryValueOrganizationUnit", "null is returned");	
		return null;
	}
	
	
	/**
	 * Get predefined categoryValueTemplate
	 * @param projectName
	 * @param element
	 * @param context
	 * @return
	 */
	public static PackageableElement getCategoryValueTemplate(final String projectName, final PackageableElement element, final ImportContext context) {
		
		LoggingUtil.traceEntry(BOMUtil.class, "getCategoryValueTemplate");
		if (projectName == null) {
			LoggingUtil.trace(BOMUtil.class, "getCategoryValueTemplate", "The project name should not be null.");
			LoggingUtil.traceExit(BOMUtil.class, "getCategoryValueTemplate");
			return null;
		}
		
		if (element == null) {
			LoggingUtil.trace(BOMUtil.class, "getCategoryValueTemplate", "The element should not be null.");
			LoggingUtil.traceExit(BOMUtil.class, "getCategoryValueTemplate");
			return null;
		}
		
		
		if(! (element instanceof OrganizationUnitType) || 
				!element.getName().equals(PredefTypesConst.CATEGORY_TEMPLATE_VALUE_NAME)){				
			LoggingUtil.trace(BOMUtil.class, "getCategoryValueTemplate", "The element type should be category value template");
			LoggingUtil.traceExit(BOMUtil.class, "getCategoryValueTemplate");
			return null;
		}		
		
		PackageableElement masterElement = null;
		
		NavigationProjectNode navProjectNode = NavigatorUtil.getProjectNode(projectName);
		if (navProjectNode == null) {
			LoggingUtil.trace(BOMUtil.class, "getCategoryValueTemplate", "The project node should not be null.");
			LoggingUtil.traceExit(BOMUtil.class, "getCategoryValueTemplate");			
			return null;
		}
		List navCategoryCatalogList = navProjectNode.getLibraryNode().getNavigationCategoryCatalogs().getNavigationCategoryCatalog();
		Iterator iterator = navCategoryCatalogList.iterator();		
		NavigationCategoryCatalogNode navCategoryCatalog = null;
		Object navNode = null;
		while(iterator.hasNext()) {
			navNode = iterator.next();
			if (navNode instanceof NavigationCategoryCatalogNode) {
				// The predefined type resource catalog
				if (((NavigationCategoryCatalogNode) navNode).getId().compareTo(NavigationConstants.PREDEFINED_TYPES_DATA_CATALOG_NAME) == 0) {
					LoggingUtil.trace(BOMUtil.class, "getCategoryValueTemplate", "The predefined resource types navigation node.");
					navCategoryCatalog = (NavigationCategoryCatalogNode) navNode;
					break;
				}
			}
		}				
		
		if (navCategoryCatalog != null) {
			List navCategoryCatalogElementList = null;
			AbstractLibraryChildNode navCategoryElementNode = null;
			Object rootObject = null;
			
			NavigationCategoryValueTypeNode catValueTypeNode = navCategoryCatalog.getNavigationCategoryValueType();
			if(catValueTypeNode != null){
				// Navigation node found, load the type by its URI						
				rootObject = loadRootObject(catValueTypeNode);
				if (rootObject instanceof OrganizationUnitType) {
					masterElement = (Type) rootObject;
				}				
			}
		}	
		
		LoggingUtil.traceExit(BOMUtil.class, "getCategoryValueTemplate");
		return masterElement;
	}
	
	/**
	 * Load the Primitive type
	 * @param projectName
	 * @param typeName
	 * @return primitive type
	 */
	public static Type getPrimitiveType(final String projectName, final String typeName) {
		LoggingUtil.traceEntry(BOMUtil.class, "getPrimitiveType");		
		
		// Get the proejct node
		NavigationProjectNode navProjectNode = NavigatorUtil.getProjectNode(projectName);
		if (navProjectNode == null) {
			LoggingUtil.trace(BOMUtil.class, "getPrimitiveType", "The project node should not be null.");
			LoggingUtil.traceExit(BOMUtil.class, "getPrimitiveType");
			return null;
		}
		
		// Get the Data catalogs from root data catalog
		NavigationDataCatalogNode navDataCatalog;
		try {
			List navDataCatalogList = navProjectNode.getLibraryNode().getDataCatalogsNode().getDataCatalogNodes();
			Iterator iterator = navDataCatalogList.iterator();
			Object navNode = null;
			navDataCatalog = null;
			while(iterator.hasNext()) {
				navNode = iterator.next();
				if (navNode instanceof NavigationDataCatalogNode) {
					// The predefined type data catalog
					if (((NavigationDataCatalogNode) navNode).getId().equals(NavigationConstants.PREDEFINED_TYPES_DATA_CATALOG_NAME)) {
						LoggingUtil.trace(BOMUtil.class, "getPrimitiveType", "The predefined types navigation node.");
						navDataCatalog = (NavigationDataCatalogNode) navNode;
					}
				}
			}
			
			if (navDataCatalog != null) {
				List navDataList = navDataCatalog.getBusinessEntitiesNode().getBusinessEntityNodes();
				Iterator dataIterator = navDataList.iterator();
				AbstractLibraryChildNode navDataNode = null;
				Object rootObject = null;
				while(dataIterator.hasNext()) {
					// Get the navigator node
					navDataNode = (AbstractLibraryChildNode) dataIterator.next();
					if (navDataNode instanceof NavigationBusinessEntityNode) {
						if (((NavigationBusinessEntityNode) navDataNode).getId().equals(typeName)) {
							// Navigation node found, load the type by its URI						
							rootObject = loadRootObject(navDataNode);
							if (rootObject instanceof Type) {
								LoggingUtil.trace(BOMUtil.class, "getPrimitiveType", "The predefined type");
								LoggingUtil.traceExit(BOMUtil.class, "getPrimitiveType");
								return (Type) rootObject;
							}
						}
					}
				}
			}			
		} catch (RuntimeException e) {
			LoggingUtil.trace(BOMUtil.class, "getPrimitiveType", "The navigation model is incorrect.");
		}
		
		LoggingUtil.traceExit(BOMUtil.class, "getPrimitiveType");
		return null;
	}
	
	/**
	 * Load the Predefined type
	 * @param projectName
	 * @param element
	 * @return predefined type
	 */
	private static Type getPredefinedType(final String projectName, final PackageableElement element) {
		LoggingUtil.traceEntry(BOMUtil.class, "getPredefinedType");
		if (element == null) {
			LoggingUtil.trace(BOMUtil.class, "getPredefinedType", "The element should not be null.");
			LoggingUtil.traceExit(BOMUtil.class, "getPredefinedType");
			return null;
		}
		
		LoggingUtil.traceExit(BOMUtil.class, "getPredefinedType");
		return getPredefinedType(projectName, element.getName(), element);
	}	
	
	/**
	 * Load the Predefined type
	 * @param projectName
	 * @param typeName
	 * @return predefined type
	 */
	public static Type getPredefinedType(final String projectName, final String typeName, final PackageableElement element) {
		LoggingUtil.traceEntry(BOMUtil.class, "getPredefinedType");
		// Get the proejct node
		NavigationProjectNode navProjectNode = NavigatorUtil.getProjectNode(projectName);
		if (navProjectNode == null) {
			LoggingUtil.trace(BOMUtil.class, "getPredefinedType", "The project node should not be null.");
			LoggingUtil.traceExit(BOMUtil.class, "getPredefinedType");			
			return null;
		}
		
		Iterator iterator = null;
		Object navNode = null;
		
		// Get the Resource catalogs from root resource catalog		
		try {
			List navResourceCatalogList = navProjectNode.getLibraryNode().getResourceCatalogsNode().getResourceCatalogNodes();
			iterator = navResourceCatalogList.iterator();		
			NavigationResourceCatalogNode navResourceCatalog = null;
			while(iterator.hasNext()) {
				navNode = iterator.next();
				if (navNode instanceof NavigationResourceCatalogNode) {
					// The predefined type resource catalog
					if (((NavigationResourceCatalogNode) navNode).getId().equals(NavigationConstants.PREDEFINED_TYPES_DATA_CATALOG_NAME)) {
						LoggingUtil.trace(BOMUtil.class, "getPredefinedType", "The predefined resource types navigation node.");
						navResourceCatalog = (NavigationResourceCatalogNode) navNode;
					}
				}
			}
			
			if (navResourceCatalog != null) {
				List navResourceCatalogElementList = null;
				AbstractLibraryChildNode navResourceElementNode = null;
				Object rootObject = null;
				Iterator resourceElementIterator = null;
				
				navResourceCatalogElementList = navResourceCatalog.getResourceDefinitionsNode().getResourceDefinitionNodes();
				resourceElementIterator = navResourceCatalogElementList.iterator();
				while(resourceElementIterator.hasNext()) {
					// Get the navigator node
					navResourceElementNode = (AbstractLibraryChildNode) resourceElementIterator.next();
					if (navResourceElementNode instanceof NavigationResourceDefinitionNode) {
						//if (((NavigationResourceDefinitionNode) navResourceElementNode).getId().equals(typeName)) {
						// d121231 - Retrieving the predefined resource and resource definition by matching the NavNode BomUID with the element's UID
						if (((NavigationResourceDefinitionNode) navResourceElementNode).getBomUID() != null &&
								((NavigationResourceDefinitionNode) navResourceElementNode).getBomUID().equals(element.getUid())) {
							// Navigation node found, load the type by its URI						
							rootObject = loadRootObject(navResourceElementNode);
							if (rootObject instanceof Type) {
								LoggingUtil.trace(BOMUtil.class, "getPredefinedType", "The predefined resource type");
								LoggingUtil.traceExit(BOMUtil.class, "getPredefinedType");								
								return (Type) rootObject;
							}
						}
					}
				}
				
				// Not a resource definition, try resource definition category
				navResourceCatalogElementList = navResourceCatalog.getResourceDefinitionCategoriesNode().getResourceDefinitionCategoryNodes();
				resourceElementIterator = navResourceCatalogElementList.iterator();
				while(resourceElementIterator.hasNext()) {
					// Get the navigator node
					navResourceElementNode = (AbstractLibraryChildNode) resourceElementIterator.next();
					if (navResourceElementNode instanceof NavigationResourceDefinitionCategoryNode) {
						//if (((NavigationResourceDefinitionCategoryNode) navResourceElementNode).getId().equals(typeName)) {
						// d121231 - Retrieving the predefined resource and resource definition by matching the NavNode BomUID with the element's UID
						if (((NavigationResourceDefinitionCategoryNode) navResourceElementNode).getBomUID() != null &&
								((NavigationResourceDefinitionCategoryNode) navResourceElementNode).getBomUID().equals(element.getUid())) {
							// Navigation node found, load the type by its URI						
							rootObject = loadRootObject(navResourceElementNode);
							if (rootObject instanceof Type) {
								LoggingUtil.trace(BOMUtil.class, "getPredefinedType", "The predefined resource definition type");
								LoggingUtil.traceExit(BOMUtil.class, "getPredefinedType");
								return (Type) rootObject;
							}
						}
					}
				}
			}	
			
			// Get the Organization catalogs from root organization catalog		
			List navOrganizationCatalogList = navProjectNode.getLibraryNode().getOrganizationCatalogsNode().getOrganizationCatalogNodes();
			iterator = navOrganizationCatalogList.iterator();
			NavigationOrganizationCatalogNode navOrganizationCatalog = null;
			while(iterator.hasNext()) {
				navNode = iterator.next();
				if (navNode instanceof NavigationOrganizationCatalogNode) {
					// The predefined type organization catalog
					if (((NavigationOrganizationCatalogNode) navNode).getId().equals(NavigationConstants.PREDEFINED_TYPES_DATA_CATALOG_NAME)) {
						navOrganizationCatalog = (NavigationOrganizationCatalogNode) navNode;
					}
				}
			}
			
			if (navOrganizationCatalog != null) {
				List navOrganizationCatalogElementList = null;
				AbstractLibraryChildNode navOrganizationElementNode = null;
				Object rootObject = null;
				Iterator organizationElementIterator = null;
				
				navOrganizationCatalogElementList = navOrganizationCatalog.getOrganizationDefinitionsNode().getOrganizationDefinitionNodes();
				organizationElementIterator = navOrganizationCatalogElementList.iterator();
				while(organizationElementIterator.hasNext()) {
					// Get the navigator node
					navOrganizationElementNode = (AbstractLibraryChildNode) organizationElementIterator.next();
					if (navOrganizationElementNode instanceof NavigationOrganizationDefinitionNode) {
						if (((NavigationOrganizationDefinitionNode) navOrganizationElementNode).getId().equals(typeName)) {
							// Navigation node found, load the type by its URI						
							rootObject = loadRootObject(navOrganizationElementNode);
							if (rootObject instanceof Type) {
								LoggingUtil.trace(BOMUtil.class, "getPredefinedType", "The predefined organization type");
								LoggingUtil.traceExit(BOMUtil.class, "getPredefinedType");
								return (Type) rootObject;
							}
						}
					}
				}
				
				// Not a organization definition, try organization definition category
				navOrganizationCatalogElementList = navOrganizationCatalog.getOrganizationDefinitionCategoriesNode().getOrganizationDefinitionCategoryNodes();
				organizationElementIterator = navOrganizationCatalogElementList.iterator();
				while(organizationElementIterator.hasNext()) {
					// Get the navigator node
					navOrganizationElementNode = (AbstractLibraryChildNode) organizationElementIterator.next();
					if (navOrganizationElementNode instanceof NavigationOrganizationDefinitionCategoryNode) {
						if (((NavigationOrganizationDefinitionCategoryNode) navOrganizationElementNode).getId().equals(typeName)) {
							// Navigation node found, load the type by its URI						
							rootObject = loadRootObject(navOrganizationElementNode);
							if (rootObject instanceof Type) {
								LoggingUtil.trace(BOMUtil.class, "getPredefinedType", "The predefined organization definition type");
								LoggingUtil.traceExit(BOMUtil.class, "getPredefinedType");
								return (Type) rootObject;
							}
						}
					}
				}
			}		
		} catch (RuntimeException e) {
			LoggingUtil.trace(BOMUtil.class, "getPredefinedType", "The navigation model is incorrect.");
		}	
		
		LoggingUtil.traceExit(BOMUtil.class, "getPredefinedType");
		return null;
	}	
	
	/**
	 * Load the Primitive type node
	 * @param projectName
	 * @param typeName
	 * @return primitive type node
	 */
	public static AbstractLibraryChildNode getPrimitiveTypeNode(final String projectName, final String typeName) {
		LoggingUtil.traceEntry(BOMUtil.class, "getPrimitiveTypeNode");
		// Get the proejct node
		NavigationProjectNode navProjectNode = NavigatorUtil.getProjectNode(projectName);
		if (navProjectNode == null) {
			LoggingUtil.trace(BOMUtil.class, "getPrimitiveTypeNode", "The project node should not be null.");
			LoggingUtil.traceExit(BOMUtil.class, "getPrimitiveTypeNode");
			return null;
		}
		
		// Get the Data catalogs from root data catalog		
		List navDataCatalogList = navProjectNode.getLibraryNode().getDataCatalogsNode().getDataCatalogNodes();
		Iterator iterator = navDataCatalogList.iterator();
		Object navNode = null;
		NavigationDataCatalogNode navDataCatalog = null;
		try {
			while(iterator.hasNext()) {
				navNode = iterator.next();
				if (navNode instanceof NavigationDataCatalogNode) {
					// The predefined type data catalog
					if (((NavigationDataCatalogNode) navNode).getId().equals(NavigationConstants.PREDEFINED_TYPES_DATA_CATALOG_NAME)) {
						navDataCatalog = (NavigationDataCatalogNode) navNode;
					}
				}
			}
			
			if (navDataCatalog != null) {
				List navDataList = navDataCatalog.getBusinessEntitiesNode().getBusinessEntityNodes();
				Iterator dataIterator = navDataList.iterator();
				AbstractLibraryChildNode navDataNode = null;
				while(dataIterator.hasNext()) {
					// Get the navigator node
					navDataNode = (AbstractLibraryChildNode) dataIterator.next();
					if (navDataNode instanceof NavigationBusinessEntityNode) {
						if (((NavigationBusinessEntityNode) navDataNode).getId().equals(typeName)) {
							// Navigation node found, load the type by its URI	
							LoggingUtil.trace(BOMUtil.class, "getPrimitiveTypeNode", "The primitive node");
							LoggingUtil.traceExit(BOMUtil.class, "getPrimitiveTypeNode");					
							return navDataNode;
						}
					}
				}
			}
		} catch (RuntimeException e) {
			LoggingUtil.trace(BOMUtil.class, "getPrimitiveTypeNode", "The navigation model is incorrect.");
		}	
		LoggingUtil.traceExit(BOMUtil.class, "getPrimitiveTypeNode");
		return null;
	}	
	
	/**
	 * Load the master copy of a given URI
	 * @param blmURI the uri of the object
	 * @param projectName the project this object belongs to.
	 * @return The master copy of the root object.
	 */
	public static Object loadRootObject(final String blmURI, final String projectName) {
		LoggingUtil.traceEntry(BOMUtil.class, "loadRootObject");
		
		String projectURI = FileMGR.getProjectPath(projectName);
		// Load the root objects.
		List rootObjectList = ResourceMGR.getResourceManger().getRootObjects(projectName, projectURI, (String) blmURI);
		LoggingUtil.trace(BOMUtil.class, "loadRootObject", "Get the object from the resource manager.");
		// Take the first root object.
		if (rootObjectList != null && ! rootObjectList.isEmpty()) {
			Object rootObject = rootObjectList.get(0);
			LoggingUtil.traceExit(BOMUtil.class, "loadRootObject");
			return rootObject;
		}
		
		// Failed to load the root object.
		LoggingUtil.traceExit(BOMUtil.class, "loadRootObject");
		return null;
	}	
	
	/**
	 * Load the master copy of a given URI
	 * @param blmURI the uri of the object
	 * @param projectName the project this object belongs to.
	 * @return The master copy of the root object.
	 */
	public static void saveRootObject(final String blmURI, final String projectName) {
		LoggingUtil.traceEntry(BOMUtil.class, "saveRootObject");
		
		String projectURI = FileMGR.getProjectPath(projectName);
		
		SaveResourceCmd cmd = new SaveResourceCmd();
		cmd.setResourceID(blmURI);
		cmd.setProjectName(projectName);
		cmd.setBaseURI(projectURI);
		
		// Save the root objects.
		if (cmd.canExecute()) {
			cmd.execute();	
		}
		
		LoggingUtil.traceExit(BOMUtil.class, "saveRootObject");
	}		
	
	/**
	 * Load the master copy of a given navigation node.
	 * @param navNode The navigation node
	 * @return The master copy of the root object.
	 */
	public static Object loadRootObject(final AbstractLibraryChildNode navNode) {
		LoggingUtil.traceEntry(BOMUtil.class, "loadRootObject");
		Object blmURI = null;
		String projectName = null;
		
		if (navNode == null) {
			LoggingUtil.trace(BOMUtil.class, "loadRootObject", "The navigation node should mot be null.");
			LoggingUtil.traceExit(BOMUtil.class, "loadRootObject");
			return null;
		}
		
		// Get the URI from navigation node
		if (navNode instanceof AbstractChildLeafNode) {
			LoggingUtil.trace(BOMUtil.class, "loadRootObject", "The navigation node is a leaf node.");
			List blmUriList = ((AbstractChildLeafNode)navNode).getEntityReferences();
			if (blmUriList != null && ! blmUriList.isEmpty()) {
				blmURI = blmUriList.get(0);
				projectName = ((AbstractChildLeafNode)navNode).getProjectNode().getLabel();
			}
		} else if (navNode instanceof AbstractChildContainerNode) {
			LoggingUtil.trace(BOMUtil.class, "loadRootObject", "The navigation node is a container node.");
			blmURI = ((AbstractChildContainerNode)navNode).getEntityReference();
			projectName = ((AbstractChildContainerNode)navNode).getProjectNode().getLabel();
		}
		
		if (blmURI instanceof String) {
			LoggingUtil.traceExit(BOMUtil.class, "loadRootObject");
			return loadRootObject((String) blmURI, projectName);
		}
		
		// Failed to load the root object.
		LoggingUtil.traceExit(BOMUtil.class, "loadRootObject");
		return null;
	}
	
	/**
	 * Load the master copy of a given navigation node.
	 * @param navNode The navigation node
	 * @return The master copy of the root object.
	 */
	public static Object loadViewRootObject(final AbstractLibraryChildNode navNode) {
		LoggingUtil.traceEntry(BOMUtil.class, "loadViewRootObject");
		Object blmURI = null;
		String projectName = null;
		
		if (navNode == null) {
			LoggingUtil.trace(BOMUtil.class, "loadViewRootObject", "The navigation node should mot be null.");
			LoggingUtil.traceExit(BOMUtil.class, "loadViewRootObject");
			return null;
		}
		
		// Get the URI from navigation node
		if (navNode instanceof AbstractChildLeafNode) {
			LoggingUtil.trace(BOMUtil.class, "loadViewRootObject", "The navigation node is a leaf node.");
			List blmUriList = ((AbstractChildLeafNode)navNode).getEntityReferences();
			if (blmUriList != null && ! blmUriList.isEmpty()) {
				blmURI = blmUriList.get(1);
				projectName = ((AbstractChildLeafNode)navNode).getProjectNode().getLabel();
			}
		}
		
		if (blmURI instanceof String) {
			LoggingUtil.traceExit(BOMUtil.class, "loadViewRootObject");
			return loadRootObject((String) blmURI, projectName);
		}
		
		// Failed to load the root object.
		LoggingUtil.traceExit(BOMUtil.class, "loadViewRootObject");
		return null;
	}	
	
	/**
	 * Updates the upperBound of the
	 */
	public static void updateUpperBound(MultiplicityElement element, int upperBoundValue){
		LoggingUtil.traceEntry(BOMUtil.class, "updateUpperBound");
		ValueSpecification valueSpec = element.getUpperBound();
		if (valueSpec != null) {
			RemoveValueSpecificationBOMCmd removeCmd = new RemoveValueSpecificationBOMCmd(valueSpec);
			if (removeCmd.canExecute()) {
				try {
					removeCmd.execute();
				} catch (RuntimeException e) {
					LoggingUtil.trace(BOMUtil.class, "updateUpperBound", "Command throw a RuntimeException.");
				}
			} else {
				LoggingUtil.trace(BOMUtil.class, "updateUpperBound", "Command cannot be executed.");			
			}
		}
		AddUpdateValueSpecificationBOMCmd addUpperBoundCmd;
		if(upperBoundValue == -1){
			addUpperBoundCmd = new AddLiteralUnlimitedNaturalUpperBoundToMultiplicityElementBOMCmd(element);
		}else{
			addUpperBoundCmd = new AddLiteralIntegerUpperBoundToMultiplicityElementBOMCmd(element);
		}
		if(addUpperBoundCmd.canExecute()){
			try{
				addUpperBoundCmd.execute();
				ValueSpecification workingUpperBound = (ValueSpecification)addUpperBoundCmd.getObject();
				if(workingUpperBound != null){
					AddUpdateLiteralSpecificationBOMCmd updateUpperBound;
					if(workingUpperBound instanceof LiteralUnlimitedNatural){
						updateUpperBound = new UpdateLiteralUnlimitedNaturalBOMCmd((LiteralUnlimitedNatural)workingUpperBound);
						((UpdateLiteralUnlimitedNaturalBOMCmd)updateUpperBound).setValue(PECommandConstants.LITERAL_UNLIMITED_NATURAL_VALUE);
					}else{
						updateUpperBound = new UpdateLiteralIntegerBOMCmd((LiteralInteger)workingUpperBound);
						((UpdateLiteralIntegerBOMCmd)updateUpperBound).setValue(upperBoundValue);
					}
					if(updateUpperBound.canExecute()){
						updateUpperBound.execute();
					}else{
						LoggingUtil.trace(BOMUtil.class, "updateUpperBound", "Command cannot be executed.");
					}
				}
			}catch(RuntimeException ex){
				LoggingUtil.trace(BOMUtil.class, "updateUpperBound", "Command throw a RuntimeException.");
			}
		}else{
			LoggingUtil.trace(BOMUtil.class, "updateUpperBound", "Command cannot be executed.");
		}
		LoggingUtil.traceExit(BOMUtil.class, "updateUpperBound");
	}
	
	/**
	 * Validate the project
	 * @param projectName
	 */
	public static void validateProject(final String projectName) {	
		LoggingUtil.traceExit(BOMUtil.class, "validateProject");
		
		
		String projectURI = FileMGR.getProjectPath(projectName);
		
		ValidateProjectCmd cmd = new ValidateProjectCmd(); 
		cmd.setProjectName(projectName);
		cmd.setProjectPath(projectURI);
		cmd.setValidateBrokenReferences(true);
		if (cmd.canExecute()) {
			try {
				cmd.execute();
			} catch (RuntimeException e) {
				LoggingUtil.trace(BOMUtil.class, "validateProject", "The command throw a RuntimeException.");								
			}
		} else {
			LoggingUtil.trace(BOMUtil.class, "validateProject", "The command cannot be exected.");			
		}	
		// Validate for duplicate namespaces
		final NamespaceValidationCmd nameValidationCmd = new NamespaceValidationCmd();
		nameValidationCmd.setNavigationRoot(NavigatorUtil.getProjectNode(projectName).getNavigationRoot());
		nameValidationCmd.execute();
		
		LoggingUtil.traceExit(BOMUtil.class, "validateProject");	
	}
	/**
	 * Get Default Unit Name
	 * @return
	 */
	public static String getDefaultUnitOfMeasureName() {
		Object[] units = UnitOfMeasureConverter.getSupportedUnitOfMeasures().toArray();
		
		return (String) units[7];	
	}	
	
	/**
	 * Creates and caches the canonical name of this element in the context.
	 */
	public static String getCanonicalName(NamedElement element, ImportContext context){
		//try to get it first from the context
		if(context != null && context.get(element) != null){
			return (String)context.get(element);
		}
		String containerCanonical = null;
		StringBuffer name = new StringBuffer();
		name.append(element.getName());
		NamedElement container = (NamedElement)element.eContainer();
		if(container != null){
			//do not include the name of the Activity in the canonical name
			if(container instanceof Action && isTopLevelProcess((Action)container)){
				if(context != null){
					context.put(element, name.toString());
				}
				return name.toString();
				//do not go higher than the default catalog.. 
			}else if(container instanceof Model && isDefaultModel(((Model)container))){
				if(context != null){
					context.put(element, name.toString());
				}
				return name.toString();
			}else{
				if(context != null){
					containerCanonical = (String)context.get(container);
				}
				if( containerCanonical == null){				
					containerCanonical = getCanonicalName(container, context);
				}
				name.insert(0, containerCanonical + ".");
			}
		}
		if(context != null){
			context.put(element, name.toString());
		}
		
		return name.toString();
	}
	
	/**
	 * Returns true if the input action is a top level StructuredActivityNode
	 * 
	 * @param action The action to check
	 * @return boolean - True if <code>action</code> is a top level SAN
	 */
	private static boolean isTopLevelProcess(Action action){
		
		if (action.eContainer() instanceof Activity){
			return true;
		}
		return false;
	}
	
	/**
	 * Returns true if the input model is not a default model.
	 * 
	 * @param model The model to check
	 * @return boolean - True if <code>model</code> is not a default catalog
	 */
	private static boolean isDefaultModel(Model model){
		
		if (model.eContainer() != null && model.eContainer().eContainer() == null){
			if (
					NavigatorUtil.getDefaultDataCatalogName().equals(model.getName()) ||
					NavigatorUtil.getDefaultOrganizationCatalogName().equals(model.getName()) ||
					NavigatorUtil.getDefaultProcessCatalogName().equals(model.getName()) ||	
					NavigatorUtil.getDefaultResourceCatalogName().equals(model.getName())
			)
				return true;
		}
		return false;
	}	
	
	public static HashMap getUIDMap(ImportContext context) {
		ImportContext importContext = context.getSubContext(IImportFramework.CONTEXT_UID_KEY);
		return importContext;
	}
	
	/**
	 * For collision handling, we need to look up the existing BOM reference in the workspace 
	 * to fix the broken reference
	 * @param session
	 * @param projectName
	 * @param classifier
	 * @return
	 */
	public static Type getTypeFromWorkspace(ImportSession session, String projectName, Type classifier){
		//andyz added for handling external schema
		if(isSchemaType(classifier)){
			return getComplexTypeFromWorkspace(session,projectName,classifier);
		}	
		if(classifier instanceof PrimitiveType){
			//we need to get the predefined project name and look up the type defect 155279
			//return getPrimitiveType(projectName,classifier.getName());
			return getPrimitiveType(PredefUtil.getPredefinedProjectName(),classifier.getName());
		}		
		if(!session.getImportOptions().isResolveRef()){
			return null;
		}		
		ArrayList catalogNames = new ArrayList();
		String leafName = classifier.getName();	
		Package parent = classifier.getOwningPackage();
		if(parent == null){
			return null;
		}
		NavigationProjectNode navProjectNode = NavigatorUtil.getProjectNode(projectName);
		if (navProjectNode == null) {
			LoggingUtil.trace(BOMUtil.class, "getTypeFromWorkspace", "The project node should not be null.");
			LoggingUtil.traceExit(BOMUtil.class, "getTypeFromWorkspace");			
			return null;
		}
		
		catalogNames.add(parent.getName());
		while(parent != null){
			parent = parent.getOwningPackage();
			if(parent != null){
				catalogNames.add(parent.getName());
			}
		}
		
		
		Object navNode = null;
		AbstractLibraryChildNode existingType = null;		
		
		try{
			NavigationDataCatalogNode navDataCatalog = null;
			List navDataCatalogList = navProjectNode.getLibraryNode().getDataCatalogsNode().getDataCatalogNodes();	
			if(catalogNames == null || catalogNames.size()<= 1){
				//get from default catalog		
				for(Iterator it = navDataCatalogList.iterator(); it.hasNext(); ) {
					navNode = it.next();
					if (navNode instanceof NavigationDataCatalogNode) {
						// The default data catalog
						if (((NavigationDataCatalogNode) navNode).getId().equals("DEFAULT_CATALOG")) {
							navDataCatalog = (NavigationDataCatalogNode)navNode;
							break;
						}
					}		
				}				
			}
			
			// Search the process catalogs starting from root process catalog		
			else {	
				String nextSubcatName = null;	
				int levelOfCat = catalogNames.size();		
				for(int i= 0; i< levelOfCat-1; i++){
					nextSubcatName = (String)catalogNames.get((levelOfCat-1) - i - 1);  //catalogNames is in reverse order
					for(Iterator it = navDataCatalogList.iterator(); it.hasNext(); ) {
						navNode = it.next();
						if (navNode instanceof NavigationDataCatalogNode) {
							// The sub data catalog
							if (((NavigationDataCatalogNode) navNode).getLabel().equals(nextSubcatName)) {
								navDataCatalog = (NavigationDataCatalogNode)navNode;
								break;
							}
						}
						
					}
					if(navDataCatalog != null && levelOfCat -1 != i + 1){
						navDataCatalogList = navDataCatalog.getDataCatalogNodeChildren();	
						navDataCatalog = null;					
					}else{
						break;
					}
				}	
			}	
			
			if(navDataCatalog != null){			
				existingType = getTypeFromCatalog(navDataCatalog, leafName);
			}
			
		} catch (RuntimeException e) {
			LoggingUtil.trace(BOMUtil.class, "getTypeFromWorkspace", "The navigation model is incorrect.");
		}	
		
		if(existingType != null){					
			Object obj = BOMUtil.loadRootObject(existingType);
			if(obj instanceof Type){
				return (Type)obj;			
			}
		}
		
		return null;
	}
	
	/**
	 * This method is to retrieve complex type from the workspace of the external model catalogs
	 * The target complex type might be in a customized BO catalog or in a default BO catalog
	 * The customized catalog is accessible through the import session additional option
	 * we already try to resolve the type from the existing workspace
	 * @param session
	 * @param projectName
	 * @param classifier
	 * @return
	 */
	private static Type getComplexTypeFromWorkspace(ImportSession session, String projectName, Type classifier){
		AbstractChildContainerNode container = null;	
		//AZ All the nodes should be in the import context keyed by the imported types. And the bom element
		//behind the navigation node should be in the workspace, so the reference will be fixed if the type
		//corresponds to a navigation node, this approach is generic for any complex types
		Object 	objectType = null;
		Object theNode = session.getContext()==null?null:session.getContext().get(classifier);
		if(theNode instanceof AbstractChildLeafNode){
			AbstractChildLeafNode targetNode = (AbstractChildLeafNode)theNode;				
			if(targetNode != null){
				objectType = loadRootObject(targetNode);
			}		
			if(objectType instanceof Type){
				return (Type)objectType;
			}			
		}
		//This is to handle the external schema look up in case the user chooses overwrite service and ignore
		//the schema
		Object nodeObject = session.getImportOptions().getAdditionalOption(NavigatorUtil.SOUREC_EXTERNAL_BO_CATALOG_NODE);
		if(nodeObject instanceof NavigationBOCatalogNode){
			//This is target customized BO catalog
			container = (AbstractChildContainerNode)nodeObject;
		}else{
			//we will be using the default BO catalog
			container = NavigatorUtil.getDefaultCatalogForExternalSchema(projectName);
		}
		
		//retrieve the target type within the container
		String leafName = classifier.getName();
		Package schema = classifier.getOwningPackage();
		
		if(schema == null){
			return null;
		}
		String schemaName = schema.getName();
		
		if(leafName == null || schemaName == null ){
			return null;
		}		
		NavigationBOCatalogNode boCatalog = (NavigationBOCatalogNode)container;
		AbstractChildContainerNode parentNode = null;
		
		//look up the catalog of the complex type
		EList externalSchemas = boCatalog.getXsdFile();
		if(externalSchemas != null && externalSchemas.size() > 0){
			Iterator schemas = externalSchemas.iterator();
			while(schemas.hasNext()){
				Object eachSchema = schemas.next();
				if(eachSchema instanceof NavigationXSDFileNode){
					if(((NavigationXSDFileNode)eachSchema).getLabel().equals(schemaName)){
						parentNode = (AbstractChildContainerNode)eachSchema;
						break;
					}
				}
			}
		}else{			
			//defect JR33663 reference v7 defect -> 95659
			//This happens when a complex type was extended by another type in one session but on its own in another session
			//The target node cannot be found based on the previous type of node since it has been changed
			parentNode = getExternalSchemaNode(boCatalog, schema);			
		}		
		//look up the complex type
		AbstractLibraryChildNode navProcElementNode = null;
		if(parentNode instanceof NavigationXSDFileNode){
			NavigationComplexTypeDefinitionsNode definitions = ((NavigationXSDFileNode)parentNode).getComplexTypeDefinitionsNode();
			if(definitions != null){
				EList defList = definitions.getComplexTypeDefinitionNode(); 
				Iterator defIterator = defList.iterator();			
				while(defIterator.hasNext()){
					NavigationComplexTypeDefinitionNode navContainerNode = (NavigationComplexTypeDefinitionNode)defIterator.next();
					String label = navContainerNode.getLabel();
					if(label != null && label.compareTo(leafName) == 0){				
						navProcElementNode = navContainerNode;
						break;
					}
				}
				//If we cannot find the definition, we look up the template
				if(navProcElementNode == null){
					NavigationComplexTypeTemplatesNode templates = ((NavigationXSDFileNode)parentNode).getComplexTypeTemplatesNode();
					if(templates == null){
						return null;
					}
					EList tempList = templates.getComplexTypeTemplateNode();
					Iterator tempIterator = tempList.iterator();
					while(tempIterator.hasNext()){
//						NavigationComplexTypeTemplateNode navContainerNode = (NavigationComplexTypeTemplateNode)defIterator.next();
						NavigationComplexTypeTemplateNode navContainerNode = (NavigationComplexTypeTemplateNode)tempIterator.next();
						String label = navContainerNode.getLabel();
						if(label != null && label.compareTo(leafName) == 0){				
							navProcElementNode = navContainerNode;
							break;
						}
					}
				}			
			}			
		}
		//look up the root object of the target node		
		if(navProcElementNode != null){
			objectType = loadRootObject(navProcElementNode);
		}		
		if(objectType instanceof Type){
			return (Type)objectType;
		}
		return null;
	}
	
	/**
	 * Resolve the target schema based on its BOM Model path instead of exhaustive loop for the sake of performance
	 * @param targetBOCatNode
	 * @param schema
	 * @return
	 */
	public  static AbstractChildContainerNode getExternalSchemaNode(AbstractChildContainerNode targetBOCatNode,Package schema){
		AbstractChildContainerNode targetSchemaNode = null;
		IProject project = ResourcesPlugin.getWorkspace().getRoot().getProject(targetBOCatNode.getProjectNode().getLabel());
		StringBuffer sb = new StringBuffer();		
		EObject rootObject = (EObject)BOMUtil.loadRootObject(targetBOCatNode);			
	    if(rootObject instanceof ExternalModel){
				ExternalModel parentModel = (ExternalModel)rootObject;
				sb.append(parentModel.getName());
				Package parent = parentModel.getOwningPackage();
				while(parent instanceof Package){
					sb.insert(0, File.separator);
					sb.insert(0, parent.getName());
					parent = parent.getOwningPackage();
				}
		}		
		if(schema.getOwningPackage() != null){
			Package parent = schema.getOwningPackage();
			StringBuffer optionFolders = new StringBuffer();
			while(parent instanceof Package){				
				optionFolders.insert(0,parent.getName());
				optionFolders.insert(0,File.separator);
				parent = parent.getOwningPackage();
			}
			sb.append(optionFolders.toString());
		}   
			sb.append(File.separator);
			sb.append(schema.getName());
			
		IFolder catFolder = project.getFolder(sb.toString());		
		if(catFolder.exists()){
			IFile modelFile = catFolder.getFile("Model.xmi");
			if(modelFile.exists()){
				URI modelResourceURI = URI.createFileURI(modelFile.getLocation().toString());
				org.eclipse.emf.ecore.resource.Resource modelResource = null;
				try{
					modelResource = new ResourceSetImpl().getResource(modelResourceURI, true);
				}catch(Exception e){
					return null;
				}
				for (Iterator iterator = modelResource.getAllContents(); iterator.hasNext();) {
					Object object = (Object) iterator.next();
					if(object instanceof ExternalSchema){
						ExternalSchema extSchema = (ExternalSchema)object;
						targetSchemaNode = NavigatorUtil.getContainerNode(targetBOCatNode.getProjectNode().getLabel(), EcoreUtil.getID(extSchema), extSchema);
						break;
					}
				}
			}
		}	
		return targetSchemaNode;
	}
	private static AbstractLibraryChildNode getTypeFromCatalog(NavigationDataCatalogNode navDataCatalog, String typeName){
		
		if (navDataCatalog == null) {
			return null;
		}		
		
		AbstractLibraryChildNode navDataElementNode = null;
		Object rootObject = null;
		if( navDataCatalog.getCategoriesNode() != null){	
			List navDataCatalogElementList = navDataCatalog.getCategoriesNode().getCategoryNodes();
			Iterator elementIterator = navDataCatalogElementList.iterator();
			while(elementIterator.hasNext()) {
				// Get the navigator node
				navDataElementNode = (AbstractLibraryChildNode) elementIterator.next();
				if (navDataElementNode instanceof NavigationCategoryNode) {
					if (((NavigationCategoryNode) navDataElementNode).getLabel().equals(typeName)) {
						return navDataElementNode;
					}
				}
			}	
		}
		
		if(navDataCatalog.getBusinessEntitiesNode() != null){
			List navDataCatalogElementList = navDataCatalog.getBusinessEntitiesNode().getBusinessEntityNodes();
			Iterator elementIterator = navDataCatalogElementList.iterator();
			while(elementIterator.hasNext()) {
				// Get the navigator node
				navDataElementNode = (AbstractLibraryChildNode) elementIterator.next();
				if (navDataElementNode instanceof NavigationBusinessEntityNode) {
					if (((NavigationBusinessEntityNode) navDataElementNode).getLabel().equals(typeName)) {
						return navDataElementNode;
					}
				}
			}	
		}		
		return null;				
	}
	
	private static int getBehaviorType(Behavior behavior){
		if(behavior instanceof Activity){
			Activity act = (Activity) behavior;
			if("PROCESS".equals(act.getImplementation().getAspect())){
				return 0;
			}else if("TASK".equals(act.getImplementation().getAspect())){
				return 1;	
			}else if("SERVICE".equals(act.getImplementation().getAspect())){
				return 2;
			}else{
				return -1;
			}
		}else{
			return -1;
		}
	}
	
	private static AbstractLibraryChildNode getProcessFromCatalog(NavigationProcessCatalogNode navProcCatalog, String typeName){
		if (navProcCatalog == null) {
			return null;
		}		
		
		if( navProcCatalog.getProcessesNode() == null){
			return null;
		}	
		
		AbstractLibraryChildNode navProcElementNode = null;
		Object rootObject = null;
		Iterator procElementIterator = null;	
		List navProcCatalogElementList = navProcCatalog.getProcessesNode().getProcessNodes();
		procElementIterator = navProcCatalogElementList.iterator();
		while(procElementIterator.hasNext()) {
			// Get the navigator node
			navProcElementNode = (AbstractLibraryChildNode) procElementIterator.next();
			if (navProcElementNode instanceof NavigationProcessNode) {
				if (((NavigationProcessNode) navProcElementNode).getLabel().equals(typeName)) {
					return navProcElementNode;
				}
			}
		}
		
		
		return null;				
	}
	
	private static AbstractLibraryChildNode getTaskFromCatalog(NavigationProcessCatalogNode navProcCatalog, String typeName){
		
		if (navProcCatalog == null) {
			return null;
		}		
		
		if(navProcCatalog.getTasksNode() == null){
			return null;
		}	
		
		AbstractLibraryChildNode navProcElementNode = null;
		Object rootObject = null;
		Iterator procElementIterator = null;
		
		List navProcCatalogElementList = navProcCatalog.getTasksNode().getTaskNodes();
		procElementIterator = navProcCatalogElementList.iterator();
		while(procElementIterator.hasNext()) {
			// Get the navigator node
			navProcElementNode = (AbstractLibraryChildNode) procElementIterator.next();
			if (navProcElementNode instanceof NavigationTaskNode) {
				if (((NavigationTaskNode) navProcElementNode).getLabel().equals(typeName)) {
					return navProcElementNode;
				}
			}
		}
		
		return null;				
	}
	
	
	private static AbstractLibraryChildNode getServiceFromCatalog(NavigationProcessCatalogNode navProcCatalog, String typeName){
		
		if (navProcCatalog == null) {
			return null;
		}		
		
		if(navProcCatalog.getServicesNode() == null){
			return null;
		}
		AbstractLibraryChildNode navProcElementNode = null;
		Object rootObject = null;
		Iterator procElementIterator = null;
		
		List navProcCatalogElementList = navProcCatalog.getServicesNode().getServiceNodes();
		procElementIterator = navProcCatalogElementList.iterator();
		while(procElementIterator.hasNext()) {
			// Get the navigator node
			navProcElementNode = (AbstractLibraryChildNode) procElementIterator.next();
			if (navProcElementNode instanceof NavigationServiceNode) {
				if (((NavigationServiceNode) navProcElementNode).getLabel().equals(typeName)) {
					return navProcElementNode;
				}
			}
		}
		
		return null;				
	}
	
	public static AbstractLibraryChildNode getBehaviorFromWorkspace(ImportSession session, String projectName, Behavior behavior){
		
		if(!session.getImportOptions().isResolveRef()){
			return null;
		}
		
		ArrayList catalogNames = new ArrayList();
		String leafName = behavior.getName();	
		Package parent = behavior.getOwningPackage();
		if(parent == null){
			return null;
		}
		NavigationProjectNode navProjectNode = NavigatorUtil.getProjectNode(projectName);
		if (navProjectNode == null) {
			LoggingUtil.trace(BOMUtil.class, "getBehaviorFromWorkspace", "The project node should not be null.");
			LoggingUtil.traceExit(BOMUtil.class, "getBehaviorFromWorkspace");			
			return null;
		}
		
		catalogNames.add(parent.getName());
		while(parent != null){
			parent = parent.getOwningPackage();
			if(parent != null){
				catalogNames.add(parent.getName());
			}
		}
		
		
		Object navNode = null;
		AbstractLibraryChildNode existingType = null;		
		
		try{
			NavigationProcessCatalogNode navProcCatalog = null;
			List navProcCatalogList = navProjectNode.getLibraryNode().getProcessCatalogsNodes().getProcessCatalogNodes();	
			if(catalogNames == null || catalogNames.size()<= 1){
				//get from default catalog		
				for(Iterator it = navProcCatalogList.iterator(); it.hasNext(); ) {
					navNode = it.next();
					if (navNode instanceof NavigationProcessCatalogNode) {
						// The default process catalog
						if (((NavigationProcessCatalogNode) navNode).getId().equals("DEFAULT_CATALOG")) {
							navProcCatalog = (NavigationProcessCatalogNode)navNode;
							break;
						}
					}		
				}				
			}
			
			// Search the process catalogs starting from root process catalog		
			else {	
				String nextSubcatName = null;	
				int levelOfCat = catalogNames.size();		
				for(int i= 0; i< levelOfCat-1; i++){
					nextSubcatName = (String)catalogNames.get((levelOfCat-1) - i - 1);  //catalogNames is in reverse order
					for(Iterator it = navProcCatalogList.iterator(); it.hasNext(); ) {
						navNode = it.next();
						if (navNode instanceof NavigationProcessCatalogNode) {
							// The sub process catalog
							if (((NavigationProcessCatalogNode) navNode).getLabel().equals(nextSubcatName)) {
								navProcCatalog = (NavigationProcessCatalogNode)navNode;
								break;
							}
						}
						
					}
					if(navProcCatalog != null && levelOfCat -1 != i + 1){
						navProcCatalogList = navProcCatalog.getProcessCatalogNodeChildren();	
						navProcCatalog = null;					
					}else{
						break;
					}
				}	
			}	
			
			if(navProcCatalog != null){
				int type = getBehaviorType(behavior);
				switch (type){				
				case 0: 				
					existingType = getProcessFromCatalog(navProcCatalog, leafName);
					break;
				case 1:
					existingType = getTaskFromCatalog(navProcCatalog, leafName);
					break;
				case 2:
					existingType = getServiceFromCatalog(navProcCatalog, leafName);
					break;
				default:
					existingType = null;
				}
			}
			
		} catch (RuntimeException e) {
			LoggingUtil.trace(BOMUtil.class, "getBehaviorFromWorkspace", "The navigation model is incorrect.");
		}	
		
		return existingType;
		
	}
	public static Role getRoleFromWorkspace(ImportSession session, String projectName, Role role){
		
		if(!session.getImportOptions().isResolveRef()){
			return null;
		}
		
		ArrayList catalogNames = new ArrayList();
		String leafName = role.getName();	
		Package parent = role.getOwningPackage();
		if(parent == null){
			return null;
		}
		NavigationProjectNode navProjectNode = NavigatorUtil.getProjectNode(projectName);
		if (navProjectNode == null) {
			LoggingUtil.trace(BOMUtil.class, "getRoleFromWorkspace", "The project node should not be null.");
			LoggingUtil.traceExit(BOMUtil.class, "getRoleFromWorkspace");			
			return null;
		}
		
		catalogNames.add(parent.getName());
		while(parent != null){
			parent = parent.getOwningPackage();
			if(parent != null){
				catalogNames.add(parent.getName());
			}
		}
		
		
		Object navNode = null;
		AbstractLibraryChildNode existingType = null;		
		
		try{
			NavigationResourceCatalogNode navResCatalog = null;
			List navResCatalogList = navProjectNode.getLibraryNode().getResourceCatalogsNode().getResourceCatalogNodes();	
			if(catalogNames == null || catalogNames.size()<= 1){
				//get from default catalog		
				for(Iterator it = navResCatalogList.iterator(); it.hasNext(); ) {
					navNode = it.next();
					if (navNode instanceof NavigationResourceCatalogNode) {
						// The default res catalog
						if (((NavigationResourceCatalogNode) navNode).getId().equals("DEFAULT_CATALOG")) {
							navResCatalog = (NavigationResourceCatalogNode)navNode;
							break;
						}
					}		
				}				
			}
			
			// Search the process catalogs starting from root process catalog		
			else {	
				String nextSubcatName = null;	
				int levelOfCat = catalogNames.size();		
				for(int i= 0; i< levelOfCat-1; i++){
					nextSubcatName = (String)catalogNames.get((levelOfCat-1) - i - 1);  //catalogNames is in reverse order
					for(Iterator it = navResCatalogList.iterator(); it.hasNext(); ) {
						navNode = it.next();
						if (navNode instanceof NavigationResourceCatalogNode) {
							// The sub data catalog
							if (((NavigationResourceCatalogNode) navNode).getLabel().equals(nextSubcatName)) {
								navResCatalog = (NavigationResourceCatalogNode)navNode;
								break;
							}
						}
						
					}
					if(navResCatalog != null && levelOfCat -1 != i + 1){
						navResCatalogList = navResCatalog.getResourceCatalogNodeChildren();	
						navResCatalog = null;					
					}else{
						break;
					}
				}	
			}	
			
			if(navResCatalog != null){			
				existingType = getRoleFromCatalog(navResCatalog, leafName);
			}
			
		} catch (RuntimeException e) {
			LoggingUtil.trace(BOMUtil.class, "getRoleFromWorkspace", "The navigation model is incorrect.");
		}	
		
		if(existingType != null){					
			Object obj = BOMUtil.loadRootObject(existingType);
			if(obj instanceof Role){
				return (Role)obj;			
			}
		}
		
		return null;
	}
	
	public static Resource getResFromWorkspace(ImportSession session, String projectName, Resource res){
		
		if(!session.getImportOptions().isResolveRef()){
			return null;
		}
		
		ArrayList catalogNames = new ArrayList();
		String leafName = res.getName();	
		Package parent = res.getOwningPackage();
		if(parent == null){
			return null;
		}
		NavigationProjectNode navProjectNode = NavigatorUtil.getProjectNode(projectName);
		if (navProjectNode == null) {
			LoggingUtil.trace(BOMUtil.class, "getResourceFromWorkspace", "The project node should not be null.");
			LoggingUtil.traceExit(BOMUtil.class, "getResourceFromWorkspace");			
			return null;
		}
		
		catalogNames.add(parent.getName());
		while(parent != null){
			parent = parent.getOwningPackage();
			if(parent != null){
				catalogNames.add(parent.getName());
			}
		}
		
		
		Object navNode = null;
		AbstractLibraryChildNode existingType = null;		
		
		try{
			NavigationResourceCatalogNode navResCatalog = null;
			List navResCatalogList = navProjectNode.getLibraryNode().getResourceCatalogsNode().getResourceCatalogNodes();	
			if(catalogNames == null || catalogNames.size()<= 1){
				//get from default catalog		
				for(Iterator it = navResCatalogList.iterator(); it.hasNext(); ) {
					navNode = it.next();
					if (navNode instanceof NavigationResourceCatalogNode) {
						// The default res catalog
						if (((NavigationResourceCatalogNode) navNode).getId().equals("DEFAULT_CATALOG")) {
							navResCatalog = (NavigationResourceCatalogNode)navNode;
							break;
						}
					}		
				}				
			}
			
			// Search the resource catalogs starting from root resource catalog		
			else {	
				String nextSubcatName = null;	
				int levelOfCat = catalogNames.size();		
				for(int i= 0; i< levelOfCat-1; i++){
					nextSubcatName = (String)catalogNames.get((levelOfCat-1) - i - 1);  //catalogNames is in reverse order
					for(Iterator it = navResCatalogList.iterator(); it.hasNext(); ) {
						navNode = it.next();
						if (navNode instanceof NavigationResourceCatalogNode) {
							// The sub data catalog
							if (((NavigationResourceCatalogNode) navNode).getLabel().equals(nextSubcatName)) {
								navResCatalog = (NavigationResourceCatalogNode)navNode;
								break;
							}
						}
						
					}
					if(navResCatalog != null && levelOfCat -1 != i + 1){
						navResCatalogList = navResCatalog.getResourceCatalogNodeChildren();	
						navResCatalog = null;					
					}else{
						break;
					}
				}	
			}	
			
			if(navResCatalog != null){			
				existingType = getResourceFromCatalog(navResCatalog, leafName);
			}
			
		} catch (RuntimeException e) {
			LoggingUtil.trace(BOMUtil.class, "getResourceFromWorkspace", "The navigation model is incorrect.");
		}	
		
		if(existingType != null){					
			Object obj = BOMUtil.loadRootObject(existingType);
			if(obj instanceof Resource){
				return (Resource)obj;			
			}
		}
		
		return null;
	}	
	
	
	public static Signal getSignalFromWorkspace(ImportSession session, String projectName, Signal signal){
		if(!session.getImportOptions().isResolveRef()){
			return null;
		}
		
		ArrayList catalogNames = new ArrayList();
		String leafName = signal.getName();	
		Package parent = signal.getOwningPackage();
		if(parent == null){
			return null;
		}
		NavigationProjectNode navProjectNode = NavigatorUtil.getProjectNode(projectName);
		if (navProjectNode == null) {
			LoggingUtil.trace(BOMUtil.class, "getSignalFromWorkspace", "The project node should not be null.");
			LoggingUtil.traceExit(BOMUtil.class, "getSignalFromWorkspace");			
			return null;
		}
		
		catalogNames.add(parent.getName());
		while(parent != null){
			parent = parent.getOwningPackage();
			if(parent != null){
				catalogNames.add(parent.getName());
			}
		}
		
		
		Object navNode = null;
		AbstractLibraryChildNode existingType = null;		
		
		try{
			NavigationDataCatalogNode navDataCatalog = null;
			List navDataCatalogList = navProjectNode.getLibraryNode().getDataCatalogsNode().getDataCatalogNodes();	
			if(catalogNames == null || catalogNames.size()<= 1){
				//get from default catalog		
				for(Iterator it = navDataCatalogList.iterator(); it.hasNext(); ) {
					navNode = it.next();
					if (navNode instanceof NavigationDataCatalogNode) {
						// The default data catalog
						if (((NavigationDataCatalogNode) navNode).getId().equals("DEFAULT_CATALOG")) {
							navDataCatalog = (NavigationDataCatalogNode)navNode;
							break;
						}
					}		
				}				
			}
			
			// Search the data catalogs starting from root data catalog		
			else {	
				String nextSubcatName = null;	
				int levelOfCat = catalogNames.size();		
				for(int i= 0; i< levelOfCat-1; i++){
					nextSubcatName = (String)catalogNames.get((levelOfCat-1) - i - 1);  //catalogNames is in reverse order
					for(Iterator it = navDataCatalogList.iterator(); it.hasNext(); ) {
						navNode = it.next();
						if (navNode instanceof NavigationDataCatalogNode) {
							// The sub data catalog
							if (((NavigationDataCatalogNode) navNode).getLabel().equals(nextSubcatName)) {
								navDataCatalog = (NavigationDataCatalogNode)navNode;
								break;
							}
						}
						
					}
					if(navDataCatalog != null && levelOfCat -1 != i + 1){
						navDataCatalogList = navDataCatalog.getDataCatalogNodeChildren();	
						navDataCatalog = null;					
					}else{
						break;
					}
				}	
			}	
			
			if(navDataCatalog != null){			
				existingType = getSignalFromCatalog(navDataCatalog, leafName);
			}
			
		} catch (RuntimeException e) {
			LoggingUtil.trace(BOMUtil.class, "getSignalFromWorkspace", "The navigation model is incorrect.");
		}	
		
		if(existingType != null){					
			Object obj = BOMUtil.loadRootObject(existingType);
			if(obj instanceof Signal){
				return (Signal)obj;			
			}
		}
		
		return null;
	}	
	
	private static AbstractLibraryChildNode getSignalFromCatalog(NavigationDataCatalogNode navDataCatalog, String signalName){
		
		if (navDataCatalog == null) {
			return null;
		}		
		
		AbstractLibraryChildNode navDataElementNode = null;
		Object rootObject = null;
		if( navDataCatalog.getDataCatalogNode() != null){	
			List navDataCatalogElementList = navDataCatalog.getDataCatalogNode().getDataCatalogNodeChildren();
			Iterator elementIterator = navDataCatalogElementList.iterator();
			while(elementIterator.hasNext()) {
				// Get the navigator node
				navDataElementNode = (AbstractLibraryChildNode) elementIterator.next();
				if (navDataElementNode instanceof NavigationCategoryNode) {
					if (((NavigationCategoryNode) navDataElementNode).getLabel().equals(signalName)) {
						return navDataElementNode;
					}
				}
			}	
		}
		
		if(navDataCatalog.getSignalsNode() != null){
			List navDataCatalogElementList = navDataCatalog.getSignalsNode().getSignalNodes();
			Iterator elementIterator = navDataCatalogElementList.iterator();
			while(elementIterator.hasNext()) {
				// Get the navigator node
				navDataElementNode = (AbstractLibraryChildNode) elementIterator.next();
				if (navDataElementNode instanceof NavigationSignalNode) {
					if (((NavigationSignalNode) navDataElementNode).getLabel().equals(signalName)) {
						return navDataElementNode;
					}
				}
			}	
		}		
		return null;				
	}		
	
	
	private static AbstractLibraryChildNode getResourceFromCatalog(NavigationResourceCatalogNode navResourceCatalog, String resName){
		
		if (navResourceCatalog == null) {
			return null;
		}		
		
		AbstractLibraryChildNode navResourceElementNode = null;
		Object rootObject = null;
		if( navResourceCatalog.getResourceCatalogNode() != null){	
			List navResourceCatalogElementList = navResourceCatalog.getResourceCatalogNode().getResourceCatalogNodeChildren();
			Iterator elementIterator = navResourceCatalogElementList.iterator();
			while(elementIterator.hasNext()) {
				// Get the navigator node
				navResourceElementNode = (AbstractLibraryChildNode) elementIterator.next();
				if (navResourceElementNode instanceof NavigationCategoryNode) {
					if (((NavigationCategoryNode) navResourceElementNode).getLabel().equals(resName)) {
						return navResourceElementNode;
					}
				}
			}	
		}
		
		if(navResourceCatalog.getResourcesNode() != null){
			List navResourceCatalogElementList = navResourceCatalog.getResourcesNode().getResourceNodes();
			Iterator elementIterator = navResourceCatalogElementList.iterator();
			while(elementIterator.hasNext()) {
				// Get the navigator node
				navResourceElementNode = (AbstractLibraryChildNode) elementIterator.next();
				if (navResourceElementNode instanceof NavigationResourceNode) {
					if (((NavigationResourceNode) navResourceElementNode).getLabel().equals(resName)) {
						return navResourceElementNode;
					}
				}
			}	
		}		
		return null;				
	}		
	
	private static AbstractLibraryChildNode getRoleFromCatalog(NavigationResourceCatalogNode navResourceCatalog, String roleName){
		
		if (navResourceCatalog == null) {
			return null;
		}		
		
		AbstractLibraryChildNode navResourceElementNode = null;
		Object rootObject = null;
		if( navResourceCatalog.getResourceCatalogNode() != null){	
			List navResourceCatalogElementList = navResourceCatalog.getResourceCatalogNode().getResourceCatalogNodeChildren();
			Iterator elementIterator = navResourceCatalogElementList.iterator();
			while(elementIterator.hasNext()) {
				// Get the navigator node
				navResourceElementNode = (AbstractLibraryChildNode) elementIterator.next();
				if (navResourceElementNode instanceof NavigationCategoryNode) {
					if (((NavigationCategoryNode) navResourceElementNode).getLabel().equals(roleName)) {
						return navResourceElementNode;
					}
				}
			}	
		}
		
		if(navResourceCatalog.getRolesNode() != null){
			List navResourceCatalogElementList = navResourceCatalog.getRolesNode().getRoleNodes();
			Iterator elementIterator = navResourceCatalogElementList.iterator();
			while(elementIterator.hasNext()) {
				// Get the navigator node
				navResourceElementNode = (AbstractLibraryChildNode) elementIterator.next();
				if (navResourceElementNode instanceof NavigationRoleNode) {
					if (((NavigationRoleNode) navResourceElementNode).getLabel().equals(roleName)) {
						return navResourceElementNode;
					}
				}
			}	
		}		
		return null;				
	}	
	
	//Added by Andy for handling external model import
	public static boolean isFileAttachment(NamedElement element){
		return (ASPECT_FILE_ATTACHMENT.equalsIgnoreCase(element.getAspect())||
				ASPECT_FILE_ATTACHMENT.equalsIgnoreCase(element.getName()));
	}
	
	public static boolean isInlineComplexType(NamedElement type){
		return ASPECT_INLINE_TYPE.equals(type.getAspect());
	}
	public static boolean isServiceOperation(NamedElement operation){
		return ASPECT_SERVICE_OPERATION.equals(operation.getAspect());
	}
	
	public static boolean isSchemaType(NamedElement type){
		if(type == null){
			return false;
		}
		return ASPECT_SCHEMA_TYPE.equals(type.getAspect())||
		ASPECT_INLINE_TYPE.equals(type.getAspect())||
		ASPECT_SCHEMA_TYPE_PRIVATE.equals(type.getAspect())||
		ASPECT_FILE_ATTACHMENT.equalsIgnoreCase(type.getAspect());
	}
	
	public static boolean isPrivateSchemaType(NamedElement type){
		return ASPECT_SCHEMA_TYPE_PRIVATE.equals(type.getAspect());
	}
	
	public static boolean isServiceCatalog(NamedElement model){
		return ASPECT_SERVICE_CATALOG.equals(model.getAspect());		
	}
	
	public static boolean isDataCatalog(NamedElement model){
		return ASPECT_DATA_CATALOG.equals(model.getAspect());
		
	}
	
	public static boolean isInlineSchema(NamedElement externalSchema){
		return ASPECT_INLINE_DATA.equals(externalSchema.getAspect());
	}
	
	//start dependency check
	public static boolean hasDependency(EObject object,String projectName){
		boolean hasDependency = false;
		DependencyModel dependencyModel = getDependencyModel(projectName);
		Set dependingObjects = dependencyModel.getSourceObjects(object,null,true,false);
		if(dependingObjects != null && dependingObjects.size() >0 ){
			hasDependency = true;
		}
		return hasDependency;
	}
	
	public static boolean hasLocalDependency(EObject object){
		DependencyModel localDependencyModel =	DependencyManager.instance().getLocalDependencyModel(object, false);
		boolean hasSelfDependency = false;
		if(localDependencyModel != null) {
			Set dependingObjects = localDependencyModel.getSourceObjects(object, null, true, false);
			if(dependingObjects != null && dependingObjects.size() > 0){
				hasSelfDependency = true;
			}
		}
		return hasSelfDependency;
	}
	
	public static  DependencyModel getDependencyModel(String projectName){		
		String projectPath = FileMGR.getProjectPath(projectName);	
		DependencyModel dependencyModel = DependencyManager.instance().getDependencyModel(projectName, projectPath);
		return dependencyModel;
	}
	
	//End dependency check
	
	//Start file attachment for BOM element	
	public static boolean attachFile2BomActivity(
			ImportSession session,
			String projectName,			
			AbstractLibraryChildNode newNode,
			ExternalDocument document,
			AbstractChildContainerNode selectedBOCatalogNode){	
		
		boolean success = false;
		if(session == null || projectName == null || newNode == null || 
				document == null || selectedBOCatalogNode == null){
			return success;
		}
		String projectPath=FileMGR.getProjectPath(projectName);
		DependencyModel dependencyModel = DependencyManager.instance().getDependencyModel( projectName,projectPath);
		String bomRelURI = getRelativePathForNode(newNode,projectName);			
		String bomActivityAbsolutePath = null;
		
		String blmUri = null;
		if(newNode instanceof AbstractChildLeafNode){
			blmUri = (String)((AbstractChildLeafNode)newNode).getEntityReferences().get(0);
		}else if(newNode instanceof AbstractChildContainerNode){
			blmUri = (String)((AbstractChildContainerNode)newNode).getEntityReference();
		}
		//Open the master copy
		String projectUri = FileMGR.getProjectPath(projectName);
		EObject bomActivity = (EObject)ResourceMGR.getResourceManger().getRootObjects(projectName, projectUri, blmUri).get(0);
		
		if(bomActivity instanceof ProcessModel || bomActivity instanceof Form ||
				bomActivity instanceof InformationModel || 
				bomActivity instanceof Activity||
				bomActivity instanceof ExternalService||
				bomActivity instanceof ExternalSchema ||
				bomActivity instanceof Class && ((Class)bomActivity).getAspect().equals(ASPECT_FILE_ATTACHMENT)){
			
			bomActivityAbsolutePath = projectPath + 
			File.separator + 
			bomRelURI.substring(0,bomRelURI.lastIndexOf(File.separator)+1);    
			
		}else{
			//For business items, we need put the resource file under the immediate root directory
			String boRoot = bomRelURI.substring(0,bomRelURI.lastIndexOf(File.separator));
			boRoot = boRoot.substring(0,boRoot.lastIndexOf(File.separator));
			bomActivityAbsolutePath = projectPath + 
			File.separator + 
			boRoot;
		}	
		
		String sourceFile = document.getLocationURL();
		
		File srcFile = new File(sourceFile);	
		
		if(srcFile.getName() == null || srcFile.getName().length() == 0){
			return success;
		}		
		String targetFileName = bomActivityAbsolutePath + srcFile.getName();
		
		File targetFile = new File(targetFileName);		
		
		if(targetFile.exists() && ivEditingDomain != null ){
			AttachmentManager.instance().detachFile(
					dependencyModel,
					bomActivity,
					targetFileName,
					ivEditingDomain.getCommandStack());
		}	
		
		success = AttachmentManager.instance().attachFile(
				dependencyModel,
				bomActivity, 
				sourceFile, 
				targetFileName,
				null);				
		//		try{
		//			//Attach the byte array into the root BOM element comment
		//			byte[] docBytes = DocumentUtil.getBytesFromDocument(srcFile);
		//			success = BOMUtil.addCommentToBOMElement((Element)bomActivity,docBytes,srcFile);		
		//			
		//			//Retrieve the content and persist it to the target directory
		//			byte[] content = BOMUtil.getDocumentContentFromComment((Element)bomActivity);			
		//			if(success){
		//				success = DocumentUtil.persistDocument(content,bomActivityAbsolutePath,srcFile.getName());
		//			}			
		//		}catch(Exception e){
		//			success = false;
		//		}
		
		if(success){
			//Update the new created BOM Model
			//updateExternalDocument(document,bomActivity,projectName,copyId);
			//Fix the import
			if(!skipFixImport(session)){
				fixImport(
						session,
						//document,
						projectName,
						targetFileName,
						bomRelURI,
						selectedBOCatalogNode);
			}
		}
		return success;
	}	
	
	/**
	 * If the import is modeler XML import, we skip the import fix since the import location
	 * has already been fixed during external model import
	 * @param session
	 * @return
	 */
	private static boolean skipFixImport(ImportSession session){
		Object xmlImportFlag = session.getContext().get(IImportConstants.MODELER_XML_IMPORT_KEY);
		if(xmlImportFlag instanceof Boolean){
			return ((Boolean)xmlImportFlag).booleanValue();
		}
		return false;
	}
	/**
	 * This method is responsible for updating the external documents' attributes:
	 * - locationUrl
	 * - sourceType
	 * - targetNamespace
	 * @param sourceDocument
	 * @param projectName
	 * @param documentNode
	 * @param session TODO
	 * @param newBOM
	 */
	public static void updateExternalDocument(ExternalDocument sourceDocument,
			//EObject newBOM,
			String projectName,
			AbstractLibraryChildNode documentNode, 
			ImportSession session){
		//Update attributes for the inline schema
		if(sourceDocument == null){// || documentNode instanceof NavigationInlineXSDSchemaNode ){
			return;
		}
		String blmUri = null;
		if(documentNode instanceof AbstractChildLeafNode){
			blmUri = (String)((AbstractChildLeafNode)documentNode).getEntityReferences().get(0);
		}else if(documentNode instanceof AbstractChildContainerNode){
			blmUri = (String)((AbstractChildContainerNode)documentNode).getEntityReference();
		}
		OpenRootObjectForUpdateBOMCmd roOpenCmd = new OpenRootObjectForUpdateBOMCmd();
		roOpenCmd.setProjectName(projectName);
		roOpenCmd.setROBLM_URI(blmUri);
		if(roOpenCmd.canExecute()){
			roOpenCmd.execute();
		}
		
		EObject bomActivity = roOpenCmd.getROCopy();
		//record the copy id for update later on
		String copyId = roOpenCmd.getCopyID();
		AddUpdateExternalDocumentBOMCmd updateCmd = null;
		if(bomActivity instanceof ExternalSchema){
			updateCmd = new UpdateExternalSchemaBOMCmd((ExternalSchema)bomActivity);
			if(needFlagComment((ExternalSchema)bomActivity, session)){
				addCommentToExternalModel((ExternalSchema)bomActivity);
			}
		}else if(bomActivity instanceof ExternalService){
			updateCmd = new UpdateExternalServiceBOMCmd((ExternalService)bomActivity);
			if(needFlagComment((ExternalService)bomActivity, session)){
				addCommentToExternalModel((ExternalService)bomActivity);
			}
		}	
		if(updateCmd != null){
			updateCmd.setLocationURL(sourceDocument.getLocationURL());
			updateCmd.setSourceType(sourceDocument.getSourceType());
			updateCmd.setTargetNamespace(sourceDocument.getTargetNamespace());		
			
			//Update external document attributes
			if(updateCmd.canExecute()){
				updateCmd.execute();
			}	
		}		
		//Save the opened root object model
		SaveRootObjectBOMCmd saveRootObjectBOMCmd = new SaveRootObjectBOMCmd();
		saveRootObjectBOMCmd.setProjectName(projectName);
		saveRootObjectBOMCmd.setCopyID(copyId);
		
		if(saveRootObjectBOMCmd.canExecute()){
			saveRootObjectBOMCmd.execute();
		}		
		if (copyId != null) {
			CloseRootObjectBOMCmd roCloseCmd = new CloseRootObjectBOMCmd();
			roCloseCmd.setCopyID(copyId);
			if(roCloseCmd.canExecute()){
				roCloseCmd.execute();
			}
		}
		
	}
	
	public static EObject getRootBOMModel(String prjName,AbstractLibraryChildNode naviNode){
		if(prjName == null ||naviNode == null){
			return null;
		}
		String blmUri = null;
		if(naviNode instanceof AbstractChildLeafNode){
			blmUri = (String)((AbstractChildLeafNode)naviNode).getEntityReferences().get(0);
		}else if(naviNode instanceof AbstractChildContainerNode){
			blmUri = (String)((AbstractChildContainerNode)naviNode).getEntityReference();
		}
		OpenRootObjectForUpdateBOMCmd roOpenCmd = new OpenRootObjectForUpdateBOMCmd();
		roOpenCmd.setProjectName(prjName);
		roOpenCmd.setROBLM_URI(blmUri);
		if(roOpenCmd.canExecute()){
			roOpenCmd.execute();
		}
		return roOpenCmd.getROCopy();
	}
	
	private static void fixImport(
			ImportSession session,			
			String projectName,
			String targetFileName,
			String bomRelURI,
			AbstractChildContainerNode boCatalogNode){	
		
		if(bomRelURI == null){
			return;
		}
		final ResourceSet resourceSet = new ResourceSetImpl();		
		String pathUp = bomRelURI.substring(0,bomRelURI.lastIndexOf(File.separator));
		org.eclipse.emf.ecore.resource.Resource resource=null;		
		File inputFile = new File(targetFileName);		
		try {
			URI fileURI = URI.createFileURI(inputFile.getAbsolutePath());				
			resource = resourceSet.getResource(fileURI, true);
		} catch (Throwable throwable) {
			// Log error on failure to read file						
		}
		
		if (!resourceSet.getResources().isEmpty()) {	
//d166063			
			List tempResources  = new ArrayList();
			tempResources.addAll(resourceSet.getResources());
			for (Iterator it=tempResources.iterator();it.hasNext();) {
//			for (Iterator it=resourceSet.getResources().iterator();it.hasNext();) {
				resource = (org.eclipse.emf.ecore.resource.Resource) it.next();
				if(resource instanceof WSDLResourceImpl){									
					if (!resource.getContents().isEmpty()) {
						Object resObject = resource.getContents().get(0);
						if(resObject instanceof Definition){
							fixDefinitionImport(
									session,									
									projectName,
									(Definition)resObject,
									resource,
									pathUp,
									boCatalogNode,
									true);
						}
						
					}
				}else if(resource instanceof XSDResourceImpl){
					if(!resource.getContents().isEmpty()){
						Object resObject = resource.getContents().get(0);
						if(resObject instanceof XSDSchema){
							fixXSDImport(
									session,									
									projectName,
									(XSDSchema)resObject,
									resource,
									pathUp,
									true);
						}
					}
				}
			}			
		}				
	}
	
	private static void fixDefinitionImport(
			ImportSession session,			
			String projectName,
			Definition definition, 
			org.eclipse.emf.ecore.resource.Resource wsdlResource, 
			String relPath,
			AbstractChildContainerNode boCatalogNode,
			boolean overwrite) {
		
		if(boCatalogNode == null){
			return;
		}
		List eImports = new LinkedList();
		Map enclosingSchemaIncludeMap = new HashMap();
		eImports.addAll(definition.getEImports());
		if(bInterfaceWISCompliant){
			if(definition.getETypes() != null){
				List schemas = definition.getETypes().getSchemas();
				if(schemas != null){
					Iterator schemasIt= schemas.iterator();
					while(schemasIt.hasNext()){
						XSDSchema schema = (XSDSchema)schemasIt.next();
						List contents = schema.getContents();
						Iterator importIt= contents.iterator();
						while(importIt.hasNext()){
							Object importDecl = importIt.next();
							if(importDecl instanceof XSDImport ||
									importDecl instanceof XSDInclude ||
									importDecl instanceof XSDRedefine){
								eImports.add(importDecl);
							}
						}
					}
				}
			}
		}
		
		Iterator it = eImports.iterator();	        
		int count = countFileSegment(relPath);		
		String backwardPath = buildBackwardPath(count);
		String importBOCatalogURI = computeDefaultNodeURI(boCatalogNode,projectName);		
		while (it.hasNext()) {
			Object obj = it.next();	
			StringBuffer sb = new StringBuffer();
			sb.append(backwardPath);
			if(obj instanceof Import){
				Import importObj = (Import)obj;
				if(importObj.getLocationURI() == null ||
						importObj.getLocationURI().length() == 0){
					continue;
				}				
				if(!importObj.getLocationURI().endsWith(".xsd")){
					//it's wsdl import
					sb.append(computeDefaultSvcNodeURI(session,projectName));
					if(BOMUtil.isCreateTNSCatalogs(session)){						
						sb.append(createTNSCatalogFromSession(session,computeKeyForImport(importObj)));
					}
					sb.append(File.separator);
					sb.append(getDirFromLocation(importObj.getLocationURI()));		
					sb.append(File.separator);
					sb.append(FILE_ATTACHMENT_NODE_NAME);						
				}else{
					//it's xsd schema import									
					sb.append(importBOCatalogURI);
					if(BOMUtil.isCreateTNSCatalogs(session)){
						sb.append(createTNSCatalogFromSession(session,computeKeyForImport(importObj)));
					}
					sb.append(File.separator);
					sb.append(getDirFromLocation(importObj.getLocationURI()));								
				}
				sb.append(File.separator);
				sb.append(FILE_ATTACHMENT_NODE_NAME);
				sb.append(File.separator);
				sb.append(extractFileNameFromSchemaLocation(importObj.getLocationURI()));
				importObj.setLocationURI(sb.toString());
			}else if(obj instanceof XSDImport){
				XSDImport xsdImportObj = (XSDImport)obj;	
				if(xsdImportObj.getSchemaLocation() == null ||
						xsdImportObj.getSchemaLocation().length() == 0){
					continue;
				}								
				sb.append(importBOCatalogURI);	
				if(BOMUtil.isCreateTNSCatalogs(session)){					
					sb.append(createTNSCatalogFromSession(session,computeKeyForImport(xsdImportObj)));
				}
				sb.append(File.separator);
				sb.append(getDirFromLocation(xsdImportObj.getSchemaLocation()));
				sb.append(File.separator);
				sb.append(FILE_ATTACHMENT_NODE_NAME);
				sb.append(File.separator);
				sb.append(extractFileNameFromSchemaLocation(xsdImportObj.getSchemaLocation()));
				xsdImportObj.setSchemaLocation(sb.toString());
			}else if(obj instanceof XSDInclude){
				XSDInclude xsdIncludeObj = (XSDInclude)obj;	
				if(xsdIncludeObj.getSchemaLocation() == null ||
						xsdIncludeObj.getSchemaLocation().length() == 0){
					continue;
				}							
				sb.append(importBOCatalogURI);
				if(BOMUtil.isCreateTNSCatalogs(session)){
					sb.append(createTNSCatalogFromSession(session,computeKeyForImport(xsdIncludeObj)));
				}
				sb.append(File.separator);				
				sb.append(getDirFromLocation(xsdIncludeObj.getSchemaLocation()));	
				sb.append(File.separator);
				sb.append(FILE_ATTACHMENT_NODE_NAME);
				sb.append(File.separator);
				sb.append(extractFileNameFromSchemaLocation(xsdIncludeObj.getSchemaLocation()));			
				xsdIncludeObj.setSchemaLocation(sb.toString());
			}else if(obj instanceof XSDRedefine){
				XSDRedefine xsdRedefineObj = (XSDRedefine)obj;	
				if(xsdRedefineObj.getSchemaLocation() == null ||
						xsdRedefineObj.getSchemaLocation().length() == 0){
					continue;
				}							
				sb.append(importBOCatalogURI);
				if(BOMUtil.isCreateTNSCatalogs(session)){					
					sb.append(createTNSCatalogFromSession(session,computeKeyForImport(xsdRedefineObj)));
				}
				sb.append(File.separator);
				sb.append(getDirFromLocation(xsdRedefineObj.getSchemaLocation()));	
				sb.append(File.separator);
				sb.append(FILE_ATTACHMENT_NODE_NAME);
				sb.append(File.separator);
				sb.append(extractFileNameFromSchemaLocation(xsdRedefineObj.getSchemaLocation()));			
				xsdRedefineObj.setSchemaLocation(sb.toString());				
			}
		}
		if(overwrite){				
			Map options = new HashMap();
			options.put(XMLResource.OPTION_DECLARE_XML, Boolean.TRUE);
			try{
				wsdlResource.save(options);		
			}catch(IOException ex){						
			}			
		}		
	}	
	
	private static void fixXSDImport(
			ImportSession session,			
			String projectName,
			XSDSchema schema,
			org.eclipse.emf.ecore.resource.Resource xsdResource,
			String relPath,
			boolean overwrite){	
		List schemaImports = new LinkedList();
		Map enclosingSchemaIncludeMap = new HashMap();
		List contents = schema.getContents();
		Iterator importIt= contents.iterator();
		while(importIt.hasNext()){
			Object importDecl = importIt.next();
			if(importDecl instanceof XSDImport ||
					importDecl instanceof XSDInclude||
					importDecl instanceof XSDRedefine){
				schemaImports.add(importDecl);
			}
		}		
		Iterator it = schemaImports.iterator();		
		int segments = countFileSegment(relPath);
		String backwardPath = buildBackwardPath(segments);
		Object nodeObjectBO = session.getImportOptions().getAdditionalOption(NavigatorUtil.SOUREC_EXTERNAL_BO_CATALOG_NODE);
		
		while(it.hasNext()){
			Object obj = it.next();
			StringBuffer sb = new StringBuffer();
			sb.append(backwardPath);
			if(obj instanceof XSDImport){
				XSDImport xsdImportObj = (XSDImport)obj;
				if(xsdImportObj.getSchemaLocation()== null || 
						xsdImportObj.getSchemaLocation().length() == 0){
					continue;
				}
				if(nodeObjectBO instanceof AbstractChildContainerNode ){
					sb.append(computeDefaultNodeURI((AbstractChildContainerNode)nodeObjectBO,projectName));					
				}
				if(BOMUtil.isCreateTNSCatalogs(session)){					
					sb.append(createTNSCatalogFromSession(session,computeKeyForImport(xsdImportObj)));
				}
				sb.append(File.separator);			
				sb.append(getDirFromLocation(xsdImportObj.getSchemaLocation()));
				sb.append(File.separator);
				sb.append(FILE_ATTACHMENT_NODE_NAME);
				sb.append(File.separator);
				sb.append(extractFileNameFromSchemaLocation(xsdImportObj.getSchemaLocation()));
				xsdImportObj.setSchemaLocation(sb.toString());
			}else if(obj instanceof XSDInclude){
				XSDInclude xsdIncludeObj = (XSDInclude)obj;	
				if(xsdIncludeObj.getSchemaLocation()== null || 
						xsdIncludeObj.getSchemaLocation().length() == 0){
					continue;
				}
				if(nodeObjectBO instanceof AbstractChildContainerNode ){
					sb.append(computeDefaultNodeURI((AbstractChildContainerNode)nodeObjectBO,projectName));					
				}				
				if(BOMUtil.isCreateTNSCatalogs(session)){					
					sb.append(createTNSCatalogFromSession(session,computeKeyForImport(xsdIncludeObj)));
				}
				sb.append(File.separator);				
				sb.append(getDirFromLocation(xsdIncludeObj.getSchemaLocation()));
				sb.append(File.separator);
				sb.append(FILE_ATTACHMENT_NODE_NAME);
				sb.append(File.separator);
				sb.append(extractFileNameFromSchemaLocation(xsdIncludeObj.getSchemaLocation()));									
				xsdIncludeObj.setSchemaLocation(sb.toString());
			}else if(obj instanceof XSDRedefine){
				XSDRedefine redefine = (XSDRedefine)obj;
				if(redefine.getSchemaLocation()== null || 
						redefine.getSchemaLocation().length() == 0){
					continue;
				}
				if(nodeObjectBO instanceof AbstractChildContainerNode ){
					sb.append(computeDefaultNodeURI((AbstractChildContainerNode)nodeObjectBO,projectName));
				}
				if(BOMUtil.isCreateTNSCatalogs(session)){				
					sb.append(createTNSCatalogFromSession(session,computeKeyForImport(redefine)));
				}
				sb.append(File.separator);				
				sb.append(getDirFromLocation(redefine.getSchemaLocation()));
				sb.append(File.separator);
				sb.append(FILE_ATTACHMENT_NODE_NAME);
				sb.append(File.separator);
				sb.append(extractFileNameFromSchemaLocation(redefine.getSchemaLocation()));									
				redefine.setSchemaLocation(sb.toString());				
			}
			if(overwrite){					
				Map options = new HashMap();
				options.put(XMLResource.OPTION_DECLARE_XML, Boolean.TRUE);
				try{
					xsdResource.save(options);		
				}catch(IOException ex){						
				}					
			}		
		}		
	}
	
	private static String buildBackwardPath(int count) {
		String path=" ";
		for (int i=0; i<=count; i++) {
			path = path+".."+File.separator;
		}
		return path.trim();
	}
	
	private static String extractFileExtension (String filename) {
		if(filename == null || filename.length() == 0){
			return " ";
		}
		int extInd = filename.lastIndexOf('.');
		if (extInd != -1) {
			return filename.substring(extInd,filename.length());
		}	
		return null;
	}	
	
	private static String computeDirNameFromFileName(String filename){
		if(filename == null || filename.length() == 0){
			return " ";
		}
		return filename.substring(0,filename.lastIndexOf("."));
		
	}
	
	private static String extractFileNameFromSchemaLocation(String location){
		if(location == null || location.length() == 0){
			return " ";
		}
		String schemaFileName = " ";
		//Andy added to check whether the location is a network url
		if(location.indexOf("/") != -1){
			schemaFileName = location.substring(location.lastIndexOf("/")+1);
		}else{
			schemaFileName = location.substring(location.lastIndexOf(File.separator)+1);
		}
		return schemaFileName;
	}
	
	private static String getDirFromLocation(String location){
		String dir = null;
		String fileName = extractFileNameFromSchemaLocation(location);
		if(fileName.indexOf(".") != -1){
			//This is to handle schema name "$pain.002.001.01.xsd",
			//where there are lots of legitimate "." in the file name
			dir = fileName.substring(0,fileName.lastIndexOf("."));
		}		
		return dir;
	}
	
	private static String computeDefaultNodeURI(AbstractLibraryChildNode customNode,String projectName){
		if(projectName == null){
			return null;
		}		
		if(customNode instanceof AbstractChildContainerNode){
			String bomRelURI = getRelativePathForNode(customNode,projectName);
			if(bomRelURI != null && bomRelURI.indexOf(File.separator) != -1){
				return bomRelURI.substring(0,bomRelURI.lastIndexOf(File.separator));
			}
		}		
		return null;
	}
	
	private static String computeDefaultSvcNodeURI(ImportSession session,String projectName){
		Object nodeObjectSVC = session.getImportOptions().getAdditionalOption(NavigatorUtil.SOUREC_EXTERNAL_SERVICE_CATALOG_NODE);
		if(projectName != null || !(nodeObjectSVC instanceof AbstractChildContainerNode)){
			String bomRelURI = getRelativePathForNode((AbstractChildContainerNode)nodeObjectSVC,projectName);
			if(bomRelURI != null && bomRelURI.indexOf(File.separator) != -1){
				return bomRelURI.substring(0,bomRelURI.lastIndexOf(File.separator));
			}
		}
		return null;
	}
	
	private static int countFileSegment(String path) {
		int count=0;
		for (int i=0; i<path.length(); i++) {
			if (path.charAt(i) == File.separatorChar) {
				count++;
			}
		}
		return count;
	}
	
	private static String getRelativePathForNode(AbstractLibraryChildNode newNode,String projectName){		
		String projectPath=FileMGR.getProjectPath(projectName);		
		ResourceMGR resMgr = ResourceMGR.getResourceManger();		
		String bomRelURI = null;
		if(newNode instanceof AbstractChildLeafNode){
			bomRelURI = resMgr.getURI(projectName,
					projectPath,
					(String)((AbstractChildLeafNode)newNode).getEntityReferences().get(0));
			
		}else if(newNode instanceof AbstractChildContainerNode){
			bomRelURI = resMgr.getURI(projectName,
					projectPath,
					(String)((AbstractChildContainerNode)newNode).getEntityReference());
		}			
		return bomRelURI;
	}
	
	/**
	 * This method is to attach byte array and the source file name to an element's comment
	 * @param element
	 * @param content
	 */
	public static boolean addCommentToBOMElement(Element element,byte[] content,File srcFile){
		if(element == null ||
				content == null || content.length == 0 ||
				srcFile == null ||srcFile.getName()== null ||
				srcFile.getName().length() == 0){
			return false;
		}
		EList comments = element.getOwnedComment();
		Comment contentComment = null;
		Comment srcFileComment = null;
		for(int i = 0; i<comments.size();i++){
			Comment comment = (Comment)comments.get(i);
			if(comment.getUid().startsWith(DOCUMENT_CONTENT)){
				contentComment = comment;				
			}else if(comment.getUid().startsWith(SOURCE_FILE)){
				srcFileComment = comment;
			}
		}
		if(contentComment == null || srcFileComment == null){
			AddCommentToElementBOMCmd contentAddCmd = new AddCommentToElementBOMCmd(element);			
			contentAddCmd.setBody(new String(content));
			contentAddCmd.setUid(DOCUMENT_CONTENT + String.valueOf(content.hashCode()));
			if(contentAddCmd.canExecute()){
				try{
					contentAddCmd.execute();
				}catch(Exception e){
					return false;
				}
			}
			AddCommentToElementBOMCmd srcFileNameAddCmd = new AddCommentToElementBOMCmd(element);			
			srcFileNameAddCmd.setBody(srcFile.getName());
			srcFileNameAddCmd.setUid(SOURCE_FILE + String.valueOf(srcFile.hashCode()));
			if(srcFileNameAddCmd.canExecute()){
				try{
					srcFileNameAddCmd.execute();
				}catch(Exception e){
					return false;
				}
			}
		}else{
			UpdateCommentBOMCmd contentUpdateCommand = new UpdateCommentBOMCmd(contentComment);			
			contentUpdateCommand.setBody(new String(content));
			if(contentUpdateCommand.canExecute()){
				try{
					contentUpdateCommand.execute();
				}catch(Exception e){
					return false;
				}
			}	
			UpdateCommentBOMCmd srcFileUpdateCommand = new UpdateCommentBOMCmd(srcFileComment);
			srcFileComment.setBody(srcFile.getName());
			if(srcFileUpdateCommand.canExecute()){
				try{
					srcFileUpdateCommand.execute();
				}catch(Exception e){
					return false;
				}
			}
		}			
		return true;
	}
	
	/**
	 * Get content from the BOM element comment
	 * @param model
	 * @return
	 */
	public static byte[] getDocumentContentFromComment(Element model){
		if(model == null){
			return new byte[0];
		}
		EList comments = model.getOwnedComment();
		for(int i = 0; i<comments.size();i++){
			Comment comment = (Comment)comments.get(i);
			if(comment.getUid().startsWith(DOCUMENT_CONTENT)){
				String body = comment.getBody();
				return body.getBytes();	
			}
		}
		return new byte[0];
	}	
	
	/**
	 * This method retrieves the original file name from the BOM element comment 
	 * @param model
	 * @return
	 */
	public static String getFileNameFromComment(Element model){
		if(model == null){
			return "";
		}
		EList comments = model.getOwnedComment();
		for(int i = 0; i<comments.size();i++){
			Comment comment = (Comment)comments.get(i);
			if(comment.getUid().startsWith(SOURCE_FILE)){
				return comment.getBody();
			}
		}
		return "";
	}
	//End file attachment for BOM element
	public static ExternalDocument getExternalDocument(PackageableElement newComplexType){
		PackageableElement container =(PackageableElement) newComplexType.getOwningPackage();
		while( !(container instanceof ExternalDocument) && !BOMUtil.isInlineSchema((ExternalDocument)container)){
			container = container.getOwningPackage();
		}
		
		return (ExternalDocument)container;
	}
	
	public static List sortTemplateModels(EList models){
		List templates = new ArrayList();
		if(models == null || models.size() == 0){
			return templates;
		}		
		Iterator modelIt = models.iterator();
		while(modelIt.hasNext()){
			Object eachModel = modelIt.next();
			if(eachModel instanceof Class){
				Class clazz = (Class)eachModel;
				if(clazz.getIsAbstract().booleanValue()){
					templates.add(0,clazz);
					continue;
				}
			}
			templates.add(eachModel);
		}
		return templates;
	}
	
	private static boolean isTypeFromInlineSchema(Type classifier){
		if(classifier != null && classifier.getOwningPackage() instanceof ExternalSchema){
			if(classifier.getOwningPackage().getOwningPackage() instanceof ExternalService){
				return true;
			}
		}
		return false;
	}
	
	/**
	 * This method is utilized to check if the external model is owned by the root external model
	 * @param model
	 * @return true if the external model is owened by the root external model, false otherwise
	 */
	public static boolean isModelOwnedByRootModel(Model model){
		if(model instanceof ExternalModel && model.getOwningPackage() != null){
			return IImportFramework.ROOT_EXTERNAL_MODEL_NAME.equals(model.getOwningPackage().getName());
		}
		return false;
	}
	
	/**
	 * Compute the catalog path based on the target namespace
	 * @param tns
	 * @return
	 */
	public static String createTNSCatalogPath(String tns) {		
		String path = null;
		if(tns == null){
			return path;
		}
		java.net.URI uri = java.net.URI.create(tns);
		String host = uri.getHost();		
		if (host==null) {
			path = "/"+uri.getSchemeSpecificPart()+"/";
		}else{
			path= "/"+host;
			String uriPath = uri.getPath();
			if(uriPath !=null && uriPath.length() ==0){
				uriPath = "/";
			}
			path += uriPath;
		}
		if (path!=null) {
			path = normalizePath(path);			
		}		
		return path;
	}
	
	/**
	 * Retrieve the external model for the TNS catalog
	 * @param session
	 * @param sourceFilePath
	 * @return String catalog name from the external model
	 */
	private static String createTNSCatalogFromSession(ImportSession session,String key){
		if(session != null && session.getContext() instanceof ImportContext && key != null){
			Object extModelRegistry = session.getContext().get(IImportConstants.EXTERNALMODEL_CATALOG_REGISTRY_KEY);
			if(extModelRegistry instanceof Map){
				Map registry = (Map)extModelRegistry;				
				Object modelObj = registry.get(key);
				PackageableElement extModel = null;
				if(modelObj instanceof ExternalService){
					ExternalService extService = (ExternalService)modelObj;
					if(extService.getOwningPackage() instanceof ExternalModel){
						extModel = (ExternalModel)extService.getOwningPackage();					
					}
				}else if (modelObj instanceof ExternalSchema){
					ExternalSchema extSchema = (ExternalSchema)modelObj;
					if(extSchema.getOwningPackage() instanceof ExternalModel){
						extModel = (ExternalModel)extSchema.getOwningPackage();
					}
				}				
				StringBuffer sb = new StringBuffer();					
				while(extModel != null){						
					sb.insert(0,extModel.getName()+File.separator);
					extModel = extModel.getOwningPackage();
				}
				sb.insert(0,File.separator);
				String catPath = sb.toString();
				return catPath.substring(0,catPath.lastIndexOf(File.separator));
			}			
		}
		return "";
	}
	
	private static String normalizePath (String path) {
		path=path.replace('/','\\');
		path=path.replace(':','\\');
		return path;
	}
	
	/**
	 * Determine whether to append target namespace/file structure catalog or not during import location fix
	 * @param session
	 * @return
	 */
	private static boolean isCreateTNSCatalogs(ImportSession session) {
		boolean createExtraCatalog = false;
		Object tnsFlag= session.getImportOptions().getAdditionalOption(IImportConstants.CREATE_CATALOG_USING_TARGETNAMESPACE_KEY);
		if (tnsFlag!=null) {
			createExtraCatalog = ((Boolean)tnsFlag).booleanValue();
		}
		if(!createExtraCatalog){
			Object fsFlag= session.getImportOptions().getAdditionalOption(IImportConstants.CREATE_CATALOG_USING_FILE_STRUCTURE_KEY);
			if (fsFlag!=null) {
				createExtraCatalog = ((Boolean)fsFlag).booleanValue();
			}
		}		
		return createExtraCatalog;
	}
	
	/**
	 * "targetnamespace + importLocation" is a compound key for the registry,
	 * and the value is the target external service or external schema	
	 * @param importObj
	 * @return String the key for the imported WSDL/XSD
	 */
	public static String computeKeyForImport(Object importObj){
		String tns = null;
		String locationURI = null;
		if(importObj instanceof Import){
			Import theImport = (Import)importObj;
			tns = theImport.getNamespaceURI();
			locationURI = theImport.getLocationURI();			
		}else if(importObj instanceof XSDImport){
			XSDImport xsdImport = (XSDImport)importObj;
			tns = xsdImport.getNamespace();
			locationURI = xsdImport.getSchemaLocation();
			
		}else if(importObj instanceof XSDInclude){
			XSDInclude xsdInclude = (XSDInclude)importObj;			
			locationURI = xsdInclude.getSchemaLocation();
			
		}else if(importObj instanceof XSDRedefine){
			XSDRedefine xsdRedefine = (XSDRedefine)importObj;			
			locationURI = xsdRedefine.getSchemaLocation();			
		}
		//We try to use the enclosing WSDL/XSD targetnamespace
		if(tns == null){
			if(((EObject)importObj).eContainer() instanceof Definition){
				Definition container = (Definition)((EObject)importObj).eContainer();
				tns = container.getTargetNamespace();
			}else if(((EObject)importObj).eContainer() instanceof XSDSchema){
				XSDSchema container = (XSDSchema)((EObject)importObj).eContainer();
				tns = container.getTargetNamespace();
			}
		}
		return tns + locationURI;
	}
	
	/**
	 * Resolve the absolute URI based on the base and relative path
	 * @param base
	 * @param relativePath
	 * @return String the resolved URI
	 */
	public static String resolveURI(String base, String relativePath) {
		if (base == null) {
			return relativePath;
		}
		if (relativePath == null) {
			return base;
		}		
		URI baseURI = URI.createURI(base);
		URI relativePathURI = null;
		if (relativePath.indexOf(File.separatorChar) != -1) {
			relativePathURI = URI.createURI(relativePath.replace(File.separatorChar, '/'));
		} else {
			relativePathURI = URI.createURI(relativePath);
		}		
		URI resolvedURI = relativePathURI.resolve(baseURI);		
		return resolvedURI.toString();
	}
	/**
	 * Check if we need to add comment to the new created external document model
	 * @param document
	 * @param session
	 * @return
	 */
	public static boolean needFlagComment(ExternalDocument targetDocument,ImportSession session){
		if(targetDocument == null || session == null){
			return false;
		}
		List<Comment> comments = targetDocument.getOwnedComment();
		if(comments != null && comments.size() != 0){
			for(Comment comment:comments){
				String uid = comment.getUid();
				//remove the existing comment flag in the case of overwrite, retain only one comment
				if(uid.startsWith(IImportConstants.ARTIFICIAL_DEFAULT_CATALOG_UID_PREFIX)){
					RemoveCommentBOMCmd removeCommentCmd = new RemoveCommentBOMCmd(comment);
					if(removeCommentCmd.canExecute()){
						removeCommentCmd.execute();
					}
					break;
				}
			}
		}		
		Object userOptionFlag = session.getImportOptions().getAdditionalOption(IImportConstants.ARTIFICIAL_DEFAULT_CATALOG_FOR_EXTERNAL_DOCUMENT_KEY);
		if(userOptionFlag instanceof Boolean){
			Boolean flagBoolean = (Boolean)userOptionFlag;
			return flagBoolean.booleanValue();
		}
		return false;
	}
	/**
	 * Add comment to flag the default catalog being artificially added in modeler,
	 * meaning not usally specified
	 * @param element
	 */
	public static void addCommentToExternalModel(Element element){
		if(element==null){
			return;
		}		
		AddCommentToElementBOMCmd contentAddCmd = new AddCommentToElementBOMCmd(element);			
		contentAddCmd.setBody(new String(IImportConstants.DEFAULT_FLAG));
		contentAddCmd.setUid(IImportConstants.ARTIFICIAL_DEFAULT_CATALOG_UID_PREFIX + String.valueOf(element.hashCode()));
		if(contentAddCmd.canExecute()){
			try{
				contentAddCmd.execute();
			}catch(Exception e){
				//no-op
			}
		}
	}
}
