package com.ibm.btools.te.ilm;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.util.MissingResourceException;
import java.util.ResourceBundle;

import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

import com.ibm.btools.te.ilm.resource.MessageKeys;
import com.ibm.cic.licensing.common.LicenseCheck;

/**
 * The main plugin class to be used in the desktop.
 */
public class IlmPlugin extends AbstractUIPlugin {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	//The shared instance.
	private static IlmPlugin plugin;
	//Resource bundle.
	private ResourceBundle resourceBundle;
	
	/**
	 * The constructor.
	 */
	public IlmPlugin() {
		super();
		plugin = this;
		try {
			//resourceBundle= ResourceBundle.getBundle("com.ibm.btools.te.ilm.ilm.IlmPluginResources");
			resourceBundle= ResourceBundle.getBundle(MessageKeys.RESOURCE_PROPERTY_FILE);
		} catch (MissingResourceException x) {
			resourceBundle = null;
		}
		
	
	}
//	/**
//	 * The constructor.
//	 */
//	public IlmPlugin(IPluginDescriptor descriptor) {
//		super(descriptor);
//		plugin = this;
//		try {
//			//resourceBundle= ResourceBundle.getBundle("com.ibm.btools.te.ilm.ilm.IlmPluginResources");
//			resourceBundle= ResourceBundle.getBundle(MessageKeys.RESOURCE_PROPERTY_FILE);
//		} catch (MissingResourceException x) {
//			resourceBundle = null;
//		}
//	}
	
	// enable LUM licensing for the Modeler Advanced Edition
	
	public void start(BundleContext context) throws Exception{
		super.start(context);
	}	
	
	/**
	 * Returns the shared instance.
	 */
	public static IlmPlugin getDefault() {
		return plugin;
	}

	/**
	 * Returns the workspace instance.
	 */
	public static IWorkspace getWorkspace() {
		return ResourcesPlugin.getWorkspace();
	}

	/**
	 * Returns the string from the plugin's resource bundle,
	 * or 'key' if not found.
	 */
	public static String getResourceString(String key) {
		ResourceBundle bundle= IlmPlugin.getDefault().getResourceBundle();
		try {
			return bundle.getString(key);
		} catch (MissingResourceException e) {
			return key;
		}
	}

	/**
	 * Returns the plugin's resource bundle,
	 */
	public ResourceBundle getResourceBundle() {
		return resourceBundle;
	}
}
