package com.ibm.btools.te.ilm.attribute.wps;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import com.ibm.btools.bom.model.artifacts.NamedElement;
import com.ibm.btools.te.ilm.attribute.AttributeValueProvider;
import com.ibm.btools.te.ilm.heuristics.naming.NameProvider;
import com.ibm.btools.te.ilm.heuristics.naming.NameProviderFactory;
import com.ibm.btools.te.ilm.heuristics.naming.NamingRegistry;

/**
* Attribute valude provider for XSD Elements.
*/
public class XSDAttributeValueProvider extends AttributeValueProvider {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	/* (non-Javadoc)
	 * @see com.ibm.btools.te.ilm.attribute.AttributeValueProvider#getAttributeValueForType(com.ibm.btools.bom.model.artifacts.NamedElement, java.lang.String)
	 */
	public Object getAttributeValueForType(NamedElement fromSource, String propertyName) {
		return getAttributeValueForType(getObjectType(propertyName), fromSource, propertyName, null);
	}

	/* (non-Javadoc)
	 * @see com.ibm.btools.te.ilm.attribute.AttributeValueProvider#getAttributeValueForType(com.ibm.btools.bom.model.artifacts.NamedElement, java.lang.String, com.ibm.btools.te.ilm.heuristics.naming.NamingRegistry)
	 */
	public Object getAttributeValueForType(Object forType, NamedElement fromSource, String propertyName, NamingRegistry registry) {
		String valueForType = null;
		if(isNameAttribute(propertyName)){
			NameProvider nameProvider = NameProviderFactory.getNameProvider(forType);
			nameProvider.setContext(this.getContext());
			nameProvider.setParentContext(inParentContext);
			valueForType = nameProvider.getName(forType, fromSource, registry, propertyName);
		}
		return valueForType;
	}
	

	/**
	 * Returns true if this attribute is for a name property for which we can delegate to the NameProvider.
	 * @param attribute the name of the attribute
	 * @return
	 */
	private boolean isNameAttribute(String attribute){
		//return attribute.equals(AttributeNameConstants.XSD_ELEMENT_NAME);
		return false;
		
	}
	
	private Class getObjectType(String propertyName){
		Class objectType = null;
		return objectType;
	}
}