/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.bptransformation.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.btools.bom.model.artifacts.Type;
import com.ibm.btools.bom.model.processes.activities.Activity;
import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationContext;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.framework.impl.TransformationRootImpl;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.bptransformation.BOMTransformation;
import com.ibm.btools.te.ilm.bptransformation.BptransformationPackage;
import com.ibm.btools.te.ilm.graphs.BPGraph;
import com.ibm.btools.te.ilm.graphs.GraphsFactory;
import com.ibm.btools.te.ilm.heuristics.helper.BomUtils;

/**
 * Transform BOM models to BPGraph
 * Source: BOM models, e.g. Process
 * Target: A BPGraph
 */
public class BOMTransformationImpl extends TransformationRootImpl implements BOMTransformation {
	
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BOMTransformationImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass()
	{
		return BptransformationPackage.eINSTANCE.getBOMTransformation();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs)
	{
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case BptransformationPackage.BOM_TRANSFORMATION__CHILD_RULES:
					return ((InternalEList)getChildRules()).basicAdd(otherEnd, msgs);
				case BptransformationPackage.BOM_TRANSFORMATION__PARENT_RULE:
					if (eContainer != null)
						msgs = eBasicRemoveFromContainer(msgs);
					return eBasicSetContainer(otherEnd, BptransformationPackage.BOM_TRANSFORMATION__PARENT_RULE, msgs);
				case BptransformationPackage.BOM_TRANSFORMATION__ROOT:
					if (root != null)
						msgs = ((InternalEObject)root).eInverseRemove(this, FrameworkPackage.TRANSFORMATION_ROOT__RULES, TransformationRoot.class, msgs);
					return basicSetRoot((TransformationRoot)otherEnd, msgs);
				case BptransformationPackage.BOM_TRANSFORMATION__RULES:
					return ((InternalEList)getRules()).basicAdd(otherEnd, msgs);
				default:
					return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs)
	{
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case BptransformationPackage.BOM_TRANSFORMATION__CHILD_RULES:
					return ((InternalEList)getChildRules()).basicRemove(otherEnd, msgs);
				case BptransformationPackage.BOM_TRANSFORMATION__PARENT_RULE:
					return eBasicSetContainer(null, BptransformationPackage.BOM_TRANSFORMATION__PARENT_RULE, msgs);
				case BptransformationPackage.BOM_TRANSFORMATION__ROOT:
					return basicSetRoot(null, msgs);
				case BptransformationPackage.BOM_TRANSFORMATION__CONTEXT:
					return basicSetContext(null, msgs);
				case BptransformationPackage.BOM_TRANSFORMATION__RULES:
					return ((InternalEList)getRules()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs)
	{
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
				case BptransformationPackage.BOM_TRANSFORMATION__PARENT_RULE:
					return ((InternalEObject)eContainer).eInverseRemove(this, FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES, TransformationRule.class, msgs);
				default:
					return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return ((InternalEObject)eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve)
	{
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case BptransformationPackage.BOM_TRANSFORMATION__COMPLETE:
				return isComplete() ? Boolean.TRUE : Boolean.FALSE;
			case BptransformationPackage.BOM_TRANSFORMATION__FAILED:
				return isFailed() ? Boolean.TRUE : Boolean.FALSE;
			case BptransformationPackage.BOM_TRANSFORMATION__CHILD_RULES:
				return getChildRules();
			case BptransformationPackage.BOM_TRANSFORMATION__PARENT_RULE:
				return getParentRule();
			case BptransformationPackage.BOM_TRANSFORMATION__TARGET:
				return getTarget();
			case BptransformationPackage.BOM_TRANSFORMATION__SOURCE:
				return getSource();
			case BptransformationPackage.BOM_TRANSFORMATION__ROOT:
				if (resolve) return getRoot();
				return basicGetRoot();
			case BptransformationPackage.BOM_TRANSFORMATION__CONTEXT:
				return getContext();
			case BptransformationPackage.BOM_TRANSFORMATION__RULES:
				return getRules();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue)
	{
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case BptransformationPackage.BOM_TRANSFORMATION__COMPLETE:
				setComplete(((Boolean)newValue).booleanValue());
				return;
			case BptransformationPackage.BOM_TRANSFORMATION__FAILED:
				setFailed(((Boolean)newValue).booleanValue());
				return;
			case BptransformationPackage.BOM_TRANSFORMATION__CHILD_RULES:
				getChildRules().clear();
				getChildRules().addAll((Collection)newValue);
				return;
			case BptransformationPackage.BOM_TRANSFORMATION__PARENT_RULE:
				setParentRule((TransformationRule)newValue);
				return;
			case BptransformationPackage.BOM_TRANSFORMATION__TARGET:
				getTarget().clear();
				getTarget().addAll((Collection)newValue);
				return;
			case BptransformationPackage.BOM_TRANSFORMATION__SOURCE:
				getSource().clear();
				getSource().addAll((Collection)newValue);
				return;
			case BptransformationPackage.BOM_TRANSFORMATION__ROOT:
				setRoot((TransformationRoot)newValue);
				return;
			case BptransformationPackage.BOM_TRANSFORMATION__CONTEXT:
				setContext((TransformationContext)newValue);
				return;
			case BptransformationPackage.BOM_TRANSFORMATION__RULES:
				getRules().clear();
				getRules().addAll((Collection)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature)
	{
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case BptransformationPackage.BOM_TRANSFORMATION__COMPLETE:
				setComplete(COMPLETE_EDEFAULT);
				return;
			case BptransformationPackage.BOM_TRANSFORMATION__FAILED:
				setFailed(FAILED_EDEFAULT);
				return;
			case BptransformationPackage.BOM_TRANSFORMATION__CHILD_RULES:
				getChildRules().clear();
				return;
			case BptransformationPackage.BOM_TRANSFORMATION__PARENT_RULE:
				setParentRule((TransformationRule)null);
				return;
			case BptransformationPackage.BOM_TRANSFORMATION__TARGET:
				getTarget().clear();
				return;
			case BptransformationPackage.BOM_TRANSFORMATION__SOURCE:
				getSource().clear();
				return;
			case BptransformationPackage.BOM_TRANSFORMATION__ROOT:
				setRoot((TransformationRoot)null);
				return;
			case BptransformationPackage.BOM_TRANSFORMATION__CONTEXT:
				setContext((TransformationContext)null);
				return;
			case BptransformationPackage.BOM_TRANSFORMATION__RULES:
				getRules().clear();
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature)
	{
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case BptransformationPackage.BOM_TRANSFORMATION__COMPLETE:
				return complete != COMPLETE_EDEFAULT;
			case BptransformationPackage.BOM_TRANSFORMATION__FAILED:
				return failed != FAILED_EDEFAULT;
			case BptransformationPackage.BOM_TRANSFORMATION__CHILD_RULES:
				return childRules != null && !childRules.isEmpty();
			case BptransformationPackage.BOM_TRANSFORMATION__PARENT_RULE:
				return getParentRule() != null;
			case BptransformationPackage.BOM_TRANSFORMATION__TARGET:
				return target != null && !target.isEmpty();
			case BptransformationPackage.BOM_TRANSFORMATION__SOURCE:
				return source != null && !source.isEmpty();
			case BptransformationPackage.BOM_TRANSFORMATION__ROOT:
				return root != null;
			case BptransformationPackage.BOM_TRANSFORMATION__CONTEXT:
				return context != null;
			case BptransformationPackage.BOM_TRANSFORMATION__RULES:
				return rules != null && !rules.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	public boolean transformSource2Target()
	{
		LoggingUtil.traceEntry(this, "transformSource2Target");
		// TODO: For M1, assume the input to BOMTransformer are
		// a list of BOM processes
		BPGraph bpGraph = GraphsFactory.eINSTANCE.createBPGraph();
		addElementsToBpGraph(bpGraph,getSource());
		sortModelElements(bpGraph);
		getTarget().add(bpGraph);
		setComplete(true);
		LoggingUtil.traceExit(this, "transformSource2Target");
		return isComplete();
	}

	private void addElementsToBpGraph(BPGraph bpGraph, Collection elements) {
		Iterator it = elements.iterator();
		EObject source;
		while (it.hasNext()) {
			source = (EObject)it.next();
			if (source instanceof com.ibm.btools.bom.model.artifacts.Package) {
				addElementsToBpGraph(bpGraph,
					((com.ibm.btools.bom.model.artifacts.Package)source).getOwnedMember());
			} else {
				//if (isSupportedType(source)) {
					bpGraph.getFirstClassArtifact().add(source);
				//}
			}
		}		
	}
	/**
	 * Sort the sequence of processing
	 * @param bpGraph
	 * @return
	 */
	private void sortModelElements(BPGraph bpGraph) {
		List elements = new ArrayList();
		for(Object element:bpGraph.getFirstClassArtifact()){
			if(element instanceof Activity && !BomUtils.isProcess(((Activity)element).getImplementation())){
				elements.add(0,element);
			}else{
				elements.add(element);
			}
		}
		bpGraph.getFirstClassArtifact().clear();
		bpGraph.getFirstClassArtifact().addAll(elements);
	}
		
	private boolean isSupportedType(EObject element) {
		if (element instanceof Activity ||
			element instanceof Type
			) 
		{
			return true;
		}
		return false;
	}
	
} //BOMTransformationImpl
