/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.graphs;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.ibm.btools.te.ilm.graphs.GraphsFactory
 * @generated
 */
public interface GraphsPackage extends EPackage{
	
	// copyright   
	  public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$  
	  
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "graphs";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///graphs.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "graphs";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	GraphsPackage eINSTANCE = com.ibm.btools.te.ilm.graphs.impl.GraphsPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.graphs.impl.BPGraphImpl <em>BP Graph</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.graphs.impl.BPGraphImpl
	 * @see com.ibm.btools.te.ilm.graphs.impl.GraphsPackageImpl#getBPGraph()
	 * @generated
	 */
	int BP_GRAPH = 0;

	/**
	 * The feature id for the '<em><b>First Class Artifact</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BP_GRAPH__FIRST_CLASS_ARTIFACT = 0;

	/**
	 * The number of structural features of the the '<em>BP Graph</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BP_GRAPH_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.graphs.impl.SAGraphImpl <em>SA Graph</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.graphs.impl.SAGraphImpl
	 * @see com.ibm.btools.te.ilm.graphs.impl.GraphsPackageImpl#getSAGraph()
	 * @generated
	 */
	int SA_GRAPH = 2;

	/**
	 * The feature id for the '<em><b>Artifact Interface</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SA_GRAPH__ARTIFACT_INTERFACE = 0;

	/**
	 * The number of structural features of the the '<em>SA Graph</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SA_GRAPH_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.graphs.impl.ProcessFlowGraphImpl <em>Process Flow Graph</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.graphs.impl.ProcessFlowGraphImpl
	 * @see com.ibm.btools.te.ilm.graphs.impl.GraphsPackageImpl#getProcessFlowGraph()
	 * @generated
	 */
	int PROCESS_FLOW_GRAPH = 1;

	/**
	 * The feature id for the '<em><b>Artifact Interface</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_FLOW_GRAPH__ARTIFACT_INTERFACE = SA_GRAPH__ARTIFACT_INTERFACE;

	/**
	 * The feature id for the '<em><b>Process Flow Definition</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_FLOW_GRAPH__PROCESS_FLOW_DEFINITION = SA_GRAPH_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the the '<em>Process Flow Graph</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_FLOW_GRAPH_FEATURE_COUNT = SA_GRAPH_FEATURE_COUNT + 1;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.graphs.impl.SolutionGraphImpl <em>Solution Graph</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.graphs.impl.SolutionGraphImpl
	 * @see com.ibm.btools.te.ilm.graphs.impl.GraphsPackageImpl#getSolutionGraph()
	 * @generated
	 */
	int SOLUTION_GRAPH = 3;

	/**
	 * The feature id for the '<em><b>Artifact Interface</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOLUTION_GRAPH__ARTIFACT_INTERFACE = SA_GRAPH__ARTIFACT_INTERFACE;

	/**
	 * The feature id for the '<em><b>Direct Links</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOLUTION_GRAPH__DIRECT_LINKS = SA_GRAPH_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the the '<em>Solution Graph</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOLUTION_GRAPH_FEATURE_COUNT = SA_GRAPH_FEATURE_COUNT + 1;


	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.graphs.BPGraph <em>BP Graph</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>BP Graph</em>'.
	 * @see com.ibm.btools.te.ilm.graphs.BPGraph
	 * @generated
	 */
	EClass getBPGraph();

	/**
	 * Returns the meta object for the reference list '{@link com.ibm.btools.te.ilm.graphs.BPGraph#getFirstClassArtifact <em>First Class Artifact</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>First Class Artifact</em>'.
	 * @see com.ibm.btools.te.ilm.graphs.BPGraph#getFirstClassArtifact()
	 * @see #getBPGraph()
	 * @generated
	 */
	EReference getBPGraph_FirstClassArtifact();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.graphs.ProcessFlowGraph <em>Process Flow Graph</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Flow Graph</em>'.
	 * @see com.ibm.btools.te.ilm.graphs.ProcessFlowGraph
	 * @generated
	 */
	EClass getProcessFlowGraph();

	/**
	 * Returns the meta object for the reference '{@link com.ibm.btools.te.ilm.graphs.ProcessFlowGraph#getProcessFlowDefinition <em>Process Flow Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Process Flow Definition</em>'.
	 * @see com.ibm.btools.te.ilm.graphs.ProcessFlowGraph#getProcessFlowDefinition()
	 * @see #getProcessFlowGraph()
	 * @generated
	 */
	EReference getProcessFlowGraph_ProcessFlowDefinition();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.graphs.SAGraph <em>SA Graph</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SA Graph</em>'.
	 * @see com.ibm.btools.te.ilm.graphs.SAGraph
	 * @generated
	 */
	EClass getSAGraph();

	/**
	 * Returns the meta object for the reference '{@link com.ibm.btools.te.ilm.graphs.SAGraph#getArtifactInterface <em>Artifact Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Artifact Interface</em>'.
	 * @see com.ibm.btools.te.ilm.graphs.SAGraph#getArtifactInterface()
	 * @see #getSAGraph()
	 * @generated
	 */
	EReference getSAGraph_ArtifactInterface();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.graphs.SolutionGraph <em>Solution Graph</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Solution Graph</em>'.
	 * @see com.ibm.btools.te.ilm.graphs.SolutionGraph
	 * @generated
	 */
	EClass getSolutionGraph();

	/**
	 * Returns the meta object for the containment reference list '{@link com.ibm.btools.te.ilm.graphs.SolutionGraph#getDirectLinks <em>Direct Links</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Direct Links</em>'.
	 * @see com.ibm.btools.te.ilm.graphs.SolutionGraph#getDirectLinks()
	 * @see #getSolutionGraph()
	 * @generated
	 */
	EReference getSolutionGraph_DirectLinks();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	GraphsFactory getGraphsFactory();

} //GraphsPackage
