/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.graphs.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Collection;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import com.ibm.btools.te.ilm.graphs.BPGraph;
import com.ibm.btools.te.ilm.graphs.GraphsPackage;

/**
 * A Business Process Graph representation of a BOM Process
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.ibm.btools.te.graphs.impl.BPGraphImpl#getFirstClassArtifact <em>First Class Artifact</em>}</li>
 * </ul>
 * </p>
 *
 */
public class BPGraphImpl extends EObjectImpl implements BPGraph {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The cached value of the '{@link #getFirstClassArtifact() <em>First Class Artifact</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFirstClassArtifact()
	 * @generated
	 * @ordered
	 */
	protected EList firstClassArtifact = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BPGraphImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return GraphsPackage.eINSTANCE.getBPGraph();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getFirstClassArtifact() {
		if (firstClassArtifact == null) {
			firstClassArtifact = new EObjectResolvingEList(EObject.class, this, GraphsPackage.BP_GRAPH__FIRST_CLASS_ARTIFACT);
		}
		return firstClassArtifact;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case GraphsPackage.BP_GRAPH__FIRST_CLASS_ARTIFACT:
				return getFirstClassArtifact();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case GraphsPackage.BP_GRAPH__FIRST_CLASS_ARTIFACT:
				getFirstClassArtifact().clear();
				getFirstClassArtifact().addAll((Collection)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case GraphsPackage.BP_GRAPH__FIRST_CLASS_ARTIFACT:
				getFirstClassArtifact().clear();
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case GraphsPackage.BP_GRAPH__FIRST_CLASS_ARTIFACT:
				return firstClassArtifact != null && !firstClassArtifact.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} //BPGraphImpl
