/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.graphs.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import com.ibm.btools.te.ilm.graphs.GraphsPackage;
import com.ibm.btools.te.ilm.graphs.ProcessFlowGraph;

/**
 * A Process flow graph that captures a ILM process definition
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.ibm.btools.te.graphs.impl.ProcessFlowGraphImpl#getProcessFlowDefinition <em>Process Flow Definition</em>}</li>
 * </ul>
 * </p>
 *
 */
public class ProcessFlowGraphImpl extends SAGraphImpl implements ProcessFlowGraph {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The cached value of the '{@link #getProcessFlowDefinition() <em>Process Flow Definition</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProcessFlowDefinition()
	 * @generated
	 * @ordered
	 */
	protected EObject processFlowDefinition = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProcessFlowGraphImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return GraphsPackage.eINSTANCE.getProcessFlowGraph();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EObject getProcessFlowDefinition() {
		if (processFlowDefinition != null && processFlowDefinition.eIsProxy()) {
			EObject oldProcessFlowDefinition = processFlowDefinition;
			processFlowDefinition = (EObject)eResolveProxy((InternalEObject)processFlowDefinition);
			if (processFlowDefinition != oldProcessFlowDefinition) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, GraphsPackage.PROCESS_FLOW_GRAPH__PROCESS_FLOW_DEFINITION, oldProcessFlowDefinition, processFlowDefinition));
			}
		}
		return processFlowDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EObject basicGetProcessFlowDefinition() {
		return processFlowDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setProcessFlowDefinition(EObject newProcessFlowDefinition) {
		EObject oldProcessFlowDefinition = processFlowDefinition;
		processFlowDefinition = newProcessFlowDefinition;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, GraphsPackage.PROCESS_FLOW_GRAPH__PROCESS_FLOW_DEFINITION, oldProcessFlowDefinition, processFlowDefinition));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case GraphsPackage.PROCESS_FLOW_GRAPH__ARTIFACT_INTERFACE:
				if (resolve) return getArtifactInterface();
				return basicGetArtifactInterface();
			case GraphsPackage.PROCESS_FLOW_GRAPH__PROCESS_FLOW_DEFINITION:
				if (resolve) return getProcessFlowDefinition();
				return basicGetProcessFlowDefinition();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case GraphsPackage.PROCESS_FLOW_GRAPH__ARTIFACT_INTERFACE:
				setArtifactInterface((EObject)newValue);
				return;
			case GraphsPackage.PROCESS_FLOW_GRAPH__PROCESS_FLOW_DEFINITION:
				setProcessFlowDefinition((EObject)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case GraphsPackage.PROCESS_FLOW_GRAPH__ARTIFACT_INTERFACE:
				setArtifactInterface((EObject)null);
				return;
			case GraphsPackage.PROCESS_FLOW_GRAPH__PROCESS_FLOW_DEFINITION:
				setProcessFlowDefinition((EObject)null);
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case GraphsPackage.PROCESS_FLOW_GRAPH__ARTIFACT_INTERFACE:
				return artifactInterface != null;
			case GraphsPackage.PROCESS_FLOW_GRAPH__PROCESS_FLOW_DEFINITION:
				return processFlowDefinition != null;
		}
		return eDynamicIsSet(eFeature);
	}

} //ProcessFlowGraphImpl
