/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see com.ibm.btools.te.ilm.heuristics.HeuristicsPackage
 * @generated
 */
public interface HeuristicsFactory extends EFactory {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	HeuristicsFactory eINSTANCE = com.ibm.btools.te.ilm.heuristics.impl.HeuristicsFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Transformation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Transformation</em>'.
	 * @generated
	 */
	HeuristicsTransformation createHeuristicsTransformation();

	/**
	 * Returns a new object of class '<em>AE Broker Pattern Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>AE Broker Pattern Rule</em>'.
	 * @generated
	 */
	AEBrokerPatternRule createAEBrokerPatternRule();

	/**
	 * Returns a new object of class '<em>AE Observer Pattern Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>AE Observer Pattern Rule</em>'.
	 * @generated
	 */
	AEObserverPatternRule createAEObserverPatternRule();

	/**
	 * Returns a new object of class '<em>Process Flow Pattern Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Process Flow Pattern Rule</em>'.
	 * @generated
	 */
	ProcessFlowPatternRule createProcessFlowPatternRule();

	/**
	 * Returns a new object of class '<em>Process Flow Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Process Flow Rule</em>'.
	 * @generated
	 */
	ProcessFlowRule createProcessFlowRule();

	/**
	 * Returns a new object of class '<em>Data Definition Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Data Definition Rule</em>'.
	 * @generated
	 */
	DataDefinitionRule createDataDefinitionRule();

	/**
	 * Returns a new object of class '<em>Interface Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Interface Rule</em>'.
	 * @generated
	 */
	InterfaceRule createInterfaceRule();

	/**
	 * Returns a new object of class '<em>Resource Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Resource Rule</em>'.
	 * @generated
	 */
	ResourceRule createResourceRule();

	/**
	 * Returns a new object of class '<em>Organization Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Organization Rule</em>'.
	 * @generated
	 */
	OrganizationRule createOrganizationRule();

	/**
	 * Returns a new object of class '<em>Time Intervals Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Time Intervals Rule</em>'.
	 * @generated
	 */
	TimeIntervalsRule createTimeIntervalsRule();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	HeuristicsPackage getHeuristicsPackage();

} //HeuristicsFactory
