package com.ibm.btools.te.ilm.heuristics;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.util.Collection;

import com.ibm.btools.blm.ie.exprt.ExportSession;
import com.ibm.btools.ie.ui.ilm.config.model.BOM2ILMTESetting;
import com.ibm.btools.ie.ui.ilm.config.model.TESetting;
import com.ibm.btools.te.ilm.Transformer;
import com.ibm.btools.te.ilm.heuristics.helper.TESettingUtil;
import com.ibm.btools.te.ilm.heuristics.helper.TransformationSessionKeyConstants;
import com.ibm.btools.te.ilm.heuristics.naming.NamingUtil;
import com.ibm.btools.te.ilm.heuristics.wsdl.util.OriginalWsdlUtil;
import com.ibm.btools.te.ilm.heuristics.xsd.util.OriginalXsdUtil;

/**
 * Transformer that creates the Heuristics transformation session. 
 */
public class HeuristicsTransformer implements Transformer {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	//public Collection transform(Collection sources,TESetting teSetting) {
	public Collection transform(Collection sources,ExportSession session) {
		HeuristicsTransformation ht = HeuristicsFactory.eINSTANCE.createHeuristicsTransformation();
		TESetting teSetting = (TESetting)session.getExportOptions().getAdditionalOption(TransformationSessionKeyConstants.TE_SETTING);
		TESettingUtil.putTESetting(ht.getContext(),(BOM2ILMTESetting)teSetting);	
		ht.getContext().put(TransformationSessionKeyConstants.PROJECT_NAME,session.getExportOptions().getAdditionalOption(TransformationSessionKeyConstants.PROJECT_NAME));
		//put the export session into the context		
		ht.getContext().put(TransformationSessionKeyConstants.EXPORT_SESSION,session);
		ht.getSource().addAll(sources);
		ht.transformSource2Target();
		OriginalWsdlUtil.cleanWSDLRegistry(ht.getContext());
		OriginalXsdUtil.cleanXSDRegistry(ht.getContext());
		NamingUtil.cleanNamingRegistries(ht.getContext());
		return ht.getTarget();
	}

}
