/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.abstractbpel;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

import com.ibm.btools.te.framework.FrameworkPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelFactory
 * @model kind="package"
 * @generated
 */
public interface AbstractbpelPackage extends EPackage {
	
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "abstractbpel";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///heuristics/abstractbpel.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "heuristics.abstractbpel";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	AbstractbpelPackage eINSTANCE = com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractProcDefRuleImpl <em>Abstract Proc Def Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractProcDefRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getAbstractProcDefRule()
	 * @generated
	 */
	int ABSTRACT_PROC_DEF_RULE = 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROC_DEF_RULE__COMPLETE = FrameworkPackage.TRANSFORMATION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROC_DEF_RULE__FAILED = FrameworkPackage.TRANSFORMATION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROC_DEF_RULE__CHILD_RULES = FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROC_DEF_RULE__PARENT_RULE = FrameworkPackage.TRANSFORMATION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROC_DEF_RULE__TARGET = FrameworkPackage.TRANSFORMATION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROC_DEF_RULE__SOURCE = FrameworkPackage.TRANSFORMATION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROC_DEF_RULE__ROOT = FrameworkPackage.TRANSFORMATION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Abstract Proc Def Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROC_DEF_RULE_FEATURE_COUNT = FrameworkPackage.TRANSFORMATION_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ConnectableRuleImpl <em>Connectable Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ConnectableRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getConnectableRule()
	 * @generated
	 */
	int CONNECTABLE_RULE = 10;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTABLE_RULE__COMPLETE = ABSTRACT_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTABLE_RULE__FAILED = ABSTRACT_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTABLE_RULE__CHILD_RULES = ABSTRACT_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTABLE_RULE__PARENT_RULE = ABSTRACT_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTABLE_RULE__TARGET = ABSTRACT_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTABLE_RULE__SOURCE = ABSTRACT_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTABLE_RULE__ROOT = ABSTRACT_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Connectable Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTABLE_RULE_FEATURE_COUNT = ABSTRACT_PROC_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ActionRuleImpl <em>Action Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ActionRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getActionRule()
	 * @generated
	 */
	int ACTION_RULE = 1;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTION_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTION_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTION_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTION_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTION_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTION_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTION_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Action Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTION_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ActivityRuleImpl <em>Activity Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ActivityRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getActivityRule()
	 * @generated
	 */
	int ACTIVITY_RULE = 2;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_RULE__COMPLETE = ABSTRACT_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_RULE__FAILED = ABSTRACT_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_RULE__CHILD_RULES = ABSTRACT_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_RULE__PARENT_RULE = ABSTRACT_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_RULE__TARGET = ABSTRACT_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_RULE__SOURCE = ABSTRACT_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_RULE__ROOT = ABSTRACT_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Activity Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_RULE_FEATURE_COUNT = ABSTRACT_PROC_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.SANReusableProcessRuleImpl <em>SAN Reusable Process Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.SANReusableProcessRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getSANReusableProcessRule()
	 * @generated
	 */
	int SAN_REUSABLE_PROCESS_RULE = 3;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_PROCESS_RULE__COMPLETE = ACTION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_PROCESS_RULE__FAILED = ACTION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_PROCESS_RULE__CHILD_RULES = ACTION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_PROCESS_RULE__PARENT_RULE = ACTION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_PROCESS_RULE__TARGET = ACTION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_PROCESS_RULE__SOURCE = ACTION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_PROCESS_RULE__ROOT = ACTION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>SAN Reusable Process Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_PROCESS_RULE_FEATURE_COUNT = ACTION_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.SANNestedProcessRuleImpl <em>SAN Nested Process Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.SANNestedProcessRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getSANNestedProcessRule()
	 * @generated
	 */
	int SAN_NESTED_PROCESS_RULE = 4;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_NESTED_PROCESS_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_NESTED_PROCESS_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_NESTED_PROCESS_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_NESTED_PROCESS_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_NESTED_PROCESS_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_NESTED_PROCESS_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_NESTED_PROCESS_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>SAN Nested Process Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_NESTED_PROCESS_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.SANTaskRuleImpl <em>SAN Task Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.SANTaskRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getSANTaskRule()
	 * @generated
	 */
	int SAN_TASK_RULE = 5;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_TASK_RULE__COMPLETE = ACTION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_TASK_RULE__FAILED = ACTION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_TASK_RULE__CHILD_RULES = ACTION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_TASK_RULE__PARENT_RULE = ACTION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_TASK_RULE__TARGET = ACTION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_TASK_RULE__SOURCE = ACTION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_TASK_RULE__ROOT = ACTION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>SAN Task Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_TASK_RULE_FEATURE_COUNT = ACTION_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ProcessWalkingRuleImpl <em>Process Walking Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ProcessWalkingRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getProcessWalkingRule()
	 * @generated
	 */
	int PROCESS_WALKING_RULE = 11;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_WALKING_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_WALKING_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_WALKING_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_WALKING_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_WALKING_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_WALKING_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_WALKING_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Process Walking Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_WALKING_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ProcessRuleImpl <em>Process Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ProcessRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getProcessRule()
	 * @generated
	 */
	int PROCESS_RULE = 6;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_RULE__COMPLETE = PROCESS_WALKING_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_RULE__FAILED = PROCESS_WALKING_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_RULE__CHILD_RULES = PROCESS_WALKING_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_RULE__PARENT_RULE = PROCESS_WALKING_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_RULE__TARGET = PROCESS_WALKING_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_RULE__SOURCE = PROCESS_WALKING_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_RULE__ROOT = PROCESS_WALKING_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Process Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_RULE_FEATURE_COUNT = PROCESS_WALKING_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ContainerRuleImpl <em>Container Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ContainerRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getContainerRule()
	 * @generated
	 */
	int CONTAINER_RULE = 7;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_RULE__COMPLETE = ABSTRACT_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_RULE__FAILED = ABSTRACT_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_RULE__CHILD_RULES = ABSTRACT_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_RULE__PARENT_RULE = ABSTRACT_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_RULE__TARGET = ABSTRACT_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_RULE__SOURCE = ABSTRACT_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_RULE__ROOT = ABSTRACT_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Container Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_RULE_FEATURE_COUNT = ABSTRACT_PROC_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.CallBehaviorActionRuleImpl <em>Call Behavior Action Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.CallBehaviorActionRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getCallBehaviorActionRule()
	 * @generated
	 */
	int CALL_BEHAVIOR_ACTION_RULE = 8;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_BEHAVIOR_ACTION_RULE__COMPLETE = ACTION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_BEHAVIOR_ACTION_RULE__FAILED = ACTION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_BEHAVIOR_ACTION_RULE__CHILD_RULES = ACTION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_BEHAVIOR_ACTION_RULE__PARENT_RULE = ACTION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_BEHAVIOR_ACTION_RULE__TARGET = ACTION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_BEHAVIOR_ACTION_RULE__SOURCE = ACTION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_BEHAVIOR_ACTION_RULE__ROOT = ACTION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Call Behavior Action Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_BEHAVIOR_ACTION_RULE_FEATURE_COUNT = ACTION_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.SANReusableTaskRuleImpl <em>SAN Reusable Task Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.SANReusableTaskRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getSANReusableTaskRule()
	 * @generated
	 */
	int SAN_REUSABLE_TASK_RULE = 9;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_TASK_RULE__COMPLETE = ACTION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_TASK_RULE__FAILED = ACTION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_TASK_RULE__CHILD_RULES = ACTION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_TASK_RULE__PARENT_RULE = ACTION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_TASK_RULE__TARGET = ACTION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_TASK_RULE__SOURCE = ACTION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_TASK_RULE__ROOT = ACTION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>SAN Reusable Task Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_TASK_RULE_FEATURE_COUNT = ACTION_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ExclusiveBranchRuleImpl <em>Exclusive Branch Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ExclusiveBranchRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getExclusiveBranchRule()
	 * @generated
	 */
	int EXCLUSIVE_BRANCH_RULE = 12;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXCLUSIVE_BRANCH_RULE__COMPLETE = PROCESS_WALKING_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXCLUSIVE_BRANCH_RULE__FAILED = PROCESS_WALKING_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXCLUSIVE_BRANCH_RULE__CHILD_RULES = PROCESS_WALKING_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXCLUSIVE_BRANCH_RULE__PARENT_RULE = PROCESS_WALKING_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXCLUSIVE_BRANCH_RULE__TARGET = PROCESS_WALKING_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXCLUSIVE_BRANCH_RULE__SOURCE = PROCESS_WALKING_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXCLUSIVE_BRANCH_RULE__ROOT = PROCESS_WALKING_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Exclusive Branch Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXCLUSIVE_BRANCH_RULE_FEATURE_COUNT = PROCESS_WALKING_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ConcurrentBranchRuleImpl <em>Concurrent Branch Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ConcurrentBranchRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getConcurrentBranchRule()
	 * @generated
	 */
	int CONCURRENT_BRANCH_RULE = 13;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCURRENT_BRANCH_RULE__COMPLETE = PROCESS_WALKING_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCURRENT_BRANCH_RULE__FAILED = PROCESS_WALKING_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCURRENT_BRANCH_RULE__CHILD_RULES = PROCESS_WALKING_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCURRENT_BRANCH_RULE__PARENT_RULE = PROCESS_WALKING_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCURRENT_BRANCH_RULE__TARGET = PROCESS_WALKING_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCURRENT_BRANCH_RULE__SOURCE = PROCESS_WALKING_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCURRENT_BRANCH_RULE__ROOT = PROCESS_WALKING_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Concurrent Branch Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCURRENT_BRANCH_RULE_FEATURE_COUNT = PROCESS_WALKING_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.DecisionRuleImpl <em>Decision Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.DecisionRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getDecisionRule()
	 * @generated
	 */
	int DECISION_RULE = 14;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Decision Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.MergeRuleImpl <em>Merge Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.MergeRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getMergeRule()
	 * @generated
	 */
	int MERGE_RULE = 15;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MERGE_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MERGE_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MERGE_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MERGE_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MERGE_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MERGE_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MERGE_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Merge Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MERGE_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AssignRuleImpl <em>Assign Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AssignRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getAssignRule()
	 * @generated
	 */
	int ASSIGN_RULE = 16;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSIGN_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSIGN_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSIGN_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSIGN_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSIGN_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSIGN_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSIGN_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Assign Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSIGN_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.LinkRuleImpl <em>Link Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.LinkRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getLinkRule()
	 * @generated
	 */
	int LINK_RULE = 17;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_RULE__COMPLETE = ABSTRACT_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_RULE__FAILED = ABSTRACT_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_RULE__CHILD_RULES = ABSTRACT_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_RULE__PARENT_RULE = ABSTRACT_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_RULE__TARGET = ABSTRACT_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_RULE__SOURCE = ABSTRACT_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_RULE__ROOT = ABSTRACT_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Link Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_RULE_FEATURE_COUNT = ABSTRACT_PROC_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.PartnerRuleImpl <em>Partner Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.PartnerRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getPartnerRule()
	 * @generated
	 */
	int PARTNER_RULE = 18;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTNER_RULE__COMPLETE = ABSTRACT_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTNER_RULE__FAILED = ABSTRACT_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTNER_RULE__CHILD_RULES = ABSTRACT_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTNER_RULE__PARENT_RULE = ABSTRACT_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTNER_RULE__TARGET = ABSTRACT_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTNER_RULE__SOURCE = ABSTRACT_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTNER_RULE__ROOT = ABSTRACT_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Partner Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTNER_RULE_FEATURE_COUNT = ABSTRACT_PROC_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.InvokeRuleImpl <em>Invoke Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.InvokeRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getInvokeRule()
	 * @generated
	 */
	int INVOKE_RULE = 19;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVOKE_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVOKE_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVOKE_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVOKE_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVOKE_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVOKE_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVOKE_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Invoke Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVOKE_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.JoinRuleImpl <em>Join Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.JoinRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getJoinRule()
	 * @generated
	 */
	int JOIN_RULE = 20;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JOIN_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JOIN_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JOIN_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JOIN_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JOIN_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JOIN_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JOIN_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Join Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JOIN_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ForkRuleImpl <em>Fork Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ForkRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getForkRule()
	 * @generated
	 */
	int FORK_RULE = 21;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Fork Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.VariableAccessRuleImpl <em>Variable Access Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.VariableAccessRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getVariableAccessRule()
	 * @generated
	 */
	int VARIABLE_ACCESS_RULE = 22;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_ACCESS_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_ACCESS_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_ACCESS_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_ACCESS_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_ACCESS_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_ACCESS_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_ACCESS_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Variable Access Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_ACCESS_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.DatastoreAccessRuleImpl <em>Datastore Access Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.DatastoreAccessRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getDatastoreAccessRule()
	 * @generated
	 */
	int DATASTORE_ACCESS_RULE = 23;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_ACCESS_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_ACCESS_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_ACCESS_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_ACCESS_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_ACCESS_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_ACCESS_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_ACCESS_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Datastore Access Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_ACCESS_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.DatastoreRuleImpl <em>Datastore Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.DatastoreRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getDatastoreRule()
	 * @generated
	 */
	int DATASTORE_RULE = 24;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_RULE__COMPLETE = ABSTRACT_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_RULE__FAILED = ABSTRACT_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_RULE__CHILD_RULES = ABSTRACT_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_RULE__PARENT_RULE = ABSTRACT_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_RULE__TARGET = ABSTRACT_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_RULE__SOURCE = ABSTRACT_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_RULE__ROOT = ABSTRACT_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Datastore Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_RULE_FEATURE_COUNT = ABSTRACT_PROC_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.VariableRuleImpl <em>Variable Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.VariableRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getVariableRule()
	 * @generated
	 */
	int VARIABLE_RULE = 25;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_RULE__COMPLETE = ABSTRACT_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_RULE__FAILED = ABSTRACT_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_RULE__CHILD_RULES = ABSTRACT_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_RULE__PARENT_RULE = ABSTRACT_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_RULE__TARGET = ABSTRACT_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_RULE__SOURCE = ABSTRACT_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_RULE__ROOT = ABSTRACT_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Variable Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_RULE_FEATURE_COUNT = ABSTRACT_PROC_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ProcessDefinitionRuleImpl <em>Process Definition Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ProcessDefinitionRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getProcessDefinitionRule()
	 * @generated
	 */
	int PROCESS_DEFINITION_RULE = 26;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DEFINITION_RULE__COMPLETE = FrameworkPackage.TRANSFORMATION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DEFINITION_RULE__FAILED = FrameworkPackage.TRANSFORMATION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DEFINITION_RULE__CHILD_RULES = FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DEFINITION_RULE__PARENT_RULE = FrameworkPackage.TRANSFORMATION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DEFINITION_RULE__TARGET = FrameworkPackage.TRANSFORMATION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DEFINITION_RULE__SOURCE = FrameworkPackage.TRANSFORMATION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DEFINITION_RULE__ROOT = FrameworkPackage.TRANSFORMATION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Process Definition Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DEFINITION_RULE_FEATURE_COUNT = FrameworkPackage.TRANSFORMATION_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ProcessInterfaceRuleImpl <em>Process Interface Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ProcessInterfaceRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getProcessInterfaceRule()
	 * @generated
	 */
	int PROCESS_INTERFACE_RULE = 27;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_INTERFACE_RULE__COMPLETE = FrameworkPackage.TRANSFORMATION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_INTERFACE_RULE__FAILED = FrameworkPackage.TRANSFORMATION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_INTERFACE_RULE__CHILD_RULES = FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_INTERFACE_RULE__PARENT_RULE = FrameworkPackage.TRANSFORMATION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_INTERFACE_RULE__TARGET = FrameworkPackage.TRANSFORMATION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_INTERFACE_RULE__SOURCE = FrameworkPackage.TRANSFORMATION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_INTERFACE_RULE__ROOT = FrameworkPackage.TRANSFORMATION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Process Interface Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_INTERFACE_RULE_FEATURE_COUNT = FrameworkPackage.TRANSFORMATION_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ExpressionRuleImpl <em>Expression Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ExpressionRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getExpressionRule()
	 * @generated
	 */
	int EXPRESSION_RULE = 28;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_RULE__COMPLETE = ABSTRACT_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_RULE__FAILED = ABSTRACT_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_RULE__CHILD_RULES = ABSTRACT_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_RULE__PARENT_RULE = ABSTRACT_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_RULE__TARGET = ABSTRACT_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_RULE__SOURCE = ABSTRACT_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_RULE__ROOT = ABSTRACT_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Expression Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_RULE_FEATURE_COUNT = ABSTRACT_PROC_DEF_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.StaffActivityRuleImpl <em>Staff Activity Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.StaffActivityRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getStaffActivityRule()
	 * @generated
	 */
	int STAFF_ACTIVITY_RULE = 29;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAFF_ACTIVITY_RULE__COMPLETE = ABSTRACT_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAFF_ACTIVITY_RULE__FAILED = ABSTRACT_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAFF_ACTIVITY_RULE__CHILD_RULES = ABSTRACT_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAFF_ACTIVITY_RULE__PARENT_RULE = ABSTRACT_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAFF_ACTIVITY_RULE__TARGET = ABSTRACT_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAFF_ACTIVITY_RULE__SOURCE = ABSTRACT_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAFF_ACTIVITY_RULE__ROOT = ABSTRACT_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Staff Activity Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAFF_ACTIVITY_RULE_FEATURE_COUNT = ABSTRACT_PROC_DEF_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.TerminationNodeRuleImpl <em>Termination Node Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.TerminationNodeRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getTerminationNodeRule()
	 * @generated
	 */
	int TERMINATION_NODE_RULE = 30;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINATION_NODE_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINATION_NODE_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINATION_NODE_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINATION_NODE_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINATION_NODE_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINATION_NODE_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINATION_NODE_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Termination Node Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINATION_NODE_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.InputValuePinRuleImpl <em>Input Value Pin Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.InputValuePinRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getInputValuePinRule()
	 * @generated
	 */
	int INPUT_VALUE_PIN_RULE = 31;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_VALUE_PIN_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_VALUE_PIN_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_VALUE_PIN_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_VALUE_PIN_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_VALUE_PIN_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_VALUE_PIN_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_VALUE_PIN_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Input Value Pin Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_VALUE_PIN_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;





















	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.CallOperationActionRuleImpl <em>Call Operation Action Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.CallOperationActionRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getCallOperationActionRule()
	 * @generated
	 */
	int CALL_OPERATION_ACTION_RULE = 32;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_OPERATION_ACTION_RULE__COMPLETE = ACTION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_OPERATION_ACTION_RULE__FAILED = ACTION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_OPERATION_ACTION_RULE__CHILD_RULES = ACTION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_OPERATION_ACTION_RULE__PARENT_RULE = ACTION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_OPERATION_ACTION_RULE__TARGET = ACTION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_OPERATION_ACTION_RULE__SOURCE = ACTION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_OPERATION_ACTION_RULE__ROOT = ACTION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Call Operation Action Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_OPERATION_ACTION_RULE_FEATURE_COUNT = ACTION_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.LoopNodeRuleImpl <em>Loop Node Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.LoopNodeRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getLoopNodeRule()
	 * @generated
	 */
	int LOOP_NODE_RULE = 33;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_NODE_RULE__COMPLETE = PROCESS_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_NODE_RULE__FAILED = PROCESS_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_NODE_RULE__CHILD_RULES = PROCESS_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_NODE_RULE__PARENT_RULE = PROCESS_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_NODE_RULE__TARGET = PROCESS_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_NODE_RULE__SOURCE = PROCESS_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_NODE_RULE__ROOT = PROCESS_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Loop Node Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_NODE_RULE_FEATURE_COUNT = PROCESS_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.MapRuleImpl <em>Map Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.MapRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getMapRule()
	 * @generated
	 */
	int MAP_RULE = 34;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Map Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.GenericActionRuleImpl <em>Generic Action Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.GenericActionRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getGenericActionRule()
	 * @generated
	 */
	int GENERIC_ACTION_RULE = 35;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_ACTION_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_ACTION_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_ACTION_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_ACTION_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_ACTION_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_ACTION_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_ACTION_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Generic Action Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_ACTION_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.OneWayInvokeRuleImpl <em>One Way Invoke Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.OneWayInvokeRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getOneWayInvokeRule()
	 * @generated
	 */
	int ONE_WAY_INVOKE_RULE = 36;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONE_WAY_INVOKE_RULE__COMPLETE = INVOKE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONE_WAY_INVOKE_RULE__FAILED = INVOKE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONE_WAY_INVOKE_RULE__CHILD_RULES = INVOKE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONE_WAY_INVOKE_RULE__PARENT_RULE = INVOKE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONE_WAY_INVOKE_RULE__TARGET = INVOKE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONE_WAY_INVOKE_RULE__SOURCE = INVOKE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONE_WAY_INVOKE_RULE__ROOT = INVOKE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>One Way Invoke Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONE_WAY_INVOKE_RULE_FEATURE_COUNT = INVOKE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.InvokeWithCallbackRuleImpl <em>Invoke With Callback Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.InvokeWithCallbackRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getInvokeWithCallbackRule()
	 * @generated
	 */
	int INVOKE_WITH_CALLBACK_RULE = 37;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVOKE_WITH_CALLBACK_RULE__COMPLETE = ONE_WAY_INVOKE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVOKE_WITH_CALLBACK_RULE__FAILED = ONE_WAY_INVOKE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVOKE_WITH_CALLBACK_RULE__CHILD_RULES = ONE_WAY_INVOKE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVOKE_WITH_CALLBACK_RULE__PARENT_RULE = ONE_WAY_INVOKE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVOKE_WITH_CALLBACK_RULE__TARGET = ONE_WAY_INVOKE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVOKE_WITH_CALLBACK_RULE__SOURCE = ONE_WAY_INVOKE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVOKE_WITH_CALLBACK_RULE__ROOT = ONE_WAY_INVOKE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Invoke With Callback Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVOKE_WITH_CALLBACK_RULE_FEATURE_COUNT = ONE_WAY_INVOKE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.BpelOptimizationRuleImpl <em>Bpel Optimization Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.BpelOptimizationRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getBpelOptimizationRule()
	 * @generated
	 */
	int BPEL_OPTIMIZATION_RULE = 38;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BPEL_OPTIMIZATION_RULE__COMPLETE = FrameworkPackage.TRANSFORMATION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BPEL_OPTIMIZATION_RULE__FAILED = FrameworkPackage.TRANSFORMATION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BPEL_OPTIMIZATION_RULE__CHILD_RULES = FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BPEL_OPTIMIZATION_RULE__PARENT_RULE = FrameworkPackage.TRANSFORMATION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BPEL_OPTIMIZATION_RULE__TARGET = FrameworkPackage.TRANSFORMATION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BPEL_OPTIMIZATION_RULE__SOURCE = FrameworkPackage.TRANSFORMATION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BPEL_OPTIMIZATION_RULE__ROOT = FrameworkPackage.TRANSFORMATION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Bpel Optimization Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BPEL_OPTIMIZATION_RULE_FEATURE_COUNT = FrameworkPackage.TRANSFORMATION_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.HumanTaskRuleImpl <em>Human Task Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.HumanTaskRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getHumanTaskRule()
	 * @generated
	 */
	int HUMAN_TASK_RULE = 39;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HUMAN_TASK_RULE__COMPLETE = ABSTRACT_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HUMAN_TASK_RULE__FAILED = ABSTRACT_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HUMAN_TASK_RULE__CHILD_RULES = ABSTRACT_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HUMAN_TASK_RULE__PARENT_RULE = ABSTRACT_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HUMAN_TASK_RULE__TARGET = ABSTRACT_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HUMAN_TASK_RULE__SOURCE = ABSTRACT_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HUMAN_TASK_RULE__ROOT = ABSTRACT_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Human Task Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HUMAN_TASK_RULE_FEATURE_COUNT = ABSTRACT_PROC_DEF_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.InputRuleImpl <em>Input Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.InputRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getInputRule()
	 * @generated
	 */
	int INPUT_RULE = 40;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_RULE__COMPLETE = ABSTRACT_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_RULE__FAILED = ABSTRACT_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_RULE__CHILD_RULES = ABSTRACT_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_RULE__PARENT_RULE = ABSTRACT_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_RULE__TARGET = ABSTRACT_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_RULE__SOURCE = ABSTRACT_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_RULE__ROOT = ABSTRACT_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Input Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_RULE_FEATURE_COUNT = ABSTRACT_PROC_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.OutputRuleImpl <em>Output Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.OutputRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getOutputRule()
	 * @generated
	 */
	int OUTPUT_RULE = 41;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_RULE__COMPLETE = ABSTRACT_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_RULE__FAILED = ABSTRACT_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_RULE__CHILD_RULES = ABSTRACT_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_RULE__PARENT_RULE = ABSTRACT_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_RULE__TARGET = ABSTRACT_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_RULE__SOURCE = ABSTRACT_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_RULE__ROOT = ABSTRACT_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Output Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_RULE_FEATURE_COUNT = ABSTRACT_PROC_DEF_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.BRReusableTaskRuleImpl <em>BR Reusable Task Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.BRReusableTaskRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getBRReusableTaskRule()
	 * @generated
	 */
	int BR_REUSABLE_TASK_RULE = 42;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_REUSABLE_TASK_RULE__COMPLETE = ACTION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_REUSABLE_TASK_RULE__FAILED = ACTION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_REUSABLE_TASK_RULE__CHILD_RULES = ACTION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_REUSABLE_TASK_RULE__PARENT_RULE = ACTION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_REUSABLE_TASK_RULE__TARGET = ACTION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_REUSABLE_TASK_RULE__SOURCE = ACTION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_REUSABLE_TASK_RULE__ROOT = ACTION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>BR Reusable Task Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_REUSABLE_TASK_RULE_FEATURE_COUNT = ACTION_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.BRTaskRuleImpl <em>BR Task Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.BRTaskRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getBRTaskRule()
	 * @generated
	 */
	int BR_TASK_RULE = 43;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_TASK_RULE__COMPLETE = ACTION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_TASK_RULE__FAILED = ACTION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_TASK_RULE__CHILD_RULES = ACTION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_TASK_RULE__PARENT_RULE = ACTION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_TASK_RULE__TARGET = ACTION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_TASK_RULE__SOURCE = ACTION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_TASK_RULE__ROOT = ACTION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>BR Task Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_TASK_RULE_FEATURE_COUNT = ACTION_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.HTReusableTaskRuleImpl <em>HT Reusable Task Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.HTReusableTaskRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getHTReusableTaskRule()
	 * @generated
	 */
	int HT_REUSABLE_TASK_RULE = 44;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_REUSABLE_TASK_RULE__COMPLETE = ACTION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_REUSABLE_TASK_RULE__FAILED = ACTION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_REUSABLE_TASK_RULE__CHILD_RULES = ACTION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_REUSABLE_TASK_RULE__PARENT_RULE = ACTION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_REUSABLE_TASK_RULE__TARGET = ACTION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_REUSABLE_TASK_RULE__SOURCE = ACTION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_REUSABLE_TASK_RULE__ROOT = ACTION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>HT Reusable Task Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_REUSABLE_TASK_RULE_FEATURE_COUNT = ACTION_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.HTTaskRuleImpl <em>HT Task Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.HTTaskRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getHTTaskRule()
	 * @generated
	 */
	int HT_TASK_RULE = 45;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_TASK_RULE__COMPLETE = ACTION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_TASK_RULE__FAILED = ACTION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_TASK_RULE__CHILD_RULES = ACTION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_TASK_RULE__PARENT_RULE = ACTION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_TASK_RULE__TARGET = ACTION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_TASK_RULE__SOURCE = ACTION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_TASK_RULE__ROOT = ACTION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>HT Task Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_TASK_RULE_FEATURE_COUNT = ACTION_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.FormRuleImpl <em>Form Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.FormRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getFormRule()
	 * @generated
	 */
	int FORM_RULE = 46;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORM_RULE__COMPLETE = ABSTRACT_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORM_RULE__FAILED = ABSTRACT_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORM_RULE__CHILD_RULES = ABSTRACT_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORM_RULE__PARENT_RULE = ABSTRACT_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORM_RULE__TARGET = ABSTRACT_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORM_RULE__SOURCE = ABSTRACT_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORM_RULE__ROOT = ABSTRACT_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Form Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORM_RULE_FEATURE_COUNT = ABSTRACT_PROC_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.HTBusinessCalendarRuleImpl <em>HT Business Calendar Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.HTBusinessCalendarRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getHTBusinessCalendarRule()
	 * @generated
	 */
	int HT_BUSINESS_CALENDAR_RULE = 47;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_BUSINESS_CALENDAR_RULE__COMPLETE = FrameworkPackage.TRANSFORMATION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_BUSINESS_CALENDAR_RULE__FAILED = FrameworkPackage.TRANSFORMATION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_BUSINESS_CALENDAR_RULE__CHILD_RULES = FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_BUSINESS_CALENDAR_RULE__PARENT_RULE = FrameworkPackage.TRANSFORMATION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_BUSINESS_CALENDAR_RULE__TARGET = FrameworkPackage.TRANSFORMATION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_BUSINESS_CALENDAR_RULE__SOURCE = FrameworkPackage.TRANSFORMATION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_BUSINESS_CALENDAR_RULE__ROOT = FrameworkPackage.TRANSFORMATION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>HT Business Calendar Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HT_BUSINESS_CALENDAR_RULE_FEATURE_COUNT = FrameworkPackage.TRANSFORMATION_RULE_FEATURE_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractProcDefRule <em>Abstract Proc Def Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Proc Def Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractProcDefRule
	 * @generated
	 */
	EClass getAbstractProcDefRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.ActionRule <em>Action Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Action Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.ActionRule
	 * @generated
	 */
	EClass getActionRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.ActivityRule <em>Activity Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Activity Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.ActivityRule
	 * @generated
	 */
	EClass getActivityRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.SANReusableProcessRule <em>SAN Reusable Process Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SAN Reusable Process Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.SANReusableProcessRule
	 * @generated
	 */
	EClass getSANReusableProcessRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.SANNestedProcessRule <em>SAN Nested Process Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SAN Nested Process Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.SANNestedProcessRule
	 * @generated
	 */
	EClass getSANNestedProcessRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.SANTaskRule <em>SAN Task Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SAN Task Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.SANTaskRule
	 * @generated
	 */
	EClass getSANTaskRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessRule <em>Process Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessRule
	 * @generated
	 */
	EClass getProcessRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.ContainerRule <em>Container Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Container Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.ContainerRule
	 * @generated
	 */
	EClass getContainerRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.CallBehaviorActionRule <em>Call Behavior Action Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Call Behavior Action Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.CallBehaviorActionRule
	 * @generated
	 */
	EClass getCallBehaviorActionRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.SANReusableTaskRule <em>SAN Reusable Task Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SAN Reusable Task Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.SANReusableTaskRule
	 * @generated
	 */
	EClass getSANReusableTaskRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.ConnectableRule <em>Connectable Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Connectable Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.ConnectableRule
	 * @generated
	 */
	EClass getConnectableRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessWalkingRule <em>Process Walking Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Walking Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessWalkingRule
	 * @generated
	 */
	EClass getProcessWalkingRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.ExclusiveBranchRule <em>Exclusive Branch Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Exclusive Branch Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.ExclusiveBranchRule
	 * @generated
	 */
	EClass getExclusiveBranchRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.ConcurrentBranchRule <em>Concurrent Branch Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Concurrent Branch Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.ConcurrentBranchRule
	 * @generated
	 */
	EClass getConcurrentBranchRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.DecisionRule <em>Decision Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Decision Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.DecisionRule
	 * @generated
	 */
	EClass getDecisionRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.MergeRule <em>Merge Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Merge Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.MergeRule
	 * @generated
	 */
	EClass getMergeRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.AssignRule <em>Assign Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Assign Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.AssignRule
	 * @generated
	 */
	EClass getAssignRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.LinkRule <em>Link Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Link Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.LinkRule
	 * @generated
	 */
	EClass getLinkRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.PartnerRule <em>Partner Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Partner Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.PartnerRule
	 * @generated
	 */
	EClass getPartnerRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.InvokeRule <em>Invoke Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Invoke Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.InvokeRule
	 * @generated
	 */
	EClass getInvokeRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.JoinRule <em>Join Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Join Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.JoinRule
	 * @generated
	 */
	EClass getJoinRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.ForkRule <em>Fork Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Fork Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.ForkRule
	 * @generated
	 */
	EClass getForkRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.VariableAccessRule <em>Variable Access Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Variable Access Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.VariableAccessRule
	 * @generated
	 */
	EClass getVariableAccessRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.DatastoreAccessRule <em>Datastore Access Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Datastore Access Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.DatastoreAccessRule
	 * @generated
	 */
	EClass getDatastoreAccessRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.DatastoreRule <em>Datastore Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Datastore Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.DatastoreRule
	 * @generated
	 */
	EClass getDatastoreRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.VariableRule <em>Variable Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Variable Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.VariableRule
	 * @generated
	 */
	EClass getVariableRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessDefinitionRule <em>Process Definition Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Definition Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessDefinitionRule
	 * @generated
	 */
	EClass getProcessDefinitionRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessInterfaceRule <em>Process Interface Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Interface Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessInterfaceRule
	 * @generated
	 */
	EClass getProcessInterfaceRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.ExpressionRule <em>Expression Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Expression Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.ExpressionRule
	 * @generated
	 */
	EClass getExpressionRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.StaffActivityRule <em>Staff Activity Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Staff Activity Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.StaffActivityRule
	 * @generated
	 */
	EClass getStaffActivityRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.TerminationNodeRule <em>Termination Node Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Termination Node Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.TerminationNodeRule
	 * @generated
	 */
	EClass getTerminationNodeRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.InputValuePinRule <em>Input Value Pin Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Input Value Pin Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.InputValuePinRule
	 * @generated
	 */
	EClass getInputValuePinRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.CallOperationActionRule <em>Call Operation Action Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Call Operation Action Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.CallOperationActionRule
	 * @generated
	 */
	EClass getCallOperationActionRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.LoopNodeRule <em>Loop Node Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Loop Node Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.LoopNodeRule
	 * @generated
	 */
	EClass getLoopNodeRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.MapRule <em>Map Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Map Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.MapRule
	 * @generated
	 */
	EClass getMapRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.GenericActionRule <em>Generic Action Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Generic Action Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.GenericActionRule
	 * @generated
	 */
	EClass getGenericActionRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.OneWayInvokeRule <em>One Way Invoke Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>One Way Invoke Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.OneWayInvokeRule
	 * @generated
	 */
	EClass getOneWayInvokeRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.InvokeWithCallbackRule <em>Invoke With Callback Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Invoke With Callback Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.InvokeWithCallbackRule
	 * @generated
	 */
	EClass getInvokeWithCallbackRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.BpelOptimizationRule <em>Bpel Optimization Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bpel Optimization Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.BpelOptimizationRule
	 * @generated
	 */
	EClass getBpelOptimizationRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.HumanTaskRule <em>Human Task Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Human Task Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.HumanTaskRule
	 * @generated
	 */
	EClass getHumanTaskRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.InputRule <em>Input Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Input Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.InputRule
	 * @generated
	 */
	EClass getInputRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.OutputRule <em>Output Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Output Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.OutputRule
	 * @generated
	 */
	EClass getOutputRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.BRReusableTaskRule <em>BR Reusable Task Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>BR Reusable Task Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.BRReusableTaskRule
	 * @generated
	 */
	EClass getBRReusableTaskRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.BRTaskRule <em>BR Task Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>BR Task Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.BRTaskRule
	 * @generated
	 */
	EClass getBRTaskRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.HTReusableTaskRule <em>HT Reusable Task Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>HT Reusable Task Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.HTReusableTaskRule
	 * @generated
	 */
	EClass getHTReusableTaskRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.HTTaskRule <em>HT Task Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>HT Task Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.HTTaskRule
	 * @generated
	 */
	EClass getHTTaskRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.FormRule <em>Form Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Form Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.FormRule
	 * @generated
	 */
	EClass getFormRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.HTBusinessCalendarRule <em>HT Business Calendar Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>HT Business Calendar Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.HTBusinessCalendarRule
	 * @generated
	 */
	EClass getHTBusinessCalendarRule();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	AbstractbpelFactory getAbstractbpelFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals  {
		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractProcDefRuleImpl <em>Abstract Proc Def Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractProcDefRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getAbstractProcDefRule()
		 * @generated
		 */
		EClass ABSTRACT_PROC_DEF_RULE = eINSTANCE.getAbstractProcDefRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ActionRuleImpl <em>Action Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ActionRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getActionRule()
		 * @generated
		 */
		EClass ACTION_RULE = eINSTANCE.getActionRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ActivityRuleImpl <em>Activity Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ActivityRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getActivityRule()
		 * @generated
		 */
		EClass ACTIVITY_RULE = eINSTANCE.getActivityRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.SANReusableProcessRuleImpl <em>SAN Reusable Process Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.SANReusableProcessRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getSANReusableProcessRule()
		 * @generated
		 */
		EClass SAN_REUSABLE_PROCESS_RULE = eINSTANCE.getSANReusableProcessRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.SANNestedProcessRuleImpl <em>SAN Nested Process Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.SANNestedProcessRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getSANNestedProcessRule()
		 * @generated
		 */
		EClass SAN_NESTED_PROCESS_RULE = eINSTANCE.getSANNestedProcessRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.SANTaskRuleImpl <em>SAN Task Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.SANTaskRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getSANTaskRule()
		 * @generated
		 */
		EClass SAN_TASK_RULE = eINSTANCE.getSANTaskRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ProcessRuleImpl <em>Process Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ProcessRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getProcessRule()
		 * @generated
		 */
		EClass PROCESS_RULE = eINSTANCE.getProcessRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ContainerRuleImpl <em>Container Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ContainerRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getContainerRule()
		 * @generated
		 */
		EClass CONTAINER_RULE = eINSTANCE.getContainerRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.CallBehaviorActionRuleImpl <em>Call Behavior Action Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.CallBehaviorActionRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getCallBehaviorActionRule()
		 * @generated
		 */
		EClass CALL_BEHAVIOR_ACTION_RULE = eINSTANCE.getCallBehaviorActionRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.SANReusableTaskRuleImpl <em>SAN Reusable Task Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.SANReusableTaskRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getSANReusableTaskRule()
		 * @generated
		 */
		EClass SAN_REUSABLE_TASK_RULE = eINSTANCE.getSANReusableTaskRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ConnectableRuleImpl <em>Connectable Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ConnectableRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getConnectableRule()
		 * @generated
		 */
		EClass CONNECTABLE_RULE = eINSTANCE.getConnectableRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ProcessWalkingRuleImpl <em>Process Walking Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ProcessWalkingRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getProcessWalkingRule()
		 * @generated
		 */
		EClass PROCESS_WALKING_RULE = eINSTANCE.getProcessWalkingRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ExclusiveBranchRuleImpl <em>Exclusive Branch Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ExclusiveBranchRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getExclusiveBranchRule()
		 * @generated
		 */
		EClass EXCLUSIVE_BRANCH_RULE = eINSTANCE.getExclusiveBranchRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ConcurrentBranchRuleImpl <em>Concurrent Branch Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ConcurrentBranchRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getConcurrentBranchRule()
		 * @generated
		 */
		EClass CONCURRENT_BRANCH_RULE = eINSTANCE.getConcurrentBranchRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.DecisionRuleImpl <em>Decision Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.DecisionRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getDecisionRule()
		 * @generated
		 */
		EClass DECISION_RULE = eINSTANCE.getDecisionRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.MergeRuleImpl <em>Merge Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.MergeRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getMergeRule()
		 * @generated
		 */
		EClass MERGE_RULE = eINSTANCE.getMergeRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AssignRuleImpl <em>Assign Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AssignRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getAssignRule()
		 * @generated
		 */
		EClass ASSIGN_RULE = eINSTANCE.getAssignRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.LinkRuleImpl <em>Link Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.LinkRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getLinkRule()
		 * @generated
		 */
		EClass LINK_RULE = eINSTANCE.getLinkRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.PartnerRuleImpl <em>Partner Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.PartnerRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getPartnerRule()
		 * @generated
		 */
		EClass PARTNER_RULE = eINSTANCE.getPartnerRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.InvokeRuleImpl <em>Invoke Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.InvokeRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getInvokeRule()
		 * @generated
		 */
		EClass INVOKE_RULE = eINSTANCE.getInvokeRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.JoinRuleImpl <em>Join Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.JoinRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getJoinRule()
		 * @generated
		 */
		EClass JOIN_RULE = eINSTANCE.getJoinRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ForkRuleImpl <em>Fork Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ForkRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getForkRule()
		 * @generated
		 */
		EClass FORK_RULE = eINSTANCE.getForkRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.VariableAccessRuleImpl <em>Variable Access Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.VariableAccessRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getVariableAccessRule()
		 * @generated
		 */
		EClass VARIABLE_ACCESS_RULE = eINSTANCE.getVariableAccessRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.DatastoreAccessRuleImpl <em>Datastore Access Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.DatastoreAccessRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getDatastoreAccessRule()
		 * @generated
		 */
		EClass DATASTORE_ACCESS_RULE = eINSTANCE.getDatastoreAccessRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.DatastoreRuleImpl <em>Datastore Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.DatastoreRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getDatastoreRule()
		 * @generated
		 */
		EClass DATASTORE_RULE = eINSTANCE.getDatastoreRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.VariableRuleImpl <em>Variable Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.VariableRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getVariableRule()
		 * @generated
		 */
		EClass VARIABLE_RULE = eINSTANCE.getVariableRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ProcessDefinitionRuleImpl <em>Process Definition Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ProcessDefinitionRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getProcessDefinitionRule()
		 * @generated
		 */
		EClass PROCESS_DEFINITION_RULE = eINSTANCE.getProcessDefinitionRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ProcessInterfaceRuleImpl <em>Process Interface Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ProcessInterfaceRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getProcessInterfaceRule()
		 * @generated
		 */
		EClass PROCESS_INTERFACE_RULE = eINSTANCE.getProcessInterfaceRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ExpressionRuleImpl <em>Expression Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ExpressionRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getExpressionRule()
		 * @generated
		 */
		EClass EXPRESSION_RULE = eINSTANCE.getExpressionRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.StaffActivityRuleImpl <em>Staff Activity Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.StaffActivityRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getStaffActivityRule()
		 * @generated
		 */
		EClass STAFF_ACTIVITY_RULE = eINSTANCE.getStaffActivityRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.TerminationNodeRuleImpl <em>Termination Node Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.TerminationNodeRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getTerminationNodeRule()
		 * @generated
		 */
		EClass TERMINATION_NODE_RULE = eINSTANCE.getTerminationNodeRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.InputValuePinRuleImpl <em>Input Value Pin Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.InputValuePinRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getInputValuePinRule()
		 * @generated
		 */
		EClass INPUT_VALUE_PIN_RULE = eINSTANCE.getInputValuePinRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.CallOperationActionRuleImpl <em>Call Operation Action Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.CallOperationActionRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getCallOperationActionRule()
		 * @generated
		 */
		EClass CALL_OPERATION_ACTION_RULE = eINSTANCE.getCallOperationActionRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.LoopNodeRuleImpl <em>Loop Node Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.LoopNodeRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getLoopNodeRule()
		 * @generated
		 */
		EClass LOOP_NODE_RULE = eINSTANCE.getLoopNodeRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.MapRuleImpl <em>Map Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.MapRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getMapRule()
		 * @generated
		 */
		EClass MAP_RULE = eINSTANCE.getMapRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.GenericActionRuleImpl <em>Generic Action Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.GenericActionRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getGenericActionRule()
		 * @generated
		 */
		EClass GENERIC_ACTION_RULE = eINSTANCE.getGenericActionRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.OneWayInvokeRuleImpl <em>One Way Invoke Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.OneWayInvokeRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getOneWayInvokeRule()
		 * @generated
		 */
		EClass ONE_WAY_INVOKE_RULE = eINSTANCE.getOneWayInvokeRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.InvokeWithCallbackRuleImpl <em>Invoke With Callback Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.InvokeWithCallbackRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getInvokeWithCallbackRule()
		 * @generated
		 */
		EClass INVOKE_WITH_CALLBACK_RULE = eINSTANCE.getInvokeWithCallbackRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.BpelOptimizationRuleImpl <em>Bpel Optimization Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.BpelOptimizationRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getBpelOptimizationRule()
		 * @generated
		 */
		EClass BPEL_OPTIMIZATION_RULE = eINSTANCE.getBpelOptimizationRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.HumanTaskRuleImpl <em>Human Task Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.HumanTaskRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getHumanTaskRule()
		 * @generated
		 */
		EClass HUMAN_TASK_RULE = eINSTANCE.getHumanTaskRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.InputRuleImpl <em>Input Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.InputRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getInputRule()
		 * @generated
		 */
		EClass INPUT_RULE = eINSTANCE.getInputRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.OutputRuleImpl <em>Output Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.OutputRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getOutputRule()
		 * @generated
		 */
		EClass OUTPUT_RULE = eINSTANCE.getOutputRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.BRReusableTaskRuleImpl <em>BR Reusable Task Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.BRReusableTaskRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getBRReusableTaskRule()
		 * @generated
		 */
		EClass BR_REUSABLE_TASK_RULE = eINSTANCE.getBRReusableTaskRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.BRTaskRuleImpl <em>BR Task Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.BRTaskRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getBRTaskRule()
		 * @generated
		 */
		EClass BR_TASK_RULE = eINSTANCE.getBRTaskRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.HTReusableTaskRuleImpl <em>HT Reusable Task Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.HTReusableTaskRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getHTReusableTaskRule()
		 * @generated
		 */
		EClass HT_REUSABLE_TASK_RULE = eINSTANCE.getHTReusableTaskRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.HTTaskRuleImpl <em>HT Task Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.HTTaskRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getHTTaskRule()
		 * @generated
		 */
		EClass HT_TASK_RULE = eINSTANCE.getHTTaskRule();

			/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.FormRuleImpl <em>Form Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.FormRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getFormRule()
		 * @generated
		 */
		EClass FORM_RULE = eINSTANCE.getFormRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.HTBusinessCalendarRuleImpl <em>HT Business Calendar Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.HTBusinessCalendarRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl#getHTBusinessCalendarRule()
		 * @generated
		 */
		EClass HT_BUSINESS_CALENDAR_RULE = eINSTANCE.getHTBusinessCalendarRule();

	}

} //AbstractbpelPackage
