/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.abstractbpel;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import com.ibm.btools.te.framework.TransformationRule;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Process Definition Rule</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Source: Top Level Process (Activity)
 * Target: BPEL Process
 * Rule:
 * 1. Creates a BPEL Process
 * 2. Creates an ActivityRule and set the Souce as the top level process (Acitivity)
 * 3. Expects a set of top level BPEL Process elements to come back as targets of the ActivityRule (e.g. Partners, Variables, Activities, etc.).  It then adds all these elements to the BPEL Process
 * 4. During the process of transforming the Process definition, other process interfaces may be created (in the case that it has reference to other processes).  Then a ProcessInterfaceRule will be created for that process and will be put in the context.
 * 
 * <!-- end-model-doc -->
 *
 *
 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelPackage#getProcessDefinitionRule()
 * @model
 * @generated
 */
public interface ProcessDefinitionRule extends TransformationRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
} // ProcessDefinitionRule
