/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.abstractbpel.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.wst.wsdl.Operation;
import org.eclipse.wst.wsdl.PortType;
import org.eclipse.wst.wsdl.WSDLFactory;

import com.ibm.btools.blm.ie.imprt.rule.util.BOMUtil;
import com.ibm.btools.bom.model.artifacts.Element;
import com.ibm.btools.bom.model.artifacts.NamedElement;
import com.ibm.btools.bom.model.artifacts.TypedElement;
import com.ibm.btools.bom.model.processes.actions.CallBehaviorAction;
import com.ibm.btools.bom.model.processes.actions.CallOperationAction;
import com.ibm.btools.bom.model.processes.actions.Decision;
import com.ibm.btools.bom.model.processes.actions.Fork;
import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.bom.model.processes.activities.Activity;
import com.ibm.btools.bom.model.processes.activities.ActivityEdge;
import com.ibm.btools.bom.model.processes.activities.InputObjectPin;
import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.bom.model.processes.activities.ObjectPin;
import com.ibm.btools.bom.model.processes.activities.OutputObjectPin;
import com.ibm.btools.bom.model.processes.activities.OutputPinSet;
import com.ibm.btools.bom.model.processes.activities.Pin;
import com.ibm.btools.bom.model.processes.activities.PinSet;
import com.ibm.btools.bom.model.processes.activities.StructuredActivityNode;
import com.ibm.btools.bom.model.services.Behavior;
import com.ibm.btools.bom.model.services.BehavioredClass;
import com.ibm.btools.bom.model.services.InputParameterSet;
import com.ibm.btools.bom.model.services.OutputParameterSet;
import com.ibm.btools.te.attributes.helper.AttributeNameConstants;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.framework.impl.TransformationRuleImpl;
import com.ibm.btools.te.framework.util.TransformationUtil;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.attribute.AttributeValueProvider;
import com.ibm.btools.te.ilm.attribute.AttributeValueProviderFactory;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractProcDefRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelFactory;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelPackage;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ContainerRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.InputRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.LinkRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.OutputRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessInterfaceRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.VariableRule;
import com.ibm.btools.te.ilm.heuristics.helper.AbstractbpelUtil;
import com.ibm.btools.te.ilm.heuristics.helper.BomUtils;
import com.ibm.btools.te.ilm.heuristics.helper.BpelOptionsUtil;
import com.ibm.btools.te.ilm.heuristics.helper.FabricIntegrationUtil;
import com.ibm.btools.te.ilm.heuristics.helper.ProcessUtil;
import com.ibm.btools.te.ilm.heuristics.helper.StaffUtil;
import com.ibm.btools.te.ilm.heuristics.naming.NamingUtil;
import com.ibm.btools.te.ilm.heuristics.scdl.ComponentRule;
import com.ibm.btools.te.ilm.heuristics.scdl.ExportRule;
import com.ibm.btools.te.ilm.heuristics.scdl.ScdlFactory;
import com.ibm.wbit.bpel.BPELVariable;
import com.ibm.wbit.bpel.Link;
import com.ibm.wbit.bpelpp.BPELPlusFactory;
import com.ibm.wbit.bpelpp.Description;
import com.ibm.wbit.bpelpp.DisplayName;
import com.ibm.wbit.bpelpp.Documentation;
import com.ibm.wbit.bpelpp.Input;
import com.ibm.wbit.bpelpp.Output;
import com.ibm.wsspi.sca.scdl.DocumentRoot;
import com.ibm.wsspi.sca.scdl.Interface;

/**
 * This is the parent rule of all ProcessDefinition rules.  It provides
 * a set of common methods to analyze the BOM activity constructs and 
 * create the BPEL process constructs  
 *
 */
public abstract class AbstractProcDefRuleImpl extends TransformationRuleImpl implements AbstractProcDefRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AbstractProcDefRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return AbstractbpelPackage.Literals.ABSTRACT_PROC_DEF_RULE;
	}

	protected List currentPathVariables;
	protected List currentPathVariablesSnapshot;
	protected List forbiddenVariables;
	
	/**
	 * Initiazes the 3 registries used for parallel flow variables management. These are: 
	 * - forbidden variables - a list of variables already used in another parallel flow
	 * - currentPathVariables - a list of (not unique) variables used currently when traversing a parallel flow branch
	 * - currentPathVariableSnapshot - a list of unique variables recorded at the begining of each parallel flow branch. 
	 * The lists are initialized as follows: 
	 * the forbidden variables is initialized with all the forbidden variables recorded until at that point.  
	 *	the currentPathVariables variables is initialized with all the variables recorded until at that point.
	 *	the currentPathVariableSnapshot is initialized with all the forbidden variables recorded until at that point.
	 */
	protected void initializePathsVariablesForBranchRegion(){
		
		forbiddenVariables = new LinkedList();
		currentPathVariables = new LinkedList();
		currentPathVariablesSnapshot = new LinkedList();
		
		//get a snapshot of the variables registered in all other parallel paths (forbiden variables).
		if(ProcessUtil.getParallelFlowsRegisteredVariables(getContext()) != null){
			forbiddenVariables.addAll(ProcessUtil.getParallelFlowsRegisteredVariables(getContext()));	
		}
		//get a snapshot of the variables on the current path.
		if(ProcessUtil.getCurrentPathParallelFlowsRegisteredVariables(getContext()) != null){
			currentPathVariables.addAll(ProcessUtil.getCurrentPathParallelFlowsRegisteredVariables(getContext()));	
			currentPathVariablesSnapshot.addAll(ProcessUtil.getCurrentPathParallelFlowsRegisteredVariables(getContext()));
		}
	}
	/**
	 * Resets the variable registries to proper values. This is called at the end of processing each parallel branch region.
	 * Will calculate the list of variable used on a branch flow from the list currentPathVariables and the list of currentPathVariablesSnapshot.
	 * These will constitute the forbidden variables on the given branch. 
	 * For parallel flows starting at a Decision (Exclusive) or Fork, will add to the forbidden variables the variables used at the Branch point.
	 * For other concurrent branches, will deregister from the forbidden variable list of variables added for the non participating variables recorded 
	 * for the PinSet concurrent branch point. They were previously added as incompatible variables (at the cb branch entry).
	 * Resets the variables currentPathVariables to the initial list at the entry of the CBRegion. 
	 * @param cbPointSet
	 * @param nextIS
	 */
	protected void resetPathRegistryInBranchPoint(PinSet cbPointSet, PinSet nextIS){
		
		currentPathVariables.addAll(ProcessUtil.getCurrentPathParallelFlowsRegisteredVariables(this.getContext()));
		List addedVariables = getPathAddedVariables();
		if((cbPointSet instanceof InputPinSet && ((InputPinSet)cbPointSet).getAction() instanceof Decision) ||(cbPointSet instanceof OutputPinSet && ((OutputPinSet)cbPointSet).getAction() instanceof Fork)){
			List cbVariables = getVariablesForSet(cbPointSet);
			addedVariables.addAll(cbVariables);
			ProcessUtil.registerVariableForParallelFlow(this.getContext(), addedVariables, false);
		}else{
			List nonCbVariables = getVariablesForCBPoint(cbPointSet, nextIS, false);
			//addedVariables.removeAll(nonCbVariables);
			ProcessUtil.registerVariableForParallelFlow(this.getContext(), addedVariables, false);
			//List nonCbVariables = getVariablesForCBPoint(cbPointSet, nextIS, false);
			ProcessUtil.deregisterVariableForParallelFlow(getContext(), nonCbVariables);
			
		}
		
		ProcessUtil.registerVariablesForCurrentPath(this.getContext(), currentPathVariablesSnapshot, true);
	}
	
	public void updatePathRegistryAtBranchPoint(PinSet cbPointSet, PinSet nextIS){
		
		List nonCbVariables = getVariablesForCBPoint(cbPointSet, nextIS, false);
	    List cbVariables = getVariablesForCBPoint(cbPointSet, nextIS, true);
		currentPathVariables.removeAll(nonCbVariables);
		currentPathVariables.addAll(cbVariables);
		ProcessUtil.registerVariablesForCurrentPath(this.getContext(), currentPathVariables, true);
		ProcessUtil.registerVariableForParallelFlow(this.getContext(), nonCbVariables, false);
	}
		
	/**
	 * Resets the variable registries to the new actual values.
	 *
	 */
	protected void resetPathsRegistry(){
		//reset the forbiden variables to the values snapshot value.. 
		ProcessUtil.registerVariableForParallelFlow(this.getContext(), forbiddenVariables, true);
		//set the current path to the new value.. 
		ProcessUtil.registerVariablesForCurrentPath(getContext(), currentPathVariables, false);
		
	}
	
	protected Link createLink(ActivityEdge edge, Pin pin, NamedElement set)
	{
		LinkRule lr = AbstractbpelFactory.eINSTANCE.createLinkRule();
		getChildRules().add(lr);
		lr.getSource().add(edge);
		lr.getSource().add(pin);
		lr.getSource().add(set);
		if (lr.transformSource2Target())
			return (Link)lr.getTarget().get(0);
		else
			return null;
	}
	
	protected BPELVariable createContainer(NamedElement srcObj)
	{	
		ContainerRule cr = AbstractbpelFactory.eINSTANCE.createContainerRule();
		getChildRules().add(cr);
		cr.getSource().add(srcObj);
		if (cr.transformSource2Target())
			return (BPELVariable)cr.getTarget().get(0);
		else
			return null;
	}
	/**
	 * Create an execute the InputRule, responsible for creating the BPEL Input.
	 * @param srcObj tipycally an Input or an OutputPinSet.
	 * @return
	 */
	protected Input createInput(NamedElement srcObj){	
		PinSet inputPinSet = (PinSet)srcObj;
		InputRule cr = AbstractbpelFactory.eINSTANCE.createInputRule();
		getChildRules().add(cr);
		cr.getSource().add(inputPinSet);
		cr.transformSource2Target();
		return (Input)cr.getTarget().get(0);

	}
	/**
	 * Create an execute the OutputRule, responsible for creating the BPEL Output.
	 * @param srcObj tipycally an Output or an InputPinSet.
	 * @return
	 */
	protected Output createOutput(NamedElement srcObj){	
		PinSet outputPinSet = (PinSet)srcObj;
		OutputRule cr = AbstractbpelFactory.eINSTANCE.createOutputRule();
		getChildRules().add(cr);
		cr.getSource().add(outputPinSet);
		cr.transformSource2Target();
		return (Output)cr.getTarget().get(0);
		
	}
	/**
	 * Returns the BPEL Variables for the <code>srcObj</code>. Will check this <code>srcObj</code>
	 * was already processed, in which case a VariableRule should have been created, if not, creates
	 * and executed the VariableRule.
	 * @param srcObj a BOMNamedElement
	 * @return a BPEL Variable or null, if none can be created.
	 */
	protected BPELVariable createVariable(NamedElement srcObj){	
		ArrayList thisSources = new ArrayList();
		thisSources.add(((TypedElement)srcObj).getType());
		thisSources.add(srcObj);
		ArrayList targets = new ArrayList();
		//check if there if this srcObj was already processed for Variable.
		TransformationRule rule = TransformationUtil.getRuleForSource(getRoot(), VariableRule.class, thisSources, targets);
		if(rule != null && !rule.getTarget().isEmpty()){
			return (BPELVariable)rule.getTarget().get(0);
		}else if(rule != null && !rule.isComplete()){
			if (rule.transformSource2Target())
				return (BPELVariable)rule.getTarget().get(0);
		}
		VariableRule cr = AbstractbpelFactory.eINSTANCE.createVariableRule();
		getChildRules().add(cr);
		cr.getSource().addAll(thisSources);
		if (cr.transformSource2Target())
			return (BPELVariable)cr.getTarget().get(0);
		else
			return null;
	}
	
	protected List getVariablesForSet(PinSet pinSet){
		List variables = new LinkedList();
		List pins = BomUtils.getObjectPinsForSet(pinSet);
		if(pins != null && !pins.isEmpty()){
			Iterator it = pins.iterator();
			while(it.hasNext()){
				NamedElement element = (NamedElement)it.next();
				BPELVariable variable = createVariable(element);
				if(variable != null){
					variables.add(variable);
				}
			}
		}
		
		return variables;
	}
	
	/*
	 * The following method is specifically for handling
	 * special cases for a CallBehaviorAction and a CallOperationAction
	 */
	protected NamedElement getCorrespondingSet(NamedElement set)
	{
		Action owner = (Action)set.eContainer();
		if (owner instanceof CallBehaviorAction)
		{
			CallBehaviorAction cba = (CallBehaviorAction)owner;
			if (set instanceof InputPinSet)
			{
				List inputSets = cba.getInputPinSet();
				// find the index of the inputset
				int ind = inputSets.indexOf(set);
				Action san = ((Activity)cba.getBehavior()).getImplementation();
				inputSets = san.getInputPinSet();
				return (InputPinSet)inputSets.get(ind);	
			} else {
				List outputSets = cba.getOutputPinSet();
				// find the index of the inputset
				int ind = outputSets.indexOf(set);
				Action san = ((Activity)cba.getBehavior()).getImplementation();
				outputSets = san.getOutputPinSet();
				return (OutputPinSet)outputSets.get(ind);			
			}
		//the corresponding set belongs to the matching Behavior as referenced by the BehavioredClass, 
		//and it can be either an InputParameterSet, if the Behavior is a services.Activity (a dummy behavior)
		//with no implementation or an InputPinSet if the Behavior is a Activity with implementation. 
		//Matching of the sets is done based on index.
		}else if (owner instanceof CallOperationAction){
			
			CallOperationAction coa = (CallOperationAction)owner;
			
			Behavior behavior = findReferencedBehaviorForOperation(coa.getOperation(), (BehavioredClass)coa.getTarget().getType());
			
			if (set instanceof InputPinSet){
				List inputSets = coa.getInputPinSet();
				// find the index of the inputset
				int ind = inputSets.indexOf(set);
				if(behavior instanceof Activity){
					Action san = ((Activity)behavior).getImplementation();
					inputSets = san.getInputPinSet();
					return (InputPinSet)inputSets.get(ind);
				}else{
					return (InputParameterSet)behavior.getInputParameterSet().get(ind);
				}
			} else {
				List outputSets = coa.getOutputPinSet();
				// find the index of the inputset
				int ind = outputSets.indexOf(set);
				if(behavior instanceof Activity){
					Action san = ((Activity)behavior).getImplementation();
					outputSets = san.getOutputPinSet();
					return (OutputPinSet)outputSets.get(ind);
				}else{
					return (OutputParameterSet)behavior.getOutputParameterSet().get(ind);
				}
			}
		}
		return null;
	}	
	
	/**
	 * The named element is either an Action or an Interface of a BehavioredClass
	 * TODO changed to NamedElement to accomodate BehavioredClass and Interface
	 */
	protected ProcessInterfaceRule createProcessInterfaceRule(NamedElement namedElement){
		Activity interfaceActivity = null;
		if(namedElement instanceof StructuredActivityNode && BomUtils.isProcess((StructuredActivityNode)namedElement)
				&& FabricIntegrationUtil.getInterfaceActivityIfAny((StructuredActivityNode)namedElement) != null){
			interfaceActivity = FabricIntegrationUtil.getInterfaceActivityIfAny((StructuredActivityNode)namedElement);
		}
		if(interfaceActivity != null){
			namedElement = interfaceActivity.getImplementation();
		}
		ProcessInterfaceRule interfaceRule = (ProcessInterfaceRule)ProcessUtil.getProcessInterfaceRule(getContext(), namedElement);
		if(interfaceRule == null){
		   interfaceRule = AbstractbpelFactory.eINSTANCE.createProcessInterfaceRule();
		   interfaceRule.getSource().add(namedElement);
		   ProcessUtil.putProcessInterfaceRule(getContext(), namedElement, interfaceRule);
		   //set the context for the interfaceRule
		   TransformationRoot root = getRoot();
		   interfaceRule.setRoot(root);			
		   interfaceRule.transformSource2Target();
		   root.getChildRules().add(interfaceRule);
		}
		return interfaceRule;
	}
	
	
	/**
	 * Retrieves the target Behavior, method of the <code>operation</code> from the behaviors referenced in
	 * the <code>behavioredClass</code>.
	 * @param operation
	 * @param behavioredClass
	 * @return behavior - the target behavior
	 */
	public Behavior findReferencedBehaviorForOperation(com.ibm.btools.bom.model.services.Operation operation, BehavioredClass behavioredClass){
		LoggingUtil.traceEntry(this, "findReferencedBehaviorForOperation");
		Behavior behavior = null;
		List methods = operation.getMethod();
		List behaviors = behavioredClass.getBehavior();
		Iterator it = methods.iterator();
		while (it.hasNext()){
			Behavior temp = (Behavior)it.next();
			for(int i=0, count = behaviors.size(); i<count; i++){
				if(behaviors.get(i).equals(temp)){
					behavior = temp;
					break;
				}
			}
			if(behavior != null){
				break;
			}
		}
		LoggingUtil.traceExit(this, "findReferencedBehaviorForOperation");
		return behavior;
	}
	
	/**
	 * Returns the Activity referecned by the CallBehaviorAction, or itself, if <code>action</code>
	 * is not a CallBehaviorAction.
	 * @param action - a BOM Action if Activity
	 * @return - namedElement
	 */
	protected NamedElement findToBeProcessedAction(NamedElement action){
		
		if (action instanceof CallBehaviorAction){
		
			//Action san=action;
			NamedElement san = action;
			Behavior behavior = ((CallBehaviorAction)action).getBehavior();
		
			if (behavior instanceof Activity){
				// Set source (SAN) to ActionRule and execute it
				//HeuristicsTransformation root = (HeuristicsTransformation) getRoot();
				// Check if the referenced Process is a first class artifact (i.e. it is a participant of the solution)
				//if (root.isFirstClassArtifact(behavior))
					san = ((Activity)behavior).getImplementation();
			}
			return san;
			//TODO AR 09.10
//		} else if (action instanceof CallOperationAction){
//			
//				CallOperationAction coa = (CallOperationAction)action;
//			
//				Operation operation = coa.getOperation();
//			
//				Behavior behavior = findReferencedBehaviorForOperation(operation, (BehavioredClass)coa.getTarget().getType());
//			
//				if(behavior instanceof Activity){
//				
//					Action san = ((Activity)behavior).getImplementation();
//					return san;
//				}else{
//					return behavior;
//				}
		}else{
			return action;
		}
			
	}	

	protected String getDisplayName(Action action) {
		
//		AttributeValueProvider valueProvider = AttributeValueProviderFactory.createAttributeValueProvider(action);
//		String convertedName = (String)valueProvider.getAttributeValueForType(action, inputSet, AttributeNameConstants.TECHNICAL_DESCRIPTOR_BPEL_ACTIVITY_DISPLAY_NAME, NamingUtil.findRegistry(this));

		String name=action.getName();
		//as CBA name is kept in synch with the referenced Process name, use the CBA name
//		if (action instanceof CallBehaviorAction) {
//			if (((CallBehaviorAction)action).getBehavior() != null) {
//				name = ((CallBehaviorAction)action).getBehavior().getName();
//			}
//		}
		return name;
	}
	
	private void updateInterfaceInExistingDocument(DocumentRoot documentRoot, Action action) {
	    com.ibm.wsspi.sca.scdl.Import importDocument = documentRoot.getImport();
	    if (importDocument == null || importDocument.getInterfaceSet() == null ||
	            importDocument.getInterfaceSet().getInterfaces() == null) {		// can there be an interface set without interfaces set, and can there be more than 1 interface? 
	        return;
	    }
	    Iterator it = importDocument.getInterfaceSet().getInterfaces().iterator();
	    Interface interfaceDocument = null;
	    
	    while (it.hasNext()) {
	        interfaceDocument = (Interface)it.next();
            // operation name has to be normalized (same name as during creation), is it the operation
	        // only 1 InputSet in the Activity that represents the External Operation
	        if (interfaceDocument.getOperation(((InputPinSet)action.getInputPinSet().get(0)).getName()) == null) {
	    		String operationName = null;

	    		Operation operation = WSDLFactory.eINSTANCE.createOperation();
	    		//getTarget().add(operation);

	    		Object parentContext = getTarget().get(0);
	    		AttributeValueProvider valueProvider = AttributeValueProviderFactory.createAttributeValueProvider(AttributeNameConstants.WSDL_OPERATION_NAME);
	    		valueProvider.setContext(this.getContext());
	    		valueProvider.setInParentContext(parentContext);
	    		operationName = (String)valueProvider.getAttributeValueForType(operation, (NamedElement)getSource().get(0), AttributeNameConstants.WSDL_OPERATION_NAME, NamingUtil.findRegistry(this));
	    		operation.setName(operationName);

	    		interfaceDocument.getOperations().add(operation);
	        }
	    }
	    
	}
	
	/**
	 * Returns the <code>bpelAct<code> displayName value. 
	 * @param bpelAct a BPEL Activity that can be a BPEL Invoke
	 * @param source a NamedElement, typically an InputSet
	 * @return a BPEL Activity DisplayName.
	 */
	protected String getBPELActivityDisplayName(com.ibm.wbit.bpel.Activity bpelAct, NamedElement source){
		AttributeValueProvider valueProvider = AttributeValueProviderFactory.createAttributeValueProvider(AttributeNameConstants.BPEL_ACTIVITY_DISPLAY_NAME);
		valueProvider.setContext(getContext());
		String convertedName = (String)valueProvider.getAttributeValueForType(bpelAct, source, AttributeNameConstants.BPEL_ACTIVITY_DISPLAY_NAME, NamingUtil.findRegistry(this));
		return convertedName;
	}
	
	/**
	 * Creates a BPELP DisplayName and set the text value to <code>name</code>
	 * @param bpelAct a BPELP Activity
	 * @param name the DisplayName value.
	 */
	protected void createDisplayName(com.ibm.wbit.bpel.Activity bpelAct, String name) {
		DisplayName dspName = BPELPlusFactory.eINSTANCE.createDisplayName();
		bpelAct.getEExtensibilityElements().add(dspName);
		// d88971
		if (name != null && name.length() > 64) {
			dspName.setText(name.substring(0, 63));
		} else {
			dspName.setText(name);
		}
	}
	
	
	protected DisplayName createDisplayName(com.ibm.wbit.bpel.Activity bpelAct, NamedElement source, String propertyName) {
		DisplayName dspName = BPELPlusFactory.eINSTANCE.createDisplayName();
		
		AttributeValueProvider valueProvider = AttributeValueProviderFactory.createAttributeValueProvider(propertyName);
		valueProvider.setContext(getContext());
		String convertedName = (String)valueProvider.getAttributeValueForType(bpelAct, source, propertyName, NamingUtil.findRegistry(this));
		// d88971
		if (convertedName != null && convertedName.length() > 64) {
			convertedName = convertedName.substring(0, 63);
		}
		
		bpelAct.getEExtensibilityElements().add(dspName);
		dspName.setText(convertedName);	
		return dspName;
	}	
//	protected boolean doAssignForPartsWithTypes(NamedElement srcSet, NamedElement tarSet){
//		
//		if(srcSet.eContainer() instanceof Action && tarSet.eContainer() instanceof Action){
//			return (isWSICompliant((Action)srcSet.eContainer()) && isWSICompliant((Action)srcSet.eContainer()));			
//		}
//			return false;
//		
//	}
	
	/** 
	 * Returns true if the Action qualifies for the generation of a WSI compliant interface. This is valid in the 
	 * following cases:
	 * - always for a task, or reusable task that has specified a MB as runtime implementation
	 * - for all task that are not implemented as ICS tasks 
	 * @param action
	 * @return
	 */
	protected boolean isWSICompliant(Action action){
		return BpelOptionsUtil.isTargetWSICompliant();
//		if((BomUtils.isTask(action) || BomUtils.isReusableTask(action)) && ProcessUtil.isWBIMBImplementation(action)){
//			return true;
//		}else if (BpelOptionsUtil.isTargetWSICompliant(getContext()) && ! ((BomUtils.isTask(action) || BomUtils.isReusableTask(action)) && ProcessUtil.isICSImplementation(action))){
//			return true;
//		}else {
//			return false;
//		}
	}	
	
	protected void mapDescriptionAndDocumentation(Element bomElement,com.ibm.wbit.bpel.Activity activity) {
		// Ray: added support for descriptions and documentations	
		Description desc = AbstractbpelUtil.transformDescription(bomElement);
		if (desc!=null) {
			activity.addExtensibilityElement(desc);
		}
		Documentation doc = AbstractbpelUtil.transformDocumentation(bomElement);
		if (doc!=null) {
			activity.addExtensibilityElement(doc);
		}		
	}
	/**
	 * Create SCDL Components 
	 * @param action
	 * @param pt
	 * @return
	 */	
	protected DocumentRoot createSCDLComponent(Action action, PortType pt) {
		//we should avoid creating a component in the case an inline HumanTask is to be created for this Action. 
		//meaning the Action has ResourceRequirements of type Staff, and there is no component defined by the user.
//		if(StaffUtil.isStaffRequired(action) && !(BomUtils.isReusableService(action) || BomUtils.isReusableTask(action))){
//			String componentName = (String)TechnicalAttributesHelper.getAttributeValue(action,AttributeNameConstants.COMPONENT_NAME);
//			Object implementation = TechnicalAttributesHelper.getAttributeValue(action,AttributeNameConstants.IMPLEMENTATION);
//			//is it enough only to check for componentName and implementation? what about component DisplayName?
//			if(implementation == null){
//				return null;
//			}
//		}
		if (StaffUtil.isInlineTask(action)) {
			return null;
		}
		
		List sources = new ArrayList();
		
		CallBehaviorAction cba = FabricIntegrationUtil.getCBAForRule(this);
		boolean isOverriden = FabricIntegrationUtil.isOverriden(cba);
		
		//d144756,d85212
	if (action != null && action.getAspect() != null && !action.getAspect().equals(BOMUtil.ASPECT_SERVICE_OPERATION)) {
			sources.add(action);
		}
		sources.add(pt);		
		
		ComponentRule rule = (ComponentRule)TransformationUtil.getRuleForSource(getRoot(),ComponentRule.class,sources,DocumentRoot.class);	
		//We support global service/task, and business service
		boolean isCBAImplOverwritenSupported = FabricIntegrationUtil.isSupportedCBA(action);
		
		if(rule != null){			
				if(isCBAImplOverwritenSupported){
					if(isOverriden){
						rule = ScdlFactory.eINSTANCE.createComponentRule();
						rule.getSource().add(action);
						rule.getSource().add(pt);
						if(cba != null){
							rule.getSource().add(cba);
						}
						getChildRules().add(rule);	
						//We are using the global element's setting
					}else if(rule.getSource().size() == 3 && rule.getSource().get(2) instanceof CallBehaviorAction){
							if(FabricIntegrationUtil.getComponentRuleForCbaAction(getContext(), action) != null){
								rule = FabricIntegrationUtil.getComponentRuleForCbaAction(getContext(), action);
							}else{
								rule = ScdlFactory.eINSTANCE.createComponentRule();
								rule.getSource().add(action);
								rule.getSource().add(pt);						
								getChildRules().add(rule);
								FabricIntegrationUtil.registerComponentRuleForCbaAction(getContext(),rule, action);
							}
					}//This is the case for handling process implements an interface activity and the interface is reused inside the process
				}else if(!rule.getSource().isEmpty() && rule.getSource().get(0) instanceof StructuredActivityNode && BomUtils.isProcess((StructuredActivityNode) rule.getSource().get(0))){
					if( cba != null && cba.eContainer() instanceof StructuredActivityNode &&  cba.eContainer() == rule.getSource().get(0)){
						if(FabricIntegrationUtil.getComponentRuleForCbaAction(getContext(), action) != null){
							rule = FabricIntegrationUtil.getComponentRuleForCbaAction(getContext(), action);
						}else{
							rule = ScdlFactory.eINSTANCE.createComponentRule();
							rule.getSource().add(action);
							rule.getSource().add(pt);						
							getChildRules().add(rule);
							FabricIntegrationUtil.registerComponentRuleForCbaAction(getContext(),rule, action);
						}
					}
			   }
		}
	
		if(rule == null){
				rule = ScdlFactory.eINSTANCE.createComponentRule();
				rule.getSource().add(action);
				rule.getSource().add(pt);	
				if(cba != null && isCBAImplOverwritenSupported && isOverriden){
					rule.getSource().add(cba);
				}
				getChildRules().add(rule);
				if(!isOverriden){
					FabricIntegrationUtil.registerComponentRuleForCbaAction(getContext(),rule, action);
				}
		}
		rule.transformSource2Target();			
		return (DocumentRoot)rule.getTarget().get(0);
	}

//	/**
//	 * Create SCDL Components 
//	 * @param action
//	 * @param pt
//	 * @return
//	 */	
//	protected DocumentRoot createSCDLComponent(Action action, PortType pt) {
//		//we should avoid creating a component in the case an inline HumanTask is to be created for this Action. 
//		//meaning the Action has ResourceRequirements of type Staff, and there is no component defined by the user.
////		if(StaffUtil.isStaffRequired(action) && !(BomUtils.isReusableService(action) || BomUtils.isReusableTask(action))){
////			String componentName = (String)TechnicalAttributesHelper.getAttributeValue(action,AttributeNameConstants.COMPONENT_NAME);
////			Object implementation = TechnicalAttributesHelper.getAttributeValue(action,AttributeNameConstants.IMPLEMENTATION);
////			//is it enough only to check for componentName and implementation? what about component DisplayName?
////			if(implementation == null){
////				return null;
////			}
////		}
//		if (StaffUtil.isInlineTask(action)) {
//			return null;
//		}
//		
//		List sources = new ArrayList();
//		//d144756
//		if (action != null && action.getAspect() != null && !action.getAspect().equals(BOMUtil.ASPECT_SERVICE_OPERATION)) {
//			sources.add(action);
//		}
//		sources.add(pt);
//		ComponentRule rule = (ComponentRule)TransformationUtil.getRuleForSource(getRoot(),ComponentRule.class,sources,DocumentRoot.class);
//		if (rule==null) {
//			rule = ScdlFactory.eINSTANCE.createComponentRule();
//			rule.getSource().add(action);
//			rule.getSource().add(pt);
//			getChildRules().add(rule);
//		}
//		rule.transformSource2Target();			
//		return (DocumentRoot)rule.getTarget().get(0);
//	}
//
//
	/**
	 * Create SCDL Export 
	 * @param component
	 * @param pt
	 * @return
	 */
	protected DocumentRoot createSCDLExport(DocumentRoot component,PortType pt) {	
		List sources = new ArrayList();
		sources.add(component);
		sources.add(pt);
		ExportRule rule = (ExportRule)TransformationUtil.getRuleForSource(getRoot(),ExportRule.class,sources,DocumentRoot.class);
		if (rule==null) {
			rule = ScdlFactory.eINSTANCE.createExportRule();
			rule.getSource().add(component);
			rule.getSource().add(pt);
			getChildRules().add(rule);
			rule.transformSource2Target();			
		}
		if(rule.getTarget() != null && !rule.getTarget().isEmpty()){
			return (DocumentRoot)rule.getTarget().get(0);
		}else{
			return null;
		}
	}
	
	private List getPathAddedVariables(){
		//the actual variables on CurrentPath
		int initialSize = currentPathVariablesSnapshot.size();
		int finalSize = currentPathVariables.size();
		List addedVariables = new LinkedList();
		if(finalSize > initialSize){
			for(int j= initialSize; j< finalSize; j++){
				if(!addedVariables.contains(currentPathVariables.get(j))){
					addedVariables.add(currentPathVariables.get(j));
				}
			}
		}else{
			if(currentPathVariables != null){
				Iterator it = currentPathVariables.iterator();
				while(it.hasNext()){
					Object var = it.next();
					if(!currentPathVariablesSnapshot.contains(var) && !addedVariables.contains(var)){
						addedVariables.add(var);
					}
				}
			}
		}
		return addedVariables;
	}
	
	/**
	 * Returns he list of variables created for the concurrent branch point, starting at <code>cbSet</code>
	 * that links to the <code>mergeSet</code>. If the flag is set to false returns all the variables created for the 
	 * concurrent branch point that are not included in the first list.
	 * @param cbSet concurrent branch point, a PinSet
	 * @param mergeSet first PinSet linked from the cbPoint in the parallel branch, a PinSet
	 * @return List of BPELVariables.
	 */
	private List getVariablesForCBPoint(PinSet cbSet, PinSet mergeSet, boolean included){
		List var = new LinkedList();
		List outVar = new LinkedList();
		//List outObjectPins = os.getOutputObjectPin();
		List outObjectPins = BomUtils.getObjectPinsForSet(cbSet);
		List inputObjectPins = BomUtils.getObjectPinsForSet(mergeSet);
		BPELVariable variable = null;
		Iterator it = outObjectPins.iterator();
		while(it.hasNext()){
			ObjectPin oop = (ObjectPin)it.next();
			if(oop instanceof OutputObjectPin && oop.getOutgoing() != null && oop.getOutgoing().getTarget() instanceof ObjectPin){
				if(inputObjectPins.contains(oop.getOutgoing().getTarget())){
					variable = createVariable(oop);
					if(variable != null) var.add(variable);
				}else{
					variable = createVariable(oop);
					if(variable != null) outVar.add(variable);
				}
			}else if(oop instanceof InputObjectPin && oop.getOutgoing() != null && oop.getOutgoing().getTarget() instanceof ObjectPin){
				if(inputObjectPins.contains(oop.getOutgoing().getTarget())){
					variable = createVariable(oop);
					if(variable != null) var.add(variable);
				}else{
					variable = createVariable(oop);
					if(variable != null) outVar.add(variable);
				}
			}
		}
		if(included){
			return var;
		}else{
			return outVar;
		}
	}		
} //AbstractProcDefRuleImpl
