/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.abstractbpel.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import com.ibm.btools.te.ilm.heuristics.abstractbpel.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class AbstractbpelFactoryImpl extends EFactoryImpl implements AbstractbpelFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static AbstractbpelFactory init() {
		try {
			AbstractbpelFactory theAbstractbpelFactory = (AbstractbpelFactory)EPackage.Registry.INSTANCE.getEFactory("http:///heuristics/abstractbpel.ecore"); 
			if (theAbstractbpelFactory != null) {
				return theAbstractbpelFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new AbstractbpelFactoryImpl();
	}

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AbstractbpelFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case AbstractbpelPackage.ACTIVITY_RULE: return createActivityRule();
			case AbstractbpelPackage.SAN_REUSABLE_PROCESS_RULE: return createSANReusableProcessRule();
			case AbstractbpelPackage.SAN_NESTED_PROCESS_RULE: return createSANNestedProcessRule();
			case AbstractbpelPackage.SAN_TASK_RULE: return createSANTaskRule();
			case AbstractbpelPackage.PROCESS_RULE: return createProcessRule();
			case AbstractbpelPackage.CONTAINER_RULE: return createContainerRule();
			case AbstractbpelPackage.CALL_BEHAVIOR_ACTION_RULE: return createCallBehaviorActionRule();
			case AbstractbpelPackage.SAN_REUSABLE_TASK_RULE: return createSANReusableTaskRule();
			case AbstractbpelPackage.EXCLUSIVE_BRANCH_RULE: return createExclusiveBranchRule();
			case AbstractbpelPackage.CONCURRENT_BRANCH_RULE: return createConcurrentBranchRule();
			case AbstractbpelPackage.DECISION_RULE: return createDecisionRule();
			case AbstractbpelPackage.MERGE_RULE: return createMergeRule();
			case AbstractbpelPackage.ASSIGN_RULE: return createAssignRule();
			case AbstractbpelPackage.LINK_RULE: return createLinkRule();
			case AbstractbpelPackage.PARTNER_RULE: return createPartnerRule();
			case AbstractbpelPackage.INVOKE_RULE: return createInvokeRule();
			case AbstractbpelPackage.JOIN_RULE: return createJoinRule();
			case AbstractbpelPackage.FORK_RULE: return createForkRule();
			case AbstractbpelPackage.VARIABLE_ACCESS_RULE: return createVariableAccessRule();
			case AbstractbpelPackage.DATASTORE_ACCESS_RULE: return createDatastoreAccessRule();
			case AbstractbpelPackage.DATASTORE_RULE: return createDatastoreRule();
			case AbstractbpelPackage.VARIABLE_RULE: return createVariableRule();
			case AbstractbpelPackage.PROCESS_DEFINITION_RULE: return createProcessDefinitionRule();
			case AbstractbpelPackage.PROCESS_INTERFACE_RULE: return createProcessInterfaceRule();
			case AbstractbpelPackage.EXPRESSION_RULE: return createExpressionRule();
			case AbstractbpelPackage.STAFF_ACTIVITY_RULE: return createStaffActivityRule();
			case AbstractbpelPackage.TERMINATION_NODE_RULE: return createTerminationNodeRule();
			case AbstractbpelPackage.INPUT_VALUE_PIN_RULE: return createInputValuePinRule();
			case AbstractbpelPackage.CALL_OPERATION_ACTION_RULE: return createCallOperationActionRule();
			case AbstractbpelPackage.LOOP_NODE_RULE: return createLoopNodeRule();
			case AbstractbpelPackage.MAP_RULE: return createMapRule();
			case AbstractbpelPackage.GENERIC_ACTION_RULE: return createGenericActionRule();
			case AbstractbpelPackage.ONE_WAY_INVOKE_RULE: return createOneWayInvokeRule();
			case AbstractbpelPackage.INVOKE_WITH_CALLBACK_RULE: return createInvokeWithCallbackRule();
			case AbstractbpelPackage.BPEL_OPTIMIZATION_RULE: return createBpelOptimizationRule();
			case AbstractbpelPackage.HUMAN_TASK_RULE: return createHumanTaskRule();
			case AbstractbpelPackage.INPUT_RULE: return createInputRule();
			case AbstractbpelPackage.OUTPUT_RULE: return createOutputRule();
			case AbstractbpelPackage.BR_REUSABLE_TASK_RULE: return createBRReusableTaskRule();
			case AbstractbpelPackage.BR_TASK_RULE: return createBRTaskRule();
			case AbstractbpelPackage.HT_REUSABLE_TASK_RULE: return createHTReusableTaskRule();
			case AbstractbpelPackage.HT_TASK_RULE: return createHTTaskRule();
			case AbstractbpelPackage.FORM_RULE: return createFormRule();
			case AbstractbpelPackage.HT_BUSINESS_CALENDAR_RULE: return createHTBusinessCalendarRule();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ActivityRule createActivityRule() {
		ActivityRuleImpl activityRule = new ActivityRuleImpl();
		return activityRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SANReusableProcessRule createSANReusableProcessRule() {
		SANReusableProcessRuleImpl sanReusableProcessRule = new SANReusableProcessRuleImpl();
		return sanReusableProcessRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SANNestedProcessRule createSANNestedProcessRule() {
		SANNestedProcessRuleImpl sanNestedProcessRule = new SANNestedProcessRuleImpl();
		return sanNestedProcessRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SANTaskRule createSANTaskRule() {
		SANTaskRuleImpl sanTaskRule = new SANTaskRuleImpl();
		return sanTaskRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProcessRule createProcessRule() {
		ProcessRuleImpl processRule = new ProcessRuleImpl();
		return processRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ContainerRule createContainerRule() {
		ContainerRuleImpl containerRule = new ContainerRuleImpl();
		return containerRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallBehaviorActionRule createCallBehaviorActionRule() {
		CallBehaviorActionRuleImpl callBehaviorActionRule = new CallBehaviorActionRuleImpl();
		return callBehaviorActionRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SANReusableTaskRule createSANReusableTaskRule() {
		SANReusableTaskRuleImpl sanReusableTaskRule = new SANReusableTaskRuleImpl();
		return sanReusableTaskRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExclusiveBranchRule createExclusiveBranchRule() {
		ExclusiveBranchRuleImpl exclusiveBranchRule = new ExclusiveBranchRuleImpl();
		return exclusiveBranchRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConcurrentBranchRule createConcurrentBranchRule() {
		ConcurrentBranchRuleImpl concurrentBranchRule = new ConcurrentBranchRuleImpl();
		return concurrentBranchRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DecisionRule createDecisionRule() {
		DecisionRuleImpl decisionRule = new DecisionRuleImpl();
		return decisionRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MergeRule createMergeRule() {
		MergeRuleImpl mergeRule = new MergeRuleImpl();
		return mergeRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AssignRule createAssignRule() {
		AssignRuleImpl assignRule = new AssignRuleImpl();
		return assignRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LinkRule createLinkRule() {
		LinkRuleImpl linkRule = new LinkRuleImpl();
		return linkRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PartnerRule createPartnerRule() {
		PartnerRuleImpl partnerRule = new PartnerRuleImpl();
		return partnerRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InvokeRule createInvokeRule() {
		InvokeRuleImpl invokeRule = new InvokeRuleImpl();
		return invokeRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public JoinRule createJoinRule() {
		JoinRuleImpl joinRule = new JoinRuleImpl();
		return joinRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ForkRule createForkRule() {
		ForkRuleImpl forkRule = new ForkRuleImpl();
		return forkRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VariableAccessRule createVariableAccessRule() {
		VariableAccessRuleImpl variableAccessRule = new VariableAccessRuleImpl();
		return variableAccessRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DatastoreAccessRule createDatastoreAccessRule() {
		DatastoreAccessRuleImpl datastoreAccessRule = new DatastoreAccessRuleImpl();
		return datastoreAccessRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DatastoreRule createDatastoreRule() {
		DatastoreRuleImpl datastoreRule = new DatastoreRuleImpl();
		return datastoreRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VariableRule createVariableRule() {
		VariableRuleImpl variableRule = new VariableRuleImpl();
		return variableRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProcessDefinitionRule createProcessDefinitionRule() {
		ProcessDefinitionRuleImpl processDefinitionRule = new ProcessDefinitionRuleImpl();
		return processDefinitionRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProcessInterfaceRule createProcessInterfaceRule() {
		ProcessInterfaceRuleImpl processInterfaceRule = new ProcessInterfaceRuleImpl();
		return processInterfaceRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExpressionRule createExpressionRule() {
		ExpressionRuleImpl expressionRule = new ExpressionRuleImpl();
		return expressionRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StaffActivityRule createStaffActivityRule() {
		StaffActivityRuleImpl staffActivityRule = new StaffActivityRuleImpl();
		return staffActivityRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TerminationNodeRule createTerminationNodeRule() {
		TerminationNodeRuleImpl terminationNodeRule = new TerminationNodeRuleImpl();
		return terminationNodeRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InputValuePinRule createInputValuePinRule() {
		InputValuePinRuleImpl inputValuePinRule = new InputValuePinRuleImpl();
		return inputValuePinRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallOperationActionRule createCallOperationActionRule() {
		CallOperationActionRuleImpl callOperationActionRule = new CallOperationActionRuleImpl();
		return callOperationActionRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LoopNodeRule createLoopNodeRule() {
		LoopNodeRuleImpl loopNodeRule = new LoopNodeRuleImpl();
		return loopNodeRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MapRule createMapRule() {
		MapRuleImpl mapRule = new MapRuleImpl();
		return mapRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GenericActionRule createGenericActionRule() {
		GenericActionRuleImpl genericActionRule = new GenericActionRuleImpl();
		return genericActionRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OneWayInvokeRule createOneWayInvokeRule() {
		OneWayInvokeRuleImpl oneWayInvokeRule = new OneWayInvokeRuleImpl();
		return oneWayInvokeRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InvokeWithCallbackRule createInvokeWithCallbackRule() {
		InvokeWithCallbackRuleImpl invokeWithCallbackRule = new InvokeWithCallbackRuleImpl();
		return invokeWithCallbackRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BpelOptimizationRule createBpelOptimizationRule() {
		BpelOptimizationRuleImpl bpelOptimizationRule = new BpelOptimizationRuleImpl();
		return bpelOptimizationRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HumanTaskRule createHumanTaskRule() {
		HumanTaskRuleImpl humanTaskRule = new HumanTaskRuleImpl();
		return humanTaskRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InputRule createInputRule() {
		InputRuleImpl inputRule = new InputRuleImpl();
		return inputRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OutputRule createOutputRule() {
		OutputRuleImpl outputRule = new OutputRuleImpl();
		return outputRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BRReusableTaskRule createBRReusableTaskRule() {
		BRReusableTaskRuleImpl brReusableTaskRule = new BRReusableTaskRuleImpl();
		return brReusableTaskRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BRTaskRule createBRTaskRule() {
		BRTaskRuleImpl brTaskRule = new BRTaskRuleImpl();
		return brTaskRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HTReusableTaskRule createHTReusableTaskRule() {
		HTReusableTaskRuleImpl htReusableTaskRule = new HTReusableTaskRuleImpl();
		return htReusableTaskRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HTTaskRule createHTTaskRule() {
		HTTaskRuleImpl htTaskRule = new HTTaskRuleImpl();
		return htTaskRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FormRule createFormRule() {
		FormRuleImpl formRule = new FormRuleImpl();
		return formRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HTBusinessCalendarRule createHTBusinessCalendarRule() {
		HTBusinessCalendarRuleImpl htBusinessCalendarRule = new HTBusinessCalendarRuleImpl();
		return htBusinessCalendarRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AbstractbpelPackage getAbstractbpelPackage() {
		return (AbstractbpelPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	public static AbstractbpelPackage getPackage() {
		return AbstractbpelPackage.eINSTANCE;
	}

} //AbstractbpelFactoryImpl
