/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.abstractbpel.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import com.ibm.btools.te.framework.FrameworkPackage;

import com.ibm.btools.te.framework.impl.FrameworkPackageImpl;

import com.ibm.btools.te.ilm.heuristics.HeuristicsPackage;

import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractProcDefRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelFactory;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelPackage;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ActionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ActivityRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AssignRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.BRReusableTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.BRTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.BpelOptimizationRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.CallBehaviorActionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.CallOperationActionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ConcurrentBranchRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ConnectableRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ContainerRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.DatastoreAccessRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.DatastoreRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.DecisionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ExclusiveBranchRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ExpressionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ForkRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.FormRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.GenericActionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.HTBusinessCalendarRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.HTReusableTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.HTTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.HumanTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.InputRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.InputValuePinRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.InvokeRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.InvokeWithCallbackRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.JoinRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.LinkRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.LoopNodeRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.MapRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.MergeRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.OneWayInvokeRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.OutputRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.PartnerRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessDefinitionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessInterfaceRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessWalkingRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.SANNestedProcessRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.SANReusableProcessRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.SANReusableTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.SANTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.StaffActivityRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.TerminationNodeRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.VariableAccessRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.VariableRule;

import com.ibm.btools.te.ilm.heuristics.bpel.BpelPackage;

import com.ibm.btools.te.ilm.heuristics.bpel.impl.BpelPackageImpl;

import com.ibm.btools.te.ilm.heuristics.bpelp.BpelpPackage;

import com.ibm.btools.te.ilm.heuristics.bpelp.impl.BpelpPackageImpl;

import com.ibm.btools.te.ilm.heuristics.br.BrPackage;

import com.ibm.btools.te.ilm.heuristics.br.impl.BrPackageImpl;

import com.ibm.btools.te.ilm.heuristics.extservice.ExtservicePackage;

import com.ibm.btools.te.ilm.heuristics.extservice.impl.ExtservicePackageImpl;

import com.ibm.btools.te.ilm.heuristics.fdl.FdlPackage;

import com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl;

import com.ibm.btools.te.ilm.heuristics.impl.HeuristicsPackageImpl;

import com.ibm.btools.te.ilm.heuristics.scdl.ScdlPackage;

import com.ibm.btools.te.ilm.heuristics.scdl.impl.ScdlPackageImpl;

import com.ibm.btools.te.ilm.heuristics.wsdl.WsdlPackage;

import com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl;

import com.ibm.btools.te.ilm.heuristics.xsd.XsdPackage;

import com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EcorePackage;

import org.eclipse.emf.ecore.impl.EPackageImpl;
import org.eclipse.emf.ecore.impl.EcorePackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class AbstractbpelPackageImpl extends EPackageImpl implements AbstractbpelPackage {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass abstractProcDefRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass actionRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass activityRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sanReusableProcessRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sanNestedProcessRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sanTaskRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass processRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass containerRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass callBehaviorActionRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sanReusableTaskRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass connectableRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass processWalkingRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass exclusiveBranchRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass concurrentBranchRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass decisionRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mergeRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass assignRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass linkRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass partnerRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass invokeRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass joinRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass forkRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass variableAccessRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass datastoreAccessRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass datastoreRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass variableRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass processDefinitionRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass processInterfaceRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass expressionRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass staffActivityRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass terminationNodeRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass inputValuePinRuleEClass = null;



	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass callOperationActionRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass loopNodeRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mapRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass genericActionRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass oneWayInvokeRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass invokeWithCallbackRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bpelOptimizationRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass humanTaskRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass inputRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass outputRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass brReusableTaskRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass brTaskRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass htReusableTaskRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass htTaskRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass formRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass htBusinessCalendarRuleEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private AbstractbpelPackageImpl() {
		super(eNS_URI, AbstractbpelFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this
	 * model, and for any others upon which it depends.  Simple
	 * dependencies are satisfied by calling this method on all
	 * dependent packages before doing anything else.  This method drives
	 * initialization for interdependent packages directly, in parallel
	 * with this package, itself.
	 * <p>Of this package and its interdependencies, all packages which
	 * have not yet been registered by their URI values are first created
	 * and registered.  The packages are then initialized in two steps:
	 * meta-model objects for all of the packages are created before any
	 * are initialized, since one package's meta-model objects may refer to
	 * those of another.
	 * <p>Invocation of this method will not affect any packages that have
	 * already been initialized.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static AbstractbpelPackage init() {
		if (isInited) return (AbstractbpelPackage)EPackage.Registry.INSTANCE.getEPackage(AbstractbpelPackage.eNS_URI);

		// Obtain or create and register package
		AbstractbpelPackageImpl theAbstractbpelPackage = (AbstractbpelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof AbstractbpelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new AbstractbpelPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		EcorePackage.eINSTANCE.eClass();
		FrameworkPackage.eINSTANCE.eClass();

		// Obtain or create and register interdependencies
		HeuristicsPackageImpl theHeuristicsPackage = (HeuristicsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(HeuristicsPackage.eNS_URI) instanceof HeuristicsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(HeuristicsPackage.eNS_URI) : HeuristicsPackage.eINSTANCE);
		XsdPackageImpl theXsdPackage = (XsdPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(XsdPackage.eNS_URI) instanceof XsdPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(XsdPackage.eNS_URI) : XsdPackage.eINSTANCE);
		FdlPackageImpl theFdlPackage = (FdlPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FdlPackage.eNS_URI) instanceof FdlPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FdlPackage.eNS_URI) : FdlPackage.eINSTANCE);
		WsdlPackageImpl theWsdlPackage = (WsdlPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(WsdlPackage.eNS_URI) instanceof WsdlPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(WsdlPackage.eNS_URI) : WsdlPackage.eINSTANCE);
		BpelpPackageImpl theBpelpPackage = (BpelpPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(BpelpPackage.eNS_URI) instanceof BpelpPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(BpelpPackage.eNS_URI) : BpelpPackage.eINSTANCE);
		ScdlPackageImpl theScdlPackage = (ScdlPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ScdlPackage.eNS_URI) instanceof ScdlPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ScdlPackage.eNS_URI) : ScdlPackage.eINSTANCE);
		ExtservicePackageImpl theExtservicePackage = (ExtservicePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ExtservicePackage.eNS_URI) instanceof ExtservicePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ExtservicePackage.eNS_URI) : ExtservicePackage.eINSTANCE);
		BrPackageImpl theBrPackage = (BrPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(BrPackage.eNS_URI) instanceof BrPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(BrPackage.eNS_URI) : BrPackage.eINSTANCE);

		// Create package meta-data objects
		theAbstractbpelPackage.createPackageContents();
		theHeuristicsPackage.createPackageContents();
		theXsdPackage.createPackageContents();
		theFdlPackage.createPackageContents();
		theWsdlPackage.createPackageContents();
		theBpelpPackage.createPackageContents();
		theScdlPackage.createPackageContents();
		theExtservicePackage.createPackageContents();
		theBrPackage.createPackageContents();

		// Initialize created meta-data
		theAbstractbpelPackage.initializePackageContents();
		theHeuristicsPackage.initializePackageContents();
		theXsdPackage.initializePackageContents();
		theFdlPackage.initializePackageContents();
		theWsdlPackage.initializePackageContents();
		theBpelpPackage.initializePackageContents();
		theScdlPackage.initializePackageContents();
		theExtservicePackage.initializePackageContents();
		theBrPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theAbstractbpelPackage.freeze();

		return theAbstractbpelPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAbstractProcDefRule() {
		return abstractProcDefRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getActionRule() {
		return actionRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getActivityRule() {
		return activityRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSANReusableProcessRule() {
		return sanReusableProcessRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSANNestedProcessRule() {
		return sanNestedProcessRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSANTaskRule() {
		return sanTaskRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getProcessRule() {
		return processRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getContainerRule() {
		return containerRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCallBehaviorActionRule() {
		return callBehaviorActionRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSANReusableTaskRule() {
		return sanReusableTaskRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getConnectableRule() {
		return connectableRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getProcessWalkingRule() {
		return processWalkingRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getExclusiveBranchRule() {
		return exclusiveBranchRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getConcurrentBranchRule() {
		return concurrentBranchRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDecisionRule() {
		return decisionRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMergeRule() {
		return mergeRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAssignRule() {
		return assignRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLinkRule() {
		return linkRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPartnerRule() {
		return partnerRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInvokeRule() {
		return invokeRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getJoinRule() {
		return joinRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getForkRule() {
		return forkRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getVariableAccessRule() {
		return variableAccessRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDatastoreAccessRule() {
		return datastoreAccessRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDatastoreRule() {
		return datastoreRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getVariableRule() {
		return variableRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getProcessDefinitionRule() {
		return processDefinitionRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getProcessInterfaceRule() {
		return processInterfaceRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getExpressionRule() {
		return expressionRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStaffActivityRule() {
		return staffActivityRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTerminationNodeRule() {
		return terminationNodeRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInputValuePinRule() {
		return inputValuePinRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCallOperationActionRule() {
		return callOperationActionRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLoopNodeRule() {
		return loopNodeRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMapRule() {
		return mapRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGenericActionRule() {
		return genericActionRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getOneWayInvokeRule() {
		return oneWayInvokeRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInvokeWithCallbackRule() {
		return invokeWithCallbackRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBpelOptimizationRule() {
		return bpelOptimizationRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getHumanTaskRule() {
		return humanTaskRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInputRule() {
		return inputRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getOutputRule() {
		return outputRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBRReusableTaskRule() {
		return brReusableTaskRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBRTaskRule() {
		return brTaskRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getHTReusableTaskRule() {
		return htReusableTaskRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getHTTaskRule() {
		return htTaskRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFormRule() {
		return formRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getHTBusinessCalendarRule() {
		return htBusinessCalendarRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AbstractbpelFactory getAbstractbpelFactory() {
		return (AbstractbpelFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		abstractProcDefRuleEClass = createEClass(ABSTRACT_PROC_DEF_RULE);

		actionRuleEClass = createEClass(ACTION_RULE);

		activityRuleEClass = createEClass(ACTIVITY_RULE);

		sanReusableProcessRuleEClass = createEClass(SAN_REUSABLE_PROCESS_RULE);

		sanNestedProcessRuleEClass = createEClass(SAN_NESTED_PROCESS_RULE);

		sanTaskRuleEClass = createEClass(SAN_TASK_RULE);

		processRuleEClass = createEClass(PROCESS_RULE);

		containerRuleEClass = createEClass(CONTAINER_RULE);

		callBehaviorActionRuleEClass = createEClass(CALL_BEHAVIOR_ACTION_RULE);

		sanReusableTaskRuleEClass = createEClass(SAN_REUSABLE_TASK_RULE);

		connectableRuleEClass = createEClass(CONNECTABLE_RULE);

		processWalkingRuleEClass = createEClass(PROCESS_WALKING_RULE);

		exclusiveBranchRuleEClass = createEClass(EXCLUSIVE_BRANCH_RULE);

		concurrentBranchRuleEClass = createEClass(CONCURRENT_BRANCH_RULE);

		decisionRuleEClass = createEClass(DECISION_RULE);

		mergeRuleEClass = createEClass(MERGE_RULE);

		assignRuleEClass = createEClass(ASSIGN_RULE);

		linkRuleEClass = createEClass(LINK_RULE);

		partnerRuleEClass = createEClass(PARTNER_RULE);

		invokeRuleEClass = createEClass(INVOKE_RULE);

		joinRuleEClass = createEClass(JOIN_RULE);

		forkRuleEClass = createEClass(FORK_RULE);

		variableAccessRuleEClass = createEClass(VARIABLE_ACCESS_RULE);

		datastoreAccessRuleEClass = createEClass(DATASTORE_ACCESS_RULE);

		datastoreRuleEClass = createEClass(DATASTORE_RULE);

		variableRuleEClass = createEClass(VARIABLE_RULE);

		processDefinitionRuleEClass = createEClass(PROCESS_DEFINITION_RULE);

		processInterfaceRuleEClass = createEClass(PROCESS_INTERFACE_RULE);

		expressionRuleEClass = createEClass(EXPRESSION_RULE);

		staffActivityRuleEClass = createEClass(STAFF_ACTIVITY_RULE);

		terminationNodeRuleEClass = createEClass(TERMINATION_NODE_RULE);

		inputValuePinRuleEClass = createEClass(INPUT_VALUE_PIN_RULE);

		callOperationActionRuleEClass = createEClass(CALL_OPERATION_ACTION_RULE);

		loopNodeRuleEClass = createEClass(LOOP_NODE_RULE);

		mapRuleEClass = createEClass(MAP_RULE);

		genericActionRuleEClass = createEClass(GENERIC_ACTION_RULE);

		oneWayInvokeRuleEClass = createEClass(ONE_WAY_INVOKE_RULE);

		invokeWithCallbackRuleEClass = createEClass(INVOKE_WITH_CALLBACK_RULE);

		bpelOptimizationRuleEClass = createEClass(BPEL_OPTIMIZATION_RULE);

		humanTaskRuleEClass = createEClass(HUMAN_TASK_RULE);

		inputRuleEClass = createEClass(INPUT_RULE);

		outputRuleEClass = createEClass(OUTPUT_RULE);

		brReusableTaskRuleEClass = createEClass(BR_REUSABLE_TASK_RULE);

		brTaskRuleEClass = createEClass(BR_TASK_RULE);

		htReusableTaskRuleEClass = createEClass(HT_REUSABLE_TASK_RULE);

		htTaskRuleEClass = createEClass(HT_TASK_RULE);

		formRuleEClass = createEClass(FORM_RULE);

		htBusinessCalendarRuleEClass = createEClass(HT_BUSINESS_CALENDAR_RULE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		FrameworkPackage theFrameworkPackage = (FrameworkPackage)EPackage.Registry.INSTANCE.getEPackage(FrameworkPackage.eNS_URI);

		// Add supertypes to classes
		abstractProcDefRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());
		actionRuleEClass.getESuperTypes().add(this.getConnectableRule());
		activityRuleEClass.getESuperTypes().add(this.getAbstractProcDefRule());
		sanReusableProcessRuleEClass.getESuperTypes().add(this.getActionRule());
		sanNestedProcessRuleEClass.getESuperTypes().add(this.getConnectableRule());
		sanTaskRuleEClass.getESuperTypes().add(this.getActionRule());
		processRuleEClass.getESuperTypes().add(this.getProcessWalkingRule());
		containerRuleEClass.getESuperTypes().add(this.getAbstractProcDefRule());
		callBehaviorActionRuleEClass.getESuperTypes().add(this.getActionRule());
		sanReusableTaskRuleEClass.getESuperTypes().add(this.getActionRule());
		connectableRuleEClass.getESuperTypes().add(this.getAbstractProcDefRule());
		processWalkingRuleEClass.getESuperTypes().add(this.getConnectableRule());
		exclusiveBranchRuleEClass.getESuperTypes().add(this.getProcessWalkingRule());
		concurrentBranchRuleEClass.getESuperTypes().add(this.getProcessWalkingRule());
		decisionRuleEClass.getESuperTypes().add(this.getConnectableRule());
		mergeRuleEClass.getESuperTypes().add(this.getConnectableRule());
		assignRuleEClass.getESuperTypes().add(this.getConnectableRule());
		linkRuleEClass.getESuperTypes().add(this.getAbstractProcDefRule());
		partnerRuleEClass.getESuperTypes().add(this.getAbstractProcDefRule());
		invokeRuleEClass.getESuperTypes().add(this.getConnectableRule());
		joinRuleEClass.getESuperTypes().add(this.getConnectableRule());
		forkRuleEClass.getESuperTypes().add(this.getConnectableRule());
		variableAccessRuleEClass.getESuperTypes().add(this.getConnectableRule());
		datastoreAccessRuleEClass.getESuperTypes().add(this.getConnectableRule());
		datastoreRuleEClass.getESuperTypes().add(this.getAbstractProcDefRule());
		variableRuleEClass.getESuperTypes().add(this.getAbstractProcDefRule());
		processDefinitionRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());
		processInterfaceRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());
		expressionRuleEClass.getESuperTypes().add(this.getAbstractProcDefRule());
		staffActivityRuleEClass.getESuperTypes().add(this.getAbstractProcDefRule());
		terminationNodeRuleEClass.getESuperTypes().add(this.getConnectableRule());
		inputValuePinRuleEClass.getESuperTypes().add(this.getConnectableRule());
		callOperationActionRuleEClass.getESuperTypes().add(this.getActionRule());
		loopNodeRuleEClass.getESuperTypes().add(this.getProcessRule());
		mapRuleEClass.getESuperTypes().add(this.getConnectableRule());
		genericActionRuleEClass.getESuperTypes().add(this.getConnectableRule());
		oneWayInvokeRuleEClass.getESuperTypes().add(this.getInvokeRule());
		invokeWithCallbackRuleEClass.getESuperTypes().add(this.getOneWayInvokeRule());
		bpelOptimizationRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());
		humanTaskRuleEClass.getESuperTypes().add(this.getAbstractProcDefRule());
		inputRuleEClass.getESuperTypes().add(this.getAbstractProcDefRule());
		outputRuleEClass.getESuperTypes().add(this.getAbstractProcDefRule());
		brReusableTaskRuleEClass.getESuperTypes().add(this.getActionRule());
		brTaskRuleEClass.getESuperTypes().add(this.getActionRule());
		htReusableTaskRuleEClass.getESuperTypes().add(this.getActionRule());
		htTaskRuleEClass.getESuperTypes().add(this.getActionRule());
		formRuleEClass.getESuperTypes().add(this.getAbstractProcDefRule());
		htBusinessCalendarRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());

		// Initialize classes and features; add operations and parameters
		initEClass(abstractProcDefRuleEClass, AbstractProcDefRule.class, "AbstractProcDefRule", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(actionRuleEClass, ActionRule.class, "ActionRule", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(activityRuleEClass, ActivityRule.class, "ActivityRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(sanReusableProcessRuleEClass, SANReusableProcessRule.class, "SANReusableProcessRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(sanNestedProcessRuleEClass, SANNestedProcessRule.class, "SANNestedProcessRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(sanTaskRuleEClass, SANTaskRule.class, "SANTaskRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(processRuleEClass, ProcessRule.class, "ProcessRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(containerRuleEClass, ContainerRule.class, "ContainerRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(callBehaviorActionRuleEClass, CallBehaviorActionRule.class, "CallBehaviorActionRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(sanReusableTaskRuleEClass, SANReusableTaskRule.class, "SANReusableTaskRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(connectableRuleEClass, ConnectableRule.class, "ConnectableRule", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(processWalkingRuleEClass, ProcessWalkingRule.class, "ProcessWalkingRule", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(exclusiveBranchRuleEClass, ExclusiveBranchRule.class, "ExclusiveBranchRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(concurrentBranchRuleEClass, ConcurrentBranchRule.class, "ConcurrentBranchRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(decisionRuleEClass, DecisionRule.class, "DecisionRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mergeRuleEClass, MergeRule.class, "MergeRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(assignRuleEClass, AssignRule.class, "AssignRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(linkRuleEClass, LinkRule.class, "LinkRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(partnerRuleEClass, PartnerRule.class, "PartnerRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(invokeRuleEClass, InvokeRule.class, "InvokeRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(joinRuleEClass, JoinRule.class, "JoinRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(forkRuleEClass, ForkRule.class, "ForkRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(variableAccessRuleEClass, VariableAccessRule.class, "VariableAccessRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(datastoreAccessRuleEClass, DatastoreAccessRule.class, "DatastoreAccessRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(datastoreRuleEClass, DatastoreRule.class, "DatastoreRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(variableRuleEClass, VariableRule.class, "VariableRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(processDefinitionRuleEClass, ProcessDefinitionRule.class, "ProcessDefinitionRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(processInterfaceRuleEClass, ProcessInterfaceRule.class, "ProcessInterfaceRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(expressionRuleEClass, ExpressionRule.class, "ExpressionRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(staffActivityRuleEClass, StaffActivityRule.class, "StaffActivityRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(terminationNodeRuleEClass, TerminationNodeRule.class, "TerminationNodeRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(inputValuePinRuleEClass, InputValuePinRule.class, "InputValuePinRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(callOperationActionRuleEClass, CallOperationActionRule.class, "CallOperationActionRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(loopNodeRuleEClass, LoopNodeRule.class, "LoopNodeRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mapRuleEClass, MapRule.class, "MapRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(genericActionRuleEClass, GenericActionRule.class, "GenericActionRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(oneWayInvokeRuleEClass, OneWayInvokeRule.class, "OneWayInvokeRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(invokeWithCallbackRuleEClass, InvokeWithCallbackRule.class, "InvokeWithCallbackRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(bpelOptimizationRuleEClass, BpelOptimizationRule.class, "BpelOptimizationRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(humanTaskRuleEClass, HumanTaskRule.class, "HumanTaskRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(inputRuleEClass, InputRule.class, "InputRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(outputRuleEClass, OutputRule.class, "OutputRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(brReusableTaskRuleEClass, BRReusableTaskRule.class, "BRReusableTaskRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(brTaskRuleEClass, BRTaskRule.class, "BRTaskRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(htReusableTaskRuleEClass, HTReusableTaskRule.class, "HTReusableTaskRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(htTaskRuleEClass, HTTaskRule.class, "HTTaskRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(formRuleEClass, FormRule.class, "FormRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(htBusinessCalendarRuleEClass, HTBusinessCalendarRule.class, "HTBusinessCalendarRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
	}

} //AbstractbpelPackageImpl
