/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.abstractbpel.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.wst.wsdl.Message;
import org.eclipse.wst.wsdl.PortType;

import com.ibm.btools.bom.model.artifacts.NamedElement;
import com.ibm.btools.bom.model.processes.activities.Datastore;
import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.framework.util.TransformationUtil;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelFactory;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelPackage;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.DatastoreRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.PartnerRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessDefinitionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessInterfaceRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.util.AbstractbpelNamingRegistry;
import com.ibm.btools.te.ilm.heuristics.helper.BomUtils;
import com.ibm.btools.te.ilm.heuristics.helper.ProcessUtil;
import com.ibm.btools.te.ilm.heuristics.naming.JavaNCNameConverter;
import com.ibm.btools.te.ilm.heuristics.naming.NamingUtil;
import com.ibm.btools.te.ilm.heuristics.wsdl.PartnerLinkRule;
import com.ibm.btools.te.ilm.heuristics.wsdl.PortTypeRule;
import com.ibm.btools.te.ilm.heuristics.wsdl.WsdlFactory;
import com.ibm.wbit.bpel.BPELFactory;
import com.ibm.wbit.bpel.BPELVariable;
import com.ibm.wbit.bpel.PartnerLink;
import com.ibm.wbit.bpel.services.partnerlinktype.PartnerLinkType;

/**
 * 
 * Creates a WSDL definition (if not already been created) with a PortType
 * that represents the Datastore.  A set of pre-defined WSDL operations will
 * be created.  
 * 
 * Source: BOM Datastore
 * Target: BPEL Variable
 *
 */
public class DatastoreRuleImpl extends AbstractProcDefRuleImpl implements DatastoreRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$


	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DatastoreRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return AbstractbpelPackage.Literals.DATASTORE_RULE;
	}

//	/**
//	 * Source = Datastore
//	 * Target = WSDL definition
//	 * There will be one WSDL definition for all datastores that belong to the same namespace (BOM package)
//	 */
//	public boolean transformSource2Target() {
//		LoggingUtil.traceEntry(this, "transformSource2Target");
//		
//		//assertion
//		if (getSource() == null || getSource().isEmpty()){
// 			LoggingUtil.traceExit(this, "transformSource2Target", "no source");
//			return false;
//		}
//
//		TransformationContext context = getContext();
//		Datastore ds = (Datastore)getSource().get(0);
//		String key = ProcessUtil.createNamespace(ds);
//		Definition wsdlDef = (Definition)context.get(key);
//		if (wsdlDef == null)
//		{
//			try {
//				wsdlDef = createWSDLDefinition(ds);
//				context.put(key,wsdlDef);
//				
//			} catch (WSDLException ex) {
//				String params[]={ds.getName()};
//				LoggingUtil.logError(MessageKeys.ERROR_CREATING_WSDL_DEFINITION, params, ex);
//				BTRuntimeException runtimeEx = new BTRuntimeException(TEResourceBundleSingleton.INSTANCE.getMessage(MessageKeys.ERROR_CREATING_WSDL_DEFINITION));
//				runtimeEx.setChainedException(ex);
//				LoggingUtil.traceExit(this, "transformSource2Target", "WSDL Exception");
//				throw runtimeEx;
//			}
//		} else { // Ray (dec 15,03)
//			LoggingUtil.traceExit(this, "transformSource2Target", "WSDL definition already exists");
//			return true;
//		}
//		
//		getTarget().add(wsdlDef);
//
////Ray (dec 15,03)		QName portTypeName = new QName(wsdlDef.getTargetNamespace(), ds.getName());
//		
//		// Check if a portType for this DataStore has already been created
////Ray (dec 15/03):Don't think we need to check this because we creates a separate wsdl for a different datastore
////		if (wsdlDef.getPortType(portTypeName) == null) {
//			
//			// Create the portType
//			PortType portType = WSDLFactory.eINSTANCE.createPortType();
////			getTarget().add(portType);
//			JavaNCNameConverter converter = new JavaNCNameConverter();
//			String convertedName;		
//			convertedName = converter.convertName(NamingUtil.findRegistry(this), portType,ds.getName());
//			QName portTypeName = new QName(wsdlDef.getTargetNamespace(), convertedName);
//			portType.setQName(portTypeName);
//			wsdlDef.addPortType(portType);
//
//			// Create RetrieveArtifact operation
//			{
//				Operation retrieveArtifactOp = WSDLFactory.eINSTANCE.createOperation();
//				retrieveArtifactOp.setName(AbstractbpelConstants.RETRIEVE_ARTIFACT_DATASTORE_OPERATION_NAME);
//				portType.addOperation(retrieveArtifactOp);
//			
//				// Create Input Message
//				Message retrieveArtifactMsg = WSDLFactory.eINSTANCE.createMessage();
//				// Check to see if it's a valid name by calling NameConverter
//				convertedName = converter.convertName(NamingUtil.findRegistry(this), retrieveArtifactMsg,ds.getName()+ AbstractbpelConstants.RETRIEVE_ARTIFACT_DATASTORE_INPUT_MESSAGE_NAME);
//				
//				retrieveArtifactMsg.setQName(
//					new QName(wsdlDef.getTargetNamespace(),
//								convertedName)); 
////							  ds.getName()+ AbstractbpelConstants.RETRIEVE_ARTIFACT_DATASTORE_INPUT_MESSAGE_NAME));
//				wsdlDef.addMessage(retrieveArtifactMsg);
//				// Create the following parts:
//				// - length of type xsd:int
//				// - isRemove of type xsd:boolean
//				// - atBeginning of type xsd:boolean
//				Part lengthPart = WSDLFactory.eINSTANCE.createPart();
//				lengthPart.setName(AbstractbpelConstants.DATASTORE_LENGTH_PART_NAME);
//				lengthPart.setType(stringXSDType);
//				Part isRemovePart = WSDLFactory.eINSTANCE.createPart();
//				isRemovePart.setName(AbstractbpelConstants.DATASTORE_IS_REMOVE_PART_NAME);
//				isRemovePart.setType(booleanXSDType);
//				Part atBeginningPart = WSDLFactory.eINSTANCE.createPart();
//				atBeginningPart.setName(AbstractbpelConstants.DATASTORE_AT_BEGINNING_PART_NAME);
//				atBeginningPart.setType(booleanXSDType);
//				retrieveArtifactMsg.addPart(lengthPart);
//				retrieveArtifactMsg.addPart(isRemovePart);
//				retrieveArtifactMsg.addPart(atBeginningPart);
//			
//				// Create Output Message
//				Message retrieveArtifactOutputMsg = WSDLFactory.eINSTANCE.createMessage();
//				convertedName = converter.convertName(NamingUtil.findRegistry(this), retrieveArtifactOutputMsg,ds.getName() + AbstractbpelConstants.RETRIEVE_ARTIFACT_DATASTORE_OUTPUT_MESSAGE_NAME);
//				retrieveArtifactOutputMsg.setQName(
//					new QName(wsdlDef.getTargetNamespace(),
//							convertedName)); 
////							  ds.getName() + AbstractbpelConstants.RETRIEVE_ARTIFACT_DATASTORE_OUTPUT_MESSAGE_NAME));
//				wsdlDef.addMessage(retrieveArtifactOutputMsg);
//				// Create the following parts:
//				// - data of the type of the Datastore
//				PartRule dsPartRule = WsdlFactory.eINSTANCE.createPartRule();
//				dsPartRule.getSource().add(ds);
//				getChildRules().add(dsPartRule);
//				dsPartRule.transformSource2Target();
//				Part dsPart = (Part)dsPartRule.getTarget().get(0);
//				dsPart.setName(AbstractbpelConstants.DATASTORE_DATA_PART_NAME);
//				retrieveArtifactOutputMsg.addPart(dsPart);
//			
//				Input input = WSDLFactory.eINSTANCE.createInput();
//				input.setMessage(retrieveArtifactMsg);
//				input.setName(AbstractbpelConstants.RETRIEVE_ARTIFACT_DATASTORE_INPUT_MESSAGE_NAME);								
//				retrieveArtifactOp.setInput(input);
//				Output output = WSDLFactory.eINSTANCE.createOutput();
//				output.setMessage(retrieveArtifactOutputMsg);
//				output.setName(AbstractbpelConstants.RETRIEVE_ARTIFACT_DATASTORE_OUTPUT_MESSAGE_NAME);								
//				retrieveArtifactOp.setOutput(output);
//				
//			}
//				// Create StoreArtifact operation
//			{
//				Operation storeArtifactOp = WSDLFactory.eINSTANCE.createOperation();
//				storeArtifactOp.setName(AbstractbpelConstants.STORE_ARTIFACT_DATASTORE_OPERATION_NAME);
//				portType.addOperation(storeArtifactOp);
//			
//				// Create Input Message
//				Message storeArtifactMsg = WSDLFactory.eINSTANCE.createMessage();
//				convertedName = converter.convertName(NamingUtil.findRegistry(this), storeArtifactMsg,ds.getName()+ AbstractbpelConstants.STORE_ARTIFACT_DATASTORE_INPUT_MESSAGE_NAME);
//				storeArtifactMsg.setQName(
//					new QName(wsdlDef.getTargetNamespace(),
//							convertedName)); 
////							  ds.getName()+ AbstractbpelConstants.STORE_ARTIFACT_DATASTORE_INPUT_MESSAGE_NAME));
//				wsdlDef.addMessage(storeArtifactMsg);
//				// Create the following parts:
//				// -length of type xsd:string
//				// -data of the type of the Datastore
//				// -isInsert of type xsd:Boolean
//				// - atBeginning of type xsd:Boolean
//				// - overflow of type xsd:Boolean
//				Part lengthPart = WSDLFactory.eINSTANCE.createPart();
//				lengthPart.setName(AbstractbpelConstants.DATASTORE_LENGTH_PART_NAME);
//				lengthPart.setType(stringXSDType);
//				PartRule dsPartRule = WsdlFactory.eINSTANCE.createPartRule();
//				getChildRules().add(dsPartRule);
//				dsPartRule.getSource().add(ds);
//				dsPartRule.transformSource2Target();
//				Part dsPart = (Part)dsPartRule.getTarget().get(0);
//				dsPart.setName(AbstractbpelConstants.DATASTORE_DATA_PART_NAME);
//				Part isInsertPart = WSDLFactory.eINSTANCE.createPart();
//				isInsertPart.setName(AbstractbpelConstants.DATASTORE_IS_INSERT_PART_NAME);
//				isInsertPart.setType(booleanXSDType);
//				Part atBeginningPart = WSDLFactory.eINSTANCE.createPart();
//				atBeginningPart.setName(AbstractbpelConstants.DATASTORE_AT_BEGINNING_PART_NAME);
//				atBeginningPart.setType(booleanXSDType);
//				Part overflowPart = WSDLFactory.eINSTANCE.createPart();
//				overflowPart.setName(AbstractbpelConstants.DATASTORE_OVERFLOW_PART_NAME);
//				overflowPart.setType(booleanXSDType);
//				storeArtifactMsg.addPart(lengthPart);
//				storeArtifactMsg.addPart(dsPart);
//				storeArtifactMsg.addPart(isInsertPart);
//				storeArtifactMsg.addPart(atBeginningPart);
//				storeArtifactMsg.addPart(overflowPart);
//			
//				// Create Output Message
//				Message storeArtifactOutputMsg = WSDLFactory.eINSTANCE.createMessage();
//				convertedName = converter.convertName(NamingUtil.findRegistry(this), storeArtifactOutputMsg,ds.getName() + AbstractbpelConstants.STORE_ARTIFACT_DATASTORE_OUTPUT_MESSAGE_NAME);
//				storeArtifactOutputMsg.setQName(
//					new QName(wsdlDef.getTargetNamespace(),
//							convertedName)); 
////							  ds.getName() + AbstractbpelConstants.STORE_ARTIFACT_DATASTORE_OUTPUT_MESSAGE_NAME));
//				wsdlDef.addMessage(storeArtifactOutputMsg);
//				
//				Input input = WSDLFactory.eINSTANCE.createInput();
//				input.setMessage(storeArtifactMsg);
//				input.setName(AbstractbpelConstants.STORE_ARTIFACT_DATASTORE_INPUT_MESSAGE_NAME);								
//				storeArtifactOp.setInput(input);
//				Output output = WSDLFactory.eINSTANCE.createOutput();
//				output.setMessage(storeArtifactOutputMsg);
//				output.setName(AbstractbpelConstants.STORE_ARTIFACT_DATASTORE_OUTPUT_MESSAGE_NAME);								
//				storeArtifactOp.setOutput(output);
//			}
//
//			/* Create the PartnerLink */
//			// TODO: Ray 09Oct03 - Don't need to add PartnerLinkType to DataStore WSDL
//			// The PartnerLinkType should be in the Process' WSDL
////			PartnerLinkRule partnerLinkRule = WsdlFactory.eINSTANCE.createPartnerLinkRule();
////			partnerLinkRule.getSource().add(ds);
////			partnerLinkRule.getSource().add(portType);
////			getChildRules().add(partnerLinkRule);
////			partnerLinkRule.transformSource2Target();
////			wsdlDef.getExtensibilityElements().add(partnerLinkRule.getTarget().get(0));
////		}
//		
//		setComplete(true);
//		LoggingUtil.traceExit(this, "transformSource2Target");
//		return isComplete();
//	}

//	/**
//	* Creates a WSDL definition.
//	* TODO:  This method should be consolidated with the same method in ProcessInterfaceRule
//	* @param create
//	* @return
//	* @throws WSDLException
//	*/
//	protected Definition createWSDLDefinition(PackageableElement element)throws WSDLException {
//		WSDLDefinitionRule wsdlDefRule = WsdlFactory.eINSTANCE.createWSDLDefinitionRule();
//		getChildRules().add(wsdlDefRule);
//		wsdlDefRule.getSource().add(element);
//		wsdlDefRule.transformSource2Target();
//		return (Definition)wsdlDefRule.getTarget().get(0);
//	}
//	
	
	/**
	 * Creates a WSDL definition (if not already been created) with a PortType
	 * to represent the Datastore.  A set of pre-defined WSDL operations will
	 * be created. /set and getVariable/ 
	 * 
	 * Source: BOM Datastore
	 * Target: BPEL Variable
	 */
	public boolean transformSource2Target() {
		LoggingUtil.traceEntry(this, "transformSource2Target");
		boolean ret=false;
		Datastore repository = (Datastore)getSource().get(0);
		// Create PortType, ServiceLink, and Partner  
		ProcessInterfaceRule processIntRule = createProcessInterfaceRule(repository);
		//add the WSDL Interface temporarily as target of this rule, needed for NamingRegistration	
		getTarget().add(processIntRule.getTarget().get(0));

		if (NamingUtil.getRegistry(getContext(), repository)==null)	
			NamingUtil.putRegistry(getContext(), repository, new AbstractbpelNamingRegistry());	

		ProcessDefinitionRule processDefRule = (ProcessDefinitionRule)ProcessUtil.getProcessDefinitionRule(getContext());
		PortTypeRule portTypeRule = createPortTypeRule(processIntRule,repository);	
		PartnerLinkRule partnerLinkRule = createPartnerLinkRule(processIntRule,repository,(PortType)portTypeRule.getTarget().get(0));
		PartnerRule partnerRule = createPartnerRule(processDefRule,repository, processIntRule);
		//also create the variable for this 
		BPELVariable variable = createVariable(processDefRule, repository, processIntRule);
		//HACK HAck 
		getTarget().remove(processIntRule.getTarget().get(0));
		getTarget().add(variable);
		//getTarget().addAll(partnerRule.getTarget());
		setComplete(true);
		LoggingUtil.traceExit(this, "transformSource2Target");
		return isComplete();	
	}

	private BPELVariable createVariable(ProcessDefinitionRule processDefRule, Datastore repository, ProcessInterfaceRule processIntRule){
		Message message = getMessageForSource(repository, processIntRule);
		BPELVariable variable = createContainer(repository, message);
		processDefRule.getTarget().add(variable);
		return variable;
	}
	
	/**
	 * Returns the Message that was created for the source of this Rule. 
	 * @return WSDL Message
	 */
	private Message getMessageForSource(NamedElement srcObj, ProcessInterfaceRule processIntRule){
		Message message = null;
		if(processIntRule != null){
			TransformationRule messageRule = TransformationUtil.getRuleForSource(processIntRule,srcObj,Message.class);
			if(messageRule != null){
				message = (Message)messageRule.getTarget().get(0);	
			}
		}
		return message;
	}
	 
	
	/**
	 * Creates a new BPEL Variable. The name of the Container is based on the source name
	 * (input/outputSet)
	 */
	private BPELVariable createContainer(NamedElement srcObj, Message msg){
		BPELVariable newContainer = BPELFactory.eINSTANCE.createBPELVariable();
		JavaNCNameConverter converter = new JavaNCNameConverter();
		String convertedName = converter.convertName(NamingUtil.findRegistry(this), newContainer, BomUtils.getCanonicalName(srcObj) + "Variable");
		newContainer.setName(convertedName);
		newContainer.setMessageType(msg);
		return newContainer;
	}
	
	/**
	* Creates the interface rules. Sets the source to be the BOM Action.
	*/
	protected PortTypeRule createPortTypeRule(ProcessInterfaceRule processIntRule, Datastore repository){
		//Creates an interfaceRule and set its source to be the ActionRule source
		//(an action) and the target of the ProcessInterfaceRule
		PortTypeRule portTypeRule = 
			(PortTypeRule)TransformationUtil.getRuleForSource(processIntRule,PortTypeRule.class, repository, PortType.class);
		if (portTypeRule == null) {
			portTypeRule = WsdlFactory.eINSTANCE.createPortTypeRule();
			portTypeRule.getSource().add(repository);
			processIntRule.getChildRules().add(portTypeRule);
			processIntRule.transformSource2Target();
		}
		//just to make sure the portType is completed.. 
		if(!portTypeRule.isComplete()){
			portTypeRule.transformSource2Target();
		}
		
		return portTypeRule;

	}	
	/**
	 * Creates the PartnerLinkType for the Repository.
	 * @param processIntRule = the Repository ProcessInterfaceRule
	 * @param repository - BOM Datastore
	 * @param portType - WSDL PortType
	 * @return WSDL PartnerLinkType
	 */
	protected PartnerLinkRule createPartnerLinkRule(ProcessInterfaceRule processIntRule, Datastore repository, PortType portType)
	{	
		PartnerLinkRule partnerLinkRule = (PartnerLinkRule)
			TransformationUtil.getRuleForSource(
				processIntRule, PartnerLinkRule.class, repository, PartnerLinkType.class);
		if (partnerLinkRule == null)
		{
			partnerLinkRule = WsdlFactory.eINSTANCE.createPartnerLinkRule();
			partnerLinkRule.getSource().add(repository);
			partnerLinkRule.getSource().add(portType);
			processIntRule.getChildRules().add(partnerLinkRule);
			processIntRule.transformSource2Target();
		}
		return partnerLinkRule;
	}
	
	/**
	 * Create the Partner for this Repository
	 * @param processDefRule ProcessDefinitionRule of the calling Process
	 * @param action BOM Datastore
	 * @param processIntRule Repository ProcessInterfaceRule
	 * @return BPEL Partner
	 */
	protected PartnerRule createPartnerRule(ProcessDefinitionRule processDefRule, Datastore action, ProcessInterfaceRule processIntRule)
	{	
		PartnerRule partnerRule = (PartnerRule)
			TransformationUtil.getRuleForSource(
				processDefRule, PartnerRule.class, action, PartnerLink.class);
		if (partnerRule == null)
		{
			partnerRule = AbstractbpelFactory.eINSTANCE.createPartnerRule();
			partnerRule.getSource().add(action);
			partnerRule.getSource().add(processIntRule);
			processDefRule.getChildRules().add(partnerRule);
			partnerRule.transformSource2Target();
		}
		return partnerRule;
	}

} //DatastoreRuleImpl
