/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.abstractbpel.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.wst.wsdl.Part;
import org.eclipse.xsd.XSDComplexTypeDefinition;
import org.eclipse.xsd.XSDElementDeclaration;
import org.eclipse.xsd.XSDModelGroup;
import org.eclipse.xsd.XSDParticle;
import org.eclipse.xsd.XSDSimpleTypeDefinition;
import org.eclipse.xsd.XSDTypeDefinition;

import com.ibm.btools.bom.model.artifacts.Comment;
import com.ibm.btools.bom.model.artifacts.MultiplicityElement;
import com.ibm.btools.bom.model.artifacts.Property;
import com.ibm.btools.bom.model.artifacts.Type;
import com.ibm.btools.bom.model.artifacts.TypedElement;
import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.bom.model.processes.activities.Activity;
import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.bom.model.processes.activities.ObjectPin;
import com.ibm.btools.bom.model.processes.activities.OutputPinSet;
import com.ibm.btools.bom.model.processes.activities.Pin;
import com.ibm.btools.bom.model.processes.activities.PinSet;
import com.ibm.btools.bom.model.processes.activities.Variable;
import com.ibm.btools.expression.function.CoreFunctions;
import com.ibm.btools.expression.model.BinaryOperatorExpression;
import com.ibm.btools.expression.model.Expression;
import com.ibm.btools.expression.model.FunctionArgument;
import com.ibm.btools.expression.model.FunctionDefinition;
import com.ibm.btools.expression.model.FunctionExpression;
import com.ibm.btools.expression.model.LiteralExpression;
import com.ibm.btools.expression.model.ModelFactory;
import com.ibm.btools.expression.model.ModelPathExpression;
import com.ibm.btools.expression.model.ReferenceStep;
import com.ibm.btools.expression.model.StaticStep;
import com.ibm.btools.expression.model.Step;
import com.ibm.btools.expression.model.StringLiteralExpression;
import com.ibm.btools.expression.model.UnaryOperatorExpression;
import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.framework.util.TransformationUtil;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelPackage;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ContainerRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.DecisionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ExpressionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.LoopNodeRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.VariableRule;
import com.ibm.btools.te.ilm.heuristics.bpelp.util.JavaConstants;
import com.ibm.btools.te.ilm.heuristics.helper.BomUtils;
import com.ibm.btools.te.ilm.heuristics.helper.BpelOptionsUtil;
import com.ibm.btools.te.ilm.heuristics.helper.ProcessUtil;
import com.ibm.btools.te.ilm.heuristics.wsdl.PartRule;
import com.ibm.btools.te.ilm.heuristics.xsd.PropertyRule;
import com.ibm.btools.te.ilm.heuristics.xsd.util.DataDefinitionUtil;
import com.ibm.btools.te.ilm.resource.MessageKeys;
import com.ibm.wbit.bpel.BPELVariable;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Expression Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class ExpressionRuleImpl extends AbstractProcDefRuleImpl implements ExpressionRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	
	private boolean fFirstTimeRunning = true;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExpressionRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return AbstractbpelPackage.Literals.EXPRESSION_RULE;
	}

//	/**
//	 * source = An Expression Model in the BOM context
//	 * target = An Expression Model in the BPEL context
//	 * 
//	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target()
//	 */
//	public boolean transformSource2Target() {
//		LoggingUtil.traceEntry(this, "transformSource2Target");
//		
//		Expression exprModelTarget = null;
//		//assertion
//		if (getSource() == null || getSource().isEmpty()) {
//			LoggingUtil.traceExit(this, "transformSource2Target", "no source");
//			return false;			
//		}
//		
//		if (!fFirstTimeRunning){
//			LoggingUtil.traceExit(this, "transformSource2Target", "already executed");			
//			return true;
//		} 
//		
//		fFirstTimeRunning = false;
//		Expression exprSource = (Expression)EcoreUtil.copy((Expression)getSource().get(0));
//		
//		exprModelTarget = mapToBPELExpressionModel(exprSource);	
//	
//		//save target
//		if (exprModelTarget != null)
//			getTarget().add(exprModelTarget);
//		else
//			LoggingUtil.logWarning(MessageKeys.INVALID_INPUT_BOM_EXPRESSION);								
//		setComplete(true);
//		LoggingUtil.traceExit(this, "transformSource2Target");
//		return isComplete();
//	}
//
//	/**
//	 * Maps to a BPEL Expression from and Expression Model Source in the BOM context
//	 * @param exprModelSrce - a Expression in the BOM context
//	 * @return Expression - A Expression in the BPEL context
//	 */	
//	private Expression mapToBPELExpressionModel(Expression exprModelSrce)
//	{
//		//top level expressions for DecisionoutputConditions
//		if (exprModelSrce instanceof UnaryOperatorExpression)
//			return mapUnaryOperatorExpression((UnaryOperatorExpression)exprModelSrce);
//		else if (exprModelSrce instanceof FunctionExpression)
//			return mapFunctionExpression((FunctionExpression)exprModelSrce);
//		else if (exprModelSrce instanceof BinaryOperatorExpression)
//			return mapBinaryOperatorExpression((BinaryOperatorExpression)exprModelSrce);
//		else if (exprModelSrce instanceof LiteralExpression)
//			return mapLiteralExpression((LiteralExpression)exprModelSrce);
//		else if (exprModelSrce instanceof ModelPathExpression)
//		{
//			// TODO Check to see if paths are absolute		
//			return mapModelPathExpression((ModelPathExpression)exprModelSrce);
//		}			
//		else
//			return null;
//	}
//
//
//	/**
//	 * Maps to a Literal Expression in the BPEL context.	 
//	 * @param exprSouce - a LiteralExpression in the BOM context
//	 * @return LiteralExpression - A LiteralExpression in the BPEL context
//	 */	
//	private LiteralExpression mapLiteralExpression(LiteralExpression exprSource)
//	{
//		return exprSource;
//	}
//
//	/**
//	 * Maps to a UnaryOperatorExpression in the BPEL context.	 
//	 * @param exprSouce - a UnaryOperatorExpression in the BOM context
//	 * @return UnaryOperatorExpression - A UnaryOperatorExpression in the BPEL context
//	 */	
//	private UnaryOperatorExpression mapUnaryOperatorExpression(UnaryOperatorExpression exprSource)
//	{		
//		Expression expr = exprSource.getExpression();		
//		exprSource.setExpression(mapToBPELExpressionModel(expr));
//		return exprSource;
//	}
//
//	/**
//	 * Maps to a mapBinaryOperatorExpression in the BPEL context.	 
//	 * @param exprSouce - a mapBinaryOperatorExpression in the BOM context
//	 * @return mapBinaryOperatorExpression - A mapBinaryOperatorExpression in the BPEL context
//	 */	
//	private BinaryOperatorExpression mapBinaryOperatorExpression(BinaryOperatorExpression exprSource)
//	{		
//		Expression operand1 = exprSource.getFirstOperand();
//		Expression operand2 = exprSource.getSecondOperand();
//		exprSource.setFirstOperand(mapToBPELExpressionModel(operand1));
//		exprSource.setSecondOperand(mapToBPELExpressionModel(operand2));
//		return exprSource;
//	}
//	
//	/**
//	 * Maps to a FunctionExpression in the BPEL context.	 
//	 * @param exprSouce - a FunctionExpression in the BOM context
//	 * @return FunctionExpression - A FunctionExpression in the BPEL context
//	 */	
//	private FunctionExpression mapFunctionExpression(FunctionExpression exprSource)
//	{
//		FunctionExpression functionExpr = ModelFactory.eINSTANCE.createFunctionExpression();
//		FunctionDefinition def = ModelFactory.eINSTANCE.createFunctionDefinition();
//		def.setFunctionID("com.ibm.btools.te.ilm.heuristics.abstractbpel.getVariableData");
//		
//		if ( (exprSource.getDefinition().getFunctionID().equals(CoreFunctions.SUM_FUNCTION)) 
//			||  (exprSource.getDefinition().getFunctionID().equals(CoreFunctions.SIZE_FUNCTION)) )
//		{			
//			return mapSumSizeExpr(exprSource);
//		}
//		else if ( (exprSource.getDefinition().getFunctionID().equals(CoreFunctions.STARTS_WITH_FUNCTION))
//		||  (exprSource.getDefinition().getFunctionID().equals(CoreFunctions.CONTAINS_FUNCTION)) )
//		{			
//			return mapContainsStartsWith(exprSource);
//		}
//		else if( (exprSource.getDefinition().getFunctionID().equals(CoreFunctions.EXISTS_FUNCTION))
//		||  (exprSource.getDefinition().getFunctionID().equals(CoreFunctions.FOR_ALL_FUNCTION )))
//		{
//			return mapExistsForAllExpr(exprSource);
//		}
//		else if(exprSource.getDefinition().getFunctionID().equals(CoreFunctions.SELECT_FUNCTION))
//		{
//			return mapSelectExpr(exprSource);
//		}
//		else if (exprSource.getDefinition().getFunctionID().equals(CoreFunctions.GET_ALL_FUNCTION))
//		{
//			return mapGetAllExpr(exprSource);
//		}
//		return functionExpr;
//	}
//
//	/**
//	 * Maps from a ModelPathExpression to an Expression in the BPEL context.	 
//	 * @param exprSouce - a ModelPathExpression in the BOM context
//	 * @return Expression - An Expression in the BPEL context
//	 */		
//	private Expression mapModelPathExpression(ModelPathExpression exprSource)
//	{
//		EList stepsList;
//				
//		// TODO: Check if ModelPathExpression is absolute
//		if (exprSource.getIsAbsolute()!=null && exprSource.getIsAbsolute().equals(Boolean.TRUE))
//		{
//			stepsList = exprSource.getSteps();
//			if(stepsList != null && !stepsList.isEmpty()){
//				if (stepsList.get(0) instanceof ReferenceStep) 
//					return mapReferenceStep(stepsList);
//				else /* If MPE is composed of all Static steps, maps to an identical MPE */		
//					return exprSource;
//			}
//		}
//		return null;
//	}
//
//	/**
//	 * Maps steps of the ModelPathExpression to a bpws:getVariableData in BPEL	 
//	 * @param stepsList - a list of steps in the ModelPathExpression
//	 * @return FunctionExpression - A bpws:getVariableData FunctionExpression in the BPEL context
//	 */		
//	private FunctionExpression mapReferenceStep(EList stepsList)
//	{				
//		//Iterator stepIt = stepsList.iterator();	
//		FunctionExpression functionExpr = ModelFactory.eINSTANCE.createFunctionExpression();
//		FunctionDefinition def = ModelFactory.eINSTANCE.createFunctionDefinition();
//		def.setFunctionID("com.ibm.btools.te.ilm.heuristics.abstractbpel.getVariableData");
//		def.setFunctionName("bpws:getVariableData");
//		
//		FunctionArgument arg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
//		StringLiteralExpression strExpr1 = ModelFactory.eINSTANCE.createStringLiteralExpression();
//		FunctionArgument arg2 = ModelFactory.eINSTANCE.createFunctionArgument();			
//		StringLiteralExpression strExpr2 = ModelFactory.eINSTANCE.createStringLiteralExpression();
//		String partName = "";
//		String variableName = "";
//		Step tempStep;
//		List tempStepsList = new LinkedList();
//		
//		FunctionArgument arg3 = ModelFactory.eINSTANCE.createFunctionArgument();		
//		ModelPathExpression mpeExpr = ModelFactory.eINSTANCE.createModelPathExpression();
//		StaticStep partNameStep = ModelFactory.eINSTANCE.createStaticStep();
//
//		// Ray added: Attempt to fix count function in Java problem (only need for loop if upperbound of item is > 1)
//		Part partRepresentingBomElement=null;
//		TypedElement bomElementRepresentedByPart = null ;
//		
//		boolean isFirstStep = true;				
//		for (int i=0; i<stepsList.size(); i++)
//		{			
//			tempStep = (Step)stepsList.get(i);
//			if ((tempStep instanceof ReferenceStep) && (((ReferenceStep)tempStep).getReferencedObject() instanceof Variable))
//			{
//				bomElementRepresentedByPart = (TypedElement)((ReferenceStep)tempStep).getReferencedObject();
//				//Call Variable Rule to find the string name for 2nd argument	
//				com.ibm.wbit.bpel.BPELVariable destVar = (com.ibm.wbit.bpel.BPELVariable)TransformationUtil.getRuleForSource(ProcessUtil.getProcessDefinitionRule
//			    							(getContext()),ContainerRule.class,((ReferenceStep)tempStep).getReferencedObject()).getTarget().get(0);
//			    variableName = destVar.getName();
//			    
//			    Iterator it = destVar.getMessageType().getParts().values().iterator();
//				partRepresentingBomElement = (Part)it.next(); 
//			    
//			    partName = partRepresentingBomElement.getName();
//			    			
//				//partName = "partName";
//				//strExpr1.setStringSymbol( tempStep.getReferenceName() );
//				//strExpr1.setStringSymbol("variableName");
//				strExpr1.setStringSymbol(variableName);
//				strExpr2.setStringSymbol(partName);	
//				
//				//AR
//				
//				if(BpelOptionsUtil.isTargetWSICompliant()){
//				//if is not wsi compliant we have another step in between... 
//					//position of Pin in PinSet 
//					if (isFirstStep){
//						partNameStep.setStepName(partName);
//						tempStepsList.add(partNameStep);
//						int index = 0;
//						XSDTypeDefinition complexTypeDefinitionForTheBOMElement = partRepresentingBomElement.getElement().getTypeDefinition();
//						XSDParticle xsdElement = (XSDParticle)((XSDModelGroup)complexTypeDefinitionForTheBOMElement.getComplexType().getContent()).getContents().get(index);	
//						ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
//						itemStep.setReferencedObject(xsdElement);
//						tempStepsList.add(itemStep);
//						isFirstStep=false;	
//					}
//				}
//			}
//			else if (   (tempStep instanceof ReferenceStep) 
//						&& ( ( ((ReferenceStep)tempStep).getReferencedObject() instanceof InputPinSet ) 
//						|| ( ((ReferenceStep)tempStep).getReferencedObject() instanceof OutputPinSet ) ))
//			{	
//				//Call Container Rule to find the string name for 2nd argument 
//				com.ibm.wbit.bpel.BPELVariable destVar = (com.ibm.wbit.bpel.BPELVariable)TransformationUtil.getRuleForSource(ProcessUtil.getProcessDefinitionRule
//											(getContext()),ContainerRule.class,((ReferenceStep)tempStep).getReferencedObject()).getTarget().get(0);
//				String varName = destVar.getName();
//				strExpr1.setStringSymbol(varName);				
//				//strExpr1.setStringSymbol( ((ReferenceStep)tempStep).getReferenceName() );
//				//strExpr1.setStringSymbol("PinSetName");											
//			}
//			else if ((tempStep instanceof ReferenceStep) && (((ReferenceStep)tempStep).getReferencedObject() instanceof Pin) )
//			{
//				// Ray: MPE may not have pinset in the path ....
//				PinSet pinSet = findPinSetForPin((Pin)((ReferenceStep)tempStep).getReferencedObject());
//				if (strExpr1.getStringSymbol()==null) {
//					//handle this case .... see findPinSetForPin function at the end
//					//PinSet pinSet = findPinSetForPin((Pin)((ReferenceStep)tempStep).getReferencedObject());
//					com.ibm.wbit.bpel.BPELVariable destVar = (com.ibm.wbit.bpel.BPELVariable)TransformationUtil.getRuleForSource(ProcessUtil.getProcessDefinitionRule
//												(getContext()),ContainerRule.class,pinSet).getTarget().get(0);
//					String varName = destVar.getName();
//					strExpr1.setStringSymbol(varName);				
//				}
//				//Call Part Rule to find the string name for 2nd argument 
//				bomElementRepresentedByPart = (TypedElement)((ReferenceStep)tempStep).getReferencedObject();
//				//Ray commented:Part destPart = (Part)TransformationUtil.getRuleForSource(ProcessUtil.getProcessInterfaceRule
//				//Ray added:
//				//TODO AR WSI and non WSI compliant support
//				Action action = null;
//				if(bomElementRepresentedByPart instanceof InputObjectPin){
//					action =((InputObjectPin) bomElementRepresentedByPart).getAction();
//				}else if(bomElementRepresentedByPart instanceof OutputObjectPin){
//					action =((OutputObjectPin) bomElementRepresentedByPart).getAction();
//				}
////				PartRule partRule = null;
////				partRule = (PartRule)TransformationUtil.getRuleForSource(ProcessUtil.getProcessInterfaceRule
////										(getContext()),PartRule.class,((ReferenceStep)tempStep).getReferencedObject());
////					
////				partRepresentingBomElement = (Part)partRule.getTarget().get(0);
////				partName = partRepresentingBomElement.getName(); 
////				//partName = "pinPartName";
////				strExpr2.setStringSymbol(partName);	
//
////				//TODO what else????
//				PartRule partRule = null;
//				if(!isWSICompliant(action)){
//					partRule = (PartRule)TransformationUtil.getRuleForSource(ProcessUtil.getProcessInterfaceRule
//											(getContext()),PartRule.class,((ReferenceStep)tempStep).getReferencedObject());
//					
//					
//				}else{
//										 
//					partRule = (PartRule)TransformationUtil.getRuleForSource(ProcessUtil.getProcessInterfaceRule
//											(getContext()),PartRule.class, pinSet);
//					
//				}
//				
//				
////				PartRule partRule = (PartRule)TransformationUtil.getRuleForSource(ProcessUtil.getProcessInterfaceRule
////										(getContext()),PartRule.class,((ReferenceStep)tempStep).getReferencedObject());
////										
////********										
//										
////				TransformationRule partRule1 = (TransformationRule)TransformationUtil.getRuleForSource(ProcessUtil.getProcessInterfaceRule
////														(getContext()),((ReferenceStep)tempStep).getReferencedObject());
//				partRepresentingBomElement = (Part)partRule.getTarget().get(0);
//				partName = partRepresentingBomElement.getName(); 
//				//partName = "pinPartName";
//				strExpr2.setStringSymbol(partName);	
//				//**** added AR
//				if(isWSICompliant(action)){
//				//if is not wsi compliant we have another step in between... 
//					//position of Pin in PinSet 
//					if (isFirstStep){
//						partNameStep.setStepName(partName);
//						tempStepsList.add(partNameStep);
//						
//						int index = 0;
//						List pins;
//						if(pinSet instanceof InputPinSet){
//							pins = ((InputPinSet)pinSet).getInputObjectPin();
//							index = pins.indexOf(bomElementRepresentedByPart);
//						}else if(pinSet instanceof OutputPinSet){
//							pins = ((OutputPinSet)pinSet).getOutputObjectPin();
//							index = pins.indexOf(bomElementRepresentedByPart);
//							
//						}
//						XSDTypeDefinition complexTypeDefinitionForTheBOMElement = partRepresentingBomElement.getElement().getTypeDefinition();
//					
//						XSDParticle xsdElement = (XSDParticle)((XSDModelGroup)complexTypeDefinitionForTheBOMElement.getComplexType().getContent()).getContents().get(index);	
//						ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
//						itemStep.setReferencedObject(xsdElement);
//						tempStepsList.add(itemStep);
//					}
//					//isFirstStep=false;	
//				}
//				
//				
//				//*****8	
//			}			
//			else if ((tempStep instanceof ReferenceStep) && (((ReferenceStep)tempStep).getReferencedObject() instanceof Property) )
//			{
//				if (isFirstStep){
//					partNameStep.setStepName(partName);
//					tempStepsList.add(partNameStep);
//					
//					//TypedElement typedElement = (TypedElement)partRule.getSource().get(0);
//					if (bomElementRepresentedByPart instanceof MultiplicityElement) {
//						if (BomUtils.isMultipled((MultiplicityElement)bomElementRepresentedByPart)) {
//							// if the typedElement has upperbound > 1, that means a List wrapper
//							// must have been created for the Pin
//							//Part part = (Part)partRule.getTarget().get(0);
//							XSDTypeDefinition typeDef = partRepresentingBomElement.getEXSDType();						
//							XSDParticle xsdElement = (XSDParticle)((XSDModelGroup)typeDef.getComplexType().getContent()).getContents().get(0);
//							ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
//							itemStep.setReferencedObject(xsdElement);
//							tempStepsList.add(itemStep);
//						}
//					}
//					//Create a new static step to store the business item			
////					StaticStep itemStep = ModelFactory.eINSTANCE.createStaticStep();				
////					itemStep.setStepName( ((ReferenceStep)tempStep).getReferenceName());					
////					tempStepsList.add(itemStep);
//					isFirstStep=false;								
//				}
////				else {			
////					StaticStep itemStep = ModelFactory.eINSTANCE.createStaticStep();
////					itemStep.setStepName( ((ReferenceStep)tempStep).getReferenceName());					
////					tempStepsList.add(itemStep);								
////				}	
//				XSDParticle xsdElement = findXSDParticle((Property)((ReferenceStep)tempStep).getReferencedObject());
//				ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
//				itemStep.setReferencedObject(xsdElement);
//				tempStepsList.add(itemStep);
//			}
//			else if (tempStep instanceof StaticStep)
//			{
//				if (isFirstStep){
//					partNameStep.setStepName(partName);
//					tempStepsList.add(partNameStep);
//					tempStepsList.add(tempStep);
//					isFirstStep=false;								
//				}
//				else {
//					tempStepsList.add(tempStep);								
//				}				
//			}							
//		}	
//		arg1.setArgumentValue(strExpr1);	
//		arg2.setArgumentValue(strExpr2);
//		def.setFunctionName("bpws:getVariableData");	
//		functionExpr.setDefinition(def);		
//		functionExpr.getArguments().add(arg1);
//		functionExpr.getArguments().add(arg2);
//		if (tempStepsList.size()>0) {
//			mpeExpr.getSteps().addAll(tempStepsList);
//			mpeExpr.setIsAbsolute(Boolean.TRUE);
//			arg3.setArgumentValue(mpeExpr);	
//			functionExpr.getArguments().add(arg3);
//		}
//		return functionExpr;
//	}
//
//	/**
//	 * Maps the sum and count Function Expressions from BOM to BPEL context.	 
//	 * @param exprSouce - a sum or count FunctionExpression in the BOM context
//	 * @return FunctionExpression - A FunctionExpression in the BPEL context
//	 */		
//	private FunctionExpression mapSumSizeExpr(FunctionExpression exprSource)
//	{		
//		FunctionExpression functionExpr;
//		/* If the argument is a ModelPathExpression */
//		FunctionArgument fcnArg = (FunctionArgument)exprSource.getArguments().get(0);
//		if (fcnArg.getArgumentValue() instanceof ModelPathExpression)
//		{				
//			// TODO Make sure the MPE is absolute!!!
//			EList stepsList;
//			stepsList = ( (ModelPathExpression)fcnArg.getArgumentValue()).getSteps();
//			functionExpr = mapReferenceStep(stepsList);
//		
//			/* Re-Composing the third argument */
//			ModelPathExpression mpeExpr = null;
//			if (functionExpr.getArguments().size()>2) {
//				fcnArg = (FunctionArgument)functionExpr.getArguments().get(2);
//				mpeExpr = (ModelPathExpression)fcnArg.getArgumentValue();
//			} else {
//				mpeExpr = createPartStepOnlyMPE(stepsList);
//			}
//		
//			FunctionExpression argFunctionExpr = ModelFactory.eINSTANCE.createFunctionExpression();
//			FunctionDefinition argDef = ModelFactory.eINSTANCE.createFunctionDefinition();
//			argDef.setFunctionID(exprSource.getDefinition().getFunctionID());
//			argDef.setFunctionName(exprSource.getDefinition().getFunctionName());
//			FunctionArgument funcArg1 = ModelFactory.eINSTANCE.createFunctionArgument();
//			
//			argFunctionExpr.setDefinition(argDef);		
//			funcArg1.setArgumentValue(mpeExpr);
//			argFunctionExpr.getArguments().add(funcArg1);	
//		
//			FunctionArgument funcArg2 = ModelFactory.eINSTANCE.createFunctionArgument();
//			funcArg2.setArgumentValue(argFunctionExpr);
//			functionExpr.getArguments().add(2, funcArg2);
//			return functionExpr;
//		}		
//		/* If the argument is a getAll function expression */
//		else if (fcnArg.getArgumentValue() instanceof FunctionExpression 
//				&& ((FunctionExpression)fcnArg.getArgumentValue()).getDefinition().getFunctionID().equals(CoreFunctions.GET_ALL_FUNCTION))
//		{
//			// TODO Make sure the MPE is absolute!!!
//			EList stepsList;
//			Expression thisExpr = ((FunctionArgument)((FunctionExpression)fcnArg.getArgumentValue()).getArguments().get(0)).getArgumentValue();
//			if (thisExpr instanceof ModelPathExpression)
//				stepsList = ((ModelPathExpression)thisExpr).getSteps();
//			else
//				return null;			
//			functionExpr = mapReferenceStep(stepsList);
//	 	
//			/* Re-Composing the third argument */	
//			ModelPathExpression mpeExpr = (ModelPathExpression)((FunctionArgument)functionExpr.getArguments().get(2)).getArgumentValue();
//	    
//			FunctionExpression argFunctionExpr = ModelFactory.eINSTANCE.createFunctionExpression();	
//			FunctionDefinition argDef = ModelFactory.eINSTANCE.createFunctionDefinition();
//						
//			argDef.setFunctionID(exprSource.getDefinition().getFunctionID());
//			argDef.setFunctionName(exprSource.getDefinition().getFunctionName());
//			argFunctionExpr.setDefinition(argDef);
//			FunctionArgument funcArg1 = ModelFactory.eINSTANCE.createFunctionArgument();
//	 
//			FunctionExpression getAllFunc = ModelFactory.eINSTANCE.createFunctionExpression();
//			FunctionDefinition getAllDef = ModelFactory.eINSTANCE.createFunctionDefinition();			
//			getAllDef.setFunctionID(CoreFunctions.GET_ALL_FUNCTION);
//					
//			FunctionArgument getAllArg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
//			
//			getAllArg1.setArgumentValue(mpeExpr);
//			getAllFunc.setDefinition(getAllDef);
//			getAllFunc.getArguments().add(getAllArg1);
//				 
//			funcArg1.setArgumentValue(getAllFunc);
//			argFunctionExpr.getArguments().add(funcArg1);
//			FunctionArgument funcArg2 = ModelFactory.eINSTANCE.createFunctionArgument();
//			funcArg2.setArgumentValue(argFunctionExpr);	
//			functionExpr.getArguments().add(2, funcArg2);
//		
//			return functionExpr;			
//		}
//		/* If the argument is a select function expression */
//		else if (fcnArg.getArgumentValue() instanceof FunctionExpression 
//				&& ((FunctionExpression)fcnArg.getArgumentValue()).getDefinition().getFunctionID().equals(CoreFunctions.SELECT_FUNCTION))
//		{
//			boolean isGetAllExpr = false;
//			// TODO Make sure the MPE is absolute!!!
//			EList stepsList;
//			Expression thisExpr = ((FunctionArgument)((FunctionExpression)fcnArg.getArgumentValue()).getArguments().get(0)).getArgumentValue();
//			if (thisExpr instanceof ModelPathExpression)
//				stepsList = ((ModelPathExpression)thisExpr).getSteps();
//			else{
//				//getall function
//				isGetAllExpr = true;
//				stepsList = ((ModelPathExpression)((FunctionArgument)((FunctionExpression)thisExpr).getArguments().get(0)).getArgumentValue()).getSteps();
//			}			
//			functionExpr = mapReferenceStep(stepsList);
//	 	
//			/* Re-Composing the third argument */	
//			ModelPathExpression mpeExpr = (ModelPathExpression)((FunctionArgument)functionExpr.getArguments().get(2)).getArgumentValue();
//	    
//			FunctionExpression argFunctionExpr = ModelFactory.eINSTANCE.createFunctionExpression();	
//			FunctionDefinition argDef = ModelFactory.eINSTANCE.createFunctionDefinition();
//			argDef.setFunctionID(exprSource.getDefinition().getFunctionID());
//			argDef.setFunctionName(exprSource.getDefinition().getFunctionName());
//			argFunctionExpr.setDefinition(argDef);
//			FunctionArgument funcArg1 = ModelFactory.eINSTANCE.createFunctionArgument();
//	 
//			/* The argument to the argFunctionExpr is a select */
//			FunctionExpression selectFunc = ModelFactory.eINSTANCE.createFunctionExpression();
//			FunctionDefinition selectDef = ModelFactory.eINSTANCE.createFunctionDefinition();			
//			selectDef.setFunctionID(CoreFunctions.SELECT_FUNCTION);
//					
//			FunctionArgument selectArg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
//			FunctionArgument selectArg2 = ModelFactory.eINSTANCE.createFunctionArgument();		
//	 	
//	 		if (!isGetAllExpr)
//				selectArg1.setArgumentValue(mpeExpr);
//			else{
//				FunctionExpression getAllFunc = ModelFactory.eINSTANCE.createFunctionExpression();
//				FunctionDefinition getAllDef = ModelFactory.eINSTANCE.createFunctionDefinition();			
//				getAllDef.setFunctionID(CoreFunctions.GET_ALL_FUNCTION);
//					
//				FunctionArgument getAllArg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
//			
//				getAllArg1.setArgumentValue(mpeExpr);
//				getAllFunc.setDefinition(getAllDef);
//				getAllFunc.getArguments().add(getAllArg1);
//				selectArg1.setArgumentValue(getAllFunc);				
//			}	
//			
//			
//			FunctionExpression tempExpr = (FunctionExpression)((FunctionArgument)exprSource.getArguments().get(0)).getArgumentValue();
//			selectArg2.setArgumentValue(mapCriteria( ((FunctionArgument)tempExpr.getArguments().get(1)).getArgumentValue() ));
//
//			selectFunc.setDefinition(selectDef);
//			selectFunc.getArguments().add(selectArg1);
//			selectFunc.getArguments().add(selectArg2);		 
//			funcArg1.setArgumentValue(selectFunc);
//			argFunctionExpr.getArguments().add(funcArg1);
//			FunctionArgument funcArg2 = ModelFactory.eINSTANCE.createFunctionArgument();
//			funcArg2.setArgumentValue(argFunctionExpr);	
//			functionExpr.getArguments().add(2, funcArg2);
//		
//			return functionExpr;
//		}
//		return null;
//	}
//
//	/**
//	 * Maps the exists and for-all Function Expressions from BOM to BPEL context.	 
//	 * @param exprSouce - a exists or for-all Function Expression in the BOM context
//	 * @return FunctionExpression - A FunctionExpression in the BPEL context
//	 */	
//	private FunctionExpression mapExistsForAllExpr(FunctionExpression exprSource)
//	{
//		FunctionExpression functionExpr;
//		// TODO Make sure the MPE is absolute!!!
//		FunctionArgument fcnArg = (FunctionArgument)exprSource.getArguments().get(0);
//		if (fcnArg.getArgumentValue() instanceof ModelPathExpression)
//		{		
//			// TODO Make sure the MPE is absolute!!!
//			EList stepsList;
//			stepsList = ( (ModelPathExpression)fcnArg.getArgumentValue()).getSteps();
//			/* Returns a bpws:GetVariableData */
//			functionExpr = mapReferenceStep(stepsList);
//		
//			/* Re-Composing the third argument */	
//			ModelPathExpression mpeExpr = (ModelPathExpression)((FunctionArgument)functionExpr.getArguments().get(2)).getArgumentValue();
//		
//			FunctionExpression argFunctionExpr = ModelFactory.eINSTANCE.createFunctionExpression();
//			FunctionDefinition argDef = ModelFactory.eINSTANCE.createFunctionDefinition();
//			argDef.setFunctionID(exprSource.getDefinition().getFunctionID());
//			argDef.setFunctionName(exprSource.getDefinition().getFunctionName());
//			FunctionArgument funcArg1 = ModelFactory.eINSTANCE.createFunctionArgument();
//			FunctionArgument funcArg2 = ModelFactory.eINSTANCE.createFunctionArgument();
//					
//			argFunctionExpr.setDefinition(argDef);		
//			funcArg1.setArgumentValue(mpeExpr);
//			funcArg2.setArgumentValue(mapCriteria(((FunctionArgument)exprSource.getArguments().get(1)).getArgumentValue() ));
//			argFunctionExpr.getArguments().add(funcArg1);	
//			argFunctionExpr.getArguments().add(funcArg2);
//			FunctionArgument funcArg3 = ModelFactory.eINSTANCE.createFunctionArgument();
//			funcArg3.setArgumentValue(argFunctionExpr);		
//			functionExpr.getArguments().add(2, funcArg3);
//			return functionExpr;
//		}		
//		/* If the argument is a select function expression */
//		else if (fcnArg.getArgumentValue()  instanceof FunctionExpression 
//				&& ((FunctionExpression)fcnArg.getArgumentValue() ).getDefinition().getFunctionID().equals(CoreFunctions.GET_ALL_FUNCTION))
//		{
//			// TODO Make sure the MPE is absolute!!!
//			EList stepsList;
//			stepsList = ((ModelPathExpression)((FunctionArgument)((FunctionExpression)fcnArg.getArgumentValue()).getArguments().get(0)).getArgumentValue()).getSteps();
//			functionExpr = mapReferenceStep(stepsList);
//	 	
//			/* Re-Composing the third argument */	
//			ModelPathExpression mpeExpr = (ModelPathExpression)((FunctionArgument)functionExpr.getArguments().get(2)).getArgumentValue();
//	    
//			FunctionExpression argFunctionExpr = ModelFactory.eINSTANCE.createFunctionExpression();	
//			FunctionDefinition argDef = ModelFactory.eINSTANCE.createFunctionDefinition();
//						
//			argDef.setFunctionID(exprSource.getDefinition().getFunctionID());
//			argDef.setFunctionName(exprSource.getDefinition().getFunctionName());
//			argFunctionExpr.setDefinition(argDef);
//			FunctionArgument funcArg1 = ModelFactory.eINSTANCE.createFunctionArgument();
//	 
//			/* The argument to the argFunctionExpr is a select */
//			FunctionExpression getAllFunc = ModelFactory.eINSTANCE.createFunctionExpression();
//			FunctionDefinition getAllDef = ModelFactory.eINSTANCE.createFunctionDefinition();			
//			getAllDef.setFunctionID(CoreFunctions.GET_ALL_FUNCTION);
//					
//			FunctionArgument getAllArg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
//			FunctionArgument funcArg2 = ModelFactory.eINSTANCE.createFunctionArgument();
//			
//			getAllArg1.setArgumentValue(mpeExpr);
//			getAllFunc.setDefinition(getAllDef);
//			getAllFunc.getArguments().add(getAllArg1);
//				 
//			funcArg1.setArgumentValue(getAllFunc);
//			funcArg2.setArgumentValue(mapCriteria(((FunctionArgument)exprSource.getArguments().get(1)).getArgumentValue() ));
//			argFunctionExpr.getArguments().add(funcArg1);
//			argFunctionExpr.getArguments().add(funcArg2);
//			FunctionArgument funcArg3 = ModelFactory.eINSTANCE.createFunctionArgument();
//			funcArg3.setArgumentValue(argFunctionExpr);	
//			functionExpr.getArguments().add(2, funcArg3);
//		
//			return functionExpr;			
//		}
//		/* If the argument is a select function expression */
//		else if (fcnArg.getArgumentValue()  instanceof FunctionExpression 
//				&& ((FunctionExpression)fcnArg.getArgumentValue() ).getDefinition().getFunctionID().equals(CoreFunctions.SELECT_FUNCTION))
//		{
//			boolean isGetAllExpr = false;
//			// TODO Make sure the MPE is absolute!!!
//			EList stepsList;
//			Expression thisExpr = ((FunctionArgument)((FunctionExpression)fcnArg.getArgumentValue()).getArguments().get(0)).getArgumentValue();
//			if (thisExpr instanceof ModelPathExpression)
//				stepsList = ((ModelPathExpression)thisExpr).getSteps();
//			else{
//				//getall function
//				isGetAllExpr = true;
//				stepsList = ((ModelPathExpression)((FunctionArgument)((FunctionExpression)thisExpr).getArguments().get(0)).getArgumentValue()).getSteps();
//			} 
//			
//			//stepsList = ((ModelPathExpression) ((FunctionArgument)((FunctionExpression)fcnArg.getArgumentValue()).getArguments().get(0)).getArgumentValue()).getSteps();
//			functionExpr = mapReferenceStep(stepsList);
//	 	
//			/* Re-Composing the third argument */	
//			ModelPathExpression mpeExpr = (ModelPathExpression)((FunctionArgument)functionExpr.getArguments().get(2)).getArgumentValue();
//	    
//			FunctionExpression argFunctionExpr = ModelFactory.eINSTANCE.createFunctionExpression();	
//			FunctionDefinition argDef = ModelFactory.eINSTANCE.createFunctionDefinition();
//			argDef.setFunctionID(exprSource.getDefinition().getFunctionID());
//			argDef.setFunctionName(exprSource.getDefinition().getFunctionName());
//			argFunctionExpr.setDefinition(argDef);
//			FunctionArgument funcArg1 = ModelFactory.eINSTANCE.createFunctionArgument();
//			FunctionArgument funcArg2 = ModelFactory.eINSTANCE.createFunctionArgument();
//	 
//			/* The argument to the argFunctionExpr is a select */
//			FunctionExpression selectFunc = ModelFactory.eINSTANCE.createFunctionExpression();
//			FunctionDefinition selectDef = ModelFactory.eINSTANCE.createFunctionDefinition();
//			selectDef.setFunctionID(CoreFunctions.SELECT_FUNCTION);
//		
//			FunctionArgument selectArg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
//			FunctionArgument selectArg2 = ModelFactory.eINSTANCE.createFunctionArgument();		
//	 	
//			//selectArg1.setArgumentValue(mpeExpr);
//			if (!isGetAllExpr)
//				selectArg1.setArgumentValue(mpeExpr);
//			else{
//				FunctionExpression getAllFunc = ModelFactory.eINSTANCE.createFunctionExpression();
//				FunctionDefinition getAllDef = ModelFactory.eINSTANCE.createFunctionDefinition();			
//				getAllDef.setFunctionID(CoreFunctions.GET_ALL_FUNCTION);
//					
//				FunctionArgument getAllArg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
//			
//				getAllArg1.setArgumentValue(mpeExpr);
//				getAllFunc.setDefinition(getAllDef);
//				getAllFunc.getArguments().add(getAllArg1);
//				selectArg1.setArgumentValue(getAllFunc);				
//			}
//			
//			selectArg2.setArgumentValue(mapCriteria(((FunctionArgument)((FunctionExpression)fcnArg.getArgumentValue()).getArguments().get(1)).getArgumentValue() ));
//			selectFunc.setDefinition(selectDef);
//			selectFunc.getArguments().add(selectArg1);			
//			selectFunc.getArguments().add(selectArg2);
//		 
//			argFunctionExpr.setDefinition(argDef);		 
//			funcArg1.setArgumentValue(selectFunc);
//			funcArg2.setArgumentValue(mapBinaryOperatorExpression(
//												(BinaryOperatorExpression)((FunctionArgument)exprSource.getArguments().get(1)).getArgumentValue() ));
//			argFunctionExpr.getArguments().add(funcArg1);	
//			argFunctionExpr.getArguments().add(funcArg2);	
//			FunctionArgument funcArg3 = ModelFactory.eINSTANCE.createFunctionArgument();
//			funcArg3.setArgumentValue(argFunctionExpr);		
//			functionExpr.getArguments().add(2, funcArg3);
//		
//			return functionExpr;
//		}
//		return null;
//	}
//
//	/**
//	 * Maps the contains and starts with Function Expressions from BOM to BPEL context.	 
//	 * @param exprSouce - a contains or starts with Function Expression in the BOM context
//	 * @return FunctionExpression - A FunctionExpression in the BPEL context
//	 */		
//	private FunctionExpression mapContainsStartsWith(FunctionExpression exprSource)
//	{
//		//If the two arguments are both StringLiteral - identical mapping
//		FunctionArgument arg1 = (FunctionArgument)exprSource.getArguments().get(0);
//		FunctionArgument arg2 = (FunctionArgument)exprSource.getArguments().get(1);
//		if ( (arg1.getArgumentValue() instanceof StringLiteralExpression) && (arg2.getArgumentValue() instanceof StringLiteralExpression) )
//			return exprSource;
//		FunctionExpression functionExpr;
//		FunctionArgument fcnArg;
//		//Map if First and SEcond are MPEs, they must be in the same container
//		if ( (arg1.getArgumentValue() instanceof ModelPathExpression) && (arg2.getArgumentValue() instanceof ModelPathExpression) )
//		{
//			EList stepsList;
//			stepsList = ( (ModelPathExpression)arg2.getArgumentValue()).getSteps();
//			/* Returns a bpws:GetVariableData */
//			functionExpr = mapReferenceStep(stepsList);
//			fcnArg = (FunctionArgument)functionExpr.getArguments().get(2);
//			ModelPathExpression mpeExpr0 = (ModelPathExpression)fcnArg.getArgumentValue();
//			stepsList = ( (ModelPathExpression)arg1.getArgumentValue()).getSteps();
//			/* Returns a bpws:GetVariableData */
//			functionExpr = mapReferenceStep(stepsList);
//			
//			/* Re-Composing the third argument */
//			fcnArg = (FunctionArgument)functionExpr.getArguments().get(2);
//			ModelPathExpression mpeExpr = (ModelPathExpression)fcnArg.getArgumentValue();
//
//			FunctionExpression argFunctionExpr = ModelFactory.eINSTANCE.createFunctionExpression();
//			FunctionDefinition argDef = ModelFactory.eINSTANCE.createFunctionDefinition();
//			argDef.setFunctionID(exprSource.getDefinition().getFunctionID());
//			argDef.setFunctionName(exprSource.getDefinition().getFunctionName());
//			FunctionArgument funcArg1 = ModelFactory.eINSTANCE.createFunctionArgument();
//			FunctionArgument secondArg = ModelFactory.eINSTANCE.createFunctionArgument();
//			argFunctionExpr.setDefinition(argDef);		
//			funcArg1.setArgumentValue(mpeExpr);
//			secondArg.setArgumentValue(mpeExpr0);
//			argFunctionExpr.getArguments().add(funcArg1);
//			argFunctionExpr.getArguments().add(secondArg);	
//
//			FunctionArgument funcArg2 = ModelFactory.eINSTANCE.createFunctionArgument();
//			funcArg2.setArgumentValue(argFunctionExpr);
//			functionExpr.getArguments().add(2, funcArg2);
//		}		
//		//Map if First Argument is MPE
//		else if (arg1.getArgumentValue() instanceof ModelPathExpression)
//		{
//			EList stepsList;
//			stepsList = ( (ModelPathExpression)arg1.getArgumentValue()).getSteps();
//			/* Returns a bpws:GetVariableData */
//			functionExpr = mapReferenceStep(stepsList);
//			/* Re-Composing the third argument */
//			fcnArg = (FunctionArgument)functionExpr.getArguments().get(2);
//			ModelPathExpression mpeExpr = (ModelPathExpression)fcnArg.getArgumentValue();
//
//			FunctionExpression argFunctionExpr = ModelFactory.eINSTANCE.createFunctionExpression();
//			FunctionDefinition argDef = ModelFactory.eINSTANCE.createFunctionDefinition();
//			argDef.setFunctionID(exprSource.getDefinition().getFunctionID());
//			argDef.setFunctionName(exprSource.getDefinition().getFunctionName());
//			FunctionArgument funcArg1 = ModelFactory.eINSTANCE.createFunctionArgument();
//			FunctionArgument strArg = ModelFactory.eINSTANCE.createFunctionArgument();
//			argFunctionExpr.setDefinition(argDef);		
//			funcArg1.setArgumentValue(mpeExpr);
//			strArg.setArgumentValue((StringLiteralExpression)arg2.getArgumentValue());
//			argFunctionExpr.getArguments().add(funcArg1);
//			argFunctionExpr.getArguments().add(strArg);	
//
//			FunctionArgument funcArg2 = ModelFactory.eINSTANCE.createFunctionArgument();
//			funcArg2.setArgumentValue(argFunctionExpr);
//			functionExpr.getArguments().add(2, funcArg2);
//		}		
//		//Map if Second Argument is MPE
//		else
//		{
//			EList stepsList;
//			stepsList = ( (ModelPathExpression)arg2.getArgumentValue()).getSteps();
//			/* Returns a bpws:GetVariableData */
//			functionExpr = mapReferenceStep(stepsList);
//			/* Re-Composing the third argument */
//			fcnArg = (FunctionArgument)functionExpr.getArguments().get(2);
//			ModelPathExpression mpeExpr = (ModelPathExpression)fcnArg.getArgumentValue();
//
//			FunctionExpression argFunctionExpr = ModelFactory.eINSTANCE.createFunctionExpression();
//			FunctionDefinition argDef = ModelFactory.eINSTANCE.createFunctionDefinition();
//			argDef.setFunctionID(exprSource.getDefinition().getFunctionID());
//			argDef.setFunctionName(exprSource.getDefinition().getFunctionName());
//			FunctionArgument funcArg1 = ModelFactory.eINSTANCE.createFunctionArgument();
//			FunctionArgument strArg = ModelFactory.eINSTANCE.createFunctionArgument();
//			argFunctionExpr.setDefinition(argDef);		
//			funcArg1.setArgumentValue(mpeExpr);
//			strArg.setArgumentValue((StringLiteralExpression)arg1.getArgumentValue());			
//			argFunctionExpr.getArguments().add(strArg);	
//			argFunctionExpr.getArguments().add(funcArg1);
//
//			FunctionArgument funcArg2 = ModelFactory.eINSTANCE.createFunctionArgument();
//			funcArg2.setArgumentValue(argFunctionExpr);
//			functionExpr.getArguments().add(2, funcArg2);
//		}
//		
//		return functionExpr;
//	}
//
//	/**
//	 * Maps the select Function Expression to a Function Expression in the BPEL context.	 
//	 * @param exprSouce - a select Function Expression in the BOM context
//	 * @return FunctionExpression - A FunctionExpression in the BPEL context
//	 */		
//	private FunctionExpression mapSelectExpr(FunctionExpression exprSource)
//	{
//		/* NOTE: Nested select function expressions are not supported */
//		FunctionExpression functionExpr;
//		EList stepsList;
//		boolean isGetAllFunction = false;
//		if (((FunctionArgument)exprSource.getArguments().get(0)).getArgumentValue() instanceof ModelPathExpression){
//			stepsList = ((ModelPathExpression)((FunctionArgument)exprSource.getArguments().get(0)).getArgumentValue()).getSteps();
//		}else if (((FunctionArgument)exprSource.getArguments().get(0)).getArgumentValue() instanceof FunctionExpression &&
//					((FunctionExpression)((FunctionArgument)exprSource.getArguments().get(0)).getArgumentValue()).getDefinition().getFunctionID().equals(CoreFunctions.GET_ALL_FUNCTION)){
//			//get the argument from getall Function	
//			FunctionExpression getAllFunction = ModelFactory.eINSTANCE.createFunctionExpression();
//			getAllFunction = (FunctionExpression)((FunctionArgument)exprSource.getArguments().get(0)).getArgumentValue();
//			//get the argument, should be mpe	
//			stepsList = ((ModelPathExpression)((FunctionArgument)getAllFunction.getArguments().get(0)).getArgumentValue()).getSteps();
//			isGetAllFunction = true;	
//		}else{
//			return null;
//		}
//				
//		functionExpr = mapReferenceStep(stepsList);
//	
//		/* Re-Composing the third argument */	
//		ModelPathExpression mpeExpr = (ModelPathExpression)((FunctionArgument)functionExpr.getArguments().get(2)).getArgumentValue();
//
//		FunctionExpression selectFunc = ModelFactory.eINSTANCE.createFunctionExpression();
//		FunctionDefinition selectDef = ModelFactory.eINSTANCE.createFunctionDefinition();
//		selectDef.setFunctionID(CoreFunctions.SELECT_FUNCTION);
//		selectFunc.setDefinition(selectDef);
//
//		FunctionArgument selectArg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
//		FunctionArgument selectArg2 = ModelFactory.eINSTANCE.createFunctionArgument();		
//
//		if (!isGetAllFunction){
//			selectArg1.setArgumentValue(mpeExpr);
//		}else{
//			//create a getAllfunction
//			FunctionExpression getallFunc = ModelFactory.eINSTANCE.createFunctionExpression();
//			FunctionDefinition getallDef = ModelFactory.eINSTANCE.createFunctionDefinition();
//			getallDef.setFunctionID(CoreFunctions.GET_ALL_FUNCTION);
//			getallFunc.setDefinition(getallDef);
//	
//			FunctionArgument getallArg1 = ModelFactory.eINSTANCE.createFunctionArgument();	
//			getallArg1.setArgumentValue(mpeExpr);
//			getallFunc.getArguments().add(getallArg1);
//			selectArg1.setArgumentValue(getallFunc);
//		}
//		
//		//FunctionExpression tempExpr = (FunctionExpression)((FunctionArgument)exprSource.getArguments().get(0)).getArgumentValue();
//				
//		selectArg2.setArgumentValue(mapCriteria(((FunctionArgument)exprSource.getArguments().get(1)).getArgumentValue()));
//		selectFunc.getArguments().add(selectArg1);
//		selectFunc.getArguments().add(selectArg2); 
//		FunctionArgument funcArg3 = ModelFactory.eINSTANCE.createFunctionArgument();
//		funcArg3.setArgumentValue(selectFunc);	
//	
//		functionExpr.getArguments().add(2, funcArg3);
//
//		return functionExpr;
//	}
//	
//	private FunctionExpression mapGetAllExpr(FunctionExpression exprSource)
//	{
//		FunctionExpression functionExpr = null;
//		//TODO argument is ALWAYS a modelpathexpression
//		//map to a getVariableData - the third argument is a getall function
//		
//		return functionExpr;
//	}
//
//	/**
//	 * Maps to the criteria expression	 
//	 * @param criteria - a criteria expression in the BOM context
//	 * @return Expression - An Expression in the BPEL context
//	 */	
//	private Expression mapCriteria (Expression criteria)
//	{
//		
//		if (criteria instanceof BinaryOperatorExpression)
//			return mapBinaryOperatorExpression((BinaryOperatorExpression)criteria);
//		else if (criteria instanceof UnaryOperatorExpression)
//			return mapUnaryOperatorExpression((UnaryOperatorExpression)criteria);
//		else if (criteria instanceof FunctionExpression)
//			return mapFunctionExpression((FunctionExpression)criteria);
//		else if (criteria instanceof ModelPathExpression)
//			return mapModelPathExpression((ModelPathExpression)criteria);
//		else if (criteria instanceof LiteralExpression)
//			return mapLiteralExpression((LiteralExpression)criteria);
//		else
//			return null;				
//	
//	}
//
//	private XSDParticle findXSDParticle(Property prop) {
//		return (XSDParticle)TransformationUtil.getRuleForSource(getRoot(),PropertyRule.class,prop).getTarget().get(0);
//	}
//
//	private ModelPathExpression createPartStepOnlyMPE(List stepsList) {
//		boolean isFirstStep = true;	
//		Step tempStep;	
//		List tempStepsList = new LinkedList();				
//		for (int i=0; i<stepsList.size(); i++)
//		{			
//			tempStep = (Step)stepsList.get(i);
//			if ((tempStep instanceof ReferenceStep) && (((ReferenceStep)tempStep).getReferencedObject() instanceof Pin) )
//			{
//				StaticStep partNameStep = ModelFactory.eINSTANCE.createStaticStep();
//				PartRule partRule = (PartRule)TransformationUtil.getRuleForSource(ProcessUtil.getProcessInterfaceRule
//										(getContext()),PartRule.class,((ReferenceStep)tempStep).getReferencedObject());
//				Part destPart = (Part)partRule.getTarget().get(0);
//				String partName = destPart.getName(); 
//
//				partNameStep.setStepName(partName);
//				tempStepsList.add(partNameStep);
//						
//				TypedElement typedElement = (TypedElement)partRule.getSource().get(0);
//				if (typedElement instanceof MultiplicityElement) {
//					if (BomUtils.isMultipled((MultiplicityElement)typedElement)) {
//						// if the typedElement has upperbound > 1, that means a List wrapper
//						// must have been created for the Pin
//						Part part = (Part)partRule.getTarget().get(0);
//						XSDTypeDefinition typeDef = part.getEXSDType();						
//						XSDParticle xsdElement = (XSDParticle)((XSDModelGroup)typeDef.getComplexType().getContent()).getContents().get(0);
//						ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
//						itemStep.setReferencedObject(xsdElement);
//						tempStepsList.add(itemStep);
//					}
//				}
//			}
//		}	
//		ModelPathExpression mpeExpr = ModelFactory.eINSTANCE.createModelPathExpression();
//		mpeExpr.getSteps().addAll(tempStepsList);
//		mpeExpr.setIsAbsolute(Boolean.TRUE);
//		return mpeExpr;	
//	}
//	
//	/**
//	 * This method attempts to find the first pinSet (input or output) that contains a Pin.  Notice a pin can never appear
//	 * in both input and output pinset.
//	 * @param pin
//	 * @return
//	 */
//	private PinSet findPinSetForPin(Pin pin) {
//		Action action = (Action)pin.eContainer();
//		Iterator it = action.getInputPinSet().iterator();
//		InputPinSet inPinSet;
//		while (it.hasNext()) {
//			inPinSet = (InputPinSet)it.next();
//			// it can never be control pin
//			if (inPinSet.getInputObjectPin().contains(pin)) {
//				return inPinSet;
//			}
//			
//		}
//		it = action.getOutputPinSet().iterator();
//		OutputPinSet outPinSet;
//		while (it.hasNext()) {
//			outPinSet = (OutputPinSet)it.next();
//			// it can never be control pin
//			if (outPinSet.getOutputObjectPin().contains(pin)) {
//				return outPinSet;
//			}
//		}
//		return null;  // This should never happened!!
//	}
	
	
	/**
	 * source = An Expression Model in the BOM context
	 * target = An Expression Model in the BPEL context
	 * 
	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target()
	 */
	public boolean transformSource2Target() {
		LoggingUtil.traceEntry(this, "transformSource2Target");
		
		Expression exprModelTarget = null;
		//assertion
		if (getSource() == null || getSource().isEmpty()) {
			LoggingUtil.traceExit(this, "transformSource2Target", "no source");
			return false;			
		}
		
		if (!fFirstTimeRunning){
			LoggingUtil.traceExit(this, "transformSource2Target", "already executed");			
			return true;
		} 
		
		fFirstTimeRunning = false;
		Expression exprSource = (Expression)EcoreUtil.copy((Expression)getSource().get(0));
		
		exprModelTarget = mapToBPELExpressionModel(exprSource);	
	
		//save target
		if (exprModelTarget != null)
			getTarget().add(exprModelTarget);
		else
			LoggingUtil.logWarning(MessageKeys.INVALID_INPUT_BOM_EXPRESSION);								
		setComplete(true);
		LoggingUtil.traceExit(this, "transformSource2Target");
		executeHandlers();
		return isComplete();
	}

	/**
	 * Maps to a BPEL Expression from and Expression Model Source in the BOM context
	 * @param exprModelSrce - a Expression in the BOM context
	 * @return Expression - A Expression in the BPEL context
	 */	
	private Expression mapToBPELExpressionModel(Expression exprModelSrce)
	{
		//top level expressions for DecisionoutputConditions
		if (exprModelSrce instanceof UnaryOperatorExpression)
			return mapUnaryOperatorExpression((UnaryOperatorExpression)exprModelSrce);
		else if (exprModelSrce instanceof FunctionExpression)
			return mapFunctionExpression((FunctionExpression)exprModelSrce);
		else if (exprModelSrce instanceof BinaryOperatorExpression)
			return mapBinaryOperatorExpression((BinaryOperatorExpression)exprModelSrce);
		else if (exprModelSrce instanceof LiteralExpression)
			return mapLiteralExpression((LiteralExpression)exprModelSrce);
		else if (exprModelSrce instanceof ModelPathExpression)
		{
			// TODO Check to see if paths are absolute		
			return mapModelPathExpression((ModelPathExpression)exprModelSrce);
		}			
		else
			return null;
	}


	/**
	 * Maps to a Literal Expression in the BPEL context.	 
	 * @param exprSouce - a LiteralExpression in the BOM context
	 * @return LiteralExpression - A LiteralExpression in the BPEL context
	 */	
	private LiteralExpression mapLiteralExpression(LiteralExpression exprSource)
	{
		return exprSource;
	}

	/**
	 * Maps to a UnaryOperatorExpression in the BPEL context.	 
	 * @param exprSouce - a UnaryOperatorExpression in the BOM context
	 * @return UnaryOperatorExpression - A UnaryOperatorExpression in the BPEL context
	 */	
	private UnaryOperatorExpression mapUnaryOperatorExpression(UnaryOperatorExpression exprSource)
	{		
		Expression expr = exprSource.getExpression();		
		exprSource.setExpression(mapToBPELExpressionModel(expr));
		return exprSource;
	}

	/**
	 * Maps to a mapBinaryOperatorExpression in the BPEL context.	 
	 * @param exprSouce - a mapBinaryOperatorExpression in the BOM context
	 * @return mapBinaryOperatorExpression - A mapBinaryOperatorExpression in the BPEL context
	 */	
	private BinaryOperatorExpression mapBinaryOperatorExpression(BinaryOperatorExpression exprSource)
	{		
		Expression operand1 = exprSource.getFirstOperand();
		Expression operand2 = exprSource.getSecondOperand();
		exprSource.setFirstOperand(mapToBPELExpressionModel(operand1));
		exprSource.setSecondOperand(mapToBPELExpressionModel(operand2));
		return exprSource;
	}
	
	/**
	 * Maps to a FunctionExpression in the BPEL context.	 
	 * @param exprSouce - a FunctionExpression in the BOM context
	 * @return FunctionExpression - A FunctionExpression in the BPEL context
	 */	
	private FunctionExpression mapFunctionExpression(FunctionExpression exprSource)
	{
		FunctionExpression functionExpr = ModelFactory.eINSTANCE.createFunctionExpression();
		FunctionDefinition def = ModelFactory.eINSTANCE.createFunctionDefinition();
		def.setFunctionID("com.ibm.btools.te.ilm.heuristics.abstractbpel.getVariableData");
		
		if ( (exprSource.getDefinition().getFunctionID().equals(CoreFunctions.SUM_FUNCTION)) 
			||  (exprSource.getDefinition().getFunctionID().equals(CoreFunctions.SIZE_FUNCTION)) )
		{			
			return mapSumSizeExpr(exprSource);
		}
		else if ( (exprSource.getDefinition().getFunctionID().equals(CoreFunctions.STARTS_WITH_FUNCTION))
		||  (exprSource.getDefinition().getFunctionID().equals(CoreFunctions.CONTAINS_FUNCTION)) )
		{			
			return mapContainsStartsWith(exprSource);
		}
		else if( (exprSource.getDefinition().getFunctionID().equals(CoreFunctions.EXISTS_FUNCTION))
		||  (exprSource.getDefinition().getFunctionID().equals(CoreFunctions.FOR_ALL_FUNCTION )))
		{
			return mapExistsForAllExpr(exprSource);
		}
		else if(exprSource.getDefinition().getFunctionID().equals(CoreFunctions.SELECT_FUNCTION))
		{
			return mapSelectExpr(exprSource);
		}
		else if (exprSource.getDefinition().getFunctionID().equals(CoreFunctions.GET_ALL_FUNCTION))
		{
			String activityName= getOwnerActionName();
			String [] params = new String []{activityName};
			LoggingUtil.logError(MessageKeys.ERROR_GET_ALL_EXPRESSION, params, null);
			return mapGetAllExpr(exprSource);
		}
		return functionExpr;
	}

	/**
	 * Maps from a ModelPathExpression to an Expression in the BPEL context.	 
	 * @param exprSouce - a ModelPathExpression in the BOM context
	 * @return Expression - An Expression in the BPEL context
	 */		
	private Expression mapModelPathExpression(ModelPathExpression exprSource)
	{
		EList stepsList;
				
		// TODO: Check if ModelPathExpression is absolute
		if (exprSource.getIsAbsolute()!=null && exprSource.getIsAbsolute().equals(Boolean.TRUE))
		{
			stepsList = exprSource.getSteps();
			if(stepsList != null && !stepsList.isEmpty()){
				if (stepsList.get(0) instanceof ReferenceStep) 
					return mapReferenceStep(stepsList);
				else /* If MPE is composed of all Static steps, maps to an identical MPE */		
					return exprSource;
			}
		}
		return null;
	}

	private FunctionExpression mapReferenceStep(EList stepsList){
		
		if(!BpelOptionsUtil.isTargetWSICompliant()){
			return mapReferenceStepMultipartMessage(stepsList);
		}else{
			return mapReferenceStepWSICompliant(stepsList);
		}
	}
	
	/**
	 * Maps steps of the ModelPathExpression to a bpws:getVariableData in BPEL	 
	 * @param stepsList - a list of steps in the ModelPathExpression
	 * @return FunctionExpression - A bpws:getVariableData FunctionExpression in the BPEL context
	 */		
	private FunctionExpression mapReferenceStepWSICompliant(EList stepsList)
	{				
		//Iterator stepIt = stepsList.iterator();	
		FunctionExpression functionExpr = ModelFactory.eINSTANCE.createFunctionExpression();
		FunctionDefinition def = ModelFactory.eINSTANCE.createFunctionDefinition();
		def.setFunctionID("com.ibm.btools.te.ilm.heuristics.abstractbpel.getVariableData");
		def.setFunctionName("bpws:getVariableData");
		
		FunctionArgument arg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
		StringLiteralExpression strExpr1 = ModelFactory.eINSTANCE.createStringLiteralExpression();
		FunctionArgument arg2 = ModelFactory.eINSTANCE.createFunctionArgument();			
		StringLiteralExpression strExpr2 = ModelFactory.eINSTANCE.createStringLiteralExpression();
		String partName = "";
		String variableName = "";
		BPELVariable destVar = null;
		Step tempStep;
		List tempStepsList = new LinkedList();
		
		FunctionArgument arg3 = ModelFactory.eINSTANCE.createFunctionArgument();		
		ModelPathExpression mpeExpr = ModelFactory.eINSTANCE.createModelPathExpression();
		StaticStep partNameStep = ModelFactory.eINSTANCE.createStaticStep();

		// Ray added: Attempt to fix count function in Java problem (only need for loop if upperbound of item is > 1)
		Part partRepresentingBomElement=null;
		TypedElement bomElementRepresentedByPart = null ;
		
		boolean isFirstStep = true;	
		boolean skipLastStep = false;
		for (int i=0; i<stepsList.size(); i++)
		{		
			if ((i+1)==stepsList.size() && skipLastStep){
				break;
			}
			tempStep = (Step)stepsList.get(i);
			if ((tempStep instanceof ReferenceStep) && (((ReferenceStep)tempStep).getReferencedObject() instanceof Variable)){
				bomElementRepresentedByPart = (TypedElement)((ReferenceStep)tempStep).getReferencedObject();
				//Call Variable Rule to find the string name for 2nd argument	
				destVar = (BPELVariable)TransformationUtil.getRuleForSource(ProcessUtil.getProcessDefinitionRule
											(getContext()),VariableRule.class,((ReferenceStep)tempStep).getReferencedObject()).getTarget().get(0);
				variableName = destVar.getName();
				strExpr1.setStringSymbol(variableName);
				//Check if it is the last step - if the Var is the last step, then we also need to check if the Var is a collection (i.e. upperbound >1)
				//If Var is a collection, then we need to find the List Wrapper Complex Type and the element inside the type that really represents the Var
				//in this case
				//JR26020 skip the last step is the one before is a simpleType Definition
				if ((i+2)==stepsList.size()){
					if((destVar.getType() != null && destVar.getType() instanceof XSDSimpleTypeDefinition) || (destVar.getXSDElement() != null && destVar.getXSDElement().getTypeDefinition() instanceof XSDSimpleTypeDefinition)) {
						XSDTypeDefinition destTypeType = null;	
						if(destVar.getType() != null){
							destTypeType = destVar.getType();
						}else{
							destTypeType = destVar.getXSDElement().getTypeDefinition();
						}
						//					lookup the base type for this definition			
						XSDTypeDefinition baseType = DataDefinitionUtil.getBaseTypeDefinition((XSDSimpleTypeDefinition)destTypeType);
						String destType = baseType.getName();

						String simpleTypeValue = getSimpleTypeValue(destType);
						String varName1= variableName + simpleTypeValue;
						strExpr1.setStringSymbol(varName1);
						skipLastStep = true;
					}
					
				}else if ((i+1)==stepsList.size()) {
					if (bomElementRepresentedByPart instanceof MultiplicityElement) {
						if (BomUtils.isMultipled((MultiplicityElement)bomElementRepresentedByPart)) {
							// if the typedElement has upperbound > 1, that means a List wrapper
							// must have been created for the Pin
							XSDTypeDefinition typeDef = destVar.getType();
							//d149524
							XSDParticle xsdElement = null;
							if (typeDef.getComplexType() != null && typeDef.getComplexType().getContent() != null) {
								xsdElement = (XSDParticle)((XSDModelGroup)typeDef.getComplexType().getContent()).getContents().get(0);
							} else if (typeDef instanceof XSDComplexTypeDefinition && ((XSDComplexTypeDefinition)typeDef).getContent() instanceof XSDParticle) {
								XSDParticle xsdParticle = (XSDParticle)((XSDComplexTypeDefinition)typeDef).getContent();
								if (xsdParticle.getContent() instanceof XSDModelGroup && 
										((XSDModelGroup)xsdParticle.getContent()).getContents() != null &&
										!((XSDModelGroup)xsdParticle.getContent()).getContents().isEmpty()) {
									xsdElement = (XSDParticle)((XSDModelGroup)xsdParticle.getContent()).getContents().get(0);
								}
							}
							ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
							itemStep.setReferencedObject(xsdElement);
							tempStepsList.add(itemStep);
						}else if(destVar.getType() instanceof XSDSimpleTypeDefinition){
							//Defect 111506
							String destType = destVar.getType().getName();
							String simpleTypeValue = getSimpleTypeValue(destType);
							String varName1= variableName + simpleTypeValue;
							strExpr1.setStringSymbol(varName1);
						}
					}
				}				
			}
			else if ((tempStep instanceof ReferenceStep) && (((ReferenceStep)tempStep).getReferencedObject() instanceof Pin) ){

				ObjectPin pin = (ObjectPin)((ReferenceStep)tempStep).getReferencedObject();
				destVar = (BPELVariable)TransformationUtil.getRuleForSource(ProcessUtil.getProcessDefinitionRule
						(getContext()),VariableRule.class,((ReferenceStep)tempStep).getReferencedObject()).getTarget().get(0);
				variableName = destVar.getName();
				strExpr1.setStringSymbol(variableName);		
				bomElementRepresentedByPart = (TypedElement)((ReferenceStep)tempStep).getReferencedObject();
				//Check if it is the last step - if the Pin is the last step, then we also need to check if the Pin is a collection (i.e. upperbound >1)
				//If Pin is a collection, then we need to find the List Wrapper Complex Type and the element inside the type that really represents the Pin
				//in this case
				if ((i+2)==stepsList.size()) {
					if((destVar.getType() != null && destVar.getType() instanceof XSDSimpleTypeDefinition) || (destVar.getXSDElement() != null && destVar.getXSDElement().getTypeDefinition() instanceof XSDSimpleTypeDefinition)) {
						XSDTypeDefinition destTypeType = null;	
						if(destVar.getType() != null){
							destTypeType = destVar.getType();
						}else{
							destTypeType = destVar.getXSDElement().getTypeDefinition();
						}
						//lookup the base type for this definition
						XSDTypeDefinition baseType = DataDefinitionUtil.getBaseTypeDefinition((XSDSimpleTypeDefinition)destTypeType);
						//String destType = destTypeType.getBaseType().getName();
						String destType = baseType.getName();
						String simpleTypeValue = getSimpleTypeValue(destType);
						String varName1= variableName + simpleTypeValue;
						strExpr1.setStringSymbol(varName1);
						skipLastStep = true;
					}	
					//Check if it is the last step - if the Pin is the last step, then we also need to check if the Pin is a collection (i.e. upperbound >1)
					//If Pin is a collection, then we need to find the List Wrapper Complex Type and the element inside the type that really represents the Pin
					//in this case
				}else if ((i+1)==stepsList.size()) {
					if (bomElementRepresentedByPart instanceof MultiplicityElement) {
						if (BomUtils.isMultipled((MultiplicityElement)bomElementRepresentedByPart)) {
							// if the typedElement has upperbound > 1, that means a List wrapper
							// must have been created for the Pin
							XSDTypeDefinition typeDef = destVar.getType();
							XSDParticle xsdElement = (XSDParticle)((XSDModelGroup)typeDef.getComplexType().getContent()).getContents().get(0);
							ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
							itemStep.setReferencedObject(xsdElement);
							tempStepsList.add(itemStep);
						}else if(destVar.getType() instanceof XSDSimpleTypeDefinition){
							//Defect 111506
							String destType = destVar.getType().getName();
							
							String simpleTypeValue = getSimpleTypeValue(destType);
							String varName1= variableName + simpleTypeValue;
							strExpr1.setStringSymbol(varName1);
						}
					}
				}
			}			
			else if ((tempStep instanceof ReferenceStep) && (((ReferenceStep)tempStep).getReferencedObject() instanceof Property) ){
				Property thisProperty = (Property)((ReferenceStep)tempStep).getReferencedObject();
				boolean skipCreateLastStep = false;
				if (isFirstStep){
					
				if (bomElementRepresentedByPart instanceof MultiplicityElement) {
						if (BomUtils.isMultipled((MultiplicityElement)bomElementRepresentedByPart)) {
							// if the typedElement has upperbound > 1, that means a List wrapper
							// must have been created for the Pin
							//Part part = (Part)partRule.getTarget().get(0);
							//XSDTypeDefinition typeDef = partRepresentingBomElement.getTypeDefinition();
							XSDTypeDefinition typeDef = destVar.getType();
							//d149524
							XSDParticle xsdElement = null;
							if (typeDef.getComplexType() != null && typeDef.getComplexType().getContent() != null) {
								xsdElement = (XSDParticle)((XSDModelGroup)typeDef.getComplexType().getContent()).getContents().get(0);
							} else if (typeDef instanceof XSDComplexTypeDefinition && ((XSDComplexTypeDefinition)typeDef).getContent() instanceof XSDParticle) {
								XSDParticle xsdParticle = (XSDParticle)((XSDComplexTypeDefinition)typeDef).getContent();
								if (xsdParticle.getContent() instanceof XSDModelGroup && 
										((XSDModelGroup)xsdParticle.getContent()).getContents() != null &&
										!((XSDModelGroup)xsdParticle.getContent()).getContents().isEmpty()) {
									xsdElement = (XSDParticle)((XSDModelGroup)xsdParticle.getContent()).getContents().get(0);
								}
							}
							
							ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
							itemStep.setReferencedObject(xsdElement);
							tempStepsList.add(itemStep);
							if(isFromDerivedType(thisProperty)){
								skipCreateLastStep = true;
							}
						}
					}
					//Create a new static step to store the business item			
					isFirstStep=false;								
				}else{
					//defect 88986. If this is not the first step, ex, if we are on a Property of a BusinessItem of type derived simple type 
					//not on a Pin or a derived simple type, we should still try to skip the last step. 
					if(isFromDerivedType(thisProperty)){
						skipCreateLastStep = true;
					}
				}
				//JR26020 if we should skip creating the last step, we need to create a staticStep in order
				//to get the value 
				if(skipCreateLastStep){
					XSDParticle xsdElement = findXSDParticle((Property)((ReferenceStep)tempStep).getReferencedObject());
					XSDTypeDefinition typeDefinition = ((XSDElementDeclaration)xsdElement.getContent()).getTypeDefinition();
					String stepName = null;
					
					// for derived simple type - do not create static step
					// for the simpleContent in complexType - create getType("value"); for example getString("value");
					if (isFromDerivedType(thisProperty) && thisProperty.eContainer() instanceof com.ibm.btools.bom.model.artifacts.Class) {
						com.ibm.btools.bom.model.artifacts.Class propOwner = (com.ibm.btools.bom.model.artifacts.Class)thisProperty.eContainer();
						if ("SchemaType".equals(propOwner.getAspect()) && i - 1 > 0) {//check the previous step - if it was an external complex type - need to add .get("value")
							Step prevStep = (Step)stepsList.get(i - 1);
							if (prevStep instanceof ReferenceStep && ((ReferenceStep)prevStep).getReferencedObject() instanceof Property) {
								XSDParticle xsdOwnerElement = findXSDParticle((Property)((ReferenceStep)prevStep).getReferencedObject());
								XSDTypeDefinition ownerTypeDefinition = ((XSDElementDeclaration)xsdOwnerElement.getContent()).getTypeDefinition();
								
								if (ownerTypeDefinition instanceof XSDSimpleTypeDefinition) {
									continue;		// do not create Static Step for simple types
								} else {
									String destType = typeDefinition.getName();
									stepName = getBuiltInTypeToSDOMethod(destType) + "(\"value\")";
								}
							} 
						} 
					}
					if (stepName == null) {			
						String destType = typeDefinition.getName();
						stepName = getSimpleTypeValue(destType);
					}
					StaticStep myStep = ModelFactory.eINSTANCE.createStaticStep();
					myStep.setStepName(stepName);
					tempStepsList.add(myStep);
					
				}else{
					XSDParticle xsdElement = findXSDParticle((Property)((ReferenceStep)tempStep).getReferencedObject());
					ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
					itemStep.setReferencedObject(xsdElement);
					tempStepsList.add(itemStep);
				}

			}
			else if (tempStep instanceof StaticStep)
			{
				if (isFirstStep){
					partNameStep.setStepName(partName);
					tempStepsList.add(partNameStep);
					tempStepsList.add(tempStep);
					isFirstStep=false;								
				}
				else {
					tempStepsList.add(tempStep);								
				}				
			}							
		}	
		arg1.setArgumentValue(strExpr1);	
		arg2.setArgumentValue(strExpr2);
		def.setFunctionName("bpws:getVariableData");	
		functionExpr.setDefinition(def);		
		functionExpr.getArguments().add(arg1);
		functionExpr.getArguments().add(arg2);
		if (tempStepsList.size()>0) {
			mpeExpr.getSteps().addAll(tempStepsList);
			mpeExpr.setIsAbsolute(Boolean.TRUE);
			arg3.setArgumentValue(mpeExpr);	
			functionExpr.getArguments().add(arg3);
		}
		return functionExpr;
	}
	//JR26020
	private String getBuiltInTypeToSDOMethod(String type) {
		if (type == null) {
			return null;
		}
		String methodName = null;
		for (int i = 0; i < JavaConstants.XSDToSDOMapping.length && methodName == null; i++) {
			if (JavaConstants.XSDToSDOMapping[i][0].equals(type)) {
				methodName = "." + JavaConstants.XSDToSDOMapping[i][1];
			}
		}
		
		return methodName;
	}
	//JR26020
	private String getSimpleTypeValue(String type) {
		if (type == null) {
			return null;
		}
		String simpleTypeValue = null;
		for (int i = 0; i < JavaConstants.XSDToSimpleValue.length && simpleTypeValue == null; i++) {
			if (JavaConstants.XSDToSimpleValue[i][0].equals(type)) {
				simpleTypeValue = JavaConstants.XSDToSimpleValue[i][1];
				if(!simpleTypeValue.equals("")){
					simpleTypeValue = "." + simpleTypeValue;
				}
			}
		}
		
		return simpleTypeValue;
	}
	
	/**
	 * @param thisProperty
	 * @return
	 */
	private boolean isFromDerivedType(Property thisProperty) {
		String IMPORT_TYPE_DERIVED_SIMPLE_TYPE_COMMENT = "WBM_IMPORT_TYPE_DERIVED_SIMPLE_TYPE_COMMENT#";
		Type thisClass = (Type)thisProperty.eContainer();
		  final Iterator ownedComments = thisClass.getOwnedComment().iterator();
          Comment thisComment = null;
          while (ownedComments.hasNext()) {
              thisComment = (Comment)ownedComments.next();
              if (thisComment != null && IMPORT_TYPE_DERIVED_SIMPLE_TYPE_COMMENT.equals(thisComment.getBody())) {
              	return true;
              }
          }
		
		return false;
	}

	/**
	 * Maps steps of the ModelPathExpression to a bpws:getVariableData in BPEL	 
	 * @param stepsList - a list of steps in the ModelPathExpression
	 * @return FunctionExpression - A bpws:getVariableData FunctionExpression in the BPEL context
	 */		
	private FunctionExpression mapReferenceStepWSICompliant_bak(EList stepsList)
	{				
		//Iterator stepIt = stepsList.iterator();	
		FunctionExpression functionExpr = ModelFactory.eINSTANCE.createFunctionExpression();
		FunctionDefinition def = ModelFactory.eINSTANCE.createFunctionDefinition();
		def.setFunctionID("com.ibm.btools.te.ilm.heuristics.abstractbpel.getVariableData");
		def.setFunctionName("bpws:getVariableData");
		
		FunctionArgument arg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
		StringLiteralExpression strExpr1 = ModelFactory.eINSTANCE.createStringLiteralExpression();
		FunctionArgument arg2 = ModelFactory.eINSTANCE.createFunctionArgument();			
		StringLiteralExpression strExpr2 = ModelFactory.eINSTANCE.createStringLiteralExpression();
		String partName = "";
		String variableName = "";
		Step tempStep;
		List tempStepsList = new LinkedList();
		
		FunctionArgument arg3 = ModelFactory.eINSTANCE.createFunctionArgument();		
		ModelPathExpression mpeExpr = ModelFactory.eINSTANCE.createModelPathExpression();
		StaticStep partNameStep = ModelFactory.eINSTANCE.createStaticStep();

		// Ray added: Attempt to fix count function in Java problem (only need for loop if upperbound of item is > 1)
		Part partRepresentingBomElement=null;
		TypedElement bomElementRepresentedByPart = null ;
		XSDTypeDefinition typeDefinitionForPin = null;
		boolean isFirstStep = true;				
		for (int i=0; i<stepsList.size(); i++)
		{			
			tempStep = (Step)stepsList.get(i);
			if ((tempStep instanceof ReferenceStep) && (((ReferenceStep)tempStep).getReferencedObject() instanceof Variable))
			{
				
				bomElementRepresentedByPart = (TypedElement)((ReferenceStep)tempStep).getReferencedObject();
				//Call Variable Rule to find the string name for 2nd argument	
				BPELVariable destVar = (BPELVariable)TransformationUtil.getRuleForSource(ProcessUtil.getProcessDefinitionRule
			    							(getContext()),ContainerRule.class,((ReferenceStep)tempStep).getReferencedObject()).getTarget().get(0);
			    variableName = destVar.getName();
			    
			    Iterator it = destVar.getMessageType().getParts().values().iterator();
				partRepresentingBomElement = (Part)it.next(); 
			    partName = partRepresentingBomElement.getName();

				strExpr1.setStringSymbol(variableName);
				strExpr2.setStringSymbol(partName);	
				XSDTypeDefinition complexTypeDefinitionForTheBOMElement= null;
				//if is not wsi compliant we have another step in between... 
				//position of Pin in PinSet 
				if (isFirstStep){
					partNameStep.setStepName(partName);
					tempStepsList.add(partNameStep);
					if (bomElementRepresentedByPart instanceof MultiplicityElement) 
						if (BomUtils.isMultipled((MultiplicityElement)bomElementRepresentedByPart)) {
							int index = 0;
							complexTypeDefinitionForTheBOMElement = partRepresentingBomElement.getElementDeclaration().getTypeDefinition();
							XSDParticle xsdElement = (XSDParticle)((XSDModelGroup)complexTypeDefinitionForTheBOMElement.getComplexType().getContent()).getContents().get(index);	
		//					save the type definition in a variable so it can be used by the Property later
							typeDefinitionForPin = ((XSDElementDeclaration)xsdElement.getContent()).getTypeDefinition();
							ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
							itemStep.setReferencedObject(xsdElement);
							tempStepsList.add(itemStep);
							isFirstStep=false;	
						}
				}

				//Check if it is the last step - if the Var is the last step, then we also need to check if the Var is a collection (i.e. upperbound >1)
				//If Var is a collection, then we need to find the List Wrapper Complex Type and the element inside the type that really represents the Var
				//in this case
//				if ((i+1)==stepsList.size()) {
//					if (bomElementRepresentedByPart instanceof MultiplicityElement) {
//						if (BomUtils.isMultipled((MultiplicityElement)bomElementRepresentedByPart)) {
//							// if the typedElement has upperbound > 1, that means a List wrapper
//							// must have been created for the Pin
//							//Part part = (Part)partRule.getTarget().get(0);
//							XSDTypeDefinition typeDef = partRepresentingBomElement.getEXSDType();						
//							XSDParticle xsdElement = (XSDParticle)((XSDModelGroup)typeDef.getComplexType().getContent()).getContents().get(0);
//							ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
//							itemStep.setReferencedObject(xsdElement);
//							tempStepsList.add(itemStep);
//							
////							XSDParticle xsdElement = (XSDParticle)((XSDModelGroup)complexTypeDefinitionForTheBOMElement.getComplexType().getContent()).getContents().get(0);
////							ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
////							itemStep.setReferencedObject(xsdElement);
////							tempStepsList.add(itemStep);
//						}
//					}
//				}

				
			}
			else if (   (tempStep instanceof ReferenceStep) 
						&& ( ( ((ReferenceStep)tempStep).getReferencedObject() instanceof InputPinSet ) 
						|| ( ((ReferenceStep)tempStep).getReferencedObject() instanceof OutputPinSet ) ))
			{	
				//Call Container Rule to find the string name for 2nd argument 
				BPELVariable destVar = (BPELVariable)TransformationUtil.getRuleForSource(ProcessUtil.getProcessDefinitionRule
											(getContext()),ContainerRule.class,((ReferenceStep)tempStep).getReferencedObject()).getTarget().get(0);
				String varName = destVar.getName();
				strExpr1.setStringSymbol(varName);				
			}
			else if ((tempStep instanceof ReferenceStep) && (((ReferenceStep)tempStep).getReferencedObject() instanceof Pin) )
			{
				
				// Ray: MPE may not have pinset in the path ....
				PinSet pinSet = findPinSetForPin((Pin)((ReferenceStep)tempStep).getReferencedObject());
				BPELVariable destVar = (BPELVariable)TransformationUtil.getRuleForSource(ProcessUtil.getProcessDefinitionRule
						(getContext()),ContainerRule.class,pinSet).getTarget().get(0);
				if (strExpr1.getStringSymbol()==null) {
					String varName = destVar.getName();
					strExpr1.setStringSymbol(varName);				
				}
				List pins;
				if(pinSet instanceof InputPinSet){
					pins = ((InputPinSet)pinSet).getInputObjectPin();
				}else{
					pins = ((OutputPinSet)pinSet).getOutputObjectPin();
				}
				int pinsSize = pins.size();
				//treat this as a Variable
				if(pinsSize == 1){
					bomElementRepresentedByPart = (TypedElement)((ReferenceStep)tempStep).getReferencedObject();
					//Call Variable Rule to find the string name for 2nd argument	
//					BPELVariable destVar = (BPELVariable)TransformationUtil.getRuleForSource(ProcessUtil.getProcessDefinitionRule
//				    							(getContext()),ContainerRule.class,((ReferenceStep)tempStep).getReferencedObject()).getTarget().get(0);
//				    variableName = destVar.getName();
//				    
				    Iterator it = destVar.getMessageType().getParts().values().iterator();
					partRepresentingBomElement = (Part)it.next(); 
				    partName = partRepresentingBomElement.getName();

					//strExpr1.setStringSymbol(variableName);
					strExpr2.setStringSymbol(partName);	
					XSDTypeDefinition complexTypeDefinitionForTheBOMElement= null;
					//if is not wsi compliant we have another step in between... 
					//position of Pin in PinSet 
					if (isFirstStep){
						partNameStep.setStepName(partName);
						tempStepsList.add(partNameStep);
						if (bomElementRepresentedByPart instanceof MultiplicityElement) 
							if (BomUtils.isMultipled((MultiplicityElement)bomElementRepresentedByPart)) {
								int index = 0;
								complexTypeDefinitionForTheBOMElement = partRepresentingBomElement.getElementDeclaration().getTypeDefinition();
								XSDParticle xsdElement = (XSDParticle)((XSDModelGroup)complexTypeDefinitionForTheBOMElement.getComplexType().getContent()).getContents().get(index);	
			//					save the type definition in a variable so it can be used by the Property later
								typeDefinitionForPin = ((XSDElementDeclaration)xsdElement.getContent()).getTypeDefinition();
								ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
								itemStep.setReferencedObject(xsdElement);
								tempStepsList.add(itemStep);
								isFirstStep=false;	
							}
					}
				}else{
					
					//Call Part Rule to find the string name for 2nd argument 
					bomElementRepresentedByPart = (TypedElement)((ReferenceStep)tempStep).getReferencedObject();
					Action action = null;
					PartRule partRule = (PartRule)TransformationUtil.getRuleForSource(ProcessUtil.getProcessInterfaceRule(getContext()),PartRule.class, pinSet);
					//this is the Part representing the PinSet to which this Pin belongs
					partRepresentingBomElement = (Part)partRule.getTarget().get(0);
					partName = partRepresentingBomElement.getName(); 
					strExpr2.setStringSymbol(partName);	
					//we need to retrieve the XSDParticle that represents this Pin.. 
					//position of Pin in PinSet will help us find the XSDParticle inside the complex type definition created for the PinSet
					if (isFirstStep){
						partNameStep.setStepName(partName);
						tempStepsList.add(partNameStep);
						int index = 0;
						index = pins.indexOf(bomElementRepresentedByPart);
						//this is the type definition created for the PinSet
						XSDTypeDefinition complexTypeDefinitionForTheBOMElement = partRepresentingBomElement.getElementDeclaration().getTypeDefinition();
						//at the "index" position we will find the Particle created for this Pin
						XSDParticle xsdElement = (XSDParticle)((XSDModelGroup)complexTypeDefinitionForTheBOMElement.getComplexType().getContent()).getContents().get(index);	
						//save the type definition in a variable so it can be used by the Property later
						typeDefinitionForPin = ((XSDElementDeclaration)xsdElement.getContent()).getTypeDefinition();
						ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
						itemStep.setReferencedObject(xsdElement);
						tempStepsList.add(itemStep);
					}
					//isFirstStep=false;	
						//Check if it is the last step - if the Pin is the last step, then we also need to check if the Pin is a collection (i.e. upperbound >1)
					//If Pin is a collection, then we need to find the List Wrapper Complex Type and the element inside the type that really represents the Pin
					//in this case
					if ((i+1)==stepsList.size()) {
						if (bomElementRepresentedByPart instanceof MultiplicityElement) {
							if (BomUtils.isMultipled((MultiplicityElement)bomElementRepresentedByPart)) {
								// if the typedElement has upperbound > 1, that means a List wrapper
								// must have been created for the Pin
								//XSDTypeDefinition typeDef = partRepresentingBomElement.getEXSDType();						
								//XSDParticle xsdElement = (XSDParticle)((XSDModelGroup)typeDef.getComplexType().getContent()).getContents().get(0);
								//the XSDParticle will be the first (only one) inside the XSDTypeDefinition created for the Pin
								XSDParticle xsdElement = (XSDParticle)((XSDModelGroup)typeDefinitionForPin.getComplexType().getContent()).getContents().get(0);
								ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
								itemStep.setReferencedObject(xsdElement);
								tempStepsList.add(itemStep);
							}
						}
					}
				}
			}
			else if ((tempStep instanceof ReferenceStep) && (((ReferenceStep)tempStep).getReferencedObject() instanceof Property) )
			{
				if (isFirstStep){
					partNameStep.setStepName(partName);
					tempStepsList.add(partNameStep);
					if (bomElementRepresentedByPart instanceof MultiplicityElement) {
						if (BomUtils.isMultipled((MultiplicityElement)bomElementRepresentedByPart)) {
							// if the typedElement has upperbound > 1, that means a List wrapper
							// must have been created for the Pin
							//Part part = (Part)partRule.getTarget().get(0);
							XSDTypeDefinition typeDef= null;
							XSDParticle xsdElement = null;
							//typeDef = partRepresentingBomElement.getElement().getType();
							//the element is the first one (single one in the List definition)						
							xsdElement = (XSDParticle)((XSDModelGroup)typeDefinitionForPin.getComplexType().getContent()).getContents().get(0);
							
							ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
							itemStep.setReferencedObject(xsdElement);
							tempStepsList.add(itemStep);
						}
					}
					isFirstStep=false;								
				}
				XSDParticle xsdElement = findXSDParticle((Property)((ReferenceStep)tempStep).getReferencedObject());
				ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
				itemStep.setReferencedObject(xsdElement);
				tempStepsList.add(itemStep);
			}
			else if (tempStep instanceof StaticStep)
			{
				if (isFirstStep){
					partNameStep.setStepName(partName);
					tempStepsList.add(partNameStep);
					tempStepsList.add(tempStep);
					isFirstStep=false;								
				}
				else {
					tempStepsList.add(tempStep);								
				}				
			}							
		}	
		arg1.setArgumentValue(strExpr1);	
		arg2.setArgumentValue(strExpr2);
		def.setFunctionName("bpws:getVariableData");	
		functionExpr.setDefinition(def);		
		functionExpr.getArguments().add(arg1);
		functionExpr.getArguments().add(arg2);
		if (tempStepsList.size()>0) {
			mpeExpr.getSteps().addAll(tempStepsList);
			mpeExpr.setIsAbsolute(Boolean.TRUE);
			arg3.setArgumentValue(mpeExpr);	
			functionExpr.getArguments().add(arg3);
		}
		return functionExpr;
	}
	
	/**
	 * Maps steps of the ModelPathExpression to a bpws:getVariableData in BPEL	 
	 * @param stepsList - a list of steps in the ModelPathExpression
	 * @return FunctionExpression - A bpws:getVariableData FunctionExpression in the BPEL context
	 */		
	private FunctionExpression mapReferenceStepMultipartMessage(EList stepsList)
	{				
		//Iterator stepIt = stepsList.iterator();	
		FunctionExpression functionExpr = ModelFactory.eINSTANCE.createFunctionExpression();
		FunctionDefinition def = ModelFactory.eINSTANCE.createFunctionDefinition();
		def.setFunctionID("com.ibm.btools.te.ilm.heuristics.abstractbpel.getVariableData");
		def.setFunctionName("bpws:getVariableData");
		
		FunctionArgument arg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
		StringLiteralExpression strExpr1 = ModelFactory.eINSTANCE.createStringLiteralExpression();
		FunctionArgument arg2 = ModelFactory.eINSTANCE.createFunctionArgument();			
		StringLiteralExpression strExpr2 = ModelFactory.eINSTANCE.createStringLiteralExpression();
		String partName = "";
		String variableName = "";
		Step tempStep;
		List tempStepsList = new LinkedList();
		
		FunctionArgument arg3 = ModelFactory.eINSTANCE.createFunctionArgument();		
		ModelPathExpression mpeExpr = ModelFactory.eINSTANCE.createModelPathExpression();
		StaticStep partNameStep = ModelFactory.eINSTANCE.createStaticStep();

		// Ray added: Attempt to fix count function in Java problem (only need for loop if upperbound of item is > 1)
		Part partRepresentingBomElement=null;
		TypedElement bomElementRepresentedByPart = null ;
		
		boolean isFirstStep = true;				
		for (int i=0; i<stepsList.size(); i++)
		{			
			tempStep = (Step)stepsList.get(i);
			if ((tempStep instanceof ReferenceStep) && (((ReferenceStep)tempStep).getReferencedObject() instanceof Variable))
			{
				bomElementRepresentedByPart = (TypedElement)((ReferenceStep)tempStep).getReferencedObject();
				//Call Variable Rule to find the string name for 2nd argument	
				BPELVariable destVar = (BPELVariable)TransformationUtil.getRuleForSource(ProcessUtil.getProcessDefinitionRule
											(getContext()),ContainerRule.class,((ReferenceStep)tempStep).getReferencedObject()).getTarget().get(0);
				variableName = destVar.getName();
				Iterator it = destVar.getMessageType().getParts().values().iterator();
				partRepresentingBomElement = (Part)it.next(); 
				partName = partRepresentingBomElement.getName();
			    			
				//partName = "partName";
				//strExpr1.setStringSymbol( tempStep.getReferenceName() );
				//strExpr1.setStringSymbol("variableName");
				strExpr1.setStringSymbol(variableName);
				strExpr2.setStringSymbol(partName);				
				//Check if it is the last step - if the Var is the last step, then we also need to check if the Var is a collection (i.e. upperbound >1)
				//If Var is a collection, then we need to find the List Wrapper Complex Type and the element inside the type that really represents the Var
				//in this case
				if ((i+1)==stepsList.size()) {
					if (bomElementRepresentedByPart instanceof MultiplicityElement) {
						if (BomUtils.isMultipled((MultiplicityElement)bomElementRepresentedByPart)) {
							partNameStep.setStepName(partName);
							tempStepsList.add(partNameStep);
							
							// if the typedElement has upperbound > 1, that means a List wrapper
							// must have been created for the Pin
							//Part part = (Part)partRule.getTarget().get(0);
							XSDTypeDefinition typeDef = partRepresentingBomElement.getTypeDefinition();						
							XSDParticle xsdElement = (XSDParticle)((XSDModelGroup)typeDef.getComplexType().getContent()).getContents().get(0);
							ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
							itemStep.setReferencedObject(xsdElement);
							tempStepsList.add(itemStep);
						}
					}
				}				
			}
			else if (   (tempStep instanceof ReferenceStep) 
						&& ( ( ((ReferenceStep)tempStep).getReferencedObject() instanceof InputPinSet ) 
						|| ( ((ReferenceStep)tempStep).getReferencedObject() instanceof OutputPinSet ) ))
			{	
				//Call Container Rule to find the string name for 2nd argument 
				BPELVariable destVar = (BPELVariable)TransformationUtil.getRuleForSource(ProcessUtil.getProcessDefinitionRule
											(getContext()),ContainerRule.class,((ReferenceStep)tempStep).getReferencedObject()).getTarget().get(0);
				String varName = destVar.getName();
				strExpr1.setStringSymbol(varName);				
				//strExpr1.setStringSymbol( ((ReferenceStep)tempStep).getReferenceName() );
				//strExpr1.setStringSymbol("PinSetName");											
			}
			else if ((tempStep instanceof ReferenceStep) && (((ReferenceStep)tempStep).getReferencedObject() instanceof Pin) )
			{
				// Ray: MPE may not have pinset in the path ....
				if (strExpr1.getStringSymbol()==null) {
					//handle this case .... see findPinSetForPin function at the end
					PinSet pinSet = findPinSetForPin((Pin)((ReferenceStep)tempStep).getReferencedObject());
					BPELVariable destVar = (BPELVariable)TransformationUtil.getRuleForSource(ProcessUtil.getProcessDefinitionRule
												(getContext()),ContainerRule.class,pinSet).getTarget().get(0);
					String varName = destVar.getName();
					strExpr1.setStringSymbol(varName);				
				}
				//Call Part Rule to find the string name for 2nd argument 
				bomElementRepresentedByPart = (TypedElement)((ReferenceStep)tempStep).getReferencedObject();
				//Ray commented:Part destPart = (Part)TransformationUtil.getRuleForSource(ProcessUtil.getProcessInterfaceRule
				//Ray added:
				PartRule partRule = (PartRule)TransformationUtil.getRuleForSource(ProcessUtil.getProcessInterfaceRule
										(getContext()),PartRule.class,((ReferenceStep)tempStep).getReferencedObject());
				partRepresentingBomElement = (Part)partRule.getTarget().get(0);
				partName = partRepresentingBomElement.getName(); 
				//partName = "pinPartName";
				strExpr2.setStringSymbol(partName);		
				
				//Check if it is the last step - if the Pin is the last step, then we also need to check if the Pin is a collection (i.e. upperbound >1)
				//If Pin is a collection, then we need to find the List Wrapper Complex Type and the element inside the type that really represents the Pin
				//in this case
				if ((i+1)==stepsList.size()) {
					if (bomElementRepresentedByPart instanceof MultiplicityElement) {
						if (BomUtils.isMultipled((MultiplicityElement)bomElementRepresentedByPart)) {
							partNameStep.setStepName(partName);
							tempStepsList.add(partNameStep);
							
							// if the typedElement has upperbound > 1, that means a List wrapper
							// must have been created for the Pin
							//Part part = (Part)partRule.getTarget().get(0);
							XSDTypeDefinition typeDef = partRepresentingBomElement.getTypeDefinition();						
							XSDParticle xsdElement = (XSDParticle)((XSDModelGroup)typeDef.getComplexType().getContent()).getContents().get(0);
							ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
							itemStep.setReferencedObject(xsdElement);
							tempStepsList.add(itemStep);
						}
					}
				}
			}			
			else if ((tempStep instanceof ReferenceStep) && (((ReferenceStep)tempStep).getReferencedObject() instanceof Property) )
			{
				if (isFirstStep){
					partNameStep.setStepName(partName);
					tempStepsList.add(partNameStep);
					
					//TypedElement typedElement = (TypedElement)partRule.getSource().get(0);
					if (bomElementRepresentedByPart instanceof MultiplicityElement) {
						if (BomUtils.isMultipled((MultiplicityElement)bomElementRepresentedByPart)) {
							// if the typedElement has upperbound > 1, that means a List wrapper
							// must have been created for the Pin
							//Part part = (Part)partRule.getTarget().get(0);
							XSDTypeDefinition typeDef = partRepresentingBomElement.getTypeDefinition();						
							XSDParticle xsdElement = (XSDParticle)((XSDModelGroup)typeDef.getComplexType().getContent()).getContents().get(0);
							ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
							itemStep.setReferencedObject(xsdElement);
							tempStepsList.add(itemStep);
						}
					}
					//Create a new static step to store the business item			
//					StaticStep itemStep = ModelFactory.eINSTANCE.createStaticStep();				
//					itemStep.setStepName( ((ReferenceStep)tempStep).getReferenceName());					
//					tempStepsList.add(itemStep);
					isFirstStep=false;								
				}
//				else {			
//					StaticStep itemStep = ModelFactory.eINSTANCE.createStaticStep();
//					itemStep.setStepName( ((ReferenceStep)tempStep).getReferenceName());					
//					tempStepsList.add(itemStep);								
//				}	
				XSDParticle xsdElement = findXSDParticle((Property)((ReferenceStep)tempStep).getReferencedObject());
				ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
				itemStep.setReferencedObject(xsdElement);
				tempStepsList.add(itemStep);
			}
			else if (tempStep instanceof StaticStep)
			{
				if (isFirstStep){
					partNameStep.setStepName(partName);
					tempStepsList.add(partNameStep);
					tempStepsList.add(tempStep);
					isFirstStep=false;								
				}
				else {
					tempStepsList.add(tempStep);								
				}				
			}							
		}	
		arg1.setArgumentValue(strExpr1);	
		arg2.setArgumentValue(strExpr2);
		def.setFunctionName("bpws:getVariableData");	
		functionExpr.setDefinition(def);		
		functionExpr.getArguments().add(arg1);
		functionExpr.getArguments().add(arg2);
		if (tempStepsList.size()>0) {
			mpeExpr.getSteps().addAll(tempStepsList);
			mpeExpr.setIsAbsolute(Boolean.TRUE);
			arg3.setArgumentValue(mpeExpr);	
			functionExpr.getArguments().add(arg3);
		}
		return functionExpr;
	}

	/**
	 * Maps the sum and count Function Expressions from BOM to BPEL context.	 
	 * @param exprSouce - a sum or count FunctionExpression in the BOM context
	 * @return FunctionExpression - A FunctionExpression in the BPEL context
	 */		
	private FunctionExpression mapSumSizeExpr(FunctionExpression exprSource)
	{		
		FunctionExpression functionExpr;
		/* If the argument is a ModelPathExpression */
		FunctionArgument fcnArg = (FunctionArgument)exprSource.getArguments().get(0);
		if (fcnArg.getArgumentValue() instanceof ModelPathExpression)
		{				
			// TODO Make sure the MPE is absolute!!!
			EList stepsList;
			stepsList = ( (ModelPathExpression)fcnArg.getArgumentValue()).getSteps();
			functionExpr = mapReferenceStep(stepsList);
		
			/* Re-Composing the third argument */
			ModelPathExpression mpeExpr = null;
			if (functionExpr.getArguments().size()>2) {
				fcnArg = (FunctionArgument)functionExpr.getArguments().get(2);
				mpeExpr = (ModelPathExpression)fcnArg.getArgumentValue();
			} else {
				mpeExpr = createPartStepOnlyMPE(stepsList);
			}
		
			FunctionExpression argFunctionExpr = ModelFactory.eINSTANCE.createFunctionExpression();
			FunctionDefinition argDef = ModelFactory.eINSTANCE.createFunctionDefinition();
			argDef.setFunctionID(exprSource.getDefinition().getFunctionID());
			argDef.setFunctionName(exprSource.getDefinition().getFunctionName());
			FunctionArgument funcArg1 = ModelFactory.eINSTANCE.createFunctionArgument();
			
			argFunctionExpr.setDefinition(argDef);		
			funcArg1.setArgumentValue(mpeExpr);
			argFunctionExpr.getArguments().add(funcArg1);	
		
			FunctionArgument funcArg2 = ModelFactory.eINSTANCE.createFunctionArgument();
			funcArg2.setArgumentValue(argFunctionExpr);
			functionExpr.getArguments().add(2, funcArg2);
			return functionExpr;
		}		
		/* If the argument is a getAll function expression */
		else if (fcnArg.getArgumentValue() instanceof FunctionExpression 
				&& ((FunctionExpression)fcnArg.getArgumentValue()).getDefinition().getFunctionID().equals(CoreFunctions.GET_ALL_FUNCTION))
		{
			String activityName= getOwnerActionName();
			String [] params = new String []{activityName};
			LoggingUtil.logError(MessageKeys.ERROR_GET_ALL_EXPRESSION, params, null);
			
			// TODO Make sure the MPE is absolute!!!
			EList stepsList;
			Expression thisExpr = ((FunctionArgument)((FunctionExpression)fcnArg.getArgumentValue()).getArguments().get(0)).getArgumentValue();
			if (thisExpr instanceof ModelPathExpression)
				stepsList = ((ModelPathExpression)thisExpr).getSteps();
			else
				return null;			
			functionExpr = mapReferenceStep(stepsList);
	 	
			Expression mpeExpr;
			/* Re-Composing the third argument */	
			if(functionExpr.getArguments().size()>2){
				mpeExpr = (ModelPathExpression)((FunctionArgument)functionExpr.getArguments().get(2)).getArgumentValue();
			}else{
				mpeExpr=(Expression) EcoreUtil.copy((Expression)((FunctionArgument)functionExpr.getArguments().get(0)).getArgumentValue());
			}
			FunctionExpression argFunctionExpr = ModelFactory.eINSTANCE.createFunctionExpression();	
			FunctionDefinition argDef = ModelFactory.eINSTANCE.createFunctionDefinition();
						
			argDef.setFunctionID(exprSource.getDefinition().getFunctionID());
			argDef.setFunctionName(exprSource.getDefinition().getFunctionName());
			argFunctionExpr.setDefinition(argDef);
			
			FunctionArgument funcArg1 = ModelFactory.eINSTANCE.createFunctionArgument();
	 
			FunctionExpression getAllFunc = ModelFactory.eINSTANCE.createFunctionExpression();
			FunctionDefinition getAllDef = ModelFactory.eINSTANCE.createFunctionDefinition();			
			getAllDef.setFunctionID(CoreFunctions.GET_ALL_FUNCTION);
					
			FunctionArgument getAllArg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
			
			getAllArg1.setArgumentValue(mpeExpr);
			getAllFunc.setDefinition(getAllDef);
			getAllFunc.getArguments().add(getAllArg1);
				 
			funcArg1.setArgumentValue(getAllFunc);
			argFunctionExpr.getArguments().add(funcArg1);
			FunctionArgument funcArg2 = ModelFactory.eINSTANCE.createFunctionArgument();
			funcArg2.setArgumentValue(argFunctionExpr);	
			functionExpr.getArguments().add(2, funcArg2);
		
			return functionExpr;			
		}
		/* If the argument is a select function expression */
		else if (fcnArg.getArgumentValue() instanceof FunctionExpression 
				&& ((FunctionExpression)fcnArg.getArgumentValue()).getDefinition().getFunctionID().equals(CoreFunctions.SELECT_FUNCTION))
		{
			boolean isGetAllExpr = false;
			// TODO Make sure the MPE is absolute!!!
			EList stepsList;
			Expression thisExpr = ((FunctionArgument)((FunctionExpression)fcnArg.getArgumentValue()).getArguments().get(0)).getArgumentValue();
			if (thisExpr instanceof ModelPathExpression)
				stepsList = ((ModelPathExpression)thisExpr).getSteps();
			else{
				//getall function
				isGetAllExpr = true;
				stepsList = ((ModelPathExpression)((FunctionArgument)((FunctionExpression)thisExpr).getArguments().get(0)).getArgumentValue()).getSteps();
			}			
			functionExpr = mapReferenceStep(stepsList);
	 	
			/* Re-Composing the third argument */	
			ModelPathExpression mpeExpr = (ModelPathExpression)((FunctionArgument)functionExpr.getArguments().get(2)).getArgumentValue();
	    
			FunctionExpression argFunctionExpr = ModelFactory.eINSTANCE.createFunctionExpression();	
			FunctionDefinition argDef = ModelFactory.eINSTANCE.createFunctionDefinition();
			argDef.setFunctionID(exprSource.getDefinition().getFunctionID());
			argDef.setFunctionName(exprSource.getDefinition().getFunctionName());
			argFunctionExpr.setDefinition(argDef);
			FunctionArgument funcArg1 = ModelFactory.eINSTANCE.createFunctionArgument();
	 
			/* The argument to the argFunctionExpr is a select */
			FunctionExpression selectFunc = ModelFactory.eINSTANCE.createFunctionExpression();
			FunctionDefinition selectDef = ModelFactory.eINSTANCE.createFunctionDefinition();			
			selectDef.setFunctionID(CoreFunctions.SELECT_FUNCTION);
					
			FunctionArgument selectArg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
			FunctionArgument selectArg2 = ModelFactory.eINSTANCE.createFunctionArgument();		
	 	
	 		if (!isGetAllExpr)
				selectArg1.setArgumentValue(mpeExpr);
			else{
				FunctionExpression getAllFunc = ModelFactory.eINSTANCE.createFunctionExpression();
				FunctionDefinition getAllDef = ModelFactory.eINSTANCE.createFunctionDefinition();			
				getAllDef.setFunctionID(CoreFunctions.GET_ALL_FUNCTION);
					
				FunctionArgument getAllArg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
			
				getAllArg1.setArgumentValue(mpeExpr);
				getAllFunc.setDefinition(getAllDef);
				getAllFunc.getArguments().add(getAllArg1);
				selectArg1.setArgumentValue(getAllFunc);				
			}	
			
			
			FunctionExpression tempExpr = (FunctionExpression)((FunctionArgument)exprSource.getArguments().get(0)).getArgumentValue();
			selectArg2.setArgumentValue(mapCriteria( ((FunctionArgument)tempExpr.getArguments().get(1)).getArgumentValue() ));

			selectFunc.setDefinition(selectDef);
			selectFunc.getArguments().add(selectArg1);
			selectFunc.getArguments().add(selectArg2);		 
			funcArg1.setArgumentValue(selectFunc);
			argFunctionExpr.getArguments().add(funcArg1);
			FunctionArgument funcArg2 = ModelFactory.eINSTANCE.createFunctionArgument();
			funcArg2.setArgumentValue(argFunctionExpr);	
			functionExpr.getArguments().add(2, funcArg2);
		
			return functionExpr;
		}
		return null;
	}

	/**
	 * Maps the exists and for-all Function Expressions from BOM to BPEL context.	 
	 * @param exprSouce - a exists or for-all Function Expression in the BOM context
	 * @return FunctionExpression - A FunctionExpression in the BPEL context
	 */	
	private FunctionExpression mapExistsForAllExpr(FunctionExpression exprSource)
	{
		FunctionExpression functionExpr;
		// TODO Make sure the MPE is absolute!!!
		FunctionArgument fcnArg = (FunctionArgument)exprSource.getArguments().get(0);
		if (fcnArg.getArgumentValue() instanceof ModelPathExpression)
		{		
			// TODO Make sure the MPE is absolute!!!
			EList stepsList;
			stepsList = ( (ModelPathExpression)fcnArg.getArgumentValue()).getSteps();
			/* Returns a bpws:GetVariableData */
			functionExpr = mapReferenceStep(stepsList);
		
			/* Re-Composing the third argument */	
			ModelPathExpression mpeExpr = (ModelPathExpression)((FunctionArgument)functionExpr.getArguments().get(2)).getArgumentValue();
		
			FunctionExpression argFunctionExpr = ModelFactory.eINSTANCE.createFunctionExpression();
			FunctionDefinition argDef = ModelFactory.eINSTANCE.createFunctionDefinition();
			argDef.setFunctionID(exprSource.getDefinition().getFunctionID());
			argDef.setFunctionName(exprSource.getDefinition().getFunctionName());
			FunctionArgument funcArg1 = ModelFactory.eINSTANCE.createFunctionArgument();
			FunctionArgument funcArg2 = ModelFactory.eINSTANCE.createFunctionArgument();
					
			argFunctionExpr.setDefinition(argDef);		
			funcArg1.setArgumentValue(mpeExpr);
			funcArg2.setArgumentValue(mapCriteria(((FunctionArgument)exprSource.getArguments().get(1)).getArgumentValue() ));
			argFunctionExpr.getArguments().add(funcArg1);	
			argFunctionExpr.getArguments().add(funcArg2);
			FunctionArgument funcArg3 = ModelFactory.eINSTANCE.createFunctionArgument();
			funcArg3.setArgumentValue(argFunctionExpr);		
			functionExpr.getArguments().add(2, funcArg3);
			return functionExpr;
		}		
		/* If the argument is a select function expression */
		else if (fcnArg.getArgumentValue()  instanceof FunctionExpression 
				&& ((FunctionExpression)fcnArg.getArgumentValue() ).getDefinition().getFunctionID().equals(CoreFunctions.GET_ALL_FUNCTION))
		{
			String activityName= getOwnerActionName();
			String [] params = new String []{activityName};
			LoggingUtil.logError(MessageKeys.ERROR_GET_ALL_EXPRESSION, params, null);
			
			// TODO Make sure the MPE is absolute!!!
			EList stepsList;
			stepsList = ((ModelPathExpression)((FunctionArgument)((FunctionExpression)fcnArg.getArgumentValue()).getArguments().get(0)).getArgumentValue()).getSteps();
			functionExpr = mapReferenceStep(stepsList);
	 	
			/* Re-Composing the third argument */	
			ModelPathExpression mpeExpr = (ModelPathExpression)((FunctionArgument)functionExpr.getArguments().get(2)).getArgumentValue();
	    
			FunctionExpression argFunctionExpr = ModelFactory.eINSTANCE.createFunctionExpression();	
			FunctionDefinition argDef = ModelFactory.eINSTANCE.createFunctionDefinition();
						
			argDef.setFunctionID(exprSource.getDefinition().getFunctionID());
			argDef.setFunctionName(exprSource.getDefinition().getFunctionName());
			argFunctionExpr.setDefinition(argDef);
			FunctionArgument funcArg1 = ModelFactory.eINSTANCE.createFunctionArgument();
	 
			/* The argument to the argFunctionExpr is a select */
			FunctionExpression getAllFunc = ModelFactory.eINSTANCE.createFunctionExpression();
			FunctionDefinition getAllDef = ModelFactory.eINSTANCE.createFunctionDefinition();			
			getAllDef.setFunctionID(CoreFunctions.GET_ALL_FUNCTION);
					
			FunctionArgument getAllArg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
			FunctionArgument funcArg2 = ModelFactory.eINSTANCE.createFunctionArgument();
			
			getAllArg1.setArgumentValue(mpeExpr);
			getAllFunc.setDefinition(getAllDef);
			getAllFunc.getArguments().add(getAllArg1);
				 
			funcArg1.setArgumentValue(getAllFunc);
			funcArg2.setArgumentValue(mapCriteria(((FunctionArgument)exprSource.getArguments().get(1)).getArgumentValue() ));
			argFunctionExpr.getArguments().add(funcArg1);
			argFunctionExpr.getArguments().add(funcArg2);
			FunctionArgument funcArg3 = ModelFactory.eINSTANCE.createFunctionArgument();
			funcArg3.setArgumentValue(argFunctionExpr);	
			functionExpr.getArguments().add(2, funcArg3);
		
			return functionExpr;			
		}
		/* If the argument is a select function expression */
		else if (fcnArg.getArgumentValue()  instanceof FunctionExpression 
				&& ((FunctionExpression)fcnArg.getArgumentValue() ).getDefinition().getFunctionID().equals(CoreFunctions.SELECT_FUNCTION))
		{
			boolean isGetAllExpr = false;
			// TODO Make sure the MPE is absolute!!!
			EList stepsList;
			Expression thisExpr = ((FunctionArgument)((FunctionExpression)fcnArg.getArgumentValue()).getArguments().get(0)).getArgumentValue();
			if (thisExpr instanceof ModelPathExpression)
				stepsList = ((ModelPathExpression)thisExpr).getSteps();
			else{
				//getall function
				isGetAllExpr = true;
				stepsList = ((ModelPathExpression)((FunctionArgument)((FunctionExpression)thisExpr).getArguments().get(0)).getArgumentValue()).getSteps();
			} 
			
			//stepsList = ((ModelPathExpression) ((FunctionArgument)((FunctionExpression)fcnArg.getArgumentValue()).getArguments().get(0)).getArgumentValue()).getSteps();
			functionExpr = mapReferenceStep(stepsList);
	 	
			/* Re-Composing the third argument */	
			ModelPathExpression mpeExpr = (ModelPathExpression)((FunctionArgument)functionExpr.getArguments().get(2)).getArgumentValue();
	    
			FunctionExpression argFunctionExpr = ModelFactory.eINSTANCE.createFunctionExpression();	
			FunctionDefinition argDef = ModelFactory.eINSTANCE.createFunctionDefinition();
			argDef.setFunctionID(exprSource.getDefinition().getFunctionID());
			argDef.setFunctionName(exprSource.getDefinition().getFunctionName());
			argFunctionExpr.setDefinition(argDef);
			FunctionArgument funcArg1 = ModelFactory.eINSTANCE.createFunctionArgument();
			FunctionArgument funcArg2 = ModelFactory.eINSTANCE.createFunctionArgument();
	 
			/* The argument to the argFunctionExpr is a select */
			FunctionExpression selectFunc = ModelFactory.eINSTANCE.createFunctionExpression();
			FunctionDefinition selectDef = ModelFactory.eINSTANCE.createFunctionDefinition();
			selectDef.setFunctionID(CoreFunctions.SELECT_FUNCTION);
		
			FunctionArgument selectArg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
			FunctionArgument selectArg2 = ModelFactory.eINSTANCE.createFunctionArgument();		
	 	
			//selectArg1.setArgumentValue(mpeExpr);
			if (!isGetAllExpr)
				selectArg1.setArgumentValue(mpeExpr);
			else{
				FunctionExpression getAllFunc = ModelFactory.eINSTANCE.createFunctionExpression();
				FunctionDefinition getAllDef = ModelFactory.eINSTANCE.createFunctionDefinition();			
				getAllDef.setFunctionID(CoreFunctions.GET_ALL_FUNCTION);
					
				FunctionArgument getAllArg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
			
				getAllArg1.setArgumentValue(mpeExpr);
				getAllFunc.setDefinition(getAllDef);
				getAllFunc.getArguments().add(getAllArg1);
				selectArg1.setArgumentValue(getAllFunc);				
			}
			
			selectArg2.setArgumentValue(mapCriteria(((FunctionArgument)((FunctionExpression)fcnArg.getArgumentValue()).getArguments().get(1)).getArgumentValue() ));
			selectFunc.setDefinition(selectDef);
			selectFunc.getArguments().add(selectArg1);			
			selectFunc.getArguments().add(selectArg2);
		 
			argFunctionExpr.setDefinition(argDef);		 
			funcArg1.setArgumentValue(selectFunc);
			funcArg2.setArgumentValue(mapBinaryOperatorExpression(
												(BinaryOperatorExpression)((FunctionArgument)exprSource.getArguments().get(1)).getArgumentValue() ));
			argFunctionExpr.getArguments().add(funcArg1);	
			argFunctionExpr.getArguments().add(funcArg2);	
			FunctionArgument funcArg3 = ModelFactory.eINSTANCE.createFunctionArgument();
			funcArg3.setArgumentValue(argFunctionExpr);		
			functionExpr.getArguments().add(2, funcArg3);
		
			return functionExpr;
		}
		return null;
	}

	/**
	 * Maps the contains and starts with Function Expressions from BOM to BPEL context.	 
	 * @param exprSouce - a contains or starts with Function Expression in the BOM context
	 * @return FunctionExpression - A FunctionExpression in the BPEL context
	 */		
	private FunctionExpression mapContainsStartsWith(FunctionExpression exprSource)
	{
		//If the two arguments are both StringLiteral - identical mapping
		FunctionArgument arg1 = (FunctionArgument)exprSource.getArguments().get(0);
		FunctionArgument arg2 = (FunctionArgument)exprSource.getArguments().get(1);
		if ( (arg1.getArgumentValue() instanceof StringLiteralExpression) && (arg2.getArgumentValue() instanceof StringLiteralExpression) )
			return exprSource;
		FunctionExpression functionExpr;
		FunctionArgument fcnArg;
		//Map if First and SEcond are MPEs, they must be in the same container
		if ( (arg1.getArgumentValue() instanceof ModelPathExpression) && (arg2.getArgumentValue() instanceof ModelPathExpression) )
		{
			
			//create the starts-with FunctionExpression
			functionExpr = ModelFactory.eINSTANCE.createFunctionExpression();
			FunctionDefinition argDef = ModelFactory.eINSTANCE.createFunctionDefinition();
			argDef.setFunctionID(exprSource.getDefinition().getFunctionID());
			argDef.setFunctionName(exprSource.getDefinition().getFunctionName());
			functionExpr.setDefinition(argDef);
			//map the firts argument (MPE) to BPEL Context 
			FunctionArgument funcArg1 = ModelFactory.eINSTANCE.createFunctionArgument();
			EList stepsList;
			stepsList = ( (ModelPathExpression)arg1.getArgumentValue()).getSteps();
			/* Returns a bpws:GetVariableData */
			FunctionExpression mpfunctionExpr = mapReferenceStep(stepsList);
			funcArg1.setArgumentValue(mpfunctionExpr);
			//map second argument (MPE) to BPEL context
			FunctionArgument funcArg2 = ModelFactory.eINSTANCE.createFunctionArgument();
			
			stepsList = ( (ModelPathExpression)arg2.getArgumentValue()).getSteps();
			/* Returns a bpws:GetVariableData */
			FunctionExpression mpfunctionExpr2 = mapReferenceStep(stepsList);
			funcArg2.setArgumentValue(mpfunctionExpr2);
			//set the arguments to the function
			functionExpr.getArguments().add(funcArg1);
			functionExpr.getArguments().add(funcArg2);
		}		
		//Map if First Argument is MPE
		else if (arg1.getArgumentValue() instanceof ModelPathExpression)
		{
			//create the starts-with FunctionExpression
			functionExpr = ModelFactory.eINSTANCE.createFunctionExpression();
			FunctionDefinition argDef = ModelFactory.eINSTANCE.createFunctionDefinition();
			argDef.setFunctionID(exprSource.getDefinition().getFunctionID());
			argDef.setFunctionName(exprSource.getDefinition().getFunctionName());
			functionExpr.setDefinition(argDef);
			//map the firts argument (MPE) to BPEL Context 
			FunctionArgument funcArg1 = ModelFactory.eINSTANCE.createFunctionArgument();
			EList stepsList;
			stepsList = ( (ModelPathExpression)arg1.getArgumentValue()).getSteps();
			/* Returns a bpws:GetVariableData */
			FunctionExpression mpfunctionExpr = mapReferenceStep(stepsList);
			funcArg1.setArgumentValue(mpfunctionExpr);
			//map second argument (StringExpression) to BPEL context
			FunctionArgument strArg = ModelFactory.eINSTANCE.createFunctionArgument();
			strArg.setArgumentValue((StringLiteralExpression)arg2.getArgumentValue());
			//set the arguments to the function
			functionExpr.getArguments().add(funcArg1);
			functionExpr.getArguments().add(strArg);
		}		
		//Map if Second Argument is MPE
		else
		{
			//create the starts-with FunctionExpression
			functionExpr = ModelFactory.eINSTANCE.createFunctionExpression();
			FunctionDefinition argDef = ModelFactory.eINSTANCE.createFunctionDefinition();
			argDef.setFunctionID(exprSource.getDefinition().getFunctionID());
			argDef.setFunctionName(exprSource.getDefinition().getFunctionName());
			functionExpr.setDefinition(argDef);
			//map the first argument (StringExpression) to BPEL Context 
			FunctionArgument strArg = ModelFactory.eINSTANCE.createFunctionArgument();
			strArg.setArgumentValue((StringLiteralExpression)arg1.getArgumentValue());
			//map second argument (MPE) to BPEL context
			FunctionArgument funcArg = ModelFactory.eINSTANCE.createFunctionArgument();
			EList stepsList;
			stepsList = ( (ModelPathExpression)arg2.getArgumentValue()).getSteps();
			/* Returns a bpws:GetVariableData */
			FunctionExpression mpfunctionExpr = mapReferenceStep(stepsList);
			funcArg.setArgumentValue(mpfunctionExpr);
			
			//set the arguments to the function
			functionExpr.getArguments().add(strArg);
			functionExpr.getArguments().add(funcArg);
		}
		
		return functionExpr;
	}

	/**
	 * Maps the select Function Expression to a Function Expression in the BPEL context.	 
	 * @param exprSouce - a select Function Expression in the BOM context
	 * @return FunctionExpression - A FunctionExpression in the BPEL context
	 */		
	private FunctionExpression mapSelectExpr(FunctionExpression exprSource)
	{
		/* NOTE: Nested select function expressions are not supported */
		FunctionExpression functionExpr;
		EList stepsList;
		boolean isGetAllFunction = false;
		if (((FunctionArgument)exprSource.getArguments().get(0)).getArgumentValue() instanceof ModelPathExpression){
			stepsList = ((ModelPathExpression)((FunctionArgument)exprSource.getArguments().get(0)).getArgumentValue()).getSteps();
		}else if (((FunctionArgument)exprSource.getArguments().get(0)).getArgumentValue() instanceof FunctionExpression &&
					((FunctionExpression)((FunctionArgument)exprSource.getArguments().get(0)).getArgumentValue()).getDefinition().getFunctionID().equals(CoreFunctions.GET_ALL_FUNCTION)){
			String activityName= getOwnerActionName();
			String [] params = new String []{activityName};
			LoggingUtil.logError(MessageKeys.ERROR_GET_ALL_EXPRESSION, params, null);
			
			//get the argument from getall Function	
			FunctionExpression getAllFunction = ModelFactory.eINSTANCE.createFunctionExpression();
			getAllFunction = (FunctionExpression)((FunctionArgument)exprSource.getArguments().get(0)).getArgumentValue();
			//get the argument, should be mpe	
			stepsList = ((ModelPathExpression)((FunctionArgument)getAllFunction.getArguments().get(0)).getArgumentValue()).getSteps();
			isGetAllFunction = true;	
		}else{
			return null;
		}
				
		functionExpr = mapReferenceStep(stepsList);
	
		/* Re-Composing the third argument */	
		ModelPathExpression mpeExpr = (ModelPathExpression)((FunctionArgument)functionExpr.getArguments().get(2)).getArgumentValue();

		FunctionExpression selectFunc = ModelFactory.eINSTANCE.createFunctionExpression();
		FunctionDefinition selectDef = ModelFactory.eINSTANCE.createFunctionDefinition();
		selectDef.setFunctionID(CoreFunctions.SELECT_FUNCTION);
		selectFunc.setDefinition(selectDef);

		FunctionArgument selectArg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
		FunctionArgument selectArg2 = ModelFactory.eINSTANCE.createFunctionArgument();		

		if (!isGetAllFunction){
			selectArg1.setArgumentValue(mpeExpr);
		}else{
			//create a getAllfunction
			FunctionExpression getallFunc = ModelFactory.eINSTANCE.createFunctionExpression();
			FunctionDefinition getallDef = ModelFactory.eINSTANCE.createFunctionDefinition();
			getallDef.setFunctionID(CoreFunctions.GET_ALL_FUNCTION);
			getallFunc.setDefinition(getallDef);
	
			FunctionArgument getallArg1 = ModelFactory.eINSTANCE.createFunctionArgument();	
			getallArg1.setArgumentValue(mpeExpr);
			getallFunc.getArguments().add(getallArg1);
			selectArg1.setArgumentValue(getallFunc);
		}
		
		//FunctionExpression tempExpr = (FunctionExpression)((FunctionArgument)exprSource.getArguments().get(0)).getArgumentValue();
				
		selectArg2.setArgumentValue(mapCriteria(((FunctionArgument)exprSource.getArguments().get(1)).getArgumentValue()));
		selectFunc.getArguments().add(selectArg1);
		selectFunc.getArguments().add(selectArg2); 
		FunctionArgument funcArg3 = ModelFactory.eINSTANCE.createFunctionArgument();
		funcArg3.setArgumentValue(selectFunc);	
	
		functionExpr.getArguments().add(2, funcArg3);

		return functionExpr;
	}
	
	private FunctionExpression mapGetAllExpr(FunctionExpression exprSource)
	{
		FunctionExpression functionExpr = null;
		//TODO argument is ALWAYS a modelpathexpression
		//map to a getVariableData - the third argument is a getall function
		
		return functionExpr;
	}

	/**
	 * Maps to the criteria expression	 
	 * @param criteria - a criteria expression in the BOM context
	 * @return Expression - An Expression in the BPEL context
	 */	
	private Expression mapCriteria (Expression criteria)
	{
		
		if (criteria instanceof BinaryOperatorExpression)
			return mapBinaryOperatorExpression((BinaryOperatorExpression)criteria);
		else if (criteria instanceof UnaryOperatorExpression)
			return mapUnaryOperatorExpression((UnaryOperatorExpression)criteria);
		else if (criteria instanceof FunctionExpression)
			return mapFunctionExpression((FunctionExpression)criteria);
		else if (criteria instanceof ModelPathExpression)
			return mapModelPathExpression((ModelPathExpression)criteria);
		else if (criteria instanceof LiteralExpression)
			return mapLiteralExpression((LiteralExpression)criteria);
		else
			return null;				
	
	}

	private XSDParticle findXSDParticle(Property prop) {
		return (XSDParticle)TransformationUtil.getRuleForSource(getRoot(),PropertyRule.class,prop).getTarget().get(0);
	}

	private ModelPathExpression createPartStepOnlyMPE(List stepsList) {
		boolean isFirstStep = true;	
		Step tempStep;	
		List tempStepsList = new LinkedList();				
		for (int i=0; i<stepsList.size(); i++)
		{			
			tempStep = (Step)stepsList.get(i);
			if ((tempStep instanceof ReferenceStep) && (((ReferenceStep)tempStep).getReferencedObject() instanceof Pin) || (((ReferenceStep)tempStep).getReferencedObject() instanceof Variable)){
				StaticStep partNameStep = ModelFactory.eINSTANCE.createStaticStep();
				
//				PartRule partRule = (PartRule)TransformationUtil.getRuleForSource(ProcessUtil.getProcessInterfaceRule
//										(getContext()),PartRule.class,((ReferenceStep)tempStep).getReferencedObject());
//				Part destPart = (Part)partRule.getTarget().get(0);
//				String partName = destPart.getName(); 
//				partNameStep.setStepName(partName);
//				tempStepsList.add(partNameStep);
	
				
				String variableName = "";
				BPELVariable destVar = null;
				
				destVar = (BPELVariable)TransformationUtil.getRuleForSource(ProcessUtil.getProcessDefinitionRule
						(getContext()),VariableRule.class,((ReferenceStep)tempStep).getReferencedObject()).getTarget().get(0);
				variableName = destVar.getName();
				
				partNameStep.setStepName(variableName);
				tempStepsList.add(partNameStep);
				TypedElement typedElement = (TypedElement)((ReferenceStep)tempStep).getReferencedObject();
			//	TypedElement typedElement = (TypedElement)partRule.getSource().get(0);
				if (typedElement instanceof MultiplicityElement) {
					if (BomUtils.isMultipled((MultiplicityElement)typedElement)) {
						// if the typedElement has upperbound > 1, that means a List wrapper
						// must have been created for the Pin
//						Part part = (Part)partRule.getTarget().get(0);
//						XSDTypeDefinition typeDef = part.getTypeDefinition();	
						XSDTypeDefinition typeDef = destVar.getType();
						XSDParticle xsdElement = (XSDParticle)((XSDModelGroup)typeDef.getComplexType().getContent()).getContents().get(0);
						ReferenceStep itemStep = ModelFactory.eINSTANCE.createReferenceStep();
						itemStep.setReferencedObject(xsdElement);
						tempStepsList.add(itemStep);
					}
				}
			}
		}	
		ModelPathExpression mpeExpr = ModelFactory.eINSTANCE.createModelPathExpression();
		mpeExpr.getSteps().addAll(tempStepsList);
		mpeExpr.setIsAbsolute(Boolean.TRUE);
		return mpeExpr;	
	}
	
	/**
	 * This method attempts to find the first pinSet (input or output) that contains a Pin.  Notice a pin can never appear
	 * in both input and output pinset.
	 * @param pin
	 * @return
	 */
	private PinSet findPinSetForPin(Pin pin) {
		Action action = (Action)pin.eContainer();
		Iterator it = action.getInputPinSet().iterator();
		InputPinSet inPinSet;
		while (it.hasNext()) {
			inPinSet = (InputPinSet)it.next();
			// it can never be control pin
			if (inPinSet.getInputObjectPin().contains(pin)) {
				return inPinSet;
			}
			
		}
		it = action.getOutputPinSet().iterator();
		OutputPinSet outPinSet;
		while (it.hasNext()) {
			outPinSet = (OutputPinSet)it.next();
			// it can never be control pin
			if (outPinSet.getOutputObjectPin().contains(pin)) {
				return outPinSet;
			}
		}
		return null;  // This should never happened!!
	}
	
	private String getOwnerActionName(){	
		String name = null;
		
		if(getParentRule() != null){
			if(getParentRule() instanceof LoopNodeRule){
				name = ((InputPinSet)((LoopNodeRule)getParentRule()).getSource().get(0)).getAction().getName();
			}else if(getParentRule() instanceof DecisionRule){
				name = ((InputPinSet)((DecisionRule)getParentRule()).getSource().get(0)).getAction().getName();
			}
		}
		if(name == null){
			name = ((Activity)ProcessUtil.getProcessDefinitionRule(getContext()).getSource().get(0)).getName();
		}
		return name;
	}


} //ExpressionRuleImpl
