/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * $Id: HTReusableTaskRuleImpl.java,v 1.6.4.1 2009/04/13 18:47:11 build Exp $
 */
package com.ibm.btools.te.ilm.heuristics.abstractbpel.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Set;

import com.ibm.btools.blm.ie.exprt.ExportSession;
import com.ibm.btools.blm.ie.exprt.option.BpelOptions;
import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.bom.model.processes.activities.Activity;
import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.bom.model.processes.activities.StructuredActivityNode;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.framework.util.TransformationUtil;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelFactory;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelPackage;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.HTReusableTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.HumanTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessInterfaceRule;
import com.ibm.btools.te.ilm.heuristics.helper.BomUtils;
import com.ibm.btools.te.ilm.heuristics.helper.BpelOptionsUtil;
import com.ibm.btools.te.ilm.heuristics.helper.HumanTaskUtil;
import com.ibm.btools.te.ilm.heuristics.helper.TransformationSessionKeyConstants;
import com.ibm.btools.te.ilm.heuristics.scdl.util.ScdlUtil;
import com.ibm.wbit.bpelpp.BPELPlusFactory;
import com.ibm.wbit.bpelpp.CustomProperty;
import com.ibm.wbit.tel.TCustomProperty;
import com.ibm.wbit.tel.TTask;
import com.ibm.wbit.tel.TaskFactory;
import com.ibm.wsspi.sca.scdl.DocumentRoot;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.wst.wsdl.PortType;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HT Reusable Task Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class HTReusableTaskRuleImpl extends ActionRuleImpl implements HTReusableTaskRule {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2008, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HTReusableTaskRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return AbstractbpelPackage.Literals.HT_REUSABLE_TASK_RULE;
	}

	/* (non-Javadoc)
	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target()
	 */
	public boolean transformSource2Target() {
		LoggingUtil.traceEntry(this, "transformSource2Target");

		boolean ret=false;
		StructuredActivityNode san = (StructuredActivityNode)getSource().get(0); //TODO: should be HumanTask
		InputPinSet inputSet = (InputPinSet)san.getInputPinSet().get(0);

		// Need to get the PortType to create the SCDL Component/Export
		Action action = inputSet.getAction();
		ProcessInterfaceRule processIntRule = createProcessInterfaceRule(action);
		TransformationRule portTypeRule = createPortTypeRule(processIntRule,action);	
		PortType taskInterface = (PortType)portTypeRule.getTarget().get(0);
		
		// Create TEL
		HumanTaskRule humanTask = AbstractbpelFactory.eINSTANCE.createHumanTaskRule();
		getChildRules().add(humanTask);
		humanTask.getSource().add(san);
		humanTask.getSource().add(taskInterface);
		humanTask.transformSource2Target();
		com.ibm.wbit.tel.DocumentRoot humanTaskRoot = (com.ibm.wbit.tel.DocumentRoot)humanTask.getTarget().get(0);
		
		createCustomProperty(((Activity)action.eContainer()), humanTaskRoot.getTask());
		
		
		HumanTaskUtil.registerHumanTask(getContext(),humanTaskRoot);
		// Create SCDL Component
		DocumentRoot componentRoot = createSCDLComponent(action,taskInterface);
	    // Create SCDL Export
	    DocumentRoot exportRoot = createSCDLExport(componentRoot,taskInterface);
	    ExportSession exportSession = BpelOptionsUtil.getExportSession();		
	    if(BpelOptions.isBestPracticePatternEnabed(exportSession)){
			Object docRootRegistry = exportSession.getExportOptions().getAdditionalOption(TransformationSessionKeyConstants.TOP_LEVEL_DOCUMENT_ROOT);
			if(docRootRegistry instanceof Set){
				((Set)docRootRegistry).add(componentRoot);
				((Set)docRootRegistry).add(exportRoot);
				((Set)docRootRegistry).add(humanTaskRoot);
			}			
		}		
	    // Create SCDL Export
		//feature 118131, only create SCDL Export if we have created a Component
		//AZ WMT 20070322 add pattern support
//		ExportSession exportSession = BpelOptionsUtil.getExportSession();
//		if(ScdlUtil.isComponent(componentRoot)|| BpelOptions.isBestPracticePatternEnabed(exportSession)){
//			createSCDLExport(componentRoot,taskInterface);
//		}
	    propagateChildTargets();
		setComplete(true);
		LoggingUtil.traceExit(this, "transformSource2Target");
		return isComplete();	
	}
	
	/**
	 * Creates a custom property which identifies the moduleName to be used as filter in the BusinessSpace.
	 * @param activity
	 * @param task
	 */
	public void createCustomProperty(Activity activity, TTask task) {
		
		String moduleName = BpelOptionsUtil.getWPSModuleyNameForElement(activity.getUid());
		if(moduleName != null){
			TCustomProperty property = TaskFactory.eINSTANCE.createTCustomProperty();
			property.setName("BUSINESS_SPACE_HUMAN_TASK_FILTER");
			property.setValue(moduleName);
			if(task.getCustomProperty() != null){
				task.getCustomProperty().add(property);
			}
		}
		
	}
	
} //HTReusableTaskRuleImpl