/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * $Id: HTTaskRuleImpl.java,v 1.10.4.1 2009/04/13 18:47:11 build Exp $
 */
package com.ibm.btools.te.ilm.heuristics.abstractbpel.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Iterator;
import java.util.List;
import java.util.Set;

import com.ibm.btools.blm.ie.exprt.ExportSession;
import com.ibm.btools.blm.ie.exprt.option.BpelOptions;
import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.bom.model.processes.activities.OutputPinSet;
import com.ibm.btools.bom.model.processes.activities.StructuredActivityNode;
import com.ibm.btools.bom.model.processes.businessrules.BusinessRuleAction;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.ExportOperation;
import com.ibm.btools.te.ilm.ExportOperationUtil;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.TransformationEngine;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelFactory;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelPackage;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.HTTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.HumanTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.InvokeRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.PartnerRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessDefinitionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessInterfaceRule;
import com.ibm.btools.te.ilm.heuristics.helper.AbstractbpelConstants;
import com.ibm.btools.te.ilm.heuristics.helper.BomUtils;
import com.ibm.btools.te.ilm.heuristics.helper.BpelOptionsUtil;
import com.ibm.btools.te.ilm.heuristics.helper.HumanTaskUtil;
import com.ibm.btools.te.ilm.heuristics.helper.ProcessUtil;
import com.ibm.btools.te.ilm.heuristics.helper.TransformationSessionKeyConstants;
import com.ibm.btools.te.ilm.heuristics.helper.TransformationSessionUtil;
import com.ibm.btools.te.ilm.heuristics.scdl.util.ScdlUtil;
import com.ibm.btools.te.ilm.heuristics.wsdl.PartnerLinkRule;
import com.ibm.wbit.bpel.BPELFactory;
import com.ibm.wbit.bpel.Invoke;
import com.ibm.wbit.bpel.Process;
import com.ibm.wbit.bpelpp.BPELPlusFactory;
import com.ibm.wbit.bpelpp.Task;
import com.ibm.wbit.tel.TTask;
import com.ibm.wsspi.sca.scdl.DocumentRoot;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.wst.wsdl.Definition;
import org.eclipse.wst.wsdl.Operation;
import org.eclipse.wst.wsdl.PortType;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HT Task Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class HTTaskRuleImpl extends ActionRuleImpl implements HTTaskRule {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2008, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	/* attribute indicate whether it is first time execution of this rule */
	  private boolean firstTimeExec = true;	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HTTaskRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return AbstractbpelPackage.Literals.HT_TASK_RULE;
	}

	/* (non-Javadoc)
	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target()
	 */
	public boolean transformSource2Target() {
		LoggingUtil.traceEntry(this, "transformSource2Target");
		// Re-execute the HT rule. 75770
		if(!firstTimeExec){
			//Invoke is always the second child rule, first one being the HumanTaskRule
			 InvokeRule invokeRule = (InvokeRule)getChildRules().get(1); 
			 invokeRule.transformSource2Target();
			 LoggingUtil.traceExit(this, "transformSource2Target", "re-execute");
			 return true;		  
		}
		firstTimeExec = false;
		//StructuredActivityNode san = (StructuredActivityNode)getSource().get(0); //TODO: should be HumanTask
		InputPinSet inputSet = (InputPinSet)getSource().get(0);

		// Need to get the PortType to create the SCDL Component/Export
		Action action = inputSet.getAction();
		ProcessInterfaceRule processIntRule = createProcessInterfaceRule(action);
		TransformationRule portTypeRule = createPortTypeRule(processIntRule,action);
		
		PortType taskInterface = (PortType)portTypeRule.getTarget().get(0);
		
		// Create TEL
		HumanTaskRule humanTask = AbstractbpelFactory.eINSTANCE.createHumanTaskRule();
		getChildRules().add(humanTask);
		humanTask.getSource().add(action);
		humanTask.getSource().add(taskInterface);
		humanTask.transformSource2Target();
		com.ibm.wbit.tel.DocumentRoot humanTaskRoot = (com.ibm.wbit.tel.DocumentRoot)humanTask.getTarget().get(0);
		HumanTaskUtil.registerInlineHumanTask(getContext(),humanTaskRoot);

	    ExportSession exportSession = BpelOptionsUtil.getExportSession();		
	    if(BpelOptions.isBestPracticePatternEnabed(exportSession)){
			Object docRootRegistry = exportSession.getExportOptions().getAdditionalOption(TransformationSessionKeyConstants.TOP_LEVEL_DOCUMENT_ROOT);
			if(docRootRegistry instanceof Set){
				((Set)docRootRegistry).add(humanTaskRoot);
			}			
		}
		// Create SCDL Component
//		DocumentRoot componentRoot = createSCDLComponent(action,taskInterface);
	    // Create SCDL Export
		//feature 118131, only create SCDL Export if we have created a Component
		//AZ WMT 20070322 add pattern support
//		ExportSession exportSession = BpelOptionsUtil.getExportSession();
//		if(ScdlUtil.isComponent(componentRoot)|| BpelOptions.isBestPracticePatternEnabed(exportSession)){
//			createSCDLExport(componentRoot,taskInterface);
//		}

		// Create invoke activity for inline task
		InvokeRule ir = AbstractbpelFactory.eINSTANCE.createInvokeRule();
		
		// create child rule - invoke rule
		// add ir as child rule (and make sure we add it as the first child rule)
		getChildRules().add(ir);	
		
		// Create Partner  
//		PartnerLinkRule partnerLinkRule= createPartnerLinkRule(processIntRule,action,taskInterface);
//		PartnerRule partnerRule = null;
//		// Partner Rule will create component reference
//		ProcessDefinitionRule processDefRule = (ProcessDefinitionRule)ProcessUtil.getProcessDefinitionRule(getContext());
//		partnerRule = createPartnerRule(processDefRule,action);
		Operation op=findOperation(processIntRule,inputSet);
		// Add the operation to the Component Reference
//		ScdlUtil.updateSCDLComponentReference(ProcessUtil.getProcessComponent(getContext()),taskInterface,op);
		
		// Now that we have the partner and operation, set them as
		// sources of the InvokeRule
		ir.getSource().add(inputSet);
		ir.getSource().add(action);
		ir.getSource().add(op);
//		ir.getSource().add(partnerRule.getTarget().get(0));
		
		// NOTE: Mapping and connecting the input sets / output sets is done by the InvokeRule
		
		// Execute the invoke rule
		ir.transformSource2Target();			
		Invoke invoke = (Invoke)ir.getTarget().get(0);
		
		//AdminTask adminTask = BPELPlusFactory.eINSTANCE.createAdminTask();
		Task adminTask = BPELPlusFactory.eINSTANCE.createTask();
		TTask task = humanTaskRoot.getTask();
		//remove the task Display name. 
		if(task.getDisplayName() != null && !task.getDisplayName().isEmpty()){
			task.getDisplayName().remove(task.getDisplayName().get(0));
		}
		if (task.getDurationUntilDeleted() != null) {
			task.setDurationUntilDeleted(null);
		}
		if (task.getStaffSettings().getPotentialInstanceCreator()!=null) {
			task.getStaffSettings().setPotentialInstanceCreator(null);
		}
		adminTask.setName(task);
		invoke.getEExtensibilityElements().add(adminTask);
		ProcessDefinitionRule currentProcessDefRule= (ProcessDefinitionRule)ProcessUtil.getProcessDefinitionRule(this.getContext());
		Process process = (Process)currentProcessDefRule.getTarget().get(0);
		// Ray - d162886
		// All itel needs to have a name prepended by the process name
		String newTaskName = task.getName();
		newTaskName = process.getName()+"_"+newTaskName;
		task.setName(newTaskName);

		// Ray - d161607
		//organizeImports(process, humanTaskRoot);
		organizeImports(process, taskInterface);
		//propagate all child target
		propagateChildTargets();
		
		setComplete(true);
		
		executeHandlers();
		
		LoggingUtil.traceExit(this, "transformSource2Target");
		return isComplete();		
	}	
	
	// d159506
	private void organizeImports(Process processDef,Object obj) {
		if(obj instanceof PortType){
			Definition toBeImportedDef = ((PortType)obj).getEnclosingDefinition();
			String namespace = toBeImportedDef.getTargetNamespace();
			
			//should add wsdl import.. leave it for the one that is saving the resource
			if(!containsImport(processDef, namespace)){
				//we need to import the schema 
				com.ibm.wbit.bpel.Import wsdlImport = BPELFactory.eINSTANCE.createImport();
				if (toBeImportedDef.getLocation() != null && ExportOperationUtil.isExternalFile(toBeImportedDef.getLocation())) {
					wsdlImport.setLocation(ExportOperationUtil.replaceConvertedSpaces(toBeImportedDef.getLocation()));
				} else {
					wsdlImport.setLocation(toBeImportedDef.getQName().getLocalPart()+ExportOperation.WSDL_FILE_EXT);
				}
				wsdlImport.setNamespace(namespace);
				wsdlImport.setImportType(AbstractbpelConstants.WSDL_IMPORT_TYPE);
				if (!wsdlImport.getLocation().equals(ExportOperation.WSDL_FILE_EXT)) {
					processDef.getImports().add(wsdlImport);
				}
			}
		} else {
			com.ibm.wbit.tel.DocumentRoot docRoot = (com.ibm.wbit.tel.DocumentRoot)obj;
			URI namespaceURI = docRoot.getTask().getTargetNamespace();
			String namespace = namespaceURI.toString();
			if(!namespace.equals(processDef.getTargetNamespace())){
				if(!containsImport(processDef,namespace)){
					//we need to import the tel file 
					com.ibm.wbit.bpel.Import wsdlImport = BPELFactory.eINSTANCE.createImport();
					wsdlImport.setLocation(docRoot.getTask().getName() + ExportOperation.ITEL_FILE_EXT );
					wsdlImport.setNamespace(namespace);
					wsdlImport.setImportType(AbstractbpelConstants.XSD_IMPORT_TYPE);
					if (!wsdlImport.getLocation().equals(ExportOperation.ITEL_FILE_EXT)) {
						processDef.getImports().add(wsdlImport);
					}
				}
			}

		}
	}
	
	/**
	 * Checks is the Process already contains a itel import for the <code>targetNamespace</code> 
	 * @param targetNamespace 
	 * @return
	 */
	private boolean containsImport(Process process, String targetNamespace){
		
		List imports = process.getImports();
		if(imports != null && !imports.isEmpty()){
			Iterator it = imports.iterator();
			while(it.hasNext()){
				com.ibm.wbit.bpel.Import thisImport = (com.ibm.wbit.bpel.Import)it.next();
				if(thisImport.getImportType() != null && thisImport.getImportType().equals(AbstractbpelConstants.WSDL_IMPORT_TYPE) && thisImport.getNamespace().equals(targetNamespace)){
					return true;
				}
			}
		}
		return false;
	}
} //HTTaskRuleImpl