/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.abstractbpel.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.wst.wsdl.ExtensibilityElement;
import org.eclipse.wst.wsdl.Part;
import org.eclipse.xsd.XSDComplexTypeDefinition;
import org.eclipse.xsd.XSDElementDeclaration;
import org.eclipse.xsd.XSDModelGroup;
import org.eclipse.xsd.XSDParticle;
import org.eclipse.xsd.XSDTypeDefinition;

import com.ibm.btools.bom.model.artifacts.InstanceSpecification;
import com.ibm.btools.bom.model.artifacts.InstanceValue;
import com.ibm.btools.bom.model.artifacts.LiteralNull;
import com.ibm.btools.bom.model.artifacts.LiteralSpecification;
import com.ibm.btools.bom.model.artifacts.LiteralString;
import com.ibm.btools.bom.model.artifacts.ValueSpecification;
import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.bom.model.processes.activities.InputValuePin;
import com.ibm.btools.bom.model.processes.activities.OutputPinSet;
import com.ibm.btools.bom.model.processes.activities.Pin;
import com.ibm.btools.bom.model.processes.activities.PinSet;
import com.ibm.btools.bom.model.services.BehavioredClass;
import com.ibm.btools.expression.function.CoreFunctions;
import com.ibm.btools.expression.model.ComparisonExpression;
import com.ibm.btools.expression.model.ComparisonOperator;
import com.ibm.btools.expression.model.FunctionArgument;
import com.ibm.btools.expression.model.FunctionDefinition;
import com.ibm.btools.expression.model.FunctionExpression;
import com.ibm.btools.expression.model.IntegerLiteralExpression;
import com.ibm.btools.expression.model.ModelFactory;
import com.ibm.btools.expression.model.ModelPathExpression;
import com.ibm.btools.expression.model.StaticStep;
import com.ibm.btools.expression.model.StringLiteralExpression;
import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.framework.util.TransformationUtil;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelPackage;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ContainerRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.InputValuePinRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.VariableRule;
import com.ibm.btools.te.ilm.heuristics.helper.AbstractbpelUtil;
import com.ibm.btools.te.ilm.heuristics.helper.BomUtils;
import com.ibm.btools.te.ilm.heuristics.helper.BpelOptionsUtil;
import com.ibm.btools.te.ilm.heuristics.helper.ProcessUtil;
import com.ibm.btools.te.ilm.heuristics.naming.NameProvider;
import com.ibm.btools.te.ilm.heuristics.naming.NameProviderFactory;
import com.ibm.btools.te.ilm.heuristics.naming.NamingUtil;
import com.ibm.btools.te.ilm.heuristics.wsdl.PartRule;
import com.ibm.btools.te.ilm.model.abstractbpel.Alternative;
import com.ibm.btools.te.ilm.model.abstractbpel.AlternativeActivity;
import com.ibm.btools.te.ilm.model.abstractbpel.ExtensibilityExpression;
import com.ibm.btools.te.ilm.model.sa.ProcessFlowType;
import com.ibm.btools.te.ilm.resource.MessageKeys;
import com.ibm.wbit.bpel.Activity;
import com.ibm.wbit.bpel.Assign;
import com.ibm.wbit.bpel.BPELFactory;
import com.ibm.wbit.bpel.BPELVariable;
import com.ibm.wbit.bpel.Copy;
import com.ibm.wbit.bpel.From;
import com.ibm.wbit.bpel.Invoke;
import com.ibm.wbit.bpel.To;
import com.ibm.wbit.bpel.Variable;
import com.ibm.wbit.bpel.impl.BPELFactoryImpl;
import com.ibm.wbit.bpelpp.BPELPlusFactory;
import com.ibm.wbit.bpelpp.JavaCode;
import com.ibm.wbit.bpelpp.JavaScriptActivity;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Input Value Pin Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class InputValuePinRuleImpl extends ConnectableRuleImpl implements InputValuePinRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InputValuePinRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return AbstractbpelPackage.Literals.INPUT_VALUE_PIN_RULE;
	}

	/* 
	 * SOURCE = InputValuePin
	 * TARGET = <assign>, that assigns the value of the InputValuePin
	 * 
	 * RESTRICTION: InputValuePin must have a 'value' that is a LiteralSpecification instance
	 * 
	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target()
	 */
	public boolean transformSource2Target() {
		LoggingUtil.traceEntry(this, "transformSource2Target");

		if (getSource().isEmpty() || !(getSource().get(0) instanceof InputValuePin)){
			LoggingUtil.traceExit(this, "transformSource2Target", "no source");
			return false;
		}
		
		InputValuePin sourcePin = (InputValuePin)getSource().get(0);

		/* Get the variable associated with the pin*/
		BPELVariable destVariable = (BPELVariable)TransformationUtil.getRuleForSource(getRoot(), VariableRule.class, sourcePin).getTarget().get(0);

		/* Create an AlterativeActivity with two alternatives, one for BPEL and one for BPEL+ since
		 * BPEL+ doesn't support XPath expressions in <assign> activities */
		Activity ivpActivity = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createAlternativeActivity();

		NameProvider nameProvider = NameProviderFactory.getNameProvider(ivpActivity);
		String convertedName = nameProvider.getName(ivpActivity, sourcePin, NamingUtil.findRegistry(this));
		ivpActivity.setName(convertedName);
		
		Alternative bpelAlt = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createAlternative();		
		Alternative bpelpAlt = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createAlternative();
		
		bpelAlt.setType(ProcessFlowType.BPEL_LITERAL);
		bpelpAlt.setType(ProcessFlowType.BPELPP_LITERAL);
			
		((AlternativeActivity)ivpActivity).getAlternative().add(bpelAlt);
		((AlternativeActivity)ivpActivity).getAlternative().add(bpelpAlt);
			
		/* BPEL: Create <assign>, with multiple BPEL Copies, one for each input value pin value*/
		//bpelAlt.setActivity(createAssign(sourcePin, destVariable, destPart));
			
		/* BPEL+: Create <invoke><wpc:script><wpc:javaCode>... */
		bpelpAlt.setActivity(createJavaInvoke(sourcePin, destVariable));
		/* Propagate this target to the parent */
		getTarget().add(ivpActivity);
		
		executeHandlers();
		
		LoggingUtil.traceExit(this, "transformSource2Target");
		return true;
	}
	
	/**
	 * Creates the Java code in a BPEL Invoke activity to set the value of the pin variable
	 * based on the literal.
	 * 
	 * @param sourcePin The InputValuePin to get the value from
	 * @param destVariable That variable to update
	 * @return Invoke - The BPEL Invoke, filled with a JavaScripActivity and JavaCode
	 */	
	private Invoke createJavaInvoke(InputValuePin sourcePin, BPELVariable destVariable){
		Invoke javaInvoke = AbstractbpelUtil.createJavaInvoke();
		JavaScriptActivity jsActivity = BPELPlusFactory.eINSTANCE.createJavaScriptActivity();
		JavaCode javaCode = BPELPlusFactory.eINSTANCE.createJavaCode();
		String javaString = new String();
		javaString += createJavaInvokeString(sourcePin, destVariable);

		jsActivity.setJavaCode(javaString);
		javaInvoke.getExtensibilityElements().add(jsActivity);
		
		createDisplayName(javaInvoke,"Set value for " + sourcePin.getName());		
		return javaInvoke;
		
	}
	
	/**
	 * Creates the Java invoke code.
	 * @param sourcePin - an InputValuePin
	 * @param destVariable - BPEL Variable
	 * @return String the JavaInvokeString
	 */
	
	private String createJavaInvokeString(InputValuePin sourcePin, BPELVariable destVariable){
		String javaString = new String();
		Object value = null;
		Object obj = null;
		PinSet pinSet = findPinSetForPin(sourcePin);
		
		boolean isDestAList = AbstractbpelUtil.isTransformedMultiplicityElementAList(sourcePin, destVariable);
		
		String variableName = destVariable.getName();
		XSDTypeDefinition variableTypeDefinition = destVariable.getType();
				
		if(isDestAList){
			javaString += AbstractbpelUtil.initializeVariable(destVariable);
			String listElement = AbstractbpelUtil.getNameOfListElement((XSDComplexTypeDefinition)destVariable.getType());
//			initialize a java.util.List
			javaString += "java.util.List " +  listElement + " = new java.util.LinkedList();\n";
			if(sourcePin.getValue()!= null && !sourcePin.getValue().isEmpty()){
				for(int i=0; i<sourcePin.getValue().size(); i++){
					obj = sourcePin.getValue().get(i);
					if (obj instanceof LiteralSpecification){
						value = AbstractbpelUtil.getLiteralValue((LiteralSpecification)obj, ((LiteralSpecification)obj).getType());
					}
					//populate the list with elements...
					javaString += listElement +
					".add("+i+"," +  AbstractbpelUtil.getLiteralAssignmentString(value, destVariable) + ");\n";
				}
			}
			javaString += AbstractbpelUtil.generateJavaSetterForVariableDiamond(variableName, listElement, variableTypeDefinition, listElement) +";\n";
		}else{
			String toGetter = null;
			if(sourcePin.getValue() != null && !sourcePin.getValue().isEmpty()){
				obj  = sourcePin.getValue().get(0);
			}else{
				obj = null;
			}
				if(obj==null || obj instanceof LiteralNull || !(obj instanceof LiteralSpecification) || isEmptyLitSpec((LiteralSpecification)obj)){
					toGetter = "null";
				}else{
					value = AbstractbpelUtil.getLiteralValue((LiteralSpecification)obj, ((LiteralSpecification)obj).getType());
					toGetter = AbstractbpelUtil.getLiteralAssignmentString(value, destVariable);
				}
				javaString += variableName + "= " + toGetter + ";";
		}
		return javaString;		
	}
	
	/**
	 * Handle the case of a LiteralSpecification with an empty String as value. (as per UI unexpected behaviour)
	 * defect 117286
	 * @param litSpec
	 * @return
	 */
	private boolean isEmptyLitSpec(LiteralSpecification litSpec){
		
		if (litSpec instanceof LiteralString ){
			if(((LiteralString)litSpec).getValue().equals("")){
				return true;
			}
		}
		return false;
		
	}

	/* 
	 * SOURCE = InputValuePin
	 * TARGET = <assign>, that assigns the value of the InputValuePin
	 * 
	 * RESTRICTION: InputValuePin must have a 'value' that is a LiteralSpecification instance
	 * 
	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target()
	 */
	public boolean transformSource2Target_bak() {
		LoggingUtil.traceEntry(this, "transformSource2Target");

		if (getSource().isEmpty() || !(getSource().get(0) instanceof InputValuePin)){
			LoggingUtil.traceExit(this, "transformSource2Target", "no source");
			return false;
		}
		
		InputValuePin sourcePin = (InputValuePin)getSource().get(0);

		/* Check the attributes that are not supported by the TE */
		Object obj;

		/* We must create an <assign> that sets the value of the Variable Part associated
		 * with the pin to the 'value's of the pin */
		/* It is a restriction that each pin belongs to only one pin set */
		InputPinSet is = (InputPinSet)BomUtils.getInputPinSets(sourcePin).get(0);
		
		/* Get the variable and part associated with the pin, go from the root, just in case the 
		 * input value pin is on a CallBehaviourAction or CallOperationAction */
		Variable destVariable = (Variable)TransformationUtil.getRuleForSource(getRoot(), ContainerRule.class, is).getTarget().get(0);
		Part destPart = null;
		//if the Action to which this set belongs to generates a multiPart WSDL, then retrieve the 
		// destination Part from the Rule that has as source the Pin, else the retrieve the Part from the Rule that have as source the pinSet.  
		if(!isWSICompliant(is.getAction())){
			destPart = (Part)TransformationUtil.getRuleForSource(getRoot(),	PartRule.class,	sourcePin).getTarget().get(0);
		}else{
			destPart = (Part)TransformationUtil.getRuleForSource(getRoot(), PartRule.class, is).getTarget().get(0);	
		}
		/* Create an AlterativeActivity with two alternatives, one for BPEL and one for BPEL+ since
		 * BPEL+ doesn't support XPath expressions in <assign> activities */
		Activity ivpActivity = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createAlternativeActivity();

		NameProvider nameProvider = NameProviderFactory.getNameProvider(ivpActivity);
		String convertedName = nameProvider.getName(ivpActivity, sourcePin, NamingUtil.findRegistry(this));
		
//		JavaNCNameConverter converter = new JavaNCNameConverter();
//		String convertedName = converter.convertName(NamingUtil.findRegistry(this), ivpActivity, BomUtils.getCanonicalName(sourcePin));
		ivpActivity.setName(convertedName);

		
		Alternative bpelAlt = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createAlternative();		
		Alternative bpelpAlt = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createAlternative();
		
		bpelAlt.setType(ProcessFlowType.BPEL_LITERAL);
		bpelpAlt.setType(ProcessFlowType.BPELPP_LITERAL);
			
		((AlternativeActivity)ivpActivity).getAlternative().add(bpelAlt);
		((AlternativeActivity)ivpActivity).getAlternative().add(bpelpAlt);
			
		/* BPEL: Create <assign>, with multiple BPEL Copies, one for each input value pin value*/
		//bpelAlt.setActivity(createAssign(sourcePin, destVariable, destPart));
			
		/* BPEL+: Create <invoke><wpc:script><wpc:javaCode>... */
		bpelpAlt.setActivity(createJavaInvoke(sourcePin, destVariable, destPart));
		/* Propagate this target to the parent */
		getTarget().add(ivpActivity);
		LoggingUtil.traceExit(this, "transformSource2Target");
		return true;
	}

	/**
	 * Creates the BPEL version of the assignment statement to put the value from the InputValuePin
	 * in the destination variable / part.
	 * @param sourcePin The InputValuePin to get the information from
	 * @param destVariable The destination variable to put the information into
	 * @param destPart The part of the destination variable to put the information into
	 * @return Assign - The BPEL Assign to use to set the IVP value, if BPEL is the target endpoint
	 */	
	private Assign createAssign(InputValuePin sourcePin, Variable destVariable, Part destPart){
	
		/* Create an <assign> to copy the values of the expression to the pin part.  Create
		 * a copy for each LiteralSpecification associated with the InputValuePin.
		 * If the type of the sourcePin is a BehavioredClass, will delegate to the 
		 * createAssignForBehavioredClass, that will assign to an endPointReference.
		 * NOTE: We can use multiple copies in a single assign because we don't care
		 *       about the order in which the copies are done */
	
		if(sourcePin.getType() instanceof BehavioredClass){
			return createAssignForBehavioredClass(sourcePin, destVariable, destPart);
		}
		Assign assign = BPELFactoryImpl.eINSTANCE.createAssign();
		Object litSpec = null;
		for (int i=0, length = sourcePin.getValue().size(); i<length; i++){
			litSpec = sourcePin.getValue().get(i);
			String stringSymbol="";
			if (!(litSpec instanceof LiteralSpecification)){
//				BTRuntimeException e = new BTRuntimeException(TEResourceBundleSingleton.INSTANCE.getMessage(MessageKeys.IVP_NOT_LIT_SPEC_NOT_SUPPORTED));
				String params[]={sourcePin.getName(),sourcePin.getAction().getName()};
				LoggingUtil.logError(MessageKeys.IVP_NOT_LIT_SPEC_NOT_SUPPORTED,params,null);
//				throw e;
			} else {
				stringSymbol=AbstractbpelUtil.getLiteralValue((LiteralSpecification)litSpec).toString();			
			}
			
			Copy copy = BPELFactoryImpl.eINSTANCE.createCopy();
			From from = BPELFactoryImpl.eINSTANCE.createFrom();
			//ToExtension toExt = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createToExtension();
			To toExt=BPELFactory.eINSTANCE.createTo();
			/* Create Expression Model for BPEL From */
			ExtensibilityExpression bpelExpr1 = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createExtensibilityExpression();
			StringLiteralExpression strExpr = ModelFactory.eINSTANCE.createStringLiteralExpression();
			strExpr.setStringSymbol(stringSymbol);
			bpelExpr1.setExpression(strExpr);
			from.addExtensibilityElement(bpelExpr1); 
									 
			/* Customize the ToExtension class */
			toExt.setVariable(destVariable);
			toExt.setPart(destPart);
			/* Ray
			 * We only need to create the 'query' expression if the pin's multiplicity is greater than 1 
			 */
			if (length > 1) {
				/* Create an expression model instance to store the queries for From*/
				ExtensibilityExpression bpelExpr2 = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createExtensibilityExpression();					
				bpelExpr2.setExpression(createExpressionModel(destPart, i+1));
				toExt.addExtensibilityElement(bpelExpr2); 	
			}

			copy.setFrom(from);
			
			copy.setTo(toExt);
			assign.getCopy().add(copy);
		}
		
		return assign;
	}
	

	/**
	 * Creates the BPEL version of the assignment statement to put the value from the InputValuePin
	 * in the destination variable / part. 
	 * The destination variable is of type wsa:EndPointReferenceType.
	 * Will create an shell endPointReference. Sets the endPointReference address to the name of the InputValuePin value - 
	 * an InstanceValue of a BehavioredClass instance. Adds documentation to the assign - extensibility element 
	 * with all the BehavioredClass attributes. This attributes may be used for specifying the wsa:EndPointReference
	 * referenceProperties. 
	 * 
	 * @param sourcePin The InputValuePin to get the information from
	 * @param destVariable The destination variable to put the information into
	 * @param destPart The part of the destination variable to put the information into
	 * @return Assign - The BPEL Assign to use to set the IVP value, if BPEL is the target endpoint
	 */	
	private Assign createAssignForBehavioredClass(InputValuePin sourcePin, Variable destVariable, Part destPart){
		/* Create an <assign> to copy the values of the expression to the pin part.  Create
		 * a copy for each LiteralSpecification associated with the InputValuePin.
		*/
			//log a warning as an incomplete endPointReference is generated. User is expected to update the 
		//generated file. 
		LoggingUtil.logWarning(MessageKeys.INCOMPLETE_END_POINT_REFERENCE); 
		Assign assign = BPELFactoryImpl.eINSTANCE.createAssign();
		ValueSpecification valueSpec = (ValueSpecification)sourcePin.getValue().get(0);
		//the valueSpec should be an InstanceValue
		if(valueSpec instanceof InstanceValue){
			InstanceValue instanceValue = (InstanceValue)valueSpec;
			String stringSimbol = null;
			ExtensibilityElement documentation = null;
			InstanceSpecification instanceSpec = null;
			if(instanceValue.getInstance() != null){
				//this is an instance of the BehavioredClass referenced 
				instanceSpec = instanceValue.getInstance();
				stringSimbol = ProcessUtil.createNamespace( instanceSpec);
				//documentation = createDocumentationExtensibleElement(instanceSpec);
				documentation = BomUtils.createDocumentationExtensibleElement(instanceSpec);
			}else if(instanceValue.getOwnedInstance() != null){
				instanceSpec = instanceValue.getOwnedInstance();
				stringSimbol = ProcessUtil.createNamespace(instanceSpec);
				documentation = BomUtils.createDocumentationExtensibleElement(instanceSpec);
			}
			Copy copy = BPELFactoryImpl.eINSTANCE.createCopy();
			From from = BPELFactoryImpl.eINSTANCE.createFrom();
			//ToExtension toExt = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createToExtension();
			To toExt = BPELFactory.eINSTANCE.createTo();
			/* Create Expression Model for BPEL From */
			ExtensibilityExpression bpelExpr1 = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createExtensibilityExpression();
			StringLiteralExpression strExpr = ModelFactory.eINSTANCE.createStringLiteralExpression();
			//set the from value to the name of the instance value
			strExpr.setStringSymbol(stringSimbol);
			bpelExpr1.setExpression(strExpr);
			from.addExtensibilityElement(bpelExpr1); 
			/* Create an expression model instance to store the queries for To*/
			ExtensibilityExpression bpelExpr2 = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createExtensibilityExpression();					
			bpelExpr2.setExpression(createExpressionModel(destPart));
			/* Customize the ToExtension class */
			toExt.setVariable(destVariable);
			toExt.setPart(destPart);
			toExt.addExtensibilityElement(bpelExpr2); 	
			copy.setFrom(from);
			copy.setTo(toExt);
			//copy.getExtensibilityElements().add(documentation);
			assign.getCopy().add(copy);
			assign.getEExtensibilityElements().add(documentation);
		}
		return assign;
	}


	/**
	 * Creates the Java invoke code for the case when the sourcePin belongs to an Action that will generate a single part WSDL message.
	 * - a WSI compliant action.
	 * @param sourcePin
	 * @param destVariable
	 * @param destPart
	 * @return
	 */
	
	private String createJavaInvokeForWSICompliant(InputValuePin sourcePin, Variable destVariable, Part destPart){
		String javaString = new String();
		Object value = null;
		Object obj = null;
		
		int index = findPinIndexInSet(sourcePin);
		boolean isDestAList = AbstractbpelUtil.isTransformedMultiplicityElementAList(sourcePin, destPart, index);
		
		javaString += AbstractbpelUtil.createJavaVariableForPartCode(destVariable, destPart, false);
		
		if(isDestAList){
			javaString += AbstractbpelUtil.createJavaVariableForPartCode(destVariable,destPart,false, index);
		}
		String varName = AbstractbpelUtil.capitalizeFirstChar(destVariable.getName());
		String partName = AbstractbpelUtil.capitalizeFirstChar(destPart.getName());
		String pinElementName = null;
		pinElementName = AbstractbpelUtil.getPinElementName(destPart, index);
		if(isDestAList){
			if(sourcePin.getValue()!= null && !sourcePin.getValue().isEmpty()){
				for(int i=0; i<sourcePin.getValue().size(); i++){
					obj = sourcePin.getValue().get(i);
					if (obj instanceof LiteralSpecification){
						value = AbstractbpelUtil.getLiteralValue((LiteralSpecification)obj, ((LiteralSpecification)obj).getType());
					}
					pinElementName = AbstractbpelUtil.getPinElementName(destPart, index);
					javaString += pinElementName +
							".set" + AbstractbpelUtil.capitalizeFirstChar(AbstractbpelUtil.getNameOfListElement((XSDComplexTypeDefinition)AbstractbpelUtil.getPinTypDefinition(destPart, index)))
											+ "("+i+","
										+  AbstractbpelUtil.getLiteralAssignmentString(value, destPart)
										   + ");\n";
						
				}
			}
		}
		String toGetter = null;
		if(isDestAList){
			toGetter = pinElementName;
		}else{
			obj  = sourcePin.getValue().get(0);
			if(obj==null || obj instanceof LiteralNull || !(obj instanceof LiteralSpecification)){
				toGetter = "null";
			}else{
				value = AbstractbpelUtil.getLiteralValue((LiteralSpecification)obj, ((LiteralSpecification)obj).getType());		
				toGetter = AbstractbpelUtil.getLiteralAssignmentString(value, destPart);
			}
		}
		
		javaString += varName + "." +
						AbstractbpelUtil.generateJavaSetterForVariable(pinElementName) +"(" + toGetter +");\n";
		
		javaString += AbstractbpelUtil.createJavaPartSetterCode(destVariable,destPart,partName);
		
		return javaString;		
	}
	
	/**
	 * Creates the Java invoke code for the case when the sourcePin belongs to an Action that will generate a single part WSDL message.
	 * - a WSI compliant action.
	 * @param sourcePin
	 * @param destVariable
	 * @param destPart
	 * @return
	 */
	
	private String createJavaInvokeForWSICompliantSDOSupport(InputValuePin sourcePin, Variable destVariable, Part destPart){
		String javaString = new String();
		Object value = null;
		Object obj = null;
		PinSet pinSet = findPinSetForPin(sourcePin);
		int index;
		if(pinSet instanceof InputPinSet && ((InputPinSet)pinSet).getInputObjectPin().size() == 1 && !BpelOptionsUtil.isAlwaysGenerateWraperComplexType()){
			index = -1;
		}else{
			index= findPinIndexInSet(sourcePin);	
		}
		javaString += AbstractbpelUtil.initializeVariable(destVariable, destPart, true);
		
		boolean isDestAList = AbstractbpelUtil.isTransformedMultiplicityElementAList(sourcePin, destPart, index);
		if(index != -1)
			javaString += AbstractbpelUtil.createJavaVariableForPartCodeDiamond(destVariable, destPart, false, index);
		
		String varName = destVariable.getName();
		String pinElementName = null;
		if(index == -1 ){
			pinElementName = destVariable.getName();
		}else{
			pinElementName = AbstractbpelUtil.getPinElementName(destPart, index);
		}
		
		XSDTypeDefinition pinPartType = AbstractbpelUtil.getPinTypDefinition(destPart, index);
				
		if(isDestAList){
			String listElement = AbstractbpelUtil.getNameOfListElement((XSDComplexTypeDefinition)AbstractbpelUtil.getPinTypDefinition(destPart, index));
			if(sourcePin.getValue()!= null && !sourcePin.getValue().isEmpty()){
//				initialize a java.util.List
				javaString += "java.util.List " +  listElement + " = new java.util.LinkedList();\n";
				for(int i=0; i<sourcePin.getValue().size(); i++){
					obj = sourcePin.getValue().get(i);
					if (obj instanceof LiteralSpecification){
						value = AbstractbpelUtil.getLiteralValue((LiteralSpecification)obj, ((LiteralSpecification)obj).getType());
					}
					//populate the list with elements...
					javaString += listElement +
					".add("+i+"," +  AbstractbpelUtil.getLiteralAssignmentString(value, destPart) + ");\n";
				}
			}
			javaString += AbstractbpelUtil.generateJavaSetterForVariableDiamond(pinElementName, listElement, pinPartType, listElement);
		}else{
			String toGetter = null;
				obj  = sourcePin.getValue().get(0);
				if(obj==null || obj instanceof LiteralNull || !(obj instanceof LiteralSpecification)){
					toGetter = "null";
				}else{
					value = AbstractbpelUtil.getLiteralValue((LiteralSpecification)obj, ((LiteralSpecification)obj).getType());	
					if(index == -1){
						toGetter = AbstractbpelUtil.getLiteralAssignmentObject(value, destPart);
					}else{
						toGetter = AbstractbpelUtil.getLiteralAssignmentString(value, destPart);			
					}
			
			}
				if(index == -1){
					//javaString += varName + "=" + toGetter + ";\n";
					javaString += "setVariable(" + varName + ", " + toGetter + ")";
				}else{
					javaString += AbstractbpelUtil.generateJavaSetterForVariableDiamond(varName, pinElementName, pinPartType, toGetter)+ ";\n";
				}
				
		}
		return javaString;		
	}
	
	/** 
	 * Creates the Java invoke code for the case when the sourcePin belongs to an Activity that will generate a multi part WSDL message.
	 * @param sourcePin
	 * @param destVariable
	 * @param destPart
	 * @return
	 */
	private String createJavaInvokeForNonWSICompliant(InputValuePin sourcePin, Variable destVariable, Part destPart){
		String javaString = new String();
		Object value = null;
		Object obj = null;
		int index = findPinIndexInSet(sourcePin);
		boolean isDestAList = AbstractbpelUtil.isTransformedMultiplicityElementAList(sourcePin, destPart, index);

		if(isDestAList){
			javaString += AbstractbpelUtil.createJavaVariableForPartCode(destVariable,destPart,false);

		}
		if(sourcePin.getValue()!= null && !sourcePin.getValue().isEmpty()){
			for(int i=0; i<sourcePin.getValue().size(); i++){
				obj = sourcePin.getValue().get(i);
				if (obj instanceof LiteralSpecification){
					value = AbstractbpelUtil.getLiteralValue((LiteralSpecification)obj, ((LiteralSpecification)obj).getType());
				}
				if(!isDestAList){
					String varName = AbstractbpelUtil.capitalizeFirstChar(destVariable.getName());
					String partName = AbstractbpelUtil.capitalizeFirstChar(destPart.getName());
						if(obj==null || obj instanceof LiteralNull || !(obj instanceof LiteralSpecification)){
							javaString += AbstractbpelUtil.generateJavaGetterForVariable(varName) + "(true)"
													+ ".set" + partName + "(null);\n";
						}else{
							javaString += AbstractbpelUtil.generateJavaGetterForVariable(varName) + "(true)"
										+ ".set" + partName + "(" + AbstractbpelUtil.getLiteralAssignmentString(value, destPart) + ");\n";
						}
				}else{
					String varName = AbstractbpelUtil.capitalizeFirstChar(destVariable.getName());
					String partName = AbstractbpelUtil.capitalizeFirstChar(destPart.getName());
					String toGetter = partName;
						javaString += toGetter
							   + ".set" + AbstractbpelUtil.capitalizeFirstChar(AbstractbpelUtil.getNameOfListElement((XSDComplexTypeDefinition)destPart.getTypeDefinition()))+"("+i+","
							   +  AbstractbpelUtil.getLiteralAssignmentString(value, destPart)
							   + ");\n";
				}
			}
		}
		if(isDestAList){
				javaString += AbstractbpelUtil.createJavaPartSetterCode(destVariable,destPart, destPart.getName());
		}

		
		return javaString;		
	}
	

	/**
	 * Creates the Java code in a BPEL Invoke activity to set the value of the pin variable
	 * based on the literal.
	 * 
	 * @param sourcePin The InputValuePin to get the value from
	 * @param destVariable That variable to update
	 * @param destPart The part of the variable to update
	 * @return Invoke - The BPEL Invoke, filled with a JavaScripActivity and JavaCode
	 */	
	private Invoke createJavaInvoke(InputValuePin sourcePin, Variable destVariable, Part destPart){
		//* If the type of the sourcePin is a BehavioredClass, will delegate to the 
	   //* createJavaInvokeForBehavioredClass, that will assign to an endPointReference.
	
		if(sourcePin.getType() instanceof BehavioredClass){
			return createJavaInvokeForBehavioredClass(sourcePin, destVariable, destPart);
		}
		Invoke javaInvoke = AbstractbpelUtil.createJavaInvoke();
		JavaScriptActivity jsActivity = BPELPlusFactory.eINSTANCE.createJavaScriptActivity();
		JavaCode javaCode = BPELPlusFactory.eINSTANCE.createJavaCode();
		String javaString = new String();
		Object value = null;
		Object obj = null;
		boolean bIsWSICompliant = isWSICompliant(sourcePin.getAction());
		int index = findPinIndexInSet(sourcePin);
		if(bIsWSICompliant){
			if(!BpelOptionsUtil.isTargetDiamondCompatible()){
				javaString += createJavaInvokeForWSICompliant(sourcePin, destVariable, destPart);
			}else{
				javaString += createJavaInvokeForWSICompliantSDOSupport(sourcePin, destVariable, destPart);
			}
		}else{
			javaString += createJavaInvokeForNonWSICompliant(sourcePin, destVariable, destPart);
		}
		
		
//		javaCode.setValue(javaString);
//		jsActivity.setJavaCode(javaCode);
		jsActivity.setJavaCode(javaString);
		javaInvoke.getExtensibilityElements().add(jsActivity);
		
		createDisplayName(javaInvoke,"Set value for " + sourcePin.getName());		
	//	createDisplayName(javaInvoke,"Set Constant Value");		
		return javaInvoke;
		
	}

	/**
	 * Creates the Java code in a BPEL Invoke activity to set the value of the pin variable
	 * based on the literal.
	 * Creates the Java code in a BPEL Invoke activity to set the value from the InputValuePin
	 * in the destination variable / part. 
	 * The destination variable is of type wsa:EndPointReferenceType.
	 * Will create an shell endPointReference. Sets the endPointReference address to the name of the InputValuePin value - 
	 * an InstanceValue of a BehavioredClass instance. Adds documentation to the assign - extensibility element 
	 * with all the BehavioredClass attributes. This attributes may be used for specifying the wsa:EndPointReference
	 * referenceProperties.  
	 * @param sourcePin The InputValuePin to get the value from
	 * @param destVariable That variable to update
	 * @param destPart The part of the variable to update
	 * @return Invoke - The BPEL Invoke, filled with a JavaScripActivity and JavaCode
	 */	
	private Invoke createJavaInvokeForBehavioredClass(InputValuePin sourcePin, Variable destVariable, Part destPart){
	
		//log a warning as an incomplete endPointReference is generated. User is expected to update the 
		//generated file. 
		LoggingUtil.logWarning(MessageKeys.INCOMPLETE_END_POINT_REFERENCE); 
		
		Invoke javaInvoke = AbstractbpelUtil.createJavaInvoke();
		JavaScriptActivity jsActivity = BPELPlusFactory.eINSTANCE.createJavaScriptActivity();
		JavaCode javaCode = BPELPlusFactory.eINSTANCE.createJavaCode();
		ExtensibilityElement documentation = null;
		String javaString = new String();
		ValueSpecification valueSpec = (ValueSpecification)sourcePin.getValue().get(0);		
		if(valueSpec instanceof InstanceValue){
			InstanceValue instanceValue = (InstanceValue)valueSpec;
			String stringSimbol = null;
			InstanceSpecification instanceSpec = null;
			if(instanceValue.getInstance() != null){
				//this is an instance of the BehavioredClass referenced 
				instanceSpec = instanceValue.getInstance();
				stringSimbol = ProcessUtil.createNamespace(instanceSpec);
				documentation = BomUtils.createDocumentationExtensibleElement(instanceSpec);
			}else if(instanceValue.getOwnedInstance() != null){
				instanceSpec = instanceValue.getOwnedInstance();
				stringSimbol = ProcessUtil.createNamespace(instanceSpec);
				documentation = BomUtils.createDocumentationExtensibleElement(instanceSpec);
			}
			String varName = AbstractbpelUtil.capitalizeFirstChar(destVariable.getName());
			String partName = AbstractbpelUtil.capitalizeFirstChar(destPart.getName());
			javaString += AbstractbpelUtil.generateJavaGetterForVariable(varName) + "(true)" + ".get" + partName + "()"
						+ ".setAddress(new AttributedURI(" + AbstractbpelUtil.getLiteralAssignmentString(stringSimbol) + "));\n";
		}

//		javaCode.setValue(javaString);
//		jsActivity.setJavaCode(javaCode);
		jsActivity.setJavaCode(javaString);
		javaInvoke.getExtensibilityElements().add(jsActivity);
		javaInvoke.getExtensibilityElements().add(documentation);
		
		return javaInvoke;
		
	}

	private FunctionExpression createExpressionModel(Part pinPart, int k)
	{
		FunctionExpression functionExpr = ModelFactory.eINSTANCE.createFunctionExpression();					
		FunctionDefinition def = ModelFactory.eINSTANCE.createFunctionDefinition();
		def.setFunctionID(CoreFunctions.SELECT_FUNCTION);

		/* First Argument (elements) for the select Function Expression is a ModelPathExpression*/
		FunctionArgument arg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
		ModelPathExpression pathExpr = ModelFactory.eINSTANCE.createModelPathExpression();
		StaticStep step1 = ModelFactory.eINSTANCE.createStaticStep();
		step1.setStepName(pinPart.getName());
		StaticStep step2 = ModelFactory.eINSTANCE.createStaticStep();		
//		step2.setStepName("child::node()");
		// TODO: Do we have to make the first character a capital letter? Check BPEL expression context definition
		//step2.setStepName(pinPart.getType().getName());
		/*
		 * Ray:
		 * Since the pin's multiplicity is > 1, then we know that a 'ListOf' xsd complex type
		 * will be created which contains a single element representing the pin.  We need to
		 * obtain the name of the element within the 'Listof' type and set it as the 2nd step
		 * for the expression
		 */
		
		step2.setStepName(getListOfElementName((XSDComplexTypeDefinition)pinPart.getTypeDefinition()));
		
		pathExpr.setIsAbsolute(Boolean.TRUE);
		pathExpr.getSteps().add(step1);
		pathExpr.getSteps().add(step2);					
		arg1.setArgumentValue(pathExpr);

		/* Second argument (selection criteria) for the select Function Expression is a ComparisonExpression */
		FunctionArgument arg2 = ModelFactory.eINSTANCE.createFunctionArgument();
		ComparisonExpression cmpExpr = ModelFactory.eINSTANCE.createComparisonExpression();	
				
		/* first operand of ComparisonExpression is position() Function Expresssion with no arguments */				
		FunctionExpression posFunctionExpr = ModelFactory.eINSTANCE.createFunctionExpression();					
		FunctionDefinition def2 = ModelFactory.eINSTANCE.createFunctionDefinition();
		def2.setFunctionID("com.ibm.btools.te.ilm.heuristics.abstractbpel.position");
		def2.setFunctionName("position");
		posFunctionExpr.setDefinition(def2);

		cmpExpr.setFirstOperand(posFunctionExpr);		

		cmpExpr.setOperator(ComparisonOperator.EQUAL_TO_LITERAL);

		/* Second operand is an IntegerLiteralExpression */
		IntegerLiteralExpression intExpr = ModelFactory.eINSTANCE.createIntegerLiteralExpression();
		intExpr.setIntegerSymbol(new Integer(k));
		cmpExpr.setSecondOperand(intExpr); 				

		arg2.setArgumentValue(cmpExpr);					
		functionExpr.setDefinition(def);
		functionExpr.getArguments().add(arg1);
		functionExpr.getArguments().add(arg2);
	
		return functionExpr;
	}
	
	/**
	 * Obtain the name of the element within the 'Listof' type
	 * @param type - This 'Listof' complex type
	 * @return The name of the multiplicity element within the 'Listof' type
	 */
	private String getListOfElementName (XSDComplexTypeDefinition type) {
		String elementName = null;
		elementName = ((XSDElementDeclaration)((XSDParticle)((XSDModelGroup)type.getComplexType().getContent()).getContents().get(0)).getContent()).getName();
		return elementName;
	}
	
	private ModelPathExpression createExpressionModel(Part pinPart)	{
		/* First Argument (elements) for the select Function Expression is a ModelPathExpression*/
		ModelPathExpression pathExpr = ModelFactory.eINSTANCE.createModelPathExpression();
		StaticStep step1 = ModelFactory.eINSTANCE.createStaticStep();
		step1.setStepName(pinPart.getName());
		StaticStep step2 = ModelFactory.eINSTANCE.createStaticStep();		
		// TODO: Do we have to make the first character a capital letter? Check BPEL expression context definition
		step2.setStepName("address");
		StaticStep step3 = ModelFactory.eINSTANCE.createStaticStep();		
		step3.setStepName("value");
		pathExpr.setIsAbsolute(Boolean.TRUE);
		pathExpr.getSteps().add(step1);
		pathExpr.getSteps().add(step2);		
		pathExpr.getSteps().add(step3);					
		return pathExpr;
	}
	
	/**
	 * This method attempts to find the first pinSet (input or output) that contains a Pin.  Notice a pin can never appear
	 * in both input and output pinset.
	 * @param pin
	 * @return
	 */
	private PinSet findPinSetForPin(Pin pin) {
		Action action = (Action)pin.eContainer();
		Iterator it = action.getInputPinSet().iterator();
		InputPinSet inPinSet;
		while (it.hasNext()) {
			inPinSet = (InputPinSet)it.next();
			// it can never be control pin
			if (inPinSet.getInputObjectPin().contains(pin)) {
				return inPinSet;
			}
			
		}
		it = action.getOutputPinSet().iterator();
		OutputPinSet outPinSet;
		while (it.hasNext()) {
			outPinSet = (OutputPinSet)it.next();
			// it can never be control pin
			if (outPinSet.getOutputObjectPin().contains(pin)) {
				return outPinSet;
			}
		}
		return null;  // This should never happened!!
	}
	
	private int findPinIndexInSet(Pin pin){
		
		PinSet pinSet = findPinSetForPin(pin);
		List pins = new LinkedList();
		if(pinSet instanceof InputPinSet){
			pins = ((InputPinSet)pinSet).getInputObjectPin();
		}else if(pinSet instanceof OutputPinSet){
			pins = ((OutputPinSet)pinSet).getOutputObjectPin();
			
		}
		return pins.indexOf(pin);
	}
	


} //InputValuePinRuleImpl
