/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.abstractbpel.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.wst.wsdl.Part;
import org.eclipse.xsd.XSDComplexTypeDefinition;
import org.eclipse.xsd.XSDElementDeclaration;
import org.eclipse.xsd.XSDModelGroup;
import org.eclipse.xsd.XSDParticle;
import org.eclipse.xsd.XSDTypeDefinition;

import com.ibm.btools.bom.model.artifacts.LiteralInteger;
import com.ibm.btools.bom.model.artifacts.LiteralUnlimitedNatural;
import com.ibm.btools.bom.model.artifacts.TypedElement;
import com.ibm.btools.bom.model.processes.activities.InputObjectPin;
import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.bom.model.processes.activities.ObjectPin;
import com.ibm.btools.bom.model.processes.activities.OutputObjectPin;
import com.ibm.btools.bom.model.processes.activities.OutputPinSet;
import com.ibm.btools.bom.model.processes.activities.Pin;
import com.ibm.btools.bom.model.processes.activities.PinSet;
import com.ibm.btools.bom.model.processes.activities.RetrieveArtifactPin;
import com.ibm.btools.bom.model.processes.activities.StoreArtifactPin;
import com.ibm.btools.expression.function.CoreFunctions;
import com.ibm.btools.expression.model.ComparisonExpression;
import com.ibm.btools.expression.model.ComparisonOperator;
import com.ibm.btools.expression.model.FunctionArgument;
import com.ibm.btools.expression.model.FunctionDefinition;
import com.ibm.btools.expression.model.FunctionExpression;
import com.ibm.btools.expression.model.IntegerLiteralExpression;
import com.ibm.btools.expression.model.ModelFactory;
import com.ibm.btools.expression.model.ModelPathExpression;
import com.ibm.btools.expression.model.StaticStep;
import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.framework.util.TransformationUtil;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelFactory;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelPackage;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ConcurrentBranchRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ContainerRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.JoinRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.VariableRule;
import com.ibm.btools.te.ilm.heuristics.helper.AbstractbpelUtil;
import com.ibm.btools.te.ilm.heuristics.helper.BomHelper;
import com.ibm.btools.te.ilm.heuristics.helper.BomUtils;
import com.ibm.btools.te.ilm.heuristics.helper.BpelOptimizationUtil;
import com.ibm.btools.te.ilm.heuristics.helper.BpelOptionsUtil;
import com.ibm.btools.te.ilm.heuristics.helper.ProcessUtil;
import com.ibm.btools.te.ilm.heuristics.naming.NameProvider;
import com.ibm.btools.te.ilm.heuristics.naming.NameProviderFactory;
import com.ibm.btools.te.ilm.heuristics.naming.NamingUtil;
import com.ibm.btools.te.ilm.heuristics.wsdl.PartRule;
import com.ibm.btools.te.ilm.model.abstractbpel.Alternative;
import com.ibm.btools.te.ilm.model.abstractbpel.AlternativeActivity;
import com.ibm.btools.te.ilm.model.abstractbpel.ExtensibilityExpression;
import com.ibm.btools.te.ilm.model.sa.ProcessFlowType;
import com.ibm.btools.te.ilm.resource.MessageKeys;
import com.ibm.wbit.bpel.Activity;
import com.ibm.wbit.bpel.Assign;
import com.ibm.wbit.bpel.BPELFactory;
import com.ibm.wbit.bpel.BPELVariable;
import com.ibm.wbit.bpel.Copy;
import com.ibm.wbit.bpel.From;
import com.ibm.wbit.bpel.Invoke;
import com.ibm.wbit.bpel.Link;
import com.ibm.wbit.bpel.To;
import com.ibm.wbit.bpel.Variable;
import com.ibm.wbit.bpelpp.BPELPlusFactory;
import com.ibm.wbit.bpelpp.DisplayName;
import com.ibm.wbit.bpelpp.JavaCode;
import com.ibm.wbit.bpelpp.JavaScriptActivity;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Join Rule</b></em>'.
 * 
 * <p>This class is responsible for mapping a BOM join into the appropriate BPEL Activities</p>
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class JoinRuleImpl extends ConnectableRuleImpl implements JoinRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/* Keeps track of whether this rule has been previously executed */
	private boolean fFirstTimeExecuting = true;
	
	private Activity fJoinActivity = null;
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected JoinRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return AbstractbpelPackage.Literals.JOIN_RULE;
	}

	/**
	 * source = input set of a BOM Join node
	 * target = BPEL <sequence>
	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target()
	 */
	public boolean transformSource2Target() {
		LoggingUtil.traceEntry(this, "transformSource2Target");

		if (getSource().isEmpty()){
			LoggingUtil.traceExit(this, "transformSource2Target", "no source");
			return false;
		}
		
		InputPinSet is = (InputPinSet)getSource().get(0);
		
		if (!fFirstTimeExecuting){
			reExecute(is);
			
			executeHandlers();
			LoggingUtil.traceExit(this, "transformSource2Target", "re-execute");
			return true;
		} else {
			fFirstTimeExecuting = false;
		}
		Variable isVariable=null;
		Variable osVariable = null;
		/* For a join, the input set must be correlated to a single output set */
		OutputPinSet os = (OutputPinSet)is.getOutputPinSet().get(0);
		List isVariables = getVariablesForPinSet(is);
		//defect 117109 do not create the osVariable unless needed
		//List osVariables = getVariablesForPinSet(os);
		
		fJoinActivity = null;				

		if (is.getInputObjectPin().size() > 0 && doNeedInvoke(os)){
			
			List osVariables = getVariablesForPinSet(os);
			/* Create an AlterativeActivity with two alternatives, one for BPEL and one for BPEL+ since
			 * BPEL+ doesn't support XPath expressions in <assign> activities */
		    fJoinActivity = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createAlternativeActivity();
			Alternative bpelAlt = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createAlternative();		
			Alternative bpelpAlt = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createAlternative();
		
			bpelAlt.setType(ProcessFlowType.BPEL_LITERAL);
			bpelpAlt.setType(ProcessFlowType.BPELPP_LITERAL);
			
			((AlternativeActivity)fJoinActivity).getAlternative().add(bpelAlt);
			((AlternativeActivity)fJoinActivity).getAlternative().add(bpelpAlt);
			
			/* BPEL: Create <assign>, with multiple BPEL Copies, if there is at least one object pin */
			//bpelAlt.setActivity(createAssign(is, isVariable, os, osVariable));
			/* BPEL+: Create <invoke><wpc:script><wpc:javaCode>... */
			bpelpAlt.setActivity(createJavaInvoke(is, isVariable, os, osVariable));
			
		} else {
			/* If there are no input object pins, we don't need any assignments, and therefore we 
			 * don't need an AlternativeActivity */
		    fJoinActivity = BPELFactory.eINSTANCE.createEmpty();
		}

		NameProvider nameProvider = NameProviderFactory.getNameProvider(fJoinActivity);
		String convertedName = nameProvider.getName(fJoinActivity, is.getAction(), NamingUtil.findRegistry(this));
		fJoinActivity.setName(convertedName);
		
		// Ray: added display name support
		DisplayName dspName = BPELPlusFactory.eINSTANCE.createDisplayName();
		dspName.setText(is.getAction().getName());
		fJoinActivity.getEExtensibilityElements().add(dspName);
		
		/* Connect the incoming links */
		connectInputSet(is, fJoinActivity);

		/* Add the joinActivity to the list of targets AFTER the input set is mapped */
		getTarget().add(fJoinActivity);
		
		/* Create the concurrent branch which should be necessary, given that this is a fork */
		if (BomHelper.getInstance().isCBranch(os)){
			ConcurrentBranchRule cbr = AbstractbpelFactory.eINSTANCE.createConcurrentBranchRule();
			cbr.getSource().add(os);
			getChildRules().add(cbr);
			cbr.transformSource2Target();
			getTarget().addAll(cbr.getTarget());
		}
		
		/* Connect the outgoing links */
		connectOutputSet(os, fJoinActivity);

		mapDescriptionAndDocumentation(is.getAction(),fJoinActivity);

		if (BpelOptionsUtil.generateEmptyActivityForControlNode()) {
			BpelOptimizationUtil.registerNonOptimizableElement(getContext(),fJoinActivity);
		}

		executeHandlers();
		
		LoggingUtil.traceExit(this, "transformSource2Target");		
		return true;
	}
	
	/**
	 * Creates the Java version of the assignment to copy the input pin information to the 
	 * corresponding output pin variable
	 */
	private Invoke createJavaInvoke(InputPinSet is, Variable isVariable, OutputPinSet os, Variable osVariable){
		Invoke joinActivity = AbstractbpelUtil.createJavaInvoke();
		JavaScriptActivity jsActivity = BPELPlusFactory.eINSTANCE.createJavaScriptActivity();
		JavaCode javaCode = BPELPlusFactory.eINSTANCE.createJavaCode();
		/* The output container is represented as a list, accessible via 'get[VariableName]()' */
		String javaAssign = "";		
		javaAssign += createJavaInvokeForWSICompliantDiamond(is, os);
		jsActivity.setJavaCode(javaAssign);
		joinActivity.getEExtensibilityElements().add(jsActivity);
		return joinActivity;
	}	
	
	/**
	 * Creates the Java version of the assignment to copy the input pin information to the 
	 * corresponding output pin variable (this is for Join and Merge)
	 */
	protected String createJavaInvokeForWSICompliantDiamond(InputPinSet is, OutputPinSet os){

		/* The output container is represented as a list, accessible via 'get[VariableName]()' */
		String javaAssign = "";
		/* For each pin in the OutputSet, there is one or more corresponding pins in the input set */
		//this list records all variables that are found for the os pins and are already initialized by code so that 
		//we do not initialize twice the same variable in the snippet
		List initializedVariable = new LinkedList();
		for (int i=0, outPinCount = os.getOutputObjectPin().size(); i<outPinCount; i++){
			
			//we should really look here for the next InputObjectPin linked to this Join OutputObjectPin 
			OutputObjectPin outPin = (OutputObjectPin)os.getOutputObjectPin().get(i);
			//** outPin **
			ObjectPin pinLinkedToOutPin = null;
			//the target of the Link from the outPin can be a ObjectPin or a TerminationNode. In case it is a Termination node, continue
			if(outPin.getOutgoing() != null && outPin.getOutgoing().getTarget() instanceof ObjectPin){
				pinLinkedToOutPin = (ObjectPin)outPin.getOutgoing().getTarget();
			}else if(outPin instanceof StoreArtifactPin){
				pinLinkedToOutPin = outPin;	
			}else{
				continue;
			}
			//now get the Set, the Variable for this set and the index of the Pin in the set..
			PinSet inPinSet = BomUtils.findPinSetForPin(pinLinkedToOutPin);
			//get the variable for this Set... **osVariable**
			BPELVariable pinSetVariable = getVariableForPin(inPinSet, pinLinkedToOutPin, true);
			//check if we have already initialized this variable
			if(!initializedVariable.contains(pinSetVariable)){
				javaAssign += AbstractbpelUtil.initializeVariable(pinSetVariable);
				initializedVariable.add(pinSetVariable);
			}
			int outPinIndex;
				outPinIndex =-1;
			XSDTypeDefinition pinTypeDefinition = pinSetVariable.getType();	
			String pinElementName = pinSetVariable.getName();
			
			/* Get the multiplicity of outPin.  This will affect whether use Java Lists or not */
			boolean useListForOutput = AbstractbpelUtil.isTransformedMultiplicityElementAList(pinLinkedToOutPin, pinSetVariable);
		
			int outListInd=0;
			boolean lastIndexInitialized = false;
			for (int j=i, inPinCount = is.getInputObjectPin().size(); j<inPinCount; j+=outPinCount){
				BPELVariable inSetVariable = null;
				InputObjectPin inPin = (InputObjectPin)is.getInputObjectPin().get(j);
				//get the real pin to which this links 
				//we should really look here for the next InputObject pin linked to this OutputObjectPin 
				//** outPin **
				ObjectPin outLinkedToInPin = null;
				if(inPin.getIncoming()!= null){
					outLinkedToInPin = (ObjectPin)inPin.getIncoming().getSource();
				}else if(inPin instanceof RetrieveArtifactPin){
					outLinkedToInPin = inPin;
				}else{
//					check if there has been a variable created for this inPin. This is the case of 
					//a Pin that is not connected -> invalid model that we try to address... 
					inSetVariable = getVariableForPin(is, inPin, false);
					if(inSetVariable != null){
						outLinkedToInPin = inPin;
					}else{
						continue;
					}
				}
				if(inSetVariable == null){
					//now get the Set, the Variable for this set and the index of the Pin in the set..
					PinSet outPinSet = BomUtils.findPinSetForPin(outLinkedToInPin);
					//get the variable for this Set... **osVariable**
					//AR this variable should have already been mapped. If it wasn't, it will need to be on the next path
					//through the process = the branch coming to this Join probably comes from a parallel path.. so we cannot 
					//predict yet the Variable.. do not create it, rather set the javaString to "" . This will be an indication 
					//that the javaCode should be rebuild.
					inSetVariable = getVariableForPin(outPinSet, outLinkedToInPin, false);
				}
					//should not finish creating the java snippet now, rather create it upon reExecute... 
				if (inSetVariable == null){
					return "";
				}
				/* Get the multiplicity of inPin.  This will affect whether use Java Lists or not */
				boolean useListForInput;
				useListForInput = AbstractbpelUtil.isTransformedMultiplicityElementAList(outLinkedToInPin, inSetVariable);
				//we should only create the assign if the variables are not identicals, else, there is not need for assign
				if(!inSetVariable.equals(pinSetVariable))
				javaAssign += AbstractbpelUtil.createJavaCopySnippetsDiamond(inSetVariable, useListForInput,pinSetVariable,useListForOutput,lastIndexInitialized,"lastIndex"+outPinIndex,Integer.toString(outListInd),false)
				+ ";\n";
				if (useListForOutput) {
					if (!useListForInput) {
						outListInd++;
					} else {
						lastIndexInitialized=true;
					}
				}
			}
		}
			
		return javaAssign;
	}
	
	/**
	 * source = input set of a BOM Join node
	 * target = BPEL <sequence>
	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target()
	 */
	public boolean transformSource2Target_bak() {
		LoggingUtil.traceEntry(this, "transformSource2Target");

		if (getSource().isEmpty()){
			LoggingUtil.traceExit(this, "transformSource2Target", "no source");
			return false;
		}
		
		InputPinSet is = (InputPinSet)getSource().get(0);
		
		if (!fFirstTimeExecuting){
			reExecute(is);
			LoggingUtil.traceExit(this, "transformSource2Target", "re-execute");
			return true;
		} else {
			fFirstTimeExecuting = false;
		}
		Variable isVariable=null;
		Variable osVariable = null;
		/* For a join, the input set must be correlated to a single output set */
		OutputPinSet os = (OutputPinSet)is.getOutputPinSet().get(0);
		List isVariables = getVariablesForPinSet(is);
		List osVariables = getVariablesForPinSet(os);
		
		
		if(!BpelOptimizationUtil.bOptimizeJoinTransformation){
			/* Create the container rule for the input set */
			if (!is.getInputObjectPin().isEmpty()) {
				ContainerRule crIS = AbstractbpelFactory.eINSTANCE.createContainerRule();
				crIS.getSource().add(is);
				getChildRules().add(crIS);
				crIS.transformSource2Target();
				getTarget().addAll(crIS.getTarget());
				isVariable = (Variable)crIS.getTarget().get(0);
			}
			/* Create the container rule for the output set */
			
			if (!os.getOutputObjectPin().isEmpty()) {
				ContainerRule crOS = AbstractbpelFactory.eINSTANCE.createContainerRule();
				crOS.getSource().add(os);
				getChildRules().add(crOS);
				crOS.transformSource2Target();
				getTarget().addAll(crOS.getTarget());
				osVariable = (Variable)crOS.getTarget().get(0);
			}		
		}

		Activity joinActivity = null;				

		if (is.getInputObjectPin().size() > 0){
			
			/* Create an AlterativeActivity with two alternatives, one for BPEL and one for BPEL+ since
			 * BPEL+ doesn't support XPath expressions in <assign> activities */
			joinActivity = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createAlternativeActivity();
			Alternative bpelAlt = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createAlternative();		
			Alternative bpelpAlt = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createAlternative();
		
			bpelAlt.setType(ProcessFlowType.BPEL_LITERAL);
			bpelpAlt.setType(ProcessFlowType.BPELPP_LITERAL);
			
			((AlternativeActivity)joinActivity).getAlternative().add(bpelAlt);
			((AlternativeActivity)joinActivity).getAlternative().add(bpelpAlt);
			
			/* BPEL: Create <assign>, with multiple BPEL Copies, if there is at least one object pin */
			//TODO come back and solve !
	//		bpelAlt.setActivity(createAssign(is, isVariable, os, osVariable));
			
			/* BPEL+: Create <invoke><wpc:script><wpc:javaCode>... */
			bpelpAlt.setActivity(createJavaInvoke(is, isVariable, os, osVariable));
			
		} else {
			/* If there are no input object pins, we don't need any assignments, and therefore we 
			 * don't need an AlternativeActivity */
			joinActivity = BPELFactory.eINSTANCE.createEmpty();
		}
//		JavaNCNameConverter converter = new JavaNCNameConverter();
//		String convertedName = converter.convertName(NamingUtil.findRegistry(this), joinActivity, BomUtils.getCanonicalName(is.getAction()));
		
		NameProvider nameProvider = NameProviderFactory.getNameProvider(joinActivity);
		String convertedName = nameProvider.getName(joinActivity, is.getAction(), NamingUtil.findRegistry(this));
		
		
		joinActivity.setName(convertedName);
		
		
		
		//joinActivity.setName(BomUtils.getCanonicalName(is.getAction()));		
		// Ray: added display name support
		DisplayName dspName = BPELPlusFactory.eINSTANCE.createDisplayName();
		dspName.setText(is.getAction().getName());
		joinActivity.getEExtensibilityElements().add(dspName);
		
		/* Connect the incoming links */
		connectInputSet(is, joinActivity);

		/* Add the joinActivity to the list of targets AFTER the input set is mapped */
		getTarget().add(joinActivity);
		
		/* Create the concurrent branch which should be necessary, given that this is a fork */
		if (BomHelper.getInstance().isCBranch(os)){
			ConcurrentBranchRule cbr = AbstractbpelFactory.eINSTANCE.createConcurrentBranchRule();
			cbr.getSource().add(os);
			getChildRules().add(cbr);
			cbr.transformSource2Target();
			getTarget().addAll(cbr.getTarget());
		}
		
		/* Connect the outgoing links */
		connectOutputSet(os, joinActivity);

		mapDescriptionAndDocumentation(is.getAction(),joinActivity);

		if (BpelOptionsUtil.generateEmptyActivityForControlNode()) {
			BpelOptimizationUtil.registerNonOptimizableElement(getContext(),joinActivity);
		}

		LoggingUtil.traceExit(this, "transformSource2Target");		
		return true;
	}
	
	
	/**
	 * Returns the activity that is the primary representation of this JoinRule
	 * 
	 * @return The primary activity created by this rule
	 */
	public Activity getJoinActivity(){
	    return fJoinActivity;
	}
	
	
	/**
	 * Creates the BPEL Assign activity to copy each multiplicity item from the variable associated with
	 * the input pin set to the variable associated with the output pin set. 
	 * 
	 * @param is The InputPinSet that is providing the information to copy
	 * @param isVariable The BpEL variable that actually holds the source information
	 * @param os The OutputPinSet that the information is being copied to
	 * @param osVariable The BPEL variable that will hold the information once it is copied 
	 * @return Assign - The BPEL Assign activitiy with potentially many Copy elements
	 */
	private Assign createAssign(InputPinSet is, Variable isVariable, OutputPinSet os, Variable osVariable){
		
		Assign joinActivity = BPELFactory.eINSTANCE.createAssign();
		
		/* For each pin in the OutputSet, there is one or more corresponding pins in the input set */
		for (int i=0, outPinCount = os.getOutputObjectPin().size(); i<outPinCount; i++){
//			Part outPinPart = (Part)((PartRule) 
//				TransformationUtil.getRuleForSource(ProcessUtil.getProcessInterfaceRule(getContext()),
//													PartRule.class,
//													(Pin)os.getOutputObjectPin().get(i))).getTarget().get(0);

			Part outPinPart = (Part)((PartRule) TransformationUtil.getRuleForSource(ProcessUtil.getProcessInterfaceRule(getContext()), PartRule.class,	os)).getTarget().get(0);
			int outPosition = 1;				

			for (int j=i, inPinCount = is.getInputObjectPin().size(); j<inPinCount; j+=outPinCount){
				InputObjectPin inPin = (InputObjectPin)is.getInputObjectPin().get(j);
//				Part inPinPart = (Part)((PartRule) 
//					TransformationUtil.getRuleForSource(ProcessUtil.getProcessInterfaceRule(getContext()),
//														PartRule.class,
//														inPin)).getTarget().get(0);
				Part inPinPart = (Part)((PartRule) TransformationUtil.getRuleForSource(ProcessUtil.getProcessInterfaceRule(getContext()), PartRule.class, is)).getTarget().get(0);										

				/* NOTE: It is a restriction that we are requiring the upper bound = lower bound
				 * for the input object pin multiplicities. If there is no multiplicity defined, assume 1..1 */
				if (inPin.getLowerBound() instanceof LiteralInteger && inPin.getUpperBound() instanceof LiteralUnlimitedNatural 
						&& ((LiteralInteger)inPin.getLowerBound()).getValue().intValue() != Integer.parseInt(((LiteralUnlimitedNatural)inPin.getUpperBound()).getValue())){
					String params[]={inPin.getName(),inPin.getAction().getName()};
					LoggingUtil.logWarning(MessageKeys.JOIN_MULTIPLICITY_NOT_SUPPORTED,params,null);		
				}		

				 
				int count;
				if (inPin.getLowerBound() != null){
					/* Use the lower-bound to be on safe side. The LB and UB are supposed to be the same anyways. */
					count = ((LiteralInteger)inPin.getLowerBound()).getValue().intValue();
				} else {
					count = 1;
				}

				for (int k=0; k<count; k++){
					Copy copy = BPELFactory.eINSTANCE.createCopy();
					From from = BPELFactory.eINSTANCE.createFrom();
				
					from.setVariable(isVariable);
					from.setPart(inPinPart);
								   
					ExtensibilityExpression bpelExpr = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createExtensibilityExpression();
					
					bpelExpr.setExpression(createExpressionModel(inPinPart, k+1));
					from.addExtensibilityElement(bpelExpr);
					
					/* Create an expression model instance to store the queries for From*/
					ExtensibilityExpression bpelExpr2 = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createExtensibilityExpression();					
					bpelExpr2.setExpression(createExpressionModel(outPinPart, outPosition));
					
					/* Create a ToExtension class */
					//ToExtension toExt = com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelFactory.eINSTANCE.createToExtension();
					To toExt = BPELFactory.eINSTANCE.createTo();
					toExt.setVariable(osVariable);
					toExt.setPart(outPinPart);
					toExt.addExtensibilityElement(bpelExpr2); 	
								
					copy.setFrom(from);
					copy.setTo(toExt);
					((Assign)joinActivity).getCopy().add(copy);
					 
					outPosition++;
				}

			}						 
		}
		
		return joinActivity;
		
	}
	



	/**
	 * Creates the Java version of the assignment to copy the input pin information to the 
	 * corresponding output pin variable. 
	 */
	private String createJavaInvokeForWSICompliant(InputPinSet is, Variable isVariable, OutputPinSet os, Variable osVariable){
				
		/* The output container is represented as a list, accessible via 'get[VariableName]()' */
		String javaAssign = "";
		Part outPinPart = (Part)((PartRule) TransformationUtil.getRuleForSource(getRoot(), PartRule.class, os)).getTarget().get(0);
		Part inPinPart= (Part)((PartRule)TransformationUtil.getRuleForSource(getRoot(), PartRule.class, is)).getTarget().get(0);
		
		/* For each pin in the OutputSet, there is one or more corresponding pins in the input set */
		boolean partCreated = false;
		for (int i=0, outPinCount = os.getOutputObjectPin().size(); i<outPinCount; i++){
			
			OutputObjectPin outPin = (OutputObjectPin)os.getOutputObjectPin().get(i);

			/* Get the multiplicity of outPin.  This will affect whether use Java Lists or not */
			boolean useListForOutput = AbstractbpelUtil.isTransformedMultiplicityElementAList(outPin,outPinPart, i);;

			if (useListForOutput) {
				javaAssign += AbstractbpelUtil.createJavaVariableForPartCode(osVariable,outPinPart,false, i);	
			}
			int outListInd=0;
			boolean lastIndexInitialized=false;
			String outVarName = AbstractbpelUtil.capitalizeFirstChar(osVariable.getName());
			String outPartName = AbstractbpelUtil.capitalizeFirstChar(outPinPart.getName());
			for (int j=i, inPinCount = is.getInputObjectPin().size(); j<inPinCount; j+=outPinCount){
				InputObjectPin inPin = (InputObjectPin)is.getInputObjectPin().get(j);
				/* Get the multiplicity of inPin.  This will affect whether use Java Lists or not */
				boolean useListForInput = AbstractbpelUtil.isTransformedMultiplicityElementAList(inPin,inPinPart, j);;
				javaAssign += AbstractbpelUtil.createJavaCopySnippets(isVariable,inPinPart,useListForInput,osVariable,outPinPart,useListForOutput,lastIndexInitialized,"lastIndex"+i,Integer.toString(outListInd),false, j, i, partCreated);
				partCreated = true;
				if (useListForOutput) {
					if (!useListForInput) {
						outListInd++;
					} else {
						lastIndexInitialized=true;
					}
				}
			}
			if (useListForOutput) {
				String pinElementName = AbstractbpelUtil.getPinElementName(outPinPart, i);
				if(!partCreated){
				  javaAssign += AbstractbpelUtil.createJavaVariableForPartCode(osVariable,outPinPart, true);
				  partCreated = true;
				}
				javaAssign += outPinPart.getName() + ".set" + pinElementName +"(" + pinElementName +");\n";
			}
		}
		javaAssign += AbstractbpelUtil.createJavaPartSetterCode(osVariable,outPinPart, outPinPart.getName());
		return javaAssign;
	}	
	
	
	/**
	 * Creates the Java version of the assignment to copy the input pin information to the 
	 * corresponding output pin variable (this is for Join and Merge)
	 */
	protected String createJavaInvokeForWSICompliantDiamond(InputPinSet is, Variable isVariable, OutputPinSet os, Variable osVariable){

		/* The output container is represented as a list, accessible via 'get[VariableName]()' */
		String javaAssign = "";
		Part outPinPart = (Part)((PartRule) TransformationUtil.getRuleForSource(getRoot(), PartRule.class, os)).getTarget().get(0);
		boolean partCreated = false;
		//initialize the outputVariable if not already initialized
		javaAssign += AbstractbpelUtil.initializeVariable(osVariable, outPinPart, true);
		/* For each pin in the OutputSet, there is one or more corresponding pins in the input set */
		for (int i=0, outPinCount = os.getOutputObjectPin().size(); i<outPinCount; i++){
			OutputObjectPin outPin = (OutputObjectPin)os.getOutputObjectPin().get(i);
			int outPinIndex;
			if(outPinCount == 1 && !BpelOptionsUtil.isAlwaysGenerateWraperComplexType()){
				outPinIndex =-1;
				partCreated = true;
			}else{
				outPinIndex = i;
			}

			XSDTypeDefinition pinTypeDefinition = AbstractbpelUtil.getPinTypDefinition(outPinPart, outPinIndex);
			String pinElementName = null;
			if(outPinIndex != -1){
				pinElementName = AbstractbpelUtil.getPinElementName(outPinPart, outPinIndex);	
			}else{
				pinElementName = osVariable.getName();
			}
			
			
			/* Get the multiplicity of outPin.  This will affect whether use Java Lists or not */
			boolean useListForOutput;
			useListForOutput = AbstractbpelUtil.isTransformedMultiplicityElementAList(outPin,outPinPart, outPinIndex);
			if (useListForOutput) {
				if(outPinIndex != -1)
					javaAssign += AbstractbpelUtil.createJavaVariableForPartCodeDiamond(osVariable, outPinPart, false, outPinIndex);
				javaAssign += AbstractbpelUtil.initializeJavaListPropertyDiamond(osVariable,outPinPart,true, outPinIndex);
				partCreated = true;
			}
			int outListInd=0;
			boolean lastIndexInitialized=false;
			Part inPinPart = (Part)((PartRule)TransformationUtil.getRuleForSource(getRoot(), PartRule.class, is)).getTarget().get(0);
			for (int j=i, inPinCount = is.getInputObjectPin().size(); j<inPinCount; j+=outPinCount){
				InputObjectPin inPin = (InputObjectPin)is.getInputObjectPin().get(j);
				/* Get the multiplicity of inPin.  This will affect whether use Java Lists or not */
				int inPinIndex;
				if(inPinCount == 1 && !BpelOptionsUtil.isAlwaysGenerateWraperComplexType()){
					inPinIndex =-1;
				}else{
					inPinIndex = j;
				}
				boolean useListForInput;
				useListForInput = AbstractbpelUtil.isTransformedMultiplicityElementAList(inPin,inPinPart, inPinIndex);
				javaAssign += AbstractbpelUtil.createJavaCopySnippetsDiamond(isVariable,inPinPart,useListForInput,osVariable,outPinPart,useListForOutput,lastIndexInitialized,"lastIndex"+outPinIndex,Integer.toString(outListInd),false, inPinIndex, outPinIndex, partCreated)
				+ ";\n";
				partCreated = true;
				if (useListForOutput) {
					if (!useListForInput) {
						outListInd++;
					} else {
						lastIndexInitialized=true;
					}
				}
			}
			if (useListForOutput) {
				  if(!partCreated){
				  	javaAssign += AbstractbpelUtil.initializeJavaListPropertyDiamond(osVariable,outPinPart, false, outPinIndex)+ ";\n";
					partCreated = true;
				  }
			}
			String listElement = AbstractbpelUtil.getNameOfListElement((XSDComplexTypeDefinition)pinTypeDefinition);
			javaAssign += AbstractbpelUtil.generateJavaSetterForVariableDiamond(pinElementName, listElement, pinTypeDefinition, listElement) + ";\n";
			
		}
		return javaAssign;
	}
		
	


	
//	/**
//	 * Creates the Java version of the assignment to copy the input pin information to the 
//	 * corresponding output pin variable (this is for Join and Merge)
//	 */
//	protected String createJavaInvokeForWSICompliantDiamond_bak(InputPinSet is, OutputPinSet os){
//
//		/* The output container is represented as a list, accessible via 'get[VariableName]()' */
//		String javaAssign = "";
//		boolean partCreated = false;
//		/* For each pin in the OutputSet, there is one or more corresponding pins in the input set */
//		//this list records all variables that are found for the os pins and are already initialized by code so that 
//		//we do not initialize twice the same variable in the snippet
//		List initializedVariable = new LinkedList();
//		
//		for (int i=0, outPinCount = os.getOutputObjectPin().size(); i<outPinCount; i++){
//			//we should really look here for the next InputObjectPin linked to this Join OutputObjectPin 
//			OutputObjectPin outPin = (OutputObjectPin)os.getOutputObjectPin().get(i);
//			//** outPin **
//			if(outPin.getOutgoing() == null){
//				break;
//			}
//			ObjectPin pinLinkedToOutPin = (ObjectPin)outPin.getOutgoing().getTarget();
//			//now get the Set, the Variable for this set and the index of the Pin in the set..
//			PinSet inPinSet = BomUtils.findPinSetForPin(pinLinkedToOutPin);
//			//get the variable for this Set... **osVariable**
//			Variable pinSetVariable = getVariableForPinSet(inPinSet);
//			Part inPinPart = (Part) TransformationUtil.getRuleForSource(getRoot(), PartRule.class, inPinSet).getTarget().get(0);
//			//check if we have already initialized this variable
//			if(!initializedVariable.contains(pinSetVariable)){
//				javaAssign += AbstractbpelUtil.initializeVariable(pinSetVariable, inPinPart, true);
//				initializedVariable.add(pinSetVariable);
//			}
//			int outPinIndex;
//			if(BomUtils.isSinglePinInSet(inPinSet)  && !BpelOptionsUtil.isAlwaysGenerateWraperComplexType()){
//				outPinIndex =-1;
//				partCreated = true;
//			}else{
//				//outPinIndex = i;
//				//outPinIndex = BomUtils.getPinsInSet(inPinSet).indexOf(pinLinkedToOutPin);
//				outPinIndex = BomUtils.getObjectPinsForSet(inPinSet).indexOf(pinLinkedToOutPin);
//				
//			}
//			XSDTypeDefinition  pinTypeDefinition = AbstractbpelUtil.getPinTypDefinition(inPinPart, outPinIndex);
//			String pinElementName = null;
//			if(outPinIndex != -1){
//				pinElementName = AbstractbpelUtil.getPinElementName(inPinPart, outPinIndex);	
//			}else{
//				pinElementName = pinSetVariable.getName();
//			}
//			
//			/* Get the multiplicity of outPin.  This will affect whether use Java Lists or not */
//			boolean useListForOutput;
//			
//			useListForOutput = AbstractbpelUtil.isTransformedMultiplicityElementAList(pinLinkedToOutPin,inPinPart, outPinIndex);
//			if (useListForOutput) {
//				if(outPinIndex != -1)
//					javaAssign += AbstractbpelUtil.createJavaVariableForPartCodeDiamond(pinSetVariable, inPinPart, false, outPinIndex);
//					javaAssign += AbstractbpelUtil.initializeJavaListPropertyDiamond(pinSetVariable,inPinPart,true, outPinIndex);
//					partCreated = true;
//			}
//			
//			int outListInd=0;
//			boolean lastIndexInitialized = false;
//			for (int j=i, inPinCount = is.getInputObjectPin().size(); j<inPinCount; j+=outPinCount){
//				InputObjectPin inPin = (InputObjectPin)is.getInputObjectPin().get(j);
//				
//				//get the real pin to which this links 
//				//we should really look here for the next InputObject pin linked to this OutputObjectPin 
//				//** outPin **
//				if(inPin.getIncoming() == null)
//					break;
//				OutputObjectPin outLinkedToInPin = (OutputObjectPin)inPin.getIncoming().getSource();
//				//now get the Set, the Variable for this set and the index of the Pin in the set..
//				PinSet outPinSet = BomUtils.findPinSetForPin(outLinkedToInPin);
//				//get the variable for this Set... **osVariable**
//				Variable inSetVariable = getVariableForPinSet(outPinSet);
//				
//				Part outPinPart = (Part)TransformationUtil.getRuleForSource(getRoot(), PartRule.class, outPinSet).getTarget().get(0);
//				
//				/* Get the multiplicity of inPin.  This will affect whether use Java Lists or not */
//				int inPinIndex;
//				//if(BomUtils.getPinsInSet(outPinSet).size()==1  && !BpelOptionsUtil.isAlwaysGenerateWraperComplexType()){
//				if(BomUtils.isSinglePinInSet(outPinSet)  && !BpelOptionsUtil.isAlwaysGenerateWraperComplexType()){
//					inPinIndex =-1;
//				}else{
//					//inPinIndex1 = j;
//					inPinIndex = BomUtils.getObjectPinsForSet(outPinSet).indexOf(outLinkedToInPin);
//					
//				}
//
//				boolean useListForInput;
//				useListForInput = AbstractbpelUtil.isTransformedMultiplicityElementAList(outLinkedToInPin,outPinPart, inPinIndex);
//				javaAssign += AbstractbpelUtil.createJavaCopySnippetsDiamond(inSetVariable,outPinPart,useListForInput,pinSetVariable,inPinPart,useListForOutput,lastIndexInitialized,"lastIndex"+outPinIndex,Integer.toString(outListInd),false, inPinIndex, outPinIndex, partCreated)
//				+ ";\n";
//				partCreated = true;
//				if (useListForOutput) {
//					if (!useListForInput) {
//						outListInd++;
//					} else {
//						lastIndexInitialized=true;
//					}
//				}
//			}
//			if (useListForOutput) {
//				  if(!partCreated){
//				  	javaAssign += AbstractbpelUtil.initializeJavaListPropertyDiamond(pinSetVariable,inPinPart, false, outPinIndex)+ ";\n";
//					partCreated = true;
//				  }
//				String listElement = AbstractbpelUtil.getNameOfListElement((XSDComplexTypeDefinition)pinTypeDefinition);
//				javaAssign += AbstractbpelUtil.generateJavaSetterForVariableDiamond(pinElementName, listElement, pinTypeDefinition, listElement) + ";\n"; 
//			}
//			
//			
//		}
//		return javaAssign;
//	}
	/**
	 * Creates the Java version of the assignment to copy the input pin information to the 
	 * corresponding output pin variable
	 */
	private String createJavaInvokeForNonWSICompliant(InputPinSet is, Variable isVariable, OutputPinSet os, Variable osVariable){
		String javaAssign = "";
		Part outPinPart = null;
		Part inPinPart = null;
		/* For each pin in the OutputSet, there is one or more corresponding pins in the input set */
		for (int i=0, outPinCount = os.getOutputObjectPin().size(); i<outPinCount; i++){
			OutputObjectPin outPin = (OutputObjectPin)os.getOutputObjectPin().get(i);

			/* Get the multiplicity of outPin.  This will affect whether use Java Lists or not */
			boolean useListForOutput;
				outPinPart = (Part)((PartRule) 
					TransformationUtil.getRuleForSource(getRoot(),
														PartRule.class,
														outPin)).getTarget().get(0);
			
			// Ray
			useListForOutput = AbstractbpelUtil.isTransformedMultiplicityElementAList(outPin,outPinPart, i);
			if (useListForOutput) {
				// Ray - the output variable of Join hasn't been set prior to this and WSADIE code-gen will have a problem with it
				// The solution is to create a new part object instance everytime and then set the contents.  This also will optimize the code on not
				// needing to do 'get' on the part as this is costly
				// 1. Get type of part
//					String fullPartTypeName = AbstractbpelUtil.getFullJavaClassName(outPinPart.getTypeName());
//				// Create partClass instance
//					javaAssign += fullPartTypeName + " " + outPinPart.getName() + " = new " + fullPartTypeName + "();\n";
					javaAssign += AbstractbpelUtil.createJavaVariableForPartCode(osVariable,outPinPart,false);
			
			}
			int outListInd=0;
			boolean lastIndexInitialized=false;
			String outVarName = AbstractbpelUtil.capitalizeFirstChar(osVariable.getName());
			String outPartName = AbstractbpelUtil.capitalizeFirstChar(outPinPart.getName());
			for (int j=i, inPinCount = is.getInputObjectPin().size(); j<inPinCount; j+=outPinCount){
				InputObjectPin inPin = (InputObjectPin)is.getInputObjectPin().get(j);
				inPinPart = (Part)((PartRule)TransformationUtil.getRuleForSource(getRoot(), PartRule.class,	inPin)).getTarget().get(0);
				/* Get the multiplicity of inPin.  This will affect whether use Java Lists or not */
				boolean useListForInput;
				useListForInput = AbstractbpelUtil.isTransformedMultiplicityElementAList(inPin,inPinPart, j);
				javaAssign += AbstractbpelUtil.createJavaCopySnippets(isVariable,inPinPart,useListForInput,osVariable,outPinPart,useListForOutput,lastIndexInitialized,"lastIndex"+i,Integer.toString(outListInd),false);
				
				if (useListForOutput) {
					if (!useListForInput) {
						outListInd++;
					} else {
						lastIndexInitialized=true;
					}
				}

			}
			if (useListForOutput) {
				javaAssign += AbstractbpelUtil.createJavaPartSetterCode(osVariable,outPinPart,outPinPart.getName());
			}
		}
		return javaAssign;
	}	


	//Ray
	private boolean isListOfElement(Pin pin,Part part) {
		boolean isList=false;
		if (pin instanceof InputObjectPin) {
			isList = BomUtils.isMultipled((InputObjectPin)pin);
		} else {
			isList = BomUtils.isMultipled((OutputObjectPin)pin);
		}
		if (isList) {

			XSDTypeDefinition partType = part.getTypeDefinition();
			if(part.getTypeDefinition() != null){
				partType = part.getTypeDefinition();
			}else if (part.getElementDeclaration().getTypeDefinition() != null){
				partType = part.getTypeDefinition();
			}
			if (partType != null) {
				if (partType instanceof XSDComplexTypeDefinition) {
					// it may not be the safest to just check the name ...
					if (!partType.getName().startsWith("ListOf")) {
						isList = false;
					}
				} else {
					isList = false;
				}
			}
		}	
		return isList;	
	}
	
	//Ray
	private String getListOfElementName (XSDComplexTypeDefinition type) {
		String elementName = null;
		elementName = ((XSDElementDeclaration)((XSDParticle)((XSDModelGroup)type.getComplexType().getContent()).getContents().get(0)).getContent()).getName();
		return elementName;
	}	
	/**
	 * Calls the method to generate the mapped representation of the input set, and connects
	 * the result via a BPEL link to the target activity, if required
	 * @param pinSet The input set to map
	 * @param target The target activity to connect to the input set representation
	 */
	private void connectInputSet(InputPinSet pinSet, Activity target){
		/* Connect the incoming and outgoing links for this action */
		List isResultList = mapInputPinSet(pinSet);
		Activity inputSetActivity = null;
		if (isResultList.isEmpty() || !(isResultList.get(0) instanceof Activity)){
			inputSetActivity = target;
		} else {
			inputSetActivity = (Activity)isResultList.get(0);
				
			/* Link the new input set activity to the sequence */
			Link link = linkActivities(inputSetActivity, 
									   target, 
									   BomUtils.getCanonicalName(pinSet) + "_to_" + pinSet.getAction().getName());
				
			isResultList.add(link);
				
			/* Propagate results from the input set mapping */
			getTarget().addAll(isResultList);
		}

		setTargetOfLinks(pinSet, inputSetActivity);	
	}

	/**
	 * Calls the method to generate the mapped representation of the output set, and connects
	 * the source to the result via a BPEL link, if required.
	 * 
	 * @param pinSet The output pin set to map
	 * @param source The BPEL activity to connect the output set reprsentation to
	 */	
	private void connectOutputSet(OutputPinSet pinSet, Activity source){
		List osResultList = mapOutputPinSet(pinSet);
		Activity outputSetActivity = null;
		if (osResultList.isEmpty() || !(osResultList.get(0) instanceof Activity)){
			outputSetActivity = source;
		} else {
			outputSetActivity = (Activity)osResultList.get(0);
				
			/* Link the new input set activity to the sequence */
			Link link = linkActivities(source, 
									   outputSetActivity, 
									   pinSet.getAction().getName() + "_to_" + BomUtils.getCanonicalName(pinSet));
				
			osResultList.add(link);
				
			/* Propagate the results from the input set mapping */
			getTarget().addAll(osResultList);
		}

		setSourceOfLinks(pinSet, outputSetActivity);	
	}

	/** 
	 * Create the expression model representation of the BPEL assignment expression
	 */	
	private FunctionExpression createExpressionModel(Part pinPart, int k)
	{
		FunctionExpression functionExpr = ModelFactory.eINSTANCE.createFunctionExpression();					
		FunctionDefinition def = ModelFactory.eINSTANCE.createFunctionDefinition();
		def.setFunctionID(CoreFunctions.SELECT_FUNCTION);

		/* First Argument (elements) for the select Function Expression is a ModelPathExpression*/
		FunctionArgument arg1 = ModelFactory.eINSTANCE.createFunctionArgument();			
		ModelPathExpression pathExpr = ModelFactory.eINSTANCE.createModelPathExpression();
		StaticStep step1 = ModelFactory.eINSTANCE.createStaticStep();
		step1.setStepName(pinPart.getName());
		StaticStep step2 = ModelFactory.eINSTANCE.createStaticStep();
		step2.setStepName(pinPart.getTypeName().getLocalPart());
		pathExpr.setIsAbsolute(Boolean.TRUE);
		pathExpr.getSteps().add(step1);
		pathExpr.getSteps().add(step2);					
		arg1.setArgumentValue(pathExpr);

		/* Second argument (selection criteria) for the select Function Expression is a ComparisonExpression */
		FunctionArgument arg2 = ModelFactory.eINSTANCE.createFunctionArgument();
		ComparisonExpression cmpExpr = ModelFactory.eINSTANCE.createComparisonExpression();	
					
		/* first operand of ComparisonExpression is position() Function Expresssion with no arguments */				
		FunctionExpression posFunctionExpr = ModelFactory.eINSTANCE.createFunctionExpression();					
		FunctionDefinition def2 = ModelFactory.eINSTANCE.createFunctionDefinition();
		def2.setFunctionID("com.ibm.btools.te.ilm.heuristics.abstractbpel.position");
		def2.setFunctionName("position");
		posFunctionExpr.setDefinition(def2);

		cmpExpr.setFirstOperand(posFunctionExpr);		

		cmpExpr.setOperator(ComparisonOperator.EQUAL_TO_LITERAL);

		/* Second operand is an IntegerLiteralExpression */
		IntegerLiteralExpression intExpr = ModelFactory.eINSTANCE.createIntegerLiteralExpression();
		intExpr.setIntegerSymbol(new Integer(k));
		cmpExpr.setSecondOperand(intExpr); 				

		arg2.setArgumentValue(cmpExpr);					
		functionExpr.setDefinition(def);
		functionExpr.getArguments().add(arg1);
		functionExpr.getArguments().add(arg2);
		
		return functionExpr;
	}
	
//	private Variable getVariableForPinSet(PinSet pinSet){
//		ContainerRule crIS = AbstractbpelFactory.eINSTANCE.createContainerRule();
//		crIS.getSource().add(pinSet);
//		getChildRules().add(crIS);
//		crIS.transformSource2Target();
//		getTarget().addAll(crIS.getTarget());
//		Variable variable = (Variable)crIS.getTarget().get(0);
//		return variable;
//	}
	/**
	 * Returns the BPELVariable created for this objectPin. Creates the variable if the flag indicates so, else, 
	 * if the BPELVariable is not set, return null.
	 * @param pinSet
	 * @param objectPin
	 * @param createNew
	 * @return
	 */
	private BPELVariable getVariableForPin(PinSet pinSet, ObjectPin objectPin , boolean createNew){
		if(!createNew){
			ArrayList thisSources = new ArrayList();
			thisSources.add(((TypedElement)objectPin).getType());
			thisSources.add(objectPin);
			//check if there if this srcObj was already processed for Variable.
			TransformationRule rule = TransformationUtil.getRuleForSource(getRoot(), VariableRule.class, thisSources, BPELVariable.class );
			if(rule != null && !rule.getTarget().isEmpty()){
				return (BPELVariable)rule.getTarget().get(0);
			}else{
				return null;
			}
		}
		BPELVariable variable = createVariable(objectPin);
		getTarget().add(variable);
		return variable;

	}
	
	private List getVariablesForPinSet(PinSet pinSet){
		List objectPins = BomUtils.getObjectPinsForSet(pinSet);
		List variables = new LinkedList();
		if(!objectPins.isEmpty()) {
			Iterator it = objectPins.iterator();
			while(it.hasNext()){
				ObjectPin op = (ObjectPin)it.next();
				BPELVariable variable = createVariable(op);
				if(variable != null){
					getTarget().add(variable);
					variables.add(variable);
				}
			}
		}
		return variables;
	}
	/**
	 * Re-executes this rule. After reExecuting the super, will attempt to rebuild the JavaSnippet that might have been created for
	 * this rule. If the input branches in this Join belong to parallel branches that were not processed at the time of processing 
	 * the flow (ex. parallel flow starting from the Process starts and/or pinSet), the Snippet created for this Join will be left
	 * as empty "". It will be created on a subsequent path (reExecute) when all the variables are known. 
	 * This is currently a workaround.. it should be handled by a ConcurrentBranchRule for the Process. 
	 */
	protected void reExecute(InputPinSet inputSet){
		super.reExecute(inputSet);
		reExecuteBPELPAlternativeActivity();
	}
	
	/**
	 * Attempts to rebuild the JavaSnippet that might have been created for this Join, if left unfinished. 
	 *
	 */
	private void reExecuteBPELPAlternativeActivity(){
		Activity bpelpActivity = getBPELPAlternativeActivity(getTarget());
		if(bpelpActivity != null){
			if(bpelpActivity instanceof Invoke){
				List extensibilityElements = bpelpActivity.getExtensibilityElements();
				JavaScriptActivity javaScript = (JavaScriptActivity)extensibilityElements.get(0);
				if(javaScript.getJavaCode().equals("")){
					InputPinSet is = (InputPinSet)getSource().get(0);
					Variable isVariable=null;
					Variable osVariable = null;
					/* For a join, the input set must be correlated to a single output set */
					OutputPinSet os = (OutputPinSet)is.getOutputPinSet().get(0);
					List isVariables = getVariablesForPinSet(is);
					List osVariables = getVariablesForPinSet(os);
					String assign = createJavaInvokeForWSICompliantDiamond(is, os);
					javaScript.setJavaCode(assign);
				}
			}
		}
	}
	
	/** 
	 * Returns the BPELP Alternative Activity that might have been created for this Join.
	 * @param targets
	 * @return
	 */
	private Activity getBPELPAlternativeActivity(List targets){
		if(targets == null || targets.isEmpty()){
			return null;
		}
		Activity bpelpActivity = null;
		Iterator it = targets.iterator();
		while(it.hasNext()){
			Object targetActivity = it.next();
			if(targetActivity instanceof AlternativeActivity){
				AlternativeActivity activity = (AlternativeActivity)targetActivity;
				bpelpActivity = ((Alternative)activity.getAlternative().get(1)).getActivity();
			}
		}
		return bpelpActivity;
	}
	
	/**
	 * Returns true if we need to create an Invoke for this Join. 
	 * This is the case we can optimize the Join. We should not need to create the JavaSnippet (it will be empty) if all the Pins in 
	 * the Join OutputPinSet are connected to StopNodes or TerminationNodes or are not Connected.
	 * @param os
	 */
	private boolean doNeedInvoke(OutputPinSet os){
		boolean invokeNeeded = true;
		if(os.getOutputObjectPin() != null && !os.getOutputObjectPin().isEmpty()){
			List unconnectedPins = new LinkedList();
			Iterator it = os.getOutputObjectPin().iterator();
			while(it.hasNext()){
				ObjectPin outPin = (ObjectPin)it.next();
				if(!(outPin instanceof StoreArtifactPin)){
					if((outPin.getOutgoing()== null ) || !(outPin.getOutgoing().getTarget() instanceof ObjectPin)){
						unconnectedPins.add(outPin);
					}
				}
			}
			if(unconnectedPins.size()== os.getOutputObjectPin().size()){
				invokeNeeded = false;
			}
		}
		
		return invokeNeeded;
		
	}
	
} //JoinRuleImpl
