/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.abstractbpel.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.wst.wsdl.Operation;
import org.eclipse.wst.wsdl.PortType;

import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.te.attributes.helper.AttributeNameConstants;
import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.attribute.AttributeValueProvider;
import com.ibm.btools.te.ilm.attribute.AttributeValueProviderFactory;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelPackage;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.OneWayInvokeRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.util.PinSetRegistryUtil;
import com.ibm.btools.te.ilm.heuristics.naming.NamingUtil;
import com.ibm.wbit.bpel.BPELFactory;
import com.ibm.wbit.bpel.Invoke;
import com.ibm.wbit.bpel.PartnerLink;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>One Way Invoke Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class OneWayInvokeRuleImpl extends InvokeRuleImpl implements OneWayInvokeRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	
//	protected CorrelationSet cSetForInvoke=null;
	
								/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OneWayInvokeRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return AbstractbpelPackage.Literals.ONE_WAY_INVOKE_RULE;
	}

	protected Invoke createInvoke(InputPinSet inputSet) {
		Operation operation;
		PartnerLink partner;
		operation = (Operation)getSource().get(2);
		partner = (PartnerLink)getSource().get(3);
		PortType portType = (PortType)operation.eContainer();
		//create BPEL invoke
		Invoke invoke = BPELFactory.eINSTANCE.createInvoke();
		
		AttributeValueProvider valueProvider = AttributeValueProviderFactory.createAttributeValueProvider(AttributeNameConstants.BPEL_ACTIVITY_NAME);
		valueProvider.setContext(this.getContext());
		String convertedName = (String)valueProvider.getAttributeValueForType(invoke, inputSet, AttributeNameConstants.BPEL_ACTIVITY_NAME, NamingUtil.findRegistry(this));

//		JavaNCNameConverter converter = new JavaNCNameConverter();
//		String convertedName = converter.convertName(NamingUtil.findRegistry(this), invoke, BomUtils.getCanonicalName(inputSet));
		invoke.setName(convertedName);
		//invoke.setName(BomUtils.getCanonicalName(inputSet));
		//invoke.setInputVariable(ivInputContainer);
		// AR invoke will use the Input instead if BPELVariable
		invoke.getExtensibilityElements().add(ivInput);
		invoke.setOperation(operation);
		invoke.setPartnerLink(partner);
		invoke.setPortType(portType);
		
		// Register the invoke activity for the inputPinSet
		PinSetRegistryUtil.registerPinSet(getContext(),inputSet,invoke);
		
		// If 1-way longrunning process is used, need to create empty correlation set
//		cSetForInvoke = BPELFactory.eINSTANCE.createCorrelationSet();
//		cSetForInvoke.setName(invoke.getName());
//		getTarget().add(cSetForInvoke);
//		Correlation cor = BPELFactory.eINSTANCE.createCorrelation();
//		cor.setSet(cSetForInvoke);
//		//migration ?? 11.09 AR
//		//cor.setInitiate(Boolean.TRUE);
//		cor.setInitiate(AbstractbpelUtil.BPEL_CORRELATION_INITIATE_YES);
//		Correlations cors = invoke.getCorrelations();
//		if (cors==null) {
//			cors=BPELFactory.eINSTANCE.createCorrelations();
//			invoke.setCorrelations(cors);
//		}
//		
//		cor.setPattern(CorrelationPattern.OUT_LITERAL);
//		cors.getChildren().add(cor);
	   
		//Ray: added for displayname on BPELP
		//String name = getDisplayName(inputSet.getAction());
		//createDisplayName(invoke,name);
		createDisplayName(invoke, inputSet, AttributeNameConstants.BPEL_ACTIVITY_DISPLAY_NAME);
//		LoggingUtil.logWarning(MessageKeys.INCOMPLETE_CORRELATION_SET_WARNING, new String[]{name}, null);
		return invoke;				
	}

} //OneWayInvokeRuleImpl
