/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.abstractbpel.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import org.eclipse.emf.ecore.EClass;
import org.eclipse.wst.wsdl.PortType;

import com.ibm.btools.blm.ie.exprt.ExportSession;
import com.ibm.btools.blm.ie.exprt.option.BpelOptions;
import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.bom.model.processes.activities.StructuredActivityNode;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelPackage;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessInterfaceRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.SANReusableTaskRule;
import com.ibm.btools.te.ilm.heuristics.helper.BpelOptionsUtil;
import com.ibm.btools.te.ilm.heuristics.scdl.util.ScdlUtil;
import com.ibm.btools.te.ilm.heuristics.wsdl.util.OriginalWsdlUtil;
import com.ibm.wsspi.sca.scdl.DocumentRoot;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>SAN Reusable Task Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class SANReusableTaskRuleImpl extends ActionRuleImpl implements SANReusableTaskRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SANReusableTaskRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return AbstractbpelPackage.Literals.SAN_REUSABLE_TASK_RULE;
	}

	/* (non-Javadoc)
	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target()
	 */
	public boolean transformSource2Target() {
		LoggingUtil.traceEntry(this, "transformSource2Target");

		StructuredActivityNode san = (StructuredActivityNode)getSource().get(0);
		InputPinSet inputSet = (InputPinSet)san.getInputPinSet().get(0);

		// Need to get the PortType to create the SCDL Component/Export
		Action action = inputSet.getAction();
		ProcessInterfaceRule processIntRule = createProcessInterfaceRule(action);
		TransformationRule portTypeRule = createPortTypeRule(processIntRule,action);	
		
		PortType taskInterface = (PortType)portTypeRule.getTarget().get(0);
		
		// Create SCDL Component
		DocumentRoot componentRoot = createSCDLComponent(action,taskInterface);
	    // Create SCDL Export
		//feature 118131, only create SCDL Export if we have created a Component
		//AZ WMT 20070322 add pattern support
		ExportSession exportSession = BpelOptionsUtil.getExportSession();
		if(ScdlUtil.isComponent(componentRoot)|| (BpelOptions.isBestPracticePatternEnabed(exportSession)&& componentRoot!= null)){
		//d2d requires export component whether there is a binding information or not
		//	if(!OriginalWsdlUtil.isBindingInfoAvailable(action,taskInterface,getContext())){				
				createSCDLExport(componentRoot,taskInterface);				
		//	}
		}
	    propagateChildTargets();
		setComplete(true);
		LoggingUtil.traceExit(this, "transformSource2Target");
		return isComplete();	
	}
} //SANReusableTaskRuleImpl
