/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.abstractbpel.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.xsd.XSDAttributeDeclaration;
import org.eclipse.xsd.XSDElementDeclaration;
import org.eclipse.xsd.XSDSchema;
import org.eclipse.xsd.XSDTypeDefinition;
import org.eclipse.xsd.util.XSDConstants;

import com.ibm.btools.bom.model.artifacts.ArtifactsFactory;
import com.ibm.btools.bom.model.artifacts.Class;
import com.ibm.btools.bom.model.artifacts.MultiplicityElement;
import com.ibm.btools.bom.model.artifacts.Type;
import com.ibm.btools.bom.model.artifacts.TypedElement;
import com.ibm.btools.bom.model.externalmodels.ExternalSchema;
import com.ibm.btools.bom.model.processes.actions.ControlAction;
import com.ibm.btools.bom.model.processes.actions.Decision;
import com.ibm.btools.bom.model.processes.actions.Fork;
import com.ibm.btools.bom.model.processes.activities.ConnectableNode;
import com.ibm.btools.bom.model.processes.activities.InputObjectPin;
import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.bom.model.processes.activities.InputValuePin;
import com.ibm.btools.bom.model.processes.activities.ObjectPin;
import com.ibm.btools.bom.model.processes.activities.OutputObjectPin;
import com.ibm.btools.bom.model.processes.activities.OutputPinSet;
import com.ibm.btools.bom.model.processes.activities.Pin;
import com.ibm.btools.bom.model.processes.activities.PinSet;
import com.ibm.btools.bom.model.processes.activities.Repository;
import com.ibm.btools.bom.model.processes.activities.RetrieveArtifactPin;
import com.ibm.btools.bom.model.processes.activities.StoreArtifactPin;
import com.ibm.btools.te.attributes.helper.AttributeNameConstants;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.framework.util.TransformationUtil;
import com.ibm.btools.te.ilm.ExportOperation;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.attribute.AttributeValueProvider;
import com.ibm.btools.te.ilm.attribute.AttributeValueProviderFactory;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelPackage;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessDefinitionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.VariableRule;
import com.ibm.btools.te.ilm.heuristics.helper.AbstractbpelConstants;
import com.ibm.btools.te.ilm.heuristics.helper.AbstractbpelUtil;
import com.ibm.btools.te.ilm.heuristics.helper.BomHelper;
import com.ibm.btools.te.ilm.heuristics.helper.BomUtils;
import com.ibm.btools.te.ilm.heuristics.helper.ProcessUtil;
import com.ibm.btools.te.ilm.heuristics.naming.JavaNCNameConverter;
import com.ibm.btools.te.ilm.heuristics.naming.NamingUtil;
import com.ibm.btools.te.ilm.heuristics.xsd.ClassRule;
import com.ibm.btools.te.ilm.heuristics.xsd.DataDefinitionRule;
import com.ibm.btools.te.ilm.heuristics.xsd.ListRule;
import com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdFactoryImpl;
import com.ibm.btools.te.ilm.heuristics.xsd.util.DataDefinitionUtil;
import com.ibm.wbit.bpel.BPELFactory;
import com.ibm.wbit.bpel.BPELVariable;
import com.ibm.wbit.bpel.Process;





/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Variable Rule</b></em>'.
 * 
 * <p>This method is responsible for mapping a BOM Variable into a BPEL variable</p>
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class VariableRuleImpl extends AbstractProcDefRuleImpl implements VariableRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	private List currentPathCompatibleVariablesRules = new LinkedList();
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected VariableRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return AbstractbpelPackage.Literals.VARIABLE_RULE;
	}

	/**
	 * @param pin
	 * @param container
	 */
	private void registerVariableForFork(OutputObjectPin objectPin, BPELVariable container) {
		
		PinSet os = BomUtils.findPinSetForPin(objectPin);
		//total number of Pins in the Fork OutputSet
		int outPins = BomUtils.getPinsInSet(os).size();
//		total number of Pins in the Fork InputSet
		//int inPins = BomUtils.getPinsInSet(is).size();
		PinSet is = (InputPinSet)((OutputPinSet)os).getInputPinSet().get(0); 
		
		int inPins = BomUtils.getObjectPinsForSet(is).size();
		//the index of the Pin in the Fork OutputSet
		//int index = BomUtils.getPinsInSet(os).indexOf(pinInForkOutput);
		int index = BomUtils.getObjectPinsForSet(os).indexOf(objectPin);
			//now get the correspondent pin in the is of the Fork inputSet
		int inputIndex = index%inPins; 
	
		ObjectPin inPin = (ObjectPin)((InputPinSet)is).getInputObjectPin().get(inputIndex);
		
		this.getSource().add(inPin);
	}
	
	/**
	 * @param pin
	 * @param container
	 */
	private void registerVariableForDecision(OutputObjectPin objectPin, BPELVariable container) {
		
		TransformationRule defRule = ProcessUtil.getProcessDefinitionRule(getContext()); 
		PinSet os = BomUtils.findPinSetForPin(objectPin);
		PinSet inputSet = (InputPinSet)((OutputPinSet)os).getInputPinSet().get(0); 
		
		BomHelper.getInstance().reuseContainer(defRule, inputSet, os);

	}

	/**
	 * Returns the variable coresponding to the OutputPin
	 * @param objectPin
	 * @return
	 */
	private BPELVariable getCompatibleVariableForFork(OutputObjectPin objectPin){
		BPELVariable variable = null;
		PinSet os = BomUtils.findPinSetForPin(objectPin);
		//total number of Pins in the Fork OutputSet
		int outPins = BomUtils.getPinsInSet(os).size();
//		total number of Pins in the Fork InputSet
		//int inPins = BomUtils.getPinsInSet(is).size();
		PinSet is = (InputPinSet)((OutputPinSet)os).getInputPinSet().get(0); 
		
		int inPins = BomUtils.getObjectPinsForSet(is).size();
		//the index of the Pin in the Fork OutputSet
		//int index = BomUtils.getPinsInSet(os).indexOf(pinInForkOutput);
		int index = BomUtils.getObjectPinsForSet(os).indexOf(objectPin);
			//now get the correspondent pin in the is of the Fork inputSet
		int inputIndex = index%inPins; 
	
		ObjectPin inPin = (ObjectPin)((InputPinSet)is).getInputObjectPin().get(inputIndex);
		ArrayList sources = new ArrayList();
		
		sources.add(inPin.getType());
		sources.add(inPin);
		
		TransformationRule rule = TransformationUtil.getRuleForSource(getRoot(), VariableRule.class, sources, BPELVariable.class);
		if(rule != null){
			variable = (BPELVariable)rule.getTarget().get(0);
		}
		
		return variable;
	}
	
	/**
	 * Returns the variable coresponding to the OutputPin
	 * @param objectPin
	 * @return
	 */
	private BPELVariable getCompatibleVariableForDecision(OutputObjectPin objectPin){
		BPELVariable variable = null;
		PinSet os = BomUtils.findPinSetForPin(objectPin);

		PinSet is = (InputPinSet)((OutputPinSet)os).getInputPinSet().get(0); 
		
		int inPins = BomUtils.getObjectPinsForSet(is).size();
		//the index of the Pin in the Fork OutputSet
		int index = BomUtils.getObjectPinsForSet(os).indexOf(objectPin);
			//now get the correspondent pin in the is of the Fork inputSet

		ObjectPin inPin = (ObjectPin)((InputPinSet)is).getInputObjectPin().get(index);
		ArrayList sources = new ArrayList();
		
		sources.add(inPin.getType());
		sources.add(inPin);
		
		TransformationRule rule = TransformationUtil.getRuleForSource(getRoot(), VariableRule.class, sources, BPELVariable.class);
		if(rule != null){
			variable = (BPELVariable)rule.getTarget().get(0);
		}
		
		return variable;
	}
	
	
	/**
	 * Creates the XSDTypeDefinition for the type of the <code>typedElement</code>.
	 * Adds <code>typedElement</code> namespace import to the <code>definition</code> if needed.
	 * @param definition the WSDL Definition 
	 * @param typedElement BOM TypedElement to be mapped to a XSDTypeDefinition
	 * @return XSDTypeDefinition
	 */
	private XSDTypeDefinition getXSDType(TypedElement typedElement) {
		
		Type dataType = typedElement.getType();
		XSDTypeDefinition typeDefinition = null;
		//gets the DataDefinitionRule, source of the XSDTransformation for the inputTypedElement
		DataDefinitionRule rule = DataDefinitionUtil.getDataDefinitionRule(this, typedElement);
		//if the typedElement has multiplicity specified, retrives the XSDTypeDefinition from a List rule
		if(AbstractbpelUtil.isMultipled((MultiplicityElement)typedElement)){
			 typeDefinition = getXSDTypeDefinition(rule, typedElement);
		//retrives the XSDTypeDefinition from a ClassRule rule
		}else{
			typeDefinition = getXSDTypeDefinition(rule, dataType);
		}
		return typeDefinition;
	}
	
	/**
	 * Maps the typedElement into a XSDTypeDefinition. Delegates the transformation to a ListRule 
	 * created in the <code>rule</code> context, if a ListRule was not already found for this <code>typedElement</code>. 
	 * @param rule the root of the XSD transformation.
	 * @param typedElement BOM TypeElement, also a multiplicity element to transform to a XSDTypeDefinition
	 * @return XSDTypeDefinition
	 */
	private XSDTypeDefinition getXSDTypeDefinition(DataDefinitionRule rule, TypedElement typedElement){
		
		XSDTypeDefinition typeDefinition = null;
		ListRule typeRule = XsdFactoryImpl.eINSTANCE.createListRule();
		typeRule.getSource().add(typedElement);
		rule.getChildRules().add(typeRule);
		//executes the rule in the context and return the target of this rule.
		boolean ret = rule.transformSource2Target();
		if(typeRule.getTarget()!= null && !typeRule.getTarget().isEmpty()){
			typeDefinition =(XSDTypeDefinition) typeRule.getTarget().get(0);
		}
		return typeDefinition;
	}
	
	
	/**
	 * Maps the <code>dataType</code> into a XSDTypeDefinition. Delegates the transformation to a ClassRule 
	 * created in the <code>rule</code> context. 
	 * @param rule the root of the XSD transformation.
	 * @param dataType BOM Type to transform to a XSDTypeDefinition
	 * @return XSDTypeDefinition
	 */
	private XSDTypeDefinition getXSDTypeDefinition(DataDefinitionRule rule, Type dataType){
		
		//tries to retrieve a rule with the same source rule from the context. 
		TransformationRule xsdRule = TransformationUtil.getRuleForSource(rule, dataType, XSDTypeDefinition.class);
		if(xsdRule != null){
			return (XSDTypeDefinition)xsdRule.getTarget().get(0);
		}
		XSDTypeDefinition typeDefinition = null;
		//create a typeRule, attach it to the DataDefinitionRule and execute it
		// get the return target and process it
		ClassRule typeRule = XsdFactoryImpl.eINSTANCE.createClassRule();
		if(dataType == null){
			dataType = ArtifactsFactory.eINSTANCE.createPrimitiveType();
			dataType.setName(DataDefinitionUtil.XSD_ANY_TYPE);
		}
		typeRule.getSource().add(dataType);
		rule.getChildRules().add(typeRule);
		boolean ret = rule.transformSource2Target();
		if(typeRule.getTarget()!= null && !typeRule.getTarget().isEmpty()){
		    if (typeRule.getTarget().get(0) instanceof XSDTypeDefinition) {
				typeDefinition =(XSDTypeDefinition) typeRule.getTarget().get(0);
		    } else if (typeRule.getTarget().get(0) instanceof XSDElementDeclaration){
		        typeDefinition = ((XSDElementDeclaration) typeRule.getTarget().get(0)).getType();
		    } else if (typeRule.getTarget().get(0) instanceof XSDAttributeDeclaration){
		        typeDefinition = ((XSDAttributeDeclaration) typeRule.getTarget().get(0)).getType();
		    }
		}
		return typeDefinition;
	}
	
	/**
	 * Returns the list of rules that are compatible with the given objectPin based on the Pin multiplicity
	 * While iterating through the list also records the list of variables that were created in the current path
	 * @param rules
	 * @param objectPin
	 * @return
	 */
	private List getCompatibleRulesForPin(Collection rules, ObjectPin objectPin){
		List compatibleRules = new LinkedList();
		Collection nonCompatibleRules = new LinkedList();
		List variablesInCurrentPath = ProcessUtil.getCurrentPathParallelFlowsRegisteredVariables(getContext());
		//defect 77820
		ConnectableNode connectedPin = null;
		if(objectPin.getOutgoing() != null) connectedPin = objectPin.getOutgoing().getTarget();
		Iterator it = rules.iterator();
		while(it.hasNext()){
			TransformationRule rule = (TransformationRule)it.next();
					//defect 119513
			for(int i=1; i<rule.getSource().size(); i++){
				//MultiplicityElement pin= (MultiplicityElement)rule.getSource().get(1);
				MultiplicityElement pin= (MultiplicityElement)rule.getSource().get(i);
				if(BomHelper.getInstance().sameMultiplicity(pin, objectPin)){
					//if(pin instanceof Pin && (BomUtils.findPinSetForPin((Pin)pin).equals(BomUtils.findPinSetForPin(objectPin)) && !(BomUtils.findPinSetForPin(objectPin).eContainer() instanceof ControlAction))){
					if(pin instanceof Pin && BomUtils.findPinSetForPin((Pin)pin).equals(BomUtils.findPinSetForPin(objectPin))){
						//there are 2 compatible pins created from the same PinSet..
						Collection samePinSetRules = TransformationUtil.getRulesForTarget(getRoot(), rule.getTarget(), Pin.class);
						if(samePinSetRules != null && !samePinSetRules.isEmpty()){
							nonCompatibleRules.addAll(samePinSetRules);
						}
						//check the upstream for some type - defect 75770, 76445
					}else if(pin instanceof Pin && connectedPin != null && connectedPin instanceof Pin && BomUtils.findPinSetForPin((Pin)pin).equals(BomUtils.findPinSetForPin((Pin)connectedPin))){
						Collection samePinSetRules = TransformationUtil.getRulesForTarget(getRoot(), rule.getTarget(), Pin.class);
						if(samePinSetRules != null && !samePinSetRules.isEmpty()){
							nonCompatibleRules.addAll(samePinSetRules);
						}
						// we need to avoid passing variables created for the Variable through the process. These are used only for compatible
						//Retrieve, store.
					}else if(pin instanceof com.ibm.btools.bom.model.processes.activities.Variable){
						nonCompatibleRules.add(rule);
						Collection sameTargetRules = TransformationUtil.getRulesForTarget(getRoot(), rule.getTarget(), Pin.class);
						if(sameTargetRules != null && !sameTargetRules.isEmpty()){
							nonCompatibleRules.addAll(sameTargetRules);
						}
					}
					compatibleRules.add(rule);
					if(variablesInCurrentPath.contains(rule.getTarget().get(0))){
						currentPathCompatibleVariablesRules.add(rule);
					}
					
					}
				}
		}

		if(nonCompatibleRules != null){
			compatibleRules.removeAll(nonCompatibleRules);
			currentPathCompatibleVariablesRules.removeAll(nonCompatibleRules);
		}
		return compatibleRules;
		
	}
	/**
	 * Returns the list of rules that are compatible with the given objectPin based on the Pin multiplicity
	 * While iterating through the list also records the list of variables that were created in the current path
	 * @param rules
	 * @param objectPin
	 * @return
	 */
	private List getCompatibleRulesForPin(Collection rules, com.ibm.btools.bom.model.processes.activities.Variable objectPin){
		List compatibleRules = new LinkedList();
		Collection nonCompatibleRules = new LinkedList();
		List variablesInCurrentPath = ProcessUtil.getCurrentPathParallelFlowsRegisteredVariables(getContext());
		Iterator it = rules.iterator();
		while(it.hasNext()){
			TransformationRule rule = (TransformationRule)it.next();
					//defect 119513
			for(int i=1; i<rule.getSource().size(); i++){
				//MultiplicityElement pin= (MultiplicityElement)rule.getSource().get(1);
				MultiplicityElement pin= (MultiplicityElement)rule.getSource().get(i);
				if(BomHelper.getInstance().sameMultiplicity(pin, objectPin)){
					compatibleRules.add(rule);
					if(variablesInCurrentPath.contains(rule.getTarget().get(0))){
						currentPathCompatibleVariablesRules.add(rule);
					}
				}
			}
		}

		if(nonCompatibleRules != null){
			compatibleRules.removeAll(nonCompatibleRules);
			currentPathCompatibleVariablesRules.removeAll(nonCompatibleRules);
		}
		return compatibleRules;
		
	}

	
	/**
	 * Returns true if the 2 pins are the duplication of the same InputObjectPin in the Fork OutputPinSet.
	 * @param pin1
	 * @param pin2
	 * @return
	 */
	private boolean compatibleForkPins(Pin pin1, Pin pin2){
		if(!(pin1 instanceof OutputObjectPin) && !(pin2 instanceof OutputObjectPin)){
			return false;
		}
		OutputObjectPin outPin1 = (OutputObjectPin)pin1;
		OutputObjectPin outPin2 = (OutputObjectPin)pin2;
		
		boolean compatiblePins = false;
		PinSet os = BomUtils.findPinSetForPin(pin1);
		if(!(os.eContainer() instanceof Fork)){
			return false;
		}
		Fork fork = (Fork)os.eContainer();
		int outPins = BomUtils.getPinsInSet(os).size();
		//get the fork inputPinSet
		PinSet is = (InputPinSet)((OutputPinSet)os).getInputPinSet().get(0); 
//		total number of Pins in the Fork InputSet
		int inPins = BomUtils.getObjectPinsForSet(is).size();
		//the index of the Pin in the Fork OutputSet
		int indexPin1 = BomUtils.getObjectPinsForSet(os).indexOf(outPin1);
		int indexPin2 = BomUtils.getObjectPinsForSet(os).indexOf(outPin2);

		//now get the correspondent pin in the is of the Fork inputSet
		int inputIndexPin1 = indexPin1%inPins; 
		int inputIndexPin2 = indexPin2%inPins; 
		
		if(inputIndexPin1 == inputIndexPin2){
			compatiblePins = true;
		}
		return compatiblePins;
	}
	
	
	private void organizeImports(BPELVariable variable){
		ProcessDefinitionRule currentProcessDefRule= (ProcessDefinitionRule)ProcessUtil.getProcessDefinitionRule(this.getContext());
		Process process = (Process)currentProcessDefRule.getTarget().get(0);
		XSDSchema xsdSchema = null;
		if (variable.getType() != null) {
		    xsdSchema = variable.getType().getSchema();
		} else if (variable.getXSDElement() != null) {
		    xsdSchema = variable.getXSDElement().getSchema();
		}
		String xsdNamespace = "";
		if (xsdSchema != null) {
		    xsdNamespace = xsdSchema.getTargetNamespace();
		}
		if(xsdNamespace != null && !xsdNamespace.equals(XSDConstants.SCHEMA_FOR_SCHEMA_URI_2001) && xsdSchema != null && 
				!containsImport(process, xsdNamespace, xsdSchema.getSchemaLocation())){
			//we need to import the schema 
			com.ibm.wbit.bpel.Import xsdImport = BPELFactory.eINSTANCE.createImport();
			if (this.getSource().get(0) instanceof Class &&
			        ((Class)this.getSource().get(0)).getOwningPackage() instanceof ExternalSchema) {
			    xsdImport.setLocation(xsdSchema.getSchemaLocation());
			} else {	// original code
			    xsdImport.setLocation(ProcessUtil.createFileName(xsdNamespace)+ExportOperation.XSD_FILE_EXT);
			}	
			
			xsdImport.setNamespace(xsdNamespace);
			
			if (xsdImport.getLocation() != null && xsdImport.getLocation().endsWith(ExportOperation.WSDL_FILE_EXT)) {
			    xsdImport.setImportType(AbstractbpelConstants.WSDL_IMPORT_TYPE);
			} else {
			    xsdImport.setImportType(AbstractbpelConstants.XSD_IMPORT_TYPE);
			}
			if (xsdImport.getLocation() != null && !xsdImport.getLocation().equals(ExportOperation.XSD_FILE_EXT)) {
				process.getImports().add(xsdImport);
			}
		}		
	}
		

	/**
	 * Checks is the Process already contains a wsdl import for the <code>targetNamespace</code> 
	 * @param process
 	 * @param targetNamespace
 	 * @param location 
	 * @return
	 */
	private boolean containsImport(Process process, String targetNamespace, String location){
		if (location == null) { //there is no schema location - internally created
			List imports = process.getImports();
			if(imports != null && !imports.isEmpty()){
				Iterator it = imports.iterator();
				while(it.hasNext()){
					com.ibm.wbit.bpel.Import thisImport = (com.ibm.wbit.bpel.Import)it.next();
					if(thisImport.getImportType() != null && thisImport.getImportType().equals(AbstractbpelConstants.XSD_IMPORT_TYPE) && 
							thisImport.getNamespace().equals(targetNamespace)){
						return true;
					}
				}
			}
		} else {
			String fileLocation = null;
			if (location.indexOf(ExportOperation.FILE_SEPARATOR_CHAR) != -1) {
				fileLocation = location;//.substring(location.lastIndexOf(ExportOperation.FILE_SEPARATOR_CHAR) + 1);
			} else {
				fileLocation = location;
			}
			List imports = process.getImports();
			String thisImportLocation = null;
			if(imports != null && !imports.isEmpty()){
				Iterator it = imports.iterator();
				while(it.hasNext()){
					com.ibm.wbit.bpel.Import thisImport = (com.ibm.wbit.bpel.Import)it.next();
					if (thisImport.getLocation().indexOf(ExportOperation.FILE_SEPARATOR_CHAR) != -1) {
						thisImportLocation = thisImport.getLocation();//.substring(thisImport.getLocation().lastIndexOf(ExportOperation.FILE_SEPARATOR_CHAR) + 1);					
					} else {
						thisImportLocation = thisImport.getLocation();
					}
					if(thisImport.getImportType() != null && thisImport.getImportType().equals(AbstractbpelConstants.XSD_IMPORT_TYPE) && 
							thisImport.getNamespace().equals(targetNamespace) && 
							thisImportLocation.equals(fileLocation)){
						return true;
					}
				}
			}
		}
		return false;
	}
	
	private BPELVariable createNewVariable(MultiplicityElement typedElement, Type srcObj, boolean register){
	
		XSDTypeDefinition variableType = null;
		TransformationRule definitionRule = null;
		if(!DataDefinitionUtil.isMultipled(typedElement)){
			definitionRule = TransformationUtil.getRuleForSource(getRoot(), ClassRule.class, srcObj, XSDTypeDefinition.class);
		}else{
			definitionRule = TransformationUtil.getRuleForSource(getRoot(), ListRule.class, typedElement, XSDTypeDefinition.class);
		}
		if(definitionRule != null && !definitionRule.getTarget().isEmpty()){
			variableType = (XSDTypeDefinition)definitionRule.getTarget().get(0);
		}else{
			variableType = getXSDType((TypedElement)typedElement);
		}
		BPELVariable container = BPELFactory.eINSTANCE.createBPELVariable();
		// for anonymous types set the element
		if (variableType.getName() == null) {
		    if (variableType.getContainer() instanceof XSDElementDeclaration) {
		        container.setXSDElement((XSDElementDeclaration)variableType.getContainer());
		    } else if (variableType.getContainer() instanceof XSDAttributeDeclaration) {
		        // BPEL spec - only elements with complex types are allowed.
		    }
		} else {
		    container.setType(variableType);
		}
		//pass the name through the registry... 
		String convertedName = null;
		//the Variable name for the LocalRepository is the only one that constitutes a TechnicalAttribute, else, get the name directly from the converter
		if(typedElement instanceof com.ibm.btools.bom.model.processes.activities.Variable){
			com.ibm.btools.bom.model.processes.activities.Variable repository = (com.ibm.btools.bom.model.processes.activities.Variable)typedElement;
			AttributeValueProvider valueProvider = AttributeValueProviderFactory.createAttributeValueProvider(AttributeNameConstants.BPEL_VARIABLE_NAME_VARIABLE);
			valueProvider.setContext(this.getContext());
			convertedName = (String)valueProvider.getAttributeValueForType(container, repository, AttributeNameConstants.BPEL_VARIABLE_NAME_VARIABLE, NamingUtil.findRegistry(this));
		}else{
			 JavaNCNameConverter converter = new JavaNCNameConverter();
			 // GJD 20060824
			 String name = variableType.getName();
			 if (name == null  && variableType.eContainer() instanceof XSDElementDeclaration) {	// anonymous type
			     name = ((XSDElementDeclaration)variableType.eContainer()).getName();
			 }
			 convertedName = converter.convertName(NamingUtil.findRegistry(this), container, name + "Variable");
		}

		container.setName(convertedName);
		if(register){
			ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), container);
		}
		organizeImports(container);
		return container;
		
		
	}
	
	/**
	 * Returns BPELVariable for a compatible InputPin in the InputPinSet correlated with the OutputPinSet to which this <code>objectPin</code> belongs to, 
	 * if one exists, else return null. 
	 * @param defRule
	 * @param objectPin
	 * @return
	 */
	private BPELVariable getCompatibleInputPinVariable(TransformationRule defRule, ObjectPin objectPin){
		BPELVariable variable = null;
		List pinSets = BomUtils.getCorrelatedPinSets(BomUtils.findPinSetForPin(objectPin));
		if(pinSets != null && !pinSets.isEmpty()){
			PinSet pinSet = (PinSet)pinSets.get(0);
			List objectPins = BomUtils.getObjectPinsForSet(pinSet);
			if(objectPins != null && !objectPins.isEmpty()){
				Iterator it = objectPins.iterator();
				while(it.hasNext()){
					ObjectPin pin = (ObjectPin)it.next();
					//do not use the Retrieve Artifact Pin 
					if(!(pin instanceof RetrieveArtifactPin) && pin.getType().equals(objectPin.getType()) && BomHelper.getInstance().sameMultiplicity(pin, objectPin)){
						ArrayList targetSources = new ArrayList();
						targetSources.add(pin.getType());
						targetSources.add(pin);
						TransformationRule rule = TransformationUtil.getRuleForSource(defRule, VariableRule.class, targetSources, BPELVariable.class);
						if(rule != null && !rule.getTarget().isEmpty()){
							variable = (BPELVariable)rule.getTarget().get(0);
							//d75770 check if there is no variable of same type assigned to the PinSet or in the connecting PinSet
							boolean isUniqueInTargetPinSet = true;
							if(objectPin.getOutgoing()!= null && objectPin.getOutgoing().getTarget() instanceof ObjectPin){
								ObjectPin targetPin = (ObjectPin)((OutputObjectPin)objectPin).getOutgoing().getTarget();
								isUniqueInTargetPinSet = isUniqueInPinSet(targetPin, variable, defRule);
							}
							if( (!forbiddenVariables.contains(variable)) && isUniqueInPinSet(objectPin, variable, defRule) && isUniqueInTargetPinSet ){
								//again try to avoid assigning to an OutputObjectPin a variable obtained from a Variable. This can sneak in 
								//with a ControlAction that propagates the input ..so if we find a rule that created this variables from a Variable
								//skip the variable
								Collection rules = TransformationUtil.getRulesForTarget(defRule, variable, com.ibm.btools.bom.model.processes.activities.Variable.class);
								if(rules == null || rules.isEmpty()){
									return variable;	
								}
								
							}
						}
					}
				}
			}
		}
		return null;
	}
	
	/**
	 * Returns true if there is not other Pin in the same PinSet as the <code>objectPin</code> for which this <code>variable</code> is assigned.
	 * @param objectPin
	 * @param variable
	 * @return
	 */
	private boolean isUniqueInPinSet(ObjectPin objectPin, BPELVariable variable, TransformationRule defRule){
		BPELVariable thisVariable = null;
		List objectPins = null;
		//defect 75770
		if(objectPin instanceof OutputObjectPin){
			objectPins = BomUtils.getObjectPinsForSet((PinSet)BomUtils.getOutputPinSets(objectPin).get(0));
		}else if(objectPin instanceof InputObjectPin){
			objectPins = BomUtils.getObjectPinsForSet((PinSet)BomUtils.getInputPinSets(objectPin).get(0));
		}
		if(objectPins != null && !objectPins.isEmpty() && objectPins.size() >1){
			Iterator it = objectPins.iterator();
			while(it.hasNext()){
				ObjectPin thisPin = (ObjectPin)it.next();
				if(!thisPin.equals(objectPin)){
					ArrayList targetSources = new ArrayList();
					targetSources.add(thisPin.getType());
					targetSources.add(thisPin);
					TransformationRule rule = TransformationUtil.getRuleForSource(defRule, VariableRule.class, targetSources, BPELVariable.class);
					if(rule != null && !rule.getTarget().isEmpty()){
						thisVariable = (BPELVariable)rule.getTarget().get(0);
						if(variable.getName().equals(thisVariable.getName())){
							return false;
						}
					}
					
				}
			}
		}
		return true;
	}
	

	/**
	 * source = BOM Type and BOM MultiplicityElement (and TypedElement) which can be a Pin, Variable
	 * target = BPEL Variable
	 * 
	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target()
	 */
	public boolean transformSource2Target() {
		LoggingUtil.traceEntry(this, "transformSource2Target");

		if (isComplete()) {
			LoggingUtil.traceExit(this, "transformSource2Target", "already completed");
			return true;				
		}
		if (getSource() == null || getSource().isEmpty()) {
			LoggingUtil.traceExit(this, "transformSource2Target", "no sources");
			return false;
		}
			
		Type srcObj=(Type)source.get(0);
		MultiplicityElement typedElement = (MultiplicityElement)getSource().get(1);
		TransformationRule rule = null;
		BPELVariable variable = null;
		boolean variableFound = false;
		TransformationRule defRule = ProcessUtil.getProcessDefinitionRule(getContext());
		//for a RetrieveArtifactPin try to reuse the Repository Variable, else create a new one.
		// this will work for Datastore, a new variable will be creted each time for it.. 
		if (typedElement instanceof RetrieveArtifactPin){
			RetrieveArtifactPin objectPin = (RetrieveArtifactPin)typedElement;
			variableFound = findVariableForRetrieveArtifactPin(objectPin);
			if (variableFound){
				return isComplete();
			}
		}else if (typedElement instanceof StoreArtifactPin && ((StoreArtifactPin)typedElement).getRepository() instanceof com.ibm.btools.bom.model.processes.activities.Variable){
			
			StoreArtifactPin objectPin = (StoreArtifactPin)typedElement;
			variableFound = findVariableForStoreArtifactPin(objectPin);
			if (variableFound){
				return isComplete();
			}
		}else if(typedElement instanceof InputObjectPin && ! (typedElement instanceof RetrieveArtifactPin || typedElement instanceof InputValuePin)){
			InputObjectPin objectPin = (InputObjectPin)typedElement;
			if(objectPin.getIncoming() != null){
				ObjectPin sourcePin = (ObjectPin)((InputObjectPin)objectPin).getIncoming().getSource();
				while (sourcePin != null && sourcePin.getIncoming() != null && sourcePin instanceof InputObjectPin && BomUtils.isLocalProcess(((InputObjectPin)sourcePin).getAction())){
					sourcePin = (ObjectPin)((InputObjectPin)sourcePin).getIncoming().getSource();
				}
				ArrayList sources = new ArrayList();
				sources.add(sourcePin.getType());
				sources.add(sourcePin);
				rule = TransformationUtil.getRuleForSource(defRule, VariableRule.class, sources, BPELVariable.class);
				//if a rule was already created for this Pin, use the variable and add the Pin as source of this rule 
				if(rule != null && !rule.getTarget().isEmpty()){
					variable = (BPELVariable)rule.getTarget().get(0);
					getTarget().add(variable);
					ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), variable);
					setComplete(true);
					executeHandlers();
					return isComplete();
				}else{
					//do not create a new variable, should always use the outputSet variable.. in case it is not yet there, 
					//it will be added on reexecute
					setComplete(false);
					/* Don't execute handlres if the rule is not complete */
					return isComplete();
				}
			}else{
				//there is no incoming for this InputObjectPin, we must be on the SAN or we must be processing an InputValuePin
				ArrayList sources = new ArrayList();
				sources.add(objectPin.getType());
				sources.add(objectPin);
				//Collection rules = TransformationUtil.getRulesForSource(defRule, VariableRule.class, objectPin.getType(), BPELVariable.class);
				Collection rules = TransformationUtil.getRulesForSource(defRule, VariableRule.class, sources, BPELVariable.class);
				//if a rule was already created for this Pin, use the variable and add the Pin as source of this rule 
				if(rules != null && !rules.isEmpty()){
					Iterator it = rules.iterator();
					while(it.hasNext()){
						VariableRule thisVariableRule = (VariableRule)it.next();
						MultiplicityElement thisSource = (MultiplicityElement)thisVariableRule.getSource().get(1);
						if(BomHelper.getInstance().sameMultiplicity(objectPin, thisSource)){
							//if the 2 pins are in the same pinSet, create a different variable
							//if(thisSource instanceof com.ibm.btools.bom.model.processes.activities.Variable || !BomUtils.findPinSetForPin((Pin)thisSource).equals(BomUtils.findPinSetForPin(objectPin))){
							//the only variable an InputObjectPin on a SAN can reuse is a Variable created from a Repository Variable, it should not reuse another
							//variable ie a Variable from anothe PinSet or from its own PinSet.
							if(thisSource instanceof com.ibm.btools.bom.model.processes.activities.Variable){
								variable = (BPELVariable)thisVariableRule.getTarget().get(0);
								getTarget().add(variable);
								setComplete(true);
								executeHandlers();
								return isComplete();
							}
						}
					}
					if(objectPin.eContainer() instanceof ControlAction){
						setComplete(false);
						/* Don't execute handlers if the rule is not complete */
						return isComplete();
					}
				}
			}
			//if the source is a Variable, check if a Variable was already created (should not as we always create the Variables in the beginning) 
			//if none found create a new variable for the repository. Do not add it to the currentPath, as it will be set as forbidden variable.. 
			//store/retrieve artifacts will be registered in the current path.
		}else if (typedElement instanceof com.ibm.btools.bom.model.processes.activities.Variable){
			com.ibm.btools.bom.model.processes.activities.Variable repository = (com.ibm.btools.bom.model.processes.activities.Variable)typedElement;
			List forbidenVariables = ProcessUtil.getParallelFlowsRegisteredVariables(getContext());
			ArrayList sources = new ArrayList();
			sources.add(repository.getType());
			sources.add(repository);
			rule = TransformationUtil.getRuleForSource(defRule, VariableRule.class, sources, BPELVariable.class);
			if(rule != null && !rule.getTarget().isEmpty()){
				getTarget().add((BPELVariable)rule.getTarget().get(0));
				setComplete(true);
				executeHandlers();
				return isComplete();
			}else{
				variable = createNewVariable(repository, repository.getType(), false);
				getTarget().add(variable);
				setComplete(true);
				executeHandlers();
				return isComplete();
				
			}
		}
		if(typedElement instanceof OutputObjectPin){
			OutputObjectPin objectPin = (OutputObjectPin)typedElement;
			variableFound = findVariableForOutputObjectPin(objectPin);
			if (variableFound){
				return isComplete();
			}
		}
		XSDTypeDefinition variableType = null;
		TransformationRule definitionRule = null;
		if(!DataDefinitionUtil.isMultipled(typedElement)){
			definitionRule = TransformationUtil.getRuleForSource(getRoot(), ClassRule.class, srcObj, XSDTypeDefinition.class);
		}else{
			definitionRule = TransformationUtil.getRuleForSource(getRoot(), ListRule.class, typedElement, XSDTypeDefinition.class);
		}
		if(definitionRule != null && !definitionRule.getTarget().isEmpty()){
			variableType = (XSDTypeDefinition)definitionRule.getTarget().get(0);
		}else{
			variableType = getXSDType((TypedElement)typedElement);
		}
		variable = createNewVariable(typedElement, srcObj, true);
		getTarget().add(variable);
		setComplete(true);
		executeHandlers();

		LoggingUtil.traceExit(this, "transformSource2Target");
		return isComplete();
		

	}
	/**
	 * Checks if the Repository is compatible with the ArtifactPin. They are compatible is they have the same
	 * multiplicity. Reuse the Repository Variable if they are compatibles, else return false to create a new Variable. 
	 * @param objectPin
	 * @return
	 */
	private boolean findVariableForRetrieveArtifactPin(RetrieveArtifactPin objectPin){
		TransformationRule defRule = ProcessUtil.getProcessDefinitionRule(getContext());
		BPELVariable variable;
		if(objectPin.getRepository() != null){
			Repository repository = (Repository)objectPin.getRepository();
			//added check for compatible variables.
			if(BomHelper.getInstance().sameMultiplicity(repository, objectPin)){
				ArrayList sources = new ArrayList();
				sources.add(repository.getType());
				sources.add(repository);
				TransformationRule rule = TransformationUtil.getRuleForSource(defRule, VariableRule.class, sources, BPELVariable.class);
				//the rule has to be created already as it is processed at the begining of the transformation 
				if(rule != null && !rule.getTarget().isEmpty()){
					variable = (BPELVariable)rule.getTarget().get(0);
					//get all the objectPins in the same PinSet as the ObjectPin and find out if there is a RetrrieveArtifactPin connected to the Variable. 
					//if it is, find this rule, incompatible
					List pins = BomUtils.getObjectPinsForSet(BomUtils.findPinSetForPin(objectPin));
					if(pins.size() >1){
						Iterator it2 = pins.iterator();
						while(it2.hasNext()){
						ObjectPin thisPin = (ObjectPin)it2.next();
							if(BomHelper.getInstance().sameMultiplicity(thisPin, objectPin)){
								ArrayList pinSources = new ArrayList();
								pinSources.add(thisPin.getType());
								pinSources.add(thisPin);
								TransformationRule objectPinRule = TransformationUtil.getRuleForSource(defRule, VariableRule.class, pinSources, BPELVariable.class);
								//the other pin already used the variable. so create a new one.
								if(objectPinRule != null && objectPinRule.getTarget().get(0).equals(variable)){
									return false;
								}
								
							}
						}
					}
				
					getTarget().add(variable);
					ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), variable);
					setComplete(true);
					executeHandlers();
					return isComplete();
				}
			}
		}
		return false;
	}
	/**
	 * 	For StoreArtifactPin linked to a LocalRepository try to reuse the Repository Variable, else create a new one. 
	 * 	@param objectPin
	 * @return
	 */
	private boolean findVariableForStoreArtifactPin(StoreArtifactPin objectPin){
		Type srcObj=(Type)source.get(0);
		TransformationRule defRule = ProcessUtil.getProcessDefinitionRule(getContext());
		if(objectPin.getRepository() != null){
		//	List forbidenVariables = ProcessUtil.getParallelFlowsRegisteredVariables(getContext());
			Repository repository = (Repository)objectPin.getRepository();
				if(BomUtils.findPinSetForPin(objectPin).eContainer() instanceof Fork){
					BPELVariable thisVariable = getCompatibleVariableForFork((OutputObjectPin)objectPin);
					if(thisVariable != null){
						getTarget().add(thisVariable);
						ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), thisVariable);
						setComplete(true);
						executeHandlers();
						return isComplete();
					}
				else{
					//this means that the inputPin on the Fork has not yet been processed.The only way this can be possible is if this pin 
					//belongs to a parallel flow that has not yet been processed. We should create a new variable for this OutputObjectPin, 
					// and then register this Variable with the InputPin. It will be used at the second pass through the process.
					BPELVariable container = createNewVariable(objectPin, srcObj, true);
					getTarget().add(container);
					registerVariableForFork((OutputObjectPin)objectPin, container);	
					setComplete(true);
					executeHandlers();
					return isComplete();
				}
			}else if(BomHelper.getInstance().sameMultiplicity(repository, objectPin)){
				ArrayList sources = new ArrayList();
				sources.add(repository.getType());
				sources.add(repository);
				TransformationRule rule = TransformationUtil.getRuleForSource(defRule, VariableRule.class, sources, BPELVariable.class);
				//the rule has to be created already as it is processed at the begining of the transformation 
				if(rule != null && !rule.getTarget().isEmpty()){
					BPELVariable variable = (BPELVariable)rule.getTarget().get(0);
					getTarget().add(variable);
					ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), variable);
					setComplete(true);
					executeHandlers();
					return isComplete();
				}
			}
		}
		return false;
	}
	
	
	/**
	 * Returns true if a variable for the <code>objectPin</code> can be found, else return false. 
	 * Checks for compatible variables in the following order: 
	 * - checks if the sources were already processed, if yes returns the target
	 * - in case this OutputObjectPin is part of a Fork, make sure that the same variable is used for all similar OutputPins - result of
	 *	the same InputObjectPin
	 * - checks if this OutputPin is connected to another Pin that was already processed and for which the variable has already been set. 
	 *	this is the case of a SANNestedProcess where the InputPinSet and OutputPinSet are processed first, and the internal of the Process is
	 *	processed later.. We have to make sure that the Pin connecting to the SAN OutputPin share the same variable. 
	 * - in case we are on a SAN, tries to reuse compatible (already created variables).
	 * - try to assign with priority from the inputSet correlated with the set to which this pin belongs to 
	 * - get all the Variables that were created for the Type of the ObjectPin and are compatible with this Pin from the context...
	 *	 Checks forbidenVariables - variables that cannot be assigned due to the fact they are in a different ParallelPath
	 *	also, 2 ObjectPins with the same type in the same PinSet will be assigned 2 different variables
	 *	variables will be assigned with priority from the currentFlowPath
	 * @param objectPin
	 * @return
	 */
	private boolean findVariableForOutputObjectPin(OutputObjectPin objectPin){
		TransformationRule defRule = ProcessUtil.getProcessDefinitionRule(getContext());
		Type srcObj=(Type)source.get(0);
		BPELVariable variable; 
		TransformationRule rule = null;
		forbiddenVariables = ProcessUtil.getParallelFlowsRegisteredVariables(getContext());
		//	1. checks if a Variable was already created for this Pin, if found, it will return it
		ArrayList sources = new ArrayList();
		sources.add(objectPin.getType());
		sources.add(objectPin);
		rule = TransformationUtil.getRuleForSource(defRule, VariableRule.class, sources, BPELVariable.class);
		if(rule != null && !rule.getTarget().isEmpty()){
			getTarget().add((BPELVariable)rule.getTarget().get(0));
			setComplete(true);
			executeHandlers();
			return isComplete();
		}
		//in case this OutputObjectPin is part of a Fork, make sure that the same variable is used for all similar OutputPins - result of
		//the same InputObjectPin
		if(BomUtils.findPinSetForPin(objectPin).eContainer() instanceof Fork){
			BPELVariable thisVariable = getCompatibleVariableForFork((OutputObjectPin)objectPin);
			if(thisVariable != null){
				getTarget().add(thisVariable);
				ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), thisVariable);
				setComplete(true);
				executeHandlers();
				return isComplete();
			}
			else{
				//this means that the inputPin on the Fork has not yet been processed.The only way this can be possible is if this pin 
				//belongs to a parallel flow that has not yet been processed. We should create a new variable for this OutputObjectPin, 
				// and then register this Variable with the InputPin. It will be used at the second pass through the process.
				BPELVariable container = createNewVariable(objectPin, srcObj, true);
				
				getTarget().add(container);
				registerVariableForFork((OutputObjectPin)objectPin, container);	
				setComplete(true);
				executeHandlers();
				return isComplete();
			}
		}
		//defect 119513
		//in case this OutputObjectPin is part of a Decision, make sure that the same variable is used for all similar OutputPins - result of
		//the same InputObjectPin
		if(BomUtils.findPinSetForPin(objectPin).eContainer() instanceof Decision){
			BPELVariable thisVariable = getCompatibleVariableForDecision((OutputObjectPin)objectPin);
			if(thisVariable != null){
				getTarget().add(thisVariable);
				ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), thisVariable);
				setComplete(true);
				executeHandlers();
				return isComplete();
			}
			else{
				//this means that the inputPin on the Decision has not yet been processed.The only way this can be possible is if this pin 
				//belongs to a parallel flow that has not yet been processed. We should create a new variable for this OutputObjectPin, 
				// and then register this Variable with the InputPin. It will be used at the second pass through the process.
				BPELVariable container = createNewVariable(objectPin, srcObj, true);
				getTarget().add(container);
				registerVariableForDecision((OutputObjectPin)objectPin, container);	
				setComplete(true);
				executeHandlers();
				return isComplete();
			}
		}
		
		//check if this OutputPin is connected to another Pin that was already processed and for which the variable has already been set.. 
		//this is the case of a SANNestedProcess where the InputPinSet and OutputPinSet are processed first, and the internal of the Process is
		// processed later.. We have to make sure that the Pin connecting to the SAN OutputPin share the same variable. 
		if(objectPin.getOutgoing() != null && ((OutputObjectPin)objectPin).getOutgoing().getTarget() instanceof ObjectPin){
			ObjectPin targetPin = (ObjectPin)((OutputObjectPin)objectPin).getOutgoing().getTarget();
			ArrayList targetSources = new ArrayList();
			targetSources.add(targetPin.getType());
			targetSources.add(targetPin);
			//rule = TransformationUtil.getRuleForSource(getRoot(), VariableRule.class, sources, BPELVariable.class);
			rule = TransformationUtil.getRuleForSource(defRule, VariableRule.class, targetSources, BPELVariable.class);
			//if a rule was already created for this Pin, use the variable and add the Pin as source of this rule 
			if(rule != null && !rule.getTarget().isEmpty()){
				variable = (BPELVariable)rule.getTarget().get(0);
				getTarget().add(variable);
				setComplete(true);
				executeHandlers();
				return isComplete();
			}
			//we are on the OutputObjectPin of a SAN
		}else if(objectPin.getIncoming() != null){
			ObjectPin sourcePin = (ObjectPin)((OutputObjectPin)objectPin).getIncoming().getSource();
			ArrayList targetSources = new ArrayList();
			targetSources.add(sourcePin.getType());
			targetSources.add(sourcePin);
			rule = TransformationUtil.getRuleForSource(defRule, VariableRule.class, targetSources, BPELVariable.class);
			//if a rule was already created for this Pin, use the variable and add the Pin as source of this rule 
			if(rule != null && !rule.getTarget().isEmpty()){
				variable = (BPELVariable)rule.getTarget().get(0);
				getTarget().add(variable);
				setComplete(true);
				executeHandlers();
				return isComplete();
			}
		}
		//assign with priority from the correlated InputPinSet
		variable = getCompatibleInputPinVariable(defRule, objectPin);
		if(variable != null){
			getTarget().add(variable);
			setComplete(true);
			executeHandlers();
			return isComplete();
		}
		//get all the Variables that were created for the Type of the ObjectPin and are compatible with this Pin from the context...
		//the check will check for forbidenVariables - variables that cannot be assigned due to the fact they are in a different ParallelPath
		//also, 2 ObjectPins with the same type in the same PinSet will be assigned 2 different variables
		//variables will be assigned with priority from the currentFlowPath
		Collection rules = TransformationUtil.getRulesForSource(defRule, VariableRule.class, objectPin.getType(), BPELVariable.class);
		List compatibleRules = null;
		if(rules != null && !rules.isEmpty()){
			//get the sublist containing the compatible Variables (based on the Pin multiplicity)
			compatibleRules = getCompatibleRulesForPin(rules, objectPin);
		}
		if(compatibleRules != null && !compatibleRules.isEmpty()){
			// 4.checks through the variable found..for a variable that can be in the currentPathList. 
			if(currentPathCompatibleVariablesRules.size()>0){
				for(int i=currentPathCompatibleVariablesRules.size()-1; i>=0; i-- ){
					TransformationRule variableRule = (TransformationRule)currentPathCompatibleVariablesRules.get(i);
					BPELVariable thisVariable = (BPELVariable)variableRule.getTarget().get(0);
					if(!forbiddenVariables.contains(thisVariable)){
						//register the variableRule with this objectPin
						getTarget().add(thisVariable);
						ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), thisVariable);
						setComplete(true);
						executeHandlers();
						return isComplete();
					}
				}
				//none of the rules are in the currentPath, so look oustide
			}else{
				for(int i=compatibleRules.size()-1; i>=0; i-- ){
					TransformationRule variableRule = (TransformationRule)compatibleRules.get(i);
					BPELVariable thisVariable = (BPELVariable)variableRule.getTarget().get(0);
					if(!forbiddenVariables.contains(thisVariable)){	
						//register the variableRule with this objectPin
						getTarget().add(thisVariable);
						ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), thisVariable);
						setComplete(true);
						executeHandlers();
						return isComplete();
					}
				}
			}
		}
		return false;
	}

//	/**
//	 * source = BOM Type and BOM MultiplicityElement (and TypedElement) which can be a Pin, Variable
//	 * target = BPEL Variable
//	 * 
//	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target()
//	 */
//	public boolean transformSource2Target_bak() {
//		LoggingUtil.traceEntry(this, "transformSource2Target");
//
//		if (isComplete()) {
//			LoggingUtil.traceExit(this, "transformSource2Target", "already completed");
//			return true;				
//		}
//		if (getSource() == null || getSource().isEmpty()) {
//			LoggingUtil.traceExit(this, "transformSource2Target", "no sources");
//			return false;
//		}
//			
//		Type srcObj=(Type)source.get(0);
//		MultiplicityElement typedElement = (MultiplicityElement)getSource().get(1);
//		TransformationRule rule = null;
//		BPELVariable variable = null;
//		TransformationRule defRule = ProcessUtil.getProcessDefinitionRule(getContext());
//		//for a RetrieveArtifactPin try to reuse the Repository Variable, else create a new one.
//		// this will work for Datastore, a new variable will be creted each time for it.. 
//		if (typedElement instanceof RetrieveArtifactPin){
//			RetrieveArtifactPin objectPin = (RetrieveArtifactPin)typedElement;
//			if(objectPin.getRepository() != null){
//				Repository repository = (Repository)objectPin.getRepository();
//				//check if the Repository is compatible with the ArtifactPin. They are compatible is they have the same
//				//multiplicity. Reuse the Repository Variable if they are compatibles, else, create a new Variable... 
//				if(BomHelper.getInstance().sameMultiplicity(repository, typedElement)){
//					ArrayList sources = new ArrayList();
//					sources.add(repository.getType());
//					sources.add(repository);
//					rule = TransformationUtil.getRuleForSource(defRule, VariableRule.class, sources, BPELVariable.class);
//					//the rule has to be created already as it is processed at the begining of the transformation 
//					if(rule != null && !rule.getTarget().isEmpty()){
//						variable = (BPELVariable)rule.getTarget().get(0);
//						getTarget().add(variable);
//						ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), variable);
//						setComplete(true);
//						executeHandlers();
//						return isComplete();
//					}
//				}
//			}
//			//for a StoreArtifactPin linked to a LocalRepository try to reuse the Repository Variable, else create a new one. 
//			//if the StoreArtifactPin is linked to a Datastore, treat it as a regular objectPin
//		}else if (typedElement instanceof StoreArtifactPin && ((StoreArtifactPin)typedElement).getRepository() instanceof com.ibm.btools.bom.model.processes.activities.Variable){
//			StoreArtifactPin objectPin = (StoreArtifactPin)typedElement;
//			if(objectPin.getRepository() != null){
//				Repository repository = (Repository)objectPin.getRepository();
////				if(BomHelper.getInstance().sameMultiplicity(repository, typedElement)){
////					ArrayList sources = new ArrayList();
////					sources.add(repository.getType());
////					sources.add(repository);
////					rule = TransformationUtil.getRuleForSource(defRule, VariableRule.class, sources, BPELVariable.class);
////					//the rule has to be created already as it is processed at the begining of the transformation 
////					if(rule != null && !rule.getTarget().isEmpty()){
////						variable = (BPELVariable)rule.getTarget().get(0);
////						getTarget().add(variable);
////						ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), variable);
////						setComplete(true);
////						executeHandlers();
////						return isComplete();
////					}
////				}else 
//					if(BomUtils.findPinSetForPin(objectPin).eContainer() instanceof Fork){
//					BPELVariable thisVariable = getCompatibleVariableForFork((OutputObjectPin)objectPin);
//					if(thisVariable != null){
//						getTarget().add(thisVariable);
//						ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), thisVariable);
//						setComplete(true);
//						executeHandlers();
//						return isComplete();
//					}
//					else{
//						//this means that the inputPin on the Fork has not yet been processed.The only way this can be possible is if this pin 
//						//belongs to a parallel flow that has not yet been processed. We should create a new variable for this OutputObjectPin, 
//						// and then register this Variable with the InputPin. It will be used at the second pass through the process.
//						BPELVariable container = createNewVariable(typedElement, srcObj);
//						getTarget().add(container);
//						registerVariableForFork((OutputObjectPin)objectPin, container);	
//						setComplete(true);
//						executeHandlers();
//						return isComplete();
//					}
//				}else if(BomHelper.getInstance().sameMultiplicity(repository, typedElement)){
//					ArrayList sources = new ArrayList();
//					sources.add(repository.getType());
//					sources.add(repository);
//					rule = TransformationUtil.getRuleForSource(defRule, VariableRule.class, sources, BPELVariable.class);
//					//the rule has to be created already as it is processed at the begining of the transformation 
//					if(rule != null && !rule.getTarget().isEmpty()){
//						variable = (BPELVariable)rule.getTarget().get(0);
//						getTarget().add(variable);
//						ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), variable);
//						setComplete(true);
//						executeHandlers();
//						return isComplete();
//					}
//				}
//			}
//		}else if(typedElement instanceof InputObjectPin && ! (typedElement instanceof RetrieveArtifactPin || typedElement instanceof InputValuePin)){
//			ObjectPin objectPin = (ObjectPin)typedElement;
//			if(objectPin.getIncoming() != null){
//				ObjectPin sourcePin = (ObjectPin)((InputObjectPin)objectPin).getIncoming().getSource();
//				ArrayList sources = new ArrayList();
//				sources.add(sourcePin.getType());
//				sources.add(sourcePin);
//				rule = TransformationUtil.getRuleForSource(defRule, VariableRule.class, sources, BPELVariable.class);
//				//if a rule was already created for this Pin, use the variable and add the Pin as source of this rule 
//				if(rule != null && !rule.getTarget().isEmpty()){
//					variable = (BPELVariable)rule.getTarget().get(0);
//					getTarget().add(variable);
//					ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), variable);
//					setComplete(true);
//					executeHandlers();
//					return isComplete();
//				}else{
//					//do not create a new variable, should always use the outputSet variable.. in case it is not yet there, 
//					//it will be added on reexecute
//					setComplete(false);
//					/* Don't execute handlres if the rule is not complete */
//					return isComplete();
//				}
//			}else{
//				//there is no incoming for this InputObjectPin, we must be on the SAN or we must be processing an InputValuePin
//				ArrayList sources = new ArrayList();
//				sources.add(objectPin.getType());
//				sources.add(objectPin);
//				Collection rules = TransformationUtil.getRulesForSource(defRule, VariableRule.class, objectPin.getType(), BPELVariable.class);
//				//Collection rules = TransformationUtil.getRulesForSource(defRule, VariableRule.class, sources, BPELVariable.class);
//				//if a rule was already created for this Pin, use the variable and add the Pin as source of this rule 
//				if(rules != null && !rules.isEmpty()){
//					Iterator it = rules.iterator();
//					while(it.hasNext()){
//						VariableRule thisVariableRule = (VariableRule)it.next();
//						MultiplicityElement thisSource = (MultiplicityElement)thisVariableRule.getSource().get(1);
//						if(BomHelper.getInstance().sameMultiplicity(objectPin, thisSource)){
//							//if the 2 pins are in the same pinSet, create a different variable
//							//if(thisSource instanceof com.ibm.btools.bom.model.processes.activities.Variable || !BomUtils.findPinSetForPin((Pin)thisSource).equals(BomUtils.findPinSetForPin(objectPin))){
//							//the only variable an InputObjectPin on a SAN can reuse is a Variable created from a Repository Variable, it should not reuse another
//							//variable ie a Variable from anothe PinSet or from its own PinSet.
//							if(thisSource instanceof com.ibm.btools.bom.model.processes.activities.Variable){
//								variable = (BPELVariable)thisVariableRule.getTarget().get(0);
//								getTarget().add(variable);
//								setComplete(true);
//								executeHandlers();
//								return isComplete();
//							}
//						}
//					}
//					if(objectPin.eContainer() instanceof ControlAction){
//						setComplete(false);
//						/* Don't execute handlers if the rule is not complete */
//						return isComplete();
//					}
//				}
//			}
//		}else if(typedElement instanceof OutputObjectPin){
//			ObjectPin objectPin = (ObjectPin)typedElement;
//			List forbidenVariables = ProcessUtil.getParallelFlowsRegisteredVariables(getContext());
//			//	1. checks if a Variable was already created for this Pin, if found, it will return it
//			ArrayList sources = new ArrayList();
//			sources.add(objectPin.getType());
//			sources.add(objectPin);
//			rule = TransformationUtil.getRuleForSource(defRule, VariableRule.class, sources, BPELVariable.class);
//			if(rule != null && !rule.getTarget().isEmpty()){
//				getTarget().add((BPELVariable)rule.getTarget().get(0));
//				setComplete(true);
//				executeHandlers();
//				return isComplete();
//			}
//			//in case this OutputObjectPin is part of a Fork, make sure that the same variable is used for all similar OutputPins - result of
//			//the same InputObjectPin
//			if(BomUtils.findPinSetForPin(objectPin).eContainer() instanceof Fork){
//				BPELVariable thisVariable = getCompatibleVariableForFork((OutputObjectPin)objectPin);
//				if(thisVariable != null){
//					getTarget().add(thisVariable);
//					ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), thisVariable);
//					setComplete(true);
//					executeHandlers();
//					return isComplete();
//				}
//				else{
//					//this means that the inputPin on the Fork has not yet been processed.The only way this can be possible is if this pin 
//					//belongs to a parallel flow that has not yet been processed. We should create a new variable for this OutputObjectPin, 
//					// and then register this Variable with the InputPin. It will be used at the second pass through the process.
//					BPELVariable container = createNewVariable(typedElement, srcObj);
//					getTarget().add(container);
//					registerVariableForFork((OutputObjectPin)objectPin, container);	
//					setComplete(true);
//					executeHandlers();
//					return isComplete();
//				}
//			}
//			//check if this OutputPin is connected to another Pin that was already processed and for which the variable has already been set.. 
//			//this is the case of a SANNestedProcess where the InputPinSet and OutputPinSet are processed first, and the internal of the Process is
//			// processed later.. We have to make sure that the Pin connecting to the SAN OutputPin share the same variable. 
//			if(objectPin.getOutgoing() != null && ((OutputObjectPin)objectPin).getOutgoing().getTarget() instanceof ObjectPin){
//				ObjectPin targetPin = (ObjectPin)((OutputObjectPin)objectPin).getOutgoing().getTarget();
//				ArrayList targetSources = new ArrayList();
//				targetSources.add(targetPin.getType());
//				targetSources.add(targetPin);
//				//rule = TransformationUtil.getRuleForSource(getRoot(), VariableRule.class, sources, BPELVariable.class);
//				rule = TransformationUtil.getRuleForSource(defRule, VariableRule.class, targetSources, BPELVariable.class);
//				//if a rule was already created for this Pin, use the variable and add the Pin as source of this rule 
//				if(rule != null && !rule.getTarget().isEmpty()){
//					variable = (BPELVariable)rule.getTarget().get(0);
//					getTarget().add(variable);
//					setComplete(true);
//					executeHandlers();
//					return isComplete();
//				}
//				//we are on the OutputObjectPin of a SAN
//			}else if(objectPin.getIncoming() != null){
//				ObjectPin sourcePin = (ObjectPin)((OutputObjectPin)objectPin).getIncoming().getSource();
//				ArrayList targetSources = new ArrayList();
//				targetSources.add(sourcePin.getType());
//				targetSources.add(sourcePin);
//				//rule = TransformationUtil.getRuleForSource(getRoot(), VariableRule.class, sources, BPELVariable.class);
//				rule = TransformationUtil.getRuleForSource(defRule, VariableRule.class, targetSources, BPELVariable.class);
//				//if a rule was already created for this Pin, use the variable and add the Pin as source of this rule 
//				if(rule != null && !rule.getTarget().isEmpty()){
//					variable = (BPELVariable)rule.getTarget().get(0);
//					getTarget().add(variable);
//					setComplete(true);
//					executeHandlers();
//					return isComplete();
//				}
//			}
//			//assign with priority from the correlated InputPinSet
//			variable = getCompatibleInputPinVariable(defRule, objectPin, forbidenVariables);
//			if(variable != null){
//				getTarget().add(variable);
//				setComplete(true);
//				executeHandlers();
//				return isComplete();
//			}
//			//get all the Variables that were created for the Type of the ObjectPin and are compatible with this Pin from the context...
//			//the check will check for forbidenVariables - variables that cannot be assigned due to the fact they are in a different ParallelPath
//			//also, 2 ObjectPins with the same type in the same PinSet will be assigned 2 different variables
//			//variables will be assigned with priority from the currentFlowPath
//			Collection rules = TransformationUtil.getRulesForSource(defRule, VariableRule.class, objectPin.getType(), BPELVariable.class);
//			List compatibleRules = null;
//			if(rules != null && !rules.isEmpty()){
//				//get the sublist containing the compatible Variables (based on the Pin multiplicity)
//				compatibleRules = getCompatibleRulesForPin(rules, objectPin);
//			}
//			if(compatibleRules != null && !compatibleRules.isEmpty()){
//				// 4.checks through the variable found..for a variable that can be in the currentPathList. 
//				if(currentPathCompatibleVariablesRules.size()>0){
//					for(int i=currentPathCompatibleVariablesRules.size()-1; i>=0; i-- ){
//						TransformationRule variableRule = (TransformationRule)currentPathCompatibleVariablesRules.get(i);
//						BPELVariable thisVariable = (BPELVariable)variableRule.getTarget().get(0);
//						if(!forbidenVariables.contains(thisVariable)){
//							//register the variableRule with this objectPin
//							getTarget().add(thisVariable);
//							ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), thisVariable);
//							setComplete(true);
//							executeHandlers();
//							return isComplete();
//						}
//					}
//					//none of the rules are in the currentPath, so look oustide
//				}else{
//					for(int i=compatibleRules.size()-1; i>=0; i-- ){
//						TransformationRule variableRule = (TransformationRule)compatibleRules.get(i);
//						BPELVariable thisVariable = (BPELVariable)variableRule.getTarget().get(0);
//						//if(!forbidenVariables.contains(thisVariable)){
//						if(!isInVariableList(forbidenVariables, thisVariable)){
//							//register the variableRule with this objectPin
//							getTarget().add(thisVariable);
//							ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), thisVariable);
//							setComplete(true);
//							executeHandlers();
//							return isComplete();
//						}
//					}
//				}
//			}
//		}
////		else if (typedElement instanceof com.ibm.btools.bom.model.processes.activities.Variable){
////			com.ibm.btools.bom.model.processes.activities.Variable repository = (com.ibm.btools.bom.model.processes.activities.Variable)typedElement;
////			List forbidenVariables = ProcessUtil.getParallelFlowsRegisteredVariables(getContext());
////			//	1. checks if a Variable was already created for this Pin, if found, it will return it
////			ArrayList sources = new ArrayList();
////			sources.add(repository.getType());
////			sources.add(repository);
////			rule = TransformationUtil.getRuleForSource(defRule, VariableRule.class, sources, BPELVariable.class);
////			if(rule != null && !rule.getTarget().isEmpty()){
////				getTarget().add((BPELVariable)rule.getTarget().get(0));
////				setComplete(true);
////				executeHandlers();
////				return isComplete();
////			}
////			Collection rules = TransformationUtil.getRulesForSource(defRule, VariableRule.class, repository.getType(), BPELVariable.class);
////			List compatibleRules = null;
////			if(rules != null && !rules.isEmpty()){
////				//get the sublist containing the compatible Variables (based on the Pin multiplicity)
////				compatibleRules = getCompatibleRulesForPin(rules, repository);
////			}
////			if(compatibleRules != null && !compatibleRules.isEmpty()){
////				// 4.checks through the variable found..for a variable that can be in the currentPathList. 
////				if(currentPathCompatibleVariablesRules.size()>0){
////					for(int i=currentPathCompatibleVariablesRules.size()-1; i>=0; i-- ){
////						TransformationRule variableRule = (TransformationRule)currentPathCompatibleVariablesRules.get(i);
////						BPELVariable thisVariable = (BPELVariable)variableRule.getTarget().get(0);
////						if(!forbidenVariables.contains(thisVariable)){
////							//register the variableRule with this objectPin
////							getTarget().add(thisVariable);
////							ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), thisVariable);
////							setComplete(true);
////							executeHandlers();
////							return isComplete();
////						}
////					}
////				}
////			}
////
////
////		}
//		
//		
//		XSDTypeDefinition variableType = null;
//		TransformationRule definitionRule = null;
//		if(!DataDefinitionUtil.isMultipled(typedElement)){
//			definitionRule = TransformationUtil.getRuleForSource(getRoot(), ClassRule.class, srcObj, XSDTypeDefinition.class);
//		}else{
//			definitionRule = TransformationUtil.getRuleForSource(getRoot(), ListRule.class, typedElement, XSDTypeDefinition.class);
//		}
//		if(definitionRule != null && !definitionRule.getTarget().isEmpty()){
//			variableType = (XSDTypeDefinition)definitionRule.getTarget().get(0);
//		}else{
//			variableType = getXSDType((TypedElement)typedElement);
//		}
//		variable = createNewVariable(typedElement, srcObj);
///*		
//		BPELVariable container = BPELFactory.eINSTANCE.createBPELVariable();
//		container.setType(variableType);
//		//pass the name through the registry... 
//		String convertedName = null;
//		//the Variable name for the LocalRepository is the only one that constitutes a TechnicalAttribute, else, get the name directly from the converter
//		if(typedElement instanceof com.ibm.btools.bom.model.processes.activities.Variable){
//			com.ibm.btools.bom.model.processes.activities.Variable repository = (com.ibm.btools.bom.model.processes.activities.Variable)typedElement;
//			AttributeValueProvider valueProvider = AttributeValueProviderFactory.createAttributeValueProvider(AttributeNameConstants.BPEL_VARIABLE_NAME_VARIABLE);
//			valueProvider.setContext(this.getContext());
//			convertedName = (String)valueProvider.getAttributeValueForType(container, repository, AttributeNameConstants.BPEL_VARIABLE_NAME_VARIABLE, NamingUtil.findRegistry(this));
//		}else{
//			 JavaNCNameConverter converter = new JavaNCNameConverter();
//			 convertedName = converter.convertName(NamingUtil.findRegistry(this), container, variableType.getName() + "Variable");
//		}
//
//		container.setName(convertedName);
//		ProcessUtil.registerVariableForParallelFlowCurrentPath(getContext(), container);
//		organizeImports(container);
//	*/	
//		getTarget().add(variable);
//		setComplete(true);
//		executeHandlers();
//
//		LoggingUtil.traceExit(this, "transformSource2Target");
//		return isComplete();
//	}
} //VariableRuleImpl
