/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.bpel.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.wst.wsdl.ExtensibleElement;

import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.framework.impl.TransformationRuleImpl;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.bpel.BpelFactory;
import com.ibm.btools.te.ilm.heuristics.bpel.BpelPackage;
import com.ibm.btools.te.ilm.heuristics.bpel.BpelRule;
import com.ibm.btools.te.ilm.heuristics.bpel.XPathExprSerializerRule;
import com.ibm.btools.te.ilm.model.abstractbpel.Alternative;
import com.ibm.btools.te.ilm.model.abstractbpel.AlternativeActivity;
import com.ibm.btools.te.ilm.model.abstractbpel.ExtensibilityExpression;
import com.ibm.btools.te.ilm.model.abstractbpel.JoinExtensibilityExpression;
import com.ibm.btools.te.ilm.model.sa.ProcessFlowType;
import com.ibm.wbit.bpel.Activity;
import com.ibm.wbit.bpel.BPELFactory;
import com.ibm.wbit.bpel.BPELVariable;
import com.ibm.wbit.bpel.BooleanExpression;
import com.ibm.wbit.bpel.Case;
import com.ibm.wbit.bpel.Expression;
import com.ibm.wbit.bpel.From;
import com.ibm.wbit.bpel.Invoke;
import com.ibm.wbit.bpel.Process;
import com.ibm.wbit.bpel.Query;
import com.ibm.wbit.bpel.Receive;
import com.ibm.wbit.bpel.Source;
import com.ibm.wbit.bpel.To;
import com.ibm.wbit.bpel.Variables;
import com.ibm.wbit.bpel.While;
import com.ibm.wbit.bpelpp.DisplayName;
import com.ibm.wbit.bpelpp.PotentialOwner;
import com.ibm.wbit.bpelpp.Staff;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class BpelRuleImpl extends TransformationRuleImpl implements BpelRule {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BpelRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return BpelPackage.eINSTANCE.getBpelRule();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case BpelPackage.BPEL_RULE__CHILD_RULES:
					return ((InternalEList)getChildRules()).basicAdd(otherEnd, msgs);
				case BpelPackage.BPEL_RULE__PARENT_RULE:
					if (eContainer != null)
						msgs = eBasicRemoveFromContainer(msgs);
					return eBasicSetContainer(otherEnd, BpelPackage.BPEL_RULE__PARENT_RULE, msgs);
				case BpelPackage.BPEL_RULE__ROOT:
					if (root != null)
						msgs = ((InternalEObject)root).eInverseRemove(this, FrameworkPackage.TRANSFORMATION_ROOT__RULES, TransformationRoot.class, msgs);
					return basicSetRoot((TransformationRoot)otherEnd, msgs);
				default:
					return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case BpelPackage.BPEL_RULE__CHILD_RULES:
					return ((InternalEList)getChildRules()).basicRemove(otherEnd, msgs);
				case BpelPackage.BPEL_RULE__PARENT_RULE:
					return eBasicSetContainer(null, BpelPackage.BPEL_RULE__PARENT_RULE, msgs);
				case BpelPackage.BPEL_RULE__ROOT:
					return basicSetRoot(null, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
				case BpelPackage.BPEL_RULE__PARENT_RULE:
					return ((InternalEObject)eContainer).eInverseRemove(this, FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES, TransformationRule.class, msgs);
				default:
					return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return ((InternalEObject)eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case BpelPackage.BPEL_RULE__COMPLETE:
				return isComplete() ? Boolean.TRUE : Boolean.FALSE;
			case BpelPackage.BPEL_RULE__FAILED:
				return isFailed() ? Boolean.TRUE : Boolean.FALSE;
			case BpelPackage.BPEL_RULE__CHILD_RULES:
				return getChildRules();
			case BpelPackage.BPEL_RULE__PARENT_RULE:
				return getParentRule();
			case BpelPackage.BPEL_RULE__TARGET:
				return getTarget();
			case BpelPackage.BPEL_RULE__SOURCE:
				return getSource();
			case BpelPackage.BPEL_RULE__ROOT:
				if (resolve) return getRoot();
				return basicGetRoot();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case BpelPackage.BPEL_RULE__COMPLETE:
				setComplete(((Boolean)newValue).booleanValue());
				return;
			case BpelPackage.BPEL_RULE__FAILED:
				setFailed(((Boolean)newValue).booleanValue());
				return;
			case BpelPackage.BPEL_RULE__CHILD_RULES:
				getChildRules().clear();
				getChildRules().addAll((Collection)newValue);
				return;
			case BpelPackage.BPEL_RULE__PARENT_RULE:
				setParentRule((TransformationRule)newValue);
				return;
			case BpelPackage.BPEL_RULE__TARGET:
				getTarget().clear();
				getTarget().addAll((Collection)newValue);
				return;
			case BpelPackage.BPEL_RULE__SOURCE:
				getSource().clear();
				getSource().addAll((Collection)newValue);
				return;
			case BpelPackage.BPEL_RULE__ROOT:
				setRoot((TransformationRoot)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case BpelPackage.BPEL_RULE__COMPLETE:
				setComplete(COMPLETE_EDEFAULT);
				return;
			case BpelPackage.BPEL_RULE__FAILED:
				setFailed(FAILED_EDEFAULT);
				return;
			case BpelPackage.BPEL_RULE__CHILD_RULES:
				getChildRules().clear();
				return;
			case BpelPackage.BPEL_RULE__PARENT_RULE:
				setParentRule((TransformationRule)null);
				return;
			case BpelPackage.BPEL_RULE__TARGET:
				getTarget().clear();
				return;
			case BpelPackage.BPEL_RULE__SOURCE:
				getSource().clear();
				return;
			case BpelPackage.BPEL_RULE__ROOT:
				setRoot((TransformationRoot)null);
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case BpelPackage.BPEL_RULE__COMPLETE:
				return complete != COMPLETE_EDEFAULT;
			case BpelPackage.BPEL_RULE__FAILED:
				return failed != FAILED_EDEFAULT;
			case BpelPackage.BPEL_RULE__CHILD_RULES:
				return childRules != null && !childRules.isEmpty();
			case BpelPackage.BPEL_RULE__PARENT_RULE:
				return getParentRule() != null;
			case BpelPackage.BPEL_RULE__TARGET:
				return target != null && !target.isEmpty();
			case BpelPackage.BPEL_RULE__SOURCE:
				return source != null && !source.isEmpty();
			case BpelPackage.BPEL_RULE__ROOT:
				return root != null;
		}
		return eDynamicIsSet(eFeature);
	}

	/* 
	 * Transforms an Abstract BPEL process flow into a BPEL process flow
	 * SOURCE: AbstractBPEL <process> activity
	 * TARGET: BPEL <process> activity with all children conforming to the BPEL Specification
	 */
	public boolean transformSource2Target() {
		LoggingUtil.traceEntry(this, "transformSource2Target");

		if (getSource().isEmpty() || !(getSource().get(0) instanceof Process)){
			LoggingUtil.traceExit(this, "transformSource2Target","no source");			
			return false;
		}
		
		/* Iterate through the containership hierarchy and delegate the transformation 
		 * of a particular item to the appropriate method */
		Process process = (Process)getSource().get(0);
	
		transformProcess(process);
		
		/* Transform the process recursively, starting from root activity */ 	
		transformActivity(process.getActivity());
		
		
						
		getTarget().add(process);
		
		setComplete(true);
		LoggingUtil.traceExit(this, "transformSource2Target");
		return isComplete();
	}
	
	/**
	 * Iterates throught the objects in the BPEL process and delegates to other methods 
	 * to perform the appropriate transformations to those objects.
	 * @param bpelObject The EObject to recursively transform along with its contained elements.
	 */
	private void transformActivity(EObject bpelObject){
		
		/* Recursive base case */
		if (bpelObject == null){
			return;
		}
	
		EObject content;
		for (int i=0; i<bpelObject.eContents().size(); i++){
			content = (EObject)bpelObject.eContents().get(i);
			
			/* Recursively transform this object's children */
			transformActivity(content);
			
			/* Actually transform the object to the pure BPEL version */
			performChildRules(content);
		}
	}
	
	/**
	 * Removes ExtensibilityElements from the Process and Variable, since there are no such 
	 * elements in the BPEL spec
	 * @param process
	 */
	private void transformProcess(Process process){
		
		EList extensibilityElements = process.getEExtensibilityElements();
		if(extensibilityElements != null && !extensibilityElements.isEmpty()){
			process.getEExtensibilityElements().removeAll(process.getEExtensibilityElements());
		}
		//TODO AR Oct 20 
		Variables variables = process.getVariables();
		if(variables != null && variables.getChildren()!= null && !variables.getChildren().isEmpty()){
			for(int i=0; i<variables.getChildren().size(); i++){
				BPELVariable variable = (BPELVariable)variables.getChildren().get(i);
				if(variable.getEExtensibilityElements() != null){
					variable.getEExtensibilityElements().removeAll(variable.getEExtensibilityElements());
				}
			}
		}
	}
	
	
	/**
	 * Performs the transformations on the given EObject that are required to adhere to the BPEL spec.
	 * @param absBpelObject
	 */
	private void performChildRules(EObject absBpelObject){
		List childRules = new ArrayList();

		if (containsExpression(absBpelObject)){
			transformExpression((ExtensibleElement)absBpelObject);
		}
				
		/* We must do this AlternativeActivity transformation *after* the expression transformation, otherwise, we may
		 * miss the opportunity to transform the expressions that are contained by this AlternativeActivity because they
		 * will be transferred to the chosen alternative, which may have already been searched for expressions.  By
		 * doing it after, we are ensuring that the post-transformation version of the expression will be moved to
		 * the chosen alternative.
		 */		
		if (absBpelObject instanceof AlternativeActivity){
			transformAlternativeActivity((AlternativeActivity)absBpelObject);
		}
		
		if (absBpelObject instanceof Receive || absBpelObject instanceof Invoke){
			removeStaffAssignment((Activity)absBpelObject);
			// Ray: Dec 15/03
			if (absBpelObject instanceof Invoke) {
				removeDisplayName((Invoke)absBpelObject);
			}
		}
		if(absBpelObject instanceof EList && ((EList)absBpelObject).get(0) instanceof BPELVariable){
			removeDisplayName((BPELVariable)absBpelObject);
		}
	}

	/**
	 * Returns true if the given EObject contains an ExtensibilityExpression, and false otherwise
	 * @param absBpelObject The EObject to examine for ExtensibilityExpressions
	 * @return Boolean - True if an ExtensibilityExpression is found, false otherwise.
	 */
	private boolean containsExpression(EObject absBpelObject){
		/* Only ExtensibleElements can contain expressions */
		if (absBpelObject instanceof ExtensibleElement){
			for (Iterator it = ((ExtensibleElement)absBpelObject).getEExtensibilityElements().iterator(); it.hasNext(); ){
				if (it.next() instanceof ExtensibilityExpression){
					return true;
				}
			}
		}
				
		return false;
	}
	
	/**
	 * Examines the given ExtensibleElement for ExtensibilityExpressions, and converts any expressions
	 * that are found into XPath using the XPathExprSerializerRule.  The serialized expressions
	 * are then assigned to the proper place based on the ExtensibleElement they were taken from.
	 * 
	 * @param extElement The ExtensibleElement in which to look for expressions to convert.
	 */
	private void transformExpression(ExtensibleElement extElement){
		Object element = null;
		ArrayList toBeRemovedExtElements=null;
		for (Iterator it = extElement.getEExtensibilityElements().iterator(); it.hasNext(); ){
			element = it.next();
			if (element instanceof ExtensibilityExpression){
				
				XPathExprSerializerRule xPathSerializerRule = BpelFactory.eINSTANCE.createXPathExprSerializerRule();
				xPathSerializerRule.getSource().add(((ExtensibilityExpression)element).getExpression());
				getChildRules().add(xPathSerializerRule);
				xPathSerializerRule.transformSource2Target();
				//migration
				String exprString = (String)((Expression)xPathSerializerRule.getTarget().get(0)).getBody();
				
				/* Of the following cases, only one can be true at a time */
				if (extElement instanceof To){
					//migration AR 11.10
					To to = (To)extElement;
					//TODO migration ??? 
					to.setQueryAttribute(exprString);
					Query query = to.getQuery();
					if(query == null){
						query = BPELFactory.eINSTANCE.createQuery();
					}
					query.setQueryLanguage("");
					query.setValue(exprString);
					//((To)extElement).setQuery(exprString);

				} else if (extElement instanceof Case){
					BooleanExpression boolExpr = BPELFactory.eINSTANCE.createBooleanExpression();
					boolExpr.setBody(exprString);
					//((Case)extElement).setCondition(boolExpr);
					((Case)extElement).setConditionAttribute(boolExpr);

				} else if (extElement instanceof While && !(element instanceof JoinExtensibilityExpression)){
					BooleanExpression boolExpr = BPELFactory.eINSTANCE.createBooleanExpression();
					boolExpr.setBody(exprString);
					//((While)extElement).setCondition(boolExpr);
					((While)extElement).setConditionAttribute(boolExpr);

				} else if (extElement instanceof From){
					//((From)extElement).setExpression(exprString);
					((From)extElement).setExpressionAttribute(exprString);

				} else if (extElement instanceof Source){
					BooleanExpression boolExpr = BPELFactory.eINSTANCE.createBooleanExpression();
					boolExpr.setBody(exprString);
					//((Source)extElement).setTransitionCondition(boolExpr);
					((Source)extElement).setTransitionConditionAttribute(boolExpr);

				} else if (extElement instanceof Activity && element instanceof JoinExtensibilityExpression){
					BooleanExpression boolExpr = BPELFactory.eINSTANCE.createBooleanExpression();
					boolExpr.setBody(exprString);
					((Activity)extElement).setJoinCondition(boolExpr);
				}
				/* Ray: Need to clean up extensibility element otherwise BPEL Resource
				 * Writer will try to serialize it and it will fail
				 */ 
				if (toBeRemovedExtElements==null) {
					toBeRemovedExtElements = new ArrayList();
				}
				toBeRemovedExtElements.add(element);
			}
		}
		if (toBeRemovedExtElements!=null) {
			extElement.getEExtensibilityElements().removeAll(toBeRemovedExtElements);
		}
	}
		
	
	/**
	 * Replaces a given AlternativeActivity with the BPEL-specific Alternative
	 * 
	 * @param altActivity The AlternativeActivity to replace with the contained BPEL alternative
	 */
	private void transformAlternativeActivity(AlternativeActivity altActivity){
		Alternative alt = null;

		for (int i=0; i<altActivity.getAlternative().size(); i++){
			alt = (Alternative)altActivity.getAlternative().get(i);

			if (alt.getType().equals(ProcessFlowType.BPEL_LITERAL)){

				/* Find the position of altActivity in its container, remove it, and put
				 * the BPEL alternative in the same spot */
				Activity bpelActivity = alt.getActivity();

				if (altActivity.eContainer().eGet(altActivity.eContainmentFeature()) instanceof List){
					List activityList = (List)altActivity.eContainer().eGet(altActivity.eContainmentFeature());
					int index = activityList.indexOf(altActivity);
					activityList.add(index, bpelActivity);
					/* The altActivity has shifted up one in the list -- remove it from its new position */
					activityList.remove(index + 1);
				} else {
					/* If the container isn't a list, just set the new containment value directly */
					altActivity.eContainer().eSet(altActivity.eContainmentFeature(), bpelActivity);
				}

				/* Copy the generic activity attributes to the actual activity */
				bpelActivity.setName(altActivity.getName());
				bpelActivity.setJoinCondition(altActivity.getJoinCondition());
				bpelActivity.getEExtensibilityElements().addAll(altActivity.getEExtensibilityElements());
				//migration AR 11.09
//				bpelActivity.getSources().addAll(altActivity.getSources());
//				bpelActivity.getTargets().addAll(altActivity.getTargets());
				bpelActivity.getSources().getChildren().addAll(altActivity.getSources().getChildren());
				bpelActivity.getTargets().getChildren().addAll(altActivity.getTargets().getChildren());
				
				return;
			}
		}
	}
	
	/** 
	 * Searches for a Staff Activity on a BPEL Invoke or Receive, and removes it if it
	 * is found, since Staff activities don't apply to BPEL processes.
	 * 
	 * @param bpelActivity The Invoke or Receive on which to look for and remove Staff activities.
	 */
	private void removeStaffAssignment(Activity bpelActivity){
		for (int i=bpelActivity.getExtensibilityElements().size()-1; i>=0; i--){
			if (bpelActivity.getExtensibilityElements().get(i) instanceof Staff
			    	|| bpelActivity.getExtensibilityElements().get(i) instanceof PotentialOwner){
				bpelActivity.getExtensibilityElements().remove(i);	
			}
		}
	}
	
	/** 
	* Searches for a Staff Activity on a BPEL Invoke or Receive, and removes it if it
	* is found, since Staff activities don't apply to BPEL processes.
	* 
	* @param bpelActivity The Invoke or Receive on which to look for and remove Staff activities.
	*/
	private void removeDisplayName(BPELVariable variable){
		for (int i=variable.getExtensibilityElements().size()-1; i>=0; i--){
			if (variable.getExtensibilityElements().get(i) instanceof DisplayName){
				variable.getExtensibilityElements().remove(i);	
			}
		}
	}

	/** 
	* Searches for a Staff Activity on a BPEL Invoke or Receive, and removes it if it
	* is found, since Staff activities don't apply to BPEL processes.
	* 
	* @param bpelActivity The Invoke or Receive on which to look for and remove Staff activities.
	*/
	private void removeDisplayName(Invoke variable){
		for (int i=variable.getExtensibilityElements().size()-1; i>=0; i--){
			if (variable.getExtensibilityElements().get(i) instanceof DisplayName){
				variable.getExtensibilityElements().remove(i);	
			}
		}
	}	
} //BpelRuleImpl
