/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.bpel.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Collection;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.btools.expression.model.BinaryLogicalBooleanExpression;
import com.ibm.btools.expression.model.BinaryNumericExpression;
import com.ibm.btools.expression.model.ComparisonExpression;
import com.ibm.btools.expression.model.Expression;
import com.ibm.btools.expression.model.FunctionArgument;
import com.ibm.btools.expression.model.FunctionExpression;
import com.ibm.btools.expression.model.ModelFactory;
import com.ibm.btools.expression.model.NegationExpression;
import com.ibm.btools.expression.model.NotExpression;
import com.ibm.btools.expression.model.StringLiteralExpression;
import com.ibm.btools.expression.xpath.XPathExpressionSerializer;
import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.framework.impl.TransformationRuleImpl;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.bpel.BpelPackage;
import com.ibm.btools.te.ilm.heuristics.bpel.XPathExprSerializerRule;
import com.ibm.btools.te.ilm.resource.MessageKeys;
import com.ibm.wbit.bpel.BPELFactory;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>XPath Expr Serializer Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class XPathExprSerializerRuleImpl extends TransformationRuleImpl implements XPathExprSerializerRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected XPathExprSerializerRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return BpelPackage.eINSTANCE.getXPathExprSerializerRule();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__CHILD_RULES:
					return ((InternalEList)getChildRules()).basicAdd(otherEnd, msgs);
				case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__PARENT_RULE:
					if (eContainer != null)
						msgs = eBasicRemoveFromContainer(msgs);
					return eBasicSetContainer(otherEnd, BpelPackage.XPATH_EXPR_SERIALIZER_RULE__PARENT_RULE, msgs);
				case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__ROOT:
					if (root != null)
						msgs = ((InternalEObject)root).eInverseRemove(this, FrameworkPackage.TRANSFORMATION_ROOT__RULES, TransformationRoot.class, msgs);
					return basicSetRoot((TransformationRoot)otherEnd, msgs);
				default:
					return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__CHILD_RULES:
					return ((InternalEList)getChildRules()).basicRemove(otherEnd, msgs);
				case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__PARENT_RULE:
					return eBasicSetContainer(null, BpelPackage.XPATH_EXPR_SERIALIZER_RULE__PARENT_RULE, msgs);
				case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__ROOT:
					return basicSetRoot(null, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
				case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__PARENT_RULE:
					return ((InternalEObject)eContainer).eInverseRemove(this, FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES, TransformationRule.class, msgs);
				default:
					return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return ((InternalEObject)eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__COMPLETE:
				return isComplete() ? Boolean.TRUE : Boolean.FALSE;
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__FAILED:
				return isFailed() ? Boolean.TRUE : Boolean.FALSE;
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__CHILD_RULES:
				return getChildRules();
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__PARENT_RULE:
				return getParentRule();
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__TARGET:
				return getTarget();
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__SOURCE:
				return getSource();
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__ROOT:
				if (resolve) return getRoot();
				return basicGetRoot();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__COMPLETE:
				setComplete(((Boolean)newValue).booleanValue());
				return;
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__FAILED:
				setFailed(((Boolean)newValue).booleanValue());
				return;
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__CHILD_RULES:
				getChildRules().clear();
				getChildRules().addAll((Collection)newValue);
				return;
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__PARENT_RULE:
				setParentRule((TransformationRule)newValue);
				return;
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__TARGET:
				getTarget().clear();
				getTarget().addAll((Collection)newValue);
				return;
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__SOURCE:
				getSource().clear();
				getSource().addAll((Collection)newValue);
				return;
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__ROOT:
				setRoot((TransformationRoot)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__COMPLETE:
				setComplete(COMPLETE_EDEFAULT);
				return;
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__FAILED:
				setFailed(FAILED_EDEFAULT);
				return;
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__CHILD_RULES:
				getChildRules().clear();
				return;
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__PARENT_RULE:
				setParentRule((TransformationRule)null);
				return;
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__TARGET:
				getTarget().clear();
				return;
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__SOURCE:
				getSource().clear();
				return;
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__ROOT:
				setRoot((TransformationRoot)null);
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__COMPLETE:
				return complete != COMPLETE_EDEFAULT;
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__FAILED:
				return failed != FAILED_EDEFAULT;
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__CHILD_RULES:
				return childRules != null && !childRules.isEmpty();
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__PARENT_RULE:
				return getParentRule() != null;
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__TARGET:
				return target != null && !target.isEmpty();
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__SOURCE:
				return source != null && !source.isEmpty();
			case BpelPackage.XPATH_EXPR_SERIALIZER_RULE__ROOT:
				return root != null;
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * source = Expression Model in the BPEL context
	 * target = BPEL Expression object (because the list of targets is an EList, and so it can't contain non-EObjects)
	 * 
	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target()
	 */
	public boolean transformSource2Target() {	
		LoggingUtil.traceEntry(this, "transformSource2Target");
		
		if (getSource() == null || getSource().isEmpty()) {
			LoggingUtil.traceExit(this, "transformSource2Target","no source");
			return false;			
		}
		
		String xpath = "";
		Expression resultExpr = null;
		XPathExpressionSerializer ser = new XPathExpressionSerializer();
		
		resultExpr = checkForExceptions((Expression)getSource().get(0), null);
		if (resultExpr != null){
			xpath = ser.serialize(resultExpr);			
			xpath = addQuotes(xpath);
		}	
		else{
			//throw new BTRuntimeException("Invalid BPEL XPath with nested bpws:getVariableData");				
			LoggingUtil.logWarning(MessageKeys.INVALID_BPEL_XPATH_EXPRESSION);							
		}
		
		/* Set Target as the XPath String */
		com.ibm.wbit.bpel.Expression bpelExpression = BPELFactory.eINSTANCE.createExpression();
		bpelExpression.setBody(xpath);
		getTarget().add(bpelExpression);
		
		/* Rule completed */
		setComplete(true);
		LoggingUtil.traceExit(this, "transformSource2Target");		
		return isComplete();	
	}

	/**
	 * Add single quotes to the third argument (if exists) of bpws:getVariableData	 
	 * @param xpath - a xpath expression string
	 * @return String - A xpath expression string with quotes in the correct position
	 */	
	private String addQuotes(String xpath)
	{
		StringBuffer xpathBuffer = new StringBuffer();
		int countParen = 1;
		int commaIndex = -1;
		int functionIndex = -1;	
		int openParenIndex = -1;
		int closeParenIndex =-1;	
		int parenIndex = -1;
		
		functionIndex = xpath.indexOf("getVariableData");
		/* If there are no getVariableData functions in the xpath Sting */
		if (-1==functionIndex)
			return xpath;
			
		while (functionIndex != -1)
		{				
			parenIndex = functionIndex + 16;
			commaIndex = xpath.indexOf(',', functionIndex);
			if (commaIndex != -1)
				commaIndex = xpath.indexOf(',', commaIndex+1);
			if ( (commaIndex!=-1) && (commaIndex < xpath.indexOf(')',functionIndex ))){		
				while (countParen != 0)
				{
					openParenIndex = xpath.indexOf('(', parenIndex);
					closeParenIndex = xpath.indexOf(')', parenIndex);				
					if ( (openParenIndex!=-1) && (openParenIndex < closeParenIndex)){
						countParen++;
						parenIndex=openParenIndex+1;
					}					
					else{
						--countParen;
						parenIndex=closeParenIndex+1;
					}
				}
				/* Now we found the end parenthesis for the function getVariableData */
				xpathBuffer.append(xpath.substring(0, commaIndex+1));
				xpathBuffer.append('\'');
				xpathBuffer.append(xpath.substring(commaIndex+1, parenIndex-1));
				xpathBuffer.append('\'');			
				xpathBuffer.append(xpath.substring(parenIndex-1, xpath.length()));
			}
			else
				return xpath;
			xpath = xpathBuffer.toString();
			xpathBuffer.delete(0, xpathBuffer.length());			
			functionIndex = xpath.indexOf("getVariableData", functionIndex+16);			
			countParen=1;
		}
			
		return xpath;
	}

	/**
	 * Check the expression to see if it's an invalid BPEL xpath expression
	 * It is invalid if we have nested bpws:getVariableData in BPEL	 
	 * @param expression - the input expression to be checked
	 * @param containerList - A List to keep track of the current BPEL container
	 * @return Expression - the result expression, null if invalid
	 */	
	private Expression checkForExceptions(Expression expression, List containerList)
	{
		Expression testExpr;
		Expression expr;
		/* Do Recursively to find any ModelPathExpressionExtension class */
		 if (expression==null)	
			return null;
		 if (expression instanceof BinaryLogicalBooleanExpression){
			expr = ModelFactory.eINSTANCE.createBinaryLogicalBooleanExpression();
			((BinaryLogicalBooleanExpression)expr).setOperator(((BinaryLogicalBooleanExpression)expression).getOperator());
			testExpr = checkForExceptions(((BinaryLogicalBooleanExpression)expression).getFirstOperand(),containerList);
			 if (testExpr!=null)
				((BinaryLogicalBooleanExpression)expr).setFirstOperand(testExpr);
			 else
				return null;
			 testExpr = checkForExceptions(((BinaryLogicalBooleanExpression)expression).getSecondOperand(),containerList);
			 if (testExpr!=null)
				((BinaryLogicalBooleanExpression)expr).setSecondOperand(testExpr);
			 else
				return null;			 
			 return expr;	
		 }
		 else if (expression instanceof BinaryNumericExpression){
			expr = ModelFactory.eINSTANCE.createBinaryNumericExpression();
			((BinaryNumericExpression)expr).setOperator(((BinaryNumericExpression)expression).getOperator());
			testExpr = checkForExceptions(((BinaryNumericExpression)expression).getFirstOperand(),containerList);
			 if (testExpr!=null)
				((BinaryNumericExpression)expr).setFirstOperand(testExpr);
			 else
				return null;
			 testExpr = checkForExceptions(((BinaryNumericExpression)expression).getSecondOperand(),containerList);
			 if (testExpr!=null)
				((BinaryNumericExpression)expr).setSecondOperand(testExpr);
			 else
				return null;			 
			 return expr;	
		 }
		 else if (expression instanceof ComparisonExpression){
			expr = ModelFactory.eINSTANCE.createComparisonExpression();
			((ComparisonExpression)expr).setOperator(((ComparisonExpression)expression).getOperator());
			testExpr = checkForExceptions(((ComparisonExpression)expression).getFirstOperand(),containerList);
			 if (testExpr!=null)
				((ComparisonExpression)expr).setFirstOperand(testExpr);
			 else
				return null;
			 testExpr = checkForExceptions(((ComparisonExpression)expression).getSecondOperand(),containerList);
			 if (testExpr!=null)
				((ComparisonExpression)expr).setSecondOperand(testExpr);
			 else
				return null;			 
			 return expr;	
		 }	
		else if (expression instanceof NotExpression){
			expr = ModelFactory.eINSTANCE.createNotExpression();
			testExpr = checkForExceptions(((NotExpression)expression).getExpression(),containerList);
			if (testExpr!=null)
				((NotExpression)expr).setExpression(testExpr);
			else
				return null;
			return expr;
		}
		else if (expression instanceof NegationExpression){
			expr =ModelFactory.eINSTANCE.createNegationExpression();
			testExpr = checkForExceptions(((NegationExpression)expression).getExpression(),containerList);
			if (testExpr!=null)
				((NegationExpression)expr).setExpression(testExpr);
			else
				return null;
			return expr;
		} else if (expression instanceof FunctionExpression) {			
			return checkForExceptions((FunctionExpression)expression,containerList);		
		} else {
			return expression;
		}				
	}

	/**
	 * Check the Function expression to see if it's an invalid BPEL xpath expression	 
	 * @param expression - the input expression to be checked
	 * @param containerList - A List to keep track of the current BPEL container
	 * @return Expression - the result expression, null if invalid
	 */		
	private Expression checkForExceptions(FunctionExpression expr, List containerList)
	{
		FunctionArgument argument;
		List arguments = expr.getArguments();
		Expression argValue;
		Expression testExpr = null;
		boolean tempBool = false;
		if (expr.getDefinition().getFunctionID().equals("com.ibm.btools.te.ilm.heuristics.abstractbpel.getVariableData"))
		{
			if(containerList == null){
				FunctionExpression funcExpr = ModelFactory.eINSTANCE.createFunctionExpression();
				funcExpr.setDefinition(expr.getDefinition());	
				FunctionArgument arg1 = ModelFactory.eINSTANCE.createFunctionArgument();
				FunctionArgument arg2 = ModelFactory.eINSTANCE.createFunctionArgument();
				arg1.setArgumentValue(((FunctionArgument)arguments.get(0)).getArgumentValue());
				arg2.setArgumentValue(((FunctionArgument)arguments.get(1)).getArgumentValue());
				funcExpr.getArguments().add(arg1);
				funcExpr.getArguments().add(arg2);
																		
				if (arguments.size()>2){
					List newList = new LinkedList();
					//List contains StringLiteralExpressions
					newList.add(arg1.getArgumentValue());				
					newList.add(arg2.getArgumentValue());	
					FunctionArgument arg3 = ModelFactory.eINSTANCE.createFunctionArgument();
					testExpr = checkForExceptions(((FunctionArgument)arguments.get(2)).getArgumentValue(), newList);
					if (testExpr!=null)
						arg3.setArgumentValue(testExpr);
					else
						return null;				
					funcExpr.getArguments().add(arg3);
				}
				return funcExpr;
			}
			else {
				/* Check to see if the two ModelPathExpressions are in the same container */				
				return checkSameContainer(expr, containerList);
			}
		}
		else{
			FunctionExpression funcExpr = ModelFactory.eINSTANCE.createFunctionExpression();
			funcExpr.setDefinition(expr.getDefinition());				
			for (int i=0; i<arguments.size(); i++)
			{					
				argument = (FunctionArgument)arguments.get(i);
				argValue = argument.getArgumentValue();
				FunctionArgument arg1 = ModelFactory.eINSTANCE.createFunctionArgument();
				testExpr = checkForExceptions(argValue, containerList);
				if (testExpr!=null)
					arg1.setArgumentValue(testExpr);
				else
					return null;
				funcExpr.getArguments().add(arg1);
			}
			return funcExpr;	
		}
	}	

	/**
	 * Check the expression to see if in the same Container as the container List 
	 * @param expression - the input expression to be checked
	 * @param containerList - A List to keep track of the current BPEL container
	 * @return Expression - the result expression, null if invalid
	 */			
	private Expression checkSameContainer(FunctionExpression expression, List containerList)
	{
		List arguments = expression.getArguments();		
		String BPELVariable = ((StringLiteralExpression)containerList.get(0)).getStringSymbol();
		String BPELPart = ((StringLiteralExpression)containerList.get(1)).getStringSymbol();
		StringLiteralExpression strExpr1 = (StringLiteralExpression)((FunctionArgument)arguments.get(0)).getArgumentValue();
		StringLiteralExpression strExpr2 = (StringLiteralExpression)((FunctionArgument)arguments.get(1)).getArgumentValue();
		if ( (BPELVariable.equalsIgnoreCase(strExpr1.getStringSymbol())) && (BPELPart.equalsIgnoreCase(strExpr2.getStringSymbol())) ){
			/* sameContainer */
			/* Must modify expression to get rid of the getVariableData for the second time getting hte container */
			/* Replace it with just the third argument */
			Expression tempExpr = ((FunctionArgument)arguments.get(2)).getArgumentValue();	
			return checkForExceptions(tempExpr, containerList);
		}
		else {
			return null;
		}
		
	}
	

} //XPathExprSerializerRuleImpl
