/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.bpelp.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import com.ibm.btools.te.framework.FrameworkPackage;

import com.ibm.btools.te.framework.impl.FrameworkPackageImpl;

import com.ibm.btools.te.ilm.heuristics.HeuristicsPackage;

import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelPackage;

import com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl;

import com.ibm.btools.te.ilm.heuristics.bpel.BpelPackage;

import com.ibm.btools.te.ilm.heuristics.bpel.impl.BpelPackageImpl;

import com.ibm.btools.te.ilm.heuristics.bpelp.BpelpFactory;
import com.ibm.btools.te.ilm.heuristics.bpelp.BpelpPackage;
import com.ibm.btools.te.ilm.heuristics.bpelp.BpelpRule;
import com.ibm.btools.te.ilm.heuristics.bpelp.JavaExprSerializerRule;


import com.ibm.btools.te.ilm.heuristics.br.BrPackage;

import com.ibm.btools.te.ilm.heuristics.br.impl.BrPackageImpl;

import com.ibm.btools.te.ilm.heuristics.extservice.ExtservicePackage;

import com.ibm.btools.te.ilm.heuristics.extservice.impl.ExtservicePackageImpl;

import com.ibm.btools.te.ilm.heuristics.fdl.FdlPackage;

import com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl;

import com.ibm.btools.te.ilm.heuristics.impl.HeuristicsPackageImpl;

import com.ibm.btools.te.ilm.heuristics.scdl.ScdlPackage;

import com.ibm.btools.te.ilm.heuristics.scdl.impl.ScdlPackageImpl;

import com.ibm.btools.te.ilm.heuristics.wsdl.WsdlPackage;

import com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl;

import com.ibm.btools.te.ilm.heuristics.xsd.XsdPackage;

import com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.EcorePackage;

import org.eclipse.emf.ecore.impl.EPackageImpl;


import org.eclipse.emf.ecore.impl.EcorePackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class BpelpPackageImpl extends EPackageImpl implements BpelpPackage {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass javaExprSerializerRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bpelpRuleEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see com.ibm.btools.te.ilm.heuristics.bpelp.BpelpPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private BpelpPackageImpl() {
		super(eNS_URI, BpelpFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this
	 * model, and for any others upon which it depends.  Simple
	 * dependencies are satisfied by calling this method on all
	 * dependent packages before doing anything else.  This method drives
	 * initialization for interdependent packages directly, in parallel
	 * with this package, itself.
	 * <p>Of this package and its interdependencies, all packages which
	 * have not yet been registered by their URI values are first created
	 * and registered.  The packages are then initialized in two steps:
	 * meta-model objects for all of the packages are created before any
	 * are initialized, since one package's meta-model objects may refer to
	 * those of another.
	 * <p>Invocation of this method will not affect any packages that have
	 * already been initialized.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static BpelpPackage init() {
		if (isInited) return (BpelpPackage)EPackage.Registry.INSTANCE.getEPackage(BpelpPackage.eNS_URI);

		// Obtain or create and register package
		BpelpPackageImpl theBpelpPackage = (BpelpPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof BpelpPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new BpelpPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		EcorePackage.eINSTANCE.eClass();

		// Obtain or create and register interdependencies
		FrameworkPackageImpl theFrameworkPackage = (FrameworkPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FrameworkPackage.eNS_URI) instanceof FrameworkPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FrameworkPackage.eNS_URI) : FrameworkPackage.eINSTANCE);
		HeuristicsPackageImpl theHeuristicsPackage = (HeuristicsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(HeuristicsPackage.eNS_URI) instanceof HeuristicsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(HeuristicsPackage.eNS_URI) : HeuristicsPackage.eINSTANCE);
		XsdPackageImpl theXsdPackage = (XsdPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(XsdPackage.eNS_URI) instanceof XsdPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(XsdPackage.eNS_URI) : XsdPackage.eINSTANCE);
		FdlPackageImpl theFdlPackage = (FdlPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FdlPackage.eNS_URI) instanceof FdlPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FdlPackage.eNS_URI) : FdlPackage.eINSTANCE);
		AbstractbpelPackageImpl theAbstractbpelPackage = (AbstractbpelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AbstractbpelPackage.eNS_URI) instanceof AbstractbpelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AbstractbpelPackage.eNS_URI) : AbstractbpelPackage.eINSTANCE);
		WsdlPackageImpl theWsdlPackage = (WsdlPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(WsdlPackage.eNS_URI) instanceof WsdlPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(WsdlPackage.eNS_URI) : WsdlPackage.eINSTANCE);
		ScdlPackageImpl theScdlPackage = (ScdlPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ScdlPackage.eNS_URI) instanceof ScdlPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ScdlPackage.eNS_URI) : ScdlPackage.eINSTANCE);
		ExtservicePackageImpl theExtservicePackage = (ExtservicePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ExtservicePackage.eNS_URI) instanceof ExtservicePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ExtservicePackage.eNS_URI) : ExtservicePackage.eINSTANCE);
		BrPackageImpl theBrPackage = (BrPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(BrPackage.eNS_URI) instanceof BrPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(BrPackage.eNS_URI) : BrPackage.eINSTANCE);

		// Create package meta-data objects
		theBpelpPackage.createPackageContents();
		theFrameworkPackage.createPackageContents();
		theHeuristicsPackage.createPackageContents();
		theXsdPackage.createPackageContents();
		theFdlPackage.createPackageContents();
		theAbstractbpelPackage.createPackageContents();
		theWsdlPackage.createPackageContents();
		theScdlPackage.createPackageContents();
		theExtservicePackage.createPackageContents();
		theBrPackage.createPackageContents();

		// Initialize created meta-data
		theBpelpPackage.initializePackageContents();
		theFrameworkPackage.initializePackageContents();
		theHeuristicsPackage.initializePackageContents();
		theXsdPackage.initializePackageContents();
		theFdlPackage.initializePackageContents();
		theAbstractbpelPackage.initializePackageContents();
		theWsdlPackage.initializePackageContents();
		theScdlPackage.initializePackageContents();
		theExtservicePackage.initializePackageContents();
		theBrPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theBpelpPackage.freeze();

		return theBpelpPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getJavaExprSerializerRule() {
		return javaExprSerializerRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBpelpRule() {
		return bpelpRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BpelpFactory getBpelpFactory() {
		return (BpelpFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		javaExprSerializerRuleEClass = createEClass(JAVA_EXPR_SERIALIZER_RULE);

		bpelpRuleEClass = createEClass(BPELP_RULE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		FrameworkPackage theFrameworkPackage = (FrameworkPackage)EPackage.Registry.INSTANCE.getEPackage(FrameworkPackage.eNS_URI);

		// Add supertypes to classes
		javaExprSerializerRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());
		bpelpRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());

		// Initialize classes and features; add operations and parameters
		initEClass(javaExprSerializerRuleEClass, JavaExprSerializerRule.class, "JavaExprSerializerRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(bpelpRuleEClass, BpelpRule.class, "BpelpRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
	}

} //BpelpPackageImpl
