package com.ibm.btools.te.ilm.heuristics.bpelp.util;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

public interface JavaConstants {
	
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	
	public final static String AND_OP = " && ";
	public final static String OR_OP  = " || ";

	public final static String ADDITION_OP                 = " + ";
	public final static String SUBTRACTION_OP              = " - ";
	public final static String MULTIPLICATION_OP           = " * ";
	public final static String DIVISION_OP                 = " / ";
	public final static String MODULUS_OP                  = " % ";
	public final static String EQUAL_TO_OP                 = " == ";
	public final static String NOT_EQUAL_TO_OP             = " != ";
	public final static String LESS_THAN_OP                = " < ";
	public final static String LESS_THAN_OR_EQUAL_TO_OP    = " <= ";
	public final static String GREATER_THAN_OP             = " > ";
	public final static String GREATER_THAN_OR_EQUAL_TO_OP = " >= ";
	
	public final static String STRING_EQUAL_TO_OP                 = " == 0";
	public final static String STRING_NOT_EQUAL_TO_OP             = " != 0";
	public final static String STRING_LESS_THAN_OP                = " > 0";
	public final static String STRING_LESS_THAN_OR_EQUAL_TO_OP    = " >= 0";
	public final static String STRING_GREATER_THAN_OP             = " < 0";
	public final static String STRING_GREATER_THAN_OR_EQUAL_TO_OP = " <= 0";

	public final static String DATE_EQUAL		= ".equals";
	public final static String DATE_BEFORE		= ".before";
	public final static String DATE_AFTER		= ".after";

	public final static String NEGATION_OP = "(-1)*";
	
	public final static String ARGUMENT_SEP = ",";

	public final static String PARENTHESIS_START = "(";
	public final static String PARENTHESIS_END   = ")";
	public final static String CURLYBRACKET_START   = "{";
	public final static String CURLYBRACKET_END   = "}";
	
	public final static String STRING_DECOR = "\"";
	public final static String EQUALS = "=";
	//defect 85847
	//public final static String NEWLINE = "\r";
	public final static String NEWLINE = "\r\n";
	public final static String RETURN = "return ";
	public final static String SEMICOLON = ";";
	public final static String COMMA = ",";

	public final static String TRUE_VALUE  = "true";
	public final static String FALSE_VALUE = "false";

	public final static String NOT_FUNC = "!";

	// Based on WID 6.02 visual expression editor (20061030)
	public final static String [][] XSDToSDOMapping = {
			{ "anyType", "getDataObject", },	// error - SDO
		    { "anyURI", "getString", },			
		    { "base64Binary", "getBytes", },	// error - byte[]
		    { "boolean", "getBoolean", },
		    { "byte", "getByte", },
		    { "date", "getDate", },
		    { "dateTime", "getDate", },  		// potential overflow - { "decimal", "getBigDecimal", },
		    { "decimal", "getDouble", },
			{ "double", "getDouble", },
		    { "duration", "getString", },		// error - duration not populated
		    { "ENTITIES", "getList", },			// error - list - getElement(index) and cast to String
		    { "ENTITY", "getString", },
		    { "float", "getFloat", },
		    { "gDay", "getString", },
		    { "gMonth", "getString", },
		    { "gMonthDay", "getString", },
		    { "gYear", "getDate", },			// cannot set the Date in Expression builder, enter String "Jan" - no errors
		    { "gYearMonth", "getDate", },		// cannot set the Date in Expression builder
		    { "hexBinary", "getBytes", },		// error - byte[]
		    { "ID", "getString", },
		    { "IDREF", "getString", },
		    { "IDREFS", "getList", },			// error - list - getElement(index) and cast to String
		    { "int", "getInt", },				// potential overflow - use long? - overflow - { "integer", "getBigInteger", },
		    { "integer", "getLong", },
		    { "language", "getString", },
		    { "long", "getLong", },
		    { "Name", "getString", },
		    { "NCName", "getString", },			// potential overflow - use int? - overflow - { "integer", "getBigInteger", },			
		    { "negativeInteger", "getInt", },
		    { "NMTOKEN", "getString", },
		    { "NMTOKENS", "getList", },			// error - list - getElement(index) and cast to String			
		    { "nonNegativeInteger", "getLong", }, // potential overflow - use long? - overflow  { "nonNegativeInteger", "getBigInteger", },
		    { "nonPositiveInteger", "getLong", },// potential overflow - did not import, use int? - overflow - { "nonPositiveInteger", "getBigInteger", },
		    { "normalizedString", "getString", },
		    { "NOTATION", "getString", },			
		    { "positiveInteger", "getLong", },	// potential overflow - use long? - overflow - { "positiveInteger", "getBigInteger", },
		    { "QName", "getString", },
		    { "short", "getShort", },
		    { "string", "getString", },
		    { "time", "getString", },			// error - expression not serialized correctly - empty calendars
		    { "token", "getString", },
		    { "unsignedByte", "getInt", },		// potential overflow - use long? - overflow - { "unsignedInt", "getBigInteger", },			
		    { "unsignedInt", "getLong", },		// potential overflow - use long? - overflow - { "unsignedLong", "getBigInteger", },			
		    { "unsignedLong", "getLong", },
		    { "unsignedShort", "getInt", },
		};
	
	//JR26020
	// Based on WID 6.02 visual expression editor (20061030)
	public final static String[][] XSDToSimpleValue = {
			{ "anyType", "", },	// error - SDO
		    { "anyURI", "", },			
		    { "base64Binary", "getBytes", },	// error - byte[]
		    { "boolean", "booleanValue()", },
		    { "byte", "byteValue()", },
		    { "date", "", },
		    { "dateTime", "", },  		
		    { "decimal", "doubleValue()", }, // potential overflow - { "decimal", "getBigDecimal", },
			{ "double", "doubleValue()", },
		    { "duration", "", },		// error - duration not populated
		    { "ENTITIES", "getList", },			// error - list - getElement(index) and cast to String
		    { "ENTITY", "", },
		    { "float", "floatValue()", },
		    { "gDay", "", },
		    { "gMonth", "", },
		    { "gMonthDay", "", },
		    { "gYear", "", },			// cannot set the Date in Expression builder, enter String "Jan" - no errors
		    { "gYearMonth", "", },		// cannot set the Date in Expression builder
		    { "hexBinary", "byteValue()", },		// error - byte[]
		    { "ID", "", },
		    { "IDREF", "", },
		    { "IDREFS", "getList", },			// error - list - getElement(index) and cast to String
		    { "int", "intValue()", },				// potential overflow - use long? - overflow - { "integer", "getBigInteger", },
		    { "integer", "longValue()", },
		    { "language", "", },
		    { "long", "longValue()", },
		    { "Name", "getString()", },
		    { "NCName", "", },			// potential overflow - use int? - overflow - { "integer", "getBigInteger", },			
		    { "negativeInteger", "intValue()", },
		    { "NMTOKEN", "", },
		    { "NMTOKENS", "getList", },			// error - list - getElement(index) and cast to String			
		    { "nonNegativeInteger", "longValue()", }, // potential overflow - use long? - overflow  { "nonNegativeInteger", "getBigInteger", },
		    { "nonPositiveInteger", "longValue()", },// potential overflow - did not import, use int? - overflow - { "nonPositiveInteger", "getBigInteger", },
		    { "normalizedString", "", },
		    { "NOTATION", "", },			
		    { "positiveInteger", "longValue()", },	// potential overflow - use long? - overflow - { "positiveInteger", "getBigInteger", },
		    { "QName", "", },
		    { "short", "shortValue()", },
		    { "string", "", },
		    { "time", "", },			// error - expression not serialized correctly - empty calendars
		    { "token", "", },
		    { "unsignedByte", "intValue()", },		// potential overflow - use long? - overflow - { "unsignedInt", "getBigInteger", },			
		    { "unsignedInt", "longValue()", },		// potential overflow - use long? - overflow - { "unsignedLong", "getBigInteger", },			
		    { "unsignedLong", "longValue()", },
		    { "unsignedShort", "intValue()", },
		};

}
