package com.ibm.btools.te.ilm.heuristics.br.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import java.util.Iterator;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.wst.wsdl.Operation;
import org.eclipse.wst.wsdl.PortType;

import com.ibm.btools.bom.model.processes.businessrules.BusinessRuleGroup;
import com.ibm.btools.bom.model.processes.businessrules.BusinessRuleSet;
import com.ibm.btools.bom.model.processes.businessrules.BusinessRuleSetSelectionRecord;
import com.ibm.btools.te.framework.impl.TransformationRuleImpl;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.BRReusableTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.BRTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.BRTaskRuleImpl;
import com.ibm.btools.te.ilm.heuristics.br.BRGroupRule;
import com.ibm.btools.te.ilm.heuristics.br.BRSetRule;
import com.ibm.btools.te.ilm.heuristics.br.BrPackage;
import com.ibm.btools.te.ilm.heuristics.helper.ProcessUtil;
import com.ibm.wbiservers.businessrule.model.brgt.BRGTDateTimeRangeKey;
import com.ibm.wbiservers.businessrule.model.brgt.BrgtFactory;
import com.ibm.wbiservers.businessrule.model.brgt.BusinessRuleGroupTable;
import com.ibm.wbiservers.businessrule.model.brgt.RuleSetSelectionData;
import com.ibm.wbiservers.common.selectiontables.OperationSelectionRecord;
import com.ibm.wbiservers.common.selectiontables.OperationSelectionTable;
import com.ibm.wbiservers.common.selectiontables.SelectionKey;
import com.ibm.wbiservers.common.selectiontables.SelectiontablesFactory;
import com.ibm.wbit.br.core.model.DocumentRoot;
import com.ibm.wbit.br.core.model.RuleSet;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>BR Group Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class BRGroupRuleImpl extends TransformationRuleImpl implements BRGroupRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	/* attribute indicate whether it is first time execution of this rule */
	private boolean firstTimeExec = true;	

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BRGroupRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return BrPackage.Literals.BR_GROUP_RULE;
	}

	/**
	 * Creates and executes rules to map BOM BusinessRuleGroup to Business Rule Group constructs.
	 */
	@SuppressWarnings("unchecked")
	public boolean transformSource2Target() {
		LoggingUtil.traceEntry(this, "transformSource2Target");
		
		//assertion
		if (getSource() == null || getSource().size() != 2) {
			LoggingUtil.traceExit(this, "transformSource2Target", "no source");
			return false;			
		}
			 
  		//check if this is first time execute this rule
		if(!firstTimeExec){
			 return true;		  
		} else {
			firstTimeExec = false;
		}

		//get sources of this rule - BusinessRuleGroup and portType
		BusinessRuleGroup businessRuleGroup = (BusinessRuleGroup)getSource().get(0);
		PortType portType = (PortType)getSource().get(1);
		
		// create and populate BusinessRuleTable
		BusinessRuleGroupTable brgTable = BrgtFactory.eINSTANCE.createBusinessRuleGroupTable();
		
		brgTable.setTargetNameSpace(ProcessUtil.createNamespace(businessRuleGroup.getOwningAction(), true));
		String baseName = null;
		Iterator targetIt = null;
		Object obj = null;
		if (getParentRule() instanceof BRTaskRule) {
			targetIt = ((BRTaskRuleImpl)getParentRule()).getTarget().iterator();
		} else if (getParentRule() instanceof BRReusableTaskRule) {
			targetIt = ((BRReusableTaskRule)getParentRule()).getTarget().iterator();
		} 
		while (targetIt.hasNext() && baseName == null) {
			obj= targetIt.next();
			if (obj instanceof com.ibm.wbiservers.businessrule.model.brg.BusinessRuleGroup) {
				baseName = ((com.ibm.wbiservers.businessrule.model.brg.BusinessRuleGroup)obj).getName();
			}
		}
		brgTable.setName(baseName);	
		
		OperationSelectionTable opSelectionTable = SelectiontablesFactory.eINSTANCE.createOperationSelectionTable();
		
		// set the operation name, only 1 operation allowed
		opSelectionTable.setOperationName(((Operation)portType.getOperations().get(0)).getName());	
		
		// add available rule sets
		if (businessRuleGroup.getAvailableTargets() != null) {
			Iterator targets = businessRuleGroup.getAvailableTargets().iterator();
			BusinessRuleSet target = null;	
			RuleSetSelectionData rsAvailable = null;

			while (targets.hasNext()) {
				target = (BusinessRuleSet) targets.next();
				rsAvailable = BrgtFactory.eINSTANCE.createRuleSetSelectionData();
				rsAvailable.setBusinessRule(findRuleSet(target));
				opSelectionTable.getAvailableTargets().add(rsAvailable);
			}
		}

		// add default rule set
		if (businessRuleGroup.getDefaultRuleSet() != null) {
			RuleSetSelectionData rsSelectionData = BrgtFactory.eINSTANCE.createRuleSetSelectionData();
			rsSelectionData.setBusinessRule(findRuleSet(businessRuleGroup.getDefaultRuleSet()));
			opSelectionTable.setDefaultSelectionData(rsSelectionData);
		}
		
		// populate the table and test values
		if (businessRuleGroup.getSelectionRecords() != null) {
			Iterator it = businessRuleGroup.getSelectionRecords().iterator();
			
			BusinessRuleSetSelectionRecord brSelRecord = null;
			OperationSelectionRecord opSelRecord = null;
			SelectionKey selKey = null;
			BRGTDateTimeRangeKey brgtRangeKey = null;
			RuleSetSelectionData selData = null;
			
			while (it.hasNext()) {
				brSelRecord = (BusinessRuleSetSelectionRecord) it.next();
				if (brSelRecord != null) {
					opSelRecord = SelectiontablesFactory.eINSTANCE.createOperationSelectionRecord();
					if (brSelRecord.getSelectionStartTime() != null || brSelRecord.getSelectionEndTime() != null) {
						selKey = SelectiontablesFactory.eINSTANCE.createSelectionKey();
						brgtRangeKey = BrgtFactory.eINSTANCE.createBRGTDateTimeRangeKey();
						if (brSelRecord.getSelectionStartTime() != null && brSelRecord.getSelectionStartTime().length() > 0) {
							brgtRangeKey.setStartingValue(brSelRecord.getSelectionStartTime());
						}
						if (brSelRecord.getSelectionEndTime() != null && brSelRecord.getSelectionEndTime().length() > 0) {
							brgtRangeKey.setEndingValue(brSelRecord.getSelectionEndTime());
						}
						selKey.getSelectionKeyElements().add(brgtRangeKey);
						opSelRecord.setSelectionKey(selKey);
					}

					if (brSelRecord.getRuleSet() != null) {
						selData = BrgtFactory.eINSTANCE.createRuleSetSelectionData();
						selData.setBusinessRule(findRuleSet(brSelRecord.getRuleSet()));
						opSelRecord.setSelectionData(selData);						
					}
					opSelectionTable.getOperationSelectionRecords().add(opSelRecord);
				}
			}
		}

		//there is only one operation and one operation table
		brgTable.getOperationSelectionTables().add(opSelectionTable);

		//set table as a target
		getTarget().add(brgTable);
		
		setComplete(true);
		
		executeHandlers();
		
		LoggingUtil.traceExit(this, "transformSource2Target");
		return isComplete();		
	}	

	// find RuleSet from the list of the parent child rules
	private RuleSet findRuleSet(BusinessRuleSet brSet) {
		if (brSet == null) {
			return null;
		}
		
		RuleSet ruleSet = null;
		BRSetRule brSetRule = null;
		if (getParentRule().getChildRules() != null) {
			Iterator it = getParentRule().getChildRules().iterator();
			Object obj = null;
			while (it.hasNext()) {
				obj = it.next();
				
				if (obj instanceof BRSetRule) {
					brSetRule = (BRSetRule)obj;
					if (brSetRule.getSource() != null &&
							brSetRule.getSource().get(0) instanceof BusinessRuleSet &&
							((BusinessRuleSet)brSetRule.getSource().get(0)).getUid().equals(brSet.getUid())) {	// object equality
						if (brSetRule.getTarget() != null && !brSetRule.getTarget().isEmpty() && 
								brSetRule.getTarget().get(0) instanceof RuleSet) {
							ruleSet = (RuleSet)brSetRule.getTarget().get(0);
							
						} else if (brSetRule.getTarget() != null && !brSetRule.getTarget().isEmpty() && 
								brSetRule.getTarget().get(0) instanceof DocumentRoot) {
							DocumentRoot root = (DocumentRoot)brSetRule.getTarget().get(0);
							ruleSet = root.getRuleSet();
						}							
						break;
					}
				}						
			}
		}
		
		return ruleSet;
	}
} //BRGroupRuleImpl