package com.ibm.btools.te.ilm.heuristics.br.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import java.util.Iterator;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.xml.type.util.XMLTypeUtil;
import org.eclipse.wst.wsdl.Operation;
import org.eclipse.wst.wsdl.PortType;

import com.ibm.btools.bom.model.artifacts.Comment;
import com.ibm.btools.bom.model.processes.businessrules.BusinessRule;
import com.ibm.btools.bom.model.processes.businessrules.BusinessRuleBlock;
import com.ibm.btools.bom.model.processes.businessrules.BusinessRuleSet;
import com.ibm.btools.bom.model.processes.businessrules.BusinessRuleTemplate;
import com.ibm.btools.te.framework.impl.TransformationRuleImpl;
import com.ibm.btools.te.ilm.ExportOperation;
import com.ibm.btools.te.ilm.ExportOperationConstants;
import com.ibm.btools.te.ilm.ExportOperationUtil;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.attribute.AttributeValueProvider;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.BRReusableTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.BRTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.BRReusableTaskRuleImpl;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.BRTaskRuleImpl;
import com.ibm.btools.te.ilm.heuristics.br.BRRule;
import com.ibm.btools.te.ilm.heuristics.br.BRSetRule;
import com.ibm.btools.te.ilm.heuristics.br.BRTemplateRule;
import com.ibm.btools.te.ilm.heuristics.br.BrFactory;
import com.ibm.btools.te.ilm.heuristics.br.BrPackage;
import com.ibm.btools.te.ilm.heuristics.br.util.BRExpressionConstants;
import com.ibm.btools.te.ilm.heuristics.br.util.BRExpressionSerializer;
import com.ibm.btools.te.ilm.heuristics.br.util.BrUtil;
import com.ibm.btools.te.ilm.heuristics.helper.ProcessUtil;
import com.ibm.wbit.br.core.model.DocumentRoot;
import com.ibm.wbit.br.core.model.Interface;
import com.ibm.wbit.br.core.model.ModelFactory;
import com.ibm.wbit.br.core.model.Property;
import com.ibm.wbit.br.core.model.Rule;
import com.ibm.wbit.br.core.model.RuleBlock;
import com.ibm.wbit.br.core.model.RuleSet;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>BR Set Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class BRSetRuleImpl extends TransformationRuleImpl implements BRSetRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	/* attribute indicate whether it is first time execution of this rule */
	private boolean firstTimeExec = true;	
	AttributeValueProvider avp = null;
//	private boolean expose2BusinessSpace = false;
//	private boolean firstTimeCreateSystemProperty = true;
	
	 /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BRSetRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return BrPackage.Literals.BR_SET_RULE;
	}

	public AttributeValueProvider getAvp() {
		return avp;
	}

	private void setAvp(AttributeValueProvider avp) {
		this.avp = avp;
	}

	/**
	 * Creates and executes rules to map BOM BusinessRuleSet to Business Rule Set constructs.
	 */
	@SuppressWarnings("unchecked")
	public boolean transformSource2Target() {
		LoggingUtil.traceEntry(this, "transformSource2Target");
		
		//assertion
		if (getSource() == null || getSource().size() != 2) {
			LoggingUtil.traceExit(this, "transformSource2Target", "no source");
			return false;			
		}
			 
		//get sources of this rule - BusinessRuleSet and a PortType		
		BusinessRuleSet businessRuleSet = (BusinessRuleSet)getSource().get(0);
		PortType pt = (PortType)getSource().get(1);
		
  		//check if this is first time execute this rule
		if(!firstTimeExec){
			 return true;		  
		} else {
			firstTimeExec = false;
		}

		RuleSet ruleSet = ModelFactory.eINSTANCE.createRuleSet();
		//add property to initialize BOs
		Property initializeBOProperty = ModelFactory.eINSTANCE.createProperty();
		initializeBOProperty.setName(BRExpressionConstants.PROPERTY_INITIALIZE_BUSINESS_OBJECTS);
		initializeBOProperty.setValue(BRExpressionConstants.TRUE_VALUE);
		initializeBOProperty.setType(BRExpressionConstants.PROPERTY_SYSTEM_DEFINED);
		ruleSet.getProperty().add(initializeBOProperty);
		RuleBlock ruleBlock = ModelFactory.eINSTANCE.createRuleBlock();
		ruleSet.getRuleBlock().add(ruleBlock);
		
		// set attributes
		if (getParentRule() instanceof BRTaskRule) {
			setAvp(((BRTaskRuleImpl)getParentRule()).getAvp());
		} else if (getParentRule() instanceof BRReusableTaskRule) {
			setAvp(((BRReusableTaskRuleImpl)getParentRule()).getAvp());
		}
		
		String rsName = BrUtil.createRuleSetName(businessRuleSet, ruleSet, getAvp(), getContext());
		String baseName = rsName.substring(rsName.lastIndexOf("/") + 1);		
		ruleSet.setName(baseName);
		ruleSet.setTargetNamespace(ProcessUtil.createNamespace(businessRuleSet.getOwningAction(), true));
		//display name and description
		if (businessRuleSet.getOwnedComment() != null && !businessRuleSet.getOwnedComment().isEmpty()) {
			ruleSet.setComment(((Comment)businessRuleSet.getOwnedComment().get(0)).getBody());
		}
		ruleSet.setDisplayName(businessRuleSet.getName());
		
		// set interface
		Interface rsInterface = ModelFactory.eINSTANCE.createInterface();
		Object qName = XMLTypeUtil.createQName(pt.getQName().getNamespaceURI(), pt.getQName().getLocalPart(), "pType"); //$NON-NLS-1$
		rsInterface.setPorttype(qName);
		rsInterface.setOperation(((Operation)pt.getOperations().get(0)).getName());
		ruleSet.setInterface(rsInterface);
		
		//Note: rule group in the set is updated AFTER the rule group is created
		// reset businessruleset for template retrieval in serializer
		BRExpressionSerializer.getInstance().setBusinessRuleSetRule(this);

		createBusinessRuleTemplates(businessRuleSet);
		createBusinessRules(businessRuleSet);

		//process all child targets and add to this ruleset
		processChildTargets(ruleSet);

		DocumentRoot root = ModelFactory.eINSTANCE.createDocumentRoot();
		root.setRuleSet(ruleSet);
		
		getTarget().add(root);
		
//		if(isExpose2BusinessSpace() && isFirstTimeCreateSystemProperty()){
//			ExportOperationUtil.createSystemCustomProperty(ruleSet, ExportOperationConstants.BRR_CUSTOM_PROPERTY_NAME,ExportOperationConstants.TRUE_LIETRAL);
//			setFirstTimeCreateSystemProperty(false);
//		}
		
		setComplete(true);
		
		executeHandlers();
		
		LoggingUtil.traceExit(this, "transformSource2Target");
		return isComplete();		
	}	

	// Create and invoke a collection of BRTemplateRules
	@SuppressWarnings("unchecked")
	private void createBusinessRuleTemplates(BusinessRuleSet businessRuleSet) {
		if (businessRuleSet.getRuleTemplates() == null ||
				businessRuleSet.getRuleTemplates().isEmpty()) {
			return;
		}
		
		Iterator it = businessRuleSet.getRuleTemplates().iterator();
		BusinessRuleTemplate brTemplate = null;
		BRTemplateRule brTemplateRule = null;
		
		while (it.hasNext()) {
			brTemplate = (BusinessRuleTemplate)it.next();
			brTemplateRule = BrFactory.eINSTANCE.createBRTemplateRule();
			brTemplateRule.getSource().add(brTemplate);		// add BusinessRuleTemplate

			getChildRules().add(brTemplateRule);
			
			// Execute the rule set
			brTemplateRule.transformSource2Target();			
		}		
	}
	
	// Create and invoke a collection of BRRules
	@SuppressWarnings("unchecked")
	private void createBusinessRules(BusinessRuleSet businessRuleSet) {
		if (businessRuleSet.getRuleBlocks() == null ||
				businessRuleSet.getRuleBlocks().size() != 1 ||		//only 1 ruleBlock
				businessRuleSet.getRuleBlocks().get(0) == null || 
				((BusinessRuleBlock)businessRuleSet.getRuleBlocks().get(0)).getRules().isEmpty()) {
			return;
		}
		
		Iterator it = ((BusinessRuleBlock)businessRuleSet.getRuleBlocks().get(0)).getRules().iterator();
		BusinessRule businessRule = null;
		BRRule brRule = null;
		
		while (it.hasNext()) {
			businessRule = (BusinessRule)it.next();
			brRule = BrFactory.eINSTANCE.createBRRule();
			brRule.getSource().add(businessRule);		// add BusinessRule

			getChildRules().add(brRule);
			
			// Execute the rule set
			brRule.transformSource2Target();			
		}		
	}

	
	/**
	* Process the targets of the rule. 
	* A BRTemplateRule will process templates and add them to the ruleset.
	* A BRRule will process rules and add them to the ruleset's ruleblock.
	* @param rule a child rule to be processed.  
	*/
	private void processChildTargets(RuleSet rSet){
		if (getChildRules() == null || getChildRules().isEmpty()) {
			return;
		}
		
		Iterator it = getChildRules().iterator();
		
		Object obj = null;
		
		while (it.hasNext()) {
			obj = it.next();
			
			if (obj instanceof BRTemplateRule) {
				addTemplate((BRTemplateRule)obj, rSet);
			} else if (obj instanceof BRRule) {
				addRule((BRRule)obj, rSet);
			}
		}
	}

	// add template to ruleset
	@SuppressWarnings("unchecked")
	private void addTemplate(BRTemplateRule brTemplateRule, RuleSet rSet){
		if (brTemplateRule == null || rSet == null || brTemplateRule.getTarget() == null || brTemplateRule.getTarget().isEmpty()) {
			return;
		}
		rSet.getTemplate().add(brTemplateRule.getTarget().get(0));	//only 1 target - template
	}
	
	// add rule to ruleset
	private void addRule(BRRule brRule, RuleSet rSet){
		if (brRule == null || rSet == null || brRule.getTarget() == null || brRule.getTarget().isEmpty()) {
			return;
		}
		
		((RuleBlock)rSet.getRuleBlock().get(0)).addRule((Rule)brRule.getTarget().get(0));	//only 1 target - template
	}

//	protected boolean isExpose2BusinessSpace() {
//		return expose2BusinessSpace;
//	}
//
//	protected void setExpose2BusinessSpace(boolean expose2BS) {
//		this.expose2BusinessSpace = expose2BS;
//	}
//
//	protected boolean isFirstTimeCreateSystemProperty() {
//		return firstTimeCreateSystemProperty;
//	}
//
//	protected void setFirstTimeCreateSystemProperty(
//			boolean firstTimeCreateSystemProperty) {
//		this.firstTimeCreateSystemProperty = firstTimeCreateSystemProperty;
//	}

} //BRSetRuleImpl