package com.ibm.btools.te.ilm.heuristics.extservice.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import org.eclipse.emf.ecore.EClass;
import org.eclipse.wst.wsdl.Definition;

import com.ibm.btools.bom.model.artifacts.NamedElement;
import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.bom.model.processes.activities.StructuredActivityNode;
import com.ibm.btools.te.framework.impl.TransformationRuleImpl;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.extservice.ExtservicePackage;
import com.ibm.btools.te.ilm.heuristics.extservice.WSDLDefinitionRule;
import com.ibm.btools.te.ilm.heuristics.helper.BomUtils;
import com.ibm.btools.te.ilm.heuristics.wsdl.util.OriginalWsdlUtil;
import com.ibm.btools.te.ilm.resource.MessageKeys;
import com.ibm.btools.te.ilm.resource.TEResourceBundleSingleton;
import com.ibm.btools.util.exception.BTRuntimeException;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>WSDL Definition Rule</b></em>'.
 * Source: ExternalService
 * Target: Original WSDL Definition Retrieved from the internal location
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class WSDLDefinitionRuleImpl extends TransformationRuleImpl implements WSDLDefinitionRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected WSDLDefinitionRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return ExtservicePackage.Literals.WSDL_DEFINITION_RULE;
	}

	/**
	 * Source: BOM NamedElement that is the type of StructuredActivityNode
	 * Target: Original WSDL Definition that is persisted in an internal location
	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target()
	 */
	public boolean transformSource2Target(){
		LoggingUtil.traceExit(this, "transformSource2Target");
		if( isComplete()){
			LoggingUtil.traceExit(this, "transformSource2Target");
			return true;
		}
		if( getSource() == null || getSource().isEmpty()){
			LoggingUtil.traceExit(this, "transformSource2Target");
			return false;
		}
		NamedElement bomSource = (NamedElement)getSource().get(0);
		if(bomSource instanceof Action){
			try{
				Definition originalWSDL= OriginalWsdlUtil.getOriginalWsdl(getContext(),
																		BomUtils.resolveFileAttachment((StructuredActivityNode)bomSource));
				if(originalWSDL != null){
					OriginalWsdlUtil.updateObjectToFilePathRegistry(getContext(), originalWSDL, 
							OriginalWsdlUtil.getTargetFileName(getContext(),BomUtils.resolveFileAttachment((StructuredActivityNode)bomSource)));					
					getTarget().add(originalWSDL);
				}				
			}catch(Exception e){
				String params[]={bomSource.getName()};
				LoggingUtil.logError(MessageKeys.ERROR_RETRIEVING_ORIGINAL_WSDL_DEFINITION, params, e);
				BTRuntimeException runtimeEx = new BTRuntimeException(TEResourceBundleSingleton.INSTANCE.getMessage(MessageKeys.ERROR_RETRIEVING_ORIGINAL_WSDL_DEFINITION));
				runtimeEx.setChainedException(e);			
				throw runtimeEx;
			}
		}
		setComplete(true);
		LoggingUtil.traceExit(this, "transformSource2Target");
		return isComplete();	
	}	
} //WSDLDefinitionRuleImpl
