/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.fdl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see com.ibm.btools.te.ilm.heuristics.fdl.FdlPackage
 * @generated
 */
public interface FdlFactory extends EFactory {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	FdlFactory eINSTANCE = com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Decision Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Decision Rule</em>'.
	 * @generated
	 */
	DecisionRule createDecisionRule();

	/**
	 * Returns a new object of class '<em>Merge Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Merge Rule</em>'.
	 * @generated
	 */
	MergeRule createMergeRule();

	/**
	 * Returns a new object of class '<em>Join Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Join Rule</em>'.
	 * @generated
	 */
	JoinRule createJoinRule();

	/**
	 * Returns a new object of class '<em>Fork Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Fork Rule</em>'.
	 * @generated
	 */
	ForkRule createForkRule();

	/**
	 * Returns a new object of class '<em>Container Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Container Rule</em>'.
	 * @generated
	 */
	ContainerRule createContainerRule();

	/**
	 * Returns a new object of class '<em>SAN Nested Process Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>SAN Nested Process Rule</em>'.
	 * @generated
	 */
	SANNestedProcessRule createSANNestedProcessRule();

	/**
	 * Returns a new object of class '<em>Block Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Block Rule</em>'.
	 * @generated
	 */
	BlockRule createBlockRule();

	/**
	 * Returns a new object of class '<em>SAN Task Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>SAN Task Rule</em>'.
	 * @generated
	 */
	SANTaskRule createSANTaskRule();

	/**
	 * Returns a new object of class '<em>Call Behavior Action Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Call Behavior Action Rule</em>'.
	 * @generated
	 */
	CallBehaviorActionRule createCallBehaviorActionRule();

	/**
	 * Returns a new object of class '<em>Concurrent Branch Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Concurrent Branch Rule</em>'.
	 * @generated
	 */
	ConcurrentBranchRule createConcurrentBranchRule();

	/**
	 * Returns a new object of class '<em>Process Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Process Rule</em>'.
	 * @generated
	 */
	ProcessRule createProcessRule();

	/**
	 * Returns a new object of class '<em>Exclusive Branch Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Exclusive Branch Rule</em>'.
	 * @generated
	 */
	ExclusiveBranchRule createExclusiveBranchRule();

	/**
	 * Returns a new object of class '<em>Flatten Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Flatten Rule</em>'.
	 * @generated
	 */
	FlattenRule createFlattenRule();

	/**
	 * Returns a new object of class '<em>SAN Reusable Process Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>SAN Reusable Process Rule</em>'.
	 * @generated
	 */
	SANReusableProcessRule createSANReusableProcessRule();

	/**
	 * Returns a new object of class '<em>Data Structure Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Data Structure Rule</em>'.
	 * @generated
	 */
	DataStructureRule createDataStructureRule();

	/**
	 * Returns a new object of class '<em>Basic Data Type Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Basic Data Type Rule</em>'.
	 * @generated
	 */
	BasicDataTypeRule createBasicDataTypeRule();

	/**
	 * Returns a new object of class '<em>Data Type Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Data Type Rule</em>'.
	 * @generated
	 */
	DataTypeRule createDataTypeRule();

	/**
	 * Returns a new object of class '<em>Member Decl Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Member Decl Rule</em>'.
	 * @generated
	 */
	MemberDeclRule createMemberDeclRule();

	/**
	 * Returns a new object of class '<em>Data Flow Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Data Flow Rule</em>'.
	 * @generated
	 */
	DataFlowRule createDataFlowRule();

	/**
	 * Returns a new object of class '<em>Flow Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Flow Rule</em>'.
	 * @generated
	 */
	FlowRule createFlowRule();

	/**
	 * Returns a new object of class '<em>Activity Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Activity Rule</em>'.
	 * @generated
	 */
	ActivityRule createActivityRule();

	/**
	 * Returns a new object of class '<em>Data Mapping Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Data Mapping Rule</em>'.
	 * @generated
	 */
	DataMappingRule createDataMappingRule();

	/**
	 * Returns a new object of class '<em>Program Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Program Rule</em>'.
	 * @generated
	 */
	ProgramRule createProgramRule();

	/**
	 * Returns a new object of class '<em>Category Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Category Rule</em>'.
	 * @generated
	 */
	CategoryRule createCategoryRule();

	/**
	 * Returns a new object of class '<em>Retrieve Datastore Artifact Pin Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Retrieve Datastore Artifact Pin Rule</em>'.
	 * @generated
	 */
	RetrieveDatastoreArtifactPinRule createRetrieveDatastoreArtifactPinRule();

	/**
	 * Returns a new object of class '<em>Retrieve Datastore Artifact Action Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Retrieve Datastore Artifact Action Rule</em>'.
	 * @generated
	 */
	RetrieveDatastoreArtifactActionRule createRetrieveDatastoreArtifactActionRule();

	/**
	 * Returns a new object of class '<em>Store Datastore Artifact Pin Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Store Datastore Artifact Pin Rule</em>'.
	 * @generated
	 */
	StoreDatastoreArtifactPinRule createStoreDatastoreArtifactPinRule();

	/**
	 * Returns a new object of class '<em>Store Datastore Artifact Action Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Store Datastore Artifact Action Rule</em>'.
	 * @generated
	 */
	StoreDatastoreArtifactActionRule createStoreDatastoreArtifactActionRule();

	/**
	 * Returns a new object of class '<em>Datastore Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Datastore Rule</em>'.
	 * @generated
	 */
	DatastoreRule createDatastoreRule();

	/**
	 * Returns a new object of class '<em>Call Operation Action Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Call Operation Action Rule</em>'.
	 * @generated
	 */
	CallOperationActionRule createCallOperationActionRule();

	/**
	 * Returns a new object of class '<em>SAN Reusable Task Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>SAN Reusable Task Rule</em>'.
	 * @generated
	 */
	SANReusableTaskRule createSANReusableTaskRule();

	/**
	 * Returns a new object of class '<em>Loop Node Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Loop Node Rule</em>'.
	 * @generated
	 */
	LoopNodeRule createLoopNodeRule();

	/**
	 * Returns a new object of class '<em>Expression Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Expression Rule</em>'.
	 * @generated
	 */
	ExpressionRule createExpressionRule();

	/**
	 * Returns a new object of class '<em>Organization Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Organization Rule</em>'.
	 * @generated
	 */
	OrganizationRule createOrganizationRule();

	/**
	 * Returns a new object of class '<em>Person Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Person Rule</em>'.
	 * @generated
	 */
	PersonRule createPersonRule();

	/**
	 * Returns a new object of class '<em>Staff Assignment Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Staff Assignment Rule</em>'.
	 * @generated
	 */
	StaffAssignmentRule createStaffAssignmentRule();

	/**
	 * Returns a new object of class '<em>FDL Optimization Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>FDL Optimization Rule</em>'.
	 * @generated
	 */
	FDLOptimizationRule createFDLOptimizationRule();

	/**
	 * Returns a new object of class '<em>Map Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Map Rule</em>'.
	 * @generated
	 */
	MapRule createMapRule();

	/**
	 * Returns a new object of class '<em>Role Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Role Rule</em>'.
	 * @generated
	 */
	RoleRule createRoleRule();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	FdlPackage getFdlPackage();

} //ModelFactory
