/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.fdl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import com.ibm.btools.te.framework.FrameworkPackage;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.ibm.btools.te.ilm.heuristics.fdl.FdlFactory
 * @model kind="package"
 * @generated
 */
public interface FdlPackage extends EPackage {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "fdl";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///heuristics/fdl.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "heuristics.fdl";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	FdlPackage eINSTANCE = com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.AbstractFdlProcDefRuleImpl <em>Abstract Fdl Proc Def Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.AbstractFdlProcDefRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getAbstractFdlProcDefRule()
	 * @generated
	 */
	int ABSTRACT_FDL_PROC_DEF_RULE = 17;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FDL_PROC_DEF_RULE__COMPLETE = FrameworkPackage.TRANSFORMATION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FDL_PROC_DEF_RULE__FAILED = FrameworkPackage.TRANSFORMATION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FDL_PROC_DEF_RULE__CHILD_RULES = FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FDL_PROC_DEF_RULE__PARENT_RULE = FrameworkPackage.TRANSFORMATION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FDL_PROC_DEF_RULE__TARGET = FrameworkPackage.TRANSFORMATION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FDL_PROC_DEF_RULE__SOURCE = FrameworkPackage.TRANSFORMATION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FDL_PROC_DEF_RULE__ROOT = FrameworkPackage.TRANSFORMATION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Abstract Fdl Proc Def Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FDL_PROC_DEF_RULE_FEATURE_COUNT = FrameworkPackage.TRANSFORMATION_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ControlActionRuleImpl <em>Control Action Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ControlActionRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getControlActionRule()
	 * @generated
	 */
	int CONTROL_ACTION_RULE = 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.DecisionRuleImpl <em>Decision Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.DecisionRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getDecisionRule()
	 * @generated
	 */
	int DECISION_RULE = 1;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.MergeRuleImpl <em>Merge Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.MergeRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getMergeRule()
	 * @generated
	 */
	int MERGE_RULE = 2;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.JoinRuleImpl <em>Join Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.JoinRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getJoinRule()
	 * @generated
	 */
	int JOIN_RULE = 3;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ForkRuleImpl <em>Fork Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ForkRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getForkRule()
	 * @generated
	 */
	int FORK_RULE = 4;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ContainerRuleImpl <em>Container Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ContainerRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getContainerRule()
	 * @generated
	 */
	int CONTAINER_RULE = 5;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ConnectorRuleImpl <em>Connector Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ConnectorRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getConnectorRule()
	 * @generated
	 */
	int CONNECTOR_RULE = 6;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.SANNestedProcessRuleImpl <em>SAN Nested Process Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.SANNestedProcessRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getSANNestedProcessRule()
	 * @generated
	 */
	int SAN_NESTED_PROCESS_RULE = 7;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ConnectableRuleImpl <em>Connectable Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ConnectableRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getConnectableRule()
	 * @generated
	 */
	int CONNECTABLE_RULE = 8;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.BlockRuleImpl <em>Block Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.BlockRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getBlockRule()
	 * @generated
	 */
	int BLOCK_RULE = 9;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.CallBehaviorActionRuleImpl <em>Call Behavior Action Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.CallBehaviorActionRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getCallBehaviorActionRule()
	 * @generated
	 */
	int CALL_BEHAVIOR_ACTION_RULE = 11;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ProcessWalkingRuleImpl <em>Process Walking Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ProcessWalkingRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getProcessWalkingRule()
	 * @generated
	 */
	int PROCESS_WALKING_RULE = 12;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ConcurrentBranchRuleImpl <em>Concurrent Branch Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ConcurrentBranchRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getConcurrentBranchRule()
	 * @generated
	 */
	int CONCURRENT_BRANCH_RULE = 13;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ProcessRuleImpl <em>Process Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ProcessRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getProcessRule()
	 * @generated
	 */
	int PROCESS_RULE = 14;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ExclusiveBranchRuleImpl <em>Exclusive Branch Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ExclusiveBranchRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getExclusiveBranchRule()
	 * @generated
	 */
	int EXCLUSIVE_BRANCH_RULE = 15;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.FlattenRuleImpl <em>Flatten Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FlattenRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getFlattenRule()
	 * @generated
	 */
	int FLATTEN_RULE = 16;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.SANReusableProcessRuleImpl <em>SAN Reusable Process Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.SANReusableProcessRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getSANReusableProcessRule()
	 * @generated
	 */
	int SAN_REUSABLE_PROCESS_RULE = 18;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.AbstractFdlDataStructRuleImpl <em>Abstract Fdl Data Struct Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.AbstractFdlDataStructRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getAbstractFdlDataStructRule()
	 * @generated
	 */
	int ABSTRACT_FDL_DATA_STRUCT_RULE = 19;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTABLE_RULE__COMPLETE = ABSTRACT_FDL_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTABLE_RULE__FAILED = ABSTRACT_FDL_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTABLE_RULE__CHILD_RULES = ABSTRACT_FDL_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTABLE_RULE__PARENT_RULE = ABSTRACT_FDL_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTABLE_RULE__TARGET = ABSTRACT_FDL_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTABLE_RULE__SOURCE = ABSTRACT_FDL_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTABLE_RULE__ROOT = ABSTRACT_FDL_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Connectable Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTABLE_RULE_FEATURE_COUNT = ABSTRACT_FDL_PROC_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_ACTION_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_ACTION_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_ACTION_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_ACTION_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_ACTION_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_ACTION_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_ACTION_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Control Action Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_ACTION_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_RULE__COMPLETE = CONTROL_ACTION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_RULE__FAILED = CONTROL_ACTION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_RULE__CHILD_RULES = CONTROL_ACTION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_RULE__PARENT_RULE = CONTROL_ACTION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_RULE__TARGET = CONTROL_ACTION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_RULE__SOURCE = CONTROL_ACTION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_RULE__ROOT = CONTROL_ACTION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Decision Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_RULE_FEATURE_COUNT = CONTROL_ACTION_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MERGE_RULE__COMPLETE = CONTROL_ACTION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MERGE_RULE__FAILED = CONTROL_ACTION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MERGE_RULE__CHILD_RULES = CONTROL_ACTION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MERGE_RULE__PARENT_RULE = CONTROL_ACTION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MERGE_RULE__TARGET = CONTROL_ACTION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MERGE_RULE__SOURCE = CONTROL_ACTION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MERGE_RULE__ROOT = CONTROL_ACTION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Merge Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MERGE_RULE_FEATURE_COUNT = CONTROL_ACTION_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JOIN_RULE__COMPLETE = CONTROL_ACTION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JOIN_RULE__FAILED = CONTROL_ACTION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JOIN_RULE__CHILD_RULES = CONTROL_ACTION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JOIN_RULE__PARENT_RULE = CONTROL_ACTION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JOIN_RULE__TARGET = CONTROL_ACTION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JOIN_RULE__SOURCE = CONTROL_ACTION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JOIN_RULE__ROOT = CONTROL_ACTION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Join Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JOIN_RULE_FEATURE_COUNT = CONTROL_ACTION_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_RULE__COMPLETE = CONTROL_ACTION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_RULE__FAILED = CONTROL_ACTION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_RULE__CHILD_RULES = CONTROL_ACTION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_RULE__PARENT_RULE = CONTROL_ACTION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_RULE__TARGET = CONTROL_ACTION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_RULE__SOURCE = CONTROL_ACTION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_RULE__ROOT = CONTROL_ACTION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Fork Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_RULE_FEATURE_COUNT = CONTROL_ACTION_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FDL_DATA_STRUCT_RULE__COMPLETE = FrameworkPackage.TRANSFORMATION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FDL_DATA_STRUCT_RULE__FAILED = FrameworkPackage.TRANSFORMATION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FDL_DATA_STRUCT_RULE__CHILD_RULES = FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FDL_DATA_STRUCT_RULE__PARENT_RULE = FrameworkPackage.TRANSFORMATION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FDL_DATA_STRUCT_RULE__TARGET = FrameworkPackage.TRANSFORMATION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FDL_DATA_STRUCT_RULE__SOURCE = FrameworkPackage.TRANSFORMATION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FDL_DATA_STRUCT_RULE__ROOT = FrameworkPackage.TRANSFORMATION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Abstract Fdl Data Struct Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FDL_DATA_STRUCT_RULE_FEATURE_COUNT = FrameworkPackage.TRANSFORMATION_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_RULE__COMPLETE = ABSTRACT_FDL_DATA_STRUCT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_RULE__FAILED = ABSTRACT_FDL_DATA_STRUCT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_RULE__CHILD_RULES = ABSTRACT_FDL_DATA_STRUCT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_RULE__PARENT_RULE = ABSTRACT_FDL_DATA_STRUCT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_RULE__TARGET = ABSTRACT_FDL_DATA_STRUCT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_RULE__SOURCE = ABSTRACT_FDL_DATA_STRUCT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_RULE__ROOT = ABSTRACT_FDL_DATA_STRUCT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Container Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_RULE_FEATURE_COUNT = ABSTRACT_FDL_DATA_STRUCT_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_RULE__COMPLETE = ABSTRACT_FDL_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_RULE__FAILED = ABSTRACT_FDL_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_RULE__CHILD_RULES = ABSTRACT_FDL_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_RULE__PARENT_RULE = ABSTRACT_FDL_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_RULE__TARGET = ABSTRACT_FDL_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_RULE__SOURCE = ABSTRACT_FDL_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_RULE__ROOT = ABSTRACT_FDL_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Connector Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_RULE_FEATURE_COUNT = ABSTRACT_FDL_PROC_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_NESTED_PROCESS_RULE__COMPLETE = ABSTRACT_FDL_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_NESTED_PROCESS_RULE__FAILED = ABSTRACT_FDL_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_NESTED_PROCESS_RULE__CHILD_RULES = ABSTRACT_FDL_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_NESTED_PROCESS_RULE__PARENT_RULE = ABSTRACT_FDL_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_NESTED_PROCESS_RULE__TARGET = ABSTRACT_FDL_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_NESTED_PROCESS_RULE__SOURCE = ABSTRACT_FDL_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_NESTED_PROCESS_RULE__ROOT = ABSTRACT_FDL_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>SAN Nested Process Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_NESTED_PROCESS_RULE_FEATURE_COUNT = ABSTRACT_FDL_PROC_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ContainmentRuleImpl <em>Containment Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ContainmentRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getContainmentRule()
	 * @generated
	 */
	int CONTAINMENT_RULE = 28;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.SANTaskRuleImpl <em>SAN Task Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.SANTaskRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getSANTaskRule()
	 * @generated
	 */
	int SAN_TASK_RULE = 10;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Containment Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK_RULE__COMPLETE = CONTAINMENT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK_RULE__FAILED = CONTAINMENT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK_RULE__CHILD_RULES = CONTAINMENT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK_RULE__PARENT_RULE = CONTAINMENT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK_RULE__TARGET = CONTAINMENT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK_RULE__SOURCE = CONTAINMENT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK_RULE__ROOT = CONTAINMENT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Block Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK_RULE_FEATURE_COUNT = CONTAINMENT_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_TASK_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_TASK_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_TASK_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_TASK_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_TASK_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_TASK_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_TASK_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>SAN Task Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_TASK_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_BEHAVIOR_ACTION_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_BEHAVIOR_ACTION_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_BEHAVIOR_ACTION_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_BEHAVIOR_ACTION_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_BEHAVIOR_ACTION_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_BEHAVIOR_ACTION_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_BEHAVIOR_ACTION_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Call Behavior Action Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_BEHAVIOR_ACTION_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_WALKING_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_WALKING_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_WALKING_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_WALKING_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_WALKING_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_WALKING_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_WALKING_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Process Walking Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_WALKING_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCURRENT_BRANCH_RULE__COMPLETE = PROCESS_WALKING_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCURRENT_BRANCH_RULE__FAILED = PROCESS_WALKING_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCURRENT_BRANCH_RULE__CHILD_RULES = PROCESS_WALKING_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCURRENT_BRANCH_RULE__PARENT_RULE = PROCESS_WALKING_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCURRENT_BRANCH_RULE__TARGET = PROCESS_WALKING_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCURRENT_BRANCH_RULE__SOURCE = PROCESS_WALKING_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCURRENT_BRANCH_RULE__ROOT = PROCESS_WALKING_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Concurrent Branch Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCURRENT_BRANCH_RULE_FEATURE_COUNT = PROCESS_WALKING_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_RULE__COMPLETE = PROCESS_WALKING_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_RULE__FAILED = PROCESS_WALKING_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_RULE__CHILD_RULES = PROCESS_WALKING_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_RULE__PARENT_RULE = PROCESS_WALKING_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_RULE__TARGET = PROCESS_WALKING_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_RULE__SOURCE = PROCESS_WALKING_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_RULE__ROOT = PROCESS_WALKING_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Process Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_RULE_FEATURE_COUNT = PROCESS_WALKING_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXCLUSIVE_BRANCH_RULE__COMPLETE = PROCESS_WALKING_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXCLUSIVE_BRANCH_RULE__FAILED = PROCESS_WALKING_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXCLUSIVE_BRANCH_RULE__CHILD_RULES = PROCESS_WALKING_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXCLUSIVE_BRANCH_RULE__PARENT_RULE = PROCESS_WALKING_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXCLUSIVE_BRANCH_RULE__TARGET = PROCESS_WALKING_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXCLUSIVE_BRANCH_RULE__SOURCE = PROCESS_WALKING_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXCLUSIVE_BRANCH_RULE__ROOT = PROCESS_WALKING_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Exclusive Branch Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXCLUSIVE_BRANCH_RULE_FEATURE_COUNT = PROCESS_WALKING_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLATTEN_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLATTEN_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLATTEN_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLATTEN_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLATTEN_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLATTEN_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLATTEN_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Flatten Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLATTEN_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_PROCESS_RULE__COMPLETE = CONTAINMENT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_PROCESS_RULE__FAILED = CONTAINMENT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_PROCESS_RULE__CHILD_RULES = CONTAINMENT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_PROCESS_RULE__PARENT_RULE = CONTAINMENT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_PROCESS_RULE__TARGET = CONTAINMENT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_PROCESS_RULE__SOURCE = CONTAINMENT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_PROCESS_RULE__ROOT = CONTAINMENT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>SAN Reusable Process Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_PROCESS_RULE_FEATURE_COUNT = CONTAINMENT_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.DataStructureRuleImpl <em>Data Structure Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.DataStructureRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getDataStructureRule()
	 * @generated
	 */
	int DATA_STRUCTURE_RULE = 20;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_STRUCTURE_RULE__COMPLETE = ABSTRACT_FDL_DATA_STRUCT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_STRUCTURE_RULE__FAILED = ABSTRACT_FDL_DATA_STRUCT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_STRUCTURE_RULE__CHILD_RULES = ABSTRACT_FDL_DATA_STRUCT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_STRUCTURE_RULE__PARENT_RULE = ABSTRACT_FDL_DATA_STRUCT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_STRUCTURE_RULE__TARGET = ABSTRACT_FDL_DATA_STRUCT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_STRUCTURE_RULE__SOURCE = ABSTRACT_FDL_DATA_STRUCT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_STRUCTURE_RULE__ROOT = ABSTRACT_FDL_DATA_STRUCT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Data Structure Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_STRUCTURE_RULE_FEATURE_COUNT = ABSTRACT_FDL_DATA_STRUCT_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.BasicDataTypeRuleImpl <em>Basic Data Type Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.BasicDataTypeRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getBasicDataTypeRule()
	 * @generated
	 */
	int BASIC_DATA_TYPE_RULE = 21;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_DATA_TYPE_RULE__COMPLETE = ABSTRACT_FDL_DATA_STRUCT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_DATA_TYPE_RULE__FAILED = ABSTRACT_FDL_DATA_STRUCT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_DATA_TYPE_RULE__CHILD_RULES = ABSTRACT_FDL_DATA_STRUCT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_DATA_TYPE_RULE__PARENT_RULE = ABSTRACT_FDL_DATA_STRUCT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_DATA_TYPE_RULE__TARGET = ABSTRACT_FDL_DATA_STRUCT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_DATA_TYPE_RULE__SOURCE = ABSTRACT_FDL_DATA_STRUCT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_DATA_TYPE_RULE__ROOT = ABSTRACT_FDL_DATA_STRUCT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Basic Data Type Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_DATA_TYPE_RULE_FEATURE_COUNT = ABSTRACT_FDL_DATA_STRUCT_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.DataTypeRuleImpl <em>Data Type Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.DataTypeRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getDataTypeRule()
	 * @generated
	 */
	int DATA_TYPE_RULE = 22;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_RULE__COMPLETE = ABSTRACT_FDL_DATA_STRUCT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_RULE__FAILED = ABSTRACT_FDL_DATA_STRUCT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_RULE__CHILD_RULES = ABSTRACT_FDL_DATA_STRUCT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_RULE__PARENT_RULE = ABSTRACT_FDL_DATA_STRUCT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_RULE__TARGET = ABSTRACT_FDL_DATA_STRUCT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_RULE__SOURCE = ABSTRACT_FDL_DATA_STRUCT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_RULE__ROOT = ABSTRACT_FDL_DATA_STRUCT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Data Type Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_RULE_FEATURE_COUNT = ABSTRACT_FDL_DATA_STRUCT_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.MemberDeclRuleImpl <em>Member Decl Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.MemberDeclRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getMemberDeclRule()
	 * @generated
	 */
	int MEMBER_DECL_RULE = 23;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMBER_DECL_RULE__COMPLETE = ABSTRACT_FDL_DATA_STRUCT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMBER_DECL_RULE__FAILED = ABSTRACT_FDL_DATA_STRUCT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMBER_DECL_RULE__CHILD_RULES = ABSTRACT_FDL_DATA_STRUCT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMBER_DECL_RULE__PARENT_RULE = ABSTRACT_FDL_DATA_STRUCT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMBER_DECL_RULE__TARGET = ABSTRACT_FDL_DATA_STRUCT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMBER_DECL_RULE__SOURCE = ABSTRACT_FDL_DATA_STRUCT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMBER_DECL_RULE__ROOT = ABSTRACT_FDL_DATA_STRUCT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Member Decl Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMBER_DECL_RULE_FEATURE_COUNT = ABSTRACT_FDL_DATA_STRUCT_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.DataFlowRuleImpl <em>Data Flow Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.DataFlowRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getDataFlowRule()
	 * @generated
	 */
	int DATA_FLOW_RULE = 24;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_RULE__COMPLETE = CONNECTOR_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_RULE__FAILED = CONNECTOR_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_RULE__CHILD_RULES = CONNECTOR_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_RULE__PARENT_RULE = CONNECTOR_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_RULE__TARGET = CONNECTOR_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_RULE__SOURCE = CONNECTOR_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_RULE__ROOT = CONNECTOR_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Data Flow Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_RULE_FEATURE_COUNT = CONNECTOR_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.FlowRuleImpl <em>Flow Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FlowRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getFlowRule()
	 * @generated
	 */
	int FLOW_RULE = 25;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_RULE__COMPLETE = CONNECTOR_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_RULE__FAILED = CONNECTOR_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_RULE__CHILD_RULES = CONNECTOR_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_RULE__PARENT_RULE = CONNECTOR_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_RULE__TARGET = CONNECTOR_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_RULE__SOURCE = CONNECTOR_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_RULE__ROOT = CONNECTOR_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Flow Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_RULE_FEATURE_COUNT = CONNECTOR_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ActivityRuleImpl <em>Activity Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ActivityRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getActivityRule()
	 * @generated
	 */
	int ACTIVITY_RULE = 26;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_RULE__COMPLETE = ABSTRACT_FDL_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_RULE__FAILED = ABSTRACT_FDL_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_RULE__CHILD_RULES = ABSTRACT_FDL_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_RULE__PARENT_RULE = ABSTRACT_FDL_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_RULE__TARGET = ABSTRACT_FDL_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_RULE__SOURCE = ABSTRACT_FDL_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_RULE__ROOT = ABSTRACT_FDL_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Activity Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_RULE_FEATURE_COUNT = ABSTRACT_FDL_PROC_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.DataMappingRuleImpl <em>Data Mapping Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.DataMappingRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getDataMappingRule()
	 * @generated
	 */
	int DATA_MAPPING_RULE = 27;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_MAPPING_RULE__COMPLETE = ABSTRACT_FDL_DATA_STRUCT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_MAPPING_RULE__FAILED = ABSTRACT_FDL_DATA_STRUCT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_MAPPING_RULE__CHILD_RULES = ABSTRACT_FDL_DATA_STRUCT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_MAPPING_RULE__PARENT_RULE = ABSTRACT_FDL_DATA_STRUCT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_MAPPING_RULE__TARGET = ABSTRACT_FDL_DATA_STRUCT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_MAPPING_RULE__SOURCE = ABSTRACT_FDL_DATA_STRUCT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_MAPPING_RULE__ROOT = ABSTRACT_FDL_DATA_STRUCT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Data Mapping Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_MAPPING_RULE_FEATURE_COUNT = ABSTRACT_FDL_DATA_STRUCT_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ProgramRuleImpl <em>Program Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ProgramRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getProgramRule()
	 * @generated
	 */
	int PROGRAM_RULE = 29;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROGRAM_RULE__COMPLETE = ABSTRACT_FDL_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROGRAM_RULE__FAILED = ABSTRACT_FDL_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROGRAM_RULE__CHILD_RULES = ABSTRACT_FDL_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROGRAM_RULE__PARENT_RULE = ABSTRACT_FDL_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROGRAM_RULE__TARGET = ABSTRACT_FDL_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROGRAM_RULE__SOURCE = ABSTRACT_FDL_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROGRAM_RULE__ROOT = ABSTRACT_FDL_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Program Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROGRAM_RULE_FEATURE_COUNT = ABSTRACT_FDL_PROC_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.CategoryRuleImpl <em>Category Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.CategoryRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getCategoryRule()
	 * @generated
	 */
	int CATEGORY_RULE = 30;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORY_RULE__COMPLETE = ABSTRACT_FDL_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORY_RULE__FAILED = ABSTRACT_FDL_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORY_RULE__CHILD_RULES = ABSTRACT_FDL_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORY_RULE__PARENT_RULE = ABSTRACT_FDL_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORY_RULE__TARGET = ABSTRACT_FDL_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORY_RULE__SOURCE = ABSTRACT_FDL_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORY_RULE__ROOT = ABSTRACT_FDL_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Category Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORY_RULE_FEATURE_COUNT = ABSTRACT_FDL_PROC_DEF_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.RetrieveDatastoreArtifactRuleImpl <em>Retrieve Datastore Artifact Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.RetrieveDatastoreArtifactRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getRetrieveDatastoreArtifactRule()
	 * @generated
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_RULE = 36;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Retrieve Datastore Artifact Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.RetrieveDatastoreArtifactPinRuleImpl <em>Retrieve Datastore Artifact Pin Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.RetrieveDatastoreArtifactPinRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getRetrieveDatastoreArtifactPinRule()
	 * @generated
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_PIN_RULE = 31;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_PIN_RULE__COMPLETE = RETRIEVE_DATASTORE_ARTIFACT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_PIN_RULE__FAILED = RETRIEVE_DATASTORE_ARTIFACT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_PIN_RULE__CHILD_RULES = RETRIEVE_DATASTORE_ARTIFACT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_PIN_RULE__PARENT_RULE = RETRIEVE_DATASTORE_ARTIFACT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_PIN_RULE__TARGET = RETRIEVE_DATASTORE_ARTIFACT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_PIN_RULE__SOURCE = RETRIEVE_DATASTORE_ARTIFACT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_PIN_RULE__ROOT = RETRIEVE_DATASTORE_ARTIFACT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Retrieve Datastore Artifact Pin Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_PIN_RULE_FEATURE_COUNT = RETRIEVE_DATASTORE_ARTIFACT_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.RetrieveDatastoreArtifactActionRuleImpl <em>Retrieve Datastore Artifact Action Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.RetrieveDatastoreArtifactActionRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getRetrieveDatastoreArtifactActionRule()
	 * @generated
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_ACTION_RULE = 32;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_ACTION_RULE__COMPLETE = RETRIEVE_DATASTORE_ARTIFACT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_ACTION_RULE__FAILED = RETRIEVE_DATASTORE_ARTIFACT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_ACTION_RULE__CHILD_RULES = RETRIEVE_DATASTORE_ARTIFACT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_ACTION_RULE__PARENT_RULE = RETRIEVE_DATASTORE_ARTIFACT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_ACTION_RULE__TARGET = RETRIEVE_DATASTORE_ARTIFACT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_ACTION_RULE__SOURCE = RETRIEVE_DATASTORE_ARTIFACT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_ACTION_RULE__ROOT = RETRIEVE_DATASTORE_ARTIFACT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Retrieve Datastore Artifact Action Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETRIEVE_DATASTORE_ARTIFACT_ACTION_RULE_FEATURE_COUNT = RETRIEVE_DATASTORE_ARTIFACT_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.StoreDatastoreArtifactRuleImpl <em>Store Datastore Artifact Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.StoreDatastoreArtifactRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getStoreDatastoreArtifactRule()
	 * @generated
	 */
	int STORE_DATASTORE_ARTIFACT_RULE = 37;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Store Datastore Artifact Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.StoreDatastoreArtifactPinRuleImpl <em>Store Datastore Artifact Pin Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.StoreDatastoreArtifactPinRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getStoreDatastoreArtifactPinRule()
	 * @generated
	 */
	int STORE_DATASTORE_ARTIFACT_PIN_RULE = 33;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_PIN_RULE__COMPLETE = STORE_DATASTORE_ARTIFACT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_PIN_RULE__FAILED = STORE_DATASTORE_ARTIFACT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_PIN_RULE__CHILD_RULES = STORE_DATASTORE_ARTIFACT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_PIN_RULE__PARENT_RULE = STORE_DATASTORE_ARTIFACT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_PIN_RULE__TARGET = STORE_DATASTORE_ARTIFACT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_PIN_RULE__SOURCE = STORE_DATASTORE_ARTIFACT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_PIN_RULE__ROOT = STORE_DATASTORE_ARTIFACT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Store Datastore Artifact Pin Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_PIN_RULE_FEATURE_COUNT = STORE_DATASTORE_ARTIFACT_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.StoreDatastoreArtifactActionRuleImpl <em>Store Datastore Artifact Action Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.StoreDatastoreArtifactActionRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getStoreDatastoreArtifactActionRule()
	 * @generated
	 */
	int STORE_DATASTORE_ARTIFACT_ACTION_RULE = 34;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_ACTION_RULE__COMPLETE = STORE_DATASTORE_ARTIFACT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_ACTION_RULE__FAILED = STORE_DATASTORE_ARTIFACT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_ACTION_RULE__CHILD_RULES = STORE_DATASTORE_ARTIFACT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_ACTION_RULE__PARENT_RULE = STORE_DATASTORE_ARTIFACT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_ACTION_RULE__TARGET = STORE_DATASTORE_ARTIFACT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_ACTION_RULE__SOURCE = STORE_DATASTORE_ARTIFACT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_ACTION_RULE__ROOT = STORE_DATASTORE_ARTIFACT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Store Datastore Artifact Action Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORE_DATASTORE_ARTIFACT_ACTION_RULE_FEATURE_COUNT = STORE_DATASTORE_ARTIFACT_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.DatastoreRuleImpl <em>Datastore Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.DatastoreRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getDatastoreRule()
	 * @generated
	 */
	int DATASTORE_RULE = 35;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_RULE__COMPLETE = ABSTRACT_FDL_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_RULE__FAILED = ABSTRACT_FDL_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_RULE__CHILD_RULES = ABSTRACT_FDL_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_RULE__PARENT_RULE = ABSTRACT_FDL_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_RULE__TARGET = ABSTRACT_FDL_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_RULE__SOURCE = ABSTRACT_FDL_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_RULE__ROOT = ABSTRACT_FDL_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Datastore Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATASTORE_RULE_FEATURE_COUNT = ABSTRACT_FDL_PROC_DEF_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.CallOperationActionRuleImpl <em>Call Operation Action Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.CallOperationActionRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getCallOperationActionRule()
	 * @generated
	 */
	int CALL_OPERATION_ACTION_RULE = 38;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_OPERATION_ACTION_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_OPERATION_ACTION_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_OPERATION_ACTION_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_OPERATION_ACTION_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_OPERATION_ACTION_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_OPERATION_ACTION_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_OPERATION_ACTION_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Call Operation Action Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_OPERATION_ACTION_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.SANReusableTaskRuleImpl <em>SAN Reusable Task Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.SANReusableTaskRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getSANReusableTaskRule()
	 * @generated
	 */
	int SAN_REUSABLE_TASK_RULE = 39;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_TASK_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_TASK_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_TASK_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_TASK_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_TASK_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_TASK_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_TASK_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>SAN Reusable Task Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAN_REUSABLE_TASK_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.LoopNodeRuleImpl <em>Loop Node Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.LoopNodeRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getLoopNodeRule()
	 * @generated
	 */
	int LOOP_NODE_RULE = 40;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_NODE_RULE__COMPLETE = BLOCK_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_NODE_RULE__FAILED = BLOCK_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_NODE_RULE__CHILD_RULES = BLOCK_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_NODE_RULE__PARENT_RULE = BLOCK_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_NODE_RULE__TARGET = BLOCK_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_NODE_RULE__SOURCE = BLOCK_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_NODE_RULE__ROOT = BLOCK_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Loop Node Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_NODE_RULE_FEATURE_COUNT = BLOCK_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ExpressionRuleImpl <em>Expression Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ExpressionRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getExpressionRule()
	 * @generated
	 */
	int EXPRESSION_RULE = 41;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_RULE__COMPLETE = ABSTRACT_FDL_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_RULE__FAILED = ABSTRACT_FDL_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_RULE__CHILD_RULES = ABSTRACT_FDL_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_RULE__PARENT_RULE = ABSTRACT_FDL_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_RULE__TARGET = ABSTRACT_FDL_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_RULE__SOURCE = ABSTRACT_FDL_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_RULE__ROOT = ABSTRACT_FDL_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Expression Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_RULE_FEATURE_COUNT = ABSTRACT_FDL_PROC_DEF_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.OrganizationRuleImpl <em>Organization Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.OrganizationRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getOrganizationRule()
	 * @generated
	 */
	int ORGANIZATION_RULE = 43;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.PersonRuleImpl <em>Person Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.PersonRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getPersonRule()
	 * @generated
	 */
	int PERSON_RULE = 44;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.StaffAssignmentRuleImpl <em>Staff Assignment Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.StaffAssignmentRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getStaffAssignmentRule()
	 * @generated
	 */
	int STAFF_ASSIGNMENT_RULE = 46;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.MapRuleImpl <em>Map Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.MapRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getMapRule()
	 * @generated
	 */
	int MAP_RULE = 42;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_RULE__COMPLETE = CONNECTABLE_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_RULE__FAILED = CONNECTABLE_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_RULE__CHILD_RULES = CONNECTABLE_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_RULE__PARENT_RULE = CONNECTABLE_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_RULE__TARGET = CONNECTABLE_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_RULE__SOURCE = CONNECTABLE_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_RULE__ROOT = CONNECTABLE_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Map Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_RULE_FEATURE_COUNT = CONNECTABLE_RULE_FEATURE_COUNT + 0;


	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ORGANIZATION_RULE__COMPLETE = ABSTRACT_FDL_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ORGANIZATION_RULE__FAILED = ABSTRACT_FDL_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ORGANIZATION_RULE__CHILD_RULES = ABSTRACT_FDL_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ORGANIZATION_RULE__PARENT_RULE = ABSTRACT_FDL_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ORGANIZATION_RULE__TARGET = ABSTRACT_FDL_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ORGANIZATION_RULE__SOURCE = ABSTRACT_FDL_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ORGANIZATION_RULE__ROOT = ABSTRACT_FDL_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Organization Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ORGANIZATION_RULE_FEATURE_COUNT = ABSTRACT_FDL_PROC_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERSON_RULE__COMPLETE = ABSTRACT_FDL_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERSON_RULE__FAILED = ABSTRACT_FDL_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERSON_RULE__CHILD_RULES = ABSTRACT_FDL_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERSON_RULE__PARENT_RULE = ABSTRACT_FDL_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERSON_RULE__TARGET = ABSTRACT_FDL_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERSON_RULE__SOURCE = ABSTRACT_FDL_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERSON_RULE__ROOT = ABSTRACT_FDL_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Person Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERSON_RULE_FEATURE_COUNT = ABSTRACT_FDL_PROC_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.RoleRuleImpl <em>Role Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.RoleRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getRoleRule()
	 * @generated
	 */
	int ROLE_RULE = 45;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_RULE__COMPLETE = ABSTRACT_FDL_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_RULE__FAILED = ABSTRACT_FDL_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_RULE__CHILD_RULES = ABSTRACT_FDL_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_RULE__PARENT_RULE = ABSTRACT_FDL_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_RULE__TARGET = ABSTRACT_FDL_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_RULE__SOURCE = ABSTRACT_FDL_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_RULE__ROOT = ABSTRACT_FDL_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Role Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_RULE_FEATURE_COUNT = ABSTRACT_FDL_PROC_DEF_RULE_FEATURE_COUNT + 0;


	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAFF_ASSIGNMENT_RULE__COMPLETE = ABSTRACT_FDL_PROC_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAFF_ASSIGNMENT_RULE__FAILED = ABSTRACT_FDL_PROC_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAFF_ASSIGNMENT_RULE__CHILD_RULES = ABSTRACT_FDL_PROC_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAFF_ASSIGNMENT_RULE__PARENT_RULE = ABSTRACT_FDL_PROC_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAFF_ASSIGNMENT_RULE__TARGET = ABSTRACT_FDL_PROC_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAFF_ASSIGNMENT_RULE__SOURCE = ABSTRACT_FDL_PROC_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAFF_ASSIGNMENT_RULE__ROOT = ABSTRACT_FDL_PROC_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Staff Assignment Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAFF_ASSIGNMENT_RULE_FEATURE_COUNT = ABSTRACT_FDL_PROC_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.FDLOptimizationRuleImpl <em>FDL Optimization Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FDLOptimizationRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getFDLOptimizationRule()
	 * @generated
	 */
	int FDL_OPTIMIZATION_RULE = 47;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FDL_OPTIMIZATION_RULE__COMPLETE = FrameworkPackage.TRANSFORMATION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FDL_OPTIMIZATION_RULE__FAILED = FrameworkPackage.TRANSFORMATION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FDL_OPTIMIZATION_RULE__CHILD_RULES = FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FDL_OPTIMIZATION_RULE__PARENT_RULE = FrameworkPackage.TRANSFORMATION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FDL_OPTIMIZATION_RULE__TARGET = FrameworkPackage.TRANSFORMATION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FDL_OPTIMIZATION_RULE__SOURCE = FrameworkPackage.TRANSFORMATION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FDL_OPTIMIZATION_RULE__ROOT = FrameworkPackage.TRANSFORMATION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>FDL Optimization Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FDL_OPTIMIZATION_RULE_FEATURE_COUNT = FrameworkPackage.TRANSFORMATION_RULE_FEATURE_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ControlActionRule <em>Control Action Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Control Action Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ControlActionRule
	 * @generated
	 */
	EClass getControlActionRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.DecisionRule <em>Decision Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Decision Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.DecisionRule
	 * @generated
	 */
	EClass getDecisionRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.MergeRule <em>Merge Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Merge Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.MergeRule
	 * @generated
	 */
	EClass getMergeRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.JoinRule <em>Join Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Join Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.JoinRule
	 * @generated
	 */
	EClass getJoinRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ForkRule <em>Fork Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Fork Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ForkRule
	 * @generated
	 */
	EClass getForkRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ContainerRule <em>Container Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Container Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ContainerRule
	 * @generated
	 */
	EClass getContainerRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ConnectorRule <em>Connector Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Connector Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ConnectorRule
	 * @generated
	 */
	EClass getConnectorRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.SANNestedProcessRule <em>SAN Nested Process Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SAN Nested Process Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.SANNestedProcessRule
	 * @generated
	 */
	EClass getSANNestedProcessRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ConnectableRule <em>Connectable Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Connectable Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ConnectableRule
	 * @generated
	 */
	EClass getConnectableRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.BlockRule <em>Block Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Block Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.BlockRule
	 * @generated
	 */
	EClass getBlockRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.SANTaskRule <em>SAN Task Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SAN Task Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.SANTaskRule
	 * @generated
	 */
	EClass getSANTaskRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.CallBehaviorActionRule <em>Call Behavior Action Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Call Behavior Action Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.CallBehaviorActionRule
	 * @generated
	 */
	EClass getCallBehaviorActionRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ProcessWalkingRule <em>Process Walking Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Walking Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ProcessWalkingRule
	 * @generated
	 */
	EClass getProcessWalkingRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ConcurrentBranchRule <em>Concurrent Branch Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Concurrent Branch Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ConcurrentBranchRule
	 * @generated
	 */
	EClass getConcurrentBranchRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ProcessRule <em>Process Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ProcessRule
	 * @generated
	 */
	EClass getProcessRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ExclusiveBranchRule <em>Exclusive Branch Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Exclusive Branch Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ExclusiveBranchRule
	 * @generated
	 */
	EClass getExclusiveBranchRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.FlattenRule <em>Flatten Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Flatten Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.FlattenRule
	 * @generated
	 */
	EClass getFlattenRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.AbstractFdlProcDefRule <em>Abstract Fdl Proc Def Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Fdl Proc Def Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.AbstractFdlProcDefRule
	 * @generated
	 */
	EClass getAbstractFdlProcDefRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.SANReusableProcessRule <em>SAN Reusable Process Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SAN Reusable Process Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.SANReusableProcessRule
	 * @generated
	 */
	EClass getSANReusableProcessRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.AbstractFdlDataStructRule <em>Abstract Fdl Data Struct Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Fdl Data Struct Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.AbstractFdlDataStructRule
	 * @generated
	 */
	EClass getAbstractFdlDataStructRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.DataStructureRule <em>Data Structure Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Structure Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.DataStructureRule
	 * @generated
	 */
	EClass getDataStructureRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.BasicDataTypeRule <em>Basic Data Type Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Basic Data Type Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.BasicDataTypeRule
	 * @generated
	 */
	EClass getBasicDataTypeRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.DataTypeRule <em>Data Type Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Type Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.DataTypeRule
	 * @generated
	 */
	EClass getDataTypeRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.MemberDeclRule <em>Member Decl Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Member Decl Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.MemberDeclRule
	 * @generated
	 */
	EClass getMemberDeclRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.DataFlowRule <em>Data Flow Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Flow Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.DataFlowRule
	 * @generated
	 */
	EClass getDataFlowRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.FlowRule <em>Flow Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Flow Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.FlowRule
	 * @generated
	 */
	EClass getFlowRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ActivityRule <em>Activity Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Activity Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ActivityRule
	 * @generated
	 */
	EClass getActivityRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.DataMappingRule <em>Data Mapping Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Mapping Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.DataMappingRule
	 * @generated
	 */
	EClass getDataMappingRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ContainmentRule <em>Containment Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Containment Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ContainmentRule
	 * @generated
	 */
	EClass getContainmentRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ProgramRule <em>Program Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Program Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ProgramRule
	 * @generated
	 */
	EClass getProgramRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.CategoryRule <em>Category Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Category Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.CategoryRule
	 * @generated
	 */
	EClass getCategoryRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.RetrieveDatastoreArtifactPinRule <em>Retrieve Datastore Artifact Pin Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Retrieve Datastore Artifact Pin Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.RetrieveDatastoreArtifactPinRule
	 * @generated
	 */
	EClass getRetrieveDatastoreArtifactPinRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.RetrieveDatastoreArtifactActionRule <em>Retrieve Datastore Artifact Action Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Retrieve Datastore Artifact Action Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.RetrieveDatastoreArtifactActionRule
	 * @generated
	 */
	EClass getRetrieveDatastoreArtifactActionRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.StoreDatastoreArtifactPinRule <em>Store Datastore Artifact Pin Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Store Datastore Artifact Pin Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.StoreDatastoreArtifactPinRule
	 * @generated
	 */
	EClass getStoreDatastoreArtifactPinRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.StoreDatastoreArtifactActionRule <em>Store Datastore Artifact Action Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Store Datastore Artifact Action Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.StoreDatastoreArtifactActionRule
	 * @generated
	 */
	EClass getStoreDatastoreArtifactActionRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.DatastoreRule <em>Datastore Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Datastore Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.DatastoreRule
	 * @generated
	 */
	EClass getDatastoreRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.RetrieveDatastoreArtifactRule <em>Retrieve Datastore Artifact Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Retrieve Datastore Artifact Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.RetrieveDatastoreArtifactRule
	 * @generated
	 */
	EClass getRetrieveDatastoreArtifactRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.StoreDatastoreArtifactRule <em>Store Datastore Artifact Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Store Datastore Artifact Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.StoreDatastoreArtifactRule
	 * @generated
	 */
	EClass getStoreDatastoreArtifactRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.CallOperationActionRule <em>Call Operation Action Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Call Operation Action Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.CallOperationActionRule
	 * @generated
	 */
	EClass getCallOperationActionRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.SANReusableTaskRule <em>SAN Reusable Task Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SAN Reusable Task Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.SANReusableTaskRule
	 * @generated
	 */
	EClass getSANReusableTaskRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.LoopNodeRule <em>Loop Node Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Loop Node Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.LoopNodeRule
	 * @generated
	 */
	EClass getLoopNodeRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ExpressionRule <em>Expression Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Expression Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ExpressionRule
	 * @generated
	 */
	EClass getExpressionRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.OrganizationRule <em>Organization Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Organization Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.OrganizationRule
	 * @generated
	 */
	EClass getOrganizationRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.PersonRule <em>Person Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Person Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.PersonRule
	 * @generated
	 */
	EClass getPersonRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.StaffAssignmentRule <em>Staff Assignment Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Staff Assignment Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.StaffAssignmentRule
	 * @generated
	 */
	EClass getStaffAssignmentRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.FDLOptimizationRule <em>FDL Optimization Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>FDL Optimization Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.FDLOptimizationRule
	 * @generated
	 */
	EClass getFDLOptimizationRule();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	FdlFactory getFdlFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals  {
		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ControlActionRuleImpl <em>Control Action Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ControlActionRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getControlActionRule()
		 * @generated
		 */
		EClass CONTROL_ACTION_RULE = eINSTANCE.getControlActionRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.DecisionRuleImpl <em>Decision Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.DecisionRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getDecisionRule()
		 * @generated
		 */
		EClass DECISION_RULE = eINSTANCE.getDecisionRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.MergeRuleImpl <em>Merge Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.MergeRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getMergeRule()
		 * @generated
		 */
		EClass MERGE_RULE = eINSTANCE.getMergeRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.JoinRuleImpl <em>Join Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.JoinRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getJoinRule()
		 * @generated
		 */
		EClass JOIN_RULE = eINSTANCE.getJoinRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ForkRuleImpl <em>Fork Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ForkRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getForkRule()
		 * @generated
		 */
		EClass FORK_RULE = eINSTANCE.getForkRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ContainerRuleImpl <em>Container Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ContainerRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getContainerRule()
		 * @generated
		 */
		EClass CONTAINER_RULE = eINSTANCE.getContainerRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ConnectorRuleImpl <em>Connector Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ConnectorRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getConnectorRule()
		 * @generated
		 */
		EClass CONNECTOR_RULE = eINSTANCE.getConnectorRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.SANNestedProcessRuleImpl <em>SAN Nested Process Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.SANNestedProcessRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getSANNestedProcessRule()
		 * @generated
		 */
		EClass SAN_NESTED_PROCESS_RULE = eINSTANCE.getSANNestedProcessRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ConnectableRuleImpl <em>Connectable Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ConnectableRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getConnectableRule()
		 * @generated
		 */
		EClass CONNECTABLE_RULE = eINSTANCE.getConnectableRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.BlockRuleImpl <em>Block Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.BlockRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getBlockRule()
		 * @generated
		 */
		EClass BLOCK_RULE = eINSTANCE.getBlockRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.SANTaskRuleImpl <em>SAN Task Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.SANTaskRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getSANTaskRule()
		 * @generated
		 */
		EClass SAN_TASK_RULE = eINSTANCE.getSANTaskRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.CallBehaviorActionRuleImpl <em>Call Behavior Action Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.CallBehaviorActionRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getCallBehaviorActionRule()
		 * @generated
		 */
		EClass CALL_BEHAVIOR_ACTION_RULE = eINSTANCE.getCallBehaviorActionRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ProcessWalkingRuleImpl <em>Process Walking Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ProcessWalkingRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getProcessWalkingRule()
		 * @generated
		 */
		EClass PROCESS_WALKING_RULE = eINSTANCE.getProcessWalkingRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ConcurrentBranchRuleImpl <em>Concurrent Branch Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ConcurrentBranchRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getConcurrentBranchRule()
		 * @generated
		 */
		EClass CONCURRENT_BRANCH_RULE = eINSTANCE.getConcurrentBranchRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ProcessRuleImpl <em>Process Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ProcessRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getProcessRule()
		 * @generated
		 */
		EClass PROCESS_RULE = eINSTANCE.getProcessRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ExclusiveBranchRuleImpl <em>Exclusive Branch Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ExclusiveBranchRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getExclusiveBranchRule()
		 * @generated
		 */
		EClass EXCLUSIVE_BRANCH_RULE = eINSTANCE.getExclusiveBranchRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.FlattenRuleImpl <em>Flatten Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FlattenRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getFlattenRule()
		 * @generated
		 */
		EClass FLATTEN_RULE = eINSTANCE.getFlattenRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.AbstractFdlProcDefRuleImpl <em>Abstract Fdl Proc Def Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.AbstractFdlProcDefRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getAbstractFdlProcDefRule()
		 * @generated
		 */
		EClass ABSTRACT_FDL_PROC_DEF_RULE = eINSTANCE.getAbstractFdlProcDefRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.SANReusableProcessRuleImpl <em>SAN Reusable Process Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.SANReusableProcessRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getSANReusableProcessRule()
		 * @generated
		 */
		EClass SAN_REUSABLE_PROCESS_RULE = eINSTANCE.getSANReusableProcessRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.AbstractFdlDataStructRuleImpl <em>Abstract Fdl Data Struct Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.AbstractFdlDataStructRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getAbstractFdlDataStructRule()
		 * @generated
		 */
		EClass ABSTRACT_FDL_DATA_STRUCT_RULE = eINSTANCE.getAbstractFdlDataStructRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.DataStructureRuleImpl <em>Data Structure Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.DataStructureRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getDataStructureRule()
		 * @generated
		 */
		EClass DATA_STRUCTURE_RULE = eINSTANCE.getDataStructureRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.BasicDataTypeRuleImpl <em>Basic Data Type Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.BasicDataTypeRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getBasicDataTypeRule()
		 * @generated
		 */
		EClass BASIC_DATA_TYPE_RULE = eINSTANCE.getBasicDataTypeRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.DataTypeRuleImpl <em>Data Type Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.DataTypeRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getDataTypeRule()
		 * @generated
		 */
		EClass DATA_TYPE_RULE = eINSTANCE.getDataTypeRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.MemberDeclRuleImpl <em>Member Decl Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.MemberDeclRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getMemberDeclRule()
		 * @generated
		 */
		EClass MEMBER_DECL_RULE = eINSTANCE.getMemberDeclRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.DataFlowRuleImpl <em>Data Flow Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.DataFlowRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getDataFlowRule()
		 * @generated
		 */
		EClass DATA_FLOW_RULE = eINSTANCE.getDataFlowRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.FlowRuleImpl <em>Flow Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FlowRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getFlowRule()
		 * @generated
		 */
		EClass FLOW_RULE = eINSTANCE.getFlowRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ActivityRuleImpl <em>Activity Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ActivityRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getActivityRule()
		 * @generated
		 */
		EClass ACTIVITY_RULE = eINSTANCE.getActivityRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.DataMappingRuleImpl <em>Data Mapping Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.DataMappingRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getDataMappingRule()
		 * @generated
		 */
		EClass DATA_MAPPING_RULE = eINSTANCE.getDataMappingRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ContainmentRuleImpl <em>Containment Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ContainmentRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getContainmentRule()
		 * @generated
		 */
		EClass CONTAINMENT_RULE = eINSTANCE.getContainmentRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ProgramRuleImpl <em>Program Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ProgramRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getProgramRule()
		 * @generated
		 */
		EClass PROGRAM_RULE = eINSTANCE.getProgramRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.CategoryRuleImpl <em>Category Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.CategoryRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getCategoryRule()
		 * @generated
		 */
		EClass CATEGORY_RULE = eINSTANCE.getCategoryRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.RetrieveDatastoreArtifactPinRuleImpl <em>Retrieve Datastore Artifact Pin Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.RetrieveDatastoreArtifactPinRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getRetrieveDatastoreArtifactPinRule()
		 * @generated
		 */
		EClass RETRIEVE_DATASTORE_ARTIFACT_PIN_RULE = eINSTANCE.getRetrieveDatastoreArtifactPinRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.RetrieveDatastoreArtifactActionRuleImpl <em>Retrieve Datastore Artifact Action Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.RetrieveDatastoreArtifactActionRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getRetrieveDatastoreArtifactActionRule()
		 * @generated
		 */
		EClass RETRIEVE_DATASTORE_ARTIFACT_ACTION_RULE = eINSTANCE.getRetrieveDatastoreArtifactActionRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.StoreDatastoreArtifactPinRuleImpl <em>Store Datastore Artifact Pin Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.StoreDatastoreArtifactPinRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getStoreDatastoreArtifactPinRule()
		 * @generated
		 */
		EClass STORE_DATASTORE_ARTIFACT_PIN_RULE = eINSTANCE.getStoreDatastoreArtifactPinRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.StoreDatastoreArtifactActionRuleImpl <em>Store Datastore Artifact Action Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.StoreDatastoreArtifactActionRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getStoreDatastoreArtifactActionRule()
		 * @generated
		 */
		EClass STORE_DATASTORE_ARTIFACT_ACTION_RULE = eINSTANCE.getStoreDatastoreArtifactActionRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.DatastoreRuleImpl <em>Datastore Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.DatastoreRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getDatastoreRule()
		 * @generated
		 */
		EClass DATASTORE_RULE = eINSTANCE.getDatastoreRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.RetrieveDatastoreArtifactRuleImpl <em>Retrieve Datastore Artifact Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.RetrieveDatastoreArtifactRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getRetrieveDatastoreArtifactRule()
		 * @generated
		 */
		EClass RETRIEVE_DATASTORE_ARTIFACT_RULE = eINSTANCE.getRetrieveDatastoreArtifactRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.StoreDatastoreArtifactRuleImpl <em>Store Datastore Artifact Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.StoreDatastoreArtifactRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getStoreDatastoreArtifactRule()
		 * @generated
		 */
		EClass STORE_DATASTORE_ARTIFACT_RULE = eINSTANCE.getStoreDatastoreArtifactRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.CallOperationActionRuleImpl <em>Call Operation Action Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.CallOperationActionRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getCallOperationActionRule()
		 * @generated
		 */
		EClass CALL_OPERATION_ACTION_RULE = eINSTANCE.getCallOperationActionRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.SANReusableTaskRuleImpl <em>SAN Reusable Task Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.SANReusableTaskRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getSANReusableTaskRule()
		 * @generated
		 */
		EClass SAN_REUSABLE_TASK_RULE = eINSTANCE.getSANReusableTaskRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.LoopNodeRuleImpl <em>Loop Node Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.LoopNodeRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getLoopNodeRule()
		 * @generated
		 */
		EClass LOOP_NODE_RULE = eINSTANCE.getLoopNodeRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.ExpressionRuleImpl <em>Expression Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.ExpressionRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getExpressionRule()
		 * @generated
		 */
		EClass EXPRESSION_RULE = eINSTANCE.getExpressionRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.MapRuleImpl <em>Map Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.MapRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getMapRule()
		 * @generated
		 */
		EClass MAP_RULE = eINSTANCE.getMapRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.OrganizationRuleImpl <em>Organization Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.OrganizationRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getOrganizationRule()
		 * @generated
		 */
		EClass ORGANIZATION_RULE = eINSTANCE.getOrganizationRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.PersonRuleImpl <em>Person Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.PersonRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getPersonRule()
		 * @generated
		 */
		EClass PERSON_RULE = eINSTANCE.getPersonRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.RoleRuleImpl <em>Role Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.RoleRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getRoleRule()
		 * @generated
		 */
		EClass ROLE_RULE = eINSTANCE.getRoleRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.StaffAssignmentRuleImpl <em>Staff Assignment Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.StaffAssignmentRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getStaffAssignmentRule()
		 * @generated
		 */
		EClass STAFF_ASSIGNMENT_RULE = eINSTANCE.getStaffAssignmentRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.fdl.impl.FDLOptimizationRuleImpl <em>FDL Optimization Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FDLOptimizationRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl#getFDLOptimizationRule()
		 * @generated
		 */
		EClass FDL_OPTIMIZATION_RULE = eINSTANCE.getFDLOptimizationRule();

	}

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.MapRule <em>Map Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Map Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.MapRule
	 * @generated
	 */
	EClass getMapRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.fdl.RoleRule <em>Role Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Role Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.RoleRule
	 * @generated
	 */
	EClass getRoleRule();

} //ModelPackage
