/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.fdl.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.btools.bom.model.processes.activities.Activity;
import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationContext;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.fdl.CategoryRule;
import com.ibm.btools.te.ilm.heuristics.fdl.FdlPackage;
import com.ibm.btools.te.ilm.heuristics.fdl.util.FdlConstants;
import com.ibm.btools.fdl.model.ProcessCategory;

/**
 * <!-- begin-user-doc -->
 * Creates FDL ProcessCategory from the BOM Activity.
 * 
 * Source: BOM Actvity
 * Target: ProcessCategory
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class CategoryRuleImpl extends AbstractFdlProcDefRuleImpl implements CategoryRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CategoryRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return FdlPackage.Literals.CATEGORY_RULE;
	}

	/**
	 * Source: BOM Activity
	 * Target: FDL ProcessCategory 
	 * 
	 * Creates FDL ProcessCategory from the BOM Activity.
	 * The name of the ProcessCategory is generated from name registry.
	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target()
	 */
	public boolean transformSource2Target() {
		LoggingUtil.traceEntry(this, "transformSource2Target");

		if(isComplete())
			return true;
		if (getSource() == null || getSource().isEmpty())
			return false;	 
	
		//find if there is a same processCategory exist
		Activity activity = (Activity)getSource().get(0);
		String pcName = getNameRegistry().getProcessCategoryName(activity);	
		ProcessCategory pc = null;	
		//find if category exist
		TransformationContext context = getContext();
		pc = (ProcessCategory)context.get(FdlConstants.FDL_CATEGORY_CONTEXT_KEY_PREFIX + pcName);    	
	  
		if(pc == null){
		  //create new process category
		  pc = getFdlModelFactoryInstance().createProcessCategory();
		  pc.setName(pcName);		  		  
		  //add to list
		  context.put(FdlConstants.FDL_CATEGORY_CONTEXT_KEY_PREFIX + pcName, pc);	
		}	
  
		getTarget().add(pc);			
		setComplete(true);
		LoggingUtil.traceExit(this, "transformSource2Target");
		return isComplete();	
	}
	
} //CategoryRuleImpl
