package com.ibm.btools.te.ilm.heuristics.fdl.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
/**
 * A key that contains two parts.
 * The equal method defines that 
 * only both parts are equal then two key objects are equal. 
 */
public class ConnectorKey {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	
	private Object source;
	private Object target;

	/**
	 * @return
	 */
	public Object getSource() {
		return source;
	}

	/**
	 * @return
	 */
	public Object getTarget() {
		return target;
	}

	/**
	 * @param Object
	 */
	public void setSource(Object source) {
		this.source = source;
	}

	/**
	 * @param Object
	 */
	public void setTarget(Object target) {
		this.target = target;
	}

	/**
	 * If obj's both parts are equal with this object, then they are equal.
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	public boolean equals(Object obj) {
		if( ! (obj instanceof ConnectorKey) )
			return false;
		ConnectorKey inKey = (ConnectorKey)obj;	
		boolean f =(this.source == inKey.getSource() && this.target == inKey.getTarget());
		return f; 
	}

	/**
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		
		return (source.hashCode() + target.hashCode());
	}

}
