/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.fdl.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import com.ibm.btools.bom.model.artifacts.PrimitiveType;
import com.ibm.btools.bom.model.artifacts.Type;
import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;

import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.DataDefinitionRule;
import com.ibm.btools.te.ilm.heuristics.fdl.AbstractFdlDataStructRule;
import com.ibm.btools.te.ilm.heuristics.fdl.DataStructureRule;
import com.ibm.btools.te.ilm.heuristics.fdl.DataTypeRule;
import com.ibm.btools.te.ilm.heuristics.fdl.FdlPackage;
import com.ibm.btools.te.ilm.heuristics.fdl.util.FdlUtil;
import com.ibm.btools.te.ilm.heuristics.helper.StaffUtil;
import com.ibm.btools.fdl.model.DataType;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Data Type Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class DataTypeRuleImpl extends AbstractFdlDataStructRuleImpl implements DataTypeRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DataTypeRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return FdlPackage.Literals.DATA_TYPE_RULE;
	}

	/**
	 * Source: BOM Type
	 * Target: FDL DataType
	 * Transform to either DataStructure and BasicDataType.  
	 * Predefined types are also handled here
	 */
	public boolean transformSource2Target()
	{
		LoggingUtil.traceEntry(this, "transformSource2Target");

		if (isComplete())
			return true;
		if (getSource() == null || getSource().isEmpty())
			return false;
		Type type = (Type)getSource().get(0);
//		if (StaffUtil.isPredefinedStaff(type) || StaffUtil.isPredefinedOrganization(type)) {
//			return true;
//		}
		String name = FdlUtil.getFullName(type);
		DataType dt = (DataType)getContext().get(name);
		if (dt == null)
		{
			AbstractFdlDataStructRule rule = createDataTypeRule(type);
			if (rule instanceof DataStructureRule) {
				if (isDataTypeCreatedAsSideEffect()) {
					getRoot().getChildRules().add(rule);
				} else {
					getChildRules().add(rule);
				}
			} else {
				getChildRules().add(rule);
			}
			rule.getSource().add(type);
			rule.transformSource2Target();
			dt = (DataType)rule.getTarget().get(0);	
		}
		getTarget().add(dt);
		
		setComplete(true);
		LoggingUtil.traceExit(this, "transformSource2Target");		
		return isComplete();				
		
	}
	
	protected AbstractFdlDataStructRule createDataTypeRule(Type type)
	{	
		// TODO: need to check on predefined types to see
		// if we can map to an FDL basic type or not
		if (!(type instanceof PrimitiveType) || !FdlUtil.isConvertibleToBasicDataType(type.getName()))
		{
			return FdlFactoryImpl.eINSTANCE.createDataStructureRule();
		} else {
			return FdlFactoryImpl.eINSTANCE.createBasicDataTypeRule();
		}
	}

	private boolean isDataTypeCreatedAsSideEffect() {
		if (this.getParentRule() != null) {
			if (this.getParentRule() instanceof DataDefinitionRule) {
				return false;
			}
		}
		return true;
	}
} //DataTypeRuleImpl
