/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.fdl.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import com.ibm.btools.te.ilm.heuristics.fdl.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class FdlFactoryImpl extends EFactoryImpl implements FdlFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static FdlFactory init() {
		try {
			FdlFactory theFdlFactory = (FdlFactory)EPackage.Registry.INSTANCE.getEFactory("http:///heuristics/fdl.ecore"); 
			if (theFdlFactory != null) {
				return theFdlFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new FdlFactoryImpl();
	}

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FdlFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case FdlPackage.DECISION_RULE: return createDecisionRule();
			case FdlPackage.MERGE_RULE: return createMergeRule();
			case FdlPackage.JOIN_RULE: return createJoinRule();
			case FdlPackage.FORK_RULE: return createForkRule();
			case FdlPackage.CONTAINER_RULE: return createContainerRule();
			case FdlPackage.SAN_NESTED_PROCESS_RULE: return createSANNestedProcessRule();
			case FdlPackage.BLOCK_RULE: return createBlockRule();
			case FdlPackage.SAN_TASK_RULE: return createSANTaskRule();
			case FdlPackage.CALL_BEHAVIOR_ACTION_RULE: return createCallBehaviorActionRule();
			case FdlPackage.CONCURRENT_BRANCH_RULE: return createConcurrentBranchRule();
			case FdlPackage.PROCESS_RULE: return createProcessRule();
			case FdlPackage.EXCLUSIVE_BRANCH_RULE: return createExclusiveBranchRule();
			case FdlPackage.FLATTEN_RULE: return createFlattenRule();
			case FdlPackage.SAN_REUSABLE_PROCESS_RULE: return createSANReusableProcessRule();
			case FdlPackage.DATA_STRUCTURE_RULE: return createDataStructureRule();
			case FdlPackage.BASIC_DATA_TYPE_RULE: return createBasicDataTypeRule();
			case FdlPackage.DATA_TYPE_RULE: return createDataTypeRule();
			case FdlPackage.MEMBER_DECL_RULE: return createMemberDeclRule();
			case FdlPackage.DATA_FLOW_RULE: return createDataFlowRule();
			case FdlPackage.FLOW_RULE: return createFlowRule();
			case FdlPackage.ACTIVITY_RULE: return createActivityRule();
			case FdlPackage.DATA_MAPPING_RULE: return createDataMappingRule();
			case FdlPackage.PROGRAM_RULE: return createProgramRule();
			case FdlPackage.CATEGORY_RULE: return createCategoryRule();
			case FdlPackage.RETRIEVE_DATASTORE_ARTIFACT_PIN_RULE: return createRetrieveDatastoreArtifactPinRule();
			case FdlPackage.RETRIEVE_DATASTORE_ARTIFACT_ACTION_RULE: return createRetrieveDatastoreArtifactActionRule();
			case FdlPackage.STORE_DATASTORE_ARTIFACT_PIN_RULE: return createStoreDatastoreArtifactPinRule();
			case FdlPackage.STORE_DATASTORE_ARTIFACT_ACTION_RULE: return createStoreDatastoreArtifactActionRule();
			case FdlPackage.DATASTORE_RULE: return createDatastoreRule();
			case FdlPackage.CALL_OPERATION_ACTION_RULE: return createCallOperationActionRule();
			case FdlPackage.SAN_REUSABLE_TASK_RULE: return createSANReusableTaskRule();
			case FdlPackage.LOOP_NODE_RULE: return createLoopNodeRule();
			case FdlPackage.EXPRESSION_RULE: return createExpressionRule();
			case FdlPackage.MAP_RULE: return createMapRule();
			case FdlPackage.ORGANIZATION_RULE: return createOrganizationRule();
			case FdlPackage.PERSON_RULE: return createPersonRule();
			case FdlPackage.ROLE_RULE: return createRoleRule();
			case FdlPackage.STAFF_ASSIGNMENT_RULE: return createStaffAssignmentRule();
			case FdlPackage.FDL_OPTIMIZATION_RULE: return createFDLOptimizationRule();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DecisionRule createDecisionRule() {
		DecisionRuleImpl decisionRule = new DecisionRuleImpl();
		return decisionRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MergeRule createMergeRule() {
		MergeRuleImpl mergeRule = new MergeRuleImpl();
		return mergeRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public JoinRule createJoinRule() {
		JoinRuleImpl joinRule = new JoinRuleImpl();
		return joinRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ForkRule createForkRule() {
		ForkRuleImpl forkRule = new ForkRuleImpl();
		return forkRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ContainerRule createContainerRule() {
		ContainerRuleImpl containerRule = new ContainerRuleImpl();
		return containerRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SANNestedProcessRule createSANNestedProcessRule() {
		SANNestedProcessRuleImpl sanNestedProcessRule = new SANNestedProcessRuleImpl();
		return sanNestedProcessRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BlockRule createBlockRule() {
		BlockRuleImpl blockRule = new BlockRuleImpl();
		return blockRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SANTaskRule createSANTaskRule() {
		SANTaskRuleImpl sanTaskRule = new SANTaskRuleImpl();
		return sanTaskRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallBehaviorActionRule createCallBehaviorActionRule() {
		CallBehaviorActionRuleImpl callBehaviorActionRule = new CallBehaviorActionRuleImpl();
		return callBehaviorActionRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConcurrentBranchRule createConcurrentBranchRule() {
		ConcurrentBranchRuleImpl concurrentBranchRule = new ConcurrentBranchRuleImpl();
		return concurrentBranchRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProcessRule createProcessRule() {
		ProcessRuleImpl processRule = new ProcessRuleImpl();
		return processRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExclusiveBranchRule createExclusiveBranchRule() {
		ExclusiveBranchRuleImpl exclusiveBranchRule = new ExclusiveBranchRuleImpl();
		return exclusiveBranchRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FlattenRule createFlattenRule() {
		FlattenRuleImpl flattenRule = new FlattenRuleImpl();
		return flattenRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SANReusableProcessRule createSANReusableProcessRule() {
		SANReusableProcessRuleImpl sanReusableProcessRule = new SANReusableProcessRuleImpl();
		return sanReusableProcessRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataStructureRule createDataStructureRule() {
		DataStructureRuleImpl dataStructureRule = new DataStructureRuleImpl();
		return dataStructureRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BasicDataTypeRule createBasicDataTypeRule() {
		BasicDataTypeRuleImpl basicDataTypeRule = new BasicDataTypeRuleImpl();
		return basicDataTypeRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataTypeRule createDataTypeRule() {
		DataTypeRuleImpl dataTypeRule = new DataTypeRuleImpl();
		return dataTypeRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MemberDeclRule createMemberDeclRule() {
		MemberDeclRuleImpl memberDeclRule = new MemberDeclRuleImpl();
		return memberDeclRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataFlowRule createDataFlowRule() {
		DataFlowRuleImpl dataFlowRule = new DataFlowRuleImpl();
		return dataFlowRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FlowRule createFlowRule() {
		FlowRuleImpl flowRule = new FlowRuleImpl();
		return flowRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ActivityRule createActivityRule() {
		ActivityRuleImpl activityRule = new ActivityRuleImpl();
		return activityRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataMappingRule createDataMappingRule() {
		DataMappingRuleImpl dataMappingRule = new DataMappingRuleImpl();
		return dataMappingRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProgramRule createProgramRule() {
		ProgramRuleImpl programRule = new ProgramRuleImpl();
		return programRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CategoryRule createCategoryRule() {
		CategoryRuleImpl categoryRule = new CategoryRuleImpl();
		return categoryRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RetrieveDatastoreArtifactPinRule createRetrieveDatastoreArtifactPinRule() {
		RetrieveDatastoreArtifactPinRuleImpl retrieveDatastoreArtifactPinRule = new RetrieveDatastoreArtifactPinRuleImpl();
		return retrieveDatastoreArtifactPinRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RetrieveDatastoreArtifactActionRule createRetrieveDatastoreArtifactActionRule() {
		RetrieveDatastoreArtifactActionRuleImpl retrieveDatastoreArtifactActionRule = new RetrieveDatastoreArtifactActionRuleImpl();
		return retrieveDatastoreArtifactActionRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StoreDatastoreArtifactPinRule createStoreDatastoreArtifactPinRule() {
		StoreDatastoreArtifactPinRuleImpl storeDatastoreArtifactPinRule = new StoreDatastoreArtifactPinRuleImpl();
		return storeDatastoreArtifactPinRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StoreDatastoreArtifactActionRule createStoreDatastoreArtifactActionRule() {
		StoreDatastoreArtifactActionRuleImpl storeDatastoreArtifactActionRule = new StoreDatastoreArtifactActionRuleImpl();
		return storeDatastoreArtifactActionRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DatastoreRule createDatastoreRule() {
		DatastoreRuleImpl datastoreRule = new DatastoreRuleImpl();
		return datastoreRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallOperationActionRule createCallOperationActionRule() {
		CallOperationActionRuleImpl callOperationActionRule = new CallOperationActionRuleImpl();
		return callOperationActionRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SANReusableTaskRule createSANReusableTaskRule() {
		SANReusableTaskRuleImpl sanReusableTaskRule = new SANReusableTaskRuleImpl();
		return sanReusableTaskRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LoopNodeRule createLoopNodeRule() {
		LoopNodeRuleImpl loopNodeRule = new LoopNodeRuleImpl();
		return loopNodeRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExpressionRule createExpressionRule() {
		ExpressionRuleImpl expressionRule = new ExpressionRuleImpl();
		return expressionRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OrganizationRule createOrganizationRule() {
		OrganizationRuleImpl organizationRule = new OrganizationRuleImpl();
		return organizationRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PersonRule createPersonRule() {
		PersonRuleImpl personRule = new PersonRuleImpl();
		return personRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StaffAssignmentRule createStaffAssignmentRule() {
		StaffAssignmentRuleImpl staffAssignmentRule = new StaffAssignmentRuleImpl();
		return staffAssignmentRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FDLOptimizationRule createFDLOptimizationRule() {
		FDLOptimizationRuleImpl fdlOptimizationRule = new FDLOptimizationRuleImpl();
		return fdlOptimizationRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MapRule createMapRule() {
		MapRuleImpl mapRule = new MapRuleImpl();
		return mapRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RoleRule createRoleRule() {
		RoleRuleImpl roleRule = new RoleRuleImpl();
		return roleRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FdlPackage getFdlPackage() {
		return (FdlPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	public static FdlPackage getPackage() {
		return FdlPackage.eINSTANCE;
	}

} //ModelFactoryImpl
