/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.fdl.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.impl.EPackageImpl;
import org.eclipse.emf.ecore.impl.EcorePackageImpl;

import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.impl.FrameworkPackageImpl;
import com.ibm.btools.te.ilm.heuristics.HeuristicsPackage;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelPackage;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl;
import com.ibm.btools.te.ilm.heuristics.bpel.BpelPackage;

import com.ibm.btools.te.ilm.heuristics.bpel.impl.BpelPackageImpl;

import com.ibm.btools.te.ilm.heuristics.bpelp.BpelpPackage;

import com.ibm.btools.te.ilm.heuristics.bpelp.impl.BpelpPackageImpl;

import com.ibm.btools.te.ilm.heuristics.br.BrPackage;

import com.ibm.btools.te.ilm.heuristics.br.impl.BrPackageImpl;

import com.ibm.btools.te.ilm.heuristics.extservice.ExtservicePackage;

import com.ibm.btools.te.ilm.heuristics.extservice.impl.ExtservicePackageImpl;

import com.ibm.btools.te.ilm.heuristics.fdl.AbstractFdlDataStructRule;
import com.ibm.btools.te.ilm.heuristics.fdl.AbstractFdlProcDefRule;
import com.ibm.btools.te.ilm.heuristics.fdl.ActivityRule;
import com.ibm.btools.te.ilm.heuristics.fdl.BasicDataTypeRule;
import com.ibm.btools.te.ilm.heuristics.fdl.BlockRule;
import com.ibm.btools.te.ilm.heuristics.fdl.CallBehaviorActionRule;
import com.ibm.btools.te.ilm.heuristics.fdl.CallOperationActionRule;
import com.ibm.btools.te.ilm.heuristics.fdl.CategoryRule;
import com.ibm.btools.te.ilm.heuristics.fdl.ConcurrentBranchRule;
import com.ibm.btools.te.ilm.heuristics.fdl.ConnectableRule;
import com.ibm.btools.te.ilm.heuristics.fdl.ConnectorRule;
import com.ibm.btools.te.ilm.heuristics.fdl.ContainerRule;
import com.ibm.btools.te.ilm.heuristics.fdl.ContainmentRule;
import com.ibm.btools.te.ilm.heuristics.fdl.ControlActionRule;
import com.ibm.btools.te.ilm.heuristics.fdl.DataFlowRule;
import com.ibm.btools.te.ilm.heuristics.fdl.DataMappingRule;
import com.ibm.btools.te.ilm.heuristics.fdl.DataStructureRule;
import com.ibm.btools.te.ilm.heuristics.fdl.DataTypeRule;
import com.ibm.btools.te.ilm.heuristics.fdl.DatastoreRule;
import com.ibm.btools.te.ilm.heuristics.fdl.DecisionRule;
import com.ibm.btools.te.ilm.heuristics.fdl.ExclusiveBranchRule;
import com.ibm.btools.te.ilm.heuristics.fdl.ExpressionRule;
import com.ibm.btools.te.ilm.heuristics.fdl.FDLOptimizationRule;
import com.ibm.btools.te.ilm.heuristics.fdl.FdlFactory;
import com.ibm.btools.te.ilm.heuristics.fdl.FdlPackage;
import com.ibm.btools.te.ilm.heuristics.fdl.FlattenRule;
import com.ibm.btools.te.ilm.heuristics.fdl.FlowRule;
import com.ibm.btools.te.ilm.heuristics.fdl.ForkRule;
import com.ibm.btools.te.ilm.heuristics.fdl.JoinRule;
import com.ibm.btools.te.ilm.heuristics.fdl.LoopNodeRule;
import com.ibm.btools.te.ilm.heuristics.fdl.MapRule;
import com.ibm.btools.te.ilm.heuristics.fdl.MemberDeclRule;
import com.ibm.btools.te.ilm.heuristics.fdl.MergeRule;
import com.ibm.btools.te.ilm.heuristics.fdl.OrganizationRule;
import com.ibm.btools.te.ilm.heuristics.fdl.PersonRule;
import com.ibm.btools.te.ilm.heuristics.fdl.ProcessRule;
import com.ibm.btools.te.ilm.heuristics.fdl.ProcessWalkingRule;
import com.ibm.btools.te.ilm.heuristics.fdl.ProgramRule;
import com.ibm.btools.te.ilm.heuristics.fdl.RetrieveDatastoreArtifactActionRule;
import com.ibm.btools.te.ilm.heuristics.fdl.RetrieveDatastoreArtifactPinRule;
import com.ibm.btools.te.ilm.heuristics.fdl.RetrieveDatastoreArtifactRule;
import com.ibm.btools.te.ilm.heuristics.fdl.RoleRule;
import com.ibm.btools.te.ilm.heuristics.fdl.SANNestedProcessRule;
import com.ibm.btools.te.ilm.heuristics.fdl.SANReusableProcessRule;
import com.ibm.btools.te.ilm.heuristics.fdl.SANReusableTaskRule;
import com.ibm.btools.te.ilm.heuristics.fdl.SANTaskRule;


import com.ibm.btools.te.ilm.heuristics.fdl.StaffAssignmentRule;
import com.ibm.btools.te.ilm.heuristics.fdl.StoreDatastoreArtifactActionRule;
import com.ibm.btools.te.ilm.heuristics.fdl.StoreDatastoreArtifactPinRule;

import com.ibm.btools.te.ilm.heuristics.fdl.StoreDatastoreArtifactRule;

import com.ibm.btools.te.ilm.heuristics.impl.HeuristicsPackageImpl;
import com.ibm.btools.te.ilm.heuristics.scdl.ScdlPackage;

import com.ibm.btools.te.ilm.heuristics.scdl.impl.ScdlPackageImpl;

import com.ibm.btools.te.ilm.heuristics.wsdl.WsdlPackage;
import com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl;
import com.ibm.btools.te.ilm.heuristics.xsd.XsdPackage;
import com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class FdlPackageImpl extends EPackageImpl implements FdlPackage {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass controlActionRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass decisionRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mergeRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass joinRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass forkRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass containerRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass connectorRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sanNestedProcessRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass connectableRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass blockRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sanTaskRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass callBehaviorActionRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass processWalkingRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass concurrentBranchRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass processRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass exclusiveBranchRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass flattenRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass abstractFdlProcDefRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sanReusableProcessRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass abstractFdlDataStructRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dataStructureRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass basicDataTypeRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dataTypeRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass memberDeclRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dataFlowRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass flowRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass activityRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dataMappingRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass containmentRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass programRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass categoryRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass retrieveDatastoreArtifactPinRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass retrieveDatastoreArtifactActionRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass storeDatastoreArtifactPinRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass storeDatastoreArtifactActionRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass datastoreRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass retrieveDatastoreArtifactRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass storeDatastoreArtifactRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass callOperationActionRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sanReusableTaskRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass loopNodeRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass expressionRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass organizationRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass personRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mapRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass roleRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass staffAssignmentRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass fdlOptimizationRuleEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.FdlPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private FdlPackageImpl() {
		super(eNS_URI, FdlFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this
	 * model, and for any others upon which it depends.  Simple
	 * dependencies are satisfied by calling this method on all
	 * dependent packages before doing anything else.  This method drives
	 * initialization for interdependent packages directly, in parallel
	 * with this package, itself.
	 * <p>Of this package and its interdependencies, all packages which
	 * have not yet been registered by their URI values are first created
	 * and registered.  The packages are then initialized in two steps:
	 * meta-model objects for all of the packages are created before any
	 * are initialized, since one package's meta-model objects may refer to
	 * those of another.
	 * <p>Invocation of this method will not affect any packages that have
	 * already been initialized.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static FdlPackage init() {
		if (isInited) return (FdlPackage)EPackage.Registry.INSTANCE.getEPackage(FdlPackage.eNS_URI);

		// Obtain or create and register package
		FdlPackageImpl theFdlPackage = (FdlPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof FdlPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new FdlPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		EcorePackage.eINSTANCE.eClass();

		// Obtain or create and register interdependencies
		FrameworkPackageImpl theFrameworkPackage = (FrameworkPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FrameworkPackage.eNS_URI) instanceof FrameworkPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FrameworkPackage.eNS_URI) : FrameworkPackage.eINSTANCE);
		HeuristicsPackageImpl theHeuristicsPackage = (HeuristicsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(HeuristicsPackage.eNS_URI) instanceof HeuristicsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(HeuristicsPackage.eNS_URI) : HeuristicsPackage.eINSTANCE);
		XsdPackageImpl theXsdPackage = (XsdPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(XsdPackage.eNS_URI) instanceof XsdPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(XsdPackage.eNS_URI) : XsdPackage.eINSTANCE);
		AbstractbpelPackageImpl theAbstractbpelPackage = (AbstractbpelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AbstractbpelPackage.eNS_URI) instanceof AbstractbpelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AbstractbpelPackage.eNS_URI) : AbstractbpelPackage.eINSTANCE);
		WsdlPackageImpl theWsdlPackage = (WsdlPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(WsdlPackage.eNS_URI) instanceof WsdlPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(WsdlPackage.eNS_URI) : WsdlPackage.eINSTANCE);
		BpelpPackageImpl theBpelpPackage = (BpelpPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(BpelpPackage.eNS_URI) instanceof BpelpPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(BpelpPackage.eNS_URI) : BpelpPackage.eINSTANCE);
		ScdlPackageImpl theScdlPackage = (ScdlPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ScdlPackage.eNS_URI) instanceof ScdlPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ScdlPackage.eNS_URI) : ScdlPackage.eINSTANCE);
		ExtservicePackageImpl theExtservicePackage = (ExtservicePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ExtservicePackage.eNS_URI) instanceof ExtservicePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ExtservicePackage.eNS_URI) : ExtservicePackage.eINSTANCE);
		BrPackageImpl theBrPackage = (BrPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(BrPackage.eNS_URI) instanceof BrPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(BrPackage.eNS_URI) : BrPackage.eINSTANCE);

		// Create package meta-data objects
		theFdlPackage.createPackageContents();
		theFrameworkPackage.createPackageContents();
		theHeuristicsPackage.createPackageContents();
		theXsdPackage.createPackageContents();
		theAbstractbpelPackage.createPackageContents();
		theWsdlPackage.createPackageContents();
		theBpelpPackage.createPackageContents();
		theScdlPackage.createPackageContents();
		theExtservicePackage.createPackageContents();
		theBrPackage.createPackageContents();

		// Initialize created meta-data
		theFdlPackage.initializePackageContents();
		theFrameworkPackage.initializePackageContents();
		theHeuristicsPackage.initializePackageContents();
		theXsdPackage.initializePackageContents();
		theAbstractbpelPackage.initializePackageContents();
		theWsdlPackage.initializePackageContents();
		theBpelpPackage.initializePackageContents();
		theScdlPackage.initializePackageContents();
		theExtservicePackage.initializePackageContents();
		theBrPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theFdlPackage.freeze();

		return theFdlPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getControlActionRule() {
		return controlActionRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDecisionRule() {
		return decisionRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMergeRule() {
		return mergeRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getJoinRule() {
		return joinRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getForkRule() {
		return forkRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getContainerRule() {
		return containerRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getConnectorRule() {
		return connectorRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSANNestedProcessRule() {
		return sanNestedProcessRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getConnectableRule() {
		return connectableRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBlockRule() {
		return blockRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSANTaskRule() {
		return sanTaskRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCallBehaviorActionRule() {
		return callBehaviorActionRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getProcessWalkingRule() {
		return processWalkingRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getConcurrentBranchRule() {
		return concurrentBranchRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getProcessRule() {
		return processRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getExclusiveBranchRule() {
		return exclusiveBranchRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFlattenRule() {
		return flattenRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAbstractFdlProcDefRule() {
		return abstractFdlProcDefRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSANReusableProcessRule() {
		return sanReusableProcessRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAbstractFdlDataStructRule() {
		return abstractFdlDataStructRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDataStructureRule() {
		return dataStructureRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBasicDataTypeRule() {
		return basicDataTypeRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDataTypeRule() {
		return dataTypeRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMemberDeclRule() {
		return memberDeclRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDataFlowRule() {
		return dataFlowRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFlowRule() {
		return flowRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getActivityRule() {
		return activityRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDataMappingRule() {
		return dataMappingRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getContainmentRule() {
		return containmentRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getProgramRule() {
		return programRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCategoryRule() {
		return categoryRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRetrieveDatastoreArtifactPinRule() {
		return retrieveDatastoreArtifactPinRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRetrieveDatastoreArtifactActionRule() {
		return retrieveDatastoreArtifactActionRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStoreDatastoreArtifactPinRule() {
		return storeDatastoreArtifactPinRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStoreDatastoreArtifactActionRule() {
		return storeDatastoreArtifactActionRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDatastoreRule() {
		return datastoreRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRetrieveDatastoreArtifactRule() {
		return retrieveDatastoreArtifactRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStoreDatastoreArtifactRule() {
		return storeDatastoreArtifactRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCallOperationActionRule() {
		return callOperationActionRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSANReusableTaskRule() {
		return sanReusableTaskRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLoopNodeRule() {
		return loopNodeRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getExpressionRule() {
		return expressionRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getOrganizationRule() {
		return organizationRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPersonRule() {
		return personRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStaffAssignmentRule() {
		return staffAssignmentRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFDLOptimizationRule() {
		return fdlOptimizationRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMapRule() {
		return mapRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRoleRule() {
		return roleRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FdlFactory getFdlFactory() {
		return (FdlFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		controlActionRuleEClass = createEClass(CONTROL_ACTION_RULE);

		decisionRuleEClass = createEClass(DECISION_RULE);

		mergeRuleEClass = createEClass(MERGE_RULE);

		joinRuleEClass = createEClass(JOIN_RULE);

		forkRuleEClass = createEClass(FORK_RULE);

		containerRuleEClass = createEClass(CONTAINER_RULE);

		connectorRuleEClass = createEClass(CONNECTOR_RULE);

		sanNestedProcessRuleEClass = createEClass(SAN_NESTED_PROCESS_RULE);

		connectableRuleEClass = createEClass(CONNECTABLE_RULE);

		blockRuleEClass = createEClass(BLOCK_RULE);

		sanTaskRuleEClass = createEClass(SAN_TASK_RULE);

		callBehaviorActionRuleEClass = createEClass(CALL_BEHAVIOR_ACTION_RULE);

		processWalkingRuleEClass = createEClass(PROCESS_WALKING_RULE);

		concurrentBranchRuleEClass = createEClass(CONCURRENT_BRANCH_RULE);

		processRuleEClass = createEClass(PROCESS_RULE);

		exclusiveBranchRuleEClass = createEClass(EXCLUSIVE_BRANCH_RULE);

		flattenRuleEClass = createEClass(FLATTEN_RULE);

		abstractFdlProcDefRuleEClass = createEClass(ABSTRACT_FDL_PROC_DEF_RULE);

		sanReusableProcessRuleEClass = createEClass(SAN_REUSABLE_PROCESS_RULE);

		abstractFdlDataStructRuleEClass = createEClass(ABSTRACT_FDL_DATA_STRUCT_RULE);

		dataStructureRuleEClass = createEClass(DATA_STRUCTURE_RULE);

		basicDataTypeRuleEClass = createEClass(BASIC_DATA_TYPE_RULE);

		dataTypeRuleEClass = createEClass(DATA_TYPE_RULE);

		memberDeclRuleEClass = createEClass(MEMBER_DECL_RULE);

		dataFlowRuleEClass = createEClass(DATA_FLOW_RULE);

		flowRuleEClass = createEClass(FLOW_RULE);

		activityRuleEClass = createEClass(ACTIVITY_RULE);

		dataMappingRuleEClass = createEClass(DATA_MAPPING_RULE);

		containmentRuleEClass = createEClass(CONTAINMENT_RULE);

		programRuleEClass = createEClass(PROGRAM_RULE);

		categoryRuleEClass = createEClass(CATEGORY_RULE);

		retrieveDatastoreArtifactPinRuleEClass = createEClass(RETRIEVE_DATASTORE_ARTIFACT_PIN_RULE);

		retrieveDatastoreArtifactActionRuleEClass = createEClass(RETRIEVE_DATASTORE_ARTIFACT_ACTION_RULE);

		storeDatastoreArtifactPinRuleEClass = createEClass(STORE_DATASTORE_ARTIFACT_PIN_RULE);

		storeDatastoreArtifactActionRuleEClass = createEClass(STORE_DATASTORE_ARTIFACT_ACTION_RULE);

		datastoreRuleEClass = createEClass(DATASTORE_RULE);

		retrieveDatastoreArtifactRuleEClass = createEClass(RETRIEVE_DATASTORE_ARTIFACT_RULE);

		storeDatastoreArtifactRuleEClass = createEClass(STORE_DATASTORE_ARTIFACT_RULE);

		callOperationActionRuleEClass = createEClass(CALL_OPERATION_ACTION_RULE);

		sanReusableTaskRuleEClass = createEClass(SAN_REUSABLE_TASK_RULE);

		loopNodeRuleEClass = createEClass(LOOP_NODE_RULE);

		expressionRuleEClass = createEClass(EXPRESSION_RULE);

		mapRuleEClass = createEClass(MAP_RULE);

		organizationRuleEClass = createEClass(ORGANIZATION_RULE);

		personRuleEClass = createEClass(PERSON_RULE);

		roleRuleEClass = createEClass(ROLE_RULE);

		staffAssignmentRuleEClass = createEClass(STAFF_ASSIGNMENT_RULE);

		fdlOptimizationRuleEClass = createEClass(FDL_OPTIMIZATION_RULE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		FrameworkPackage theFrameworkPackage = (FrameworkPackage)EPackage.Registry.INSTANCE.getEPackage(FrameworkPackage.eNS_URI);

		// Add supertypes to classes
		controlActionRuleEClass.getESuperTypes().add(this.getConnectableRule());
		decisionRuleEClass.getESuperTypes().add(this.getControlActionRule());
		mergeRuleEClass.getESuperTypes().add(this.getControlActionRule());
		joinRuleEClass.getESuperTypes().add(this.getControlActionRule());
		forkRuleEClass.getESuperTypes().add(this.getControlActionRule());
		containerRuleEClass.getESuperTypes().add(this.getAbstractFdlDataStructRule());
		connectorRuleEClass.getESuperTypes().add(this.getAbstractFdlProcDefRule());
		sanNestedProcessRuleEClass.getESuperTypes().add(this.getAbstractFdlProcDefRule());
		connectableRuleEClass.getESuperTypes().add(this.getAbstractFdlProcDefRule());
		blockRuleEClass.getESuperTypes().add(this.getContainmentRule());
		sanTaskRuleEClass.getESuperTypes().add(this.getConnectableRule());
		callBehaviorActionRuleEClass.getESuperTypes().add(this.getConnectableRule());
		processWalkingRuleEClass.getESuperTypes().add(this.getConnectableRule());
		concurrentBranchRuleEClass.getESuperTypes().add(this.getProcessWalkingRule());
		processRuleEClass.getESuperTypes().add(this.getProcessWalkingRule());
		exclusiveBranchRuleEClass.getESuperTypes().add(this.getProcessWalkingRule());
		flattenRuleEClass.getESuperTypes().add(this.getConnectableRule());
		abstractFdlProcDefRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());
		sanReusableProcessRuleEClass.getESuperTypes().add(this.getContainmentRule());
		abstractFdlDataStructRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());
		dataStructureRuleEClass.getESuperTypes().add(this.getAbstractFdlDataStructRule());
		basicDataTypeRuleEClass.getESuperTypes().add(this.getAbstractFdlDataStructRule());
		dataTypeRuleEClass.getESuperTypes().add(this.getAbstractFdlDataStructRule());
		memberDeclRuleEClass.getESuperTypes().add(this.getAbstractFdlDataStructRule());
		dataFlowRuleEClass.getESuperTypes().add(this.getConnectorRule());
		flowRuleEClass.getESuperTypes().add(this.getConnectorRule());
		activityRuleEClass.getESuperTypes().add(this.getAbstractFdlProcDefRule());
		dataMappingRuleEClass.getESuperTypes().add(this.getAbstractFdlDataStructRule());
		containmentRuleEClass.getESuperTypes().add(this.getConnectableRule());
		programRuleEClass.getESuperTypes().add(this.getAbstractFdlProcDefRule());
		categoryRuleEClass.getESuperTypes().add(this.getAbstractFdlProcDefRule());
		retrieveDatastoreArtifactPinRuleEClass.getESuperTypes().add(this.getRetrieveDatastoreArtifactRule());
		retrieveDatastoreArtifactActionRuleEClass.getESuperTypes().add(this.getRetrieveDatastoreArtifactRule());
		storeDatastoreArtifactPinRuleEClass.getESuperTypes().add(this.getStoreDatastoreArtifactRule());
		storeDatastoreArtifactActionRuleEClass.getESuperTypes().add(this.getStoreDatastoreArtifactRule());
		datastoreRuleEClass.getESuperTypes().add(this.getAbstractFdlProcDefRule());
		retrieveDatastoreArtifactRuleEClass.getESuperTypes().add(this.getConnectableRule());
		storeDatastoreArtifactRuleEClass.getESuperTypes().add(this.getConnectableRule());
		callOperationActionRuleEClass.getESuperTypes().add(this.getConnectableRule());
		sanReusableTaskRuleEClass.getESuperTypes().add(this.getConnectableRule());
		loopNodeRuleEClass.getESuperTypes().add(this.getBlockRule());
		expressionRuleEClass.getESuperTypes().add(this.getAbstractFdlProcDefRule());
		mapRuleEClass.getESuperTypes().add(this.getConnectableRule());
		organizationRuleEClass.getESuperTypes().add(this.getAbstractFdlProcDefRule());
		personRuleEClass.getESuperTypes().add(this.getAbstractFdlProcDefRule());
		roleRuleEClass.getESuperTypes().add(this.getAbstractFdlProcDefRule());
		staffAssignmentRuleEClass.getESuperTypes().add(this.getAbstractFdlProcDefRule());
		fdlOptimizationRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());

		// Initialize classes and features; add operations and parameters
		initEClass(controlActionRuleEClass, ControlActionRule.class, "ControlActionRule", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(decisionRuleEClass, DecisionRule.class, "DecisionRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mergeRuleEClass, MergeRule.class, "MergeRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(joinRuleEClass, JoinRule.class, "JoinRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(forkRuleEClass, ForkRule.class, "ForkRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(containerRuleEClass, ContainerRule.class, "ContainerRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(connectorRuleEClass, ConnectorRule.class, "ConnectorRule", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(sanNestedProcessRuleEClass, SANNestedProcessRule.class, "SANNestedProcessRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(connectableRuleEClass, ConnectableRule.class, "ConnectableRule", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(blockRuleEClass, BlockRule.class, "BlockRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(sanTaskRuleEClass, SANTaskRule.class, "SANTaskRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(callBehaviorActionRuleEClass, CallBehaviorActionRule.class, "CallBehaviorActionRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(processWalkingRuleEClass, ProcessWalkingRule.class, "ProcessWalkingRule", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(concurrentBranchRuleEClass, ConcurrentBranchRule.class, "ConcurrentBranchRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(processRuleEClass, ProcessRule.class, "ProcessRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(exclusiveBranchRuleEClass, ExclusiveBranchRule.class, "ExclusiveBranchRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(flattenRuleEClass, FlattenRule.class, "FlattenRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(abstractFdlProcDefRuleEClass, AbstractFdlProcDefRule.class, "AbstractFdlProcDefRule", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(sanReusableProcessRuleEClass, SANReusableProcessRule.class, "SANReusableProcessRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(abstractFdlDataStructRuleEClass, AbstractFdlDataStructRule.class, "AbstractFdlDataStructRule", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(dataStructureRuleEClass, DataStructureRule.class, "DataStructureRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(basicDataTypeRuleEClass, BasicDataTypeRule.class, "BasicDataTypeRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(dataTypeRuleEClass, DataTypeRule.class, "DataTypeRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(memberDeclRuleEClass, MemberDeclRule.class, "MemberDeclRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(dataFlowRuleEClass, DataFlowRule.class, "DataFlowRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(flowRuleEClass, FlowRule.class, "FlowRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(activityRuleEClass, ActivityRule.class, "ActivityRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(dataMappingRuleEClass, DataMappingRule.class, "DataMappingRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(containmentRuleEClass, ContainmentRule.class, "ContainmentRule", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(programRuleEClass, ProgramRule.class, "ProgramRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(categoryRuleEClass, CategoryRule.class, "CategoryRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(retrieveDatastoreArtifactPinRuleEClass, RetrieveDatastoreArtifactPinRule.class, "RetrieveDatastoreArtifactPinRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(retrieveDatastoreArtifactActionRuleEClass, RetrieveDatastoreArtifactActionRule.class, "RetrieveDatastoreArtifactActionRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(storeDatastoreArtifactPinRuleEClass, StoreDatastoreArtifactPinRule.class, "StoreDatastoreArtifactPinRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(storeDatastoreArtifactActionRuleEClass, StoreDatastoreArtifactActionRule.class, "StoreDatastoreArtifactActionRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(datastoreRuleEClass, DatastoreRule.class, "DatastoreRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(retrieveDatastoreArtifactRuleEClass, RetrieveDatastoreArtifactRule.class, "RetrieveDatastoreArtifactRule", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(storeDatastoreArtifactRuleEClass, StoreDatastoreArtifactRule.class, "StoreDatastoreArtifactRule", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(callOperationActionRuleEClass, CallOperationActionRule.class, "CallOperationActionRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(sanReusableTaskRuleEClass, SANReusableTaskRule.class, "SANReusableTaskRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(loopNodeRuleEClass, LoopNodeRule.class, "LoopNodeRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(expressionRuleEClass, ExpressionRule.class, "ExpressionRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mapRuleEClass, MapRule.class, "MapRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(organizationRuleEClass, OrganizationRule.class, "OrganizationRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(personRuleEClass, PersonRule.class, "PersonRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(roleRuleEClass, RoleRule.class, "RoleRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(staffAssignmentRuleEClass, StaffAssignmentRule.class, "StaffAssignmentRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(fdlOptimizationRuleEClass, FDLOptimizationRule.class, "FDLOptimizationRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
	}

} //ModelPackageImpl
