/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.fdl.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.btools.bom.model.processes.actions.CallOperationAction;
import com.ibm.btools.bom.model.processes.activities.ActivityEdge;
import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.bom.model.processes.activities.ObjectFlow;
import com.ibm.btools.bom.model.processes.activities.ObjectPin;
import com.ibm.btools.bom.model.processes.activities.PinSet;
import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.fdl.FdlPackage;
import com.ibm.btools.te.ilm.heuristics.fdl.FlowRule;
import com.ibm.btools.te.ilm.heuristics.helper.BomUtils;
import com.ibm.btools.fdl.model.DataFlow;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Flow Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class FlowRuleImpl extends ConnectorRuleImpl implements FlowRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FlowRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return FdlPackage.Literals.FLOW_RULE;
	}

	/**
	 * Source : BOM Activity Edge, Source PinSet, Target PinSet
	 * Target : FDL Control Flow and Data Flow (optional) 
	 */
	public boolean transformSource2Target()
	{
		LoggingUtil.traceEntry(this, "transformSource2Target");
		
		if (isComplete())
			return true;
		if (getSource() == null || getSource().isEmpty())
			return false;
			
		ActivityEdge edge = (ActivityEdge)getSource().get(0);
		PinSet srcPinSet = (PinSet)getSource().get(1);
		PinSet tarPinSet = (PinSet)getSource().get(2);

		if (isFirstTimeExec())
		{		
			setFirstTimeExec(false);
//			ArrayList pinSets = new ArrayList();
//			pinSets.add(srcPinSet);
//			pinSets.add(tarPinSet);
//			FlowRule rule = (FlowRule)TransformationUtil.getRuleForSource(getRoot(),FlowRule.class,pinSets,ControlFlow.class);
//			if (rule != null)
//			{
//				ctrlFlow = (ControlFlow)rule.getTarget().get(0);
//				getTarget().add(ctrlFlow);
//				if (rule.getTarget().size() > 1)
//				{
//					dataFlow = (DataFlow)rule.getTarget().get(1);
//				} else {
//					dataFlow = createDataFlow(edge);
//				}
//			} else {
				// Create a FDL ControlFlow regardless of whether the BOM edge
				// is an Object or Control Flow
				ctrlFlow = com.ibm.btools.fdl.model.impl.ModelFactoryImpl.eINSTANCE.createControlFlow();
				//ctrlFlow.setName(edge.getName());
				getTarget().add(ctrlFlow);
				dataFlow = createDataFlow(edge);
//			}
		}
		updateDataMapping(edge,srcPinSet,tarPinSet);
		
		executeHandlers();
		
		LoggingUtil.traceExit(this, "transformSource2Target");
		return true;
	}

	private DataFlow createDataFlow(ActivityEdge edge) {
		DataFlow dataFlow;
		if ((edge instanceof ObjectFlow) &&
			(edge.getSource() instanceof ObjectPin) &&
			(edge.getTarget() instanceof ObjectPin) 
			)
		{
			//TODO: check if this is okay
			PinSet pinSet = (PinSet)BomUtils.findTargetSet(edge);
			if( pinSet instanceof InputPinSet && ((InputPinSet)pinSet).getAction() instanceof CallOperationAction){
				//for CallOperationAction, if the edge is connected to the target pin of the CallOperationAction,
				//do not create data connector
				if(edge.getTarget()== ((CallOperationAction)((InputPinSet)pinSet).getAction()).getTarget())
					return null;
			}
			// Create a FDL DataFlow
			dataFlow = com.ibm.btools.fdl.model.ModelFactory.eINSTANCE.createDataFlow();
			dataFlow.setName(edge.getName());	
			getTarget().add(dataFlow);
			return dataFlow;
		} else {
			return null;
		}
	}
} //FlowRuleImpl
