/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.fdl.util;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import com.ibm.btools.te.framework.TransformationRule;

import com.ibm.btools.te.ilm.heuristics.fdl.*;


import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see com.ibm.btools.te.ilm.heuristics.fdl.FdlPackage
 * @generated
 */
public class FdlAdapterFactory extends AdapterFactoryImpl {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static FdlPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FdlAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = FdlPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch the delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FdlSwitch modelSwitch =
		new FdlSwitch() {
			public Object caseControlActionRule(ControlActionRule object) {
				return createControlActionRuleAdapter();
			}
			public Object caseDecisionRule(DecisionRule object) {
				return createDecisionRuleAdapter();
			}
			public Object caseMergeRule(MergeRule object) {
				return createMergeRuleAdapter();
			}
			public Object caseJoinRule(JoinRule object) {
				return createJoinRuleAdapter();
			}
			public Object caseForkRule(ForkRule object) {
				return createForkRuleAdapter();
			}
			public Object caseContainerRule(ContainerRule object) {
				return createContainerRuleAdapter();
			}
			public Object caseConnectorRule(ConnectorRule object) {
				return createConnectorRuleAdapter();
			}
			public Object caseSANNestedProcessRule(SANNestedProcessRule object) {
				return createSANNestedProcessRuleAdapter();
			}
			public Object caseConnectableRule(ConnectableRule object) {
				return createConnectableRuleAdapter();
			}
			public Object caseBlockRule(BlockRule object) {
				return createBlockRuleAdapter();
			}
			public Object caseSANTaskRule(SANTaskRule object) {
				return createSANTaskRuleAdapter();
			}
			public Object caseCallBehaviorActionRule(CallBehaviorActionRule object) {
				return createCallBehaviorActionRuleAdapter();
			}
			public Object caseProcessWalkingRule(ProcessWalkingRule object) {
				return createProcessWalkingRuleAdapter();
			}
			public Object caseConcurrentBranchRule(ConcurrentBranchRule object) {
				return createConcurrentBranchRuleAdapter();
			}
			public Object caseProcessRule(ProcessRule object) {
				return createProcessRuleAdapter();
			}
			public Object caseExclusiveBranchRule(ExclusiveBranchRule object) {
				return createExclusiveBranchRuleAdapter();
			}
			public Object caseFlattenRule(FlattenRule object) {
				return createFlattenRuleAdapter();
			}
			public Object caseAbstractFdlProcDefRule(AbstractFdlProcDefRule object) {
				return createAbstractFdlProcDefRuleAdapter();
			}
			public Object caseSANReusableProcessRule(SANReusableProcessRule object) {
				return createSANReusableProcessRuleAdapter();
			}
			public Object caseAbstractFdlDataStructRule(AbstractFdlDataStructRule object) {
				return createAbstractFdlDataStructRuleAdapter();
			}
			public Object caseDataStructureRule(DataStructureRule object) {
				return createDataStructureRuleAdapter();
			}
			public Object caseBasicDataTypeRule(BasicDataTypeRule object) {
				return createBasicDataTypeRuleAdapter();
			}
			public Object caseDataTypeRule(DataTypeRule object) {
				return createDataTypeRuleAdapter();
			}
			public Object caseMemberDeclRule(MemberDeclRule object) {
				return createMemberDeclRuleAdapter();
			}
			public Object caseDataFlowRule(DataFlowRule object) {
				return createDataFlowRuleAdapter();
			}
			public Object caseFlowRule(FlowRule object) {
				return createFlowRuleAdapter();
			}
			public Object caseActivityRule(ActivityRule object) {
				return createActivityRuleAdapter();
			}
			public Object caseDataMappingRule(DataMappingRule object) {
				return createDataMappingRuleAdapter();
			}
			public Object caseContainmentRule(ContainmentRule object) {
				return createContainmentRuleAdapter();
			}
			public Object caseProgramRule(ProgramRule object) {
				return createProgramRuleAdapter();
			}
			public Object caseCategoryRule(CategoryRule object) {
				return createCategoryRuleAdapter();
			}
			public Object caseRetrieveDatastoreArtifactPinRule(RetrieveDatastoreArtifactPinRule object) {
				return createRetrieveDatastoreArtifactPinRuleAdapter();
			}
			public Object caseRetrieveDatastoreArtifactActionRule(RetrieveDatastoreArtifactActionRule object) {
				return createRetrieveDatastoreArtifactActionRuleAdapter();
			}
			public Object caseStoreDatastoreArtifactPinRule(StoreDatastoreArtifactPinRule object) {
				return createStoreDatastoreArtifactPinRuleAdapter();
			}
			public Object caseStoreDatastoreArtifactActionRule(StoreDatastoreArtifactActionRule object) {
				return createStoreDatastoreArtifactActionRuleAdapter();
			}
			public Object caseDatastoreRule(DatastoreRule object) {
				return createDatastoreRuleAdapter();
			}
			public Object caseRetrieveDatastoreArtifactRule(RetrieveDatastoreArtifactRule object) {
				return createRetrieveDatastoreArtifactRuleAdapter();
			}
			public Object caseStoreDatastoreArtifactRule(StoreDatastoreArtifactRule object) {
				return createStoreDatastoreArtifactRuleAdapter();
			}
			public Object caseCallOperationActionRule(CallOperationActionRule object) {
				return createCallOperationActionRuleAdapter();
			}
			public Object caseSANReusableTaskRule(SANReusableTaskRule object) {
				return createSANReusableTaskRuleAdapter();
			}
			public Object caseLoopNodeRule(LoopNodeRule object) {
				return createLoopNodeRuleAdapter();
			}
			public Object caseExpressionRule(ExpressionRule object) {
				return createExpressionRuleAdapter();
			}
			public Object caseMapRule(MapRule object) {
				return createMapRuleAdapter();
			}
			public Object caseOrganizationRule(OrganizationRule object) {
				return createOrganizationRuleAdapter();
			}
			public Object casePersonRule(PersonRule object) {
				return createPersonRuleAdapter();
			}
			public Object caseRoleRule(RoleRule object) {
				return createRoleRuleAdapter();
			}
			public Object caseStaffAssignmentRule(StaffAssignmentRule object) {
				return createStaffAssignmentRuleAdapter();
			}
			public Object caseFDLOptimizationRule(FDLOptimizationRule object) {
				return createFDLOptimizationRuleAdapter();
			}
			public Object caseTransformationRule(TransformationRule object) {
				return createTransformationRuleAdapter();
			}
			public Object defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	public Adapter createAdapter(Notifier target) {
		return (Adapter)modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ControlActionRule <em>Control Action Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ControlActionRule
	 * @generated
	 */
	public Adapter createControlActionRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.DecisionRule <em>Decision Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.DecisionRule
	 * @generated
	 */
	public Adapter createDecisionRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.MergeRule <em>Merge Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.MergeRule
	 * @generated
	 */
	public Adapter createMergeRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.JoinRule <em>Join Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.JoinRule
	 * @generated
	 */
	public Adapter createJoinRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ForkRule <em>Fork Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ForkRule
	 * @generated
	 */
	public Adapter createForkRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ContainerRule <em>Container Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ContainerRule
	 * @generated
	 */
	public Adapter createContainerRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ConnectorRule <em>Connector Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ConnectorRule
	 * @generated
	 */
	public Adapter createConnectorRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.SANNestedProcessRule <em>SAN Nested Process Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.SANNestedProcessRule
	 * @generated
	 */
	public Adapter createSANNestedProcessRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ConnectableRule <em>Connectable Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ConnectableRule
	 * @generated
	 */
	public Adapter createConnectableRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.BlockRule <em>Block Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.BlockRule
	 * @generated
	 */
	public Adapter createBlockRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.SANTaskRule <em>SAN Task Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.SANTaskRule
	 * @generated
	 */
	public Adapter createSANTaskRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.CallBehaviorActionRule <em>Call Behavior Action Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.CallBehaviorActionRule
	 * @generated
	 */
	public Adapter createCallBehaviorActionRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ProcessWalkingRule <em>Process Walking Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ProcessWalkingRule
	 * @generated
	 */
	public Adapter createProcessWalkingRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ConcurrentBranchRule <em>Concurrent Branch Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ConcurrentBranchRule
	 * @generated
	 */
	public Adapter createConcurrentBranchRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ProcessRule <em>Process Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ProcessRule
	 * @generated
	 */
	public Adapter createProcessRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ExclusiveBranchRule <em>Exclusive Branch Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ExclusiveBranchRule
	 * @generated
	 */
	public Adapter createExclusiveBranchRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.FlattenRule <em>Flatten Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.FlattenRule
	 * @generated
	 */
	public Adapter createFlattenRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.AbstractFdlProcDefRule <em>Abstract Fdl Proc Def Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.AbstractFdlProcDefRule
	 * @generated
	 */
	public Adapter createAbstractFdlProcDefRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.SANReusableProcessRule <em>SAN Reusable Process Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.SANReusableProcessRule
	 * @generated
	 */
	public Adapter createSANReusableProcessRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.AbstractFdlDataStructRule <em>Abstract Fdl Data Struct Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.AbstractFdlDataStructRule
	 * @generated
	 */
	public Adapter createAbstractFdlDataStructRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.DataStructureRule <em>Data Structure Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.DataStructureRule
	 * @generated
	 */
	public Adapter createDataStructureRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.BasicDataTypeRule <em>Basic Data Type Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.BasicDataTypeRule
	 * @generated
	 */
	public Adapter createBasicDataTypeRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.DataTypeRule <em>Data Type Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.DataTypeRule
	 * @generated
	 */
	public Adapter createDataTypeRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.MemberDeclRule <em>Member Decl Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.MemberDeclRule
	 * @generated
	 */
	public Adapter createMemberDeclRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.DataFlowRule <em>Data Flow Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.DataFlowRule
	 * @generated
	 */
	public Adapter createDataFlowRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.FlowRule <em>Flow Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.FlowRule
	 * @generated
	 */
	public Adapter createFlowRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ActivityRule <em>Activity Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ActivityRule
	 * @generated
	 */
	public Adapter createActivityRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.DataMappingRule <em>Data Mapping Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.DataMappingRule
	 * @generated
	 */
	public Adapter createDataMappingRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ContainmentRule <em>Containment Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ContainmentRule
	 * @generated
	 */
	public Adapter createContainmentRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ProgramRule <em>Program Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ProgramRule
	 * @generated
	 */
	public Adapter createProgramRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.CategoryRule <em>Category Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.CategoryRule
	 * @generated
	 */
	public Adapter createCategoryRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.RetrieveDatastoreArtifactPinRule <em>Retrieve Datastore Artifact Pin Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.RetrieveDatastoreArtifactPinRule
	 * @generated
	 */
	public Adapter createRetrieveDatastoreArtifactPinRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.RetrieveDatastoreArtifactActionRule <em>Retrieve Datastore Artifact Action Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.RetrieveDatastoreArtifactActionRule
	 * @generated
	 */
	public Adapter createRetrieveDatastoreArtifactActionRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.StoreDatastoreArtifactPinRule <em>Store Datastore Artifact Pin Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.StoreDatastoreArtifactPinRule
	 * @generated
	 */
	public Adapter createStoreDatastoreArtifactPinRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.StoreDatastoreArtifactActionRule <em>Store Datastore Artifact Action Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.StoreDatastoreArtifactActionRule
	 * @generated
	 */
	public Adapter createStoreDatastoreArtifactActionRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.DatastoreRule <em>Datastore Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.DatastoreRule
	 * @generated
	 */
	public Adapter createDatastoreRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.RetrieveDatastoreArtifactRule <em>Retrieve Datastore Artifact Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.RetrieveDatastoreArtifactRule
	 * @generated
	 */
	public Adapter createRetrieveDatastoreArtifactRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.StoreDatastoreArtifactRule <em>Store Datastore Artifact Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.StoreDatastoreArtifactRule
	 * @generated
	 */
	public Adapter createStoreDatastoreArtifactRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.CallOperationActionRule <em>Call Operation Action Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.CallOperationActionRule
	 * @generated
	 */
	public Adapter createCallOperationActionRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.SANReusableTaskRule <em>SAN Reusable Task Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.SANReusableTaskRule
	 * @generated
	 */
	public Adapter createSANReusableTaskRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.LoopNodeRule <em>Loop Node Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.LoopNodeRule
	 * @generated
	 */
	public Adapter createLoopNodeRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.ExpressionRule <em>Expression Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.ExpressionRule
	 * @generated
	 */
	public Adapter createExpressionRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.OrganizationRule <em>Organization Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.OrganizationRule
	 * @generated
	 */
	public Adapter createOrganizationRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.PersonRule <em>Person Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.PersonRule
	 * @generated
	 */
	public Adapter createPersonRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.StaffAssignmentRule <em>Staff Assignment Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.StaffAssignmentRule
	 * @generated
	 */
	public Adapter createStaffAssignmentRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.FDLOptimizationRule <em>FDL Optimization Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.FDLOptimizationRule
	 * @generated
	 */
	public Adapter createFDLOptimizationRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.MapRule <em>Map Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.MapRule
	 * @generated
	 */
	public Adapter createMapRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.ilm.heuristics.fdl.RoleRule <em>Role Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.ilm.heuristics.fdl.RoleRule
	 * @generated
	 */
	public Adapter createRoleRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.ibm.btools.te.framework.TransformationRule <em>Transformation Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.ibm.btools.te.framework.TransformationRule
	 * @generated
	 */
	public Adapter createTransformationRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //ModelAdapterFactory
