package com.ibm.btools.te.ilm.heuristics.fdl.util;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import java.util.ArrayList;
import java.util.List;

import com.ibm.btools.fdl.model.Block;
import com.ibm.btools.fdl.model.PaperSize;
import com.ibm.btools.te.ilm.LoggingUtil;

/**
 * Class handles layout fdl block
 *
 */
class FdlBlockGraphLayoutManager extends AbstractFdlLayoutManager {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2008, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

			
	protected Block ivFdlBlock;
	
	protected FdlBlockGraphLayoutManager(Block fdlBlock){
		ivFdlBlock = fdlBlock;
	}
	
	protected void setBlock(Block fdlBlock){
		ivFdlBlock = fdlBlock;
	}
	/**
	 * Returns a list of nodes in the block that to be layed out.
	 */
	protected List getModelNodes() {
		LoggingUtil.traceEntry(this, "getModelNodes()");
		ArrayList nodes = new ArrayList();
		if(!ivFdlBlock.getSource().isEmpty()){
			nodes.addAll(ivFdlBlock.getSource());
		}
		if(!ivFdlBlock.getSink().isEmpty()){
			nodes.addAll(ivFdlBlock.getSink());
		}
		if(!ivFdlBlock.getConstructs().isEmpty()){
			nodes.addAll(ivFdlBlock.getConstructs());
		}
		LoggingUtil.traceExit(this, "getModelNodes()");
		return nodes;
	}
	
	/**
	 * Set block paper size
	 */
	protected void setPaperSize(PaperSize paperSize){
		ivFdlBlock.setPaperSize(paperSize);
	}

}
