package com.ibm.btools.te.ilm.heuristics.fdl.util;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

/**
 * Contains constants used in FDL mapping
 */
public abstract class FdlConstants {
	
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	
	/* FDL empty program name */
	public static final String NOOP_PROGRAM_NAME = "FMCINTERNALNOOP";
	
	/* FDL top-level data structure name (used to refer to the entire structure */
	public static final String TOP_STRUCTURE_NAME = "_STRUCT"; 

	/* predefined key for the FDL name registry in the transformation context */
	static final String FDL_NAME_REGISTRY_KEY = "FdlNameRegistryInContext";
	
	/* attribute names used for input/output datastructure for retrieve and store datastore programs */
	public static final String DATASTORE_LENGTH_NAME = "length";
	public static final String DATASTORE_IS_REMOVE_NAME = "isRemove";
	public static final String DATASTORE_AT_BEGINNING_NAME = "atBeginning";
	public static final String DATASTORE_OVERFLOW_NAME = "overflow";
	public static final String DATASTORE_IS_INSERT_NAME = "isInsert";
	
	/* suffix of retrieve datastore program input data structure name */
	public static final String DATASTORE_RETRIEVE_IN_SUFFIX = "_R_IN";
	
	/* suffix of retrieve datastore program output data structure name */
	public static final String DATASTORE_RETRIEVE_OUT_SUFFIX = "_R_OUT";
	
	/* suffix of store datastore program input data structure name */
	public static final String DATASTORE_STORE_IN_SUFFIX = "_W_IN";
	
	/* suffix of retrieve datastore program name */
	public static final String DATASTORE_RETRIEVE_PROGRAM_SUFFIX = "_R";
	
	/* suffix of store datastore program name */
	public static final String DATASTORE_STORE_PROGRAM_SUFFIX = "_W";
	
	/* suffix for empty activity name */
	public static final String EMPTY_NAME_SUFFIX = "_NOOP";
	
	/* description for empty activity representing input/output pin set of nested SAN */
	public static final String EMPTY_DESCRIPTION = "TE added EMPTY program activity to represent synchronization point of InputPinSet/OutputPinSet of StructuredActivityNode"; 

	/* predefined key used for store mapped ouput pin set activity for faltten rule in the transformation context */
	public static String FDL_MAPPED_OUTPUT_PIN_SET_ACTIVITY_REGISTRY = "FDL_MAPPED_OUTPUT_PIN_SET_ACTIVITY_REGISTRY";
	
	/* predefined key used for container prefix in transformation context */
	public static final String FDL_CONTAINER_CONTEXT_KEY_PREFIX="FDLContainer";

	/* predefined key used for category in transformation context */
	public static final String FDL_CATEGORY_CONTEXT_KEY_PREFIX="FDLCategory";

	/* predefined key used for program in transformation context */
	public static final String FDL_PROGRAM_CONTEXT_KEY_PREFIX="FDLProgram";

	/* TE defined default empty container name */
	//public static final String EMPTY_CONTAINER_NAME="Default Empty Container";
	public static final String EMPTY_CONTAINER_NAME="Default Data Structure";
	
	/* TE used string representing boolean true */
	public static final String TRUE_INT_STRING = "1";
	
	/* TE used string representing boolean false */
	public static final String FALSE_INT_STRING = "0";
	
	/* suffix for function program name */
	public static final String FUNCTION_PROGRAM_NAME_SUFFIX = "_FUNC";
	
	/* description for function program */
	public static final String FUNCTION_PROGRAM_DESCRIPTION = "map function program";
	
	/* description for function program */
	public static final String LOOP_ACCUMULATION_PROGRAM_DESCRIPTION = "loop object pin accumulation program";
		
}
