/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.fdl.util;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import com.ibm.btools.te.framework.TransformationRule;

import com.ibm.btools.te.ilm.heuristics.fdl.*;


import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see com.ibm.btools.te.ilm.heuristics.fdl.FdlPackage
 * @generated
 */
public class FdlSwitch {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static FdlPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FdlSwitch() {
		if (modelPackage == null) {
			modelPackage = FdlPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public Object doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected Object doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch((EClass)eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected Object doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case FdlPackage.CONTROL_ACTION_RULE: {
				ControlActionRule controlActionRule = (ControlActionRule)theEObject;
				Object result = caseControlActionRule(controlActionRule);
				if (result == null) result = caseConnectableRule(controlActionRule);
				if (result == null) result = caseAbstractFdlProcDefRule(controlActionRule);
				if (result == null) result = caseTransformationRule(controlActionRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.DECISION_RULE: {
				DecisionRule decisionRule = (DecisionRule)theEObject;
				Object result = caseDecisionRule(decisionRule);
				if (result == null) result = caseControlActionRule(decisionRule);
				if (result == null) result = caseConnectableRule(decisionRule);
				if (result == null) result = caseAbstractFdlProcDefRule(decisionRule);
				if (result == null) result = caseTransformationRule(decisionRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.MERGE_RULE: {
				MergeRule mergeRule = (MergeRule)theEObject;
				Object result = caseMergeRule(mergeRule);
				if (result == null) result = caseControlActionRule(mergeRule);
				if (result == null) result = caseConnectableRule(mergeRule);
				if (result == null) result = caseAbstractFdlProcDefRule(mergeRule);
				if (result == null) result = caseTransformationRule(mergeRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.JOIN_RULE: {
				JoinRule joinRule = (JoinRule)theEObject;
				Object result = caseJoinRule(joinRule);
				if (result == null) result = caseControlActionRule(joinRule);
				if (result == null) result = caseConnectableRule(joinRule);
				if (result == null) result = caseAbstractFdlProcDefRule(joinRule);
				if (result == null) result = caseTransformationRule(joinRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.FORK_RULE: {
				ForkRule forkRule = (ForkRule)theEObject;
				Object result = caseForkRule(forkRule);
				if (result == null) result = caseControlActionRule(forkRule);
				if (result == null) result = caseConnectableRule(forkRule);
				if (result == null) result = caseAbstractFdlProcDefRule(forkRule);
				if (result == null) result = caseTransformationRule(forkRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.CONTAINER_RULE: {
				ContainerRule containerRule = (ContainerRule)theEObject;
				Object result = caseContainerRule(containerRule);
				if (result == null) result = caseAbstractFdlDataStructRule(containerRule);
				if (result == null) result = caseTransformationRule(containerRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.CONNECTOR_RULE: {
				ConnectorRule connectorRule = (ConnectorRule)theEObject;
				Object result = caseConnectorRule(connectorRule);
				if (result == null) result = caseAbstractFdlProcDefRule(connectorRule);
				if (result == null) result = caseTransformationRule(connectorRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.SAN_NESTED_PROCESS_RULE: {
				SANNestedProcessRule sanNestedProcessRule = (SANNestedProcessRule)theEObject;
				Object result = caseSANNestedProcessRule(sanNestedProcessRule);
				if (result == null) result = caseAbstractFdlProcDefRule(sanNestedProcessRule);
				if (result == null) result = caseTransformationRule(sanNestedProcessRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.CONNECTABLE_RULE: {
				ConnectableRule connectableRule = (ConnectableRule)theEObject;
				Object result = caseConnectableRule(connectableRule);
				if (result == null) result = caseAbstractFdlProcDefRule(connectableRule);
				if (result == null) result = caseTransformationRule(connectableRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.BLOCK_RULE: {
				BlockRule blockRule = (BlockRule)theEObject;
				Object result = caseBlockRule(blockRule);
				if (result == null) result = caseContainmentRule(blockRule);
				if (result == null) result = caseConnectableRule(blockRule);
				if (result == null) result = caseAbstractFdlProcDefRule(blockRule);
				if (result == null) result = caseTransformationRule(blockRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.SAN_TASK_RULE: {
				SANTaskRule sanTaskRule = (SANTaskRule)theEObject;
				Object result = caseSANTaskRule(sanTaskRule);
				if (result == null) result = caseConnectableRule(sanTaskRule);
				if (result == null) result = caseAbstractFdlProcDefRule(sanTaskRule);
				if (result == null) result = caseTransformationRule(sanTaskRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.CALL_BEHAVIOR_ACTION_RULE: {
				CallBehaviorActionRule callBehaviorActionRule = (CallBehaviorActionRule)theEObject;
				Object result = caseCallBehaviorActionRule(callBehaviorActionRule);
				if (result == null) result = caseConnectableRule(callBehaviorActionRule);
				if (result == null) result = caseAbstractFdlProcDefRule(callBehaviorActionRule);
				if (result == null) result = caseTransformationRule(callBehaviorActionRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.PROCESS_WALKING_RULE: {
				ProcessWalkingRule processWalkingRule = (ProcessWalkingRule)theEObject;
				Object result = caseProcessWalkingRule(processWalkingRule);
				if (result == null) result = caseConnectableRule(processWalkingRule);
				if (result == null) result = caseAbstractFdlProcDefRule(processWalkingRule);
				if (result == null) result = caseTransformationRule(processWalkingRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.CONCURRENT_BRANCH_RULE: {
				ConcurrentBranchRule concurrentBranchRule = (ConcurrentBranchRule)theEObject;
				Object result = caseConcurrentBranchRule(concurrentBranchRule);
				if (result == null) result = caseProcessWalkingRule(concurrentBranchRule);
				if (result == null) result = caseConnectableRule(concurrentBranchRule);
				if (result == null) result = caseAbstractFdlProcDefRule(concurrentBranchRule);
				if (result == null) result = caseTransformationRule(concurrentBranchRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.PROCESS_RULE: {
				ProcessRule processRule = (ProcessRule)theEObject;
				Object result = caseProcessRule(processRule);
				if (result == null) result = caseProcessWalkingRule(processRule);
				if (result == null) result = caseConnectableRule(processRule);
				if (result == null) result = caseAbstractFdlProcDefRule(processRule);
				if (result == null) result = caseTransformationRule(processRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.EXCLUSIVE_BRANCH_RULE: {
				ExclusiveBranchRule exclusiveBranchRule = (ExclusiveBranchRule)theEObject;
				Object result = caseExclusiveBranchRule(exclusiveBranchRule);
				if (result == null) result = caseProcessWalkingRule(exclusiveBranchRule);
				if (result == null) result = caseConnectableRule(exclusiveBranchRule);
				if (result == null) result = caseAbstractFdlProcDefRule(exclusiveBranchRule);
				if (result == null) result = caseTransformationRule(exclusiveBranchRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.FLATTEN_RULE: {
				FlattenRule flattenRule = (FlattenRule)theEObject;
				Object result = caseFlattenRule(flattenRule);
				if (result == null) result = caseConnectableRule(flattenRule);
				if (result == null) result = caseAbstractFdlProcDefRule(flattenRule);
				if (result == null) result = caseTransformationRule(flattenRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.ABSTRACT_FDL_PROC_DEF_RULE: {
				AbstractFdlProcDefRule abstractFdlProcDefRule = (AbstractFdlProcDefRule)theEObject;
				Object result = caseAbstractFdlProcDefRule(abstractFdlProcDefRule);
				if (result == null) result = caseTransformationRule(abstractFdlProcDefRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.SAN_REUSABLE_PROCESS_RULE: {
				SANReusableProcessRule sanReusableProcessRule = (SANReusableProcessRule)theEObject;
				Object result = caseSANReusableProcessRule(sanReusableProcessRule);
				if (result == null) result = caseContainmentRule(sanReusableProcessRule);
				if (result == null) result = caseConnectableRule(sanReusableProcessRule);
				if (result == null) result = caseAbstractFdlProcDefRule(sanReusableProcessRule);
				if (result == null) result = caseTransformationRule(sanReusableProcessRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.ABSTRACT_FDL_DATA_STRUCT_RULE: {
				AbstractFdlDataStructRule abstractFdlDataStructRule = (AbstractFdlDataStructRule)theEObject;
				Object result = caseAbstractFdlDataStructRule(abstractFdlDataStructRule);
				if (result == null) result = caseTransformationRule(abstractFdlDataStructRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.DATA_STRUCTURE_RULE: {
				DataStructureRule dataStructureRule = (DataStructureRule)theEObject;
				Object result = caseDataStructureRule(dataStructureRule);
				if (result == null) result = caseAbstractFdlDataStructRule(dataStructureRule);
				if (result == null) result = caseTransformationRule(dataStructureRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.BASIC_DATA_TYPE_RULE: {
				BasicDataTypeRule basicDataTypeRule = (BasicDataTypeRule)theEObject;
				Object result = caseBasicDataTypeRule(basicDataTypeRule);
				if (result == null) result = caseAbstractFdlDataStructRule(basicDataTypeRule);
				if (result == null) result = caseTransformationRule(basicDataTypeRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.DATA_TYPE_RULE: {
				DataTypeRule dataTypeRule = (DataTypeRule)theEObject;
				Object result = caseDataTypeRule(dataTypeRule);
				if (result == null) result = caseAbstractFdlDataStructRule(dataTypeRule);
				if (result == null) result = caseTransformationRule(dataTypeRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.MEMBER_DECL_RULE: {
				MemberDeclRule memberDeclRule = (MemberDeclRule)theEObject;
				Object result = caseMemberDeclRule(memberDeclRule);
				if (result == null) result = caseAbstractFdlDataStructRule(memberDeclRule);
				if (result == null) result = caseTransformationRule(memberDeclRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.DATA_FLOW_RULE: {
				DataFlowRule dataFlowRule = (DataFlowRule)theEObject;
				Object result = caseDataFlowRule(dataFlowRule);
				if (result == null) result = caseConnectorRule(dataFlowRule);
				if (result == null) result = caseAbstractFdlProcDefRule(dataFlowRule);
				if (result == null) result = caseTransformationRule(dataFlowRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.FLOW_RULE: {
				FlowRule flowRule = (FlowRule)theEObject;
				Object result = caseFlowRule(flowRule);
				if (result == null) result = caseConnectorRule(flowRule);
				if (result == null) result = caseAbstractFdlProcDefRule(flowRule);
				if (result == null) result = caseTransformationRule(flowRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.ACTIVITY_RULE: {
				ActivityRule activityRule = (ActivityRule)theEObject;
				Object result = caseActivityRule(activityRule);
				if (result == null) result = caseAbstractFdlProcDefRule(activityRule);
				if (result == null) result = caseTransformationRule(activityRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.DATA_MAPPING_RULE: {
				DataMappingRule dataMappingRule = (DataMappingRule)theEObject;
				Object result = caseDataMappingRule(dataMappingRule);
				if (result == null) result = caseAbstractFdlDataStructRule(dataMappingRule);
				if (result == null) result = caseTransformationRule(dataMappingRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.CONTAINMENT_RULE: {
				ContainmentRule containmentRule = (ContainmentRule)theEObject;
				Object result = caseContainmentRule(containmentRule);
				if (result == null) result = caseConnectableRule(containmentRule);
				if (result == null) result = caseAbstractFdlProcDefRule(containmentRule);
				if (result == null) result = caseTransformationRule(containmentRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.PROGRAM_RULE: {
				ProgramRule programRule = (ProgramRule)theEObject;
				Object result = caseProgramRule(programRule);
				if (result == null) result = caseAbstractFdlProcDefRule(programRule);
				if (result == null) result = caseTransformationRule(programRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.CATEGORY_RULE: {
				CategoryRule categoryRule = (CategoryRule)theEObject;
				Object result = caseCategoryRule(categoryRule);
				if (result == null) result = caseAbstractFdlProcDefRule(categoryRule);
				if (result == null) result = caseTransformationRule(categoryRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.RETRIEVE_DATASTORE_ARTIFACT_PIN_RULE: {
				RetrieveDatastoreArtifactPinRule retrieveDatastoreArtifactPinRule = (RetrieveDatastoreArtifactPinRule)theEObject;
				Object result = caseRetrieveDatastoreArtifactPinRule(retrieveDatastoreArtifactPinRule);
				if (result == null) result = caseRetrieveDatastoreArtifactRule(retrieveDatastoreArtifactPinRule);
				if (result == null) result = caseConnectableRule(retrieveDatastoreArtifactPinRule);
				if (result == null) result = caseAbstractFdlProcDefRule(retrieveDatastoreArtifactPinRule);
				if (result == null) result = caseTransformationRule(retrieveDatastoreArtifactPinRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.RETRIEVE_DATASTORE_ARTIFACT_ACTION_RULE: {
				RetrieveDatastoreArtifactActionRule retrieveDatastoreArtifactActionRule = (RetrieveDatastoreArtifactActionRule)theEObject;
				Object result = caseRetrieveDatastoreArtifactActionRule(retrieveDatastoreArtifactActionRule);
				if (result == null) result = caseRetrieveDatastoreArtifactRule(retrieveDatastoreArtifactActionRule);
				if (result == null) result = caseConnectableRule(retrieveDatastoreArtifactActionRule);
				if (result == null) result = caseAbstractFdlProcDefRule(retrieveDatastoreArtifactActionRule);
				if (result == null) result = caseTransformationRule(retrieveDatastoreArtifactActionRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.STORE_DATASTORE_ARTIFACT_PIN_RULE: {
				StoreDatastoreArtifactPinRule storeDatastoreArtifactPinRule = (StoreDatastoreArtifactPinRule)theEObject;
				Object result = caseStoreDatastoreArtifactPinRule(storeDatastoreArtifactPinRule);
				if (result == null) result = caseStoreDatastoreArtifactRule(storeDatastoreArtifactPinRule);
				if (result == null) result = caseConnectableRule(storeDatastoreArtifactPinRule);
				if (result == null) result = caseAbstractFdlProcDefRule(storeDatastoreArtifactPinRule);
				if (result == null) result = caseTransformationRule(storeDatastoreArtifactPinRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.STORE_DATASTORE_ARTIFACT_ACTION_RULE: {
				StoreDatastoreArtifactActionRule storeDatastoreArtifactActionRule = (StoreDatastoreArtifactActionRule)theEObject;
				Object result = caseStoreDatastoreArtifactActionRule(storeDatastoreArtifactActionRule);
				if (result == null) result = caseStoreDatastoreArtifactRule(storeDatastoreArtifactActionRule);
				if (result == null) result = caseConnectableRule(storeDatastoreArtifactActionRule);
				if (result == null) result = caseAbstractFdlProcDefRule(storeDatastoreArtifactActionRule);
				if (result == null) result = caseTransformationRule(storeDatastoreArtifactActionRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.DATASTORE_RULE: {
				DatastoreRule datastoreRule = (DatastoreRule)theEObject;
				Object result = caseDatastoreRule(datastoreRule);
				if (result == null) result = caseAbstractFdlProcDefRule(datastoreRule);
				if (result == null) result = caseTransformationRule(datastoreRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.RETRIEVE_DATASTORE_ARTIFACT_RULE: {
				RetrieveDatastoreArtifactRule retrieveDatastoreArtifactRule = (RetrieveDatastoreArtifactRule)theEObject;
				Object result = caseRetrieveDatastoreArtifactRule(retrieveDatastoreArtifactRule);
				if (result == null) result = caseConnectableRule(retrieveDatastoreArtifactRule);
				if (result == null) result = caseAbstractFdlProcDefRule(retrieveDatastoreArtifactRule);
				if (result == null) result = caseTransformationRule(retrieveDatastoreArtifactRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.STORE_DATASTORE_ARTIFACT_RULE: {
				StoreDatastoreArtifactRule storeDatastoreArtifactRule = (StoreDatastoreArtifactRule)theEObject;
				Object result = caseStoreDatastoreArtifactRule(storeDatastoreArtifactRule);
				if (result == null) result = caseConnectableRule(storeDatastoreArtifactRule);
				if (result == null) result = caseAbstractFdlProcDefRule(storeDatastoreArtifactRule);
				if (result == null) result = caseTransformationRule(storeDatastoreArtifactRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.CALL_OPERATION_ACTION_RULE: {
				CallOperationActionRule callOperationActionRule = (CallOperationActionRule)theEObject;
				Object result = caseCallOperationActionRule(callOperationActionRule);
				if (result == null) result = caseConnectableRule(callOperationActionRule);
				if (result == null) result = caseAbstractFdlProcDefRule(callOperationActionRule);
				if (result == null) result = caseTransformationRule(callOperationActionRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.SAN_REUSABLE_TASK_RULE: {
				SANReusableTaskRule sanReusableTaskRule = (SANReusableTaskRule)theEObject;
				Object result = caseSANReusableTaskRule(sanReusableTaskRule);
				if (result == null) result = caseConnectableRule(sanReusableTaskRule);
				if (result == null) result = caseAbstractFdlProcDefRule(sanReusableTaskRule);
				if (result == null) result = caseTransformationRule(sanReusableTaskRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.LOOP_NODE_RULE: {
				LoopNodeRule loopNodeRule = (LoopNodeRule)theEObject;
				Object result = caseLoopNodeRule(loopNodeRule);
				if (result == null) result = caseBlockRule(loopNodeRule);
				if (result == null) result = caseContainmentRule(loopNodeRule);
				if (result == null) result = caseConnectableRule(loopNodeRule);
				if (result == null) result = caseAbstractFdlProcDefRule(loopNodeRule);
				if (result == null) result = caseTransformationRule(loopNodeRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.EXPRESSION_RULE: {
				ExpressionRule expressionRule = (ExpressionRule)theEObject;
				Object result = caseExpressionRule(expressionRule);
				if (result == null) result = caseAbstractFdlProcDefRule(expressionRule);
				if (result == null) result = caseTransformationRule(expressionRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.MAP_RULE: {
				MapRule mapRule = (MapRule)theEObject;
				Object result = caseMapRule(mapRule);
				if (result == null) result = caseConnectableRule(mapRule);
				if (result == null) result = caseAbstractFdlProcDefRule(mapRule);
				if (result == null) result = caseTransformationRule(mapRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.ORGANIZATION_RULE: {
				OrganizationRule organizationRule = (OrganizationRule)theEObject;
				Object result = caseOrganizationRule(organizationRule);
				if (result == null) result = caseAbstractFdlProcDefRule(organizationRule);
				if (result == null) result = caseTransformationRule(organizationRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.PERSON_RULE: {
				PersonRule personRule = (PersonRule)theEObject;
				Object result = casePersonRule(personRule);
				if (result == null) result = caseAbstractFdlProcDefRule(personRule);
				if (result == null) result = caseTransformationRule(personRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.ROLE_RULE: {
				RoleRule roleRule = (RoleRule)theEObject;
				Object result = caseRoleRule(roleRule);
				if (result == null) result = caseAbstractFdlProcDefRule(roleRule);
				if (result == null) result = caseTransformationRule(roleRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.STAFF_ASSIGNMENT_RULE: {
				StaffAssignmentRule staffAssignmentRule = (StaffAssignmentRule)theEObject;
				Object result = caseStaffAssignmentRule(staffAssignmentRule);
				if (result == null) result = caseAbstractFdlProcDefRule(staffAssignmentRule);
				if (result == null) result = caseTransformationRule(staffAssignmentRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case FdlPackage.FDL_OPTIMIZATION_RULE: {
				FDLOptimizationRule fdlOptimizationRule = (FDLOptimizationRule)theEObject;
				Object result = caseFDLOptimizationRule(fdlOptimizationRule);
				if (result == null) result = caseTransformationRule(fdlOptimizationRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Control Action Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Control Action Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseControlActionRule(ControlActionRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Decision Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Decision Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseDecisionRule(DecisionRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Merge Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Merge Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseMergeRule(MergeRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Join Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Join Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseJoinRule(JoinRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Fork Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Fork Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseForkRule(ForkRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Container Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Container Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseContainerRule(ContainerRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Connector Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Connector Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseConnectorRule(ConnectorRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>SAN Nested Process Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>SAN Nested Process Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseSANNestedProcessRule(SANNestedProcessRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Connectable Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Connectable Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseConnectableRule(ConnectableRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Block Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Block Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBlockRule(BlockRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>SAN Task Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>SAN Task Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseSANTaskRule(SANTaskRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Call Behavior Action Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Call Behavior Action Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCallBehaviorActionRule(CallBehaviorActionRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Process Walking Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Process Walking Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseProcessWalkingRule(ProcessWalkingRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Concurrent Branch Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Concurrent Branch Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseConcurrentBranchRule(ConcurrentBranchRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Process Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Process Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseProcessRule(ProcessRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Exclusive Branch Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Exclusive Branch Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseExclusiveBranchRule(ExclusiveBranchRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Flatten Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Flatten Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseFlattenRule(FlattenRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Abstract Fdl Proc Def Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Abstract Fdl Proc Def Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseAbstractFdlProcDefRule(AbstractFdlProcDefRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>SAN Reusable Process Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>SAN Reusable Process Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseSANReusableProcessRule(SANReusableProcessRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Abstract Fdl Data Struct Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Abstract Fdl Data Struct Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseAbstractFdlDataStructRule(AbstractFdlDataStructRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Data Structure Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Data Structure Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseDataStructureRule(DataStructureRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Basic Data Type Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Basic Data Type Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBasicDataTypeRule(BasicDataTypeRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Data Type Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Data Type Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseDataTypeRule(DataTypeRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Member Decl Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Member Decl Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseMemberDeclRule(MemberDeclRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Data Flow Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Data Flow Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseDataFlowRule(DataFlowRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Flow Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Flow Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseFlowRule(FlowRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Activity Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Activity Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseActivityRule(ActivityRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Data Mapping Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Data Mapping Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseDataMappingRule(DataMappingRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Containment Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Containment Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseContainmentRule(ContainmentRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Program Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Program Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseProgramRule(ProgramRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Category Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Category Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCategoryRule(CategoryRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Retrieve Datastore Artifact Pin Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Retrieve Datastore Artifact Pin Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRetrieveDatastoreArtifactPinRule(RetrieveDatastoreArtifactPinRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Retrieve Datastore Artifact Action Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Retrieve Datastore Artifact Action Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRetrieveDatastoreArtifactActionRule(RetrieveDatastoreArtifactActionRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Store Datastore Artifact Pin Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Store Datastore Artifact Pin Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseStoreDatastoreArtifactPinRule(StoreDatastoreArtifactPinRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Store Datastore Artifact Action Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Store Datastore Artifact Action Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseStoreDatastoreArtifactActionRule(StoreDatastoreArtifactActionRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Datastore Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Datastore Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseDatastoreRule(DatastoreRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Retrieve Datastore Artifact Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Retrieve Datastore Artifact Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRetrieveDatastoreArtifactRule(RetrieveDatastoreArtifactRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Store Datastore Artifact Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Store Datastore Artifact Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseStoreDatastoreArtifactRule(StoreDatastoreArtifactRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Call Operation Action Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Call Operation Action Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCallOperationActionRule(CallOperationActionRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>SAN Reusable Task Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>SAN Reusable Task Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseSANReusableTaskRule(SANReusableTaskRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Loop Node Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Loop Node Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseLoopNodeRule(LoopNodeRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Expression Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Expression Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseExpressionRule(ExpressionRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Organization Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Organization Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseOrganizationRule(OrganizationRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Person Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Person Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object casePersonRule(PersonRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Staff Assignment Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Staff Assignment Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseStaffAssignmentRule(StaffAssignmentRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>FDL Optimization Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>FDL Optimization Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseFDLOptimizationRule(FDLOptimizationRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Map Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Map Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseMapRule(MapRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Role Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Role Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRoleRule(RoleRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Transformation Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Transformation Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseTransformationRule(TransformationRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public Object defaultCase(EObject object) {
		return null;
	}

} //ModelSwitch
