package com.ibm.btools.te.ilm.heuristics.helper;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.eclipse.wst.wsdl.Definition;
import org.osgi.framework.Bundle;

import com.ibm.btools.blm.ie.exprt.ExportSession;
import com.ibm.btools.blm.ie.exprt.option.BpelOptions;
import com.ibm.btools.blm.ie.exprt.option.DeployableElementWpsOptionsBean;
import com.ibm.btools.blm.ie.exprt.option.ProjectWpsOptionsBean;
import com.ibm.btools.blm.ie.exprt.option.WpsExportOptionsBean;
import com.ibm.btools.bom.model.artifacts.NamedElement;
import com.ibm.btools.ie.ui.ilm.config.model.TESetting;
import com.ibm.btools.te.attributes.helper.AttributeNameConstants;
import com.ibm.btools.te.attributes.helper.TechnicalAttributesHelper;
import com.ibm.btools.te.framework.TransformationContext;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.CrossProjectReferenceUtil;
import com.ibm.btools.te.ilm.ExportOperationConstants;
import com.ibm.btools.te.ilm.TransformationEngine;
import com.ibm.btools.te.ilm.WIDProjectUtil;
//import com.ibm.btools.te.logicalGroup.model.LogicalEntityRoot;
import com.ibm.btools.te.logicalGroup.model.LogicalEntityRoot;

/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

public class BpelOptionsUtil {
	
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	
	
	/**
	 * Returns true if the BpelOptions is set to a LongRunning Receive Reply Macroflow.
	 * @param context TransformationContext
	 * @return boolean 
	 */
//	public static boolean isTargetLongRunningReceiveReplyMacroflow(){
//		
//		//return BpelOptions.isBpelOptionsLongRunningReceiveReply(TransformationEngine.getExportSession());
//		return true;
//		
//	}
//	/**
//	 * Returns true if the BpelOptions is set to reuse the BPEL Variable between for the Input and Output of an Invoke.
//	 * @param context TransformationContext
//	 * @return boolean
//	 */
//	public static boolean reuseBPELVariableForInputAndOutput1(NamedElement activity){
//	
//		Object emptyStyle = TechnicalAttributesHelper.getAttributeValue(activity, AttributeNameConstants.BPEL_PROCESS_USE_SAME_INPUT_OUTPUT_VARIABLE);
//		if(emptyStyle == null || emptyStyle.equals("")){
//			return true;
//		}else{
//			return ((Boolean)emptyStyle).booleanValue();
//		}
//	}
	
	/**
	 * Returns true if the BpelOptions is set to generate a WSI compliant WSDL Interface - single Part WSDL.
	 * @param context TransformationContext
	 * @return boolean
	 */
	public static boolean isTargetWSICompliant(){

		//return BpelOptions.isTargetWSICompliant(TransformationEngine.getExportSession());
		return true;
	}
	
	/**
	 * Returns true if the BpelOptions is set to generate a WSI compliant WSDL Interface - single Part WSDL.
	 * @param context TransformationContext
	 * @return boolean
	 */
	public static boolean generateStaffActivity51Compliant(){

		//return true;
		return false;

	}
	
	/**
	 * Returns true if the BpelOptions is set to generate a WSI compliant WSDL Interface - single Part WSDL.
	 * @param context TransformationContext
	 * @return boolean
	 */
	public static boolean isTargetDiamondCompatible(){

		//return BpelOptions.isTargetDiamondCompatible(TransformationEngine.getExportSession());
		return true;

	}
	
	public static boolean isAlwaysGenerateWraperComplexType(){
		return true;
		//return false;
	}
	
	/**
	 * Returns true if the BpelOptions is set to generate a WSI compliant WSDL Interface - single Part WSDL.
	 * @param context TransformationContext
	 * @return boolean
	 */
	public static boolean generateEmptyActivityForControlNode(){
		return false;
		//return BpelOptions.generateEmptyActivityForControlNode(TransformationEngine.getExportSession());

	}	

//	/**
//	 * Returns true if the BpelOptions is set to generate a WSI compliant WSDL Interface - single Part WSDL.
//	 * @param context TransformationContext
//	 * @return boolean
//	 */
//	public static boolean generateSwitchForExclusiveDecision1(){
//		return true;
//		//return BpelOptions.generateEmptyActivityForControlNode(TransformationEngine.getExportSession());
//
//	}
	
	/**
	 * Returns true if the BpelOptions is set to generate a WSI compliant WSDL Interface - single Part WSDL.
	 * @param context TransformationContext
	 * @return boolean
	 */
	public static boolean generateGlobalRepositoryInvoke(){
		return false;
		//return BpelOptions.generateEmptyActivityForControlNode(TransformationEngine.getExportSession());

	}
	
	/**
	 * Returns true if the BpelOptions is set to generate a WSI compliant WSDL Interface - single Part WSDL.
	 * @param context TransformationContext
	 * @return boolean
	 */
	public static boolean generateGlobalRepositoryJavaSnippet(){
		return true;
		//return BpelOptions.generateEmptyActivityForControlNode(TransformationEngine.getExportSession());

	}
	/**
	 * Returns true if the BpelOptions is set to generate a WSI compliant WSDL Interface - single Part WSDL.
	 * @param context TransformationContext
	 * @return boolean
	 */
	public static boolean generateGlobalRepositoryNoActivity(){
		return false;
		//return BpelOptions.generateEmptyActivityForControlNode(TransformationEngine.getExportSession());

	}
	/**
	 * Returns true if the transformation is run in the GenerateDefaultValuesWithOverwrite style.
	 * @return
	 */
	public static boolean generateDefaultValuesWithOverwrite(){
		Object genWithOverwrite = TransformationEngine.getTransformationSession().get(TransformationSessionKeyConstants.GENERATE_DEFAULT_TECH_ATTRIBUTE);
		return (! (genWithOverwrite == null)  && ((Boolean)genWithOverwrite).booleanValue());
	}

	/**
	 * Returns true if the transformation is run in the GenerateDefaultValuesNoOverwrite style.
	 */
	public static boolean generateDefaultValuesNoOverwrite(){
		Object genWithOverwrite = TransformationEngine.getTransformationSession().get(TransformationSessionKeyConstants.GENERATE_DEFAULT_TECH_ATTRIBUTE);
		return (! (genWithOverwrite == null)  && !((Boolean)genWithOverwrite).booleanValue());

	}
	/**
	 * Returns true if the transformation is run in the runTransformation style.
	 */
	public static boolean runTransformation(){
		 Object genWithOverwrite = TransformationEngine.getTransformationSession().get(TransformationSessionKeyConstants.GENERATE_DEFAULT_TECH_ATTRIBUTE);
		 Object runValidation = TransformationEngine.getTransformationSession().get(TransformationSessionKeyConstants.RUN_VALIDATION);
		 return (genWithOverwrite == null && runValidation == null);

	}
	
	public static boolean isWPSCreateModule() {
		// TODO: Need to update this line to check if we need to create Module
		return getWPSModuleName(null)!=null || getWPSExistingModuleDirectory()!=null;				
	}

	public static boolean isWPSCreateLibrary() {
		// TODO: Need to update this line to check if we need to create Module
		return getWPSLibraryName(null)!=null || getWPSExistingLibraryDirectory()!=null;				
	}

	/**
	 * Returns true if the transformation is run in the runValidation style.
	 */
	public static boolean runValidation(){
		Object runValidation = TransformationEngine.getTransformationSession().get(TransformationSessionKeyConstants.RUN_VALIDATION);
		return (! (runValidation == null)  && ((Boolean)runValidation).booleanValue());
	
	}

	public static String getWPSModuleName(String projectName) {
		ExportSession es = TransformationSessionUtil.getExportSession(TransformationEngine.getTransformationSession());
		//if (BpelOptions.getWpsOptions(es)!=null) {
		if(getProjectWpsOptionsBean(es,projectName)!= null){
			//AZ only one project for now, we need to pass in project name to do look-up for mutilple projects
            return getProjectWpsOptionsBean(es,projectName).getWpsExportGeneralModuleName();
			//return (String)BpelOptions.getWpsOptions(es).get(BpelOptions.WPS_EXPORT_GENERAL_MODULE_NAME);					
		}
		return null;
	}
	
	public static String getWPSLibraryName(String projectName) {
		ExportSession es = TransformationSessionUtil.getExportSession(TransformationEngine.getTransformationSession());
//		if (BpelOptions.getWpsOptions(es)!=null) {
//			return (String)BpelOptions.getWpsOptions(es).get(BpelOptions.WPS_EXPORT_SHARED_MODULE_NAME);				
//		}
		if(getProjectWpsOptionsBean(es,projectName)!= null){
			//AZ only one project for now, we need to pass in project name to do look-up for mutilple projects
            return getProjectWpsOptionsBean(es,projectName).getWpsExportSharedModuleName();
			//return (String)BpelOptions.getWpsOptions(es).get(BpelOptions.WPS_EXPORT_GENERAL_MODULE_NAME);					
		}
		return null;		
	}
	
	public static String getWPSLibraryNameForElement(String elementID) {
		ExportSession es = TransformationSessionUtil.getExportSession(TransformationEngine.getTransformationSession());
		DeployableElementWpsOptionsBean bean = getElementWpsOptionsBean(es, elementID); 
		if(bean!= null){
            return bean.getWpsLibraryName();
		}
		return null;		
	}
	
	public static String getWPSLibraryVersionForElement(String elementID) {
		ExportSession es = TransformationSessionUtil.getExportSession(TransformationEngine.getTransformationSession());
		DeployableElementWpsOptionsBean bean = getElementWpsOptionsBean(es, elementID); 
		if(bean!= null){
            return bean.getWpsLibraryVersion();
		}
		return null;		
	}
	
	public static String getWPSModuleVersionForElement(String elementID) {
		ExportSession es = TransformationSessionUtil.getExportSession(TransformationEngine.getTransformationSession());
		DeployableElementWpsOptionsBean bean = getElementWpsOptionsBean(es, elementID); 
		if(bean!= null){
            return bean.getWpsModuleVersion();
		}
		return null;		
	}
	
	public static String getWPSTemplateSuffixForElement(String elementID) {
		ExportSession es = TransformationSessionUtil.getExportSession(TransformationEngine.getTransformationSession());
		DeployableElementWpsOptionsBean bean = getElementWpsOptionsBean(es, elementID); 
		if(bean!= null){
            return bean.getTemplateSuffix();
		}
		return null;		
	}
	
	public static String getWPSVersionForProject(String projectName) {
		ExportSession es = TransformationSessionUtil.getExportSession(TransformationEngine.getTransformationSession());
		WpsExportOptionsBean exportOptionBean = BpelOptions.getWpsOptions(es);
		Map<String, String> projectVersionMap = exportOptionBean.getProjectVersionMap();
		if(projectVersionMap != null){
			return projectVersionMap.get(projectName);
		}
		return null;		
	}

	public static String getWPSModuleyNameForElement(String elementID) {
		ExportSession es = TransformationSessionUtil.getExportSession(TransformationEngine.getTransformationSession());
		DeployableElementWpsOptionsBean bean = getElementWpsOptionsBean(es, elementID); 
		if(bean!= null){
            return bean.getWpsModuleName();
		}
		return null;		
	}

	public static String getWPSExistingModuleDirectory() {
		ExportSession es = TransformationSessionUtil.getExportSession(TransformationEngine.getTransformationSession());
		if (BpelOptions.getWpsOptions(es)!=null) {
			//return (String)BpelOptions.getWpsOptions(es).get(BpelOptions.WPS_EXPORT_GENERAL_MODULE_DIRECTORY);				
		}
		return null;				
	}

	public static String getWPSExistingLibraryDirectory() {
		ExportSession es = TransformationSessionUtil.getExportSession(TransformationEngine.getTransformationSession());
		if (BpelOptions.getWpsOptions(es)!=null) {
			//return (String)BpelOptions.getWpsOptions(es).get(BpelOptions.WPS_EXPORT_SHARED_MODULE_DIRECTORY);						
		}
		return null;				
	}
	
	public static String getWPSModuleDirectory() {
		ExportSession es = TransformationSessionUtil.getExportSession(TransformationEngine.getTransformationSession());
//		if (BpelOptions.getWpsOptions(es)!=null) {
//			return (String)BpelOptions.getWpsOptions(es).get(BpelOptions.WPS_EXPORT_MODULE_DIRECTORY);						
//		}
		if(BpelOptions.getWpsOptions(es) != null){
			return BpelOptions.getWpsOptions(es).getWpsExportModuleDirectory();
		}
		return null;						
	}
	
	public static boolean isPersistSCDLComponentToRootFolder() {
		return false;
	}
	
	public static boolean isExportSCDLArtifactsOnly() {
		return false;
	}
	
	public static boolean isTransformNonConnectedNode() {
		return !BpelOptionsUtil.runTransformation();
	}
	
	public static boolean generateDefaultComponentImplementation(){
		return true;
	}
	
//	/**
//	 * Returns true if Modeler is installed as standalone and at least one of the Module name or the Library name are filled in
//	 */
//	public static boolean generateProjectInterchange(){
//		
//		if((getWPSModuleName() != null || getWPSLibraryName() != null)&& WIDProjectUtil.getWidPlugin() == null)
//			return true;
//		return false;
//		
//		
//	}
	
	/**
	 * Returns the name of the ProjectInterchange.
	 * Note: This may change in the future to a user defined value through UI. For now, take the Module, Library or a combination of these.
	 * @return
	 */
	public static String getWPSProjectInterchangeName() {
		
		ExportSession es = TransformationSessionUtil.getExportSession(TransformationEngine.getTransformationSession());
		if (BpelOptions.getWpsOptions(es)!=null) {
			//return (String)BpelOptions.getWpsOptions(es).get(BpelOptions.WPS_EXPORT_PROJECT_INTERCHANGE);		
			return BpelOptions.getWpsOptions(es).getWpsExportProjectInterchangeName();
		}
		return null;	
	}
	/**
	 * AZ WMT 20070321 get implementation module name from the
	 * export options
	 * @param projectName TODO
	 * @return
	 */
	public static String getImplementationModuleName(String projectName){
//		ExportSession es = TransformationSessionUtil.getExportSession(TransformationEngine.getTransformationSession());
//		if (BpelOptions.getWpsOptions(es)!=null) {
//			return (String)BpelOptions.getWpsOptions(es).get(BpelOptions.WPS_EXPORT_IMPLEMENTATION_MODULE_NAME);					
//		}
		//return getWPSModuleName()+"_Impl";
		ExportSession es = TransformationSessionUtil.getExportSession(TransformationEngine.getTransformationSession());
		if (getProjectWpsOptionsBean(es,projectName)!=null) {
			//return (String)BpelOptions.getWpsOptions(es).get(BpelOptions.WPS_EXPORT_PROJECT_INTERCHANGE);		
			return getProjectWpsOptionsBean(es,projectName).getWpsExportImplementationModuleName();
		}
		return null;	
	}
	
	/**
	 * AZ WMT 20070321 get export session for the transformation rule
	 * export options
	 * @return
	 */
	public static ExportSession getExportSession(){
		return TransformationSessionUtil.getExportSession(TransformationEngine.getTransformationSession());
	}
    
	/**
	 * This method is to check the export session option to see if the user select partial export
	 * @return
	 */
	public static boolean isPartialExport() {	
		//ExportSession expSession = getExportSession();
		if(BpelOptions.getWpsOptions(getExportSession())==null){
			return false;
		}
		return BpelOptions.getWpsOptions(getExportSession()).isPartialExport();
		//return true;
	}	
	
	/**
	 * If this method returns true, we need generate Map Model
	 * @return
	 */
	public static boolean isMapModelGenerationEnabled(){
		WpsExportOptionsBean bean = BpelOptions.getWpsOptions(getExportSession());
		if(bean == null){
			return false;
		}
		boolean isPureArtifactsExport = (bean.getExportOption()== WpsExportOptionsBean.NONE);
		//If the user chooses export option as 'none', we disable the Map Model generation
		if(isPureArtifactsExport){
			//return !isPureArtifactsExport;
			return isPureArtifactsExport;
		}
		//return BpelOptions.getWpsOptions(getExportSession()).isProjectInterchangeEnabled();
		return true;
	}
	
	public static boolean isProjectInterchangeEnabled(){	
		// Ray d158717 - For FDL the WPSOptions will not be available
		if (BpelOptions.getWpsOptions(getExportSession())==null) {
			return false; 
		}
		return BpelOptions.getWpsOptions(getExportSession()).isProjectInterchangeEnabled();
	}
	
	/**
	 * Returns true is this session is for d2d
	 * @return
	 */
	public static boolean isGenerateForDeployPatternEnabled(){	
		if (BpelOptions.getWpsOptions(getExportSession())==null) {
			return false; 
		}
		return BpelOptions.getWpsOptions(getExportSession()).isGenerateForDeployPatternEnabled();
	}
	
	/**
	 * Returns true if this session was generated from a Test Action (d2d).
	 * @return
	 */
	public static boolean isGenerateForTestDeploy(){	
		if (BpelOptions.getWpsOptions(getExportSession())==null) {
			return false; 
		}
		return BpelOptions.getWpsOptions(getExportSession()).isForTestDeploy();
	}
	
	public static LogicalEntityRoot getLogicalGroupMapping(){
		if (BpelOptions.getWpsOptions(getExportSession())==null) {
			return null; 
		}
		return (LogicalEntityRoot)BpelOptions.getWpsOptions(getExportSession()).getLogicalGroupMapping();
	}
	
	/**
	 * 
	 * @return
	 */
	public static boolean isModuleEnabledWithLib(){
		if(BpelOptions.getWpsOptions(getExportSession())==null){
			return false;
		}
		return (BpelOptions.getWpsOptions(getExportSession()).getExportOption() == WpsExportOptionsBean.MOD_LIB);
	}
	
	/**
	 * Check if the option is library only
	 */
	public static boolean isLibraryOnly(){
		if(BpelOptions.getWpsOptions(getExportSession())==null){
			return false;
		}
		return (BpelOptions.getWpsOptions(getExportSession()).getExportOption() == WpsExportOptionsBean.LIB_ONLY);
	}
	
	/**
	 * This method is to check if the library option is enabled with module project
	 * we will get rid of the lib project from the import location path since WID
	 * resolves the path based on classpath where the project dependency was specified
	 * @return
	 */
	public static boolean isLibraryEnabledWithModuleProject(){
		if(BpelOptions.getWpsOptions(getExportSession())==null){
			return false;
		}
		return (BpelOptions.getWpsOptions(getExportSession()).getExportOption() == WpsExportOptionsBean.MOD_LIB)||
		(BpelOptions.getWpsOptions(getExportSession()).getExportOption() == WpsExportOptionsBean.TOP_IMP_LIB);
		
	}
	
	/**
	 * Append timestamp of the current export session if it is true
	 * @return
	 */
	public static boolean isProjectInterchangeTimeStampEnabled(){
		if(BpelOptions.getWpsOptions(getExportSession())==null){
			return false;
		}
		return BpelOptions.getWpsOptions(getExportSession()).isProjectInterchangeTimeStampEnabled();
	}
	
	/**
	 * This is for one project case....
	 * TODO cross projects reference
	 * @param es
	 * @return
	 */
	public static ProjectWpsOptionsBean getProjectWpsOptionsBean(ExportSession es,String projectName) {
		ProjectWpsOptionsBean eachProjectNameBean = null;	
		if(BpelOptions.getWpsOptions(es)==null){
			return eachProjectNameBean;
		}
		List beanList = (List)BpelOptions.getWpsOptions(es).getSelectedProjectWpsOptionsBeanList();
		if(beanList != null && !beanList.isEmpty()){
			for(Iterator beanIt = beanList.iterator();beanIt.hasNext();){
				Object eachProjectNamesBeanObj = beanIt.next();
				if(eachProjectNamesBeanObj instanceof ProjectWpsOptionsBean){
					ProjectWpsOptionsBean eachBean = (ProjectWpsOptionsBean)eachProjectNamesBeanObj;
					
					//Handle NullPointerException defect 145459 resubmit into cmvc
					
					if(eachBean.getWbmProjectName()!= null && eachBean.getWbmProjectName().equals(projectName)){
						
						eachProjectNameBean =  eachBean;
						
						break;
						
					}else if(eachBean.getWpsExportSharedModuleName() != null && eachBean.getWpsExportSharedModuleName().equals(projectName)){
						
						eachProjectNameBean =  eachBean;
						
						break;
					}
				}
			}
		}
		return eachProjectNameBean;
	}
	
	/**
	 * This is for one project case....
	 * TODO cross projects reference
	 * @param es
	 * @return
	 */
	public static DeployableElementWpsOptionsBean getElementWpsOptionsBean(ExportSession es,String elementID) {
		DeployableElementWpsOptionsBean eachProjectNameBean = null;	
		if(BpelOptions.getWpsOptions(es)==null){
			return eachProjectNameBean;
		}
		List beanList = (List)BpelOptions.getWpsOptions(es).getSelectedDeployableElementWpsOptionsBeanList();
		if(beanList != null && !beanList.isEmpty()){
			for(Iterator beanIt = beanList.iterator();beanIt.hasNext();){
				Object eachProjectNamesBeanObj = beanIt.next();
				if(eachProjectNamesBeanObj instanceof DeployableElementWpsOptionsBean){
					DeployableElementWpsOptionsBean eachBean = (DeployableElementWpsOptionsBean)eachProjectNamesBeanObj;
					if(eachBean.getBlmID()!= null && eachBean.getBlmID().equals(elementID)){
						eachProjectNameBean =  eachBean;
						break;
						
					}
				}
			}
		}
		return eachProjectNameBean;
	}

	public static boolean isNoneOption() {
		WpsExportOptionsBean bean = BpelOptions.getWpsOptions(getExportSession());
		if(bean == null){
			return false;
		}
		boolean isPureArtifactsExport = (bean.getExportOption()== WpsExportOptionsBean.NONE);
		return isPureArtifactsExport;
	}
	
}
