/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.wst.wsdl.Definition;
import org.eclipse.wst.wsdl.PortType;

import com.ibm.btools.bom.model.artifacts.NamedElement;
import com.ibm.btools.bom.model.services.Interface;
import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationContext;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.framework.impl.TransformationRuleImpl;
import com.ibm.btools.te.framework.util.TransformationUtil;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.HeuristicsPackage;
import com.ibm.btools.te.ilm.heuristics.InterfaceRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelFactory;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessInterfaceRule;
import com.ibm.btools.te.ilm.heuristics.helper.ProcessUtil;
import com.ibm.btools.te.ilm.heuristics.helper.SAUtil;
import com.ibm.btools.te.ilm.heuristics.wsdl.PortTypeRule;
import com.ibm.btools.te.ilm.heuristics.wsdl.WsdlFactory;
import com.ibm.btools.te.ilm.model.sa.SolutionArtifact;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Interface Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class InterfaceRuleImpl extends TransformationRuleImpl implements InterfaceRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InterfaceRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return HeuristicsPackage.Literals.INTERFACE_RULE;
	}

	public boolean transformSource2Target(){
		LoggingUtil.traceEntry(this, "transformSource2Target");	
		TransformationContext context = getContext();
		Interface bomInterface = (Interface)getSource().get(0);
		ProcessInterfaceRule interfaceRule = createProcessInterfaceRule(bomInterface);
		PortTypeRule portTypeRule = createPortTypeRule(interfaceRule, bomInterface);
		if(interfaceRule.getTarget() != null){
			SolutionArtifact unclassifiedSA = SAUtil.createUnclassifiedSolutionArtifact();
			getTarget().add(unclassifiedSA);
			SAUtil.updateUnclassifiedSA(unclassifiedSA, (Definition)interfaceRule.getTarget().get(0));
		}
		setComplete(true);
		LoggingUtil.traceExit(this, "transformSource2Target");
		return isComplete();
			
	}
	
	/**
	 * The named element is either an Action or an Interface of a BehavioredClass
	 * TODO changed to NamedElement to accomodate BehavioredClass and Interface
	 */
	protected ProcessInterfaceRule createProcessInterfaceRule(NamedElement namedElement){
		
		ProcessInterfaceRule interfaceRule = (ProcessInterfaceRule)ProcessUtil.getProcessInterfaceRule(getContext(), namedElement);
		if(interfaceRule == null){
		   interfaceRule = AbstractbpelFactory.eINSTANCE.createProcessInterfaceRule();
		   interfaceRule.getSource().add(namedElement);
		   //set the context for the interfaceRule
		   ProcessUtil.putProcessInterfaceRule(getContext(), interfaceRule);
		   getChildRules().add(interfaceRule);		
		   interfaceRule.setRoot(getRoot());	
		   ProcessUtil.putProcessInterfaceRule(getContext(), namedElement, interfaceRule);
		   interfaceRule.transformSource2Target();
		   
		}
			return interfaceRule;
	}
	
	/**
	* Creates the interface rules. Sets the source to be the BOM NamedElement.
	* TODO changed to NamedElement to accomodate BehavioredClass and Interface
	*/
	protected PortTypeRule createPortTypeRule(ProcessInterfaceRule processIntRule, NamedElement namedElement){
		//Creates an interfaceRule and set its source to be the ActionRule source
		//(an action) and the target of the ProcessInterfaceRule
		PortTypeRule portTypeRule = 
			(PortTypeRule)TransformationUtil.getRuleForSource(processIntRule,PortTypeRule.class, namedElement, PortType.class);
		if (portTypeRule == null) {
			portTypeRule = WsdlFactory.eINSTANCE.createPortTypeRule();
			portTypeRule.getSource().add(namedElement);
			processIntRule.getChildRules().add(portTypeRule);
			processIntRule.transformSource2Target();
		}
		return portTypeRule;
	}	
	


} //InterfaceRuleImpl
