package com.ibm.btools.te.ilm.heuristics.naming;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import org.eclipse.emf.ecore.EObject;

public interface NameConverter {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	/**
	 * Returns a String that is a valid name
	 * It converts the name into a valid name that is also unique in the registry	 
	 * @param registry  the registry to store the source name
	 * @param obj  the object of the construct
	 * @param sourceName  the String name to be converted to a valid name	 
	 * @return String the converted String name
	 */		
	public abstract String convertName(NamingRegistry registry, Object obj, String sourceName);
	
}
