package com.ibm.btools.te.ilm.heuristics.naming;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import org.eclipse.emf.ecore.EObject;

public interface NamingRegistry {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	
	/**
	 * Returns a boolean whether the name is unique
	 * It searches the registry and and return false if name is not unique
	 * it returns true if name is unique and it stores the name in the registry.
	 * @param obj  the EObject of a construct
	 * @param name  the String name
	 * @return boolean the boolean value whether name is unique or not
	 */	
	public abstract boolean isUniqueName(Object obj, String name);
	
	/**
	 * Returns a boolean whether the name is unique
	 * It searches the registry and and return false if name is not unique
	 * it returns true if name is unique and it stores the name in the registry.
	 * @param obj  the EObject of a construct
	 * @param name  the String name
	 * @return boolean the boolean value whether name is unique or not
	 */	
	public abstract boolean isUniqueName(Object obj, Object inParentContext,  String name);
	
	
	/**
	 * Deregister the <code>name</code> for the <code>obj</code> from the registry.
	 * @param obj  the EObject of a construct
	 * @param name  the String name
	 * @return boolean the boolean value whether name is unique or not
	 */	
	public abstract void deregister(Object obj, String name);
	
	/**
	 * Retrieves an entry from the registry based on the Object class type.
	 * @param forSource
	 * @param registryEntry
	 * @return
	 */
	public abstract Object retrieveFromRegistry(Class forSource, String registryEntry);
	
	
	/**
	 * Deregister the <code>name</code> for the <code>obj</code> from the registry.
	 * @param obj  the EObject of a construct
	 * @param name  the String name
	 * @return boolean the boolean value whether name is unique or not
	 */	
	public abstract void register(Object obj, String name);
}
