package com.ibm.btools.te.ilm.heuristics.naming;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.util.HashMap;

import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.te.ilm.CrossProjectReferenceUtil;

/**
 * Naming registry for a project artifacts to ensure the unqiuenes of their name
 */
public class ProjectNamingRegistry implements NamingRegistry {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	private  HashMap<String, NoHashNamingRegistry> allProjectsRegistry = new HashMap<String, NoHashNamingRegistry>();

	public void deregister(Object obj, String name) {
		// TODO Auto-generated method stub
		
	}

	public boolean isUniqueName(Object obj, Object inParentContext, String name) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isUniqueName(Object obj, String name) {
		// TODO Auto-generated method stub
		return false;
	}

	public void register(Object obj, String name) {
		if (obj instanceof Action) {
			Action action = (Action)obj;
			String projectName = CrossProjectReferenceUtil.getProjectNameForBOMElement(action);
			NoHashNamingRegistry projectRegistry = (NoHashNamingRegistry)allProjectsRegistry.get(projectName);			
			if (projectRegistry == null){
				NoHashNamingRegistry newRegistry = new NoHashNamingRegistry();
				newRegistry.register(obj, name);
				allProjectsRegistry.put(projectName, newRegistry);
				return;		 		
			} else {
				projectRegistry.register(obj, name);
			}
		}
		return;
	}

	public Object retrieveFromRegistry(Class forSource, String registryEntry) {
		// TODO Auto-generated method stub
		return null;
	}

	/**
	 * Returns a project registry for the project	 
	 * @param projectName String	
	 * @return NoHashNamingRegistry
	 */		
	public NoHashNamingRegistry getProjectRegistry(String projectName) {
		if (projectName == null) {
			return null;
		}
		
		if (!allProjectsRegistry.containsKey(projectName)) {
			NoHashNamingRegistry newRegistry = new NoHashNamingRegistry();
			allProjectsRegistry.put(projectName, newRegistry);
			return newRegistry;		 		
		}
		
		return (NoHashNamingRegistry)allProjectsRegistry.get(projectName);
	}

}
