/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.wsdl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import com.ibm.btools.te.framework.FrameworkPackage;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.ibm.btools.te.ilm.heuristics.wsdl.WsdlFactory
 * @model kind="package"
 * @generated
 */
public interface WsdlPackage extends EPackage {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "wsdl";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///heuristics/wsdl.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "heuristics.wsdl";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	WsdlPackage eINSTANCE = com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.wsdl.impl.AbstractProcIntRuleImpl <em>Abstract Proc Int Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.AbstractProcIntRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl#getAbstractProcIntRule()
	 * @generated
	 */
	int ABSTRACT_PROC_INT_RULE = 5;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROC_INT_RULE__COMPLETE = FrameworkPackage.TRANSFORMATION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROC_INT_RULE__FAILED = FrameworkPackage.TRANSFORMATION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROC_INT_RULE__CHILD_RULES = FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROC_INT_RULE__PARENT_RULE = FrameworkPackage.TRANSFORMATION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROC_INT_RULE__TARGET = FrameworkPackage.TRANSFORMATION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROC_INT_RULE__SOURCE = FrameworkPackage.TRANSFORMATION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROC_INT_RULE__ROOT = FrameworkPackage.TRANSFORMATION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Abstract Proc Int Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROC_INT_RULE_FEATURE_COUNT = FrameworkPackage.TRANSFORMATION_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.wsdl.impl.PartRuleImpl <em>Part Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.PartRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl#getPartRule()
	 * @generated
	 */
	int PART_RULE = 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PART_RULE__COMPLETE = ABSTRACT_PROC_INT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PART_RULE__FAILED = ABSTRACT_PROC_INT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PART_RULE__CHILD_RULES = ABSTRACT_PROC_INT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PART_RULE__PARENT_RULE = ABSTRACT_PROC_INT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PART_RULE__TARGET = ABSTRACT_PROC_INT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PART_RULE__SOURCE = ABSTRACT_PROC_INT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PART_RULE__ROOT = ABSTRACT_PROC_INT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Part Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PART_RULE_FEATURE_COUNT = ABSTRACT_PROC_INT_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.wsdl.impl.ParameterRuleImpl <em>Parameter Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.ParameterRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl#getParameterRule()
	 * @generated
	 */
	int PARAMETER_RULE = 1;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_RULE__COMPLETE = ABSTRACT_PROC_INT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_RULE__FAILED = ABSTRACT_PROC_INT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_RULE__CHILD_RULES = ABSTRACT_PROC_INT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_RULE__PARENT_RULE = ABSTRACT_PROC_INT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_RULE__TARGET = ABSTRACT_PROC_INT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_RULE__SOURCE = ABSTRACT_PROC_INT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_RULE__ROOT = ABSTRACT_PROC_INT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Parameter Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_RULE_FEATURE_COUNT = ABSTRACT_PROC_INT_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.wsdl.impl.OperationRuleImpl <em>Operation Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.OperationRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl#getOperationRule()
	 * @generated
	 */
	int OPERATION_RULE = 2;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_RULE__COMPLETE = ABSTRACT_PROC_INT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_RULE__FAILED = ABSTRACT_PROC_INT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_RULE__CHILD_RULES = ABSTRACT_PROC_INT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_RULE__PARENT_RULE = ABSTRACT_PROC_INT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_RULE__TARGET = ABSTRACT_PROC_INT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_RULE__SOURCE = ABSTRACT_PROC_INT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_RULE__ROOT = ABSTRACT_PROC_INT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Operation Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_RULE_FEATURE_COUNT = ABSTRACT_PROC_INT_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.wsdl.impl.MessageRuleImpl <em>Message Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.MessageRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl#getMessageRule()
	 * @generated
	 */
	int MESSAGE_RULE = 3;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_RULE__COMPLETE = ABSTRACT_PROC_INT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_RULE__FAILED = ABSTRACT_PROC_INT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_RULE__CHILD_RULES = ABSTRACT_PROC_INT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_RULE__PARENT_RULE = ABSTRACT_PROC_INT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_RULE__TARGET = ABSTRACT_PROC_INT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_RULE__SOURCE = ABSTRACT_PROC_INT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_RULE__ROOT = ABSTRACT_PROC_INT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Message Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_RULE_FEATURE_COUNT = ABSTRACT_PROC_INT_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.wsdl.impl.PortTypeRuleImpl <em>Port Type Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.PortTypeRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl#getPortTypeRule()
	 * @generated
	 */
	int PORT_TYPE_RULE = 4;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_TYPE_RULE__COMPLETE = ABSTRACT_PROC_INT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_TYPE_RULE__FAILED = ABSTRACT_PROC_INT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_TYPE_RULE__CHILD_RULES = ABSTRACT_PROC_INT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_TYPE_RULE__PARENT_RULE = ABSTRACT_PROC_INT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_TYPE_RULE__TARGET = ABSTRACT_PROC_INT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_TYPE_RULE__SOURCE = ABSTRACT_PROC_INT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_TYPE_RULE__ROOT = ABSTRACT_PROC_INT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Port Type Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_TYPE_RULE_FEATURE_COUNT = ABSTRACT_PROC_INT_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.wsdl.impl.PartnerLinkRuleImpl <em>Partner Link Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.PartnerLinkRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl#getPartnerLinkRule()
	 * @generated
	 */
	int PARTNER_LINK_RULE = 6;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTNER_LINK_RULE__COMPLETE = ABSTRACT_PROC_INT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTNER_LINK_RULE__FAILED = ABSTRACT_PROC_INT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTNER_LINK_RULE__CHILD_RULES = ABSTRACT_PROC_INT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTNER_LINK_RULE__PARENT_RULE = ABSTRACT_PROC_INT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTNER_LINK_RULE__TARGET = ABSTRACT_PROC_INT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTNER_LINK_RULE__SOURCE = ABSTRACT_PROC_INT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTNER_LINK_RULE__ROOT = ABSTRACT_PROC_INT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Partner Link Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTNER_LINK_RULE_FEATURE_COUNT = ABSTRACT_PROC_INT_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.wsdl.impl.WSDLDefinitionRuleImpl <em>WSDL Definition Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.WSDLDefinitionRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl#getWSDLDefinitionRule()
	 * @generated
	 */
	int WSDL_DEFINITION_RULE = 7;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WSDL_DEFINITION_RULE__COMPLETE = ABSTRACT_PROC_INT_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WSDL_DEFINITION_RULE__FAILED = ABSTRACT_PROC_INT_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WSDL_DEFINITION_RULE__CHILD_RULES = ABSTRACT_PROC_INT_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WSDL_DEFINITION_RULE__PARENT_RULE = ABSTRACT_PROC_INT_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WSDL_DEFINITION_RULE__TARGET = ABSTRACT_PROC_INT_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WSDL_DEFINITION_RULE__SOURCE = ABSTRACT_PROC_INT_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WSDL_DEFINITION_RULE__ROOT = ABSTRACT_PROC_INT_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>WSDL Definition Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WSDL_DEFINITION_RULE_FEATURE_COUNT = ABSTRACT_PROC_INT_RULE_FEATURE_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.wsdl.PartRule <em>Part Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Part Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.PartRule
	 * @generated
	 */
	EClass getPartRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.wsdl.ParameterRule <em>Parameter Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Parameter Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.ParameterRule
	 * @generated
	 */
	EClass getParameterRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.wsdl.OperationRule <em>Operation Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Operation Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.OperationRule
	 * @generated
	 */
	EClass getOperationRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.wsdl.MessageRule <em>Message Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Message Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.MessageRule
	 * @generated
	 */
	EClass getMessageRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.wsdl.PortTypeRule <em>Port Type Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Port Type Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.PortTypeRule
	 * @generated
	 */
	EClass getPortTypeRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.wsdl.AbstractProcIntRule <em>Abstract Proc Int Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Proc Int Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.AbstractProcIntRule
	 * @generated
	 */
	EClass getAbstractProcIntRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.wsdl.PartnerLinkRule <em>Partner Link Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Partner Link Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.PartnerLinkRule
	 * @generated
	 */
	EClass getPartnerLinkRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.wsdl.WSDLDefinitionRule <em>WSDL Definition Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>WSDL Definition Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.wsdl.WSDLDefinitionRule
	 * @generated
	 */
	EClass getWSDLDefinitionRule();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	WsdlFactory getWsdlFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals  {
		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.wsdl.impl.PartRuleImpl <em>Part Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.PartRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl#getPartRule()
		 * @generated
		 */
		EClass PART_RULE = eINSTANCE.getPartRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.wsdl.impl.ParameterRuleImpl <em>Parameter Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.ParameterRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl#getParameterRule()
		 * @generated
		 */
		EClass PARAMETER_RULE = eINSTANCE.getParameterRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.wsdl.impl.OperationRuleImpl <em>Operation Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.OperationRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl#getOperationRule()
		 * @generated
		 */
		EClass OPERATION_RULE = eINSTANCE.getOperationRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.wsdl.impl.MessageRuleImpl <em>Message Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.MessageRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl#getMessageRule()
		 * @generated
		 */
		EClass MESSAGE_RULE = eINSTANCE.getMessageRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.wsdl.impl.PortTypeRuleImpl <em>Port Type Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.PortTypeRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl#getPortTypeRule()
		 * @generated
		 */
		EClass PORT_TYPE_RULE = eINSTANCE.getPortTypeRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.wsdl.impl.AbstractProcIntRuleImpl <em>Abstract Proc Int Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.AbstractProcIntRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl#getAbstractProcIntRule()
		 * @generated
		 */
		EClass ABSTRACT_PROC_INT_RULE = eINSTANCE.getAbstractProcIntRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.wsdl.impl.PartnerLinkRuleImpl <em>Partner Link Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.PartnerLinkRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl#getPartnerLinkRule()
		 * @generated
		 */
		EClass PARTNER_LINK_RULE = eINSTANCE.getPartnerLinkRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.wsdl.impl.WSDLDefinitionRuleImpl <em>WSDL Definition Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.WSDLDefinitionRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl#getWSDLDefinitionRule()
		 * @generated
		 */
		EClass WSDL_DEFINITION_RULE = eINSTANCE.getWSDLDefinitionRule();

	}

} //WsdlPackage
