/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.wsdl.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.wst.wsdl.Definition;

import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.framework.impl.TransformationRuleImpl;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.DatastoreRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessInterfaceRule;
import com.ibm.btools.te.ilm.heuristics.helper.BpelOptionsUtil;
import com.ibm.btools.te.ilm.heuristics.wsdl.AbstractProcIntRule;
import com.ibm.btools.te.ilm.heuristics.wsdl.WsdlPackage;

/**
 * <!-- begin-user-doc -->
 * Abstract Rule that provides means for retrieving the WSDL Definition 	
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 */
public abstract class AbstractProcIntRuleImpl extends TransformationRuleImpl implements AbstractProcIntRule {
	
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AbstractProcIntRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return WsdlPackage.Literals.ABSTRACT_PROC_INT_RULE;
	}

	/**
	 * Retrieves the WSDL definition. Will navigate through the parent rules until reaches
	 * the parent ProcessInterface of DataStoreRule,  whose target is the WSDLDefinition. 
	 * @return WSDLDefinition
	 */
	public Definition getWSDLDefinition() {
		
		TransformationRule rule = (TransformationRule)getParentRule();
		while (!(rule instanceof ProcessInterfaceRule) && !(rule instanceof DatastoreRule)){
			rule = (TransformationRule)rule.getParentRule();
		}
		return rule != null ?(Definition)rule.getTarget().get(0) :null;

	}
//	/**
//	 * Creates a WSDL Service with the <code>serviceName</code> for the <code>wsdlDefinition</code>
//	 * @param wsdlDefinition
//	 * @param serviceName
//	 * @return
//	 */
//	protected Service createService(Definition wsdlDefinition, String serviceName){
//
//		Service service = wsdlDefinition.getService(new QName(wsdlDefinition.getTargetNamespace(), serviceName)); 
//		if(service == null){
//			service = WSDLFactory.eINSTANCE.createService();
//			service.setQName(new QName(wsdlDefinition.getTargetNamespace(), serviceName));
//		}
//				
//		return service;
//	}
//
//	protected Binding createSOAPBinding(Definition wsdlDefinition, PortType portType, String bindingName, String bindingStyle, String bindingTransportURI, String operationEncodingStyle ){
//		
//			Binding binding = WSDLFactory.eINSTANCE.createBinding();
//				
//			binding.setQName(new QName(wsdlDefinition.getTargetNamespace(), bindingName));
//			binding.setPortType(portType);
//			SOAPBinding soapBinding = SoapbindingFactory.eINSTANCE.createSOAPBinding();
//		//	soapBinding.setStyle(WSDLConstants.BINDING_STYPE_RPC);
//			soapBinding.setStyle(bindingStyle);
//			soapBinding.setTransportURI(bindingTransportURI);
//			binding.addExtensibilityElement(soapBinding);
//		
//			List bindingOperations = binding.getBindingOperations();
//			Iterator it = portType.getOperations().iterator();
//			while(it.hasNext()){
//				com.ibm.etools.ctc.wsdl.Operation operation = (com.ibm.etools.ctc.wsdl.Operation)it.next();
//				BindingOperation bindingOperation = WSDLFactory.eINSTANCE.createBindingOperation();
//				SOAPOperation soapOperation = SoapbindingFactory.eINSTANCE.createSOAPOperation();
//				soapOperation.setStyle(bindingStyle);
//				soapOperation.setSoapActionURI("urn:a");
//				bindingOperation.addExtensibilityElement(soapOperation);
//				bindingOperation.setOperation(operation);					
//				binding.getBindingOperations().add(bindingOperation);
//				
//				Input input = operation.getInput();
//				if(input != null){
//					BindingInput bindingInput = WSDLFactory.eINSTANCE.createBindingInput();
//					bindingOperation.setBindingInput(bindingInput);
//					//bindingInput.setInput(input);
//					bindingInput.setName(input.getName());
//					SOAPBody soapBody = SoapbindingFactory.eINSTANCE.createSOAPBody();
//					soapBody.getEncodingStyles().add(operationEncodingStyle);
//					soapBody.setUse(WSDLConstants.USE_ENCODED);
//					
//					soapBody.setNamespaceURI("tns:" + portType.getQName().getLocalPart());
//					//soapBody.setNamespaceURI(portType.getQName().getNamespaceURI());
//					//soapBody.setElementType(portType.getQName());
//					bindingInput.addExtensibilityElement(soapBody);
//					
//					//TODO consider adding output parts
//				}
//				Output output = operation.getOutput();
//				if(output != null){
//					BindingOutput bindingOutput = WSDLFactory.eINSTANCE.createBindingOutput();
//					bindingOperation.setBindingOutput(bindingOutput);
//					bindingOutput.setName(output.getName());
//					SOAPBody soapBody = SoapbindingFactory.eINSTANCE.createSOAPBody();
//					soapBody.setUse(WSDLConstants.USE_ENCODED);
//					soapBody.getEncodingStyles().add(operationEncodingStyle);
//					//soapBody.setNamespaceURI(portType.getQName().getNamespaceURI());
//				//soapBody.setNamespaceURI(WSDLHelper.getInstance().getDefaultPrefixFromNamespaceURI(wsdlDefinition.getTargetNamespace())+ ":" + portType.getQName().getLocalPart());
//					soapBody.setNamespaceURI("tns:" + portType.getQName().getLocalPart());
//					bindingOutput.addExtensibilityElement(soapBody);
//				}
//			}
//		return binding;
//		
//	}
//	
//	protected Binding createJMSBinding(Definition wsdlDefinition, PortType portType, String bindingName ){
//		
//			Binding binding = WSDLFactory.eINSTANCE.createBinding();
//				
//			binding.setQName(new QName(wsdlDefinition.getTargetNamespace(), bindingName));
//			binding.setPortType(portType);
//			JMSBinding jmsBinding = JMSBindingFactory.eINSTANCE.createJMSBinding();
//			//jmsBinding.setJmsMessageType(JMSConstants.MESSAGE_TYPE_BYTEMESSAGE);
//			jmsBinding.setJmsMessageType(JMSConstants.MESSAGE_TYPE_TEXTMESSAGE);
//			binding.addExtensibilityElement(jmsBinding);
//		
//			List bindingOperations = binding.getBindingOperations();
//			Iterator it = portType.getOperations().iterator();
//			while(it.hasNext()){
//				com.ibm.etools.ctc.wsdl.Operation operation = (com.ibm.etools.ctc.wsdl.Operation)it.next();
//				BindingOperation bindingOperation = WSDLFactory.eINSTANCE.createBindingOperation();
//				bindingOperation.setOperation(operation);					
//				binding.getBindingOperations().add(bindingOperation);
//				
//				Input input = operation.getInput();
//				if(input != null){
//					BindingInput bindingInput = WSDLFactory.eINSTANCE.createBindingInput();
//					bindingOperation.setBindingInput(bindingInput);
//					//bindingInput.setInput(input);
//					bindingInput.setName(input.getName());
//					//TODO consider adding output parts
//				}
//				Output output = operation.getOutput();
//				if(output != null){
//					BindingOutput bindingOutput = WSDLFactory.eINSTANCE.createBindingOutput();
//					bindingOperation.setBindingOutput(bindingOutput);
//					bindingOutput.setName(output.getName());
//				}
//			}
//		return binding;
//		
//	}
//	protected Port createJMSPort(Binding binding, String portName, Map addressParameters){
//		
//		Port port = WSDLFactory.eINSTANCE.createPort();
//		port.setName(portName);
//		port.setBinding(binding);
//			
//		JMSAddress jmsAddress = JMSBindingFactory.eINSTANCE.createJMSAddress();
//		if(addressParameters != null){
//			
//			if(addressParameters.get(WSDLConstants.JMS_DESTINATION_STYLE_KEY) != null){
//				jmsAddress.setDestStyle((String)addressParameters.get(WSDLConstants.JMS_DESTINATION_STYLE_KEY));
//				
//			}
//			if(addressParameters.get(WSDLConstants.JMS_PROVIDER_DESTINATION_NAME_KEY) != null){
//				jmsAddress.setJmsProvDestName((String)addressParameters.get(WSDLConstants.JMS_PROVIDER_DESTINATION_NAME_KEY));
//				
//			}
//			if(addressParameters.get(WSDLConstants.JMS_VENDOR_URI_KEY) != null){
//				jmsAddress.setJmsVendorURL((String)addressParameters.get(WSDLConstants.JMS_VENDOR_URI_KEY));
//				
//			}
//			if(addressParameters.get(WSDLConstants.JMS_INITIAL_CONTEXT_FACTORY_KEY) != null){
//				jmsAddress.setInitCtxFact((String)addressParameters.get(WSDLConstants.JMS_INITIAL_CONTEXT_FACTORY_KEY));
//			}					
//		}
//		port.addExtensibilityElement(jmsAddress);
//		
//		return port;
//	}
//
//
//	protected Port createSOAPPort(Binding binding, String portName, Map addressParameters){
//		
//		Port port = WSDLFactory.eINSTANCE.createPort();
//		port.setName(portName);
//		port.setBinding(binding);
//			
//		SOAPAddress soapAddress = SoapbindingFactory.eINSTANCE.createSOAPAddress();
//		if(addressParameters != null){
//			if(addressParameters.get(WSDLConstants.ADRRESS_LOCATION_KEY) != null){
//				soapAddress.setLocationURI((String)addressParameters.get(WSDLConstants.ADRRESS_LOCATION_KEY));
//			}
//		}
//		port.addExtensibilityElement(soapAddress);
//		
//		return port;
//	}
	
	/** 
	 * Returns true if the Action qualifies for the generation of a WSI compliant interface. This is valid in the 
	 * following cases:
	 * - always for a task, or reusable task that has specified a MB as runtime implementation
	 * - for all task that are not implemented as ICS tasks 
	 * @param action
	 * @return
	 */
	protected boolean isWSICompliant(Action action){
		return BpelOptionsUtil.isTargetWSICompliant();
		
//		if((BomUtils.isTask(action) || BomUtils.isReusableTask(action)) && ProcessUtil.isWBIMBImplementation(action)){
//			return true;
//		}else if (BpelOptionsUtil.isTargetWSICompliant(getContext()) && ! ((BomUtils.isTask(action) || BomUtils.isReusableTask(action)) && ProcessUtil.isICSImplementation(action))){
//			return true;
//		}else {
//			return false;
//		}
	}
} //AbstractProcIntRuleImpl
