/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.wsdl.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.wst.wsdl.Definition;
import org.eclipse.wst.wsdl.Import;
import org.eclipse.wst.wsdl.Part;
import org.eclipse.wst.wsdl.Types;
import org.eclipse.wst.wsdl.WSDLFactory;
import org.eclipse.wst.wsdl.XSDSchemaExtensibilityElement;
import org.eclipse.wst.wsdl.internal.impl.DefinitionImpl;
import org.eclipse.xsd.XSDElementDeclaration;
import org.eclipse.xsd.XSDFactory;
import org.eclipse.xsd.XSDImport;
import org.eclipse.xsd.XSDNamedComponent;
import org.eclipse.xsd.XSDSchema;
import org.eclipse.xsd.XSDSimpleTypeDefinition;
import org.eclipse.xsd.XSDTypeDefinition;
import org.eclipse.xsd.util.XSDConstants;

import com.ibm.btools.bom.model.artifacts.ArtifactsFactory;
import com.ibm.btools.bom.model.artifacts.MultiplicityElement;
import com.ibm.btools.bom.model.artifacts.NamedElement;
import com.ibm.btools.bom.model.artifacts.Type;
import com.ibm.btools.bom.model.artifacts.TypedElement;
import com.ibm.btools.bom.model.processes.activities.ActivityEdge;
import com.ibm.btools.bom.model.processes.activities.ConnectableNode;
import com.ibm.btools.bom.model.processes.activities.Datastore;
import com.ibm.btools.bom.model.processes.activities.Pin;
import com.ibm.btools.bom.model.processes.activities.PinSet;
import com.ibm.btools.bom.model.processes.activities.Variable;
import com.ibm.btools.bom.model.services.ParameterSet;
import com.ibm.btools.te.attributes.helper.AttributeNameConstants;
import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.framework.util.TransformationUtil;
import com.ibm.btools.te.ilm.ExportOperation;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.attribute.AttributeValueProvider;
import com.ibm.btools.te.ilm.attribute.AttributeValueProviderFactory;
import com.ibm.btools.te.ilm.heuristics.helper.AbstractbpelUtil;
import com.ibm.btools.te.ilm.heuristics.helper.BpelOptionsUtil;
import com.ibm.btools.te.ilm.heuristics.helper.ProcessUtil;
import com.ibm.btools.te.ilm.heuristics.naming.NamingUtil;
import com.ibm.btools.te.ilm.heuristics.wsdl.PartRule;
import com.ibm.btools.te.ilm.heuristics.wsdl.WsdlPackage;
import com.ibm.btools.te.ilm.heuristics.wsdl.util.OriginalWsdlUtil;
import com.ibm.btools.te.ilm.heuristics.xsd.ClassRule;
import com.ibm.btools.te.ilm.heuristics.xsd.DataDefinitionRule;
import com.ibm.btools.te.ilm.heuristics.xsd.ElementDeclarationRule;
import com.ibm.btools.te.ilm.heuristics.xsd.ListRule;
import com.ibm.btools.te.ilm.heuristics.xsd.XsdFactory;
import com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdFactoryImpl;
import com.ibm.btools.te.ilm.heuristics.xsd.util.DataDefinitionUtil;

/**
 * <!-- begin-user-doc -->
 * Source: a BOM TypedElement
 * Target : WSDL Part. 
 * The Rule is responsible for transforming  a BOM TypedElement (typically a BOM ObjectPin) to a WSDL Part. 
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class PartRuleImpl extends AbstractProcIntRuleImpl implements PartRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PartRuleImpl() {
		super();
	}

	boolean useWSDLImport = false;
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return WsdlPackage.Literals.PART_RULE;
	}

	/**
	 * Source: a BOM TypedElement or a PinSet (Input/OutputPinSet or Input/OutputParameterSet)
	 * Target : WSDL Part. 
	 * Transforms the source to a WSDL Part. Depending on the source Pin vs PinSet, a Part with either a XSDTypeDefinition
	 * or an ElementDeclaration will be created.
	 * Creates (reuse) the DataDefinitionRule with it's child ClassRule (or ListRule) to retrieve the XSDTypeDefinition for the source TypedElement. Set the type of the
	 * WSDL Part to the XSDTypeDefinition. Add necessary imports to the WSDLDefinitoon for the XSDType.  
	 * 
	*/
	public boolean transformSource2Target() {
		
		// Will create (retrieve) the XSD Definition for the BOM Type by retrieving
		// the DataDefinitionRule (associated with the type namespace) from the context
		// or creating one if it does not exist. Will create (reuse) the ClassRule for
		// the BOM Type and set the target of the rule (a XSDTypeDefinition) as the type
		// of the Part. Will add imports to the WSDLDefinition for the XSD type. (if needed). 
		LoggingUtil.traceEntry(this, "transformSource2Target");
		if( isComplete()){
			LoggingUtil.traceExit(this, "transformSource2Target");
			return true;
		}
		
		if( getSource() == null || getSource().isEmpty()){
			LoggingUtil.traceExit(this, "transformSource2Target");
			return false;
		}
		Part part = WSDLFactory.eINSTANCE.createPart();
		getTarget().add(part);
		AttributeValueProvider valueProvider = AttributeValueProviderFactory.createAttributeValueProvider(AttributeNameConstants.WSDL_PART_NAME);
		valueProvider.setContext(this.getContext());
		String convertedName = (String)valueProvider.getAttributeValueForType(part, (NamedElement)getSource().get(0), AttributeNameConstants.WSDL_PART_NAME, NamingUtil.findRegistry(this));
		part.setName(convertedName);		
		Definition definition = getWSDLDefinition();	
		
		useWSDLImport = ProcessUtil.useWSDLImport((NamedElement)getSource().get(0));
	
		// This is the case for non-WSI Compliant WSDL
		// - if the source of this rule is a Pin or a Variable in the non WSI compliant target, the Part will have a type.
		if(getSource().get(0) instanceof Pin || 
				(getSource().get(0) instanceof Variable && !BpelOptionsUtil.isTargetWSICompliant())){
		
			TypedElement typedElement = (TypedElement)getSource().get(0);
			//create a WSDL Part and set it as target of this rule
			Type partType = typedElement.getType();
			XSDTypeDefinition type = getXSDType(definition, typedElement);
			part.setTypeDefinition(type);			
			// In the case if the original WSDL is available, the source of this rule will include the
			// original Part element (see MessageRule).  Hence we just need to set the target of this 
			// rule to the original Part
			if (getSource().size()>1 && getSource().get(1) instanceof Part) {
				// remove the newly created Part
				getTarget().remove(part);
				part = (Part)getSource().get(1);
				OriginalWsdlUtil.registerWsdlElement(getContext(),(NamedElement)getSource().get(0),part);
				getTarget().add(part);
			} else 
			organizeImports(definition, type, !useWSDLImport);
		
		// This is the case fo WSI Compliant WSDL
		// - if the source of this rule is a PinSet or a Variable in a WSI compliant context, the Part will be defined with an ElementDeclaration	
		}else if(getSource().get(0) instanceof PinSet || 
					getSource().get(0) instanceof ParameterSet || getSource().get(0) instanceof Variable || getSource().get(0) instanceof Datastore){
			EObject set = (EObject)getSource().get(0);
			XSDElementDeclaration elementDeclaration = null;
			ElementDeclarationRule  elementDeclarationRule = null;
			NamedElement container = (NamedElement)set.eContainer();
			if(container == null){
				container =(NamedElement) set;
			}
			
		///	DataDefinitionRule parentRule = DataDefinitionUtil.getDataDefinitionRule(this, container);
			XSDSchema typesSchema = getSchemaForDefinition(definition);
			//defect 88901, due to a BUG in org.eclipse.xsd, need to create the DOM here rather then 
			//doing it in the end. 
			((DefinitionImpl)definition).updateElement();
			elementDeclarationRule = XsdFactory.eINSTANCE.createElementDeclarationRule();
		//	parentRule.getChildRules().add(elementDeclarationRule);
			getChildRules().add(elementDeclarationRule);
			elementDeclarationRule.getSource().add(set);
			elementDeclarationRule.getSource().add(typesSchema);			
			// In the case if the original WSDL is available, the source of this rule will include the
			// original Part element (see MessageRule).  Hence we just need to set the target of this 
			// rule to the original Part
			if (getSource().size()>1 && getSource().get(1) instanceof Part) {
				// remove the newly created Part ... we don't need it
				getTarget().remove(part);
				part = (Part)getSource().get(1);
				OriginalWsdlUtil.registerWsdlElement(getContext(),(NamedElement)getSource().get(0),part);
				getTarget().add(part);
				elementDeclarationRule.getSource().add(part.getElementDeclaration());
				elementDeclarationRule.transformSource2Target();
			} else {
			boolean ret = elementDeclarationRule.transformSource2Target();
			if(elementDeclarationRule.getTarget()!= null && !elementDeclarationRule.getTarget().isEmpty()){
				elementDeclaration = (XSDElementDeclaration)elementDeclarationRule.getTarget().get(0);
			}
			if(elementDeclaration.isElementDeclarationReference()){
				part.setElementDeclaration(elementDeclaration.getResolvedElementDeclaration());				
			}else{
				part.setElementDeclaration(elementDeclaration);
			}
			}
		}
//		AZ WMT 20070322
		
		executeHandlers();
		setComplete(true);
		LoggingUtil.traceExit(this, "transformSource2Target");
		return isComplete();
	}
	/**
	 * Creates the XSDTypeDefinition for the type of the <code>typedElement</code>.
	 * Adds <code>typedElement</code> namespace import to the <code>definition</code> if needed.
	 * @param definition the WSDL Definition 
	 * @param typedElement BOM TypedElement to be mapped to a XSDTypeDefinition
	 * @return XSDTypeDefinition
	 */
	private XSDTypeDefinition getXSDType(Definition definition, TypedElement typedElement) {
		
		Type dataType = typedElement.getType();
		XSDTypeDefinition typeDefinition = null;
		//gets the DataDefinitionRule, source of the XSDTransformation for the inputTypedElement
		DataDefinitionRule rule = DataDefinitionUtil.getDataDefinitionRule(this, typedElement);
		//if the typedElement has multiplicity specified, retrives the XSDTypeDefinition from a List rule
		if(AbstractbpelUtil.isMultipled((MultiplicityElement)typedElement)){
			 typeDefinition = getXSDTypeDefinition(rule, typedElement);
		//retrives the XSDTypeDefinition from a ClassRule rule
		}else{
			typeDefinition = getXSDTypeDefinition(rule, dataType);
		}
		return typeDefinition;
	}
	/**
	 * Maps the typedElement into a XSDTypeDefinition. Delegates the transformation to a ListRule 
	 * created in the <code>rule</code> context, if a ListRule was not already found for this <code>typedElement</code>. 
	 * @param rule the root of the XSD transformation.
	 * @param typedElement BOM TypeElement, also a multiplicity element to transform to a XSDTypeDefinition
	 * @return XSDTypeDefinition
	 */
	private XSDTypeDefinition getXSDTypeDefinition(DataDefinitionRule rule, TypedElement typedElement){
		
		// Ray
		XSDTypeDefinition typeDefinition = findTypeDefinitionForMultiplicityElement(rule, typedElement);
		if (typeDefinition != null) {
			return typeDefinition;
		}
		ListRule typeRule = XsdFactoryImpl.eINSTANCE.createListRule();
		typeRule.getSource().add(typedElement);
		rule.getChildRules().add(typeRule);
		//executes the rule in the context and return the target of this rule.
		boolean ret = rule.transformSource2Target();
		if(typeRule.getTarget()!= null && !typeRule.getTarget().isEmpty()){
				typeDefinition =(XSDTypeDefinition) typeRule.getTarget().get(0);
		}
		return typeDefinition;
	}

	/**
	 * This method attempts to find an existing type definition for the TypedElement (with upperbound > 1) 
	 * @param rule
	 * @param typedElement
	 * @return
	 */
	private XSDTypeDefinition findTypeDefinitionForMultiplicityElement(DataDefinitionRule rule, TypedElement typedElement) {
		TransformationRule xsdRule = null;
		if (typedElement instanceof ConnectableNode) {
			ConnectableNode connectableNode = (ConnectableNode)typedElement;
			// assume the connectable node can either have an incoming or outgoing edge but not both
			boolean isIncoming = connectableNode.getIncoming()==null?false:true;
			ActivityEdge edge;
			if (isIncoming) {
				edge = connectableNode.getIncoming();
			} else {
				edge = connectableNode.getOutgoing();
			}
			if (edge != null) {
				// retrieve the connected node
				ConnectableNode connectedNode=isIncoming?edge.getSource():edge.getTarget();
				// Check if the two connected nodes has the same type
				// if they do, then find the typeDefinition of the other node if exists
				// Note: here we intentionally ignore the multiplicity checking because it 
				// complicates this Part rule if we want to handle compatible multiplicity
				// properly in here (which is arguable if it should be taken care in this rule.
				// Therefore, we are basing on the following assumption:
				// 	If the two connected nodes (of same type) have different multiplicity, then if a typeDefinition
				// 	is already available, then use it as the typeDefinition of the other node.
				if (connectedNode instanceof TypedElement) {
					if (typedElement.getType() == ((TypedElement)connectedNode).getType()) {
						xsdRule = TransformationUtil.getRuleForSource(getRoot(), (TypedElement)connectedNode, XSDTypeDefinition.class);
					} else {
						// 	If the two connected nodes has different type (the target node's type must be a superclass of 
						// 	the source), then for now force to make them the same type ... until we find a better solution
						xsdRule = TransformationUtil.getRuleForSource(getRoot(), (TypedElement)connectedNode, XSDTypeDefinition.class);
					}
				}
			}
		} else {
			xsdRule = TransformationUtil.getRuleForSource(getRoot(), typedElement, XSDTypeDefinition.class);
		}
		if(xsdRule != null){
			return (XSDTypeDefinition)xsdRule.getTarget().get(0);
		}
		return null;		
	}	
	
	/**
	 * Maps the <code>dataType</code> into a XSDTypeDefinition. Delegates the transformation to a ClassRule 
	 * created in the <code>rule</code> context. 
	 * @param rule the root of the XSD transformation.
	 * @param dataType BOM Type to transform to a XSDTypeDefinition
	 * @return XSDTypeDefinition
	 */
	private XSDTypeDefinition getXSDTypeDefinition(DataDefinitionRule rule, Type dataType){
		
		//tries to retrieve a rule with the same source rule from the context. 
		TransformationRule xsdRule = TransformationUtil.getRuleForSource(rule, dataType, XSDTypeDefinition.class);
		if(xsdRule != null){
			return (XSDTypeDefinition)xsdRule.getTarget().get(0);
		}
		XSDTypeDefinition typeDefinition = null;
		//create a typeRule, attach it to the DataDefinitionRule and execute it
		// get the return target and process it
		ClassRule typeRule = XsdFactoryImpl.eINSTANCE.createClassRule();
		if(dataType == null){
			dataType = ArtifactsFactory.eINSTANCE.createPrimitiveType();
			dataType.setName(DataDefinitionUtil.XSD_ANY_TYPE);
		}
		typeRule.getSource().add(dataType);
		rule.getChildRules().add(typeRule);
		boolean ret = rule.transformSource2Target();
		if(typeRule.getTarget()!= null && !typeRule.getTarget().isEmpty()){
		    //GJD 20060817
		    if (typeRule.getTarget().get(0) instanceof XSDElementDeclaration) {
		        typeDefinition = ((XSDElementDeclaration) typeRule.getTarget().get(0)).getType();
		    } else {
				typeDefinition =(XSDTypeDefinition) typeRule.getTarget().get(0);
		    }
		}
		return typeDefinition;
	}

	
	/**
	 * Checks if an import for the namespace of the <code>typeDefinition</code> already exists in 
	 * the <code>definition</code>. If not, it will add it. Registers the prefix with the namespace
	 * in the <code>definition</code>.
	 * @param definition the WSDL Definition 
	 * @param typeDefinition an XSDTypeDefinition to check in the WSDL Definition namespace.
	 */
	private void organizeImports(Definition definition, XSDNamedComponent typeDefinition, boolean useXSDImport){
		if(!(typeDefinition instanceof XSDSimpleTypeDefinition) && !(typeDefinition.getTargetNamespace() == null)){
			if(typeDefinition.getTargetNamespace().equals(XSDConstants.SCHEMA_FOR_SCHEMA_URI_2001)){
				return;
			}
			String namespace = typeDefinition.getTargetNamespace();
			//AR typeDefinition and definition are different type of def.. xsd versus wsdl, so always import.. 
		//	if(!namespace.equals(definition.getTargetNamespace())){
				if (useXSDImport) {
					organizeTypesImports(definition, typeDefinition);
				}else{
					Map imports = definition.getImports();
					if(imports.get(namespace) == null){
						//we neet to import the schema 
						Import wsdlImport = WSDLFactory.eINSTANCE.createImport();
						//wsdlImport.setLocationURI(typeDefinition.getSchema().getSchemaLocation());
						wsdlImport.setLocationURI(ProcessUtil.createFileName(namespace)+ExportOperation.XSD_FILE_EXT);
						wsdlImport.setNamespaceURI(namespace);
						definition.addImport(wsdlImport);
					}
				}
		//	}	
			String prefix = DataDefinitionUtil.getPrefixFromNamespaceURI(namespace);
			if (definition.getNamespace(prefix) == null){
				//register the prefix for the namespace
				definition.addNamespace( prefix, namespace);
			}
		}
	}		
	/**
	 * Returns the XSDSchema reference by the WSDL Types embeded in the WSDL Definition. This schema will contain all element
	 * declarations referenced by all WSDL Messages defined in this WSDL Definition. The targetNamespace of this XSDSchema is teh same as 
	 * the WSDLDefinition targetNamespace
	 * @param definition
	 * @return
	 */
	private XSDSchema getSchemaForDefinition (Definition definition){
		
		XSDSchema xsdSchema = null;
		Types types = definition.getETypes();
		if(types == null){	
			//ANDYXZ Added to handle imported WSDL Message Definition
			EList eImports = definition.getEImports();
			if(eImports.size() > 0){				
				Import eachImport = (Import)eImports.get(0);	
				Definition imprtDef = eachImport.getEDefinition();
				types = imprtDef.getETypes();
			}else{			
				types = WSDLFactory.eINSTANCE.createTypes();
				definition.setTypes(types);
			}
		}
		
		List extElements = types.getSchemas();
		if(extElements.isEmpty()){
			xsdSchema = XSDFactory.eINSTANCE.createXSDSchema();
			xsdSchema.setTargetNamespace(definition.getTargetNamespace());
			xsdSchema.setSchemaForSchemaQNamePrefix("xsd");
			Map namespaces = xsdSchema.getQNamePrefixToNamespaceMap();
			namespaces.put(xsdSchema.getSchemaForSchemaQNamePrefix(), XSDConstants.SCHEMA_FOR_SCHEMA_URI_2001);
			namespaces.put("tns", definition.getTargetNamespace());
			XSDSchemaExtensibilityElement xsdExtensibilityElement = WSDLFactory.eINSTANCE.createXSDSchemaExtensibilityElement();
//			types.getEExtensibilityElements().add(xsdExtensibilityElement);
			xsdExtensibilityElement.setSchema(xsdSchema);
			types.getEExtensibilityElements().add(xsdExtensibilityElement);
		}else{
			xsdSchema = (XSDSchema)types.getSchemas().get(0);
		}
		return xsdSchema;
	}
	private void addToDefinition(Definition definition, XSDElementDeclaration typeDefinition){

		XSDSchema xsdSchema = null;
		Types types = definition.getETypes();
		if(types == null){
			types = WSDLFactory.eINSTANCE.createTypes();
			definition.setTypes(types);
		}
		
		String namespace = typeDefinition.getTargetNamespace();
		List extElements = types.getSchemas();
		if(extElements.isEmpty()){
//			XSDImport xsdImport = XSDFactory.eINSTANCE.createXSDImport();
//			xsdImport.setSchemaLocation(ProcessUtil.createFileName(namespace)+ExportOperation.XSD_FILE_EXT);
//			xsdImport.setNamespace(namespace);

			xsdSchema = XSDFactory.eINSTANCE.createXSDSchema();
			xsdSchema.setTargetNamespace(definition.getTargetNamespace());
			
			xsdSchema.setSchemaForSchemaQNamePrefix("xsd");
			
//			xsdSchema.getContents().add(0, xsdImport);
		
			Map namespaces = xsdSchema.getQNamePrefixToNamespaceMap();
			namespaces.put(xsdSchema.getSchemaForSchemaQNamePrefix(), XSDConstants.SCHEMA_FOR_SCHEMA_URI_2001);
			namespaces.put("tns", definition.getTargetNamespace());
			//namespaces.put(DataDefinitionUtil.getNamespacePrefix(namespace), namespace);

			XSDSchemaExtensibilityElement xsdExtensibilityElement = WSDLFactory.eINSTANCE.createXSDSchemaExtensibilityElement();
			types.getEExtensibilityElements().add(xsdExtensibilityElement);
			xsdExtensibilityElement.setSchema(xsdSchema);
			//types.getSchemas().add(xsdSchema);
			
			String prefix = DataDefinitionUtil.getPrefixFromNamespaceURI(namespace);
			if (definition.getNamespace(prefix) == null){
				//register the prefix for the namespace
				definition.addNamespace( prefix, namespace);
			}
		}else{
			xsdSchema = (XSDSchema)types.getSchemas().get(0);
			
		}

		if(!xsdSchema.getContents().contains(typeDefinition)){
		//	DataDefinitionUtil.organizeImports(xsdSchema, typeDefinition.getTypeDefinition());
			xsdSchema.getContents().add(typeDefinition);
		}
	}
	/**
	 * Checks if an XSDImport for the namespace of the <code>typeDefinition</code> already exists in 
	 * the <code>definition</code>. If not, it will add it. Registers the prefix with the namespace
	 * in the <code>definition</code>.
	 * @param definition the WSDL Definition 
	 * @param typeDefinition an XSDTypeDefinition to check in the WSDL Definition namespace.
	 */

	private XSDSchema organizeTypesImports(Definition definition, XSDNamedComponent typeDefinition){
		if(!(typeDefinition instanceof XSDSimpleTypeDefinition) && !(typeDefinition.getTargetNamespace() == null)){
			if(typeDefinition.getTargetNamespace().equals(XSDConstants.SCHEMA_FOR_SCHEMA_URI_2001)){
				return null;
			}
		}
		XSDSchema xsdSchema = null;
		Types types = definition.getETypes();
		if(types == null){
			types = WSDLFactory.eINSTANCE.createTypes();
			definition.setTypes(types);
		}
		String namespace = typeDefinition.getTargetNamespace();
		List extElements = types.getSchemas();
		if(extElements.isEmpty()){
			XSDImport xsdImport = XSDFactory.eINSTANCE.createXSDImport();
			if (typeDefinition.getSchema().getSchemaLocation() != null && 
					typeDefinition.getSchema().getSchemaLocation().indexOf(ExportOperation.ROOT_EXTERNAL_MODEL) != -1) {
				xsdImport.setSchemaLocation(typeDefinition.getSchema().getSchemaLocation());							
			} else {
				xsdImport.setSchemaLocation(ProcessUtil.createFileName(namespace)+ExportOperation.XSD_FILE_EXT);
			}
			xsdImport.setNamespace(namespace);

			xsdSchema = XSDFactory.eINSTANCE.createXSDSchema();
			xsdSchema.setSchemaForSchemaQNamePrefix("xsd");
			xsdSchema.getContents().add(0, xsdImport);
		
			Map namespaces = xsdSchema.getQNamePrefixToNamespaceMap();
			namespaces.put(xsdSchema.getSchemaForSchemaQNamePrefix(), XSDConstants.SCHEMA_FOR_SCHEMA_URI_2001);
			namespaces.put(DataDefinitionUtil.getNamespacePrefix(namespace), namespace);
			
			XSDSchemaExtensibilityElement xsdExtensibilityElement = WSDLFactory.eINSTANCE.createXSDSchemaExtensibilityElement();
			types.getEExtensibilityElements().add(xsdExtensibilityElement);
			xsdExtensibilityElement.setSchema(xsdSchema);
			//types.getSchemas().add(xsdSchema);
			
			String prefix = DataDefinitionUtil.getPrefixFromNamespaceURI(namespace);
			if (definition.getNamespace(prefix) == null){
				//register the prefix for the namespace
				definition.addNamespace( prefix, namespace);
			}
		}else{
			Iterator it = extElements.iterator();
			boolean imported = false;
			while(it.hasNext()){
				Object thisElement = it.next();
				if(thisElement instanceof XSDSchema){
					if(((XSDSchema)thisElement).getContents().contains(typeDefinition)){
						imported = true;
						xsdSchema = (XSDSchema)thisElement;
						break;
					}
					if(((XSDSchema)thisElement).getQNamePrefixToNamespaceMap().get(DataDefinitionUtil.getNamespacePrefix(namespace)) != null){
						imported = true;
						xsdSchema = (XSDSchema)thisElement;
						break;
					}
				}
			}
			if(!imported){
				XSDImport xsdImport = XSDFactory.eINSTANCE.createXSDImport();
				if (typeDefinition.getSchema().getSchemaLocation() != null && 
						typeDefinition.getSchema().getSchemaLocation().indexOf(ExportOperation.ROOT_EXTERNAL_MODEL) != -1) {
					xsdImport.setSchemaLocation(typeDefinition.getSchema().getSchemaLocation());							
				} else {
					xsdImport.setSchemaLocation(ProcessUtil.createFileName(namespace)+ExportOperation.XSD_FILE_EXT);
				}
				xsdImport.setNamespace(namespace);
				

				xsdSchema = XSDFactory.eINSTANCE.createXSDSchema();
				xsdSchema.setSchemaForSchemaQNamePrefix("xsd");
				xsdSchema.getContents().add(0, xsdImport);

				Map namespaces = xsdSchema.getQNamePrefixToNamespaceMap();
				namespaces.put(xsdSchema.getSchemaForSchemaQNamePrefix(), XSDConstants.SCHEMA_FOR_SCHEMA_URI_2001);
				namespaces.put(DataDefinitionUtil.getNamespacePrefix(namespace), namespace);
				XSDSchemaExtensibilityElement xsdExtensibilityElement = WSDLFactory.eINSTANCE.createXSDSchemaExtensibilityElement();
				types.getEExtensibilityElements().add(xsdExtensibilityElement);
				xsdExtensibilityElement.setSchema(xsdSchema);
				//types.getSchemas().add(xsdSchema);
				
				String prefix = DataDefinitionUtil.getPrefixFromNamespaceURI(namespace);
				if (definition.getNamespace(prefix) == null){
					//register the prefix for the namespace
					definition.addNamespace( prefix, namespace);
				}
			}
		}
		//defect 88901, due to a BUG in org.eclipse.xsd, need to create the DOM here rather then 
		//doing it in the end. 
		((DefinitionImpl)definition).updateElement();
		return xsdSchema;
	}


} //PartRuleImpl
