/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.xsd.impl;
/*
 * Licensed Materials - Property of IBM
 * 5724-I74, 5724-I75
 *  Copyright IBM Corporation 2008, 2009. All rights reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */


import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.wst.wsdl.Definition;
import org.eclipse.wst.wsdl.Types;
import org.eclipse.wst.wsdl.XSDSchemaExtensibilityElement;
import org.eclipse.xsd.XSDAttributeDeclaration;
import org.eclipse.xsd.XSDComplexTypeDefinition;
import org.eclipse.xsd.XSDCompositor;
import org.eclipse.xsd.XSDElementDeclaration;
import org.eclipse.xsd.XSDFactory;
import org.eclipse.xsd.XSDImport;
import org.eclipse.xsd.XSDInclude;
import org.eclipse.xsd.XSDModelGroup;
import org.eclipse.xsd.XSDParticle;
import org.eclipse.xsd.XSDSchema;
import org.eclipse.xsd.XSDTypeDefinition;
import org.eclipse.xsd.util.XSDConstants;

import com.ibm.btools.bom.model.artifacts.ArtifactsFactory;
import com.ibm.btools.bom.model.artifacts.Comment;
import com.ibm.btools.bom.model.artifacts.MultiplicityElement;
import com.ibm.btools.bom.model.artifacts.NamedElement;
import com.ibm.btools.bom.model.artifacts.Type;
import com.ibm.btools.bom.model.artifacts.TypedElement;
import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.bom.model.processes.activities.ActivityEdge;
import com.ibm.btools.bom.model.processes.activities.ConnectableNode;
import com.ibm.btools.bom.model.processes.activities.Datastore;
import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.bom.model.processes.activities.OutputPinSet;
import com.ibm.btools.bom.model.processes.activities.PinSet;
import com.ibm.btools.bom.model.processes.activities.Variable;
import com.ibm.btools.bom.model.services.InputParameterSet;
import com.ibm.btools.bom.model.services.OutputParameterSet;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.framework.util.TransformationUtil;
import com.ibm.btools.te.ilm.CrossProjectReferenceUtil;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.form.FormGenerator;
import com.ibm.btools.te.ilm.heuristics.helper.AbstractbpelUtil;
import com.ibm.btools.te.ilm.heuristics.helper.BomUtils;
import com.ibm.btools.te.ilm.heuristics.helper.BpelOptionsUtil;
import com.ibm.btools.te.ilm.heuristics.helper.ProcessUtil;
import com.ibm.btools.te.ilm.heuristics.naming.JavaNCNameConverter;
import com.ibm.btools.te.ilm.heuristics.naming.NameProvider;
import com.ibm.btools.te.ilm.heuristics.naming.NameProviderFactory;
import com.ibm.btools.te.ilm.heuristics.naming.NamingUtil;
import com.ibm.btools.te.ilm.heuristics.xsd.ClassRule;
import com.ibm.btools.te.ilm.heuristics.xsd.DataDefinitionRule;
import com.ibm.btools.te.ilm.heuristics.xsd.ElementDeclarationRule;
import com.ibm.btools.te.ilm.heuristics.xsd.ListRule;
import com.ibm.btools.te.ilm.heuristics.xsd.PinSetRule;
import com.ibm.btools.te.ilm.heuristics.xsd.XsdPackage;
import com.ibm.btools.te.ilm.heuristics.xsd.util.DataDefinitionUtil;
import com.ibm.btools.te.ilm.heuristics.xsd.util.OriginalXsdUtil;
import com.ibm.btools.util.xml.NCNameConverter;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Pin Set Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class PinSetRuleImpl extends AbstractDataDefRuleImpl implements PinSetRule {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2008, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	public static final String DISPLAY_NAME_DELIMITER= "displayName###";
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PinSetRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return XsdPackage.Literals.PIN_SET_RULE;
	}

	/**
	 * True if the Rule was already executed.
	 */
	boolean runOnce = false;
	/**
	 * Maps a BOM PinSet to a XSDTypeDefinition.
	 * SOURCE: BOM Input/OutputPinSet or a BOM Variable and an XSDSchema. 
	 * Target: XSDTypeDefinition.
	 * @return boolean
	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target()
	 */
	public boolean transformSource2Target(){
		/*
		 * This rule will only execute once. 
		 * This rule is responsible for creating the wrapping complex type for a PinSet, Variable.
		 * If the Pin has specified multiplicity ex Pn has 1..5 BI, an elementDeclaration with the ListOf1To5BI 
		 * will be created rather then an ElementDeclaration with min and max 1.5.
		 * Imports are added for the TypeDefinition of the corresponding Pin in the xsdSchema, second source of this Rule. 
		 * The target of each rule is then attached to the complex type definition. 
		 */
		LoggingUtil.traceEntry(this, "transformSource2Target");
		if(isComplete()){
			LoggingUtil.traceExit(this, "transformSource2Target");
			return true;
		}
		if (getSource() == null || getSource().isEmpty()){
			LoggingUtil.traceExit(this, "transformSource2Target");
			return false;
		}
		EObject pinSet =(EObject) getSource().get(0);
		if (pinSet == null){
			setComplete(true);
			return isComplete();
		}
		if(runOnce){
			setComplete(true);
			LoggingUtil.traceExit(this, "transformSource2Target");
			return isComplete();
		}
		runOnce = true;

		// xsd import enhancement
		XSDElementDeclaration element = OriginalXsdUtil.getElementDeclarationFromRegistry(getContext(),(NamedElement)pinSet);
		if (element != null) {		    
			List pins = collectPins(pinSet);
			if (pins !=null && !pins.isEmpty()) {
				Iterator it = pins.iterator();
				NamedElement pin;
				while(it.hasNext()){
					pin = (NamedElement)it.next();
					getXSDTypeDefinition((TypedElement)pin); // trigger creation of the XSD type
				}			
				setComplete(true);
				return isComplete();
			}
		} else {
			XSDAttributeDeclaration attribute = OriginalXsdUtil.getAttributeDeclarationFromRegistry(getContext(),(NamedElement)pinSet);
			if (attribute != null) {		    
				List pins = collectPins(pinSet);
				if (pins !=null && !pins.isEmpty()) {
					Iterator it = pins.iterator();
					NamedElement pin;
					while(it.hasNext()){
						pin = (NamedElement)it.next();
						getXSDTypeDefinition((TypedElement)pin); // trigger creation of the XSD type
					}			
					setComplete(true);
					return isComplete();
				}
			}
		}

		//if the source of this rule is a BOM Variable get the XSDTypeDefinition for that type and set it as the target of this rule, 
		if(pinSet instanceof Variable || pinSet instanceof Datastore){
			XSDTypeDefinition typeDefinition = getXSDTypeDefinition((TypedElement)pinSet);
			getTarget().add(typeDefinition);
			setComplete(true);
			LoggingUtil.traceExit(this, "transformSource2Target");
			return isComplete();
		}

		XSDSchema schema = (XSDSchema)getSource().get(1);
		List pins = collectPins(pinSet);
		if(pins != null && !pins.isEmpty() ){
			//added special case for PinSet with only one Pin
			if(BomUtils.isSinglePinInSet((PinSet)pinSet) && !BpelOptionsUtil.isAlwaysGenerateWraperComplexType()){
				NamedElement pin = (NamedElement)pins.get(0);
				XSDTypeDefinition typeDefinition = getXSDTypeDefinition((TypedElement)pin);
				// xsd import enhancement
				if (OriginalXsdUtil.isRegisteredAsExternalElement(getContext(), ((TypedElement)pin).getType())) {
					organizeImports(schema, typeDefinition, true, pin);
				} else {
					organizeImports(schema, typeDefinition, false, pin);
				}					
				getTarget().add(typeDefinition);
			}else{
				//TODO add special handling for fault when defined by a SINGLE pin
				if (pinSet instanceof OutputPinSet && 
						((OutputPinSet)pinSet).getIsException() != null && ((OutputPinSet)pinSet).getIsException().booleanValue() &&
						pins.size() == 1 &&
						getParentRule() instanceof ElementDeclarationRule &&
						getParentRule().getTarget().size() > 0 &&
						getParentRule().getTarget().get(0) instanceof XSDElementDeclaration) {
					String convertedPinName = null;
					XSDTypeDefinition typeDefinition = null;
					NamedElement pin = (NamedElement)pins.get(0);
					// update XSDElementDeclaration from the parent rule
					XSDElementDeclaration elementDeclaration = (XSDElementDeclaration)(((ElementDeclarationRule)getParentRule()).getTarget().get(0));
					JavaNCNameConverter converter  = new JavaNCNameConverter();
					convertedPinName = converter.convertName(NamingUtil.findRegistry(this), elementDeclaration, pin.getName()); //, schema);

					elementDeclaration.setName(convertedPinName);
					typeDefinition = getXSDTypeDefinition((TypedElement)pin);	// GJD: 20060720 this should set the element reference for the anonymous type (do not create the complex type, e.g. <xsd:element ref="bons1:anonymousElement"/>
					// xsd import enhancement
					XSDElementDeclaration xsdElementDeclaration = null; 
					if (typeDefinition != null && typeDefinition.getName() == null && typeDefinition.getContainer() instanceof XSDElementDeclaration) {
						xsdElementDeclaration = (XSDElementDeclaration)typeDefinition.getContainer();
					}

					boolean shouldPromotePrefix = false;

					if (xsdElementDeclaration == null) {
						elementDeclaration.setTypeDefinition(typeDefinition);
					} else {
						 elementDeclaration.setResolvedElementDeclaration(xsdElementDeclaration);
						//We need to resolve to the XSD Element Declaration in the Definition
						//1. If the element declaration exists, we refer to the existing element by removing the create element declaration from the inline schema
						//2. If there is no element declaration exists, we create a wrapper element declaration 
						// for the element reference						
						boolean existElement = isReferenceElementCreated(schema, xsdElementDeclaration);
						if(schema.eContainer() instanceof XSDSchemaExtensibilityElement && existElement){
							schema.getContents().remove(elementDeclaration);
							shouldPromotePrefix = true;
						}else{
							//Create wrapper element for the element ref					    	
							createWrappedElement(pin, converter,xsdElementDeclaration);
						}
					}
					if (OriginalXsdUtil.isRegisteredAsExternalElement(getContext(), ((TypedElement)pin).getType())) {
						organizeImports(schema, typeDefinition, true, pin);
						//promote the prefix
						promoteTargetNameSpace(schema, xsdElementDeclaration,shouldPromotePrefix);
					} else {
						organizeImports(schema, typeDefinition, false, pin);
					}					
				} else { // existing code prior to fault handling
					//else if the source of this rule is a Pin/ParameterSet create a complex type definition that will wrap the Set.
					XSDComplexTypeDefinition complexType = XSDFactory.eINSTANCE.createXSDComplexTypeDefinition();
					//				// Check to see if it's a valid name by calling NameConverter
					NameProvider nameProvider = NameProviderFactory.getNameProvider(complexType);
					getTarget().add(complexType);
					//now build the complexType
					XSDModelGroup modelGroup = XSDFactory.eINSTANCE.createXSDModelGroup();
					modelGroup.setCompositor(XSDCompositor.SEQUENCE_LITERAL);
					XSDParticle particle = XSDFactory.eINSTANCE.createXSDParticle();
					particle.setContent(modelGroup);
					complexType.setContent(particle);	

					Iterator it = pins.iterator();
					XSDElementDeclaration elementDeclaration = null;
					String convertedPinName = null;
					XSDTypeDefinition typeDefinition = null;
					NamedElement pin = null;
					while(it.hasNext()){
						pin = (NamedElement)it.next();
						elementDeclaration = XSDFactory.eINSTANCE.createXSDElementDeclaration();
						//set the name of the ElementDeclaration using the NameProvider, name can be stored as a Technical Attribute for a Service thta was imported 
						//through a WSDL Import.If there is no TA set, pin name will be used instead
						//convertedPinName = nameProvider.getName(elementDeclaration, pin, NamingUtil.findRegistry(this), AttributeNameConstants.WSDL_PARAMETER_NAME);
						//PMR 54206,999,616. Should always use the PinName, drop the support for WSDL Import tech Preview
						JavaNCNameConverter converter  = new JavaNCNameConverter();
						//convertedPinName = converter.convertName(NamingUtil.findRegistry(this), elementDeclaration, pin.getName());
						convertedPinName = converter.convertName(NamingUtil.findRegistry(this), elementDeclaration, pin.getName(), modelGroup);
						//feature 190156, form enhancement
						//defect 90307
						Action action = (Action)pin.eContainer();
						String displayName = pin.getName();
						if(FormGenerator.ASPECT_FOR_TEMP_FORM_SAN.equals(action.getAspect())){
							if(pin.getOwnedComment() != null && !pin.getOwnedComment().isEmpty()){
								Iterator it1 = pin.getOwnedComment().iterator();
								while(it1.hasNext()){
									Comment thisComment = (Comment)it1.next();
									if(thisComment.getBody() != null && !thisComment.getBody().equals("") && thisComment.getBody().startsWith(DISPLAY_NAME_DELIMITER) ){
										displayName = thisComment.getBody().substring(DISPLAY_NAME_DELIMITER.length());
										break;
									}
								}
							}
						}
						ProcessUtil.registerDisplayNameForXSDElement(this.getContext(), elementDeclaration, displayName);
						elementDeclaration.setName(convertedPinName);
						typeDefinition = getXSDTypeDefinition((TypedElement)pin);	// GJD: 20060720 this should set the element reference for the anonymous type (do not create the complex type, e.g. <xsd:element ref="bons1:anonymousElement"/>
						// xsd import enhancement
						XSDElementDeclaration xsdElementDeclaration = null; 
						if (typeDefinition != null && typeDefinition.getName() == null && typeDefinition.getContainer() instanceof XSDElementDeclaration) {
							xsdElementDeclaration = (XSDElementDeclaration)typeDefinition.getContainer();
						}

						XSDParticle xsdParticle = XSDFactory.eINSTANCE.createXSDParticle();
						xsdParticle.setContent(elementDeclaration);
						if (xsdElementDeclaration == null) {
							elementDeclaration.setTypeDefinition(typeDefinition);
						} else {
							elementDeclaration.setResolvedElementDeclaration(xsdElementDeclaration);
						}
						if (OriginalXsdUtil.isRegisteredAsExternalElement(getContext(), ((TypedElement)pin).getType())) {
							organizeImports(schema, typeDefinition, true, pin);
						} else {
							organizeImports(schema, typeDefinition, false, pin);
						}					
						modelGroup.getContents().add(xsdParticle);
					}
				}
			}
		}else if(pins.isEmpty()){
			XSDComplexTypeDefinition complexType = XSDFactory.eINSTANCE.createXSDComplexTypeDefinition();
			getTarget().add(complexType);
			//now build the complexType
			XSDModelGroup modelGroup = XSDFactory.eINSTANCE.createXSDModelGroup();
			modelGroup.setCompositor(XSDCompositor.SEQUENCE_LITERAL);
			XSDParticle particle = XSDFactory.eINSTANCE.createXSDParticle();
			particle.setContent(modelGroup);
			complexType.setContent(particle);	
		}
		executeHandlers();
		setComplete(true);
		LoggingUtil.traceExit(this, "transformSource2Target");
		return isComplete();

	}
/**
 * If the message part needs to refer to an XSDElementDeclaration directly, the inline schema's targetnamespace registry needs to be
 * promoted to the enclosing WSDL definition to enhance the visibility of the element
 * @param schema
 * @param xsdElementDeclaration
 * @param shouldPromotePrefix
 */
	private void promoteTargetNameSpace(XSDSchema schema,XSDElementDeclaration xsdElementDeclaration,boolean shouldPromotePrefix) {
		if(shouldPromotePrefix){
			Map<String, String> prefix = schema.getQNamePrefixToNamespaceMap();
			Set<String> keys = prefix.keySet();
			Iterator<String> keyIt = keys.iterator();
			while(keyIt.hasNext()){
				String key = keyIt.next();
				if(xsdElementDeclaration.getTargetNamespace() != null && xsdElementDeclaration.getTargetNamespace().equals(prefix.get(key))){
					//find the target prefix
					if(schema.eContainer() != null && schema.eContainer().eContainer() instanceof Types){
						if(schema.eContainer().eContainer().eContainer() instanceof Definition){
							Definition def = (Definition)schema.eContainer().eContainer().eContainer();
							def.addNamespace(key, prefix.get(key));
							schema.getQNamePrefixToNamespaceMap().remove(key);
						}
					}
				}
				break;
			}
		}
	}
    /**
     * If the element refers to an XSDElementDecalaration reference, for example:
     * <xsd:element ref="bons1:OTA_AirAvailRS"/>
     * We need to create a wrapper element
     * @param pin
     * @param converter
     * @param xsdElementDeclaration
     */
	private void createWrappedElement(NamedElement pin,	JavaNCNameConverter converter,XSDElementDeclaration xsdElementDeclaration) {	
		XSDComplexTypeDefinition complexType = XSDFactory.eINSTANCE.createXSDComplexTypeDefinition();					    	
		NameProvider nameProvider = NameProviderFactory.getNameProvider(complexType);
		getTarget().add(complexType);
		//now build the complexType
		XSDModelGroup modelGroup = XSDFactory.eINSTANCE.createXSDModelGroup();
		modelGroup.setCompositor(XSDCompositor.SEQUENCE_LITERAL);
		XSDParticle particle = XSDFactory.eINSTANCE.createXSDParticle();
		particle.setContent(modelGroup);
		complexType.setContent(particle);

		XSDParticle xsdParticle = XSDFactory.eINSTANCE.createXSDParticle();
		XSDElementDeclaration elementDeclarationWrapped = XSDFactory.eINSTANCE.createXSDElementDeclaration();							
		String convertedPinName = converter.convertName(NamingUtil.findRegistry(this), elementDeclarationWrapped, pin.getName(), modelGroup);							
		Action action = (Action)pin.eContainer();
		String displayName = pin.getName();
		ProcessUtil.registerDisplayNameForXSDElement(this.getContext(), elementDeclarationWrapped, displayName);
		elementDeclarationWrapped.setName(convertedPinName);

		xsdParticle.setContent(elementDeclarationWrapped);
		elementDeclarationWrapped.setResolvedElementDeclaration(xsdElementDeclaration);
		modelGroup.getContents().add(xsdParticle);
	}
    /**
     * Check if the inline schema includes a wrapped element, which is a XSDElementDeclaration reference, that matches the just resolved
     *  XSDElementDeclaration reference
     * @param schema
     * @param xsdElementDeclaration
     * @return
     */
	private boolean isReferenceElementCreated(XSDSchema schema,XSDElementDeclaration xsdElementDeclaration) {
		boolean existElement=false;
		EList contents = schema.getContents();
		Iterator it = contents.iterator();
		while(it.hasNext()){
			Object each = it.next();
			if(each instanceof XSDElementDeclaration){
				XSDElementDeclaration eachED = (XSDElementDeclaration)each;
				XSDTypeDefinition typeDef = eachED.getAnonymousTypeDefinition();
				if(typeDef instanceof XSDComplexTypeDefinition){
					XSDComplexTypeDefinition complexDef = (XSDComplexTypeDefinition)typeDef;
					if(complexDef.getContent() instanceof XSDParticle){
						XSDParticle particle = (XSDParticle)complexDef.getContent();
						if(particle.getContent() instanceof XSDModelGroup){
							XSDModelGroup modelGroup = (XSDModelGroup)particle.getContent();
							if(modelGroup.getContents()!= null && !modelGroup.getContents().isEmpty()){
								Iterator<XSDParticle> particleIt = modelGroup.getContents().iterator();
								while(particleIt.hasNext()){								
									XSDParticle nestedParticle = particleIt.next();
									if(nestedParticle.getContent() instanceof XSDElementDeclaration){
										XSDElementDeclaration createdXSDElementDeclaration = (XSDElementDeclaration)nestedParticle.getContent();
										if(createdXSDElementDeclaration.isElementDeclarationReference()){
											XSDElementDeclaration resolvedXSDElementDeclaration = createdXSDElementDeclaration.getResolvedElementDeclaration();
											if(resolvedXSDElementDeclaration.getTargetNamespace() != null && resolvedXSDElementDeclaration.getName() != null){
												if(resolvedXSDElementDeclaration.getTargetNamespace().equals(xsdElementDeclaration.getTargetNamespace()) &&
														resolvedXSDElementDeclaration.getName().equals(xsdElementDeclaration.getName())){
													existElement = true;
													break;
												}
											}
										}
									}
								}							
							}
						}
					}
				}
			}
			if(existElement){
				break;
			}
		}
		return existElement;
	}	
	/**
	 * Collects the ObjectPins is the <code>pinSet</code>.
	 * @param pinSet a BOM PinSet.
	 * @return List
	 */
	private List collectPins(EObject pinSet){

		List pins = new LinkedList();
		if(pinSet instanceof InputPinSet){
			pins = ((InputPinSet)pinSet).getInputObjectPin();
		}else if(pinSet instanceof OutputPinSet){
			pins = ((OutputPinSet)pinSet).getOutputObjectPin();
		}else if(pinSet instanceof InputParameterSet){
			pins = ((InputParameterSet)pinSet).getParameter();
		}else if(pinSet instanceof OutputParameterSet){
			pins = ((OutputParameterSet)pinSet).getParameter();
		}
		return pins;
	}
	/**
	 * Maps the <code>dataType</code> into a XSDTypeDefinition. Delegates the transformation to a ClassRule 
	 * created in the <code>rule</code> context. 
	 * @param rule the root of the XSD transformation.
	 * @param dataType BOM Type to transform to a XSDTypeDefinition
	 * @return XSDTypeDefinition
	 */
	private XSDTypeDefinition getXSDTypeDefinition(TypedElement pin){

		//pinSet is a NamedElement and a TypedElement - Pin or Parameter.. 
		Type dataType = pin.getType();
		//DataDefinitionRule parentRule = DataDefinitionUtil.getDataDefinitionRule(this, dataType);
		DataDefinitionRule parentRule = DataDefinitionUtil.getDataDefinitionRule(this, pin);
		if(AbstractbpelUtil.isMultipled((MultiplicityElement)pin)){
			return getXSDTypeDefinition(parentRule, pin);
		}else{
			return getXSDTypeDefinition(parentRule , dataType);

		}

	}	

	/**
	 * Maps the <code>dataType</code> into a XSDTypeDefinition. Delegates the transformation to a ClassRule 
	 * created in the <code>rule</code> context. 
	 * @param rule the root of the XSD transformation.
	 * @param dataType BOM Type to transform to a XSDTypeDefinition
	 * @return XSDTypeDefinition
	 */
	private XSDTypeDefinition getXSDTypeDefinition(DataDefinitionRule rule, Type dataType){

		//tries to retrieve a rule with the same source rule from the context. 
		TransformationRule xsdRule = TransformationUtil.getRuleForSource(rule, dataType, XSDTypeDefinition.class);
		if(xsdRule != null){
			return (XSDTypeDefinition)xsdRule.getTarget().get(0);
		}
		XSDTypeDefinition typeDefinition = null;
		//create a typeRule, attach it to the DataDefinitionRule and execute it
		// get the return target and process it
		ClassRule typeRule = XsdFactoryImpl.eINSTANCE.createClassRule();
		if(dataType == null){
			dataType = ArtifactsFactory.eINSTANCE.createPrimitiveType();
			dataType.setName(DataDefinitionUtil.XSD_ANY_TYPE);
		}
		typeRule.getSource().add(dataType);
		rule.getChildRules().add(typeRule);
		boolean ret = rule.transformSource2Target();
		if(typeRule.getTarget()!= null && !typeRule.getTarget().isEmpty()){
			if (typeRule.getTarget().get(0) instanceof XSDTypeDefinition) {
				typeDefinition =(XSDTypeDefinition) typeRule.getTarget().get(0);
				//for anonymous types get the type of the element reference
			} else if (typeRule.getTarget().get(0) instanceof XSDElementDeclaration) {
				XSDElementDeclaration xsdElementDeclaration = (XSDElementDeclaration)typeRule.getTarget().get(0);
				if (xsdElementDeclaration.getType() != null) {
					typeDefinition = xsdElementDeclaration.getType();
				}
			}
		}
		return typeDefinition;
	}

	/**
	 * Maps the typedElement into a XSDTypeDefinition. Delegates the transformation to a ListRule 
	 * created in the <code>rule</code> context, if a ListRule was not already found for this <code>typedElement</code>. 
	 * @param rule the root of the XSD transformation.
	 * @param typedElement BOM TypeElement, also a multiplicity element to transform to a XSDTypeDefinition
	 * @return XSDTypeDefinition
	 */
	private XSDTypeDefinition getXSDTypeDefinition(DataDefinitionRule rule, TypedElement typedElement){

		XSDTypeDefinition typeDefinition = findTypeDefinitionForMultiplicityElement(rule, typedElement);
		if (typeDefinition != null) {
			return typeDefinition;
		}
		ListRule typeRule = XsdFactoryImpl.eINSTANCE.createListRule();
		typeRule.getSource().add(typedElement);
		rule.getChildRules().add(typeRule);
		//executes the rule in the context and return the target of this rule.
		boolean ret = rule.transformSource2Target();
		if(typeRule.getTarget()!= null && !typeRule.getTarget().isEmpty()){
			typeDefinition =(XSDTypeDefinition) typeRule.getTarget().get(0);
		}
		return typeDefinition;
	}	

	/**
	 * If the <code>typeDefinition</code> is defined in another XSDSchema, add the import for that schema
	 * (if not already added) to this <code>schema</code>.
	 * @param schema - XSDSchema 
	 * @param typeDefinition - XSDTypeDefiniton 
	 * @param pin TODO
	 */
	private void organizeImports(XSDSchema schema, XSDTypeDefinition typeDefinition, boolean isExternal, NamedElement pin){
		if(typeDefinition == null || schema == null){	// can typeDefinition NOT be in the schema (created not added)?
			return;
		}

		String namespace = null;
		namespace = typeDefinition.getTargetNamespace();

		if (namespace == null && typeDefinition.getSchema() != null) {
			namespace = typeDefinition.getSchema().getTargetNamespace();
		}

		//		if (namespace ==  null) {
		//			String name = typeDefinition.getName();
		//			if (name == null && typeDefinition.eContainer() != null && typeDefinition.eContainer() instanceof XSDElementDeclaration) {
		//				name = ((XSDElementDeclaration)typeDefinition.eContainer()).getName();
		//			}
		//			String params[] = {name};
		//			LoggingUtil.logError(MessageKeys.NO_NAMESPACE_FOR_ORIGINAL_XSD_DEFINITION, params, null);
		//			BTRuntimeException runtimeEx = new BTRuntimeException(TEResourceBundleSingleton.INSTANCE.getMessage(MessageKeys.NO_NAMESPACE_FOR_ORIGINAL_XSD_DEFINITION));
		//			throw runtimeEx;
		//		}

		if (namespace != null && namespace.equals(XSDConstants.SCHEMA_FOR_SCHEMA_URI_2001)) {
			return;
		}

		if (namespace == null) {
			if (typeDefinition.getSchema() != null && 
					typeDefinition.getSchema().getSchemaLocation() != null) {
				if (namespace == null && schema.getTargetNamespace() == null) {
					if(!OriginalXsdUtil.hasIncludeForFile(schema, typeDefinition.getSchema().getSchemaLocation())) {
						XSDInclude include = XSDFactory.eINSTANCE.createXSDInclude();
						include.setSchemaLocation(typeDefinition.getSchema().getSchemaLocation());
						schema.getContents().add(0,include);
					}	
				} else {
					if(!OriginalXsdUtil.hasImportForFile(schema, typeDefinition.getSchema().getSchemaLocation())) {
						XSDImport imp = XSDFactory.eINSTANCE.createXSDImport();
						imp.setSchemaLocation(typeDefinition.getSchema().getSchemaLocation());
						schema.getContents().add(0,imp);					
						//once an import is added, registe it with the PortType it is created for. This is the PortType that 
						//is currently in the context.
						ProcessUtil.registerMessageTypeForPortType(getContext(), imp);
					}else{
						XSDImport imp = getImportForLocation(schema, typeDefinition.getSchema().getSchemaLocation());
						ProcessUtil.registerMessageTypeForPortType(getContext(), imp);
					}


				}
			}
		} else {
			if (namespace.equals(schema.getTargetNamespace()) && 
					schema.getSchemaLocation() != null && 
					typeDefinition.getSchema() != null &&
					!schema.getSchemaLocation().equals(typeDefinition.getSchema().getSchemaLocation())) {
				XSDTypeDefinition resolved = schema.resolveTypeDefinition(namespace, typeDefinition.getName());
				XSDInclude include = XSDFactory.eINSTANCE.createXSDInclude();
				if (isExternal) {
					include.setSchemaLocation(typeDefinition.getSchema().getSchemaLocation());
				} else {
					include.setSchemaLocation(ProcessUtil.createFileName(namespace)+".xsd");
				}
				schema.getContents().add(0, include);					
			} else {
				XSDTypeDefinition resolved = schema.resolveTypeDefinition(namespace, typeDefinition.getName());
				if(resolved != typeDefinition) {
					// need to add namespaces etc
					//check if there already is an import for this namespace
					//AZ Handle duplicate key
					String projectName = null;
					if(pin instanceof TypedElement){	
						TypedElement typedElement = (TypedElement)pin;
						if(typedElement.getType() instanceof com.ibm.btools.bom.model.artifacts.Class){
							projectName = CrossProjectReferenceUtil.getProjectNameForSourceObject(typedElement.getType());
						}
					}
					if(!OriginalXsdUtil.hasImportForNamespace(schema, namespace)) {
						XSDImport imp = XSDFactory.eINSTANCE.createXSDImport();
						imp.setNamespace(namespace);
						if (isExternal) {
							imp.setSchemaLocation(typeDefinition.getSchema().getSchemaLocation());
						} else {
							imp.setSchemaLocation(ProcessUtil.createFileName(namespace)+".xsd");
						}
						schema.getContents().add(0,imp);					
						if(projectName != null){
							JavaNCNameConverter converter = new JavaNCNameConverter();
							String projectNCName = converter.convertName(projectName);	
							schema.getQNamePrefixToNamespaceMap().put(DataDefinitionUtil.getNamespacePrefix(namespace)+projectNCName, namespace);
						}else{
							schema.getQNamePrefixToNamespaceMap().put(DataDefinitionUtil.getNamespacePrefix(namespace), namespace);
						}
						//once an import is added, registe it with the PortType it is created for. This is the PortType that 
						//is currently in the context.
						ProcessUtil.registerMessageTypeForPortType(getContext(), imp);
					}else{
						//even if the import already exists, try to register it with the PortType. If it was already registered, it will
						//be skipped.
						XSDImport xsdImport= getImportForNamespace(schema, namespace);
						if(xsdImport != null)
							ProcessUtil.registerMessageTypeForPortType(getContext(), xsdImport);
						if (isExternal && !OriginalXsdUtil.hasImportForFile(schema, typeDefinition.getSchema().getSchemaLocation())) {
							XSDImport imp = XSDFactory.eINSTANCE.createXSDImport();
							imp.setNamespace(namespace);
							imp.setSchemaLocation(typeDefinition.getSchema().getSchemaLocation());
							schema.getContents().add(0,imp);						
						}
					}
				}
			}
		}
	}

	private XSDImport getImportForNamespace(XSDSchema schema, String namespace){
		XSDImport xsdImport = null;
		List schemaContents = schema.getContents();
		if(schemaContents != null && !schemaContents.isEmpty()){
			Iterator it = schemaContents.iterator();
			while(it.hasNext()){
				Object obj = it.next();
				if(obj instanceof XSDImport &&
						((XSDImport)obj).getNamespace() != null &&
						((XSDImport)obj).getNamespace().equals(namespace)){
					xsdImport = (XSDImport)obj;
					return xsdImport;
				}
			}
		}
		return xsdImport;
	}

	private XSDImport getImportForLocation(XSDSchema schema, String location){
		XSDImport xsdImport = null;
		List schemaContents = schema.getContents();
		if(schemaContents != null && !schemaContents.isEmpty()){
			Iterator it = schemaContents.iterator();
			while(it.hasNext()){
				Object obj = it.next();
				if(obj instanceof XSDImport &&
						((XSDImport)obj).getSchemaLocation() != null &&
						((XSDImport)obj).getSchemaLocation().equals(location)){
					xsdImport = (XSDImport)obj;
					return xsdImport;
				}
			}
		}
		return xsdImport;
	}
	/**
	 * This method attempts to find an existing type definition for the TypedElement (with upperbound > 1) 
	 * @param rule
	 * @param typedElement
	 * @return
	 */
	private XSDTypeDefinition findTypeDefinitionForMultiplicityElement(DataDefinitionRule rule, TypedElement typedElement) {
		TransformationRule xsdRule = null;
		if (typedElement instanceof ConnectableNode) {
			ConnectableNode connectableNode = (ConnectableNode)typedElement;
			// assume the connectable node can either have an incoming or outgoing edge but not both
			boolean isIncoming = connectableNode.getIncoming()==null?false:true;
			ActivityEdge edge;
			if (isIncoming) {
				edge = connectableNode.getIncoming();
			} else {
				edge = connectableNode.getOutgoing();
			}
			if (edge != null) {
				// retrieve the connected node
				ConnectableNode connectedNode=isIncoming?edge.getSource():edge.getTarget();
				// Check if the two connected nodes has the same type
				// if they do, then find the typeDefinition of the other node if exists
				// Note: here we intentionally ignore the multiplicity checking because it 
				// complicates this Part rule if we want to handle compatible multiplicity
				// properly in here (which is arguable if it should be taken care in this rule.
				// Therefore, we are basing on the following assumption:
				// 	If the two connected nodes (of same type) have different multiplicity, then if a typeDefinition
				// 	is already available, then use it as the typeDefinition of the other node.
				if (connectedNode instanceof TypedElement) {
					if (typedElement.getType() == ((TypedElement)connectedNode).getType()) {
						xsdRule = TransformationUtil.getRuleForSource(getRoot(), (TypedElement)connectedNode, XSDTypeDefinition.class);
					} else {
						// 	If the two connected nodes has different type (the target node's type must be a superclass of 
						// 	the source), then for now force to make them the same type ... until we find a better solution
						xsdRule = TransformationUtil.getRuleForSource(getRoot(), (TypedElement)connectedNode, XSDTypeDefinition.class);
					}
				}
			}
		} else {
			xsdRule = TransformationUtil.getRuleForSource(getRoot(), typedElement, XSDTypeDefinition.class);
		}
		if(xsdRule != null){
			return (XSDTypeDefinition)xsdRule.getTarget().get(0);
		}
		return null;		
	}	

} //PinSetRuleImpl
