/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.xsd.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.xsd.XSDAttributeDeclaration;
import org.eclipse.xsd.XSDComplexTypeContent;
import org.eclipse.xsd.XSDComplexTypeDefinition;
import org.eclipse.xsd.XSDElementDeclaration;
import org.eclipse.xsd.XSDFactory;
import org.eclipse.xsd.XSDParticle;
import org.eclipse.xsd.XSDTypeDefinition;

import com.ibm.btools.bom.model.artifacts.Classifier;
import com.ibm.btools.bom.model.artifacts.NamedElement;
import com.ibm.btools.bom.model.artifacts.Property;
import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.xsd.PropertyRule;
import com.ibm.btools.te.ilm.heuristics.xsd.XsdPackage;
import com.ibm.btools.te.ilm.heuristics.xsd.util.DataDefinitionUtil;
import com.ibm.btools.te.ilm.heuristics.xsd.util.OriginalXsdUtil;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Property Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class PropertyRuleImpl extends AbstractDataDefRuleImpl implements PropertyRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return XsdPackage.Literals.PROPERTY_RULE;
	}

	/**
	 * Source = BOM Property and XSDTypeDefinition (Optional)
	 * Target = XSDParticle of the XML element that represents the BOM Property
	 * This rule creates an XSD particle for a BOM Property.  It only adds the Type definition
	 * for the XSDParticle if it is presented in the source
	 */
	public boolean transformSource2Target() {
		LoggingUtil.traceEntry(this, "transformSource2Target");

		Property property = (Property)getSource().get(0);

		XSDTypeDefinition typeDef = null;
		if (getSource().size() > 1) {
			typeDef = (XSDTypeDefinition)getSource().get(1);
		}
		// We don't convert the XSD element name at this point because at this point
		// the element is not yet scoped to the complex type.  It is important for the NCName
		// conversion to perform properly for checking uniqueness of the name
		// within the scope of the complex type.  Therefore it should be the parent rule that
		// created this rule to perform NCName conversion of the xsd element name afterwards
		
		XSDParticle xsdParticle = null;
		XSDParticle originalParticle = null;
		
		if (property.eContainer() instanceof Classifier) {
			XSDTypeDefinition typeDefinition = OriginalXsdUtil.getXSDTypeFromRegistry(getContext(),(NamedElement)property.eContainer());
			if (typeDefinition == null) {
			    XSDElementDeclaration componentDefinition = OriginalXsdUtil.getElementDeclarationFromRegistry(getContext(),(NamedElement)property.eContainer());
			    if (componentDefinition != null) {
			        typeDefinition = componentDefinition.getType();
			    } else {
				    XSDAttributeDeclaration attributeDefinition = OriginalXsdUtil.getAttributeDeclarationFromRegistry(getContext(),(NamedElement)property.eContainer());
				    if (attributeDefinition != null) {
				        typeDefinition = attributeDefinition.getType();
				    }
			    }
			}
			
			if (typeDefinition != null && typeDefinition instanceof XSDComplexTypeDefinition) {
				XSDComplexTypeContent content = ((XSDComplexTypeDefinition)typeDefinition).getContent();
				if (content != null && content instanceof XSDParticle) {
				    originalParticle = OriginalXsdUtil.getParticleFromParticle((XSDParticle)content, property.getName());
				}
			}
		}

	    if (originalParticle != null) {
	        xsdParticle = originalParticle;
	    } else {	// original code
			XSDElementDeclaration decl =
				XSDFactory.eINSTANCE.createXSDElementDeclaration();
			if (typeDef != null) {
				if (typeDef.getName() != null) {
					decl.setTypeDefinition(typeDef);
					decl.setName(property.getName());
				} else if (typeDef.getContainer() instanceof XSDElementDeclaration){	//anonymous element
					decl.setResolvedElementDeclaration((XSDElementDeclaration)typeDef.getContainer());
				}
			}
			xsdParticle = XSDFactory.eINSTANCE.createXSDParticle();
			xsdParticle.setContent(decl);
	
			if (property.getLowerBound()!=null) {
				xsdParticle.setMinOccurs(DataDefinitionUtil.convertToXSDMultiplicity(property.getLowerBound()));
			}
			if (property.getLowerBound()!=null) {
				xsdParticle.setMaxOccurs(DataDefinitionUtil.convertToXSDMultiplicity(property.getUpperBound()));
			}
	    }
	    
		getTarget().add(xsdParticle);	    
		setComplete(true);
		
		executeHandlers();
		
		LoggingUtil.traceExit(this, "transformSource2Target");
		return true;
	}

} //PropertyRuleImpl
