/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.model.sa;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.ibm.btools.te.ilm.model.sa.SaFactory
 * @model kind="package"
 * @generated
 */
public interface SaPackage extends EPackage {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  String eNAME = "sa";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  String eNS_URI = "http:///model/sa.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  String eNS_PREFIX = "model.sa";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  SaPackage eINSTANCE = com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.model.sa.impl.SolutionArtifactImpl <em>Solution Artifact</em>}' class.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.model.sa.impl.SolutionArtifactImpl
	 * @see com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl#getSolutionArtifact()
	 * @generated
	 */
  int SOLUTION_ARTIFACT = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
  int SOLUTION_ARTIFACT__NAME = 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
  int SOLUTION_ARTIFACT__TYPE = 1;

	/**
	 * The feature id for the '<em><b>Package</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOLUTION_ARTIFACT__PACKAGE = 2;

	/**
	 * The feature id for the '<em><b>Composed Artifacts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
  int SOLUTION_ARTIFACT__COMPOSED_ARTIFACTS = 3;

	/**
	 * The number of structural features of the '<em>Solution Artifact</em>' class.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
  int SOLUTION_ARTIFACT_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.model.sa.impl.ComposedArtifactImpl <em>Composed Artifact</em>}' class.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.model.sa.impl.ComposedArtifactImpl
	 * @see com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl#getComposedArtifact()
	 * @generated
	 */
  int COMPOSED_ARTIFACT = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
  int COMPOSED_ARTIFACT__NAME = 0;

	/**
	 * The number of structural features of the '<em>Composed Artifact</em>' class.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
  int COMPOSED_ARTIFACT_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.model.sa.impl.ProcessFlowImpl <em>Process Flow</em>}' class.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.model.sa.impl.ProcessFlowImpl
	 * @see com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl#getProcessFlow()
	 * @generated
	 */
  int PROCESS_FLOW = 2;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
  int PROCESS_FLOW__NAME = COMPOSED_ARTIFACT__NAME;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
  int PROCESS_FLOW__TYPE = COMPOSED_ARTIFACT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Process Interface</b></em>' reference list.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
  int PROCESS_FLOW__PROCESS_INTERFACE = COMPOSED_ARTIFACT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Process Definition</b></em>' reference.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
  int PROCESS_FLOW__PROCESS_DEFINITION = COMPOSED_ARTIFACT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Related Artifacts</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_FLOW__RELATED_ARTIFACTS = COMPOSED_ARTIFACT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Process Flow</em>' class.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
  int PROCESS_FLOW_FEATURE_COUNT = COMPOSED_ARTIFACT_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.model.sa.impl.UnclassifiedArtifactImpl <em>Unclassified Artifact</em>}' class.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.model.sa.impl.UnclassifiedArtifactImpl
	 * @see com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl#getUnclassifiedArtifact()
	 * @generated
	 */
  int UNCLASSIFIED_ARTIFACT = 3;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
  int UNCLASSIFIED_ARTIFACT__NAME = COMPOSED_ARTIFACT__NAME;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
  int UNCLASSIFIED_ARTIFACT__TYPE = COMPOSED_ARTIFACT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Artifacts</b></em>' reference list.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
  int UNCLASSIFIED_ARTIFACT__ARTIFACTS = COMPOSED_ARTIFACT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Unclassified Artifact</em>' class.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
  int UNCLASSIFIED_ARTIFACT_FEATURE_COUNT = COMPOSED_ARTIFACT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.model.sa.impl.ScdlArtifactImpl <em>Scdl Artifact</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.model.sa.impl.ScdlArtifactImpl
	 * @see com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl#getScdlArtifact()
	 * @generated
	 */
	int SCDL_ARTIFACT = 4;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCDL_ARTIFACT__NAME = COMPOSED_ARTIFACT__NAME;

	/**
	 * The feature id for the '<em><b>Artifact</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCDL_ARTIFACT__ARTIFACT = COMPOSED_ARTIFACT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Scdl Artifact</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCDL_ARTIFACT_FEATURE_COUNT = COMPOSED_ARTIFACT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.model.sa.impl.HumanTaskImpl <em>Human Task</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.model.sa.impl.HumanTaskImpl
	 * @see com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl#getHumanTask()
	 * @generated
	 */
	int HUMAN_TASK = 5;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HUMAN_TASK__NAME = COMPOSED_ARTIFACT__NAME;

	/**
	 * The feature id for the '<em><b>Inline</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HUMAN_TASK__INLINE = COMPOSED_ARTIFACT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Human Task</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HUMAN_TASK__HUMAN_TASK = COMPOSED_ARTIFACT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Human Task</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HUMAN_TASK_FEATURE_COUNT = COMPOSED_ARTIFACT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.model.sa.SAType <em>SA Type</em>}' enum.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.model.sa.SAType
	 * @see com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl#getSAType()
	 * @generated
	 */
  int SA_TYPE = 6;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.model.sa.ProcessFlowType <em>Process Flow Type</em>}' enum.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.model.sa.ProcessFlowType
	 * @see com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl#getProcessFlowType()
	 * @generated
	 */
  int PROCESS_FLOW_TYPE = 7;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.model.sa.UnclassifiedArtifactType <em>Unclassified Artifact Type</em>}' enum.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.model.sa.UnclassifiedArtifactType
	 * @see com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl#getUnclassifiedArtifactType()
	 * @generated
	 */
  int UNCLASSIFIED_ARTIFACT_TYPE = 8;


	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.model.sa.SolutionArtifact <em>Solution Artifact</em>}'.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Solution Artifact</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.SolutionArtifact
	 * @generated
	 */
  EClass getSolutionArtifact();

	/**
	 * Returns the meta object for the attribute '{@link com.ibm.btools.te.ilm.model.sa.SolutionArtifact#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.SolutionArtifact#getName()
	 * @see #getSolutionArtifact()
	 * @generated
	 */
  EAttribute getSolutionArtifact_Name();

	/**
	 * Returns the meta object for the attribute '{@link com.ibm.btools.te.ilm.model.sa.SolutionArtifact#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.SolutionArtifact#getType()
	 * @see #getSolutionArtifact()
	 * @generated
	 */
  EAttribute getSolutionArtifact_Type();

	/**
	 * Returns the meta object for the attribute '{@link com.ibm.btools.te.ilm.model.sa.SolutionArtifact#getPackage <em>Package</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Package</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.SolutionArtifact#getPackage()
	 * @see #getSolutionArtifact()
	 * @generated
	 */
	EAttribute getSolutionArtifact_Package();

	/**
	 * Returns the meta object for the containment reference list '{@link com.ibm.btools.te.ilm.model.sa.SolutionArtifact#getComposedArtifacts <em>Composed Artifacts</em>}'.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Composed Artifacts</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.SolutionArtifact#getComposedArtifacts()
	 * @see #getSolutionArtifact()
	 * @generated
	 */
  EReference getSolutionArtifact_ComposedArtifacts();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.model.sa.ComposedArtifact <em>Composed Artifact</em>}'.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Composed Artifact</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.ComposedArtifact
	 * @generated
	 */
  EClass getComposedArtifact();

	/**
	 * Returns the meta object for the attribute '{@link com.ibm.btools.te.ilm.model.sa.ComposedArtifact#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.ComposedArtifact#getName()
	 * @see #getComposedArtifact()
	 * @generated
	 */
  EAttribute getComposedArtifact_Name();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.model.sa.ProcessFlow <em>Process Flow</em>}'.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Flow</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.ProcessFlow
	 * @generated
	 */
  EClass getProcessFlow();

	/**
	 * Returns the meta object for the attribute '{@link com.ibm.btools.te.ilm.model.sa.ProcessFlow#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.ProcessFlow#getType()
	 * @see #getProcessFlow()
	 * @generated
	 */
  EAttribute getProcessFlow_Type();

	/**
	 * Returns the meta object for the reference list '{@link com.ibm.btools.te.ilm.model.sa.ProcessFlow#getProcessInterface <em>Process Interface</em>}'.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Process Interface</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.ProcessFlow#getProcessInterface()
	 * @see #getProcessFlow()
	 * @generated
	 */
  EReference getProcessFlow_ProcessInterface();

	/**
	 * Returns the meta object for the reference '{@link com.ibm.btools.te.ilm.model.sa.ProcessFlow#getProcessDefinition <em>Process Definition</em>}'.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Process Definition</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.ProcessFlow#getProcessDefinition()
	 * @see #getProcessFlow()
	 * @generated
	 */
  EReference getProcessFlow_ProcessDefinition();

	/**
	 * Returns the meta object for the reference list '{@link com.ibm.btools.te.ilm.model.sa.ProcessFlow#getRelatedArtifacts <em>Related Artifacts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Related Artifacts</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.ProcessFlow#getRelatedArtifacts()
	 * @see #getProcessFlow()
	 * @generated
	 */
	EReference getProcessFlow_RelatedArtifacts();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.model.sa.UnclassifiedArtifact <em>Unclassified Artifact</em>}'.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unclassified Artifact</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.UnclassifiedArtifact
	 * @generated
	 */
  EClass getUnclassifiedArtifact();

	/**
	 * Returns the meta object for the attribute '{@link com.ibm.btools.te.ilm.model.sa.UnclassifiedArtifact#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.UnclassifiedArtifact#getType()
	 * @see #getUnclassifiedArtifact()
	 * @generated
	 */
  EAttribute getUnclassifiedArtifact_Type();

	/**
	 * Returns the meta object for the reference list '{@link com.ibm.btools.te.ilm.model.sa.UnclassifiedArtifact#getArtifacts <em>Artifacts</em>}'.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Artifacts</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.UnclassifiedArtifact#getArtifacts()
	 * @see #getUnclassifiedArtifact()
	 * @generated
	 */
  EReference getUnclassifiedArtifact_Artifacts();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.model.sa.ScdlArtifact <em>Scdl Artifact</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Scdl Artifact</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.ScdlArtifact
	 * @generated
	 */
	EClass getScdlArtifact();

	/**
	 * Returns the meta object for the reference '{@link com.ibm.btools.te.ilm.model.sa.ScdlArtifact#getArtifact <em>Artifact</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Artifact</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.ScdlArtifact#getArtifact()
	 * @see #getScdlArtifact()
	 * @generated
	 */
	EReference getScdlArtifact_Artifact();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.model.sa.HumanTask <em>Human Task</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Human Task</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.HumanTask
	 * @generated
	 */
	EClass getHumanTask();

	/**
	 * Returns the meta object for the attribute '{@link com.ibm.btools.te.ilm.model.sa.HumanTask#isInline <em>Inline</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Inline</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.HumanTask#isInline()
	 * @see #getHumanTask()
	 * @generated
	 */
	EAttribute getHumanTask_Inline();

	/**
	 * Returns the meta object for the reference '{@link com.ibm.btools.te.ilm.model.sa.HumanTask#getHumanTask <em>Human Task</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Human Task</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.HumanTask#getHumanTask()
	 * @see #getHumanTask()
	 * @generated
	 */
	EReference getHumanTask_HumanTask();

	/**
	 * Returns the meta object for enum '{@link com.ibm.btools.te.ilm.model.sa.SAType <em>SA Type</em>}'.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>SA Type</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.SAType
	 * @generated
	 */
  EEnum getSAType();

	/**
	 * Returns the meta object for enum '{@link com.ibm.btools.te.ilm.model.sa.ProcessFlowType <em>Process Flow Type</em>}'.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Process Flow Type</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.ProcessFlowType
	 * @generated
	 */
  EEnum getProcessFlowType();

	/**
	 * Returns the meta object for enum '{@link com.ibm.btools.te.ilm.model.sa.UnclassifiedArtifactType <em>Unclassified Artifact Type</em>}'.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Unclassified Artifact Type</em>'.
	 * @see com.ibm.btools.te.ilm.model.sa.UnclassifiedArtifactType
	 * @generated
	 */
  EEnum getUnclassifiedArtifactType();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
  SaFactory getSaFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals  {
		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.model.sa.impl.SolutionArtifactImpl <em>Solution Artifact</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.model.sa.impl.SolutionArtifactImpl
		 * @see com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl#getSolutionArtifact()
		 * @generated
		 */
		EClass SOLUTION_ARTIFACT = eINSTANCE.getSolutionArtifact();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SOLUTION_ARTIFACT__NAME = eINSTANCE.getSolutionArtifact_Name();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SOLUTION_ARTIFACT__TYPE = eINSTANCE.getSolutionArtifact_Type();

		/**
		 * The meta object literal for the '<em><b>Package</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SOLUTION_ARTIFACT__PACKAGE = eINSTANCE.getSolutionArtifact_Package();

		/**
		 * The meta object literal for the '<em><b>Composed Artifacts</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SOLUTION_ARTIFACT__COMPOSED_ARTIFACTS = eINSTANCE.getSolutionArtifact_ComposedArtifacts();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.model.sa.impl.ComposedArtifactImpl <em>Composed Artifact</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.model.sa.impl.ComposedArtifactImpl
		 * @see com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl#getComposedArtifact()
		 * @generated
		 */
		EClass COMPOSED_ARTIFACT = eINSTANCE.getComposedArtifact();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COMPOSED_ARTIFACT__NAME = eINSTANCE.getComposedArtifact_Name();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.model.sa.impl.ProcessFlowImpl <em>Process Flow</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.model.sa.impl.ProcessFlowImpl
		 * @see com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl#getProcessFlow()
		 * @generated
		 */
		EClass PROCESS_FLOW = eINSTANCE.getProcessFlow();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROCESS_FLOW__TYPE = eINSTANCE.getProcessFlow_Type();

		/**
		 * The meta object literal for the '<em><b>Process Interface</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROCESS_FLOW__PROCESS_INTERFACE = eINSTANCE.getProcessFlow_ProcessInterface();

		/**
		 * The meta object literal for the '<em><b>Process Definition</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROCESS_FLOW__PROCESS_DEFINITION = eINSTANCE.getProcessFlow_ProcessDefinition();

		/**
		 * The meta object literal for the '<em><b>Related Artifacts</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROCESS_FLOW__RELATED_ARTIFACTS = eINSTANCE.getProcessFlow_RelatedArtifacts();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.model.sa.impl.UnclassifiedArtifactImpl <em>Unclassified Artifact</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.model.sa.impl.UnclassifiedArtifactImpl
		 * @see com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl#getUnclassifiedArtifact()
		 * @generated
		 */
		EClass UNCLASSIFIED_ARTIFACT = eINSTANCE.getUnclassifiedArtifact();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute UNCLASSIFIED_ARTIFACT__TYPE = eINSTANCE.getUnclassifiedArtifact_Type();

		/**
		 * The meta object literal for the '<em><b>Artifacts</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference UNCLASSIFIED_ARTIFACT__ARTIFACTS = eINSTANCE.getUnclassifiedArtifact_Artifacts();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.model.sa.impl.ScdlArtifactImpl <em>Scdl Artifact</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.model.sa.impl.ScdlArtifactImpl
		 * @see com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl#getScdlArtifact()
		 * @generated
		 */
		EClass SCDL_ARTIFACT = eINSTANCE.getScdlArtifact();

		/**
		 * The meta object literal for the '<em><b>Artifact</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SCDL_ARTIFACT__ARTIFACT = eINSTANCE.getScdlArtifact_Artifact();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.model.sa.impl.HumanTaskImpl <em>Human Task</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.model.sa.impl.HumanTaskImpl
		 * @see com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl#getHumanTask()
		 * @generated
		 */
		EClass HUMAN_TASK = eINSTANCE.getHumanTask();

		/**
		 * The meta object literal for the '<em><b>Inline</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HUMAN_TASK__INLINE = eINSTANCE.getHumanTask_Inline();

		/**
		 * The meta object literal for the '<em><b>Human Task</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference HUMAN_TASK__HUMAN_TASK = eINSTANCE.getHumanTask_HumanTask();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.model.sa.SAType <em>SA Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.model.sa.SAType
		 * @see com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl#getSAType()
		 * @generated
		 */
		EEnum SA_TYPE = eINSTANCE.getSAType();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.model.sa.ProcessFlowType <em>Process Flow Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.model.sa.ProcessFlowType
		 * @see com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl#getProcessFlowType()
		 * @generated
		 */
		EEnum PROCESS_FLOW_TYPE = eINSTANCE.getProcessFlowType();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.model.sa.UnclassifiedArtifactType <em>Unclassified Artifact Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.model.sa.UnclassifiedArtifactType
		 * @see com.ibm.btools.te.ilm.model.sa.impl.SaPackageImpl#getUnclassifiedArtifactType()
		 * @generated
		 */
		EEnum UNCLASSIFIED_ARTIFACT_TYPE = eINSTANCE.getUnclassifiedArtifactType();

	}

} //SaPackage
