/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.model.sa;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Unclassified Artifact Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see com.ibm.btools.te.ilm.model.sa.SaPackage#getUnclassifiedArtifactType()
 * @model
 * @generated
 */
public final class UnclassifiedArtifactType extends AbstractEnumerator
{
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The '<em><b>Web Services Interface</b></em>' literal value.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see #WEB_SERVICES_INTERFACE_LITERAL
	 * @model name="WebServicesInterface"
	 * @generated
	 * @ordered
	 */
  public static final int WEB_SERVICES_INTERFACE = 0;

	/**
	 * The '<em><b>Xml Schema</b></em>' literal value.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see #XML_SCHEMA_LITERAL
	 * @model name="XmlSchema"
	 * @generated
	 * @ordered
	 */
  public static final int XML_SCHEMA = 1;

	/**
	 * The '<em><b>Workflow Definition</b></em>' literal value.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see #WORKFLOW_DEFINITION_LITERAL
	 * @model name="WorkflowDefinition"
	 * @generated
	 * @ordered
	 */
  public static final int WORKFLOW_DEFINITION = 2;

	/**
	 * The '<em><b>XFDL</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>XFDL</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #XFDL_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int XFDL = 3;

	/**
	 * The '<em><b>Web Services Interface</b></em>' literal object.
	 * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Web Services Interface</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
	 * @see #WEB_SERVICES_INTERFACE
	 * @generated
	 * @ordered
	 */
  public static final UnclassifiedArtifactType WEB_SERVICES_INTERFACE_LITERAL = new UnclassifiedArtifactType(WEB_SERVICES_INTERFACE, "WebServicesInterface", "WebServicesInterface");

	/**
	 * The '<em><b>Xml Schema</b></em>' literal object.
	 * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Xml Schema</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
	 * @see #XML_SCHEMA
	 * @generated
	 * @ordered
	 */
  public static final UnclassifiedArtifactType XML_SCHEMA_LITERAL = new UnclassifiedArtifactType(XML_SCHEMA, "XmlSchema", "XmlSchema");

	/**
	 * The '<em><b>Workflow Definition</b></em>' literal object.
	 * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Workflow Definition</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
	 * @see #WORKFLOW_DEFINITION
	 * @generated
	 * @ordered
	 */
  public static final UnclassifiedArtifactType WORKFLOW_DEFINITION_LITERAL = new UnclassifiedArtifactType(WORKFLOW_DEFINITION, "WorkflowDefinition", "WorkflowDefinition");

	/**
	 * The '<em><b>XFDL</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #XFDL
	 * @generated
	 * @ordered
	 */
	public static final UnclassifiedArtifactType XFDL_LITERAL = new UnclassifiedArtifactType(XFDL, "XFDL", "XFDL");

	/**
	 * An array of all the '<em><b>Unclassified Artifact Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  private static final UnclassifiedArtifactType[] VALUES_ARRAY =
		new UnclassifiedArtifactType[] {
			WEB_SERVICES_INTERFACE_LITERAL,
			XML_SCHEMA_LITERAL,
			WORKFLOW_DEFINITION_LITERAL,
			XFDL_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>Unclassified Artifact Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Unclassified Artifact Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public static UnclassifiedArtifactType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			UnclassifiedArtifactType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Unclassified Artifact Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static UnclassifiedArtifactType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			UnclassifiedArtifactType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Unclassified Artifact Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public static UnclassifiedArtifactType get(int value) {
		switch (value) {
			case WEB_SERVICES_INTERFACE: return WEB_SERVICES_INTERFACE_LITERAL;
			case XML_SCHEMA: return XML_SCHEMA_LITERAL;
			case WORKFLOW_DEFINITION: return WORKFLOW_DEFINITION_LITERAL;
			case XFDL: return XFDL_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private UnclassifiedArtifactType(int value, String name, String literal) {
		super(value, name, literal);
	}

} //UnclassifiedArtifactType
