package com.ibm.btools.te.ilm.resource;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import com.ibm.btools.util.resource.CommonMessageKeys;

public interface MessageKeys extends CommonMessageKeys {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	public final static String RESOURCE_PROPERTY_FILE = "com.ibm.btools.te.ilm.resource.messages";
	public final static String PLUGIN_ID = "com.ibm.btools.te.ilm";
	
	
	/*---------- 0001 - 1000 -- Mapping rule ERROR messages ----------*/
	/* 0001 - 0100 -- Common Error */
	public final static String UNABLE_WRITE_TO_FILE = "TEN00001e";
	public final static String UNABLE_READ_FROM_FILE = "TEN00002e";
	/*----------support traceabilit---------------------------------*/
	public final static String ERROR_GET_MD5_INSTANCE = "TEN00003e";
	/*----------error message when persisting ODF-------------------*/
	public final static String ERROR_RETRIEVE_MAPPING_MANAGER = "TEN00004e";
	public final static String ERROR_SAVE_ODF_FILE = "TEN00005e";	
	
	/* 0101 - 0150 -- BPEL/BPEL+ specific error */
	public final static String BOM_OBJECT_NOT_SUPPORTED 	= "TEN01010e";
	public final static String CBA_MULTIPLE_CORRELATION_NOT_SUPPORTED 	= "TEN01020e";
	public final static String IVP_NOT_LIT_SPEC_NOT_SUPPORTED 	= "TEN01030e";
	public final static String CONSTANT_NOT_SUPPORTED 	= "TEN01031e";
	public final static String TOP_LEVEL_MULTIPLE_CORR_NOT_SUPPORTED 	= "TEN01040e";
	public final static String IVP_LIT_NULL_NOT_SUPPORTED 	= "TEN01050e";
	public final static String SAN_MULTIPLE_INPUT_SETS_NOT_SUPPORTED = "TEN01060e";
	public final static String MISSING_TARGET_FOR_COA = "TEN01070e";
	public final static String PROJECT_NAME_NOT_FOUND = "TEN01080e";
	public static final String ERROR_SAVE_IMPORT_COMPONENT = "TEN01090e";
	public static final String ERROR_IN_TRANSFORMATION = "TEN01100e";	
	public static final String ERROR_GET_ALL_EXPRESSION= "TEN01110e";
		
	/* 0151 - 0200 -- FDL specific error */	
	public final static String CYCLIC_REFERENCE_IN_DATA_STRUCTURE = "TEN01510e";
	public final static String VARIABLE_REPOSITORY_NOT_SUPPORTED = "TEN12052w"; 
 
	
	/* 0201 - 0250 -- XSD specific error */	
	public final static String ERROR_RETRIEVING_ORIGINAL_XSD_DEFINITION = "TEN0201e";
	public final static String ELEMENT_DEFINED_AS_XSD_ATTRIBUTE = "TEN0202e";
	public final static String ERROR_COPYING_ORIGINAL_XSD_DEFINITION = "TEN0203e";
	public final static String NO_NAMESPACE_FOR_ORIGINAL_XSD_DEFINITION = "TEN0204e";
	public final static String ERROR_ENCODING_SCHEMA_LOCATION = "TEN0205e";
	public final static String ERROR_RETRIEVE_WBM_SCHEMA = "TEN0206e";
	
	/* 0301 - 0350 -- WSDL specific error */	
	public final static String ERROR_CREATING_WSDL_DEFINITION 	= "TEN03010e";
	//Error code for original WSDL retrieval
	public final static String ERROR_RETRIEVING_ORIGINAL_WSDL_DEFINITION = "TEN03020e";
	//Error code for BPEL parameter retrieval
	public final static String ERROR_RETRIEVING_PARAMETER_NAME = "TEN03030e";
	
	/* 0351 - 0400 -- WDO specific error */	
	
	/* 0451 - 0500 -- WCDL specific error */	
	
	/* 0551 - 0600 -- UML specific error */	
	
	/* 0601 - 0650 -- Adapter/Mediator specific error */	
	
	/* 0651 - 0700 -- Technical Attributes specific error */	
	public final static String TE_ATTRIBUTES_INVALID_NCNAME 	= "TEN06510e";
	public final static String TE_ATTRIBUTES_DUPLICATE_NAME 	= "TEN06520e";
	public final static String TE_ATTRIBUTES_INVALID_NAME	 	= "TEN06530e";
	public final static String TE_ATTRIBUTES_INVALID_BOM_MODEL	= "TEN06540e";
	public final static String TE_ATTRIBUTES_INVALID_NAMESPACE	= "TEN06550e";
	public final static String TE_ATTRIBUTES_INVALID_LOCAL_NAMESPACE= "TEN06560e";

	public final static String TE_FAILED_TO_CREATE_PROJECT = "TEN00701e";
	public final static String TE_FAILED_TO_CREATE_JAVA_IMPLEMENTATION = "TEN00702e";

	/* 0751 - 0800 -- Form specific error */
	public final static String FAILED_TO_GENERATE_XFDL_FORM = "TEN00801e";
	public final static String FAILED_TO_PERSIST_XFDL_FILE = "TEN00802e";

	/*---------- 1001 - 5000 -- Mapping Rule Warning Messages ----------*/
	/* 1001 - 1100 -- Common Warning */
	public final static String EXPRESSION_NULL_OR_UNKNOWN_WARNING = "TEN10010w";
	public final static String NO_TYPE_SPECIFIED = "TEN10011w";
	public final static String FILE_NOT_OVERWRITTEN = "TEN10012w";
	
	
	/* 1101 - 1200 -- BPEL/BPEL+ specific warning */
	public final static String PRE_POST_CONDITIONS_NOT_SUPPORTED 	= "TEN11010w";
	public final static String JOIN_MULTIPLICITY_NOT_SUPPORTED 		= "TEN11020w";
	public final static String INPUT_SET_CONSRTRAINTS_NOT_SUPPORTED 	= "TEN11030w";
	public final static String CORRELATION_PREDICATES_NOT_SUPPORTED 	= "TEN11040w";
	public final static String MULTIPLE_CORR_MATCHES_NOT_SUPPORTED 	= "TEN11050w";
	public final static String NO_CORR_MATCHES_NOT_SUPPORTED 	= "TEN11060w";
	public final static String OPTIONAL_PINS_NOT_SUPPORTED 	= "TEN11070w";
	public final static String STREAMING_OUTPUT_SETS_NOT_SUPPORTED 	= "TEN11080w";
	public final static String EXCEPTION_OUTPUT_SETS_NOT_SUPPORTED 	= "TEN11090w";
	public final static String ASYNCH_CBA_NOT_SUPPORTED 	= "TEN11100w";
	public final static String ASYNCH_COA_NOT_SUPPORTED 	= "TEN11110w";
	public final static String VAR_AT_BEGINNING_NOT_SUPPORTED 	= "TEN11120w";
	public final static String VAR_IS_INSERT_NOT_SUPPORTED 	= "TEN11130w";
	public final static String VAR_IS_REMOVE_NOT_SUPPORTED 	= "TEN11140w";
	public final static String VAR_OVERFLOW_NOT_SUPPORTED 	= "TEN11150w";
	public final static String VAR_LENGTH_NOT_SUPPORTED 	= "TEN11160w";
	public final static String UNKNOWN_STAFF_ALLOCATION_CONSTRAINT 	= "TEN11170w";
	public final static String MISSING_MANDATORY_STAFF_PARAMETER = "TEN11171w";
	public final static String STAFF_ALLOCATION_UNSUPPORTED_FOR_MICROFLOW 	= "TEN11172w";
	public final static String OVERLAPPING_PIN_SET_NOT_SUPPORTED 	= "TEN11180w";
	public final static String RETRIEVE_ART_NOT_IVP_NOT_SUPPORTED 	= "TEN11190w";
	public final static String TASK_MULTIPLE_CORR_NOT_SUPPORTED 	= "TEN11200w";
	public final static String INVALID_BPEL_XPATH_EXPRESSION = "TEN11210w";
	public final static String INVALID_INPUT_BOM_EXPRESSION = "TEN11220w";
	public final static String INCOMPLETE_END_POINT_REFERENCE ="TEN11230w";
	public final static String INCOMPLETE_END_POINT_REFERENCE_WARNING = "TEN11240w";
	public final static String DURATION_LITERAL_NOT_SUPPORTED = "TEN11250w";
	public final static String DATE_TIME_OPERATOR_LITERAL_NOT_SUPPORTED = "TEN11260w";
	public final static String INCOMPLETE_CORRELATION_SET_WARNING = "TEN11270w";
	public final static String TRUNCATED_ANNOTATION_WARNING = "TEN11280w";	
	public final static String TRUNCATED_DESCRIPTION_WARNING = "TEN11290w";
	public final static String INCOMPLETE_ASSIGN_WARNING ="TEN11295w";
	
//	public final static String VMM_PERSON_ACCOUNT_MISSING_MANDATORY_ATTRIBUTES = "TEN11300w";
//	public final static String VMM_PERSON_ACCOUNT_MISSING_MANDATORY_ATTRIBUTES_DEFAULT_SET = "TEN11310w";
//	public final static String VMM_GROUP_MISSING_MANDATORY_ATTRIBUTES = "TEN11320w";
	public final static String VMM_SAVE_VMM_SCRIPT_FAILED = "TEN11330w";

	/* 1201 - 1300 -- FDL specific warning */
	public final static String INVALID_FDL_EXPRESSION = "TEN12010w";
	public final static String LOWER_UPPER_BOUND_NOT_MATCH = "TEN12020w";
	public final static String UNBOUNDED_MULTIPLCITY_NOT_SUPPORTED = "TEN12030w";
	public final static String ZERO_MULTIPLCITY_NOT_SUPPORTED = "TEN12040w";
	public final static String UNKNOWN_FDL_STAFF_ALLOCATION_CONSTRAINT 	= "TEN12050w";
	public final static String VARIABLE_REF_IN_EXPRESSION_NOT_SUPPORTED = "TEN12060w";
	public final static String DATE_TIME_LITERAL_NOT_SUPPORTED = "TEN12070w";



	/* 1301 - 1400 -- XSD specific warning */
	
	/* 1401 - 1500 -- WSDL specific warning */
	public final static String WSDL_MULTIPLE_PARTS = "TEN14010e";
	public final static String NAMESPACE_SIZE_UNSUPPORTED = "TEN14020e";
	
	/* 1501 - 1600 -- WDO specific warning */
	
	/* 1601 - 1700 -- WCDL specific warning */
	
	/* 1701 - 1800 -- UML specific warning */
	
	/* 1801 - 1900 -- Adapter/Mediator specific warning */
	
	// BR Serializer exceptions: 1901 - 2000
	public final static String 	NOT_SUPPORTED_OPERAND			= "TEN19010E";
	public final static String 	INVALID_OPERAND					= "TEN19020E";
	public final static String 	NOT_SUPPORTED_OPERATION			= "TEN19030E";
	
	//Fault link support error
	public static final String MULTIPLE_PARTS_MESSAGE_NOT_SUPPORTED = "TEN19040E";

	public final static String NOT_SUPPORTED_IMPLEMENTATION_TYPE		= "TEN20010W";

	// Timetable exceptions: 2201 - 2300
	public final static String 	TE_FAILED_TO_CREATE_TIMETABLE	= "TEN22010E";
	

	// Monitor exceptions and warnings
	public final static String 	BM_EXPORT_ERROR			= "BME01000e";
	public final static String 	BM_EXPORT_PROJ_ERROR	= "BME01010e";
	public final static String 	BM_EXPORT_DECISION_WARNING		= "BME02010w";
	public final static String 	BM_EXPORT_LINK_NO_COND_WARNING	= "BME02020w";
	public final static String 	BM_EXPORT_NOT_APPEAR_WARNING	= "BME02030w";

	
	
}
