package com.ibm.btools.te.ilm.rulehandler.mapping.wps;

import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.wst.wsdl.PortType;

import com.ibm.btools.bom.model.processes.actions.CallBehaviorAction;
import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.bom.model.processes.activities.OutputObjectPin;
import com.ibm.btools.bom.model.processes.activities.OutputPinSet;
import com.ibm.btools.te.framework.TransformationRule;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.CallBehaviorActionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.CallBehaviorActionRuleImpl;
import com.ibm.btools.te.ilm.heuristics.helper.BomUtils;
import com.ibm.btools.te.ilm.heuristics.helper.CBPELMappingUtil;
import com.ibm.btools.te.ilm.heuristics.helper.CBPELUtil;
import com.ibm.btools.te.ilm.rulehandler.mapping.MappingManager;
import com.ibm.wbit.bpel.Assign;
import com.ibm.wbit.bpel.Invoke;
import com.ibm.wbit.bpel.Source;
import com.ibm.wbit.bpel.Target;
import com.ibm.wbit.bpelpp.FaultSource;
import com.ibm.wbit.bpelpp.FaultSources;

public class CallBehaviorActionRuleHandler extends ConnectableRuleHandler {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 
	
	/**
	 * Handle the CallBehaviorActionRule that just was executed
	 * Source: BOM CallBehaviorAction
	 * Target: The portType (interface)representing the CBA
	 */
	public void handleRule(TransformationRule rule) {
		if(rule == null || !(rule instanceof CallBehaviorActionRule)){
			return;
		}
		if (rule.getSource() == null || rule.getSource().isEmpty()) {
			LoggingUtil.traceExit(this, "handleRule","no source");
			return;			
		}			
		InputPinSet inputSet = (InputPinSet)rule.getSource().get(0);
		CallBehaviorAction source = (CallBehaviorAction)inputSet.getAction();
		CallBehaviorActionRuleImpl cbaImpl = (CallBehaviorActionRuleImpl)rule;
		PortType target = cbaImpl.getPortTypeForCallingProcess();
		if(target != null){
			MappingManager mapMgr = getMappingManager(rule);
			mapMgr.addMapDefinition(source,target);
		}
		
		
		MappingManager mapMgr = getMappingManager(rule);
		CBPELMappingUtil.createFaultMappingsForTask(rule, mapMgr);
		
//		List<OutputPinSet> opsList = CBPELMappingUtil.getExceptionPS(rule);
//		if (opsList.size() == 0) {
//			return;
//		}
//		
//		//if (true) return;
//		
//		//CBA IPS --> FaultSources
//		MappingManager mapMgr = getMappingManager(rule);
//		Map<TransformationRule,Map<String, List<EObject>>> faultSourcesMap = CBPELUtil.getFaultSourcesMap(rule.getRoot().getContext());
//		Map<String, List<EObject>> epsMap = faultSourcesMap.get(rule.getChildRules().get(0));
//		
//		Invoke invoke = (Invoke) rule.getTarget().get(0);
//		FaultSources faultSources = getFaultSources(invoke);
//		//List<FaultSource> faultSourceList = faultSources.getFaultSource();
//		//mapMgr.addMapDefinition(opsList.get(0).getAction(), faultSources);
//		//IPS --> FaultSources
//		mapMgr.addMapDefinition((InputPinSet)rule.getSource().get(0), faultSources);
//		
//		List<OutputPinSet> exceptionOPSList = getExceptionPS(rule);
//		for (OutputPinSet exceptionOPS : exceptionOPSList) {
//			List<FaultSource> faultSourceForThisOPS = getFaultSourceForEPS(faultSources, exceptionOPS, rule);
//			for (FaultSource faultSource : faultSourceForThisOPS) {
//					//EPS --> FaultSource
//					mapMgr.addMapDefinition(exceptionOPS, faultSource);
//			}
//			
////			List<EObject> targetObjects = epsMap.get(exceptionOPS.getName());
////			
////			//Map this EPS to all FaultSource
////			for (FaultSource faultSource : faultSourceList) {
////				if (targetObjects.contains(faultSource.getLink())) {
////					//EPS --> FaultSource
////					mapMgr.addMapDefinition(exceptionOPS, faultSource);
////				}
////			}
//		}
//		
//		//Map assigns
//		for (Object targetObj : rule.getTarget()) {
//			if (targetObj instanceof Assign) {
//				//Assign assign = (Assign) rule.getTarget().get(1);
//				Assign assign = (Assign) targetObj;
//				OutputPinSet exceptionOPS = getEPSForAssign(assign, faultSources, exceptionOPSList, rule);
//				
//				for (FaultSource faultSource : getFaultSourceForEPS(faultSources, exceptionOPS, rule)) {
//					//Figure out which faultSource this assign pertains to.
//					if (((Target)(faultSource.getLink().getTargets().get(0))).eContainer().eContainer() == assign) {
//						//EPS --> Assign
//						//mapMgr.addMapDefinition(exceptionOPS, assign);
//						//IPS --> Assign Sources
//						mapMgr.addMapDefinition((InputPinSet)rule.getSource().get(0), assign.getSources());
//						//EPS --> Assign Source
//						for (Source src : (List<Source>)assign.getSources().getChildren()) {
//							mapMgr.addMapDefinition(exceptionOPS, src);
//						}
//						//All connections from this EPS --> link from invoke to assign
//						for (OutputObjectPin op : (List<OutputObjectPin>)exceptionOPS.getOutputObjectPin()) {
//							mapMgr.addMapDefinition(op.getOutgoing(), faultSource.getLink());
//						}
//					}
//				}//Each assign should only be connected to one fault source
//			}//for each assign
//		}
//		
		
	}
}
