package com.ibm.btools.te.ilm.rulehandler.mapping.wps;

/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import java.util.Iterator;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.wst.wsdl.PortType;

import com.ibm.btools.bom.model.processes.activities.StructuredActivityNode;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.heuristics.helper.BomUtils;
import com.ibm.btools.te.ilm.rulehandler.mapping.MappingManager;

/**
 * This handler is responsbile for creating the ObjectDefinition mapping between 
 * BOM <code>StructuredActivityNode</code> and WSDL <code>PortType </code>
 */
public class PortTypeRuleHandler extends ConnectableRuleHandler {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 
	
	/**	 
	 * @param rule the PortTypeRule that has just executed
	 */
	public void handleRule(TransformationRule rule) {
		if (rule.getSource().get(0) instanceof StructuredActivityNode) {
			StructuredActivityNode san = (StructuredActivityNode)rule.getSource().get(0);
			if (san.getActivity()!=null) {
				MappingManager mapMgr = getMappingManager(rule);
				//mapMgr.addMapDefinition(san.getActivity(),(EObject)rule.getTarget().get(0));
				Iterator it = rule.getTarget().iterator();
				while(it.hasNext()){
					EObject obj = (EObject)it.next();
					if(obj instanceof PortType){
						if(BomUtils.isServiceOperation(san)){
							continue;
						}
						mapMgr.addMapDefinition(san.getActivity(),obj);
					}
				}
			}else if(BomUtils.isTask(san)||
					BomUtils.isBusinessRuleTask(san)||
					BomUtils.isHumanTask(san)){
				MappingManager mapMgr = getMappingManager(rule);				
				Iterator it = rule.getTarget().iterator();
				while(it.hasNext()){
					EObject obj = (EObject)it.next();
					if(obj instanceof PortType){						
						mapMgr.addMapDefinition(san,obj);
					}
				}
			}
				return;
			}
		super.handleRule(rule);
	}

}
