package com.ibm.btools.te.ilm.rulehandler.mapping.wps;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.util.Iterator;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.wst.wsdl.Definition;

import com.ibm.btools.bom.model.externalmodels.ExternalDocument;
import com.ibm.btools.bom.model.externalmodels.ExternalService;
import com.ibm.btools.bom.model.externalmodels.ServiceInterface;
import com.ibm.btools.bom.model.processes.activities.Activity;
import com.ibm.btools.bom.model.processes.activities.StructuredActivityNode;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.ExportOperationUtil;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessInterfaceRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ProcessInterfaceRuleImpl;
import com.ibm.btools.te.ilm.heuristics.helper.BomUtils;
import com.ibm.btools.te.ilm.rulehandler.mapping.MappingManager;
import com.ibm.btools.te.ilm.rulehandler.mapping.MappingUtil;

/**
 * This handler is responsbile for creating the ObjectDenifition mapping between 
 * BOM <code> StructuredActivityNode </code> and WSDL <code>Definition </code>
 */
public class ProcessInterfaceRuleHandler extends ConnectableRuleHandler {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 	
	/**	
	 * @param rule The ProcessInterfaceRule that has just executed.
	 */
	
	public void handleRule(TransformationRule rule) {
		if (rule.getSource().get(0) instanceof StructuredActivityNode) {
			StructuredActivityNode san = (StructuredActivityNode)rule.getSource().get(0);
			if (san.getActivity()!=null) {
				MappingManager mapMgr = getMappingManager(rule);
				//mapMgr.addMapDefinition(san.getActivity(),(EObject)rule.getTarget().get(0));
				Iterator it = rule.getTarget().iterator();
				while(it.hasNext()){
					EObject obj = (EObject)it.next();
					if(obj instanceof Definition){
						if(rule instanceof ProcessInterfaceRuleImpl){
							ProcessInterfaceRuleImpl proInterRule = (ProcessInterfaceRuleImpl)rule;
							if(proInterRule.getWsdlCallbackDefinition() != null && proInterRule.getWsdlCallbackDefinition() == obj ){
		                       //we need to add descriptor for the  call back definition, register it
							   //in the transformation context
							   MappingUtil.registerCallBackArtifacts(rule.getRoot().getContext(),obj);
							}			
						}	
						if(BomUtils.isServiceOperation(san)){
							//we resolve to external service
							if(san.eContainer() instanceof Activity){
								if(((Activity)san.eContainer()).getOwningPackage() instanceof ServiceInterface){
									ServiceInterface si = (ServiceInterface)((Activity)san.eContainer()).getOwningPackage();
									if(si.getOwningPackage() instanceof ExternalService){
										ExportOperationUtil.addToExtDocumentWithArtCatList((ExternalDocument)si.getOwningPackage());
										mapMgr.addMapDefinition(si.getOwningPackage(),obj);
									}
								}
							}
						}else{
							mapMgr.addMapDefinition(san.getActivity(),obj);
						}
					}
				}
				return;
			}
		}
		//Default handling
		super.handleRule(rule);
	}			
}
