package com.ibm.btools.te.ilm.rulehandler.mapping.wps;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xsd.XSDParticle;

import com.ibm.btools.bom.model.artifacts.PrimitiveType;
import com.ibm.btools.bom.model.artifacts.Property;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.rulehandler.mapping.MappingManager;
import com.ibm.btools.te.ilm.rulehandler.mapping.MappingUtil;

/**
 * This handler is responsbile for creating the ObjectDenifition mapping between 
 * BOM <code> Property </code> and XSD <code>XSDParticle </code> and its content
 */

public class PropertyRuleHandler extends ConnectableRuleHandler {
	
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 
	
	/**
	 * Creates the ObjectDefinitions for the BOM Property and the XSDElementDeclaration and XSDParticle. 
	 * @param rule the PropertyRule that has just executed
	 */
	public void handleRule(TransformationRule rule) {		
		if(rule.getSource().get(0) instanceof Property && rule.getTarget().get(0) instanceof XSDParticle){
			Property source = (Property)rule.getSource().get(0);
			//if(MappingUtil.isPrimitiveType(source)||MappingUtil.isPrivateTypeProperty(source)){
		    if(MappingUtil.isPrivateTypeProperty(source)){
				return;
			}
			MappingManager mapMgr = getMappingManager(rule);
			XSDParticle particle = (XSDParticle)rule.getTarget().get(0);
			mapMgr.addMapDefinition((EObject)rule.getSource().get(0),particle);
			mapMgr.addMapDefinition((EObject)rule.getSource().get(0),particle.getContent());			
		}
		// Default MapDefinition Handling	
		super.handleRule(rule);
	}
}
