package com.ibm.btools.te.ilm.rulehandler.mapping.wps;

/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import com.ibm.btools.bom.model.time.RecurringTimeIntervals;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.rulehandler.mapping.MappingManager;
import com.ibm.wbit.businesscalendar.ICalendar;

/**
 * This handler is responsbile for creating the <code>ObjectDefinition</code> mapping 
 * between BOM <code> RecurringTimeIntervals </code> and WID <code>BusinessCalendar</code>
 */
public class TimetableRuleHandler extends ConnectableRuleHandler {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 
	
	/**	 
	 * @param rule The TimeIntervalsRule that has just executed.
	 */
	public void handleRule(TransformationRule rule) {
		/**
		 * Handles the TimeIntervalsRule
		 * Source: BOM RecurringTimeIntervals
		 * Target: WID Calendar
		 */
		
		RecurringTimeIntervals rti = (RecurringTimeIntervals)rule.getSource().get(0);
		ICalendar calendar = (ICalendar)rule.getTarget().get(0);
		
		MappingManager mapMgr = getMappingManager(rule);
		mapMgr.addMapDefinition(rti, calendar);
	}			
}
