package com.ibm.btools.te.ilm.rulehandler.mapping.wps;

/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import com.ibm.btools.bom.model.artifacts.Type;
import com.ibm.btools.bom.model.artifacts.TypedElement;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.rulehandler.mapping.MappingManager;
import com.ibm.wbit.bpel.BPELVariable;

/**
 * This handler is responsbile for creating the ObjectDenifition mapping between 
 *BOM <code> TypedElement </code> and BPEL <code>BPELVariable </code>
 */
public class VariableRuleHandler extends ConnectableRuleHandler {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 

	/**
	 * Handles the VariableRule.
	 * @param rule The VariableRule that has just executed.
	 */
	public void handleRule(TransformationRule rule) {
		/**
		 * Handles the VarialbleRule. 
		 * 
		 * Source: BOM Type, BOM MultiplicityElement (pin or variable) 
		 * Target: BPEL Variable
		 */

		Type type = (Type)rule.getSource().get(0);
		TypedElement pinOrVariable = (TypedElement)rule.getSource().get(1);
		BPELVariable bpelVariable = (BPELVariable)rule.getTarget().get(0);	

		MappingManager mapMgr = getMappingManager(rule);
		mapMgr.addMapDefinition(pinOrVariable,bpelVariable); 	
	}		
}
